/* textdocument.c generated by valac 0.56.17, the Vala compiler
 * generated from textdocument.vala, do not modify */

/* textdocument.vala
 *
 * Copyright 2020 Princeton Ferro <princetonferro@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <vala.h>
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <glib/gstdio.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define VLS_TYPE_TEXT_DOCUMENT (vls_text_document_get_type ())
#define VLS_TEXT_DOCUMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VLS_TYPE_TEXT_DOCUMENT, VlsTextDocument))
#define VLS_TEXT_DOCUMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VLS_TYPE_TEXT_DOCUMENT, VlsTextDocumentClass))
#define VLS_IS_TEXT_DOCUMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VLS_TYPE_TEXT_DOCUMENT))
#define VLS_IS_TEXT_DOCUMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VLS_TYPE_TEXT_DOCUMENT))
#define VLS_TEXT_DOCUMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VLS_TYPE_TEXT_DOCUMENT, VlsTextDocumentClass))

typedef struct _VlsTextDocument VlsTextDocument;
typedef struct _VlsTextDocumentClass VlsTextDocumentClass;
typedef struct _VlsTextDocumentPrivate VlsTextDocumentPrivate;
#define _g_time_zone_unref0(var) ((var == NULL) ? NULL : (var = (g_time_zone_unref (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _vala_source_file_unref0(var) ((var == NULL) ? NULL : (var = (vala_source_file_unref (var), NULL)))

struct _VlsTextDocument {
	ValaSourceFile parent_instance;
	VlsTextDocumentPrivate * priv;
};

struct _VlsTextDocumentClass {
	ValaSourceFileClass parent_class;
};

struct _VlsTextDocumentPrivate {
	GDateTime* _last_updated;
	gint _version;
	gint _last_saved_version;
	gchar* _last_saved_content;
	gchar* _last_fresh_content;
};

static gint VlsTextDocument_private_offset;
static gpointer vls_text_document_parent_class = NULL;

VALA_EXTERN GType vls_text_document_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VlsTextDocument, vala_source_file_unref)
VALA_EXTERN VlsTextDocument* vls_text_document_new (ValaCodeContext* context,
                                        GFile* file,
                                        const gchar* content,
                                        gboolean cmdline,
                                        GError** error);
VALA_EXTERN VlsTextDocument* vls_text_document_construct (GType object_type,
                                              ValaCodeContext* context,
                                              GFile* file,
                                              const gchar* content,
                                              gboolean cmdline,
                                              GError** error);
VALA_EXTERN gchar* vls_util_realpath (const gchar* name,
                          const gchar* cwd);
VALA_EXTERN GDateTime* vls_text_document_get_last_updated (VlsTextDocument* self);
VALA_EXTERN void vls_text_document_set_last_updated (VlsTextDocument* self,
                                         GDateTime* value);
VALA_EXTERN gint vls_text_document_get_version (VlsTextDocument* self);
VALA_EXTERN void vls_text_document_set_version (VlsTextDocument* self,
                                    gint value);
VALA_EXTERN gint vls_text_document_get_last_saved_version (VlsTextDocument* self);
static void vls_text_document_set_last_saved_version (VlsTextDocument* self,
                                               gint value);
VALA_EXTERN const gchar* vls_text_document_get_last_saved_content (VlsTextDocument* self);
VALA_EXTERN void vls_text_document_set_last_saved_content (VlsTextDocument* self,
                                               const gchar* value);
VALA_EXTERN const gchar* vls_text_document_get_last_fresh_content (VlsTextDocument* self);
VALA_EXTERN void vls_text_document_set_last_fresh_content (VlsTextDocument* self,
                                               const gchar* value);
static void vls_text_document_finalize (ValaSourceFile * obj);
static GType vls_text_document_get_type_once (void);

static inline gpointer
vls_text_document_get_instance_private (VlsTextDocument* self)
{
	return G_STRUCT_MEMBER_P (self, VlsTextDocument_private_offset);
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
#line 1624 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1625 "glib-2.0.vapi"
	result = self;
#line 1625 "glib-2.0.vapi"
	return result;
#line 133 "textdocument.c"
}

VlsTextDocument*
vls_text_document_construct (GType object_type,
                             ValaCodeContext* context,
                             GFile* file,
                             const gchar* content,
                             gboolean cmdline,
                             GError** error)
{
	VlsTextDocument* self = NULL;
	gchar* cont = NULL;
	gchar* _tmp0_;
	gchar* uri = NULL;
	gchar* _tmp1_;
	gchar* path = NULL;
	gchar* _tmp2_;
	gchar* _tmp3_ = NULL;
	const gchar* _tmp4_;
	gchar* _tmp7_;
	gboolean _tmp8_ = FALSE;
	const gchar* _tmp9_;
	ValaSourceFileType ftype = 0;
	gboolean _tmp22_ = FALSE;
	const gchar* _tmp23_;
	const gchar* _tmp29_ = NULL;
	const gchar* _tmp30_;
	const gchar* _tmp32_;
	GError* _inner_error0_ = NULL;
#line 59 "../src/projects/textdocument.vala"
	g_return_val_if_fail (context != NULL, NULL);
#line 59 "../src/projects/textdocument.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 60 "../src/projects/textdocument.vala"
	_tmp0_ = g_strdup (content);
#line 60 "../src/projects/textdocument.vala"
	cont = _tmp0_;
#line 61 "../src/projects/textdocument.vala"
	_tmp1_ = g_file_get_uri (file);
#line 61 "../src/projects/textdocument.vala"
	uri = _tmp1_;
#line 62 "../src/projects/textdocument.vala"
	_tmp2_ = g_file_get_path (file);
#line 62 "../src/projects/textdocument.vala"
	path = _tmp2_;
#line 63 "../src/projects/textdocument.vala"
	_tmp4_ = path;
#line 63 "../src/projects/textdocument.vala"
	if (_tmp4_ != NULL) {
#line 183 "textdocument.c"
		const gchar* _tmp5_;
		gchar* _tmp6_;
#line 63 "../src/projects/textdocument.vala"
		_tmp5_ = path;
#line 63 "../src/projects/textdocument.vala"
		_tmp6_ = vls_util_realpath (_tmp5_, NULL);
#line 63 "../src/projects/textdocument.vala"
		_g_free0 (_tmp3_);
#line 63 "../src/projects/textdocument.vala"
		_tmp3_ = _tmp6_;
#line 194 "textdocument.c"
	} else {
#line 63 "../src/projects/textdocument.vala"
		_g_free0 (_tmp3_);
#line 63 "../src/projects/textdocument.vala"
		_tmp3_ = NULL;
#line 200 "textdocument.c"
	}
#line 63 "../src/projects/textdocument.vala"
	_tmp7_ = g_strdup (_tmp3_);
#line 63 "../src/projects/textdocument.vala"
	_g_free0 (path);
#line 63 "../src/projects/textdocument.vala"
	path = _tmp7_;
#line 64 "../src/projects/textdocument.vala"
	_tmp9_ = path;
#line 64 "../src/projects/textdocument.vala"
	if (_tmp9_ != NULL) {
#line 212 "textdocument.c"
		const gchar* _tmp10_;
#line 64 "../src/projects/textdocument.vala"
		_tmp10_ = cont;
#line 64 "../src/projects/textdocument.vala"
		_tmp8_ = _tmp10_ == NULL;
#line 218 "textdocument.c"
	} else {
#line 64 "../src/projects/textdocument.vala"
		_tmp8_ = FALSE;
#line 222 "textdocument.c"
	}
#line 64 "../src/projects/textdocument.vala"
	if (_tmp8_) {
#line 226 "textdocument.c"
		const gchar* _tmp11_;
		gchar* _tmp12_ = NULL;
#line 65 "../src/projects/textdocument.vala"
		_tmp11_ = path;
#line 65 "../src/projects/textdocument.vala"
		g_file_get_contents (_tmp11_, &_tmp12_, NULL, &_inner_error0_);
#line 65 "../src/projects/textdocument.vala"
		_g_free0 (cont);
#line 65 "../src/projects/textdocument.vala"
		cont = _tmp12_;
#line 65 "../src/projects/textdocument.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 65 "../src/projects/textdocument.vala"
			if (_inner_error0_->domain == G_FILE_ERROR) {
#line 65 "../src/projects/textdocument.vala"
				g_propagate_error (error, _inner_error0_);
#line 65 "../src/projects/textdocument.vala"
				_g_free0 (_tmp3_);
#line 65 "../src/projects/textdocument.vala"
				_g_free0 (path);
#line 65 "../src/projects/textdocument.vala"
				_g_free0 (uri);
#line 65 "../src/projects/textdocument.vala"
				_g_free0 (cont);
#line 65 "../src/projects/textdocument.vala"
				_vala_source_file_unref0 (self);
#line 65 "../src/projects/textdocument.vala"
				return NULL;
#line 255 "textdocument.c"
			} else {
#line 65 "../src/projects/textdocument.vala"
				_g_free0 (_tmp3_);
#line 65 "../src/projects/textdocument.vala"
				_g_free0 (path);
#line 65 "../src/projects/textdocument.vala"
				_g_free0 (uri);
#line 65 "../src/projects/textdocument.vala"
				_g_free0 (cont);
#line 65 "../src/projects/textdocument.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 65 "../src/projects/textdocument.vala"
				g_clear_error (&_inner_error0_);
#line 65 "../src/projects/textdocument.vala"
				return NULL;
#line 271 "textdocument.c"
			}
		}
	} else {
		gboolean _tmp13_ = FALSE;
		const gchar* _tmp14_;
#line 66 "../src/projects/textdocument.vala"
		_tmp14_ = path;
#line 66 "../src/projects/textdocument.vala"
		if (_tmp14_ == NULL) {
#line 281 "textdocument.c"
			const gchar* _tmp15_;
#line 66 "../src/projects/textdocument.vala"
			_tmp15_ = cont;
#line 66 "../src/projects/textdocument.vala"
			_tmp13_ = _tmp15_ == NULL;
#line 287 "textdocument.c"
		} else {
#line 66 "../src/projects/textdocument.vala"
			_tmp13_ = FALSE;
#line 291 "textdocument.c"
		}
#line 66 "../src/projects/textdocument.vala"
		if (_tmp13_) {
#line 295 "textdocument.c"
			const gchar* _tmp16_;
			const gchar* _tmp17_;
			gchar* _tmp18_;
			gchar* _tmp19_;
			GError* _tmp20_;
			GError* _tmp21_;
#line 67 "../src/projects/textdocument.vala"
			_tmp16_ = uri;
#line 67 "../src/projects/textdocument.vala"
			_tmp17_ = string_to_string (_tmp16_);
#line 67 "../src/projects/textdocument.vala"
			_tmp18_ = g_strconcat ("file ", _tmp17_, " does not exist either on the system or in memory", NULL);
#line 67 "../src/projects/textdocument.vala"
			_tmp19_ = _tmp18_;
#line 67 "../src/projects/textdocument.vala"
			_tmp20_ = g_error_new_literal (G_FILE_ERROR, G_FILE_ERROR_NOENT, _tmp19_);
#line 67 "../src/projects/textdocument.vala"
			_tmp21_ = _tmp20_;
#line 67 "../src/projects/textdocument.vala"
			_g_free0 (_tmp19_);
#line 67 "../src/projects/textdocument.vala"
			_inner_error0_ = _tmp21_;
#line 67 "../src/projects/textdocument.vala"
			if (_inner_error0_->domain == G_FILE_ERROR) {
#line 67 "../src/projects/textdocument.vala"
				g_propagate_error (error, _inner_error0_);
#line 67 "../src/projects/textdocument.vala"
				_g_free0 (_tmp3_);
#line 67 "../src/projects/textdocument.vala"
				_g_free0 (path);
#line 67 "../src/projects/textdocument.vala"
				_g_free0 (uri);
#line 67 "../src/projects/textdocument.vala"
				_g_free0 (cont);
#line 67 "../src/projects/textdocument.vala"
				_vala_source_file_unref0 (self);
#line 67 "../src/projects/textdocument.vala"
				return NULL;
#line 334 "textdocument.c"
			} else {
#line 67 "../src/projects/textdocument.vala"
				_g_free0 (_tmp3_);
#line 67 "../src/projects/textdocument.vala"
				_g_free0 (path);
#line 67 "../src/projects/textdocument.vala"
				_g_free0 (uri);
#line 67 "../src/projects/textdocument.vala"
				_g_free0 (cont);
#line 67 "../src/projects/textdocument.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 67 "../src/projects/textdocument.vala"
				g_clear_error (&_inner_error0_);
#line 67 "../src/projects/textdocument.vala"
				return NULL;
#line 350 "textdocument.c"
			}
		}
	}
#line 69 "../src/projects/textdocument.vala"
	_tmp23_ = uri;
#line 69 "../src/projects/textdocument.vala"
	if (g_str_has_suffix (_tmp23_, ".vapi")) {
#line 69 "../src/projects/textdocument.vala"
		_tmp22_ = TRUE;
#line 360 "textdocument.c"
	} else {
		const gchar* _tmp24_;
#line 69 "../src/projects/textdocument.vala"
		_tmp24_ = uri;
#line 69 "../src/projects/textdocument.vala"
		_tmp22_ = g_str_has_suffix (_tmp24_, ".gir");
#line 367 "textdocument.c"
	}
#line 69 "../src/projects/textdocument.vala"
	if (_tmp22_) {
#line 70 "../src/projects/textdocument.vala"
		ftype = VALA_SOURCE_FILE_TYPE_PACKAGE;
#line 373 "textdocument.c"
	} else {
		gboolean _tmp25_ = FALSE;
		const gchar* _tmp26_;
#line 71 "../src/projects/textdocument.vala"
		_tmp26_ = uri;
#line 71 "../src/projects/textdocument.vala"
		if (g_str_has_suffix (_tmp26_, ".vala")) {
#line 71 "../src/projects/textdocument.vala"
			_tmp25_ = TRUE;
#line 383 "textdocument.c"
		} else {
			const gchar* _tmp27_;
#line 71 "../src/projects/textdocument.vala"
			_tmp27_ = uri;
#line 71 "../src/projects/textdocument.vala"
			_tmp25_ = g_str_has_suffix (_tmp27_, ".gs");
#line 390 "textdocument.c"
		}
#line 71 "../src/projects/textdocument.vala"
		if (_tmp25_) {
#line 72 "../src/projects/textdocument.vala"
			ftype = VALA_SOURCE_FILE_TYPE_SOURCE;
#line 396 "textdocument.c"
		} else {
			const gchar* _tmp28_;
#line 74 "../src/projects/textdocument.vala"
			ftype = VALA_SOURCE_FILE_TYPE_NONE;
#line 75 "../src/projects/textdocument.vala"
			_tmp28_ = uri;
#line 75 "../src/projects/textdocument.vala"
			g_warning ("textdocument.vala:75: TextDocument: file %s is neither a package nor a" \
" source file", _tmp28_);
#line 405 "textdocument.c"
		}
	}
#line 79 "../src/projects/textdocument.vala"
	_tmp30_ = path;
#line 79 "../src/projects/textdocument.vala"
	_tmp29_ = _tmp30_;
#line 79 "../src/projects/textdocument.vala"
	if (_tmp29_ == NULL) {
#line 414 "textdocument.c"
		const gchar* _tmp31_;
#line 79 "../src/projects/textdocument.vala"
		_tmp31_ = uri;
#line 79 "../src/projects/textdocument.vala"
		_tmp29_ = _tmp31_;
#line 420 "textdocument.c"
	}
#line 79 "../src/projects/textdocument.vala"
	_tmp32_ = cont;
#line 79 "../src/projects/textdocument.vala"
	self = (VlsTextDocument*) vala_source_file_construct (object_type, context, ftype, _tmp29_, _tmp32_, cmdline);
#line 59 "../src/projects/textdocument.vala"
	_g_free0 (_tmp3_);
#line 59 "../src/projects/textdocument.vala"
	_g_free0 (path);
#line 59 "../src/projects/textdocument.vala"
	_g_free0 (uri);
#line 59 "../src/projects/textdocument.vala"
	_g_free0 (cont);
#line 59 "../src/projects/textdocument.vala"
	return self;
#line 436 "textdocument.c"
}

VlsTextDocument*
vls_text_document_new (ValaCodeContext* context,
                       GFile* file,
                       const gchar* content,
                       gboolean cmdline,
                       GError** error)
{
#line 59 "../src/projects/textdocument.vala"
	return vls_text_document_construct (VLS_TYPE_TEXT_DOCUMENT, context, file, content, cmdline, error);
#line 448 "textdocument.c"
}

GDateTime*
vls_text_document_get_last_updated (VlsTextDocument* self)
{
	GDateTime* result;
	GDateTime* _tmp0_;
#line 26 "../src/projects/textdocument.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 26 "../src/projects/textdocument.vala"
	_tmp0_ = self->priv->_last_updated;
#line 26 "../src/projects/textdocument.vala"
	result = _tmp0_;
#line 26 "../src/projects/textdocument.vala"
	return result;
#line 464 "textdocument.c"
}

static gpointer
_g_date_time_ref0 (gpointer self)
{
#line 26 "../src/projects/textdocument.vala"
	return self ? g_date_time_ref (self) : NULL;
#line 472 "textdocument.c"
}

void
vls_text_document_set_last_updated (VlsTextDocument* self,
                                    GDateTime* value)
{
	GDateTime* _tmp0_;
#line 26 "../src/projects/textdocument.vala"
	g_return_if_fail (self != NULL);
#line 26 "../src/projects/textdocument.vala"
	_tmp0_ = _g_date_time_ref0 (value);
#line 26 "../src/projects/textdocument.vala"
	_g_date_time_unref0 (self->priv->_last_updated);
#line 26 "../src/projects/textdocument.vala"
	self->priv->_last_updated = _tmp0_;
#line 488 "textdocument.c"
}

gint
vls_text_document_get_version (VlsTextDocument* self)
{
	gint result;
#line 27 "../src/projects/textdocument.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 27 "../src/projects/textdocument.vala"
	result = self->priv->_version;
#line 27 "../src/projects/textdocument.vala"
	return result;
#line 501 "textdocument.c"
}

void
vls_text_document_set_version (VlsTextDocument* self,
                               gint value)
{
#line 27 "../src/projects/textdocument.vala"
	g_return_if_fail (self != NULL);
#line 27 "../src/projects/textdocument.vala"
	self->priv->_version = value;
#line 512 "textdocument.c"
}

gint
vls_text_document_get_last_saved_version (VlsTextDocument* self)
{
	gint result;
#line 29 "../src/projects/textdocument.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 29 "../src/projects/textdocument.vala"
	result = self->priv->_last_saved_version;
#line 29 "../src/projects/textdocument.vala"
	return result;
#line 525 "textdocument.c"
}

static void
vls_text_document_set_last_saved_version (VlsTextDocument* self,
                                          gint value)
{
#line 29 "../src/projects/textdocument.vala"
	g_return_if_fail (self != NULL);
#line 29 "../src/projects/textdocument.vala"
	self->priv->_last_saved_version = value;
#line 536 "textdocument.c"
}

const gchar*
vls_text_document_get_last_saved_content (VlsTextDocument* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	const gchar* _tmp3_;
#line 32 "../src/projects/textdocument.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 33 "../src/projects/textdocument.vala"
	_tmp0_ = self->priv->_last_saved_content;
#line 33 "../src/projects/textdocument.vala"
	if (_tmp0_ == NULL) {
#line 551 "textdocument.c"
		const gchar* _tmp1_;
		const gchar* _tmp2_;
#line 34 "../src/projects/textdocument.vala"
		_tmp1_ = vala_source_file_get_content ((ValaSourceFile*) self);
#line 34 "../src/projects/textdocument.vala"
		_tmp2_ = _tmp1_;
#line 34 "../src/projects/textdocument.vala"
		result = _tmp2_;
#line 34 "../src/projects/textdocument.vala"
		return result;
#line 562 "textdocument.c"
	}
#line 35 "../src/projects/textdocument.vala"
	_tmp3_ = self->priv->_last_saved_content;
#line 35 "../src/projects/textdocument.vala"
	result = _tmp3_;
#line 35 "../src/projects/textdocument.vala"
	return result;
#line 570 "textdocument.c"
}

void
vls_text_document_set_last_saved_content (VlsTextDocument* self,
                                          const gchar* value)
{
	gchar* _tmp0_;
	gint _tmp1_;
#line 37 "../src/projects/textdocument.vala"
	g_return_if_fail (self != NULL);
#line 38 "../src/projects/textdocument.vala"
	_tmp0_ = g_strdup (value);
#line 38 "../src/projects/textdocument.vala"
	_g_free0 (self->priv->_last_saved_content);
#line 38 "../src/projects/textdocument.vala"
	self->priv->_last_saved_content = _tmp0_;
#line 39 "../src/projects/textdocument.vala"
	_tmp1_ = self->priv->_version;
#line 39 "../src/projects/textdocument.vala"
	vls_text_document_set_last_saved_version (self, _tmp1_);
#line 591 "textdocument.c"
}

const gchar*
vls_text_document_get_last_fresh_content (VlsTextDocument* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	const gchar* _tmp3_;
#line 49 "../src/projects/textdocument.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 50 "../src/projects/textdocument.vala"
	_tmp0_ = self->priv->_last_fresh_content;
#line 50 "../src/projects/textdocument.vala"
	if (_tmp0_ == NULL) {
#line 606 "textdocument.c"
		const gchar* _tmp1_;
		const gchar* _tmp2_;
#line 51 "../src/projects/textdocument.vala"
		_tmp1_ = vala_source_file_get_content ((ValaSourceFile*) self);
#line 51 "../src/projects/textdocument.vala"
		_tmp2_ = _tmp1_;
#line 51 "../src/projects/textdocument.vala"
		result = _tmp2_;
#line 51 "../src/projects/textdocument.vala"
		return result;
#line 617 "textdocument.c"
	}
#line 52 "../src/projects/textdocument.vala"
	_tmp3_ = self->priv->_last_fresh_content;
#line 52 "../src/projects/textdocument.vala"
	result = _tmp3_;
#line 52 "../src/projects/textdocument.vala"
	return result;
#line 625 "textdocument.c"
}

void
vls_text_document_set_last_fresh_content (VlsTextDocument* self,
                                          const gchar* value)
{
	gchar* _tmp0_;
#line 54 "../src/projects/textdocument.vala"
	g_return_if_fail (self != NULL);
#line 55 "../src/projects/textdocument.vala"
	_tmp0_ = g_strdup (value);
#line 55 "../src/projects/textdocument.vala"
	_g_free0 (self->priv->_last_fresh_content);
#line 55 "../src/projects/textdocument.vala"
	self->priv->_last_fresh_content = _tmp0_;
#line 641 "textdocument.c"
}

static void
vls_text_document_class_init (VlsTextDocumentClass * klass,
                              gpointer klass_data)
{
#line 21 "../src/projects/textdocument.vala"
	vls_text_document_parent_class = g_type_class_peek_parent (klass);
#line 21 "../src/projects/textdocument.vala"
	((ValaSourceFileClass *) klass)->finalize = vls_text_document_finalize;
#line 21 "../src/projects/textdocument.vala"
	g_type_class_adjust_private_offset (klass, &VlsTextDocument_private_offset);
#line 654 "textdocument.c"
}

static void
vls_text_document_instance_init (VlsTextDocument * self,
                                 gpointer klass)
{
	GTimeZone* _tmp0_;
	GTimeZone* _tmp1_;
	GDateTime* _tmp2_;
#line 21 "../src/projects/textdocument.vala"
	self->priv = vls_text_document_get_instance_private (self);
#line 26 "../src/projects/textdocument.vala"
	_tmp0_ = g_time_zone_new_local ();
#line 26 "../src/projects/textdocument.vala"
	_tmp1_ = _tmp0_;
#line 26 "../src/projects/textdocument.vala"
	_tmp2_ = g_date_time_new_now (_tmp1_);
#line 26 "../src/projects/textdocument.vala"
	self->priv->_last_updated = _tmp2_;
#line 26 "../src/projects/textdocument.vala"
	_g_time_zone_unref0 (_tmp1_);
#line 30 "../src/projects/textdocument.vala"
	self->priv->_last_saved_content = NULL;
#line 43 "../src/projects/textdocument.vala"
	self->priv->_last_fresh_content = NULL;
#line 680 "textdocument.c"
}

static void
vls_text_document_finalize (ValaSourceFile * obj)
{
	VlsTextDocument * self;
#line 21 "../src/projects/textdocument.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VLS_TYPE_TEXT_DOCUMENT, VlsTextDocument);
#line 26 "../src/projects/textdocument.vala"
	_g_date_time_unref0 (self->priv->_last_updated);
#line 30 "../src/projects/textdocument.vala"
	_g_free0 (self->priv->_last_saved_content);
#line 43 "../src/projects/textdocument.vala"
	_g_free0 (self->priv->_last_fresh_content);
#line 21 "../src/projects/textdocument.vala"
	VALA_SOURCE_FILE_CLASS (vls_text_document_parent_class)->finalize (obj);
#line 697 "textdocument.c"
}

 G_GNUC_NO_INLINE static GType
vls_text_document_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (VlsTextDocumentClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vls_text_document_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (VlsTextDocument), 0, (GInstanceInitFunc) vls_text_document_instance_init, NULL };
	GType vls_text_document_type_id;
	vls_text_document_type_id = g_type_register_static (VALA_TYPE_SOURCE_FILE, "VlsTextDocument", &g_define_type_info, 0);
	VlsTextDocument_private_offset = g_type_add_instance_private (vls_text_document_type_id, sizeof (VlsTextDocumentPrivate));
	return vls_text_document_type_id;
}

GType
vls_text_document_get_type (void)
{
	static gsize vls_text_document_type_id__once = 0;
	if (g_once_init_enter (&vls_text_document_type_id__once)) {
		GType vls_text_document_type_id;
		vls_text_document_type_id = vls_text_document_get_type_once ();
		g_once_init_leave (&vls_text_document_type_id__once, vls_text_document_type_id);
	}
	return vls_text_document_type_id__once;
}

