/* protocol.c generated by valac 0.56.17, the Vala compiler
 * generated from protocol.vala, do not modify */

/* protocol.vala
 *
 * Copyright 2017-2019 Ben Iofel <ben@iofel.me>
 * Copyright 2017-2020 Princeton Ferro <princetonferro@gmail.com>
 * Copyright 2020 Sergii Fesenko <s.fesenko@outlook.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib-object.h>
#include <gee.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <vala.h>
#include <gio/gio.h>
#include <json-glib/json-glib.h>
#include <valagee.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef enum  {
	LSP_TEXT_DOCUMENT_SYNC_KIND_Unset = -1,
	LSP_TEXT_DOCUMENT_SYNC_KIND_None = 0,
	LSP_TEXT_DOCUMENT_SYNC_KIND_Full = 1,
	LSP_TEXT_DOCUMENT_SYNC_KIND_Incremental = 2
} LspTextDocumentSyncKind;

#define LSP_TYPE_TEXT_DOCUMENT_SYNC_KIND (lsp_text_document_sync_kind_get_type ())
typedef enum  {
	LSP_DIAGNOSTIC_SEVERITY_Unset = 0,
	LSP_DIAGNOSTIC_SEVERITY_Error = 1,
	LSP_DIAGNOSTIC_SEVERITY_Warning = 2,
	LSP_DIAGNOSTIC_SEVERITY_Information = 3,
	LSP_DIAGNOSTIC_SEVERITY_Hint = 4
} LspDiagnosticSeverity;

#define LSP_TYPE_DIAGNOSTIC_SEVERITY (lsp_diagnostic_severity_get_type ())

#define LSP_TYPE_POSITION (lsp_position_get_type ())
#define LSP_POSITION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_POSITION, LspPosition))
#define LSP_POSITION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_POSITION, LspPositionClass))
#define LSP_IS_POSITION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_POSITION))
#define LSP_IS_POSITION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_POSITION))
#define LSP_POSITION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_POSITION, LspPositionClass))

typedef struct _LspPosition LspPosition;
typedef struct _LspPositionClass LspPositionClass;
typedef struct _LspPositionPrivate LspPositionPrivate;
enum  {
	LSP_POSITION_0_PROPERTY,
	LSP_POSITION_LINE_PROPERTY,
	LSP_POSITION_CHARACTER_PROPERTY,
	LSP_POSITION_NUM_PROPERTIES
};
static GParamSpec* lsp_position_properties[LSP_POSITION_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))

#define LSP_TYPE_RANGE (lsp_range_get_type ())
#define LSP_RANGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_RANGE, LspRange))
#define LSP_RANGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_RANGE, LspRangeClass))
#define LSP_IS_RANGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_RANGE))
#define LSP_IS_RANGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_RANGE))
#define LSP_RANGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_RANGE, LspRangeClass))

typedef struct _LspRange LspRange;
typedef struct _LspRangeClass LspRangeClass;
typedef struct _LspRangePrivate LspRangePrivate;
enum  {
	LSP_RANGE_0_PROPERTY,
	LSP_RANGE_START_PROPERTY,
	LSP_RANGE_END_PROPERTY,
	LSP_RANGE_NUM_PROPERTIES
};
static GParamSpec* lsp_range_properties[LSP_RANGE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define LSP_TYPE_DIAGNOSTIC (lsp_diagnostic_get_type ())
#define LSP_DIAGNOSTIC(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_DIAGNOSTIC, LspDiagnostic))
#define LSP_DIAGNOSTIC_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_DIAGNOSTIC, LspDiagnosticClass))
#define LSP_IS_DIAGNOSTIC(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_DIAGNOSTIC))
#define LSP_IS_DIAGNOSTIC_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_DIAGNOSTIC))
#define LSP_DIAGNOSTIC_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_DIAGNOSTIC, LspDiagnosticClass))

typedef struct _LspDiagnostic LspDiagnostic;
typedef struct _LspDiagnosticClass LspDiagnosticClass;
typedef struct _LspDiagnosticPrivate LspDiagnosticPrivate;
enum  {
	LSP_DIAGNOSTIC_0_PROPERTY,
	LSP_DIAGNOSTIC_RANGE_PROPERTY,
	LSP_DIAGNOSTIC_SEVERITY_PROPERTY,
	LSP_DIAGNOSTIC_CODE_PROPERTY,
	LSP_DIAGNOSTIC_SOURCE_PROPERTY,
	LSP_DIAGNOSTIC_MESSAGE_PROPERTY,
	LSP_DIAGNOSTIC_NUM_PROPERTIES
};
static GParamSpec* lsp_diagnostic_properties[LSP_DIAGNOSTIC_NUM_PROPERTIES];

#define LSP_TYPE_TEXT_DOCUMENT_CONTENT_CHANGE_EVENT (lsp_text_document_content_change_event_get_type ())
#define LSP_TEXT_DOCUMENT_CONTENT_CHANGE_EVENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_TEXT_DOCUMENT_CONTENT_CHANGE_EVENT, LspTextDocumentContentChangeEvent))
#define LSP_TEXT_DOCUMENT_CONTENT_CHANGE_EVENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_TEXT_DOCUMENT_CONTENT_CHANGE_EVENT, LspTextDocumentContentChangeEventClass))
#define LSP_IS_TEXT_DOCUMENT_CONTENT_CHANGE_EVENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_TEXT_DOCUMENT_CONTENT_CHANGE_EVENT))
#define LSP_IS_TEXT_DOCUMENT_CONTENT_CHANGE_EVENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_TEXT_DOCUMENT_CONTENT_CHANGE_EVENT))
#define LSP_TEXT_DOCUMENT_CONTENT_CHANGE_EVENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_TEXT_DOCUMENT_CONTENT_CHANGE_EVENT, LspTextDocumentContentChangeEventClass))

typedef struct _LspTextDocumentContentChangeEvent LspTextDocumentContentChangeEvent;
typedef struct _LspTextDocumentContentChangeEventClass LspTextDocumentContentChangeEventClass;
typedef struct _LspTextDocumentContentChangeEventPrivate LspTextDocumentContentChangeEventPrivate;
enum  {
	LSP_TEXT_DOCUMENT_CONTENT_CHANGE_EVENT_0_PROPERTY,
	LSP_TEXT_DOCUMENT_CONTENT_CHANGE_EVENT_RANGE_PROPERTY,
	LSP_TEXT_DOCUMENT_CONTENT_CHANGE_EVENT_RANGE_LENGTH_PROPERTY,
	LSP_TEXT_DOCUMENT_CONTENT_CHANGE_EVENT_TEXT_PROPERTY,
	LSP_TEXT_DOCUMENT_CONTENT_CHANGE_EVENT_NUM_PROPERTIES
};
static GParamSpec* lsp_text_document_content_change_event_properties[LSP_TEXT_DOCUMENT_CONTENT_CHANGE_EVENT_NUM_PROPERTIES];
typedef enum  {
	LSP_MESSAGE_TYPE_Error = 1,
	LSP_MESSAGE_TYPE_Warning = 2,
	LSP_MESSAGE_TYPE_Info = 3,
	LSP_MESSAGE_TYPE_Log = 4
} LspMessageType;

#define LSP_TYPE_MESSAGE_TYPE (lsp_message_type_get_type ())

#define LSP_TYPE_TEXT_DOCUMENT_IDENTIFIER (lsp_text_document_identifier_get_type ())
#define LSP_TEXT_DOCUMENT_IDENTIFIER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_TEXT_DOCUMENT_IDENTIFIER, LspTextDocumentIdentifier))
#define LSP_TEXT_DOCUMENT_IDENTIFIER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_TEXT_DOCUMENT_IDENTIFIER, LspTextDocumentIdentifierClass))
#define LSP_IS_TEXT_DOCUMENT_IDENTIFIER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_TEXT_DOCUMENT_IDENTIFIER))
#define LSP_IS_TEXT_DOCUMENT_IDENTIFIER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_TEXT_DOCUMENT_IDENTIFIER))
#define LSP_TEXT_DOCUMENT_IDENTIFIER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_TEXT_DOCUMENT_IDENTIFIER, LspTextDocumentIdentifierClass))

typedef struct _LspTextDocumentIdentifier LspTextDocumentIdentifier;
typedef struct _LspTextDocumentIdentifierClass LspTextDocumentIdentifierClass;
typedef struct _LspTextDocumentIdentifierPrivate LspTextDocumentIdentifierPrivate;
enum  {
	LSP_TEXT_DOCUMENT_IDENTIFIER_0_PROPERTY,
	LSP_TEXT_DOCUMENT_IDENTIFIER_URI_PROPERTY,
	LSP_TEXT_DOCUMENT_IDENTIFIER_NUM_PROPERTIES
};
static GParamSpec* lsp_text_document_identifier_properties[LSP_TEXT_DOCUMENT_IDENTIFIER_NUM_PROPERTIES];

#define LSP_TYPE_VERSIONED_TEXT_DOCUMENT_IDENTIFIER (lsp_versioned_text_document_identifier_get_type ())
#define LSP_VERSIONED_TEXT_DOCUMENT_IDENTIFIER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_VERSIONED_TEXT_DOCUMENT_IDENTIFIER, LspVersionedTextDocumentIdentifier))
#define LSP_VERSIONED_TEXT_DOCUMENT_IDENTIFIER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_VERSIONED_TEXT_DOCUMENT_IDENTIFIER, LspVersionedTextDocumentIdentifierClass))
#define LSP_IS_VERSIONED_TEXT_DOCUMENT_IDENTIFIER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_VERSIONED_TEXT_DOCUMENT_IDENTIFIER))
#define LSP_IS_VERSIONED_TEXT_DOCUMENT_IDENTIFIER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_VERSIONED_TEXT_DOCUMENT_IDENTIFIER))
#define LSP_VERSIONED_TEXT_DOCUMENT_IDENTIFIER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_VERSIONED_TEXT_DOCUMENT_IDENTIFIER, LspVersionedTextDocumentIdentifierClass))

typedef struct _LspVersionedTextDocumentIdentifier LspVersionedTextDocumentIdentifier;
typedef struct _LspVersionedTextDocumentIdentifierClass LspVersionedTextDocumentIdentifierClass;
typedef struct _LspVersionedTextDocumentIdentifierPrivate LspVersionedTextDocumentIdentifierPrivate;
enum  {
	LSP_VERSIONED_TEXT_DOCUMENT_IDENTIFIER_0_PROPERTY,
	LSP_VERSIONED_TEXT_DOCUMENT_IDENTIFIER_VERSION_PROPERTY,
	LSP_VERSIONED_TEXT_DOCUMENT_IDENTIFIER_NUM_PROPERTIES
};
static GParamSpec* lsp_versioned_text_document_identifier_properties[LSP_VERSIONED_TEXT_DOCUMENT_IDENTIFIER_NUM_PROPERTIES];

#define LSP_TYPE_TEXT_DOCUMENT_POSITION_PARAMS (lsp_text_document_position_params_get_type ())
#define LSP_TEXT_DOCUMENT_POSITION_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_TEXT_DOCUMENT_POSITION_PARAMS, LspTextDocumentPositionParams))
#define LSP_TEXT_DOCUMENT_POSITION_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_TEXT_DOCUMENT_POSITION_PARAMS, LspTextDocumentPositionParamsClass))
#define LSP_IS_TEXT_DOCUMENT_POSITION_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_TEXT_DOCUMENT_POSITION_PARAMS))
#define LSP_IS_TEXT_DOCUMENT_POSITION_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_TEXT_DOCUMENT_POSITION_PARAMS))
#define LSP_TEXT_DOCUMENT_POSITION_PARAMS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_TEXT_DOCUMENT_POSITION_PARAMS, LspTextDocumentPositionParamsClass))

typedef struct _LspTextDocumentPositionParams LspTextDocumentPositionParams;
typedef struct _LspTextDocumentPositionParamsClass LspTextDocumentPositionParamsClass;
typedef struct _LspTextDocumentPositionParamsPrivate LspTextDocumentPositionParamsPrivate;
enum  {
	LSP_TEXT_DOCUMENT_POSITION_PARAMS_0_PROPERTY,
	LSP_TEXT_DOCUMENT_POSITION_PARAMS_TEXT_DOCUMENT_PROPERTY,
	LSP_TEXT_DOCUMENT_POSITION_PARAMS_POSITION_PROPERTY,
	LSP_TEXT_DOCUMENT_POSITION_PARAMS_NUM_PROPERTIES
};
static GParamSpec* lsp_text_document_position_params_properties[LSP_TEXT_DOCUMENT_POSITION_PARAMS_NUM_PROPERTIES];

#define LSP_TYPE_REFERENCE_PARAMS (lsp_reference_params_get_type ())
#define LSP_REFERENCE_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_REFERENCE_PARAMS, LspReferenceParams))
#define LSP_REFERENCE_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_REFERENCE_PARAMS, LspReferenceParamsClass))
#define LSP_IS_REFERENCE_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_REFERENCE_PARAMS))
#define LSP_IS_REFERENCE_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_REFERENCE_PARAMS))
#define LSP_REFERENCE_PARAMS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_REFERENCE_PARAMS, LspReferenceParamsClass))

typedef struct _LspReferenceParams LspReferenceParams;
typedef struct _LspReferenceParamsClass LspReferenceParamsClass;
typedef struct _LspReferenceParamsPrivate LspReferenceParamsPrivate;

#define LSP_REFERENCE_PARAMS_TYPE_REFERENCE_CONTEXT (lsp_reference_params_reference_context_get_type ())
#define LSP_REFERENCE_PARAMS_REFERENCE_CONTEXT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_REFERENCE_PARAMS_TYPE_REFERENCE_CONTEXT, LspReferenceParamsReferenceContext))
#define LSP_REFERENCE_PARAMS_REFERENCE_CONTEXT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_REFERENCE_PARAMS_TYPE_REFERENCE_CONTEXT, LspReferenceParamsReferenceContextClass))
#define LSP_REFERENCE_PARAMS_IS_REFERENCE_CONTEXT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_REFERENCE_PARAMS_TYPE_REFERENCE_CONTEXT))
#define LSP_REFERENCE_PARAMS_IS_REFERENCE_CONTEXT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_REFERENCE_PARAMS_TYPE_REFERENCE_CONTEXT))
#define LSP_REFERENCE_PARAMS_REFERENCE_CONTEXT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_REFERENCE_PARAMS_TYPE_REFERENCE_CONTEXT, LspReferenceParamsReferenceContextClass))

typedef struct _LspReferenceParamsReferenceContext LspReferenceParamsReferenceContext;
typedef struct _LspReferenceParamsReferenceContextClass LspReferenceParamsReferenceContextClass;
enum  {
	LSP_REFERENCE_PARAMS_0_PROPERTY,
	LSP_REFERENCE_PARAMS_CONTEXT_PROPERTY,
	LSP_REFERENCE_PARAMS_NUM_PROPERTIES
};
static GParamSpec* lsp_reference_params_properties[LSP_REFERENCE_PARAMS_NUM_PROPERTIES];
typedef struct _LspReferenceParamsReferenceContextPrivate LspReferenceParamsReferenceContextPrivate;
enum  {
	LSP_REFERENCE_PARAMS_REFERENCE_CONTEXT_0_PROPERTY,
	LSP_REFERENCE_PARAMS_REFERENCE_CONTEXT_INCLUDE_DECLARATION_PROPERTY,
	LSP_REFERENCE_PARAMS_REFERENCE_CONTEXT_NUM_PROPERTIES
};
static GParamSpec* lsp_reference_params_reference_context_properties[LSP_REFERENCE_PARAMS_REFERENCE_CONTEXT_NUM_PROPERTIES];

#define LSP_TYPE_LOCATION (lsp_location_get_type ())
#define LSP_LOCATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_LOCATION, LspLocation))
#define LSP_LOCATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_LOCATION, LspLocationClass))
#define LSP_IS_LOCATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_LOCATION))
#define LSP_IS_LOCATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_LOCATION))
#define LSP_LOCATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_LOCATION, LspLocationClass))

typedef struct _LspLocation LspLocation;
typedef struct _LspLocationClass LspLocationClass;
typedef struct _LspLocationPrivate LspLocationPrivate;
enum  {
	LSP_LOCATION_0_PROPERTY,
	LSP_LOCATION_URI_PROPERTY,
	LSP_LOCATION_RANGE_PROPERTY,
	LSP_LOCATION_NUM_PROPERTIES
};
static GParamSpec* lsp_location_properties[LSP_LOCATION_NUM_PROPERTIES];
typedef enum  {
	LSP_DOCUMENT_HIGHLIGHT_KIND_Text = 1,
	LSP_DOCUMENT_HIGHLIGHT_KIND_Read = 2,
	LSP_DOCUMENT_HIGHLIGHT_KIND_Write = 3
} LspDocumentHighlightKind;

#define LSP_TYPE_DOCUMENT_HIGHLIGHT_KIND (lsp_document_highlight_kind_get_type ())

#define LSP_TYPE_DOCUMENT_HIGHLIGHT (lsp_document_highlight_get_type ())
#define LSP_DOCUMENT_HIGHLIGHT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_DOCUMENT_HIGHLIGHT, LspDocumentHighlight))
#define LSP_DOCUMENT_HIGHLIGHT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_DOCUMENT_HIGHLIGHT, LspDocumentHighlightClass))
#define LSP_IS_DOCUMENT_HIGHLIGHT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_DOCUMENT_HIGHLIGHT))
#define LSP_IS_DOCUMENT_HIGHLIGHT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_DOCUMENT_HIGHLIGHT))
#define LSP_DOCUMENT_HIGHLIGHT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_DOCUMENT_HIGHLIGHT, LspDocumentHighlightClass))

typedef struct _LspDocumentHighlight LspDocumentHighlight;
typedef struct _LspDocumentHighlightClass LspDocumentHighlightClass;
typedef struct _LspDocumentHighlightPrivate LspDocumentHighlightPrivate;
enum  {
	LSP_DOCUMENT_HIGHLIGHT_0_PROPERTY,
	LSP_DOCUMENT_HIGHLIGHT_RANGE_PROPERTY,
	LSP_DOCUMENT_HIGHLIGHT_KIND_PROPERTY,
	LSP_DOCUMENT_HIGHLIGHT_NUM_PROPERTIES
};
static GParamSpec* lsp_document_highlight_properties[LSP_DOCUMENT_HIGHLIGHT_NUM_PROPERTIES];

#define LSP_TYPE_DOCUMENT_SYMBOL_PARAMS (lsp_document_symbol_params_get_type ())
#define LSP_DOCUMENT_SYMBOL_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_DOCUMENT_SYMBOL_PARAMS, LspDocumentSymbolParams))
#define LSP_DOCUMENT_SYMBOL_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_DOCUMENT_SYMBOL_PARAMS, LspDocumentSymbolParamsClass))
#define LSP_IS_DOCUMENT_SYMBOL_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_DOCUMENT_SYMBOL_PARAMS))
#define LSP_IS_DOCUMENT_SYMBOL_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_DOCUMENT_SYMBOL_PARAMS))
#define LSP_DOCUMENT_SYMBOL_PARAMS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_DOCUMENT_SYMBOL_PARAMS, LspDocumentSymbolParamsClass))

typedef struct _LspDocumentSymbolParams LspDocumentSymbolParams;
typedef struct _LspDocumentSymbolParamsClass LspDocumentSymbolParamsClass;
typedef struct _LspDocumentSymbolParamsPrivate LspDocumentSymbolParamsPrivate;
enum  {
	LSP_DOCUMENT_SYMBOL_PARAMS_0_PROPERTY,
	LSP_DOCUMENT_SYMBOL_PARAMS_TEXT_DOCUMENT_PROPERTY,
	LSP_DOCUMENT_SYMBOL_PARAMS_NUM_PROPERTIES
};
static GParamSpec* lsp_document_symbol_params_properties[LSP_DOCUMENT_SYMBOL_PARAMS_NUM_PROPERTIES];

#define LSP_TYPE_DOCUMENT_SYMBOL (lsp_document_symbol_get_type ())
#define LSP_DOCUMENT_SYMBOL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_DOCUMENT_SYMBOL, LspDocumentSymbol))
#define LSP_DOCUMENT_SYMBOL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_DOCUMENT_SYMBOL, LspDocumentSymbolClass))
#define LSP_IS_DOCUMENT_SYMBOL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_DOCUMENT_SYMBOL))
#define LSP_IS_DOCUMENT_SYMBOL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_DOCUMENT_SYMBOL))
#define LSP_DOCUMENT_SYMBOL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_DOCUMENT_SYMBOL, LspDocumentSymbolClass))

typedef struct _LspDocumentSymbol LspDocumentSymbol;
typedef struct _LspDocumentSymbolClass LspDocumentSymbolClass;
typedef struct _LspDocumentSymbolPrivate LspDocumentSymbolPrivate;
typedef enum  {
	LSP_SYMBOL_KIND_File = 1,
	LSP_SYMBOL_KIND_Module = 2,
	LSP_SYMBOL_KIND_Namespace = 3,
	LSP_SYMBOL_KIND_Package = 4,
	LSP_SYMBOL_KIND_Class = 5,
	LSP_SYMBOL_KIND_Method = 6,
	LSP_SYMBOL_KIND_Property = 7,
	LSP_SYMBOL_KIND_Field = 8,
	LSP_SYMBOL_KIND_Constructor = 9,
	LSP_SYMBOL_KIND_Enum = 10,
	LSP_SYMBOL_KIND_Interface = 11,
	LSP_SYMBOL_KIND_Function = 12,
	LSP_SYMBOL_KIND_Variable = 13,
	LSP_SYMBOL_KIND_Constant = 14,
	LSP_SYMBOL_KIND_String = 15,
	LSP_SYMBOL_KIND_Number = 16,
	LSP_SYMBOL_KIND_Boolean = 17,
	LSP_SYMBOL_KIND_Array = 18,
	LSP_SYMBOL_KIND_Object = 19,
	LSP_SYMBOL_KIND_Key = 20,
	LSP_SYMBOL_KIND_Null = 21,
	LSP_SYMBOL_KIND_EnumMember = 22,
	LSP_SYMBOL_KIND_Struct = 23,
	LSP_SYMBOL_KIND_Event = 24,
	LSP_SYMBOL_KIND_Operator = 25,
	LSP_SYMBOL_KIND_TypeParameter = 26
} LspSymbolKind;

#define LSP_TYPE_SYMBOL_KIND (lsp_symbol_kind_get_type ())
enum  {
	LSP_DOCUMENT_SYMBOL_0_PROPERTY,
	LSP_DOCUMENT_SYMBOL_NAME_PROPERTY,
	LSP_DOCUMENT_SYMBOL_DETAIL_PROPERTY,
	LSP_DOCUMENT_SYMBOL_KIND_PROPERTY,
	LSP_DOCUMENT_SYMBOL_DEPRECATED_PROPERTY,
	LSP_DOCUMENT_SYMBOL_RANGE_PROPERTY,
	LSP_DOCUMENT_SYMBOL_SELECTION_RANGE_PROPERTY,
	LSP_DOCUMENT_SYMBOL_CHILDREN_PROPERTY,
	LSP_DOCUMENT_SYMBOL_NUM_PROPERTIES
};
static GParamSpec* lsp_document_symbol_properties[LSP_DOCUMENT_SYMBOL_NUM_PROPERTIES];
#define _vala_source_reference_unref0(var) ((var == NULL) ? NULL : (var = (vala_source_reference_unref (var), NULL)))
#define _vala_code_node_unref0(var) ((var == NULL) ? NULL : (var = (vala_code_node_unref (var), NULL)))
#define _json_array_unref0(var) ((var == NULL) ? NULL : (var = (json_array_unref (var), NULL)))

#define LSP_TYPE_SYMBOL_INFORMATION (lsp_symbol_information_get_type ())
#define LSP_SYMBOL_INFORMATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_SYMBOL_INFORMATION, LspSymbolInformation))
#define LSP_SYMBOL_INFORMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_SYMBOL_INFORMATION, LspSymbolInformationClass))
#define LSP_IS_SYMBOL_INFORMATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_SYMBOL_INFORMATION))
#define LSP_IS_SYMBOL_INFORMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_SYMBOL_INFORMATION))
#define LSP_SYMBOL_INFORMATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_SYMBOL_INFORMATION, LspSymbolInformationClass))

typedef struct _LspSymbolInformation LspSymbolInformation;
typedef struct _LspSymbolInformationClass LspSymbolInformationClass;
typedef struct _LspSymbolInformationPrivate LspSymbolInformationPrivate;
enum  {
	LSP_SYMBOL_INFORMATION_0_PROPERTY,
	LSP_SYMBOL_INFORMATION_NAME_PROPERTY,
	LSP_SYMBOL_INFORMATION_KIND_PROPERTY,
	LSP_SYMBOL_INFORMATION_LOCATION_PROPERTY,
	LSP_SYMBOL_INFORMATION_CONTAINER_NAME_PROPERTY,
	LSP_SYMBOL_INFORMATION_NUM_PROPERTIES
};
static GParamSpec* lsp_symbol_information_properties[LSP_SYMBOL_INFORMATION_NUM_PROPERTIES];

#define LSP_TYPE_COMPLETION_LIST (lsp_completion_list_get_type ())
#define LSP_COMPLETION_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_COMPLETION_LIST, LspCompletionList))
#define LSP_COMPLETION_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_COMPLETION_LIST, LspCompletionListClass))
#define LSP_IS_COMPLETION_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_COMPLETION_LIST))
#define LSP_IS_COMPLETION_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_COMPLETION_LIST))
#define LSP_COMPLETION_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_COMPLETION_LIST, LspCompletionListClass))

typedef struct _LspCompletionList LspCompletionList;
typedef struct _LspCompletionListClass LspCompletionListClass;
typedef struct _LspCompletionListPrivate LspCompletionListPrivate;

#define LSP_TYPE_COMPLETION_ITEM (lsp_completion_item_get_type ())
#define LSP_COMPLETION_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_COMPLETION_ITEM, LspCompletionItem))
#define LSP_COMPLETION_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_COMPLETION_ITEM, LspCompletionItemClass))
#define LSP_IS_COMPLETION_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_COMPLETION_ITEM))
#define LSP_IS_COMPLETION_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_COMPLETION_ITEM))
#define LSP_COMPLETION_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_COMPLETION_ITEM, LspCompletionItemClass))

typedef struct _LspCompletionItem LspCompletionItem;
typedef struct _LspCompletionItemClass LspCompletionItemClass;
enum  {
	LSP_COMPLETION_LIST_0_PROPERTY,
	LSP_COMPLETION_LIST_IS_INCOMPLETE_PROPERTY,
	LSP_COMPLETION_LIST_ITEMS_PROPERTY,
	LSP_COMPLETION_LIST_NUM_PROPERTIES
};
static GParamSpec* lsp_completion_list_properties[LSP_COMPLETION_LIST_NUM_PROPERTIES];
typedef enum  {
	LSP_COMPLETION_TRIGGER_KIND_Invoked = 1,
	LSP_COMPLETION_TRIGGER_KIND_TriggerCharacter = 2,
	LSP_COMPLETION_TRIGGER_KIND_TriggerForIncompleteCompletions = 3
} LspCompletionTriggerKind;

#define LSP_TYPE_COMPLETION_TRIGGER_KIND (lsp_completion_trigger_kind_get_type ())

#define LSP_TYPE_COMPLETION_CONTEXT (lsp_completion_context_get_type ())
#define LSP_COMPLETION_CONTEXT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_COMPLETION_CONTEXT, LspCompletionContext))
#define LSP_COMPLETION_CONTEXT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_COMPLETION_CONTEXT, LspCompletionContextClass))
#define LSP_IS_COMPLETION_CONTEXT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_COMPLETION_CONTEXT))
#define LSP_IS_COMPLETION_CONTEXT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_COMPLETION_CONTEXT))
#define LSP_COMPLETION_CONTEXT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_COMPLETION_CONTEXT, LspCompletionContextClass))

typedef struct _LspCompletionContext LspCompletionContext;
typedef struct _LspCompletionContextClass LspCompletionContextClass;
typedef struct _LspCompletionContextPrivate LspCompletionContextPrivate;
enum  {
	LSP_COMPLETION_CONTEXT_0_PROPERTY,
	LSP_COMPLETION_CONTEXT_TRIGGER_KIND_PROPERTY,
	LSP_COMPLETION_CONTEXT_TRIGGER_CHARACTER_PROPERTY,
	LSP_COMPLETION_CONTEXT_NUM_PROPERTIES
};
static GParamSpec* lsp_completion_context_properties[LSP_COMPLETION_CONTEXT_NUM_PROPERTIES];

#define LSP_TYPE_COMPLETION_PARAMS (lsp_completion_params_get_type ())
#define LSP_COMPLETION_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_COMPLETION_PARAMS, LspCompletionParams))
#define LSP_COMPLETION_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_COMPLETION_PARAMS, LspCompletionParamsClass))
#define LSP_IS_COMPLETION_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_COMPLETION_PARAMS))
#define LSP_IS_COMPLETION_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_COMPLETION_PARAMS))
#define LSP_COMPLETION_PARAMS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_COMPLETION_PARAMS, LspCompletionParamsClass))

typedef struct _LspCompletionParams LspCompletionParams;
typedef struct _LspCompletionParamsClass LspCompletionParamsClass;
typedef struct _LspCompletionParamsPrivate LspCompletionParamsPrivate;
enum  {
	LSP_COMPLETION_PARAMS_0_PROPERTY,
	LSP_COMPLETION_PARAMS_CONTEXT_PROPERTY,
	LSP_COMPLETION_PARAMS_NUM_PROPERTIES
};
static GParamSpec* lsp_completion_params_properties[LSP_COMPLETION_PARAMS_NUM_PROPERTIES];
typedef enum  {
	LSP_COMPLETION_ITEM_TAG_Deprecated = 1
} LspCompletionItemTag;

#define LSP_TYPE_COMPLETION_ITEM_TAG (lsp_completion_item_tag_get_type ())
typedef enum  {
	LSP_INSERT_TEXT_FORMAT_PlainText = 1,
	LSP_INSERT_TEXT_FORMAT_Snippet = 2
} LspInsertTextFormat;

#define LSP_TYPE_INSERT_TEXT_FORMAT (lsp_insert_text_format_get_type ())
typedef struct _LspCompletionItemPrivate LspCompletionItemPrivate;
typedef enum  {
	LSP_COMPLETION_ITEM_KIND_Text = 1,
	LSP_COMPLETION_ITEM_KIND_Method = 2,
	LSP_COMPLETION_ITEM_KIND_Function = 3,
	LSP_COMPLETION_ITEM_KIND_Constructor = 4,
	LSP_COMPLETION_ITEM_KIND_Field = 5,
	LSP_COMPLETION_ITEM_KIND_Variable = 6,
	LSP_COMPLETION_ITEM_KIND_Class = 7,
	LSP_COMPLETION_ITEM_KIND_Interface = 8,
	LSP_COMPLETION_ITEM_KIND_Module = 9,
	LSP_COMPLETION_ITEM_KIND_Property = 10,
	LSP_COMPLETION_ITEM_KIND_Unit = 11,
	LSP_COMPLETION_ITEM_KIND_Value = 12,
	LSP_COMPLETION_ITEM_KIND_Enum = 13,
	LSP_COMPLETION_ITEM_KIND_Keyword = 14,
	LSP_COMPLETION_ITEM_KIND_Snippet = 15,
	LSP_COMPLETION_ITEM_KIND_Color = 16,
	LSP_COMPLETION_ITEM_KIND_File = 17,
	LSP_COMPLETION_ITEM_KIND_Reference = 18,
	LSP_COMPLETION_ITEM_KIND_Folder = 19,
	LSP_COMPLETION_ITEM_KIND_EnumMember = 20,
	LSP_COMPLETION_ITEM_KIND_Constant = 21,
	LSP_COMPLETION_ITEM_KIND_Struct = 22,
	LSP_COMPLETION_ITEM_KIND_Event = 23,
	LSP_COMPLETION_ITEM_KIND_Operator = 24,
	LSP_COMPLETION_ITEM_KIND_TypeParameter = 25
} LspCompletionItemKind;

#define LSP_TYPE_COMPLETION_ITEM_KIND (lsp_completion_item_kind_get_type ())

#define LSP_TYPE_MARKUP_CONTENT (lsp_markup_content_get_type ())
#define LSP_MARKUP_CONTENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_MARKUP_CONTENT, LspMarkupContent))
#define LSP_MARKUP_CONTENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_MARKUP_CONTENT, LspMarkupContentClass))
#define LSP_IS_MARKUP_CONTENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_MARKUP_CONTENT))
#define LSP_IS_MARKUP_CONTENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_MARKUP_CONTENT))
#define LSP_MARKUP_CONTENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_MARKUP_CONTENT, LspMarkupContentClass))

typedef struct _LspMarkupContent LspMarkupContent;
typedef struct _LspMarkupContentClass LspMarkupContentClass;
enum  {
	LSP_COMPLETION_ITEM_0_PROPERTY,
	LSP_COMPLETION_ITEM_LABEL_PROPERTY,
	LSP_COMPLETION_ITEM_KIND_PROPERTY,
	LSP_COMPLETION_ITEM_DETAIL_PROPERTY,
	LSP_COMPLETION_ITEM_DOCUMENTATION_PROPERTY,
	LSP_COMPLETION_ITEM_DEPRECATED_PROPERTY,
	LSP_COMPLETION_ITEM_TAGS_PROPERTY,
	LSP_COMPLETION_ITEM_INSERT_TEXT_PROPERTY,
	LSP_COMPLETION_ITEM_INSERT_TEXT_FORMAT_PROPERTY,
	LSP_COMPLETION_ITEM_NUM_PROPERTIES
};
static GParamSpec* lsp_completion_item_properties[LSP_COMPLETION_ITEM_NUM_PROPERTIES];

#define VLS_TYPE_DOC_COMMENT (vls_doc_comment_get_type ())
#define VLS_DOC_COMMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VLS_TYPE_DOC_COMMENT, VlsDocComment))
#define VLS_DOC_COMMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VLS_TYPE_DOC_COMMENT, VlsDocCommentClass))
#define VLS_IS_DOC_COMMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VLS_TYPE_DOC_COMMENT))
#define VLS_IS_DOC_COMMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VLS_TYPE_DOC_COMMENT))
#define VLS_DOC_COMMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VLS_TYPE_DOC_COMMENT, VlsDocCommentClass))

typedef struct _VlsDocComment VlsDocComment;
typedef struct _VlsDocCommentClass VlsDocCommentClass;
typedef struct _LspMarkupContentPrivate LspMarkupContentPrivate;
enum  {
	LSP_MARKUP_CONTENT_0_PROPERTY,
	LSP_MARKUP_CONTENT_KIND_PROPERTY,
	LSP_MARKUP_CONTENT_VALUE_PROPERTY,
	LSP_MARKUP_CONTENT_NUM_PROPERTIES
};
static GParamSpec* lsp_markup_content_properties[LSP_MARKUP_CONTENT_NUM_PROPERTIES];

#define LSP_TYPE_DOCUMENT_SYMBOL_CAPABILITIES (lsp_document_symbol_capabilities_get_type ())
#define LSP_DOCUMENT_SYMBOL_CAPABILITIES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_DOCUMENT_SYMBOL_CAPABILITIES, LspDocumentSymbolCapabilities))
#define LSP_DOCUMENT_SYMBOL_CAPABILITIES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_DOCUMENT_SYMBOL_CAPABILITIES, LspDocumentSymbolCapabilitiesClass))
#define LSP_IS_DOCUMENT_SYMBOL_CAPABILITIES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_DOCUMENT_SYMBOL_CAPABILITIES))
#define LSP_IS_DOCUMENT_SYMBOL_CAPABILITIES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_DOCUMENT_SYMBOL_CAPABILITIES))
#define LSP_DOCUMENT_SYMBOL_CAPABILITIES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_DOCUMENT_SYMBOL_CAPABILITIES, LspDocumentSymbolCapabilitiesClass))

typedef struct _LspDocumentSymbolCapabilities LspDocumentSymbolCapabilities;
typedef struct _LspDocumentSymbolCapabilitiesClass LspDocumentSymbolCapabilitiesClass;
typedef struct _LspDocumentSymbolCapabilitiesPrivate LspDocumentSymbolCapabilitiesPrivate;
enum  {
	LSP_DOCUMENT_SYMBOL_CAPABILITIES_0_PROPERTY,
	LSP_DOCUMENT_SYMBOL_CAPABILITIES_HIERARCHICAL_DOCUMENT_SYMBOL_SUPPORT_PROPERTY,
	LSP_DOCUMENT_SYMBOL_CAPABILITIES_NUM_PROPERTIES
};
static GParamSpec* lsp_document_symbol_capabilities_properties[LSP_DOCUMENT_SYMBOL_CAPABILITIES_NUM_PROPERTIES];

#define LSP_TYPE_RENAME_CLIENT_CAPABILITIES (lsp_rename_client_capabilities_get_type ())
#define LSP_RENAME_CLIENT_CAPABILITIES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_RENAME_CLIENT_CAPABILITIES, LspRenameClientCapabilities))
#define LSP_RENAME_CLIENT_CAPABILITIES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_RENAME_CLIENT_CAPABILITIES, LspRenameClientCapabilitiesClass))
#define LSP_IS_RENAME_CLIENT_CAPABILITIES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_RENAME_CLIENT_CAPABILITIES))
#define LSP_IS_RENAME_CLIENT_CAPABILITIES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_RENAME_CLIENT_CAPABILITIES))
#define LSP_RENAME_CLIENT_CAPABILITIES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_RENAME_CLIENT_CAPABILITIES, LspRenameClientCapabilitiesClass))

typedef struct _LspRenameClientCapabilities LspRenameClientCapabilities;
typedef struct _LspRenameClientCapabilitiesClass LspRenameClientCapabilitiesClass;
typedef struct _LspRenameClientCapabilitiesPrivate LspRenameClientCapabilitiesPrivate;
enum  {
	LSP_RENAME_CLIENT_CAPABILITIES_0_PROPERTY,
	LSP_RENAME_CLIENT_CAPABILITIES_PREPARE_SUPPORT_PROPERTY,
	LSP_RENAME_CLIENT_CAPABILITIES_NUM_PROPERTIES
};
static GParamSpec* lsp_rename_client_capabilities_properties[LSP_RENAME_CLIENT_CAPABILITIES_NUM_PROPERTIES];

#define LSP_TYPE_TEXT_DOCUMENT_CLIENT_CAPABILITIES (lsp_text_document_client_capabilities_get_type ())
#define LSP_TEXT_DOCUMENT_CLIENT_CAPABILITIES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_TEXT_DOCUMENT_CLIENT_CAPABILITIES, LspTextDocumentClientCapabilities))
#define LSP_TEXT_DOCUMENT_CLIENT_CAPABILITIES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_TEXT_DOCUMENT_CLIENT_CAPABILITIES, LspTextDocumentClientCapabilitiesClass))
#define LSP_IS_TEXT_DOCUMENT_CLIENT_CAPABILITIES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_TEXT_DOCUMENT_CLIENT_CAPABILITIES))
#define LSP_IS_TEXT_DOCUMENT_CLIENT_CAPABILITIES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_TEXT_DOCUMENT_CLIENT_CAPABILITIES))
#define LSP_TEXT_DOCUMENT_CLIENT_CAPABILITIES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_TEXT_DOCUMENT_CLIENT_CAPABILITIES, LspTextDocumentClientCapabilitiesClass))

typedef struct _LspTextDocumentClientCapabilities LspTextDocumentClientCapabilities;
typedef struct _LspTextDocumentClientCapabilitiesClass LspTextDocumentClientCapabilitiesClass;
typedef struct _LspTextDocumentClientCapabilitiesPrivate LspTextDocumentClientCapabilitiesPrivate;
enum  {
	LSP_TEXT_DOCUMENT_CLIENT_CAPABILITIES_0_PROPERTY,
	LSP_TEXT_DOCUMENT_CLIENT_CAPABILITIES_DOCUMENT_SYMBOL_PROPERTY,
	LSP_TEXT_DOCUMENT_CLIENT_CAPABILITIES_RENAME_PROPERTY,
	LSP_TEXT_DOCUMENT_CLIENT_CAPABILITIES_NUM_PROPERTIES
};
static GParamSpec* lsp_text_document_client_capabilities_properties[LSP_TEXT_DOCUMENT_CLIENT_CAPABILITIES_NUM_PROPERTIES];

#define LSP_TYPE_CLIENT_CAPABILITIES (lsp_client_capabilities_get_type ())
#define LSP_CLIENT_CAPABILITIES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_CLIENT_CAPABILITIES, LspClientCapabilities))
#define LSP_CLIENT_CAPABILITIES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_CLIENT_CAPABILITIES, LspClientCapabilitiesClass))
#define LSP_IS_CLIENT_CAPABILITIES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_CLIENT_CAPABILITIES))
#define LSP_IS_CLIENT_CAPABILITIES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_CLIENT_CAPABILITIES))
#define LSP_CLIENT_CAPABILITIES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_CLIENT_CAPABILITIES, LspClientCapabilitiesClass))

typedef struct _LspClientCapabilities LspClientCapabilities;
typedef struct _LspClientCapabilitiesClass LspClientCapabilitiesClass;
typedef struct _LspClientCapabilitiesPrivate LspClientCapabilitiesPrivate;
enum  {
	LSP_CLIENT_CAPABILITIES_0_PROPERTY,
	LSP_CLIENT_CAPABILITIES_TEXT_DOCUMENT_PROPERTY,
	LSP_CLIENT_CAPABILITIES_NUM_PROPERTIES
};
static GParamSpec* lsp_client_capabilities_properties[LSP_CLIENT_CAPABILITIES_NUM_PROPERTIES];

#define LSP_TYPE_INITIALIZE_PARAMS (lsp_initialize_params_get_type ())
#define LSP_INITIALIZE_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_INITIALIZE_PARAMS, LspInitializeParams))
#define LSP_INITIALIZE_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_INITIALIZE_PARAMS, LspInitializeParamsClass))
#define LSP_IS_INITIALIZE_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_INITIALIZE_PARAMS))
#define LSP_IS_INITIALIZE_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_INITIALIZE_PARAMS))
#define LSP_INITIALIZE_PARAMS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_INITIALIZE_PARAMS, LspInitializeParamsClass))

typedef struct _LspInitializeParams LspInitializeParams;
typedef struct _LspInitializeParamsClass LspInitializeParamsClass;
typedef struct _LspInitializeParamsPrivate LspInitializeParamsPrivate;
enum  {
	LSP_INITIALIZE_PARAMS_0_PROPERTY,
	LSP_INITIALIZE_PARAMS_PROCESS_ID_PROPERTY,
	LSP_INITIALIZE_PARAMS_ROOT_PATH_PROPERTY,
	LSP_INITIALIZE_PARAMS_ROOT_URI_PROPERTY,
	LSP_INITIALIZE_PARAMS_CAPABILITIES_PROPERTY,
	LSP_INITIALIZE_PARAMS_NUM_PROPERTIES
};
static GParamSpec* lsp_initialize_params_properties[LSP_INITIALIZE_PARAMS_NUM_PROPERTIES];

#define LSP_TYPE_SIGNATURE_INFORMATION (lsp_signature_information_get_type ())
#define LSP_SIGNATURE_INFORMATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_SIGNATURE_INFORMATION, LspSignatureInformation))
#define LSP_SIGNATURE_INFORMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_SIGNATURE_INFORMATION, LspSignatureInformationClass))
#define LSP_IS_SIGNATURE_INFORMATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_SIGNATURE_INFORMATION))
#define LSP_IS_SIGNATURE_INFORMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_SIGNATURE_INFORMATION))
#define LSP_SIGNATURE_INFORMATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_SIGNATURE_INFORMATION, LspSignatureInformationClass))

typedef struct _LspSignatureInformation LspSignatureInformation;
typedef struct _LspSignatureInformationClass LspSignatureInformationClass;
typedef struct _LspSignatureInformationPrivate LspSignatureInformationPrivate;

#define LSP_TYPE_PARAMETER_INFORMATION (lsp_parameter_information_get_type ())
#define LSP_PARAMETER_INFORMATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_PARAMETER_INFORMATION, LspParameterInformation))
#define LSP_PARAMETER_INFORMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_PARAMETER_INFORMATION, LspParameterInformationClass))
#define LSP_IS_PARAMETER_INFORMATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_PARAMETER_INFORMATION))
#define LSP_IS_PARAMETER_INFORMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_PARAMETER_INFORMATION))
#define LSP_PARAMETER_INFORMATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_PARAMETER_INFORMATION, LspParameterInformationClass))

typedef struct _LspParameterInformation LspParameterInformation;
typedef struct _LspParameterInformationClass LspParameterInformationClass;
enum  {
	LSP_SIGNATURE_INFORMATION_0_PROPERTY,
	LSP_SIGNATURE_INFORMATION_LABEL_PROPERTY,
	LSP_SIGNATURE_INFORMATION_DOCUMENTATION_PROPERTY,
	LSP_SIGNATURE_INFORMATION_PARAMETERS_PROPERTY,
	LSP_SIGNATURE_INFORMATION_NUM_PROPERTIES
};
static GParamSpec* lsp_signature_information_properties[LSP_SIGNATURE_INFORMATION_NUM_PROPERTIES];

#define LSP_TYPE_SIGNATURE_HELP (lsp_signature_help_get_type ())
#define LSP_SIGNATURE_HELP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_SIGNATURE_HELP, LspSignatureHelp))
#define LSP_SIGNATURE_HELP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_SIGNATURE_HELP, LspSignatureHelpClass))
#define LSP_IS_SIGNATURE_HELP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_SIGNATURE_HELP))
#define LSP_IS_SIGNATURE_HELP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_SIGNATURE_HELP))
#define LSP_SIGNATURE_HELP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_SIGNATURE_HELP, LspSignatureHelpClass))

typedef struct _LspSignatureHelp LspSignatureHelp;
typedef struct _LspSignatureHelpClass LspSignatureHelpClass;
typedef struct _LspSignatureHelpPrivate LspSignatureHelpPrivate;
enum  {
	LSP_SIGNATURE_HELP_0_PROPERTY,
	LSP_SIGNATURE_HELP_SIGNATURES_PROPERTY,
	LSP_SIGNATURE_HELP_ACTIVE_SIGNATURE_PROPERTY,
	LSP_SIGNATURE_HELP_ACTIVE_PARAMETER_PROPERTY,
	LSP_SIGNATURE_HELP_NUM_PROPERTIES
};
static GParamSpec* lsp_signature_help_properties[LSP_SIGNATURE_HELP_NUM_PROPERTIES];
typedef struct _LspParameterInformationPrivate LspParameterInformationPrivate;
enum  {
	LSP_PARAMETER_INFORMATION_0_PROPERTY,
	LSP_PARAMETER_INFORMATION_LABEL_PROPERTY,
	LSP_PARAMETER_INFORMATION_DOCUMENTATION_PROPERTY,
	LSP_PARAMETER_INFORMATION_NUM_PROPERTIES
};
static GParamSpec* lsp_parameter_information_properties[LSP_PARAMETER_INFORMATION_NUM_PROPERTIES];

#define LSP_TYPE_MARKED_STRING (lsp_marked_string_get_type ())
#define LSP_MARKED_STRING(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_MARKED_STRING, LspMarkedString))
#define LSP_MARKED_STRING_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_MARKED_STRING, LspMarkedStringClass))
#define LSP_IS_MARKED_STRING(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_MARKED_STRING))
#define LSP_IS_MARKED_STRING_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_MARKED_STRING))
#define LSP_MARKED_STRING_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_MARKED_STRING, LspMarkedStringClass))

typedef struct _LspMarkedString LspMarkedString;
typedef struct _LspMarkedStringClass LspMarkedStringClass;
typedef struct _LspMarkedStringPrivate LspMarkedStringPrivate;
enum  {
	LSP_MARKED_STRING_0_PROPERTY,
	LSP_MARKED_STRING_LANGUAGE_PROPERTY,
	LSP_MARKED_STRING_VALUE_PROPERTY,
	LSP_MARKED_STRING_NUM_PROPERTIES
};
static GParamSpec* lsp_marked_string_properties[LSP_MARKED_STRING_NUM_PROPERTIES];

#define LSP_TYPE_HOVER (lsp_hover_get_type ())
#define LSP_HOVER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_HOVER, LspHover))
#define LSP_HOVER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_HOVER, LspHoverClass))
#define LSP_IS_HOVER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_HOVER))
#define LSP_IS_HOVER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_HOVER))
#define LSP_HOVER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_HOVER, LspHoverClass))

typedef struct _LspHover LspHover;
typedef struct _LspHoverClass LspHoverClass;
typedef struct _LspHoverPrivate LspHoverPrivate;
enum  {
	LSP_HOVER_0_PROPERTY,
	LSP_HOVER_CONTENTS_PROPERTY,
	LSP_HOVER_RANGE_PROPERTY,
	LSP_HOVER_NUM_PROPERTIES
};
static GParamSpec* lsp_hover_properties[LSP_HOVER_NUM_PROPERTIES];
#define __vala_JsonNode_free0(var) ((var == NULL) ? NULL : (var = (_vala_JsonNode_free (var), NULL)))

#define LSP_TYPE_TEXT_EDIT (lsp_text_edit_get_type ())
#define LSP_TEXT_EDIT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_TEXT_EDIT, LspTextEdit))
#define LSP_TEXT_EDIT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_TEXT_EDIT, LspTextEditClass))
#define LSP_IS_TEXT_EDIT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_TEXT_EDIT))
#define LSP_IS_TEXT_EDIT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_TEXT_EDIT))
#define LSP_TEXT_EDIT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_TEXT_EDIT, LspTextEditClass))

typedef struct _LspTextEdit LspTextEdit;
typedef struct _LspTextEditClass LspTextEditClass;
typedef struct _LspTextEditPrivate LspTextEditPrivate;
enum  {
	LSP_TEXT_EDIT_0_PROPERTY,
	LSP_TEXT_EDIT_RANGE_PROPERTY,
	LSP_TEXT_EDIT_NEW_TEXT_PROPERTY,
	LSP_TEXT_EDIT_NUM_PROPERTIES
};
static GParamSpec* lsp_text_edit_properties[LSP_TEXT_EDIT_NUM_PROPERTIES];

#define LSP_TYPE_TEXT_DOCUMENT_EDIT (lsp_text_document_edit_get_type ())
#define LSP_TEXT_DOCUMENT_EDIT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_TEXT_DOCUMENT_EDIT, LspTextDocumentEdit))
#define LSP_TEXT_DOCUMENT_EDIT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_TEXT_DOCUMENT_EDIT, LspTextDocumentEditClass))
#define LSP_IS_TEXT_DOCUMENT_EDIT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_TEXT_DOCUMENT_EDIT))
#define LSP_IS_TEXT_DOCUMENT_EDIT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_TEXT_DOCUMENT_EDIT))
#define LSP_TEXT_DOCUMENT_EDIT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_TEXT_DOCUMENT_EDIT, LspTextDocumentEditClass))

typedef struct _LspTextDocumentEdit LspTextDocumentEdit;
typedef struct _LspTextDocumentEditClass LspTextDocumentEditClass;
typedef struct _LspTextDocumentEditPrivate LspTextDocumentEditPrivate;
enum  {
	LSP_TEXT_DOCUMENT_EDIT_0_PROPERTY,
	LSP_TEXT_DOCUMENT_EDIT_TEXT_DOCUMENT_PROPERTY,
	LSP_TEXT_DOCUMENT_EDIT_EDITS_PROPERTY,
	LSP_TEXT_DOCUMENT_EDIT_NUM_PROPERTIES
};
static GParamSpec* lsp_text_document_edit_properties[LSP_TEXT_DOCUMENT_EDIT_NUM_PROPERTIES];

#define LSP_TYPE_COMMAND_LIKE (lsp_command_like_get_type ())
#define LSP_COMMAND_LIKE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_COMMAND_LIKE, LspCommandLike))
#define LSP_COMMAND_LIKE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_COMMAND_LIKE, LspCommandLikeClass))
#define LSP_IS_COMMAND_LIKE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_COMMAND_LIKE))
#define LSP_IS_COMMAND_LIKE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_COMMAND_LIKE))
#define LSP_COMMAND_LIKE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_COMMAND_LIKE, LspCommandLikeClass))

typedef struct _LspCommandLike LspCommandLike;
typedef struct _LspCommandLikeClass LspCommandLikeClass;
typedef struct _LspCommandLikePrivate LspCommandLikePrivate;
enum  {
	LSP_COMMAND_LIKE_0_PROPERTY,
	LSP_COMMAND_LIKE_COMMAND_PROPERTY,
	LSP_COMMAND_LIKE_ARGUMENTS_PROPERTY,
	LSP_COMMAND_LIKE_NUM_PROPERTIES
};
static GParamSpec* lsp_command_like_properties[LSP_COMMAND_LIKE_NUM_PROPERTIES];
#define _g_array_unref0(var) ((var == NULL) ? NULL : (var = (g_array_unref (var), NULL)))
typedef struct _Block27Data Block27Data;
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define LSP_TYPE_EXECUTE_COMMAND_PARAMS (lsp_execute_command_params_get_type ())
#define LSP_EXECUTE_COMMAND_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_EXECUTE_COMMAND_PARAMS, LspExecuteCommandParams))
#define LSP_EXECUTE_COMMAND_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_EXECUTE_COMMAND_PARAMS, LspExecuteCommandParamsClass))
#define LSP_IS_EXECUTE_COMMAND_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_EXECUTE_COMMAND_PARAMS))
#define LSP_IS_EXECUTE_COMMAND_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_EXECUTE_COMMAND_PARAMS))
#define LSP_EXECUTE_COMMAND_PARAMS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_EXECUTE_COMMAND_PARAMS, LspExecuteCommandParamsClass))

typedef struct _LspExecuteCommandParams LspExecuteCommandParams;
typedef struct _LspExecuteCommandParamsClass LspExecuteCommandParamsClass;
typedef struct _LspExecuteCommandParamsPrivate LspExecuteCommandParamsPrivate;
enum  {
	LSP_EXECUTE_COMMAND_PARAMS_0_PROPERTY,
	LSP_EXECUTE_COMMAND_PARAMS_NUM_PROPERTIES
};
static GParamSpec* lsp_execute_command_params_properties[LSP_EXECUTE_COMMAND_PARAMS_NUM_PROPERTIES];

#define LSP_TYPE_COMMAND (lsp_command_get_type ())
#define LSP_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_COMMAND, LspCommand))
#define LSP_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_COMMAND, LspCommandClass))
#define LSP_IS_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_COMMAND))
#define LSP_IS_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_COMMAND))
#define LSP_COMMAND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_COMMAND, LspCommandClass))

typedef struct _LspCommand LspCommand;
typedef struct _LspCommandClass LspCommandClass;
typedef struct _LspCommandPrivate LspCommandPrivate;
enum  {
	LSP_COMMAND_0_PROPERTY,
	LSP_COMMAND_TITLE_PROPERTY,
	LSP_COMMAND_NUM_PROPERTIES
};
static GParamSpec* lsp_command_properties[LSP_COMMAND_NUM_PROPERTIES];

#define LSP_TYPE_CODE_LENS (lsp_code_lens_get_type ())
#define LSP_CODE_LENS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_CODE_LENS, LspCodeLens))
#define LSP_CODE_LENS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_CODE_LENS, LspCodeLensClass))
#define LSP_IS_CODE_LENS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_CODE_LENS))
#define LSP_IS_CODE_LENS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_CODE_LENS))
#define LSP_CODE_LENS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_CODE_LENS, LspCodeLensClass))

typedef struct _LspCodeLens LspCodeLens;
typedef struct _LspCodeLensClass LspCodeLensClass;
typedef struct _LspCodeLensPrivate LspCodeLensPrivate;
enum  {
	LSP_CODE_LENS_0_PROPERTY,
	LSP_CODE_LENS_RANGE_PROPERTY,
	LSP_CODE_LENS_COMMAND_PROPERTY,
	LSP_CODE_LENS_NUM_PROPERTIES
};
static GParamSpec* lsp_code_lens_properties[LSP_CODE_LENS_NUM_PROPERTIES];

#define LSP_TYPE_DOCUMENT_RANGE_FORMATTING_PARAMS (lsp_document_range_formatting_params_get_type ())
#define LSP_DOCUMENT_RANGE_FORMATTING_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_DOCUMENT_RANGE_FORMATTING_PARAMS, LspDocumentRangeFormattingParams))
#define LSP_DOCUMENT_RANGE_FORMATTING_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_DOCUMENT_RANGE_FORMATTING_PARAMS, LspDocumentRangeFormattingParamsClass))
#define LSP_IS_DOCUMENT_RANGE_FORMATTING_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_DOCUMENT_RANGE_FORMATTING_PARAMS))
#define LSP_IS_DOCUMENT_RANGE_FORMATTING_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_DOCUMENT_RANGE_FORMATTING_PARAMS))
#define LSP_DOCUMENT_RANGE_FORMATTING_PARAMS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_DOCUMENT_RANGE_FORMATTING_PARAMS, LspDocumentRangeFormattingParamsClass))

typedef struct _LspDocumentRangeFormattingParams LspDocumentRangeFormattingParams;
typedef struct _LspDocumentRangeFormattingParamsClass LspDocumentRangeFormattingParamsClass;
typedef struct _LspDocumentRangeFormattingParamsPrivate LspDocumentRangeFormattingParamsPrivate;

#define LSP_TYPE_FORMATTING_OPTIONS (lsp_formatting_options_get_type ())
#define LSP_FORMATTING_OPTIONS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_FORMATTING_OPTIONS, LspFormattingOptions))
#define LSP_FORMATTING_OPTIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_FORMATTING_OPTIONS, LspFormattingOptionsClass))
#define LSP_IS_FORMATTING_OPTIONS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_FORMATTING_OPTIONS))
#define LSP_IS_FORMATTING_OPTIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_FORMATTING_OPTIONS))
#define LSP_FORMATTING_OPTIONS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_FORMATTING_OPTIONS, LspFormattingOptionsClass))

typedef struct _LspFormattingOptions LspFormattingOptions;
typedef struct _LspFormattingOptionsClass LspFormattingOptionsClass;
enum  {
	LSP_DOCUMENT_RANGE_FORMATTING_PARAMS_0_PROPERTY,
	LSP_DOCUMENT_RANGE_FORMATTING_PARAMS_TEXT_DOCUMENT_PROPERTY,
	LSP_DOCUMENT_RANGE_FORMATTING_PARAMS_RANGE_PROPERTY,
	LSP_DOCUMENT_RANGE_FORMATTING_PARAMS_OPTIONS_PROPERTY,
	LSP_DOCUMENT_RANGE_FORMATTING_PARAMS_NUM_PROPERTIES
};
static GParamSpec* lsp_document_range_formatting_params_properties[LSP_DOCUMENT_RANGE_FORMATTING_PARAMS_NUM_PROPERTIES];
typedef struct _LspFormattingOptionsPrivate LspFormattingOptionsPrivate;
enum  {
	LSP_FORMATTING_OPTIONS_0_PROPERTY,
	LSP_FORMATTING_OPTIONS_TAB_SIZE_PROPERTY,
	LSP_FORMATTING_OPTIONS_INSERT_SPACES_PROPERTY,
	LSP_FORMATTING_OPTIONS_TRIM_TRAILING_WHITESPACE_PROPERTY,
	LSP_FORMATTING_OPTIONS_INSERT_FINAL_NEWLINE_PROPERTY,
	LSP_FORMATTING_OPTIONS_TRIM_FINAL_NEWLINES_PROPERTY,
	LSP_FORMATTING_OPTIONS_NUM_PROPERTIES
};
static GParamSpec* lsp_formatting_options_properties[LSP_FORMATTING_OPTIONS_NUM_PROPERTIES];

#define LSP_TYPE_CODE_ACTION_PARAMS (lsp_code_action_params_get_type ())
#define LSP_CODE_ACTION_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_CODE_ACTION_PARAMS, LspCodeActionParams))
#define LSP_CODE_ACTION_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_CODE_ACTION_PARAMS, LspCodeActionParamsClass))
#define LSP_IS_CODE_ACTION_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_CODE_ACTION_PARAMS))
#define LSP_IS_CODE_ACTION_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_CODE_ACTION_PARAMS))
#define LSP_CODE_ACTION_PARAMS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_CODE_ACTION_PARAMS, LspCodeActionParamsClass))

typedef struct _LspCodeActionParams LspCodeActionParams;
typedef struct _LspCodeActionParamsClass LspCodeActionParamsClass;
typedef struct _LspCodeActionParamsPrivate LspCodeActionParamsPrivate;

#define LSP_TYPE_CODE_ACTION_CONTEXT (lsp_code_action_context_get_type ())
#define LSP_CODE_ACTION_CONTEXT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_CODE_ACTION_CONTEXT, LspCodeActionContext))
#define LSP_CODE_ACTION_CONTEXT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_CODE_ACTION_CONTEXT, LspCodeActionContextClass))
#define LSP_IS_CODE_ACTION_CONTEXT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_CODE_ACTION_CONTEXT))
#define LSP_IS_CODE_ACTION_CONTEXT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_CODE_ACTION_CONTEXT))
#define LSP_CODE_ACTION_CONTEXT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_CODE_ACTION_CONTEXT, LspCodeActionContextClass))

typedef struct _LspCodeActionContext LspCodeActionContext;
typedef struct _LspCodeActionContextClass LspCodeActionContextClass;
enum  {
	LSP_CODE_ACTION_PARAMS_0_PROPERTY,
	LSP_CODE_ACTION_PARAMS_TEXT_DOCUMENT_PROPERTY,
	LSP_CODE_ACTION_PARAMS_RANGE_PROPERTY,
	LSP_CODE_ACTION_PARAMS_CONTEXT_PROPERTY,
	LSP_CODE_ACTION_PARAMS_NUM_PROPERTIES
};
static GParamSpec* lsp_code_action_params_properties[LSP_CODE_ACTION_PARAMS_NUM_PROPERTIES];
typedef struct _LspCodeActionContextPrivate LspCodeActionContextPrivate;
enum  {
	LSP_CODE_ACTION_CONTEXT_0_PROPERTY,
	LSP_CODE_ACTION_CONTEXT_DIAGNOSTICS_PROPERTY,
	LSP_CODE_ACTION_CONTEXT_ONLY_PROPERTY,
	LSP_CODE_ACTION_CONTEXT_NUM_PROPERTIES
};
static GParamSpec* lsp_code_action_context_properties[LSP_CODE_ACTION_CONTEXT_NUM_PROPERTIES];
typedef struct _Block28Data Block28Data;

#define LSP_TYPE_CODE_ACTION (lsp_code_action_get_type ())
#define LSP_CODE_ACTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_CODE_ACTION, LspCodeAction))
#define LSP_CODE_ACTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_CODE_ACTION, LspCodeActionClass))
#define LSP_IS_CODE_ACTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_CODE_ACTION))
#define LSP_IS_CODE_ACTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_CODE_ACTION))
#define LSP_CODE_ACTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_CODE_ACTION, LspCodeActionClass))

typedef struct _LspCodeAction LspCodeAction;
typedef struct _LspCodeActionClass LspCodeActionClass;
typedef struct _LspCodeActionPrivate LspCodeActionPrivate;

#define LSP_TYPE_WORKSPACE_EDIT (lsp_workspace_edit_get_type ())
#define LSP_WORKSPACE_EDIT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_WORKSPACE_EDIT, LspWorkspaceEdit))
#define LSP_WORKSPACE_EDIT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_WORKSPACE_EDIT, LspWorkspaceEditClass))
#define LSP_IS_WORKSPACE_EDIT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_WORKSPACE_EDIT))
#define LSP_IS_WORKSPACE_EDIT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_WORKSPACE_EDIT))
#define LSP_WORKSPACE_EDIT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_WORKSPACE_EDIT, LspWorkspaceEditClass))

typedef struct _LspWorkspaceEdit LspWorkspaceEdit;
typedef struct _LspWorkspaceEditClass LspWorkspaceEditClass;
enum  {
	LSP_CODE_ACTION_0_PROPERTY,
	LSP_CODE_ACTION_TITLE_PROPERTY,
	LSP_CODE_ACTION_KIND_PROPERTY,
	LSP_CODE_ACTION_DIAGNOSTICS_PROPERTY,
	LSP_CODE_ACTION_IS_PREFERRED_PROPERTY,
	LSP_CODE_ACTION_EDIT_PROPERTY,
	LSP_CODE_ACTION_COMMAND_PROPERTY,
	LSP_CODE_ACTION_DATA_PROPERTY,
	LSP_CODE_ACTION_NUM_PROPERTIES
};
static GParamSpec* lsp_code_action_properties[LSP_CODE_ACTION_NUM_PROPERTIES];
typedef struct _LspWorkspaceEditPrivate LspWorkspaceEditPrivate;
enum  {
	LSP_WORKSPACE_EDIT_0_PROPERTY,
	LSP_WORKSPACE_EDIT_DOCUMENT_CHANGES_PROPERTY,
	LSP_WORKSPACE_EDIT_NUM_PROPERTIES
};
static GParamSpec* lsp_workspace_edit_properties[LSP_WORKSPACE_EDIT_NUM_PROPERTIES];
typedef enum  {
	LSP_SYMBOL_TAGS_NONE = 1 << 0,
	LSP_SYMBOL_TAGS_DEPRECATED = 1 << 1
} LspSymbolTags;

#define LSP_TYPE_SYMBOL_TAGS (lsp_symbol_tags_get_type ())

#define LSP_TYPE_CALL_HIERARCHY_ITEM (lsp_call_hierarchy_item_get_type ())
#define LSP_CALL_HIERARCHY_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_CALL_HIERARCHY_ITEM, LspCallHierarchyItem))
#define LSP_CALL_HIERARCHY_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_CALL_HIERARCHY_ITEM, LspCallHierarchyItemClass))
#define LSP_IS_CALL_HIERARCHY_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_CALL_HIERARCHY_ITEM))
#define LSP_IS_CALL_HIERARCHY_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_CALL_HIERARCHY_ITEM))
#define LSP_CALL_HIERARCHY_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_CALL_HIERARCHY_ITEM, LspCallHierarchyItemClass))

typedef struct _LspCallHierarchyItem LspCallHierarchyItem;
typedef struct _LspCallHierarchyItemClass LspCallHierarchyItemClass;
typedef struct _LspCallHierarchyItemPrivate LspCallHierarchyItemPrivate;
enum  {
	LSP_CALL_HIERARCHY_ITEM_0_PROPERTY,
	LSP_CALL_HIERARCHY_ITEM_NAME_PROPERTY,
	LSP_CALL_HIERARCHY_ITEM_KIND_PROPERTY,
	LSP_CALL_HIERARCHY_ITEM_TAGS_PROPERTY,
	LSP_CALL_HIERARCHY_ITEM_DETAIL_PROPERTY,
	LSP_CALL_HIERARCHY_ITEM_URI_PROPERTY,
	LSP_CALL_HIERARCHY_ITEM_RANGE_PROPERTY,
	LSP_CALL_HIERARCHY_ITEM_SELECTION_RANGE_PROPERTY,
	LSP_CALL_HIERARCHY_ITEM_NUM_PROPERTIES
};
static GParamSpec* lsp_call_hierarchy_item_properties[LSP_CALL_HIERARCHY_ITEM_NUM_PROPERTIES];

#define LSP_TYPE_CALL_HIERARCHY_INCOMING_CALL (lsp_call_hierarchy_incoming_call_get_type ())
#define LSP_CALL_HIERARCHY_INCOMING_CALL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_CALL_HIERARCHY_INCOMING_CALL, LspCallHierarchyIncomingCall))
#define LSP_CALL_HIERARCHY_INCOMING_CALL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_CALL_HIERARCHY_INCOMING_CALL, LspCallHierarchyIncomingCallClass))
#define LSP_IS_CALL_HIERARCHY_INCOMING_CALL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_CALL_HIERARCHY_INCOMING_CALL))
#define LSP_IS_CALL_HIERARCHY_INCOMING_CALL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_CALL_HIERARCHY_INCOMING_CALL))
#define LSP_CALL_HIERARCHY_INCOMING_CALL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_CALL_HIERARCHY_INCOMING_CALL, LspCallHierarchyIncomingCallClass))

typedef struct _LspCallHierarchyIncomingCall LspCallHierarchyIncomingCall;
typedef struct _LspCallHierarchyIncomingCallClass LspCallHierarchyIncomingCallClass;
typedef struct _LspCallHierarchyIncomingCallPrivate LspCallHierarchyIncomingCallPrivate;
enum  {
	LSP_CALL_HIERARCHY_INCOMING_CALL_0_PROPERTY,
	LSP_CALL_HIERARCHY_INCOMING_CALL_FROM_PROPERTY,
	LSP_CALL_HIERARCHY_INCOMING_CALL_FROM_RANGES_PROPERTY,
	LSP_CALL_HIERARCHY_INCOMING_CALL_NUM_PROPERTIES
};
static GParamSpec* lsp_call_hierarchy_incoming_call_properties[LSP_CALL_HIERARCHY_INCOMING_CALL_NUM_PROPERTIES];

#define LSP_TYPE_CALL_HIERARCHY_OUTGOING_CALL (lsp_call_hierarchy_outgoing_call_get_type ())
#define LSP_CALL_HIERARCHY_OUTGOING_CALL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_CALL_HIERARCHY_OUTGOING_CALL, LspCallHierarchyOutgoingCall))
#define LSP_CALL_HIERARCHY_OUTGOING_CALL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_CALL_HIERARCHY_OUTGOING_CALL, LspCallHierarchyOutgoingCallClass))
#define LSP_IS_CALL_HIERARCHY_OUTGOING_CALL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_CALL_HIERARCHY_OUTGOING_CALL))
#define LSP_IS_CALL_HIERARCHY_OUTGOING_CALL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_CALL_HIERARCHY_OUTGOING_CALL))
#define LSP_CALL_HIERARCHY_OUTGOING_CALL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_CALL_HIERARCHY_OUTGOING_CALL, LspCallHierarchyOutgoingCallClass))

typedef struct _LspCallHierarchyOutgoingCall LspCallHierarchyOutgoingCall;
typedef struct _LspCallHierarchyOutgoingCallClass LspCallHierarchyOutgoingCallClass;
typedef struct _LspCallHierarchyOutgoingCallPrivate LspCallHierarchyOutgoingCallPrivate;
enum  {
	LSP_CALL_HIERARCHY_OUTGOING_CALL_0_PROPERTY,
	LSP_CALL_HIERARCHY_OUTGOING_CALL_TO_PROPERTY,
	LSP_CALL_HIERARCHY_OUTGOING_CALL_FROM_RANGES_PROPERTY,
	LSP_CALL_HIERARCHY_OUTGOING_CALL_NUM_PROPERTIES
};
static GParamSpec* lsp_call_hierarchy_outgoing_call_properties[LSP_CALL_HIERARCHY_OUTGOING_CALL_NUM_PROPERTIES];

#define LSP_TYPE_INLAY_HINT_PARAMS (lsp_inlay_hint_params_get_type ())
#define LSP_INLAY_HINT_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_INLAY_HINT_PARAMS, LspInlayHintParams))
#define LSP_INLAY_HINT_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_INLAY_HINT_PARAMS, LspInlayHintParamsClass))
#define LSP_IS_INLAY_HINT_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_INLAY_HINT_PARAMS))
#define LSP_IS_INLAY_HINT_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_INLAY_HINT_PARAMS))
#define LSP_INLAY_HINT_PARAMS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_INLAY_HINT_PARAMS, LspInlayHintParamsClass))

typedef struct _LspInlayHintParams LspInlayHintParams;
typedef struct _LspInlayHintParamsClass LspInlayHintParamsClass;
typedef struct _LspInlayHintParamsPrivate LspInlayHintParamsPrivate;
enum  {
	LSP_INLAY_HINT_PARAMS_0_PROPERTY,
	LSP_INLAY_HINT_PARAMS_TEXT_DOCUMENT_PROPERTY,
	LSP_INLAY_HINT_PARAMS_RANGE_PROPERTY,
	LSP_INLAY_HINT_PARAMS_NUM_PROPERTIES
};
static GParamSpec* lsp_inlay_hint_params_properties[LSP_INLAY_HINT_PARAMS_NUM_PROPERTIES];
typedef enum  {
	LSP_INLAY_HINT_KIND_UNSET,
	LSP_INLAY_HINT_KIND_TYPE,
	LSP_INLAY_HINT_KIND_PARAMETER
} LspInlayHintKind;

#define LSP_TYPE_INLAY_HINT_KIND (lsp_inlay_hint_kind_get_type ())

#define LSP_TYPE_INLAY_HINT (lsp_inlay_hint_get_type ())
#define LSP_INLAY_HINT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_INLAY_HINT, LspInlayHint))
#define LSP_INLAY_HINT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_INLAY_HINT, LspInlayHintClass))
#define LSP_IS_INLAY_HINT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_INLAY_HINT))
#define LSP_IS_INLAY_HINT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_INLAY_HINT))
#define LSP_INLAY_HINT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_INLAY_HINT, LspInlayHintClass))

typedef struct _LspInlayHint LspInlayHint;
typedef struct _LspInlayHintClass LspInlayHintClass;
typedef struct _LspInlayHintPrivate LspInlayHintPrivate;
enum  {
	LSP_INLAY_HINT_0_PROPERTY,
	LSP_INLAY_HINT_POSITION_PROPERTY,
	LSP_INLAY_HINT_LABEL_PROPERTY,
	LSP_INLAY_HINT_KIND_PROPERTY,
	LSP_INLAY_HINT_TOOLTIP_PROPERTY,
	LSP_INLAY_HINT_PADDING_LEFT_PROPERTY,
	LSP_INLAY_HINT_PADDING_RIGHT_PROPERTY,
	LSP_INLAY_HINT_NUM_PROPERTIES
};
static GParamSpec* lsp_inlay_hint_properties[LSP_INLAY_HINT_NUM_PROPERTIES];

#define LSP_TYPE_TYPEHIERARCHY_ITEM (lsp_typehierarchy_item_get_type ())
#define LSP_TYPEHIERARCHY_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_TYPEHIERARCHY_ITEM, LspTypeHierarchyItem))
#define LSP_TYPEHIERARCHY_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_TYPEHIERARCHY_ITEM, LspTypeHierarchyItemClass))
#define LSP_IS_TYPEHIERARCHY_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_TYPEHIERARCHY_ITEM))
#define LSP_IS_TYPEHIERARCHY_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_TYPEHIERARCHY_ITEM))
#define LSP_TYPEHIERARCHY_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_TYPEHIERARCHY_ITEM, LspTypeHierarchyItemClass))

typedef struct _LspTypeHierarchyItem LspTypeHierarchyItem;
typedef struct _LspTypeHierarchyItemClass LspTypeHierarchyItemClass;
typedef struct _LspTypeHierarchyItemPrivate LspTypeHierarchyItemPrivate;
enum  {
	LSP_TYPEHIERARCHY_ITEM_0_PROPERTY,
	LSP_TYPEHIERARCHY_ITEM_NAME_PROPERTY,
	LSP_TYPEHIERARCHY_ITEM_KIND_PROPERTY,
	LSP_TYPEHIERARCHY_ITEM_TAGS_PROPERTY,
	LSP_TYPEHIERARCHY_ITEM_DETAIL_PROPERTY,
	LSP_TYPEHIERARCHY_ITEM_URI_PROPERTY,
	LSP_TYPEHIERARCHY_ITEM_RANGE_PROPERTY,
	LSP_TYPEHIERARCHY_ITEM_SELECTION_RANGE_PROPERTY,
	LSP_TYPEHIERARCHY_ITEM_NUM_PROPERTIES
};
static GParamSpec* lsp_typehierarchy_item_properties[LSP_TYPEHIERARCHY_ITEM_NUM_PROPERTIES];

struct _LspPosition {
	GObject parent_instance;
	LspPositionPrivate * priv;
};

struct _LspPositionClass {
	GObjectClass parent_class;
};

struct _LspPositionPrivate {
	guint _line;
	guint _character;
};

struct _LspRange {
	GObject parent_instance;
	LspRangePrivate * priv;
};

struct _LspRangeClass {
	GObjectClass parent_class;
};

struct _LspRangePrivate {
	LspPosition* _start;
	LspPosition* _end;
	gchar* filename;
};

struct _LspDiagnostic {
	GObject parent_instance;
	LspDiagnosticPrivate * priv;
};

struct _LspDiagnosticClass {
	GObjectClass parent_class;
};

struct _LspDiagnosticPrivate {
	LspRange* _range;
	LspDiagnosticSeverity _severity;
	gchar* _code;
	gchar* _source;
	gchar* _message;
};

struct _LspTextDocumentContentChangeEvent {
	GObject parent_instance;
	LspTextDocumentContentChangeEventPrivate * priv;
};

struct _LspTextDocumentContentChangeEventClass {
	GObjectClass parent_class;
};

struct _LspTextDocumentContentChangeEventPrivate {
	LspRange* _range;
	gint _rangeLength;
	gchar* _text;
};

struct _LspTextDocumentIdentifier {
	GObject parent_instance;
	LspTextDocumentIdentifierPrivate * priv;
};

struct _LspTextDocumentIdentifierClass {
	GObjectClass parent_class;
};

struct _LspTextDocumentIdentifierPrivate {
	gchar* _uri;
};

struct _LspVersionedTextDocumentIdentifier {
	LspTextDocumentIdentifier parent_instance;
	LspVersionedTextDocumentIdentifierPrivate * priv;
};

struct _LspVersionedTextDocumentIdentifierClass {
	LspTextDocumentIdentifierClass parent_class;
};

struct _LspVersionedTextDocumentIdentifierPrivate {
	gint _version;
};

struct _LspTextDocumentPositionParams {
	GObject parent_instance;
	LspTextDocumentPositionParamsPrivate * priv;
};

struct _LspTextDocumentPositionParamsClass {
	GObjectClass parent_class;
};

struct _LspTextDocumentPositionParamsPrivate {
	LspTextDocumentIdentifier* _textDocument;
	LspPosition* _position;
};

struct _LspReferenceParams {
	LspTextDocumentPositionParams parent_instance;
	LspReferenceParamsPrivate * priv;
};

struct _LspReferenceParamsClass {
	LspTextDocumentPositionParamsClass parent_class;
};

struct _LspReferenceParamsPrivate {
	LspReferenceParamsReferenceContext* _context;
};

struct _LspReferenceParamsReferenceContext {
	GObject parent_instance;
	LspReferenceParamsReferenceContextPrivate * priv;
};

struct _LspReferenceParamsReferenceContextClass {
	GObjectClass parent_class;
};

struct _LspReferenceParamsReferenceContextPrivate {
	gboolean _includeDeclaration;
};

struct _LspLocation {
	GObject parent_instance;
	LspLocationPrivate * priv;
};

struct _LspLocationClass {
	GObjectClass parent_class;
};

struct _LspLocationPrivate {
	gchar* _uri;
	LspRange* _range;
};

struct _LspDocumentHighlight {
	GObject parent_instance;
	LspDocumentHighlightPrivate * priv;
};

struct _LspDocumentHighlightClass {
	GObjectClass parent_class;
};

struct _LspDocumentHighlightPrivate {
	LspRange* _range;
	LspDocumentHighlightKind _kind;
};

struct _LspDocumentSymbolParams {
	GObject parent_instance;
	LspDocumentSymbolParamsPrivate * priv;
};

struct _LspDocumentSymbolParamsClass {
	GObjectClass parent_class;
};

struct _LspDocumentSymbolParamsPrivate {
	LspTextDocumentIdentifier* _textDocument;
};

struct _LspDocumentSymbol {
	GObject parent_instance;
	LspDocumentSymbolPrivate * priv;
	gchar* parent_name;
};

struct _LspDocumentSymbolClass {
	GObjectClass parent_class;
};

struct _LspDocumentSymbolPrivate {
	ValaSourceReference* _source_reference;
	gchar* _name;
	gchar* _detail;
	LspSymbolKind _kind;
	gboolean _deprecated;
	LspRange* _initial_range;
	LspRange* _selectionRange;
	GeeList* _children;
};

struct _LspSymbolInformation {
	GObject parent_instance;
	LspSymbolInformationPrivate * priv;
};

struct _LspSymbolInformationClass {
	GObjectClass parent_class;
};

struct _LspSymbolInformationPrivate {
	gchar* _name;
	LspSymbolKind _kind;
	LspLocation* _location;
	gchar* _containerName;
};

struct _LspCompletionList {
	GObject parent_instance;
	LspCompletionListPrivate * priv;
};

struct _LspCompletionListClass {
	GObjectClass parent_class;
};

struct _LspCompletionListPrivate {
	gboolean _isIncomplete;
	GeeList* _items;
};

struct _LspCompletionContext {
	GObject parent_instance;
	LspCompletionContextPrivate * priv;
};

struct _LspCompletionContextClass {
	GObjectClass parent_class;
};

struct _LspCompletionContextPrivate {
	LspCompletionTriggerKind _triggerKind;
	gchar* _triggerCharacter;
};

struct _LspCompletionParams {
	LspTextDocumentPositionParams parent_instance;
	LspCompletionParamsPrivate * priv;
};

struct _LspCompletionParamsClass {
	LspTextDocumentPositionParamsClass parent_class;
};

struct _LspCompletionParamsPrivate {
	LspCompletionContext* _context;
};

struct _LspCompletionItem {
	GObject parent_instance;
	LspCompletionItemPrivate * priv;
};

struct _LspCompletionItemClass {
	GObjectClass parent_class;
};

struct _LspCompletionItemPrivate {
	gchar* _label;
	LspCompletionItemKind _kind;
	gchar* _detail;
	LspMarkupContent* _documentation;
	gboolean _deprecated;
	GeeList* _tags;
	gchar* _insertText;
	LspInsertTextFormat _insertTextFormat;
	guint _hash;
};

struct _LspMarkupContent {
	GObject parent_instance;
	LspMarkupContentPrivate * priv;
};

struct _LspMarkupContentClass {
	GObjectClass parent_class;
};

struct _LspMarkupContentPrivate {
	gchar* _kind;
	gchar* _value;
};

struct _LspDocumentSymbolCapabilities {
	GObject parent_instance;
	LspDocumentSymbolCapabilitiesPrivate * priv;
};

struct _LspDocumentSymbolCapabilitiesClass {
	GObjectClass parent_class;
};

struct _LspDocumentSymbolCapabilitiesPrivate {
	gboolean _hierarchicalDocumentSymbolSupport;
};

struct _LspRenameClientCapabilities {
	GObject parent_instance;
	LspRenameClientCapabilitiesPrivate * priv;
};

struct _LspRenameClientCapabilitiesClass {
	GObjectClass parent_class;
};

struct _LspRenameClientCapabilitiesPrivate {
	gboolean _prepareSupport;
};

struct _LspTextDocumentClientCapabilities {
	GObject parent_instance;
	LspTextDocumentClientCapabilitiesPrivate * priv;
};

struct _LspTextDocumentClientCapabilitiesClass {
	GObjectClass parent_class;
};

struct _LspTextDocumentClientCapabilitiesPrivate {
	LspDocumentSymbolCapabilities* _documentSymbol;
	LspRenameClientCapabilities* _rename;
};

struct _LspClientCapabilities {
	GObject parent_instance;
	LspClientCapabilitiesPrivate * priv;
};

struct _LspClientCapabilitiesClass {
	GObjectClass parent_class;
};

struct _LspClientCapabilitiesPrivate {
	LspTextDocumentClientCapabilities* _textDocument;
};

struct _LspInitializeParams {
	GObject parent_instance;
	LspInitializeParamsPrivate * priv;
};

struct _LspInitializeParamsClass {
	GObjectClass parent_class;
};

struct _LspInitializeParamsPrivate {
	gint _processId;
	gchar* _rootPath;
	gchar* _rootUri;
	LspClientCapabilities* _capabilities;
};

struct _LspSignatureInformation {
	GObject parent_instance;
	LspSignatureInformationPrivate * priv;
};

struct _LspSignatureInformationClass {
	GObjectClass parent_class;
};

struct _LspSignatureInformationPrivate {
	gchar* _label;
	LspMarkupContent* _documentation;
	GeeList* _parameters;
};

struct _LspSignatureHelp {
	GObject parent_instance;
	LspSignatureHelpPrivate * priv;
};

struct _LspSignatureHelpClass {
	GObjectClass parent_class;
};

struct _LspSignatureHelpPrivate {
	GeeCollection* _signatures;
	gint _activeSignature;
	gint _activeParameter;
};

struct _LspParameterInformation {
	GObject parent_instance;
	LspParameterInformationPrivate * priv;
};

struct _LspParameterInformationClass {
	GObjectClass parent_class;
};

struct _LspParameterInformationPrivate {
	gchar* _label;
	LspMarkupContent* _documentation;
};

struct _LspMarkedString {
	GObject parent_instance;
	LspMarkedStringPrivate * priv;
};

struct _LspMarkedStringClass {
	GObjectClass parent_class;
};

struct _LspMarkedStringPrivate {
	gchar* _language;
	gchar* _value;
};

struct _LspHover {
	GObject parent_instance;
	LspHoverPrivate * priv;
};

struct _LspHoverClass {
	GObjectClass parent_class;
};

struct _LspHoverPrivate {
	GeeList* _contents;
	LspRange* _range;
};

struct _LspTextEdit {
	GObject parent_instance;
	LspTextEditPrivate * priv;
};

struct _LspTextEditClass {
	GObjectClass parent_class;
};

struct _LspTextEditPrivate {
	LspRange* _range;
	gchar* _newText;
};

struct _LspTextDocumentEdit {
	GObject parent_instance;
	LspTextDocumentEditPrivate * priv;
};

struct _LspTextDocumentEditClass {
	GObjectClass parent_class;
};

struct _LspTextDocumentEditPrivate {
	LspVersionedTextDocumentIdentifier* _textDocument;
	GeeArrayList* _edits;
};

struct _LspCommandLike {
	GObject parent_instance;
	LspCommandLikePrivate * priv;
};

struct _LspCommandLikeClass {
	GObjectClass parent_class;
};

struct _LspCommandLikePrivate {
	gchar* _command;
	GArray* _arguments;
};

struct _Block27Data {
	int _ref_count_;
	LspCommandLike* self;
	GArray* arguments;
};

struct _LspExecuteCommandParams {
	LspCommandLike parent_instance;
	LspExecuteCommandParamsPrivate * priv;
};

struct _LspExecuteCommandParamsClass {
	LspCommandLikeClass parent_class;
};

struct _LspCommand {
	LspCommandLike parent_instance;
	LspCommandPrivate * priv;
};

struct _LspCommandClass {
	LspCommandLikeClass parent_class;
};

struct _LspCommandPrivate {
	gchar* _title;
};

struct _LspCodeLens {
	GObject parent_instance;
	LspCodeLensPrivate * priv;
};

struct _LspCodeLensClass {
	GObjectClass parent_class;
};

struct _LspCodeLensPrivate {
	LspRange* _range;
	LspCommand* _command;
};

struct _LspDocumentRangeFormattingParams {
	GObject parent_instance;
	LspDocumentRangeFormattingParamsPrivate * priv;
};

struct _LspDocumentRangeFormattingParamsClass {
	GObjectClass parent_class;
};

struct _LspDocumentRangeFormattingParamsPrivate {
	LspTextDocumentIdentifier* _textDocument;
	LspRange* _range;
	LspFormattingOptions* _options;
};

struct _LspFormattingOptions {
	GObject parent_instance;
	LspFormattingOptionsPrivate * priv;
};

struct _LspFormattingOptionsClass {
	GObjectClass parent_class;
};

struct _LspFormattingOptionsPrivate {
	guint _tabSize;
	gboolean _insertSpaces;
	gboolean _trimTrailingWhitespace;
	gboolean _insertFinalNewline;
	gboolean _trimFinalNewlines;
};

struct _LspCodeActionParams {
	GObject parent_instance;
	LspCodeActionParamsPrivate * priv;
};

struct _LspCodeActionParamsClass {
	GObjectClass parent_class;
};

struct _LspCodeActionParamsPrivate {
	LspTextDocumentIdentifier* _textDocument;
	LspRange* _range;
	LspCodeActionContext* _context;
};

struct _LspCodeActionContext {
	GObject parent_instance;
	LspCodeActionContextPrivate * priv;
};

struct _LspCodeActionContextClass {
	GObjectClass parent_class;
};

struct _LspCodeActionContextPrivate {
	GeeList* _diagnostics;
	gchar** _only;
	gint _only_length1;
	gint __only_size_;
};

struct _Block28Data {
	int _ref_count_;
	LspCodeActionContext* self;
	GeeArrayList* diags;
};

struct _LspCodeAction {
	GObject parent_instance;
	LspCodeActionPrivate * priv;
};

struct _LspCodeActionClass {
	GObjectClass parent_class;
};

struct _LspCodeActionPrivate {
	gchar* _title;
	gchar* _kind;
	GeeCollection* _diagnostics;
	gboolean _isPreferred;
	LspWorkspaceEdit* _edit;
	LspCommand* _command;
	GObject* _data;
};

struct _LspWorkspaceEdit {
	GObject parent_instance;
	LspWorkspaceEditPrivate * priv;
};

struct _LspWorkspaceEditClass {
	GObjectClass parent_class;
};

struct _LspWorkspaceEditPrivate {
	GeeList* _documentChanges;
};

struct _LspCallHierarchyItem {
	GObject parent_instance;
	LspCallHierarchyItemPrivate * priv;
};

struct _LspCallHierarchyItemClass {
	GObjectClass parent_class;
};

struct _LspCallHierarchyItemPrivate {
	gchar* _name;
	LspSymbolKind _kind;
	LspSymbolTags _tags;
	gchar* _detail;
	gchar* _uri;
	LspRange* _range;
	LspRange* _selectionRange;
};

struct _LspCallHierarchyIncomingCall {
	GObject parent_instance;
	LspCallHierarchyIncomingCallPrivate * priv;
};

struct _LspCallHierarchyIncomingCallClass {
	GObjectClass parent_class;
};

struct _LspCallHierarchyIncomingCallPrivate {
	LspCallHierarchyItem* _from;
	GeeArrayList* _fromRanges;
};

struct _LspCallHierarchyOutgoingCall {
	GObject parent_instance;
	LspCallHierarchyOutgoingCallPrivate * priv;
};

struct _LspCallHierarchyOutgoingCallClass {
	GObjectClass parent_class;
};

struct _LspCallHierarchyOutgoingCallPrivate {
	LspCallHierarchyItem* _to;
	GeeArrayList* _fromRanges;
};

struct _LspInlayHintParams {
	GObject parent_instance;
	LspInlayHintParamsPrivate * priv;
};

struct _LspInlayHintParamsClass {
	GObjectClass parent_class;
};

struct _LspInlayHintParamsPrivate {
	LspTextDocumentIdentifier* _textDocument;
	LspRange* _range;
};

struct _LspInlayHint {
	GObject parent_instance;
	LspInlayHintPrivate * priv;
};

struct _LspInlayHintClass {
	GObjectClass parent_class;
};

struct _LspInlayHintPrivate {
	LspPosition* _position;
	gchar* _label;
	LspInlayHintKind _kind;
	gchar* _tooltip;
	gboolean _paddingLeft;
	gboolean _paddingRight;
};

struct _LspTypeHierarchyItem {
	GObject parent_instance;
	LspTypeHierarchyItemPrivate * priv;
};

struct _LspTypeHierarchyItemClass {
	GObjectClass parent_class;
};

struct _LspTypeHierarchyItemPrivate {
	gchar* _name;
	LspSymbolKind _kind;
	LspSymbolTags _tags;
	gchar* _detail;
	gchar* _uri;
	LspRange* _range;
	LspRange* _selectionRange;
};

static gint LspPosition_private_offset;
static gpointer lsp_position_parent_class = NULL;
static GeeComparableIface * lsp_position_gee_comparable_parent_iface = NULL;
static gint LspRange_private_offset;
static gpointer lsp_range_parent_class = NULL;
static GeeHashableIface * lsp_range_gee_hashable_parent_iface = NULL;
static GeeComparableIface * lsp_range_gee_comparable_parent_iface = NULL;
static gint LspDiagnostic_private_offset;
static gpointer lsp_diagnostic_parent_class = NULL;
static gint LspTextDocumentContentChangeEvent_private_offset;
static gpointer lsp_text_document_content_change_event_parent_class = NULL;
static gint LspTextDocumentIdentifier_private_offset;
static gpointer lsp_text_document_identifier_parent_class = NULL;
static gint LspVersionedTextDocumentIdentifier_private_offset;
static gpointer lsp_versioned_text_document_identifier_parent_class = NULL;
static gint LspTextDocumentPositionParams_private_offset;
static gpointer lsp_text_document_position_params_parent_class = NULL;
static gint LspReferenceParams_private_offset;
static gpointer lsp_reference_params_parent_class = NULL;
static gint LspReferenceParamsReferenceContext_private_offset;
static gpointer lsp_reference_params_reference_context_parent_class = NULL;
static gint LspLocation_private_offset;
static gpointer lsp_location_parent_class = NULL;
static gint LspDocumentHighlight_private_offset;
static gpointer lsp_document_highlight_parent_class = NULL;
static gint LspDocumentSymbolParams_private_offset;
static gpointer lsp_document_symbol_params_parent_class = NULL;
static gint LspDocumentSymbol_private_offset;
static gpointer lsp_document_symbol_parent_class = NULL;
static JsonSerializableIface * lsp_document_symbol_json_serializable_parent_iface = NULL;
static gint LspSymbolInformation_private_offset;
static gpointer lsp_symbol_information_parent_class = NULL;
static gint LspCompletionList_private_offset;
static gpointer lsp_completion_list_parent_class = NULL;
static JsonSerializableIface * lsp_completion_list_json_serializable_parent_iface = NULL;
static gint LspCompletionContext_private_offset;
static gpointer lsp_completion_context_parent_class = NULL;
static gint LspCompletionParams_private_offset;
static gpointer lsp_completion_params_parent_class = NULL;
static gint LspCompletionItem_private_offset;
static gpointer lsp_completion_item_parent_class = NULL;
static GeeHashableIface * lsp_completion_item_gee_hashable_parent_iface = NULL;
static JsonSerializableIface * lsp_completion_item_json_serializable_parent_iface = NULL;
static gint LspMarkupContent_private_offset;
static gpointer lsp_markup_content_parent_class = NULL;
static gint LspDocumentSymbolCapabilities_private_offset;
static gpointer lsp_document_symbol_capabilities_parent_class = NULL;
static gint LspRenameClientCapabilities_private_offset;
static gpointer lsp_rename_client_capabilities_parent_class = NULL;
static gint LspTextDocumentClientCapabilities_private_offset;
static gpointer lsp_text_document_client_capabilities_parent_class = NULL;
static gint LspClientCapabilities_private_offset;
static gpointer lsp_client_capabilities_parent_class = NULL;
static gint LspInitializeParams_private_offset;
static gpointer lsp_initialize_params_parent_class = NULL;
static gint LspSignatureInformation_private_offset;
static gpointer lsp_signature_information_parent_class = NULL;
static JsonSerializableIface * lsp_signature_information_json_serializable_parent_iface = NULL;
static gint LspSignatureHelp_private_offset;
static gpointer lsp_signature_help_parent_class = NULL;
static JsonSerializableIface * lsp_signature_help_json_serializable_parent_iface = NULL;
static gint LspParameterInformation_private_offset;
static gpointer lsp_parameter_information_parent_class = NULL;
static gint LspMarkedString_private_offset;
static gpointer lsp_marked_string_parent_class = NULL;
static gint LspHover_private_offset;
static gpointer lsp_hover_parent_class = NULL;
static JsonSerializableIface * lsp_hover_json_serializable_parent_iface = NULL;
static gint LspTextEdit_private_offset;
static gpointer lsp_text_edit_parent_class = NULL;
static gint LspTextDocumentEdit_private_offset;
static gpointer lsp_text_document_edit_parent_class = NULL;
static JsonSerializableIface * lsp_text_document_edit_json_serializable_parent_iface = NULL;
static gint LspCommandLike_private_offset;
static gpointer lsp_command_like_parent_class = NULL;
static JsonSerializableIface * lsp_command_like_json_serializable_parent_iface = NULL;
static gpointer lsp_execute_command_params_parent_class = NULL;
static gint LspCommand_private_offset;
static gpointer lsp_command_parent_class = NULL;
static gint LspCodeLens_private_offset;
static gpointer lsp_code_lens_parent_class = NULL;
static gint LspDocumentRangeFormattingParams_private_offset;
static gpointer lsp_document_range_formatting_params_parent_class = NULL;
static gint LspFormattingOptions_private_offset;
static gpointer lsp_formatting_options_parent_class = NULL;
static gint LspCodeActionParams_private_offset;
static gpointer lsp_code_action_params_parent_class = NULL;
static gint LspCodeActionContext_private_offset;
static gpointer lsp_code_action_context_parent_class = NULL;
static JsonSerializableIface * lsp_code_action_context_json_serializable_parent_iface = NULL;
static gint LspCodeAction_private_offset;
static gpointer lsp_code_action_parent_class = NULL;
static JsonSerializableIface * lsp_code_action_json_serializable_parent_iface = NULL;
static gint LspWorkspaceEdit_private_offset;
static gpointer lsp_workspace_edit_parent_class = NULL;
static JsonSerializableIface * lsp_workspace_edit_json_serializable_parent_iface = NULL;
static gint LspCallHierarchyItem_private_offset;
static gpointer lsp_call_hierarchy_item_parent_class = NULL;
static JsonSerializableIface * lsp_call_hierarchy_item_json_serializable_parent_iface = NULL;
static gint LspCallHierarchyIncomingCall_private_offset;
static gpointer lsp_call_hierarchy_incoming_call_parent_class = NULL;
static JsonSerializableIface * lsp_call_hierarchy_incoming_call_json_serializable_parent_iface = NULL;
static gint LspCallHierarchyOutgoingCall_private_offset;
static gpointer lsp_call_hierarchy_outgoing_call_parent_class = NULL;
static JsonSerializableIface * lsp_call_hierarchy_outgoing_call_json_serializable_parent_iface = NULL;
static gint LspInlayHintParams_private_offset;
static gpointer lsp_inlay_hint_params_parent_class = NULL;
static JsonSerializableIface * lsp_inlay_hint_params_json_serializable_parent_iface = NULL;
static gint LspInlayHint_private_offset;
static gpointer lsp_inlay_hint_parent_class = NULL;
static gint LspTypeHierarchyItem_private_offset;
static gpointer lsp_typehierarchy_item_parent_class = NULL;
static JsonSerializableIface * lsp_typehierarchy_item_json_serializable_parent_iface = NULL;

VALA_EXTERN GType lsp_text_document_sync_kind_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType lsp_diagnostic_severity_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType lsp_position_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspPosition, g_object_unref)
static gint lsp_position_real_compare_to (GeeComparable* base,
                                   LspPosition* other);
VALA_EXTERN guint lsp_position_get_line (LspPosition* self);
VALA_EXTERN guint lsp_position_get_character (LspPosition* self);
VALA_EXTERN gchar* lsp_position_to_string (LspPosition* self);
VALA_EXTERN LspPosition* lsp_position_new_from_libvala (ValaSourceLocation* sloc);
VALA_EXTERN LspPosition* lsp_position_construct_from_libvala (GType object_type,
                                                  ValaSourceLocation* sloc);
VALA_EXTERN void lsp_position_set_line (LspPosition* self,
                            guint value);
VALA_EXTERN void lsp_position_set_character (LspPosition* self,
                                 guint value);
VALA_EXTERN LspPosition* lsp_position_dup (LspPosition* self);
VALA_EXTERN LspPosition* lsp_position_translate (LspPosition* self,
                                     gint dl,
                                     gint dc);
VALA_EXTERN LspPosition* lsp_position_new (void);
VALA_EXTERN LspPosition* lsp_position_construct (GType object_type);
static void lsp_position_finalize (GObject * obj);
static GType lsp_position_get_type_once (void);
static void _vala_lsp_position_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec);
static void _vala_lsp_position_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec);
VALA_EXTERN GType lsp_range_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspRange, g_object_unref)
VALA_EXTERN gchar* lsp_range_to_string (LspRange* self);
VALA_EXTERN LspPosition* lsp_range_get_start (LspRange* self);
VALA_EXTERN LspPosition* lsp_range_get_end (LspRange* self);
VALA_EXTERN LspRange* lsp_range_new_from_sourceref (ValaSourceReference* sref);
VALA_EXTERN LspRange* lsp_range_construct_from_sourceref (GType object_type,
                                              ValaSourceReference* sref);
VALA_EXTERN void lsp_range_set_start (LspRange* self,
                          LspPosition* value);
VALA_EXTERN void lsp_range_set_end (LspRange* self,
                        LspPosition* value);
static guint lsp_range_real_hash (GeeHashable* base);
static gboolean lsp_range_real_equal_to (GeeHashable* base,
                                  LspRange* other);
static gint lsp_range_real_compare_to (GeeComparable* base,
                                LspRange* other);
VALA_EXTERN LspRange* lsp_range_union (LspRange* self,
                           LspRange* other);
VALA_EXTERN LspRange* lsp_range_new (void);
VALA_EXTERN LspRange* lsp_range_construct (GType object_type);
VALA_EXTERN gboolean lsp_range_contains (LspRange* self,
                             LspPosition* pos);
static void lsp_range_finalize (GObject * obj);
static GType lsp_range_get_type_once (void);
static void _vala_lsp_range_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec);
static void _vala_lsp_range_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec);
VALA_EXTERN GType lsp_diagnostic_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspDiagnostic, g_object_unref)
VALA_EXTERN LspDiagnostic* lsp_diagnostic_new (void);
VALA_EXTERN LspDiagnostic* lsp_diagnostic_construct (GType object_type);
VALA_EXTERN LspRange* lsp_diagnostic_get_range (LspDiagnostic* self);
VALA_EXTERN void lsp_diagnostic_set_range (LspDiagnostic* self,
                               LspRange* value);
VALA_EXTERN LspDiagnosticSeverity lsp_diagnostic_get_severity (LspDiagnostic* self);
VALA_EXTERN void lsp_diagnostic_set_severity (LspDiagnostic* self,
                                  LspDiagnosticSeverity value);
VALA_EXTERN const gchar* lsp_diagnostic_get_code (LspDiagnostic* self);
VALA_EXTERN void lsp_diagnostic_set_code (LspDiagnostic* self,
                              const gchar* value);
VALA_EXTERN const gchar* lsp_diagnostic_get_source (LspDiagnostic* self);
VALA_EXTERN void lsp_diagnostic_set_source (LspDiagnostic* self,
                                const gchar* value);
VALA_EXTERN const gchar* lsp_diagnostic_get_message (LspDiagnostic* self);
VALA_EXTERN void lsp_diagnostic_set_message (LspDiagnostic* self,
                                 const gchar* value);
static void lsp_diagnostic_finalize (GObject * obj);
static GType lsp_diagnostic_get_type_once (void);
static void _vala_lsp_diagnostic_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec);
static void _vala_lsp_diagnostic_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec);
VALA_EXTERN GType lsp_text_document_content_change_event_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspTextDocumentContentChangeEvent, g_object_unref)
VALA_EXTERN LspTextDocumentContentChangeEvent* lsp_text_document_content_change_event_new (void);
VALA_EXTERN LspTextDocumentContentChangeEvent* lsp_text_document_content_change_event_construct (GType object_type);
VALA_EXTERN LspRange* lsp_text_document_content_change_event_get_range (LspTextDocumentContentChangeEvent* self);
VALA_EXTERN void lsp_text_document_content_change_event_set_range (LspTextDocumentContentChangeEvent* self,
                                                       LspRange* value);
VALA_EXTERN gint lsp_text_document_content_change_event_get_rangeLength (LspTextDocumentContentChangeEvent* self);
VALA_EXTERN void lsp_text_document_content_change_event_set_rangeLength (LspTextDocumentContentChangeEvent* self,
                                                             gint value);
VALA_EXTERN const gchar* lsp_text_document_content_change_event_get_text (LspTextDocumentContentChangeEvent* self);
VALA_EXTERN void lsp_text_document_content_change_event_set_text (LspTextDocumentContentChangeEvent* self,
                                                      const gchar* value);
static void lsp_text_document_content_change_event_finalize (GObject * obj);
static GType lsp_text_document_content_change_event_get_type_once (void);
static void _vala_lsp_text_document_content_change_event_get_property (GObject * object,
                                                                guint property_id,
                                                                GValue * value,
                                                                GParamSpec * pspec);
static void _vala_lsp_text_document_content_change_event_set_property (GObject * object,
                                                                guint property_id,
                                                                const GValue * value,
                                                                GParamSpec * pspec);
VALA_EXTERN GType lsp_message_type_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType lsp_text_document_identifier_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspTextDocumentIdentifier, g_object_unref)
VALA_EXTERN LspTextDocumentIdentifier* lsp_text_document_identifier_new (void);
VALA_EXTERN LspTextDocumentIdentifier* lsp_text_document_identifier_construct (GType object_type);
VALA_EXTERN const gchar* lsp_text_document_identifier_get_uri (LspTextDocumentIdentifier* self);
VALA_EXTERN void lsp_text_document_identifier_set_uri (LspTextDocumentIdentifier* self,
                                           const gchar* value);
static void lsp_text_document_identifier_finalize (GObject * obj);
static GType lsp_text_document_identifier_get_type_once (void);
static void _vala_lsp_text_document_identifier_get_property (GObject * object,
                                                      guint property_id,
                                                      GValue * value,
                                                      GParamSpec * pspec);
static void _vala_lsp_text_document_identifier_set_property (GObject * object,
                                                      guint property_id,
                                                      const GValue * value,
                                                      GParamSpec * pspec);
VALA_EXTERN GType lsp_versioned_text_document_identifier_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspVersionedTextDocumentIdentifier, g_object_unref)
VALA_EXTERN LspVersionedTextDocumentIdentifier* lsp_versioned_text_document_identifier_new (void);
VALA_EXTERN LspVersionedTextDocumentIdentifier* lsp_versioned_text_document_identifier_construct (GType object_type);
VALA_EXTERN gint lsp_versioned_text_document_identifier_get_version (LspVersionedTextDocumentIdentifier* self);
VALA_EXTERN void lsp_versioned_text_document_identifier_set_version (LspVersionedTextDocumentIdentifier* self,
                                                         gint value);
static void lsp_versioned_text_document_identifier_finalize (GObject * obj);
static GType lsp_versioned_text_document_identifier_get_type_once (void);
static void _vala_lsp_versioned_text_document_identifier_get_property (GObject * object,
                                                                guint property_id,
                                                                GValue * value,
                                                                GParamSpec * pspec);
static void _vala_lsp_versioned_text_document_identifier_set_property (GObject * object,
                                                                guint property_id,
                                                                const GValue * value,
                                                                GParamSpec * pspec);
VALA_EXTERN GType lsp_text_document_position_params_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspTextDocumentPositionParams, g_object_unref)
VALA_EXTERN LspTextDocumentPositionParams* lsp_text_document_position_params_new (void);
VALA_EXTERN LspTextDocumentPositionParams* lsp_text_document_position_params_construct (GType object_type);
VALA_EXTERN LspTextDocumentIdentifier* lsp_text_document_position_params_get_textDocument (LspTextDocumentPositionParams* self);
VALA_EXTERN void lsp_text_document_position_params_set_textDocument (LspTextDocumentPositionParams* self,
                                                         LspTextDocumentIdentifier* value);
VALA_EXTERN LspPosition* lsp_text_document_position_params_get_position (LspTextDocumentPositionParams* self);
VALA_EXTERN void lsp_text_document_position_params_set_position (LspTextDocumentPositionParams* self,
                                                     LspPosition* value);
static void lsp_text_document_position_params_finalize (GObject * obj);
static GType lsp_text_document_position_params_get_type_once (void);
static void _vala_lsp_text_document_position_params_get_property (GObject * object,
                                                           guint property_id,
                                                           GValue * value,
                                                           GParamSpec * pspec);
static void _vala_lsp_text_document_position_params_set_property (GObject * object,
                                                           guint property_id,
                                                           const GValue * value,
                                                           GParamSpec * pspec);
VALA_EXTERN GType lsp_reference_params_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspReferenceParams, g_object_unref)
VALA_EXTERN GType lsp_reference_params_reference_context_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspReferenceParamsReferenceContext, g_object_unref)
VALA_EXTERN LspReferenceParams* lsp_reference_params_new (void);
VALA_EXTERN LspReferenceParams* lsp_reference_params_construct (GType object_type);
VALA_EXTERN LspReferenceParamsReferenceContext* lsp_reference_params_get_context (LspReferenceParams* self);
VALA_EXTERN void lsp_reference_params_set_context (LspReferenceParams* self,
                                       LspReferenceParamsReferenceContext* value);
VALA_EXTERN LspReferenceParamsReferenceContext* lsp_reference_params_reference_context_new (void);
VALA_EXTERN LspReferenceParamsReferenceContext* lsp_reference_params_reference_context_construct (GType object_type);
VALA_EXTERN gboolean lsp_reference_params_reference_context_get_includeDeclaration (LspReferenceParamsReferenceContext* self);
VALA_EXTERN void lsp_reference_params_reference_context_set_includeDeclaration (LspReferenceParamsReferenceContext* self,
                                                                    gboolean value);
static void lsp_reference_params_reference_context_finalize (GObject * obj);
static GType lsp_reference_params_reference_context_get_type_once (void);
static void _vala_lsp_reference_params_reference_context_get_property (GObject * object,
                                                                guint property_id,
                                                                GValue * value,
                                                                GParamSpec * pspec);
static void _vala_lsp_reference_params_reference_context_set_property (GObject * object,
                                                                guint property_id,
                                                                const GValue * value,
                                                                GParamSpec * pspec);
static void lsp_reference_params_finalize (GObject * obj);
static GType lsp_reference_params_get_type_once (void);
static void _vala_lsp_reference_params_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec);
static void _vala_lsp_reference_params_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec);
VALA_EXTERN GType lsp_location_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspLocation, g_object_unref)
VALA_EXTERN LspLocation* lsp_location_new_from_sourceref (ValaSourceReference* sref);
VALA_EXTERN LspLocation* lsp_location_construct_from_sourceref (GType object_type,
                                                    ValaSourceReference* sref);
VALA_EXTERN LspLocation* lsp_location_new (const gchar* filename,
                               LspRange* range);
VALA_EXTERN LspLocation* lsp_location_construct (GType object_type,
                                     const gchar* filename,
                                     LspRange* range);
VALA_EXTERN void lsp_location_set_uri (LspLocation* self,
                           const gchar* value);
VALA_EXTERN void lsp_location_set_range (LspLocation* self,
                             LspRange* value);
VALA_EXTERN const gchar* lsp_location_get_uri (LspLocation* self);
VALA_EXTERN LspRange* lsp_location_get_range (LspLocation* self);
static void lsp_location_finalize (GObject * obj);
static GType lsp_location_get_type_once (void);
static void _vala_lsp_location_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec);
static void _vala_lsp_location_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec);
VALA_EXTERN GType lsp_document_highlight_kind_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType lsp_document_highlight_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspDocumentHighlight, g_object_unref)
VALA_EXTERN LspDocumentHighlight* lsp_document_highlight_new (void);
VALA_EXTERN LspDocumentHighlight* lsp_document_highlight_construct (GType object_type);
VALA_EXTERN LspRange* lsp_document_highlight_get_range (LspDocumentHighlight* self);
VALA_EXTERN void lsp_document_highlight_set_range (LspDocumentHighlight* self,
                                       LspRange* value);
VALA_EXTERN LspDocumentHighlightKind lsp_document_highlight_get_kind (LspDocumentHighlight* self);
VALA_EXTERN void lsp_document_highlight_set_kind (LspDocumentHighlight* self,
                                      LspDocumentHighlightKind value);
static void lsp_document_highlight_finalize (GObject * obj);
static GType lsp_document_highlight_get_type_once (void);
static void _vala_lsp_document_highlight_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec);
static void _vala_lsp_document_highlight_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec);
VALA_EXTERN GType lsp_document_symbol_params_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspDocumentSymbolParams, g_object_unref)
VALA_EXTERN LspDocumentSymbolParams* lsp_document_symbol_params_new (void);
VALA_EXTERN LspDocumentSymbolParams* lsp_document_symbol_params_construct (GType object_type);
VALA_EXTERN LspTextDocumentIdentifier* lsp_document_symbol_params_get_textDocument (LspDocumentSymbolParams* self);
VALA_EXTERN void lsp_document_symbol_params_set_textDocument (LspDocumentSymbolParams* self,
                                                  LspTextDocumentIdentifier* value);
static void lsp_document_symbol_params_finalize (GObject * obj);
static GType lsp_document_symbol_params_get_type_once (void);
static void _vala_lsp_document_symbol_params_get_property (GObject * object,
                                                    guint property_id,
                                                    GValue * value,
                                                    GParamSpec * pspec);
static void _vala_lsp_document_symbol_params_set_property (GObject * object,
                                                    guint property_id,
                                                    const GValue * value,
                                                    GParamSpec * pspec);
VALA_EXTERN GType lsp_document_symbol_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspDocumentSymbol, g_object_unref)
VALA_EXTERN GType lsp_symbol_kind_get_type (void) G_GNUC_CONST ;
static LspDocumentSymbol* lsp_document_symbol_new (void);
static LspDocumentSymbol* lsp_document_symbol_construct (GType object_type);
VALA_EXTERN LspDocumentSymbol* lsp_document_symbol_new_from_vala_symbol (ValaDataType* type,
                                                             ValaSymbol* sym,
                                                             LspSymbolKind kind);
VALA_EXTERN LspDocumentSymbol* lsp_document_symbol_construct_from_vala_symbol (GType object_type,
                                                                   ValaDataType* type,
                                                                   ValaSymbol* sym,
                                                                   LspSymbolKind kind);
VALA_EXTERN void lsp_document_symbol_set_name (LspDocumentSymbol* self,
                                   const gchar* value);
VALA_EXTERN gchar* vls_code_help_get_symbol_representation (ValaDataType* data_type,
                                                ValaSymbol* sym,
                                                ValaScope* scope,
                                                gboolean allow_show_parent_member,
                                                ValaList* method_type_arguments,
                                                const gchar* override_name,
                                                gboolean show_initializers,
                                                gboolean is_parent_symbol,
                                                ValaList* ellipsis_overrides,
                                                gboolean show_parameter_direction);
VALA_EXTERN void lsp_document_symbol_set_detail (LspDocumentSymbol* self,
                                     const gchar* value);
VALA_EXTERN void lsp_document_symbol_set_kind (LspDocumentSymbol* self,
                                   LspSymbolKind value);
VALA_EXTERN void lsp_document_symbol_set_selectionRange (LspDocumentSymbol* self,
                                             LspRange* value);
VALA_EXTERN void lsp_document_symbol_set_deprecated (LspDocumentSymbol* self,
                                         gboolean value);
static void lsp_document_symbol_real_json_serializable_set_property (JsonSerializable* base,
                                                              GParamSpec* pspec,
                                                              GValue* value);
static void lsp_document_symbol_real_json_serializable_get_property (JsonSerializable* base,
                                                              GParamSpec* pspec,
                                                              GValue* result);
static GParamSpec* lsp_document_symbol_real_find_property (JsonSerializable* base,
                                                    const gchar* name);
static JsonNode* lsp_document_symbol_real_serialize_property (JsonSerializable* base,
                                                       const gchar* property_name,
                                                       GValue* value,
                                                       GParamSpec* pspec);
VALA_EXTERN GeeList* lsp_document_symbol_get_children (LspDocumentSymbol* self);
static gboolean lsp_document_symbol_real_deserialize_property (JsonSerializable* base,
                                                        const gchar* property_name,
                                                        GValue* value,
                                                        GParamSpec* pspec,
                                                        JsonNode* property_node);
VALA_EXTERN const gchar* lsp_document_symbol_get_name (LspDocumentSymbol* self);
VALA_EXTERN const gchar* lsp_document_symbol_get_detail (LspDocumentSymbol* self);
VALA_EXTERN LspSymbolKind lsp_document_symbol_get_kind (LspDocumentSymbol* self);
VALA_EXTERN gboolean lsp_document_symbol_get_deprecated (LspDocumentSymbol* self);
VALA_EXTERN LspRange* lsp_document_symbol_get_range (LspDocumentSymbol* self);
static LspRange* _lsp_document_symbol_range___lambda5_ (LspDocumentSymbol* self,
                                                 LspDocumentSymbol* child,
                                                 LspRange* current_range);
static gpointer __lsp_document_symbol_range___lambda5__gee_fold_func (gpointer g,
                                                               gpointer a,
                                                               gpointer self);
VALA_EXTERN LspRange* lsp_document_symbol_get_selectionRange (LspDocumentSymbol* self);
static void lsp_document_symbol_set_children (LspDocumentSymbol* self,
                                       GeeList* value);
static void lsp_document_symbol_finalize (GObject * obj);
static GType lsp_document_symbol_get_type_once (void);
static void _vala_lsp_document_symbol_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec);
static void _vala_lsp_document_symbol_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec);
VALA_EXTERN GType lsp_symbol_information_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspSymbolInformation, g_object_unref)
VALA_EXTERN LspSymbolInformation* lsp_symbol_information_new_from_document_symbol (LspDocumentSymbol* dsym,
                                                                       const gchar* uri);
VALA_EXTERN LspSymbolInformation* lsp_symbol_information_construct_from_document_symbol (GType object_type,
                                                                             LspDocumentSymbol* dsym,
                                                                             const gchar* uri);
VALA_EXTERN void lsp_symbol_information_set_name (LspSymbolInformation* self,
                                      const gchar* value);
VALA_EXTERN void lsp_symbol_information_set_kind (LspSymbolInformation* self,
                                      LspSymbolKind value);
VALA_EXTERN void lsp_symbol_information_set_location (LspSymbolInformation* self,
                                          LspLocation* value);
VALA_EXTERN void lsp_symbol_information_set_containerName (LspSymbolInformation* self,
                                               const gchar* value);
VALA_EXTERN LspSymbolInformation* lsp_symbol_information_new (void);
VALA_EXTERN LspSymbolInformation* lsp_symbol_information_construct (GType object_type);
VALA_EXTERN const gchar* lsp_symbol_information_get_name (LspSymbolInformation* self);
VALA_EXTERN LspSymbolKind lsp_symbol_information_get_kind (LspSymbolInformation* self);
VALA_EXTERN LspLocation* lsp_symbol_information_get_location (LspSymbolInformation* self);
VALA_EXTERN const gchar* lsp_symbol_information_get_containerName (LspSymbolInformation* self);
static void lsp_symbol_information_finalize (GObject * obj);
static GType lsp_symbol_information_get_type_once (void);
static void _vala_lsp_symbol_information_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec);
static void _vala_lsp_symbol_information_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec);
VALA_EXTERN GType lsp_completion_list_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspCompletionList, g_object_unref)
VALA_EXTERN GType lsp_completion_item_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspCompletionItem, g_object_unref)
static void lsp_completion_list_real_json_serializable_set_property (JsonSerializable* base,
                                                              GParamSpec* pspec,
                                                              GValue* value);
static void lsp_completion_list_real_json_serializable_get_property (JsonSerializable* base,
                                                              GParamSpec* pspec,
                                                              GValue* result);
static GParamSpec* lsp_completion_list_real_find_property (JsonSerializable* base,
                                                    const gchar* name);
static JsonNode* lsp_completion_list_real_serialize_property (JsonSerializable* base,
                                                       const gchar* property_name,
                                                       GValue* value,
                                                       GParamSpec* pspec);
VALA_EXTERN GeeList* lsp_completion_list_get_items (LspCompletionList* self);
static gboolean lsp_completion_list_real_deserialize_property (JsonSerializable* base,
                                                        const gchar* property_name,
                                                        GValue* value,
                                                        GParamSpec* pspec,
                                                        JsonNode* property_node);
VALA_EXTERN LspCompletionList* lsp_completion_list_new (void);
VALA_EXTERN LspCompletionList* lsp_completion_list_construct (GType object_type);
VALA_EXTERN gboolean lsp_completion_list_get_isIncomplete (LspCompletionList* self);
VALA_EXTERN void lsp_completion_list_set_isIncomplete (LspCompletionList* self,
                                           gboolean value);
static void lsp_completion_list_set_items (LspCompletionList* self,
                                    GeeList* value);
static void lsp_completion_list_finalize (GObject * obj);
static GType lsp_completion_list_get_type_once (void);
static void _vala_lsp_completion_list_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec);
static void _vala_lsp_completion_list_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec);
VALA_EXTERN GType lsp_completion_trigger_kind_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType lsp_completion_context_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspCompletionContext, g_object_unref)
VALA_EXTERN LspCompletionContext* lsp_completion_context_new (void);
VALA_EXTERN LspCompletionContext* lsp_completion_context_construct (GType object_type);
VALA_EXTERN LspCompletionTriggerKind lsp_completion_context_get_triggerKind (LspCompletionContext* self);
VALA_EXTERN void lsp_completion_context_set_triggerKind (LspCompletionContext* self,
                                             LspCompletionTriggerKind value);
VALA_EXTERN const gchar* lsp_completion_context_get_triggerCharacter (LspCompletionContext* self);
VALA_EXTERN void lsp_completion_context_set_triggerCharacter (LspCompletionContext* self,
                                                  const gchar* value);
static void lsp_completion_context_finalize (GObject * obj);
static GType lsp_completion_context_get_type_once (void);
static void _vala_lsp_completion_context_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec);
static void _vala_lsp_completion_context_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec);
VALA_EXTERN GType lsp_completion_params_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspCompletionParams, g_object_unref)
VALA_EXTERN LspCompletionParams* lsp_completion_params_new (void);
VALA_EXTERN LspCompletionParams* lsp_completion_params_construct (GType object_type);
VALA_EXTERN LspCompletionContext* lsp_completion_params_get_context (LspCompletionParams* self);
VALA_EXTERN void lsp_completion_params_set_context (LspCompletionParams* self,
                                        LspCompletionContext* value);
static void lsp_completion_params_finalize (GObject * obj);
static GType lsp_completion_params_get_type_once (void);
static void _vala_lsp_completion_params_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec);
static void _vala_lsp_completion_params_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec);
VALA_EXTERN GType lsp_completion_item_tag_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType lsp_insert_text_format_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType lsp_completion_item_kind_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType lsp_markup_content_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspMarkupContent, g_object_unref)
static LspCompletionItem* lsp_completion_item_new (void);
static LspCompletionItem* lsp_completion_item_construct (GType object_type);
VALA_EXTERN LspCompletionItem* lsp_completion_item_new_keyword (const gchar* keyword,
                                                    const gchar* insert_text,
                                                    const gchar* documentation);
VALA_EXTERN LspCompletionItem* lsp_completion_item_construct_keyword (GType object_type,
                                                          const gchar* keyword,
                                                          const gchar* insert_text,
                                                          const gchar* documentation);
VALA_EXTERN void lsp_completion_item_set_label (LspCompletionItem* self,
                                    const gchar* value);
VALA_EXTERN void lsp_completion_item_set_kind (LspCompletionItem* self,
                                   LspCompletionItemKind value);
VALA_EXTERN void lsp_completion_item_set_insertText (LspCompletionItem* self,
                                         const gchar* value);
VALA_EXTERN void lsp_completion_item_set_insertTextFormat (LspCompletionItem* self,
                                               LspInsertTextFormat value);
VALA_EXTERN LspMarkupContent* lsp_markup_content_new_from_plaintext (const gchar* doc);
VALA_EXTERN LspMarkupContent* lsp_markup_content_construct_from_plaintext (GType object_type,
                                                               const gchar* doc);
VALA_EXTERN void lsp_completion_item_set_documentation (LspCompletionItem* self,
                                            LspMarkupContent* value);
VALA_EXTERN const gchar* lsp_completion_item_get_label (LspCompletionItem* self);
VALA_EXTERN LspCompletionItemKind lsp_completion_item_get_kind (LspCompletionItem* self);
VALA_EXTERN gpointer vls_doc_comment_ref (gpointer instance);
VALA_EXTERN void vls_doc_comment_unref (gpointer instance);
VALA_EXTERN GParamSpec* vls_param_spec_doc_comment (const gchar* name,
                                        const gchar* nick,
                                        const gchar* blurb,
                                        GType object_type,
                                        GParamFlags flags);
VALA_EXTERN void vls_value_set_doc_comment (GValue* value,
                                gpointer v_object);
VALA_EXTERN void vls_value_take_doc_comment (GValue* value,
                                 gpointer v_object);
VALA_EXTERN gpointer vls_value_get_doc_comment (const GValue* value);
VALA_EXTERN GType vls_doc_comment_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VlsDocComment, vls_doc_comment_unref)
VALA_EXTERN LspCompletionItem* lsp_completion_item_new_from_symbol (ValaDataType* instance_type,
                                                        ValaSymbol* sym,
                                                        ValaScope* scope,
                                                        LspCompletionItemKind kind,
                                                        VlsDocComment* documentation,
                                                        const gchar* label_override);
VALA_EXTERN LspCompletionItem* lsp_completion_item_construct_from_symbol (GType object_type,
                                                              ValaDataType* instance_type,
                                                              ValaSymbol* sym,
                                                              ValaScope* scope,
                                                              LspCompletionItemKind kind,
                                                              VlsDocComment* documentation,
                                                              const gchar* label_override);
VALA_EXTERN void lsp_completion_item_set_detail (LspCompletionItem* self,
                                     const gchar* value);
VALA_EXTERN const gchar* vls_doc_comment_get_body (VlsDocComment* self);
VALA_EXTERN LspMarkupContent* lsp_markup_content_new_from_markdown (const gchar* doc);
VALA_EXTERN LspMarkupContent* lsp_markup_content_construct_from_markdown (GType object_type,
                                                              const gchar* doc);
VALA_EXTERN GeeList* lsp_completion_item_get_tags (LspCompletionItem* self);
VALA_EXTERN void lsp_completion_item_set_deprecated (LspCompletionItem* self,
                                         gboolean value);
VALA_EXTERN LspCompletionItem* lsp_completion_item_new_from_synthetic_symbol (ValaDataType* symbol_type,
                                                                  const gchar* symbol_name,
                                                                  ValaScope* scope,
                                                                  LspCompletionItemKind kind,
                                                                  VlsDocComment* documentation);
VALA_EXTERN LspCompletionItem* lsp_completion_item_construct_from_synthetic_symbol (GType object_type,
                                                                        ValaDataType* symbol_type,
                                                                        const gchar* symbol_name,
                                                                        ValaScope* scope,
                                                                        LspCompletionItemKind kind,
                                                                        VlsDocComment* documentation);
VALA_EXTERN LspCompletionItem* lsp_completion_item_new_from_unimplemented_symbol (ValaSymbol* sym,
                                                                      const gchar* label,
                                                                      LspCompletionItemKind kind,
                                                                      const gchar* insert_text,
                                                                      VlsDocComment* documentation);
VALA_EXTERN LspCompletionItem* lsp_completion_item_construct_from_unimplemented_symbol (GType object_type,
                                                                            ValaSymbol* sym,
                                                                            const gchar* label,
                                                                            LspCompletionItemKind kind,
                                                                            const gchar* insert_text,
                                                                            VlsDocComment* documentation);
static guint lsp_completion_item_real_hash (GeeHashable* base);
static gboolean lsp_completion_item_real_equal_to (GeeHashable* base,
                                            LspCompletionItem* other);
static void lsp_completion_item_real_json_serializable_set_property (JsonSerializable* base,
                                                              GParamSpec* pspec,
                                                              GValue* value);
static void lsp_completion_item_real_json_serializable_get_property (JsonSerializable* base,
                                                              GParamSpec* pspec,
                                                              GValue* result);
static GParamSpec* lsp_completion_item_real_find_property (JsonSerializable* base,
                                                    const gchar* name);
static JsonNode* lsp_completion_item_real_serialize_property (JsonSerializable* base,
                                                       const gchar* property_name,
                                                       GValue* value,
                                                       GParamSpec* pspec);
static gboolean lsp_completion_item_real_deserialize_property (JsonSerializable* base,
                                                        const gchar* property_name,
                                                        GValue* value,
                                                        GParamSpec* pspec,
                                                        JsonNode* property_node);
VALA_EXTERN const gchar* lsp_completion_item_get_detail (LspCompletionItem* self);
VALA_EXTERN LspMarkupContent* lsp_completion_item_get_documentation (LspCompletionItem* self);
VALA_EXTERN gboolean lsp_completion_item_get_deprecated (LspCompletionItem* self);
static void lsp_completion_item_set_tags (LspCompletionItem* self,
                                   GeeList* value);
VALA_EXTERN const gchar* lsp_completion_item_get_insertText (LspCompletionItem* self);
VALA_EXTERN LspInsertTextFormat lsp_completion_item_get_insertTextFormat (LspCompletionItem* self);
static void lsp_completion_item_finalize (GObject * obj);
static GType lsp_completion_item_get_type_once (void);
static void _vala_lsp_completion_item_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec);
static void _vala_lsp_completion_item_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec);
static LspMarkupContent* lsp_markup_content_new (void);
static LspMarkupContent* lsp_markup_content_construct (GType object_type);
VALA_EXTERN void lsp_markup_content_set_kind (LspMarkupContent* self,
                                  const gchar* value);
VALA_EXTERN void lsp_markup_content_set_value (LspMarkupContent* self,
                                   const gchar* value);
VALA_EXTERN const gchar* lsp_markup_content_get_kind (LspMarkupContent* self);
VALA_EXTERN const gchar* lsp_markup_content_get_value (LspMarkupContent* self);
static void lsp_markup_content_finalize (GObject * obj);
static GType lsp_markup_content_get_type_once (void);
static void _vala_lsp_markup_content_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec);
static void _vala_lsp_markup_content_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec);
VALA_EXTERN GType lsp_document_symbol_capabilities_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspDocumentSymbolCapabilities, g_object_unref)
VALA_EXTERN LspDocumentSymbolCapabilities* lsp_document_symbol_capabilities_new (void);
VALA_EXTERN LspDocumentSymbolCapabilities* lsp_document_symbol_capabilities_construct (GType object_type);
VALA_EXTERN gboolean lsp_document_symbol_capabilities_get_hierarchicalDocumentSymbolSupport (LspDocumentSymbolCapabilities* self);
VALA_EXTERN void lsp_document_symbol_capabilities_set_hierarchicalDocumentSymbolSupport (LspDocumentSymbolCapabilities* self,
                                                                             gboolean value);
static void lsp_document_symbol_capabilities_finalize (GObject * obj);
static GType lsp_document_symbol_capabilities_get_type_once (void);
static void _vala_lsp_document_symbol_capabilities_get_property (GObject * object,
                                                          guint property_id,
                                                          GValue * value,
                                                          GParamSpec * pspec);
static void _vala_lsp_document_symbol_capabilities_set_property (GObject * object,
                                                          guint property_id,
                                                          const GValue * value,
                                                          GParamSpec * pspec);
VALA_EXTERN GType lsp_rename_client_capabilities_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspRenameClientCapabilities, g_object_unref)
VALA_EXTERN LspRenameClientCapabilities* lsp_rename_client_capabilities_new (void);
VALA_EXTERN LspRenameClientCapabilities* lsp_rename_client_capabilities_construct (GType object_type);
VALA_EXTERN gboolean lsp_rename_client_capabilities_get_prepareSupport (LspRenameClientCapabilities* self);
VALA_EXTERN void lsp_rename_client_capabilities_set_prepareSupport (LspRenameClientCapabilities* self,
                                                        gboolean value);
static void lsp_rename_client_capabilities_finalize (GObject * obj);
static GType lsp_rename_client_capabilities_get_type_once (void);
static void _vala_lsp_rename_client_capabilities_get_property (GObject * object,
                                                        guint property_id,
                                                        GValue * value,
                                                        GParamSpec * pspec);
static void _vala_lsp_rename_client_capabilities_set_property (GObject * object,
                                                        guint property_id,
                                                        const GValue * value,
                                                        GParamSpec * pspec);
VALA_EXTERN GType lsp_text_document_client_capabilities_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspTextDocumentClientCapabilities, g_object_unref)
VALA_EXTERN LspTextDocumentClientCapabilities* lsp_text_document_client_capabilities_new (void);
VALA_EXTERN LspTextDocumentClientCapabilities* lsp_text_document_client_capabilities_construct (GType object_type);
VALA_EXTERN LspDocumentSymbolCapabilities* lsp_text_document_client_capabilities_get_documentSymbol (LspTextDocumentClientCapabilities* self);
VALA_EXTERN void lsp_text_document_client_capabilities_set_documentSymbol (LspTextDocumentClientCapabilities* self,
                                                               LspDocumentSymbolCapabilities* value);
VALA_EXTERN LspRenameClientCapabilities* lsp_text_document_client_capabilities_get_rename (LspTextDocumentClientCapabilities* self);
VALA_EXTERN void lsp_text_document_client_capabilities_set_rename (LspTextDocumentClientCapabilities* self,
                                                       LspRenameClientCapabilities* value);
static void lsp_text_document_client_capabilities_finalize (GObject * obj);
static GType lsp_text_document_client_capabilities_get_type_once (void);
static void _vala_lsp_text_document_client_capabilities_get_property (GObject * object,
                                                               guint property_id,
                                                               GValue * value,
                                                               GParamSpec * pspec);
static void _vala_lsp_text_document_client_capabilities_set_property (GObject * object,
                                                               guint property_id,
                                                               const GValue * value,
                                                               GParamSpec * pspec);
VALA_EXTERN GType lsp_client_capabilities_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspClientCapabilities, g_object_unref)
VALA_EXTERN LspClientCapabilities* lsp_client_capabilities_new (void);
VALA_EXTERN LspClientCapabilities* lsp_client_capabilities_construct (GType object_type);
VALA_EXTERN LspTextDocumentClientCapabilities* lsp_client_capabilities_get_textDocument (LspClientCapabilities* self);
VALA_EXTERN void lsp_client_capabilities_set_textDocument (LspClientCapabilities* self,
                                               LspTextDocumentClientCapabilities* value);
static void lsp_client_capabilities_finalize (GObject * obj);
static GType lsp_client_capabilities_get_type_once (void);
static void _vala_lsp_client_capabilities_get_property (GObject * object,
                                                 guint property_id,
                                                 GValue * value,
                                                 GParamSpec * pspec);
static void _vala_lsp_client_capabilities_set_property (GObject * object,
                                                 guint property_id,
                                                 const GValue * value,
                                                 GParamSpec * pspec);
VALA_EXTERN GType lsp_initialize_params_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspInitializeParams, g_object_unref)
VALA_EXTERN LspInitializeParams* lsp_initialize_params_new (void);
VALA_EXTERN LspInitializeParams* lsp_initialize_params_construct (GType object_type);
VALA_EXTERN gint lsp_initialize_params_get_processId (LspInitializeParams* self);
VALA_EXTERN void lsp_initialize_params_set_processId (LspInitializeParams* self,
                                          gint value);
VALA_EXTERN const gchar* lsp_initialize_params_get_rootPath (LspInitializeParams* self);
VALA_EXTERN void lsp_initialize_params_set_rootPath (LspInitializeParams* self,
                                         const gchar* value);
VALA_EXTERN const gchar* lsp_initialize_params_get_rootUri (LspInitializeParams* self);
VALA_EXTERN void lsp_initialize_params_set_rootUri (LspInitializeParams* self,
                                        const gchar* value);
VALA_EXTERN LspClientCapabilities* lsp_initialize_params_get_capabilities (LspInitializeParams* self);
VALA_EXTERN void lsp_initialize_params_set_capabilities (LspInitializeParams* self,
                                             LspClientCapabilities* value);
static void lsp_initialize_params_finalize (GObject * obj);
static GType lsp_initialize_params_get_type_once (void);
static void _vala_lsp_initialize_params_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec);
static void _vala_lsp_initialize_params_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec);
VALA_EXTERN GType lsp_signature_information_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspSignatureInformation, g_object_unref)
VALA_EXTERN GType lsp_parameter_information_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspParameterInformation, g_object_unref)
static void lsp_signature_information_real_json_serializable_set_property (JsonSerializable* base,
                                                                    GParamSpec* pspec,
                                                                    GValue* value);
static void lsp_signature_information_real_json_serializable_get_property (JsonSerializable* base,
                                                                    GParamSpec* pspec,
                                                                    GValue* result);
static GParamSpec* lsp_signature_information_real_find_property (JsonSerializable* base,
                                                          const gchar* name);
static JsonNode* lsp_signature_information_real_serialize_property (JsonSerializable* base,
                                                             const gchar* property_name,
                                                             GValue* value,
                                                             GParamSpec* pspec);
VALA_EXTERN GeeList* lsp_signature_information_get_parameters (LspSignatureInformation* self);
static gboolean lsp_signature_information_real_deserialize_property (JsonSerializable* base,
                                                              const gchar* property_name,
                                                              GValue* value,
                                                              GParamSpec* pspec,
                                                              JsonNode* property_node);
VALA_EXTERN LspSignatureInformation* lsp_signature_information_new (void);
VALA_EXTERN LspSignatureInformation* lsp_signature_information_construct (GType object_type);
VALA_EXTERN const gchar* lsp_signature_information_get_label (LspSignatureInformation* self);
VALA_EXTERN void lsp_signature_information_set_label (LspSignatureInformation* self,
                                          const gchar* value);
VALA_EXTERN LspMarkupContent* lsp_signature_information_get_documentation (LspSignatureInformation* self);
VALA_EXTERN void lsp_signature_information_set_documentation (LspSignatureInformation* self,
                                                  LspMarkupContent* value);
static void lsp_signature_information_set_parameters (LspSignatureInformation* self,
                                               GeeList* value);
static void lsp_signature_information_finalize (GObject * obj);
static GType lsp_signature_information_get_type_once (void);
static void _vala_lsp_signature_information_get_property (GObject * object,
                                                   guint property_id,
                                                   GValue * value,
                                                   GParamSpec * pspec);
static void _vala_lsp_signature_information_set_property (GObject * object,
                                                   guint property_id,
                                                   const GValue * value,
                                                   GParamSpec * pspec);
VALA_EXTERN GType lsp_signature_help_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspSignatureHelp, g_object_unref)
static JsonNode* lsp_signature_help_real_serialize_property (JsonSerializable* base,
                                                      const gchar* property_name,
                                                      GValue* value,
                                                      GParamSpec* pspec);
VALA_EXTERN GeeCollection* lsp_signature_help_get_signatures (LspSignatureHelp* self);
static gboolean lsp_signature_help_real_deserialize_property (JsonSerializable* base,
                                                       const gchar* property_name,
                                                       GValue* value,
                                                       GParamSpec* pspec,
                                                       JsonNode* property_node);
VALA_EXTERN LspSignatureHelp* lsp_signature_help_new (void);
VALA_EXTERN LspSignatureHelp* lsp_signature_help_construct (GType object_type);
VALA_EXTERN void lsp_signature_help_set_signatures (LspSignatureHelp* self,
                                        GeeCollection* value);
VALA_EXTERN gint lsp_signature_help_get_activeSignature (LspSignatureHelp* self);
VALA_EXTERN void lsp_signature_help_set_activeSignature (LspSignatureHelp* self,
                                             gint value);
VALA_EXTERN gint lsp_signature_help_get_activeParameter (LspSignatureHelp* self);
VALA_EXTERN void lsp_signature_help_set_activeParameter (LspSignatureHelp* self,
                                             gint value);
static void lsp_signature_help_finalize (GObject * obj);
static GType lsp_signature_help_get_type_once (void);
static void _vala_lsp_signature_help_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec);
static void _vala_lsp_signature_help_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec);
VALA_EXTERN LspParameterInformation* lsp_parameter_information_new (void);
VALA_EXTERN LspParameterInformation* lsp_parameter_information_construct (GType object_type);
VALA_EXTERN const gchar* lsp_parameter_information_get_label (LspParameterInformation* self);
VALA_EXTERN void lsp_parameter_information_set_label (LspParameterInformation* self,
                                          const gchar* value);
VALA_EXTERN LspMarkupContent* lsp_parameter_information_get_documentation (LspParameterInformation* self);
VALA_EXTERN void lsp_parameter_information_set_documentation (LspParameterInformation* self,
                                                  LspMarkupContent* value);
static void lsp_parameter_information_finalize (GObject * obj);
static GType lsp_parameter_information_get_type_once (void);
static void _vala_lsp_parameter_information_get_property (GObject * object,
                                                   guint property_id,
                                                   GValue * value,
                                                   GParamSpec * pspec);
static void _vala_lsp_parameter_information_set_property (GObject * object,
                                                   guint property_id,
                                                   const GValue * value,
                                                   GParamSpec * pspec);
VALA_EXTERN GType lsp_marked_string_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspMarkedString, g_object_unref)
VALA_EXTERN LspMarkedString* lsp_marked_string_new (void);
VALA_EXTERN LspMarkedString* lsp_marked_string_construct (GType object_type);
VALA_EXTERN const gchar* lsp_marked_string_get_language (LspMarkedString* self);
VALA_EXTERN void lsp_marked_string_set_language (LspMarkedString* self,
                                     const gchar* value);
VALA_EXTERN const gchar* lsp_marked_string_get_value (LspMarkedString* self);
VALA_EXTERN void lsp_marked_string_set_value (LspMarkedString* self,
                                  const gchar* value);
static void lsp_marked_string_finalize (GObject * obj);
static GType lsp_marked_string_get_type_once (void);
static void _vala_lsp_marked_string_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec);
static void _vala_lsp_marked_string_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec);
VALA_EXTERN GType lsp_hover_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspHover, g_object_unref)
static void lsp_hover_real_json_serializable_set_property (JsonSerializable* base,
                                                    GParamSpec* pspec,
                                                    GValue* value);
static void lsp_hover_real_json_serializable_get_property (JsonSerializable* base,
                                                    GParamSpec* pspec,
                                                    GValue* result);
static GParamSpec* lsp_hover_real_find_property (JsonSerializable* base,
                                          const gchar* name);
static JsonNode* lsp_hover_real_serialize_property (JsonSerializable* base,
                                             const gchar* property_name,
                                             GValue* value,
                                             GParamSpec* pspec);
VALA_EXTERN GeeList* lsp_hover_get_contents (LspHover* self);
static JsonNode* _vala_JsonNode_copy (JsonNode* self);
static void _vala_JsonNode_free (JsonNode* self);
static gboolean lsp_hover_real_deserialize_property (JsonSerializable* base,
                                              const gchar* property_name,
                                              GValue* value,
                                              GParamSpec* pspec,
                                              JsonNode* property_node);
VALA_EXTERN LspHover* lsp_hover_new (void);
VALA_EXTERN LspHover* lsp_hover_construct (GType object_type);
VALA_EXTERN void lsp_hover_set_contents (LspHover* self,
                             GeeList* value);
VALA_EXTERN LspRange* lsp_hover_get_range (LspHover* self);
VALA_EXTERN void lsp_hover_set_range (LspHover* self,
                          LspRange* value);
static void lsp_hover_finalize (GObject * obj);
static GType lsp_hover_get_type_once (void);
static void _vala_lsp_hover_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec);
static void _vala_lsp_hover_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec);
VALA_EXTERN GType lsp_text_edit_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspTextEdit, g_object_unref)
VALA_EXTERN LspTextEdit* lsp_text_edit_new (LspRange* range,
                                const gchar* new_text);
VALA_EXTERN LspTextEdit* lsp_text_edit_construct (GType object_type,
                                      LspRange* range,
                                      const gchar* new_text);
VALA_EXTERN void lsp_text_edit_set_range (LspTextEdit* self,
                              LspRange* value);
VALA_EXTERN void lsp_text_edit_set_newText (LspTextEdit* self,
                                const gchar* value);
VALA_EXTERN LspRange* lsp_text_edit_get_range (LspTextEdit* self);
VALA_EXTERN const gchar* lsp_text_edit_get_newText (LspTextEdit* self);
static void lsp_text_edit_finalize (GObject * obj);
static GType lsp_text_edit_get_type_once (void);
static void _vala_lsp_text_edit_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec);
static void _vala_lsp_text_edit_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec);
VALA_EXTERN GType lsp_text_document_edit_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspTextDocumentEdit, g_object_unref)
VALA_EXTERN LspTextDocumentEdit* lsp_text_document_edit_new (LspVersionedTextDocumentIdentifier* text_document);
VALA_EXTERN LspTextDocumentEdit* lsp_text_document_edit_construct (GType object_type,
                                                       LspVersionedTextDocumentIdentifier* text_document);
VALA_EXTERN void lsp_text_document_edit_set_textDocument (LspTextDocumentEdit* self,
                                              LspVersionedTextDocumentIdentifier* value);
static JsonNode* lsp_text_document_edit_real_serialize_property (JsonSerializable* base,
                                                          const gchar* property_name,
                                                          GValue* value,
                                                          GParamSpec* pspec);
VALA_EXTERN GeeArrayList* lsp_text_document_edit_get_edits (LspTextDocumentEdit* self);
static gboolean lsp_text_document_edit_real_deserialize_property (JsonSerializable* base,
                                                           const gchar* property_name,
                                                           GValue* value,
                                                           GParamSpec* pspec,
                                                           JsonNode* property_node);
VALA_EXTERN LspVersionedTextDocumentIdentifier* lsp_text_document_edit_get_textDocument (LspTextDocumentEdit* self);
VALA_EXTERN void lsp_text_document_edit_set_edits (LspTextDocumentEdit* self,
                                       GeeArrayList* value);
static void lsp_text_document_edit_finalize (GObject * obj);
static GType lsp_text_document_edit_get_type_once (void);
static void _vala_lsp_text_document_edit_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec);
static void _vala_lsp_text_document_edit_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec);
VALA_EXTERN GType lsp_command_like_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspCommandLike, g_object_unref)
static JsonNode* lsp_command_like_real_serialize_property (JsonSerializable* base,
                                                    const gchar* property_name,
                                                    GValue* value,
                                                    GParamSpec* pspec);
VALA_EXTERN GArray* lsp_command_like_get_arguments (LspCommandLike* self);
static gboolean lsp_command_like_real_deserialize_property (JsonSerializable* base,
                                                     const gchar* property_name,
                                                     GValue* value,
                                                     GParamSpec* pspec,
                                                     JsonNode* property_node);
static Block27Data* block27_data_ref (Block27Data* _data27_);
static void block27_data_unref (void * _userdata_);
static void _g_variant_unref0_ (gpointer var);
static void _vala_GVariant_free_function_content_of (gpointer data);
static void ___lambda7_ (Block27Data* _data27_,
                  JsonArray* array,
                  guint index,
                  JsonNode* element);
static void ____lambda7__json_array_foreach (JsonArray* array,
                                      guint index_,
                                      JsonNode* element_node,
                                      gpointer self);
VALA_EXTERN LspCommandLike* lsp_command_like_construct (GType object_type);
VALA_EXTERN const gchar* lsp_command_like_get_command (LspCommandLike* self);
VALA_EXTERN void lsp_command_like_set_command (LspCommandLike* self,
                                   const gchar* value);
VALA_EXTERN void lsp_command_like_set_arguments (LspCommandLike* self,
                                     GArray* value);
static void lsp_command_like_finalize (GObject * obj);
static GType lsp_command_like_get_type_once (void);
static void _vala_lsp_command_like_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec);
static void _vala_lsp_command_like_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec);
VALA_EXTERN GType lsp_execute_command_params_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspExecuteCommandParams, g_object_unref)
VALA_EXTERN LspExecuteCommandParams* lsp_execute_command_params_new (void);
VALA_EXTERN LspExecuteCommandParams* lsp_execute_command_params_construct (GType object_type);
static GType lsp_execute_command_params_get_type_once (void);
VALA_EXTERN GType lsp_command_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspCommand, g_object_unref)
VALA_EXTERN LspCommand* lsp_command_new (void);
VALA_EXTERN LspCommand* lsp_command_construct (GType object_type);
VALA_EXTERN const gchar* lsp_command_get_title (LspCommand* self);
VALA_EXTERN void lsp_command_set_title (LspCommand* self,
                            const gchar* value);
static void lsp_command_finalize (GObject * obj);
static GType lsp_command_get_type_once (void);
static void _vala_lsp_command_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_lsp_command_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);
VALA_EXTERN GType lsp_code_lens_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspCodeLens, g_object_unref)
VALA_EXTERN LspCodeLens* lsp_code_lens_new (void);
VALA_EXTERN LspCodeLens* lsp_code_lens_construct (GType object_type);
VALA_EXTERN LspRange* lsp_code_lens_get_range (LspCodeLens* self);
VALA_EXTERN void lsp_code_lens_set_range (LspCodeLens* self,
                              LspRange* value);
VALA_EXTERN LspCommand* lsp_code_lens_get_command (LspCodeLens* self);
VALA_EXTERN void lsp_code_lens_set_command (LspCodeLens* self,
                                LspCommand* value);
static void lsp_code_lens_finalize (GObject * obj);
static GType lsp_code_lens_get_type_once (void);
static void _vala_lsp_code_lens_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec);
static void _vala_lsp_code_lens_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec);
VALA_EXTERN GType lsp_document_range_formatting_params_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspDocumentRangeFormattingParams, g_object_unref)
VALA_EXTERN GType lsp_formatting_options_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspFormattingOptions, g_object_unref)
VALA_EXTERN LspDocumentRangeFormattingParams* lsp_document_range_formatting_params_new (void);
VALA_EXTERN LspDocumentRangeFormattingParams* lsp_document_range_formatting_params_construct (GType object_type);
VALA_EXTERN LspTextDocumentIdentifier* lsp_document_range_formatting_params_get_textDocument (LspDocumentRangeFormattingParams* self);
VALA_EXTERN void lsp_document_range_formatting_params_set_textDocument (LspDocumentRangeFormattingParams* self,
                                                            LspTextDocumentIdentifier* value);
VALA_EXTERN LspRange* lsp_document_range_formatting_params_get_range (LspDocumentRangeFormattingParams* self);
VALA_EXTERN void lsp_document_range_formatting_params_set_range (LspDocumentRangeFormattingParams* self,
                                                     LspRange* value);
VALA_EXTERN LspFormattingOptions* lsp_document_range_formatting_params_get_options (LspDocumentRangeFormattingParams* self);
VALA_EXTERN void lsp_document_range_formatting_params_set_options (LspDocumentRangeFormattingParams* self,
                                                       LspFormattingOptions* value);
static void lsp_document_range_formatting_params_finalize (GObject * obj);
static GType lsp_document_range_formatting_params_get_type_once (void);
static void _vala_lsp_document_range_formatting_params_get_property (GObject * object,
                                                              guint property_id,
                                                              GValue * value,
                                                              GParamSpec * pspec);
static void _vala_lsp_document_range_formatting_params_set_property (GObject * object,
                                                              guint property_id,
                                                              const GValue * value,
                                                              GParamSpec * pspec);
VALA_EXTERN LspFormattingOptions* lsp_formatting_options_new (void);
VALA_EXTERN LspFormattingOptions* lsp_formatting_options_construct (GType object_type);
VALA_EXTERN guint lsp_formatting_options_get_tabSize (LspFormattingOptions* self);
VALA_EXTERN void lsp_formatting_options_set_tabSize (LspFormattingOptions* self,
                                         guint value);
VALA_EXTERN gboolean lsp_formatting_options_get_insertSpaces (LspFormattingOptions* self);
VALA_EXTERN void lsp_formatting_options_set_insertSpaces (LspFormattingOptions* self,
                                              gboolean value);
VALA_EXTERN gboolean lsp_formatting_options_get_trimTrailingWhitespace (LspFormattingOptions* self);
VALA_EXTERN void lsp_formatting_options_set_trimTrailingWhitespace (LspFormattingOptions* self,
                                                        gboolean value);
VALA_EXTERN gboolean lsp_formatting_options_get_insertFinalNewline (LspFormattingOptions* self);
VALA_EXTERN void lsp_formatting_options_set_insertFinalNewline (LspFormattingOptions* self,
                                                    gboolean value);
VALA_EXTERN gboolean lsp_formatting_options_get_trimFinalNewlines (LspFormattingOptions* self);
VALA_EXTERN void lsp_formatting_options_set_trimFinalNewlines (LspFormattingOptions* self,
                                                   gboolean value);
static void lsp_formatting_options_finalize (GObject * obj);
static GType lsp_formatting_options_get_type_once (void);
static void _vala_lsp_formatting_options_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec);
static void _vala_lsp_formatting_options_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec);
VALA_EXTERN GType lsp_code_action_params_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspCodeActionParams, g_object_unref)
VALA_EXTERN GType lsp_code_action_context_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspCodeActionContext, g_object_unref)
VALA_EXTERN LspCodeActionParams* lsp_code_action_params_new (void);
VALA_EXTERN LspCodeActionParams* lsp_code_action_params_construct (GType object_type);
VALA_EXTERN LspTextDocumentIdentifier* lsp_code_action_params_get_textDocument (LspCodeActionParams* self);
VALA_EXTERN void lsp_code_action_params_set_textDocument (LspCodeActionParams* self,
                                              LspTextDocumentIdentifier* value);
VALA_EXTERN LspRange* lsp_code_action_params_get_range (LspCodeActionParams* self);
VALA_EXTERN void lsp_code_action_params_set_range (LspCodeActionParams* self,
                                       LspRange* value);
VALA_EXTERN LspCodeActionContext* lsp_code_action_params_get_context (LspCodeActionParams* self);
VALA_EXTERN void lsp_code_action_params_set_context (LspCodeActionParams* self,
                                         LspCodeActionContext* value);
static void lsp_code_action_params_finalize (GObject * obj);
static GType lsp_code_action_params_get_type_once (void);
static void _vala_lsp_code_action_params_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec);
static void _vala_lsp_code_action_params_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec);
static gboolean lsp_code_action_context_real_deserialize_property (JsonSerializable* base,
                                                            const gchar* property_name,
                                                            GValue* value,
                                                            GParamSpec* pspec,
                                                            JsonNode* property_node);
static Block28Data* block28_data_ref (Block28Data* _data28_);
static void block28_data_unref (void * _userdata_);
static void __lambda8_ (Block28Data* _data28_,
                 JsonArray* array,
                 guint index,
                 JsonNode* element);
VALA_EXTERN gpointer vls_util_parse_variant (GType t_type,
                                 GBoxedCopyFunc t_dup_func,
                                 GDestroyNotify t_destroy_func,
                                 GVariant* variant);
static void ___lambda8__json_array_foreach (JsonArray* array,
                                     guint index_,
                                     JsonNode* element_node,
                                     gpointer self);
VALA_EXTERN LspCodeActionContext* lsp_code_action_context_new (void);
VALA_EXTERN LspCodeActionContext* lsp_code_action_context_construct (GType object_type);
VALA_EXTERN GeeList* lsp_code_action_context_get_diagnostics (LspCodeActionContext* self);
VALA_EXTERN void lsp_code_action_context_set_diagnostics (LspCodeActionContext* self,
                                              GeeList* value);
VALA_EXTERN gchar** lsp_code_action_context_get_only (LspCodeActionContext* self,
                                          gint* result_length1);
VALA_EXTERN void lsp_code_action_context_set_only (LspCodeActionContext* self,
                                       gchar** value,
                                       gint value_length1);
static gchar** _vala_array_dup12 (gchar** self,
                           gssize length);
static void lsp_code_action_context_finalize (GObject * obj);
static GType lsp_code_action_context_get_type_once (void);
static void _vala_lsp_code_action_context_get_property (GObject * object,
                                                 guint property_id,
                                                 GValue * value,
                                                 GParamSpec * pspec);
static void _vala_lsp_code_action_context_set_property (GObject * object,
                                                 guint property_id,
                                                 const GValue * value,
                                                 GParamSpec * pspec);
VALA_EXTERN GType lsp_code_action_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspCodeAction, g_object_unref)
VALA_EXTERN GType lsp_workspace_edit_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspWorkspaceEdit, g_object_unref)
VALA_EXTERN void lsp_code_action_add_diagnostic (LspCodeAction* self,
                                     LspDiagnostic* diag);
VALA_EXTERN GeeCollection* lsp_code_action_get_diagnostics (LspCodeAction* self);
VALA_EXTERN void lsp_code_action_set_diagnostics (LspCodeAction* self,
                                      GeeCollection* value);
static JsonNode* lsp_code_action_real_serialize_property (JsonSerializable* base,
                                                   const gchar* property_name,
                                                   GValue* value,
                                                   GParamSpec* pspec);
VALA_EXTERN LspCodeAction* lsp_code_action_new (void);
VALA_EXTERN LspCodeAction* lsp_code_action_construct (GType object_type);
VALA_EXTERN const gchar* lsp_code_action_get_title (LspCodeAction* self);
VALA_EXTERN void lsp_code_action_set_title (LspCodeAction* self,
                                const gchar* value);
VALA_EXTERN const gchar* lsp_code_action_get_kind (LspCodeAction* self);
VALA_EXTERN void lsp_code_action_set_kind (LspCodeAction* self,
                               const gchar* value);
VALA_EXTERN gboolean lsp_code_action_get_isPreferred (LspCodeAction* self);
VALA_EXTERN void lsp_code_action_set_isPreferred (LspCodeAction* self,
                                      gboolean value);
VALA_EXTERN LspWorkspaceEdit* lsp_code_action_get_edit (LspCodeAction* self);
VALA_EXTERN void lsp_code_action_set_edit (LspCodeAction* self,
                               LspWorkspaceEdit* value);
VALA_EXTERN LspCommand* lsp_code_action_get_command (LspCodeAction* self);
VALA_EXTERN void lsp_code_action_set_command (LspCodeAction* self,
                                  LspCommand* value);
VALA_EXTERN GObject* lsp_code_action_get_data (LspCodeAction* self);
VALA_EXTERN void lsp_code_action_set_data (LspCodeAction* self,
                               GObject* value);
static void lsp_code_action_finalize (GObject * obj);
static GType lsp_code_action_get_type_once (void);
static void _vala_lsp_code_action_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec);
static void _vala_lsp_code_action_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec);
static JsonNode* lsp_workspace_edit_real_serialize_property (JsonSerializable* base,
                                                      const gchar* property_name,
                                                      GValue* value,
                                                      GParamSpec* pspec);
VALA_EXTERN GeeList* lsp_workspace_edit_get_documentChanges (LspWorkspaceEdit* self);
VALA_EXTERN LspWorkspaceEdit* lsp_workspace_edit_new (void);
VALA_EXTERN LspWorkspaceEdit* lsp_workspace_edit_construct (GType object_type);
VALA_EXTERN void lsp_workspace_edit_set_documentChanges (LspWorkspaceEdit* self,
                                             GeeList* value);
static void lsp_workspace_edit_finalize (GObject * obj);
static GType lsp_workspace_edit_get_type_once (void);
static void _vala_lsp_workspace_edit_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec);
static void _vala_lsp_workspace_edit_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec);
VALA_EXTERN GType lsp_symbol_tags_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType lsp_call_hierarchy_item_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspCallHierarchyItem, g_object_unref)
static JsonNode* lsp_call_hierarchy_item_real_serialize_property (JsonSerializable* base,
                                                           const gchar* property_name,
                                                           GValue* value,
                                                           GParamSpec* pspec);
VALA_EXTERN LspSymbolTags lsp_call_hierarchy_item_get_tags (LspCallHierarchyItem* self);
VALA_EXTERN LspCallHierarchyItem* lsp_call_hierarchy_item_new_from_symbol (ValaSymbol* symbol);
VALA_EXTERN LspCallHierarchyItem* lsp_call_hierarchy_item_construct_from_symbol (GType object_type,
                                                                     ValaSymbol* symbol);
VALA_EXTERN void lsp_call_hierarchy_item_set_name (LspCallHierarchyItem* self,
                                       const gchar* value);
VALA_EXTERN void lsp_call_hierarchy_item_set_kind (LspCallHierarchyItem* self,
                                       LspSymbolKind value);
VALA_EXTERN void lsp_call_hierarchy_item_set_tags (LspCallHierarchyItem* self,
                                       LspSymbolTags value);
VALA_EXTERN void lsp_call_hierarchy_item_set_detail (LspCallHierarchyItem* self,
                                         const gchar* value);
VALA_EXTERN void lsp_call_hierarchy_item_set_uri (LspCallHierarchyItem* self,
                                      const gchar* value);
VALA_EXTERN void lsp_call_hierarchy_item_set_range (LspCallHierarchyItem* self,
                                        LspRange* value);
VALA_EXTERN LspRange* lsp_call_hierarchy_item_get_range (LspCallHierarchyItem* self);
VALA_EXTERN void lsp_call_hierarchy_item_set_selectionRange (LspCallHierarchyItem* self,
                                                 LspRange* value);
VALA_EXTERN LspCallHierarchyItem* lsp_call_hierarchy_item_new (void);
VALA_EXTERN LspCallHierarchyItem* lsp_call_hierarchy_item_construct (GType object_type);
VALA_EXTERN const gchar* lsp_call_hierarchy_item_get_name (LspCallHierarchyItem* self);
VALA_EXTERN LspSymbolKind lsp_call_hierarchy_item_get_kind (LspCallHierarchyItem* self);
VALA_EXTERN const gchar* lsp_call_hierarchy_item_get_detail (LspCallHierarchyItem* self);
VALA_EXTERN const gchar* lsp_call_hierarchy_item_get_uri (LspCallHierarchyItem* self);
VALA_EXTERN LspRange* lsp_call_hierarchy_item_get_selectionRange (LspCallHierarchyItem* self);
static void lsp_call_hierarchy_item_finalize (GObject * obj);
static GType lsp_call_hierarchy_item_get_type_once (void);
static void _vala_lsp_call_hierarchy_item_get_property (GObject * object,
                                                 guint property_id,
                                                 GValue * value,
                                                 GParamSpec * pspec);
static void _vala_lsp_call_hierarchy_item_set_property (GObject * object,
                                                 guint property_id,
                                                 const GValue * value,
                                                 GParamSpec * pspec);
VALA_EXTERN GType lsp_call_hierarchy_incoming_call_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspCallHierarchyIncomingCall, g_object_unref)
static JsonNode* lsp_call_hierarchy_incoming_call_real_serialize_property (JsonSerializable* base,
                                                                    const gchar* property_name,
                                                                    GValue* value,
                                                                    GParamSpec* pspec);
VALA_EXTERN GeeArrayList* lsp_call_hierarchy_incoming_call_get_fromRanges (LspCallHierarchyIncomingCall* self);
VALA_EXTERN LspCallHierarchyIncomingCall* lsp_call_hierarchy_incoming_call_new (void);
VALA_EXTERN LspCallHierarchyIncomingCall* lsp_call_hierarchy_incoming_call_construct (GType object_type);
VALA_EXTERN LspCallHierarchyItem* lsp_call_hierarchy_incoming_call_get_from (LspCallHierarchyIncomingCall* self);
VALA_EXTERN void lsp_call_hierarchy_incoming_call_set_from (LspCallHierarchyIncomingCall* self,
                                                LspCallHierarchyItem* value);
VALA_EXTERN void lsp_call_hierarchy_incoming_call_set_fromRanges (LspCallHierarchyIncomingCall* self,
                                                      GeeArrayList* value);
static void lsp_call_hierarchy_incoming_call_finalize (GObject * obj);
static GType lsp_call_hierarchy_incoming_call_get_type_once (void);
static void _vala_lsp_call_hierarchy_incoming_call_get_property (GObject * object,
                                                          guint property_id,
                                                          GValue * value,
                                                          GParamSpec * pspec);
static void _vala_lsp_call_hierarchy_incoming_call_set_property (GObject * object,
                                                          guint property_id,
                                                          const GValue * value,
                                                          GParamSpec * pspec);
VALA_EXTERN GType lsp_call_hierarchy_outgoing_call_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspCallHierarchyOutgoingCall, g_object_unref)
static JsonNode* lsp_call_hierarchy_outgoing_call_real_serialize_property (JsonSerializable* base,
                                                                    const gchar* property_name,
                                                                    GValue* value,
                                                                    GParamSpec* pspec);
VALA_EXTERN GeeArrayList* lsp_call_hierarchy_outgoing_call_get_fromRanges (LspCallHierarchyOutgoingCall* self);
VALA_EXTERN LspCallHierarchyOutgoingCall* lsp_call_hierarchy_outgoing_call_new (void);
VALA_EXTERN LspCallHierarchyOutgoingCall* lsp_call_hierarchy_outgoing_call_construct (GType object_type);
VALA_EXTERN LspCallHierarchyItem* lsp_call_hierarchy_outgoing_call_get_to (LspCallHierarchyOutgoingCall* self);
VALA_EXTERN void lsp_call_hierarchy_outgoing_call_set_to (LspCallHierarchyOutgoingCall* self,
                                              LspCallHierarchyItem* value);
VALA_EXTERN void lsp_call_hierarchy_outgoing_call_set_fromRanges (LspCallHierarchyOutgoingCall* self,
                                                      GeeArrayList* value);
static void lsp_call_hierarchy_outgoing_call_finalize (GObject * obj);
static GType lsp_call_hierarchy_outgoing_call_get_type_once (void);
static void _vala_lsp_call_hierarchy_outgoing_call_get_property (GObject * object,
                                                          guint property_id,
                                                          GValue * value,
                                                          GParamSpec * pspec);
static void _vala_lsp_call_hierarchy_outgoing_call_set_property (GObject * object,
                                                          guint property_id,
                                                          const GValue * value,
                                                          GParamSpec * pspec);
VALA_EXTERN GType lsp_inlay_hint_params_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspInlayHintParams, g_object_unref)
VALA_EXTERN LspInlayHintParams* lsp_inlay_hint_params_new (void);
VALA_EXTERN LspInlayHintParams* lsp_inlay_hint_params_construct (GType object_type);
VALA_EXTERN LspTextDocumentIdentifier* lsp_inlay_hint_params_get_textDocument (LspInlayHintParams* self);
VALA_EXTERN void lsp_inlay_hint_params_set_textDocument (LspInlayHintParams* self,
                                             LspTextDocumentIdentifier* value);
VALA_EXTERN LspRange* lsp_inlay_hint_params_get_range (LspInlayHintParams* self);
VALA_EXTERN void lsp_inlay_hint_params_set_range (LspInlayHintParams* self,
                                      LspRange* value);
static void lsp_inlay_hint_params_finalize (GObject * obj);
static GType lsp_inlay_hint_params_get_type_once (void);
static void _vala_lsp_inlay_hint_params_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec);
static void _vala_lsp_inlay_hint_params_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec);
VALA_EXTERN GType lsp_inlay_hint_kind_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType lsp_inlay_hint_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspInlayHint, g_object_unref)
VALA_EXTERN LspInlayHint* lsp_inlay_hint_new (void);
VALA_EXTERN LspInlayHint* lsp_inlay_hint_construct (GType object_type);
VALA_EXTERN LspPosition* lsp_inlay_hint_get_position (LspInlayHint* self);
VALA_EXTERN void lsp_inlay_hint_set_position (LspInlayHint* self,
                                  LspPosition* value);
VALA_EXTERN const gchar* lsp_inlay_hint_get_label (LspInlayHint* self);
VALA_EXTERN void lsp_inlay_hint_set_label (LspInlayHint* self,
                               const gchar* value);
VALA_EXTERN LspInlayHintKind lsp_inlay_hint_get_kind (LspInlayHint* self);
VALA_EXTERN void lsp_inlay_hint_set_kind (LspInlayHint* self,
                              LspInlayHintKind value);
VALA_EXTERN const gchar* lsp_inlay_hint_get_tooltip (LspInlayHint* self);
VALA_EXTERN void lsp_inlay_hint_set_tooltip (LspInlayHint* self,
                                 const gchar* value);
VALA_EXTERN gboolean lsp_inlay_hint_get_paddingLeft (LspInlayHint* self);
VALA_EXTERN void lsp_inlay_hint_set_paddingLeft (LspInlayHint* self,
                                     gboolean value);
VALA_EXTERN gboolean lsp_inlay_hint_get_paddingRight (LspInlayHint* self);
VALA_EXTERN void lsp_inlay_hint_set_paddingRight (LspInlayHint* self,
                                      gboolean value);
static void lsp_inlay_hint_finalize (GObject * obj);
static GType lsp_inlay_hint_get_type_once (void);
static void _vala_lsp_inlay_hint_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec);
static void _vala_lsp_inlay_hint_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec);
VALA_EXTERN GType lsp_typehierarchy_item_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspTypeHierarchyItem, g_object_unref)
static LspTypeHierarchyItem* lsp_typehierarchy_item_new (void);
static LspTypeHierarchyItem* lsp_typehierarchy_item_construct (GType object_type);
VALA_EXTERN LspTypeHierarchyItem* lsp_typehierarchy_item_new_from_symbol (ValaTypeSymbol* symbol);
VALA_EXTERN LspTypeHierarchyItem* lsp_typehierarchy_item_construct_from_symbol (GType object_type,
                                                                    ValaTypeSymbol* symbol);
VALA_EXTERN void lsp_typehierarchy_item_set_name (LspTypeHierarchyItem* self,
                                      const gchar* value);
VALA_EXTERN void lsp_typehierarchy_item_set_kind (LspTypeHierarchyItem* self,
                                      LspSymbolKind value);
VALA_EXTERN LspSymbolTags lsp_typehierarchy_item_get_tags (LspTypeHierarchyItem* self);
VALA_EXTERN void lsp_typehierarchy_item_set_tags (LspTypeHierarchyItem* self,
                                      LspSymbolTags value);
VALA_EXTERN void lsp_typehierarchy_item_set_detail (LspTypeHierarchyItem* self,
                                        const gchar* value);
VALA_EXTERN void lsp_typehierarchy_item_set_uri (LspTypeHierarchyItem* self,
                                     const gchar* value);
VALA_EXTERN void lsp_typehierarchy_item_set_range (LspTypeHierarchyItem* self,
                                       LspRange* value);
VALA_EXTERN LspRange* lsp_typehierarchy_item_get_range (LspTypeHierarchyItem* self);
VALA_EXTERN void lsp_typehierarchy_item_set_selectionRange (LspTypeHierarchyItem* self,
                                                LspRange* value);
VALA_EXTERN const gchar* lsp_typehierarchy_item_get_name (LspTypeHierarchyItem* self);
VALA_EXTERN LspSymbolKind lsp_typehierarchy_item_get_kind (LspTypeHierarchyItem* self);
VALA_EXTERN const gchar* lsp_typehierarchy_item_get_detail (LspTypeHierarchyItem* self);
VALA_EXTERN const gchar* lsp_typehierarchy_item_get_uri (LspTypeHierarchyItem* self);
VALA_EXTERN LspRange* lsp_typehierarchy_item_get_selectionRange (LspTypeHierarchyItem* self);
static void lsp_typehierarchy_item_finalize (GObject * obj);
static GType lsp_typehierarchy_item_get_type_once (void);
static void _vala_lsp_typehierarchy_item_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec);
static void _vala_lsp_typehierarchy_item_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

/**
     * Defines how the host (editor) should sync document changes to the language server.
     */
 G_GNUC_NO_INLINE static GType
lsp_text_document_sync_kind_get_type_once (void)
{
	static const GEnumValue values[] = {{LSP_TEXT_DOCUMENT_SYNC_KIND_Unset, "LSP_TEXT_DOCUMENT_SYNC_KIND_Unset", "unset"}, {LSP_TEXT_DOCUMENT_SYNC_KIND_None, "LSP_TEXT_DOCUMENT_SYNC_KIND_None", "none"}, {LSP_TEXT_DOCUMENT_SYNC_KIND_Full, "LSP_TEXT_DOCUMENT_SYNC_KIND_Full", "full"}, {LSP_TEXT_DOCUMENT_SYNC_KIND_Incremental, "LSP_TEXT_DOCUMENT_SYNC_KIND_Incremental", "incremental"}, {0, NULL, NULL}};
	GType lsp_text_document_sync_kind_type_id;
	lsp_text_document_sync_kind_type_id = g_enum_register_static ("LspTextDocumentSyncKind", values);
	return lsp_text_document_sync_kind_type_id;
}

GType
lsp_text_document_sync_kind_get_type (void)
{
	static gsize lsp_text_document_sync_kind_type_id__once = 0;
	if (g_once_init_enter (&lsp_text_document_sync_kind_type_id__once)) {
		GType lsp_text_document_sync_kind_type_id;
		lsp_text_document_sync_kind_type_id = lsp_text_document_sync_kind_get_type_once ();
		g_once_init_leave (&lsp_text_document_sync_kind_type_id__once, lsp_text_document_sync_kind_type_id);
	}
	return lsp_text_document_sync_kind_type_id__once;
}

 G_GNUC_NO_INLINE static GType
lsp_diagnostic_severity_get_type_once (void)
{
	static const GEnumValue values[] = {{LSP_DIAGNOSTIC_SEVERITY_Unset, "LSP_DIAGNOSTIC_SEVERITY_Unset", "unset"}, {LSP_DIAGNOSTIC_SEVERITY_Error, "LSP_DIAGNOSTIC_SEVERITY_Error", "error"}, {LSP_DIAGNOSTIC_SEVERITY_Warning, "LSP_DIAGNOSTIC_SEVERITY_Warning", "warning"}, {LSP_DIAGNOSTIC_SEVERITY_Information, "LSP_DIAGNOSTIC_SEVERITY_Information", "information"}, {LSP_DIAGNOSTIC_SEVERITY_Hint, "LSP_DIAGNOSTIC_SEVERITY_Hint", "hint"}, {0, NULL, NULL}};
	GType lsp_diagnostic_severity_type_id;
	lsp_diagnostic_severity_type_id = g_enum_register_static ("LspDiagnosticSeverity", values);
	return lsp_diagnostic_severity_type_id;
}

GType
lsp_diagnostic_severity_get_type (void)
{
	static gsize lsp_diagnostic_severity_type_id__once = 0;
	if (g_once_init_enter (&lsp_diagnostic_severity_type_id__once)) {
		GType lsp_diagnostic_severity_type_id;
		lsp_diagnostic_severity_type_id = lsp_diagnostic_severity_get_type_once ();
		g_once_init_leave (&lsp_diagnostic_severity_type_id__once, lsp_diagnostic_severity_type_id);
	}
	return lsp_diagnostic_severity_type_id__once;
}

static inline gpointer
lsp_position_get_instance_private (LspPosition* self)
{
	return G_STRUCT_MEMBER_P (self, LspPosition_private_offset);
}

static gint
lsp_position_real_compare_to (GeeComparable* base,
                              LspPosition* other)
{
	LspPosition * self;
	gint _tmp0_ = 0;
	guint _tmp1_;
	guint _tmp2_;
	gint result;
#line 79 "../src/protocol.vala"
	self = (LspPosition*) base;
#line 79 "../src/protocol.vala"
	g_return_val_if_fail (other != NULL, 0);
#line 80 "../src/protocol.vala"
	_tmp1_ = self->priv->_line;
#line 80 "../src/protocol.vala"
	_tmp2_ = other->priv->_line;
#line 80 "../src/protocol.vala"
	if (_tmp1_ > _tmp2_) {
#line 80 "../src/protocol.vala"
		_tmp0_ = 1;
#line 3312 "protocol.c"
	} else {
		gint _tmp3_ = 0;
		guint _tmp4_;
		guint _tmp5_;
#line 81 "../src/protocol.vala"
		_tmp4_ = self->priv->_line;
#line 81 "../src/protocol.vala"
		_tmp5_ = other->priv->_line;
#line 81 "../src/protocol.vala"
		if (_tmp4_ == _tmp5_) {
#line 3323 "protocol.c"
			gint _tmp6_ = 0;
			guint _tmp7_;
			guint _tmp8_;
#line 82 "../src/protocol.vala"
			_tmp7_ = self->priv->_character;
#line 82 "../src/protocol.vala"
			_tmp8_ = other->priv->_character;
#line 82 "../src/protocol.vala"
			if (_tmp7_ > _tmp8_) {
#line 82 "../src/protocol.vala"
				_tmp6_ = 1;
#line 3335 "protocol.c"
			} else {
				gint _tmp9_ = 0;
				guint _tmp10_;
				guint _tmp11_;
#line 83 "../src/protocol.vala"
				_tmp10_ = self->priv->_character;
#line 83 "../src/protocol.vala"
				_tmp11_ = other->priv->_character;
#line 83 "../src/protocol.vala"
				if (_tmp10_ == _tmp11_) {
#line 83 "../src/protocol.vala"
					_tmp9_ = 0;
#line 3348 "protocol.c"
				} else {
#line 83 "../src/protocol.vala"
					_tmp9_ = -1;
#line 3352 "protocol.c"
				}
#line 83 "../src/protocol.vala"
				_tmp6_ = _tmp9_;
#line 3356 "protocol.c"
			}
#line 82 "../src/protocol.vala"
			_tmp3_ = _tmp6_;
#line 3360 "protocol.c"
		} else {
#line 83 "../src/protocol.vala"
			_tmp3_ = -1;
#line 3364 "protocol.c"
		}
#line 81 "../src/protocol.vala"
		_tmp0_ = _tmp3_;
#line 3368 "protocol.c"
	}
#line 80 "../src/protocol.vala"
	result = _tmp0_;
#line 80 "../src/protocol.vala"
	return result;
#line 3374 "protocol.c"
}

gchar*
lsp_position_to_string (LspPosition* self)
{
	guint _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	guint _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* result;
#line 86 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 87 "../src/protocol.vala"
	_tmp0_ = self->priv->_line;
#line 87 "../src/protocol.vala"
	_tmp1_ = g_strdup_printf ("%u", _tmp0_);
#line 87 "../src/protocol.vala"
	_tmp2_ = _tmp1_;
#line 87 "../src/protocol.vala"
	_tmp3_ = self->priv->_character;
#line 87 "../src/protocol.vala"
	_tmp4_ = g_strdup_printf ("%u", _tmp3_);
#line 87 "../src/protocol.vala"
	_tmp5_ = _tmp4_;
#line 87 "../src/protocol.vala"
	_tmp6_ = g_strconcat (_tmp2_, ":", _tmp5_, NULL);
#line 87 "../src/protocol.vala"
	_tmp7_ = _tmp6_;
#line 87 "../src/protocol.vala"
	_g_free0 (_tmp5_);
#line 87 "../src/protocol.vala"
	_g_free0 (_tmp2_);
#line 87 "../src/protocol.vala"
	result = _tmp7_;
#line 87 "../src/protocol.vala"
	return result;
#line 3415 "protocol.c"
}

LspPosition*
lsp_position_construct_from_libvala (GType object_type,
                                     ValaSourceLocation* sloc)
{
	LspPosition * self = NULL;
	ValaSourceLocation _tmp0_;
	ValaSourceLocation _tmp1_;
#line 90 "../src/protocol.vala"
	g_return_val_if_fail (sloc != NULL, NULL);
#line 90 "../src/protocol.vala"
	self = (LspPosition*) g_object_new (object_type, NULL);
#line 91 "../src/protocol.vala"
	_tmp0_ = *sloc;
#line 91 "../src/protocol.vala"
	lsp_position_set_line (self, (guint) (_tmp0_.line - 1));
#line 92 "../src/protocol.vala"
	_tmp1_ = *sloc;
#line 92 "../src/protocol.vala"
	lsp_position_set_character (self, (guint) _tmp1_.column);
#line 90 "../src/protocol.vala"
	return self;
#line 3439 "protocol.c"
}

LspPosition*
lsp_position_new_from_libvala (ValaSourceLocation* sloc)
{
#line 90 "../src/protocol.vala"
	return lsp_position_construct_from_libvala (LSP_TYPE_POSITION, sloc);
#line 3447 "protocol.c"
}

LspPosition*
lsp_position_dup (LspPosition* self)
{
	LspPosition* _tmp0_;
	LspPosition* result;
#line 95 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 96 "../src/protocol.vala"
	_tmp0_ = lsp_position_translate (self, 0, 0);
#line 96 "../src/protocol.vala"
	result = _tmp0_;
#line 96 "../src/protocol.vala"
	return result;
#line 3463 "protocol.c"
}

LspPosition*
lsp_position_translate (LspPosition* self,
                        gint dl,
                        gint dc)
{
	guint _tmp0_;
	guint _tmp1_;
	LspPosition* _tmp2_ = NULL;
	LspPosition* result;
#line 99 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 100 "../src/protocol.vala"
	_tmp0_ = self->priv->_line;
#line 100 "../src/protocol.vala"
	_tmp1_ = self->priv->_character;
#line 100 "../src/protocol.vala"
	_tmp2_ = lsp_position_new ();
#line 100 "../src/protocol.vala"
	lsp_position_set_line (_tmp2_, _tmp0_ + dl);
#line 100 "../src/protocol.vala"
	lsp_position_set_character (_tmp2_, _tmp1_ + dc);
#line 100 "../src/protocol.vala"
	result = _tmp2_;
#line 100 "../src/protocol.vala"
	return result;
#line 3491 "protocol.c"
}

LspPosition*
lsp_position_construct (GType object_type)
{
	LspPosition * self = NULL;
#line 63 "../src/protocol.vala"
	self = (LspPosition*) g_object_new (object_type, NULL);
#line 63 "../src/protocol.vala"
	return self;
#line 3502 "protocol.c"
}

LspPosition*
lsp_position_new (void)
{
#line 63 "../src/protocol.vala"
	return lsp_position_construct (LSP_TYPE_POSITION);
#line 3510 "protocol.c"
}

guint
lsp_position_get_line (LspPosition* self)
{
	guint result;
#line 67 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 67 "../src/protocol.vala"
	result = self->priv->_line;
#line 67 "../src/protocol.vala"
	return result;
#line 3523 "protocol.c"
}

void
lsp_position_set_line (LspPosition* self,
                       guint value)
{
	guint old_value;
#line 67 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 67 "../src/protocol.vala"
	old_value = lsp_position_get_line (self);
#line 67 "../src/protocol.vala"
	if (old_value != value) {
#line 67 "../src/protocol.vala"
		self->priv->_line = value;
#line 67 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_position_properties[LSP_POSITION_LINE_PROPERTY]);
#line 3541 "protocol.c"
	}
}

guint
lsp_position_get_character (LspPosition* self)
{
	guint result;
#line 77 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 77 "../src/protocol.vala"
	result = self->priv->_character;
#line 77 "../src/protocol.vala"
	return result;
#line 3555 "protocol.c"
}

void
lsp_position_set_character (LspPosition* self,
                            guint value)
{
	guint old_value;
#line 77 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 77 "../src/protocol.vala"
	old_value = lsp_position_get_character (self);
#line 77 "../src/protocol.vala"
	if (old_value != value) {
#line 77 "../src/protocol.vala"
		self->priv->_character = value;
#line 77 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_position_properties[LSP_POSITION_CHARACTER_PROPERTY]);
#line 3573 "protocol.c"
	}
}

static void
lsp_position_class_init (LspPositionClass * klass,
                         gpointer klass_data)
{
#line 63 "../src/protocol.vala"
	lsp_position_parent_class = g_type_class_peek_parent (klass);
#line 63 "../src/protocol.vala"
	g_type_class_adjust_private_offset (klass, &LspPosition_private_offset);
#line 63 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_lsp_position_get_property;
#line 63 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_lsp_position_set_property;
#line 63 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->finalize = lsp_position_finalize;
#line 3591 "protocol.c"
	/**
	         * Line position in a document (zero-based).
	         */
#line 63 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_POSITION_LINE_PROPERTY, lsp_position_properties[LSP_POSITION_LINE_PROPERTY] = g_param_spec_uint ("line", "line", "line", 0, G_MAXUINT, (guint) -1, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 3597 "protocol.c"
	/**
	         * Character offset on a line in a document (zero-based). Assuming that the line is
	         * represented as a string, the `character` value represents the gap between the
	         * `character` and `character + 1`.
	         *
	         * If the character value is greater than the line length it defaults back to the
	         * line length.
	         */
#line 63 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_POSITION_CHARACTER_PROPERTY, lsp_position_properties[LSP_POSITION_CHARACTER_PROPERTY] = g_param_spec_uint ("character", "character", "character", 0, G_MAXUINT, (guint) -1, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 3608 "protocol.c"
}

static void
lsp_position_gee_comparable_interface_init (GeeComparableIface * iface,
                                            gpointer iface_data)
{
#line 63 "../src/protocol.vala"
	lsp_position_gee_comparable_parent_iface = g_type_interface_peek_parent (iface);
#line 63 "../src/protocol.vala"
	iface->compare_to = (gint (*) (GeeComparable*, gconstpointer)) lsp_position_real_compare_to;
#line 3619 "protocol.c"
}

static void
lsp_position_instance_init (LspPosition * self,
                            gpointer klass)
{
#line 63 "../src/protocol.vala"
	self->priv = lsp_position_get_instance_private (self);
#line 67 "../src/protocol.vala"
	self->priv->_line = (guint) -1;
#line 77 "../src/protocol.vala"
	self->priv->_character = (guint) -1;
#line 3632 "protocol.c"
}

static void
lsp_position_finalize (GObject * obj)
{
	LspPosition * self;
#line 63 "../src/protocol.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, LSP_TYPE_POSITION, LspPosition);
#line 63 "../src/protocol.vala"
	G_OBJECT_CLASS (lsp_position_parent_class)->finalize (obj);
#line 3643 "protocol.c"
}

 G_GNUC_NO_INLINE static GType
lsp_position_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (LspPositionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) lsp_position_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LspPosition), 0, (GInstanceInitFunc) lsp_position_instance_init, NULL };
	static const GInterfaceInfo gee_comparable_info = { (GInterfaceInitFunc) lsp_position_gee_comparable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType lsp_position_type_id;
	lsp_position_type_id = g_type_register_static (G_TYPE_OBJECT, "LspPosition", &g_define_type_info, 0);
	g_type_add_interface_static (lsp_position_type_id, GEE_TYPE_COMPARABLE, &gee_comparable_info);
	LspPosition_private_offset = g_type_add_instance_private (lsp_position_type_id, sizeof (LspPositionPrivate));
	return lsp_position_type_id;
}

GType
lsp_position_get_type (void)
{
	static gsize lsp_position_type_id__once = 0;
	if (g_once_init_enter (&lsp_position_type_id__once)) {
		GType lsp_position_type_id;
		lsp_position_type_id = lsp_position_get_type_once ();
		g_once_init_leave (&lsp_position_type_id__once, lsp_position_type_id);
	}
	return lsp_position_type_id__once;
}

static void
_vala_lsp_position_get_property (GObject * object,
                                 guint property_id,
                                 GValue * value,
                                 GParamSpec * pspec)
{
	LspPosition * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_POSITION, LspPosition);
#line 63 "../src/protocol.vala"
	switch (property_id) {
#line 63 "../src/protocol.vala"
		case LSP_POSITION_LINE_PROPERTY:
#line 63 "../src/protocol.vala"
		g_value_set_uint (value, lsp_position_get_line (self));
#line 63 "../src/protocol.vala"
		break;
#line 63 "../src/protocol.vala"
		case LSP_POSITION_CHARACTER_PROPERTY:
#line 63 "../src/protocol.vala"
		g_value_set_uint (value, lsp_position_get_character (self));
#line 63 "../src/protocol.vala"
		break;
#line 3692 "protocol.c"
		default:
#line 63 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 63 "../src/protocol.vala"
		break;
#line 3698 "protocol.c"
	}
}

static void
_vala_lsp_position_set_property (GObject * object,
                                 guint property_id,
                                 const GValue * value,
                                 GParamSpec * pspec)
{
	LspPosition * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_POSITION, LspPosition);
#line 63 "../src/protocol.vala"
	switch (property_id) {
#line 63 "../src/protocol.vala"
		case LSP_POSITION_LINE_PROPERTY:
#line 63 "../src/protocol.vala"
		lsp_position_set_line (self, g_value_get_uint (value));
#line 63 "../src/protocol.vala"
		break;
#line 63 "../src/protocol.vala"
		case LSP_POSITION_CHARACTER_PROPERTY:
#line 63 "../src/protocol.vala"
		lsp_position_set_character (self, g_value_get_uint (value));
#line 63 "../src/protocol.vala"
		break;
#line 3724 "protocol.c"
		default:
#line 63 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 63 "../src/protocol.vala"
		break;
#line 3730 "protocol.c"
	}
}

static inline gpointer
lsp_range_get_instance_private (LspRange* self)
{
	return G_STRUCT_MEMBER_P (self, LspRange_private_offset);
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
#line 1624 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1625 "glib-2.0.vapi"
	result = self;
#line 1625 "glib-2.0.vapi"
	return result;
#line 3750 "protocol.c"
}

gchar*
lsp_range_to_string (LspRange* self)
{
	gchar* _tmp0_ = NULL;
	const gchar* _tmp1_;
	LspPosition* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	LspPosition* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* result;
#line 120 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 120 "../src/protocol.vala"
	_tmp1_ = self->priv->filename;
#line 120 "../src/protocol.vala"
	if (_tmp1_ != NULL) {
#line 3775 "protocol.c"
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
#line 120 "../src/protocol.vala"
		_tmp2_ = self->priv->filename;
#line 120 "../src/protocol.vala"
		_tmp3_ = string_to_string (_tmp2_);
#line 120 "../src/protocol.vala"
		_tmp4_ = g_strconcat (_tmp3_, ":", NULL);
#line 120 "../src/protocol.vala"
		_g_free0 (_tmp0_);
#line 120 "../src/protocol.vala"
		_tmp0_ = _tmp4_;
#line 3789 "protocol.c"
	} else {
		gchar* _tmp5_;
#line 120 "../src/protocol.vala"
		_tmp5_ = g_strdup ("");
#line 120 "../src/protocol.vala"
		_g_free0 (_tmp0_);
#line 120 "../src/protocol.vala"
		_tmp0_ = _tmp5_;
#line 3798 "protocol.c"
	}
#line 120 "../src/protocol.vala"
	_tmp6_ = self->priv->_start;
#line 120 "../src/protocol.vala"
	_tmp7_ = lsp_position_to_string (_tmp6_);
#line 120 "../src/protocol.vala"
	_tmp8_ = _tmp7_;
#line 120 "../src/protocol.vala"
	_tmp9_ = self->priv->_end;
#line 120 "../src/protocol.vala"
	_tmp10_ = lsp_position_to_string (_tmp9_);
#line 120 "../src/protocol.vala"
	_tmp11_ = _tmp10_;
#line 120 "../src/protocol.vala"
	_tmp12_ = g_strconcat (_tmp8_, " -> ", _tmp11_, NULL);
#line 120 "../src/protocol.vala"
	_tmp13_ = _tmp12_;
#line 120 "../src/protocol.vala"
	_tmp14_ = g_strconcat (_tmp0_, _tmp13_, NULL);
#line 120 "../src/protocol.vala"
	_tmp15_ = _tmp14_;
#line 120 "../src/protocol.vala"
	_g_free0 (_tmp13_);
#line 120 "../src/protocol.vala"
	_g_free0 (_tmp11_);
#line 120 "../src/protocol.vala"
	_g_free0 (_tmp8_);
#line 120 "../src/protocol.vala"
	result = _tmp15_;
#line 120 "../src/protocol.vala"
	_g_free0 (_tmp0_);
#line 120 "../src/protocol.vala"
	return result;
#line 3832 "protocol.c"
}

LspRange*
lsp_range_construct_from_sourceref (GType object_type,
                                    ValaSourceReference* sref)
{
	LspRange * self = NULL;
	ValaSourceLocation _tmp0_ = {0};
	ValaSourceLocation _tmp1_;
	LspPosition* _tmp2_;
	LspPosition* _tmp3_;
	ValaSourceLocation _tmp4_ = {0};
	ValaSourceLocation _tmp5_;
	LspPosition* _tmp6_;
	LspPosition* _tmp7_;
	LspPosition* _tmp8_;
	LspPosition* _tmp9_;
	guint _tmp10_;
	guint _tmp11_;
	ValaSourceFile* _tmp12_;
	ValaSourceFile* _tmp13_;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
	gchar* _tmp16_;
#line 122 "../src/protocol.vala"
	g_return_val_if_fail (sref != NULL, NULL);
#line 122 "../src/protocol.vala"
	self = (LspRange*) g_object_new (object_type, NULL);
#line 123 "../src/protocol.vala"
	vala_source_reference_get_begin (sref, &_tmp0_);
#line 123 "../src/protocol.vala"
	_tmp1_ = _tmp0_;
#line 123 "../src/protocol.vala"
	_tmp2_ = lsp_position_new_from_libvala (&_tmp1_);
#line 123 "../src/protocol.vala"
	if (_tmp2_) {
#line 123 "../src/protocol.vala"
		g_object_set_data ((GObject *) _tmp2_, "vala-creation-function", "Lsp.Range.from_sourceref");
#line 3871 "protocol.c"
	}
#line 123 "../src/protocol.vala"
	_tmp3_ = _tmp2_;
#line 123 "../src/protocol.vala"
	lsp_range_set_start (self, _tmp3_);
#line 123 "../src/protocol.vala"
	_g_object_unref0 (_tmp3_);
#line 124 "../src/protocol.vala"
	vala_source_reference_get_end (sref, &_tmp4_);
#line 124 "../src/protocol.vala"
	_tmp5_ = _tmp4_;
#line 124 "../src/protocol.vala"
	_tmp6_ = lsp_position_new_from_libvala (&_tmp5_);
#line 124 "../src/protocol.vala"
	if (_tmp6_) {
#line 124 "../src/protocol.vala"
		g_object_set_data ((GObject *) _tmp6_, "vala-creation-function", "Lsp.Range.from_sourceref");
#line 3889 "protocol.c"
	}
#line 124 "../src/protocol.vala"
	_tmp7_ = _tmp6_;
#line 124 "../src/protocol.vala"
	lsp_range_set_end (self, _tmp7_);
#line 124 "../src/protocol.vala"
	_g_object_unref0 (_tmp7_);
#line 125 "../src/protocol.vala"
	_tmp8_ = self->priv->_start;
#line 125 "../src/protocol.vala"
	_tmp9_ = self->priv->_start;
#line 125 "../src/protocol.vala"
	_tmp10_ = lsp_position_get_character (_tmp9_);
#line 125 "../src/protocol.vala"
	_tmp11_ = _tmp10_;
#line 125 "../src/protocol.vala"
	lsp_position_set_character (_tmp9_, _tmp11_ - 1);
#line 126 "../src/protocol.vala"
	_tmp12_ = vala_source_reference_get_file (sref);
#line 126 "../src/protocol.vala"
	_tmp13_ = _tmp12_;
#line 126 "../src/protocol.vala"
	_tmp14_ = vala_source_file_get_filename (_tmp13_);
#line 126 "../src/protocol.vala"
	_tmp15_ = _tmp14_;
#line 126 "../src/protocol.vala"
	_tmp16_ = g_strdup (_tmp15_);
#line 126 "../src/protocol.vala"
	_g_free0 (self->priv->filename);
#line 126 "../src/protocol.vala"
	self->priv->filename = _tmp16_;
#line 122 "../src/protocol.vala"
	return self;
#line 3923 "protocol.c"
}

LspRange*
lsp_range_new_from_sourceref (ValaSourceReference* sref)
{
#line 122 "../src/protocol.vala"
	return lsp_range_construct_from_sourceref (LSP_TYPE_RANGE, sref);
#line 3931 "protocol.c"
}

static guint
lsp_range_real_hash (GeeHashable* base)
{
	LspRange * self;
	gchar* _tmp0_;
	gchar* _tmp1_;
	guint _tmp2_;
	guint result;
#line 129 "../src/protocol.vala"
	self = (LspRange*) base;
#line 130 "../src/protocol.vala"
	_tmp0_ = lsp_range_to_string (self);
#line 130 "../src/protocol.vala"
	_tmp1_ = _tmp0_;
#line 130 "../src/protocol.vala"
	_tmp2_ = g_str_hash (_tmp1_);
#line 130 "../src/protocol.vala"
	_g_free0 (_tmp1_);
#line 130 "../src/protocol.vala"
	result = _tmp2_;
#line 130 "../src/protocol.vala"
	return result;
#line 3956 "protocol.c"
}

static gboolean
lsp_range_real_equal_to (GeeHashable* base,
                         LspRange* other)
{
	LspRange * self;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gboolean _tmp4_;
	gboolean result;
#line 133 "../src/protocol.vala"
	self = (LspRange*) base;
#line 133 "../src/protocol.vala"
	g_return_val_if_fail (other != NULL, FALSE);
#line 133 "../src/protocol.vala"
	_tmp0_ = lsp_range_to_string (self);
#line 133 "../src/protocol.vala"
	_tmp1_ = _tmp0_;
#line 133 "../src/protocol.vala"
	_tmp2_ = lsp_range_to_string (other);
#line 133 "../src/protocol.vala"
	_tmp3_ = _tmp2_;
#line 133 "../src/protocol.vala"
	_tmp4_ = g_strcmp0 (_tmp1_, _tmp3_) == 0;
#line 133 "../src/protocol.vala"
	_g_free0 (_tmp3_);
#line 133 "../src/protocol.vala"
	_g_free0 (_tmp1_);
#line 133 "../src/protocol.vala"
	result = _tmp4_;
#line 133 "../src/protocol.vala"
	return result;
#line 3992 "protocol.c"
}

static gint
lsp_range_real_compare_to (GeeComparable* base,
                           LspRange* other)
{
	LspRange * self;
	LspPosition* _tmp0_;
	LspPosition* _tmp1_;
	gint result;
#line 135 "../src/protocol.vala"
	self = (LspRange*) base;
#line 135 "../src/protocol.vala"
	g_return_val_if_fail (other != NULL, 0);
#line 136 "../src/protocol.vala"
	_tmp0_ = self->priv->_start;
#line 136 "../src/protocol.vala"
	_tmp1_ = other->priv->_start;
#line 136 "../src/protocol.vala"
	result = gee_comparable_compare_to ((GeeComparable*) _tmp0_, _tmp1_);
#line 136 "../src/protocol.vala"
	return result;
#line 4015 "protocol.c"
}

/**
         * Return a new range that includes `this` and `other`.
         */
static gpointer
_g_object_ref0 (gpointer self)
{
#line 143 "../src/protocol.vala"
	return self ? g_object_ref (self) : NULL;
#line 4026 "protocol.c"
}

LspRange*
lsp_range_union (LspRange* self,
                 LspRange* other)
{
	LspPosition* _tmp0_ = NULL;
	LspPosition* _tmp1_;
	LspPosition* _tmp2_;
	LspPosition* _tmp5_ = NULL;
	LspPosition* _tmp6_;
	LspPosition* _tmp7_;
	LspPosition* _tmp10_;
	LspPosition* _tmp11_;
	LspRange* _tmp12_ = NULL;
	LspRange* result;
#line 142 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 142 "../src/protocol.vala"
	g_return_val_if_fail (other != NULL, NULL);
#line 144 "../src/protocol.vala"
	_tmp1_ = self->priv->_start;
#line 144 "../src/protocol.vala"
	_tmp2_ = other->priv->_start;
#line 144 "../src/protocol.vala"
	if (gee_comparable_compare_to ((GeeComparable*) _tmp1_, _tmp2_) < 0) {
#line 4053 "protocol.c"
		LspPosition* _tmp3_;
#line 144 "../src/protocol.vala"
		_tmp3_ = self->priv->_start;
#line 144 "../src/protocol.vala"
		_tmp0_ = _tmp3_;
#line 4059 "protocol.c"
	} else {
		LspPosition* _tmp4_;
#line 144 "../src/protocol.vala"
		_tmp4_ = other->priv->_start;
#line 144 "../src/protocol.vala"
		_tmp0_ = _tmp4_;
#line 4066 "protocol.c"
	}
#line 145 "../src/protocol.vala"
	_tmp6_ = self->priv->_end;
#line 145 "../src/protocol.vala"
	_tmp7_ = other->priv->_end;
#line 145 "../src/protocol.vala"
	if (gee_comparable_compare_to ((GeeComparable*) _tmp6_, _tmp7_) < 0) {
#line 4074 "protocol.c"
		LspPosition* _tmp8_;
#line 145 "../src/protocol.vala"
		_tmp8_ = other->priv->_end;
#line 145 "../src/protocol.vala"
		_tmp5_ = _tmp8_;
#line 4080 "protocol.c"
	} else {
		LspPosition* _tmp9_;
#line 145 "../src/protocol.vala"
		_tmp9_ = self->priv->_end;
#line 145 "../src/protocol.vala"
		_tmp5_ = _tmp9_;
#line 4087 "protocol.c"
	}
#line 143 "../src/protocol.vala"
	_tmp10_ = _g_object_ref0 (_tmp0_);
#line 143 "../src/protocol.vala"
	_tmp11_ = _g_object_ref0 (_tmp5_);
#line 143 "../src/protocol.vala"
	_tmp12_ = lsp_range_new ();
#line 143 "../src/protocol.vala"
	lsp_range_set_start (_tmp12_, _tmp10_);
#line 143 "../src/protocol.vala"
	_g_object_unref0 (_tmp10_);
#line 143 "../src/protocol.vala"
	lsp_range_set_end (_tmp12_, _tmp11_);
#line 143 "../src/protocol.vala"
	_g_object_unref0 (_tmp11_);
#line 143 "../src/protocol.vala"
	result = _tmp12_;
#line 143 "../src/protocol.vala"
	return result;
#line 4107 "protocol.c"
}

gboolean
lsp_range_contains (LspRange* self,
                    LspPosition* pos)
{
	gboolean _tmp0_ = FALSE;
	LspPosition* _tmp1_;
	gboolean result;
#line 149 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 149 "../src/protocol.vala"
	g_return_val_if_fail (pos != NULL, FALSE);
#line 150 "../src/protocol.vala"
	_tmp1_ = self->priv->_start;
#line 150 "../src/protocol.vala"
	if (gee_comparable_compare_to ((GeeComparable*) _tmp1_, pos) <= 0) {
#line 4125 "protocol.c"
		LspPosition* _tmp2_;
#line 150 "../src/protocol.vala"
		_tmp2_ = self->priv->_end;
#line 150 "../src/protocol.vala"
		_tmp0_ = gee_comparable_compare_to ((GeeComparable*) pos, _tmp2_) <= 0;
#line 4131 "protocol.c"
	} else {
#line 150 "../src/protocol.vala"
		_tmp0_ = FALSE;
#line 4135 "protocol.c"
	}
#line 150 "../src/protocol.vala"
	result = _tmp0_;
#line 150 "../src/protocol.vala"
	return result;
#line 4141 "protocol.c"
}

LspRange*
lsp_range_construct (GType object_type)
{
	LspRange * self = NULL;
#line 107 "../src/protocol.vala"
	self = (LspRange*) g_object_new (object_type, NULL);
#line 107 "../src/protocol.vala"
	return self;
#line 4152 "protocol.c"
}

LspRange*
lsp_range_new (void)
{
#line 107 "../src/protocol.vala"
	return lsp_range_construct (LSP_TYPE_RANGE);
#line 4160 "protocol.c"
}

LspPosition*
lsp_range_get_start (LspRange* self)
{
	LspPosition* result;
	LspPosition* _tmp0_;
#line 111 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 111 "../src/protocol.vala"
	_tmp0_ = self->priv->_start;
#line 111 "../src/protocol.vala"
	result = _tmp0_;
#line 111 "../src/protocol.vala"
	return result;
#line 4176 "protocol.c"
}

void
lsp_range_set_start (LspRange* self,
                     LspPosition* value)
{
	LspPosition* old_value;
#line 111 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 111 "../src/protocol.vala"
	old_value = lsp_range_get_start (self);
#line 111 "../src/protocol.vala"
	if (old_value != value) {
#line 4190 "protocol.c"
		LspPosition* _tmp0_;
#line 111 "../src/protocol.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 111 "../src/protocol.vala"
		_g_object_unref0 (self->priv->_start);
#line 111 "../src/protocol.vala"
		self->priv->_start = _tmp0_;
#line 111 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_range_properties[LSP_RANGE_START_PROPERTY]);
#line 4200 "protocol.c"
	}
}

LspPosition*
lsp_range_get_end (LspRange* self)
{
	LspPosition* result;
	LspPosition* _tmp0_;
#line 116 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 116 "../src/protocol.vala"
	_tmp0_ = self->priv->_end;
#line 116 "../src/protocol.vala"
	result = _tmp0_;
#line 116 "../src/protocol.vala"
	return result;
#line 4217 "protocol.c"
}

void
lsp_range_set_end (LspRange* self,
                   LspPosition* value)
{
	LspPosition* old_value;
#line 116 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 116 "../src/protocol.vala"
	old_value = lsp_range_get_end (self);
#line 116 "../src/protocol.vala"
	if (old_value != value) {
#line 4231 "protocol.c"
		LspPosition* _tmp0_;
#line 116 "../src/protocol.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 116 "../src/protocol.vala"
		_g_object_unref0 (self->priv->_end);
#line 116 "../src/protocol.vala"
		self->priv->_end = _tmp0_;
#line 116 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_range_properties[LSP_RANGE_END_PROPERTY]);
#line 4241 "protocol.c"
	}
}

static void
lsp_range_class_init (LspRangeClass * klass,
                      gpointer klass_data)
{
#line 107 "../src/protocol.vala"
	lsp_range_parent_class = g_type_class_peek_parent (klass);
#line 107 "../src/protocol.vala"
	g_type_class_adjust_private_offset (klass, &LspRange_private_offset);
#line 107 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_lsp_range_get_property;
#line 107 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_lsp_range_set_property;
#line 107 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->finalize = lsp_range_finalize;
#line 4259 "protocol.c"
	/**
	         * The range's start position.
	         */
#line 107 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_RANGE_START_PROPERTY, lsp_range_properties[LSP_RANGE_START_PROPERTY] = g_param_spec_object ("start", "start", "start", LSP_TYPE_POSITION, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 4265 "protocol.c"
	/**
	         * The range's end position.
	         */
#line 107 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_RANGE_END_PROPERTY, lsp_range_properties[LSP_RANGE_END_PROPERTY] = g_param_spec_object ("end", "end", "end", LSP_TYPE_POSITION, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 4271 "protocol.c"
}

static void
lsp_range_gee_hashable_interface_init (GeeHashableIface * iface,
                                       gpointer iface_data)
{
#line 107 "../src/protocol.vala"
	lsp_range_gee_hashable_parent_iface = g_type_interface_peek_parent (iface);
#line 107 "../src/protocol.vala"
	iface->hash = (guint (*) (GeeHashable*)) lsp_range_real_hash;
#line 107 "../src/protocol.vala"
	iface->equal_to = (gboolean (*) (GeeHashable*, gconstpointer)) lsp_range_real_equal_to;
#line 4284 "protocol.c"
}

static void
lsp_range_gee_comparable_interface_init (GeeComparableIface * iface,
                                         gpointer iface_data)
{
#line 107 "../src/protocol.vala"
	lsp_range_gee_comparable_parent_iface = g_type_interface_peek_parent (iface);
#line 107 "../src/protocol.vala"
	iface->compare_to = (gint (*) (GeeComparable*, gconstpointer)) lsp_range_real_compare_to;
#line 4295 "protocol.c"
}

static void
lsp_range_instance_init (LspRange * self,
                         gpointer klass)
{
#line 107 "../src/protocol.vala"
	self->priv = lsp_range_get_instance_private (self);
#line 4304 "protocol.c"
}

static void
lsp_range_finalize (GObject * obj)
{
	LspRange * self;
#line 107 "../src/protocol.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, LSP_TYPE_RANGE, LspRange);
#line 111 "../src/protocol.vala"
	_g_object_unref0 (self->priv->_start);
#line 116 "../src/protocol.vala"
	_g_object_unref0 (self->priv->_end);
#line 118 "../src/protocol.vala"
	_g_free0 (self->priv->filename);
#line 107 "../src/protocol.vala"
	G_OBJECT_CLASS (lsp_range_parent_class)->finalize (obj);
#line 4321 "protocol.c"
}

 G_GNUC_NO_INLINE static GType
lsp_range_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (LspRangeClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) lsp_range_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LspRange), 0, (GInstanceInitFunc) lsp_range_instance_init, NULL };
	static const GInterfaceInfo gee_hashable_info = { (GInterfaceInitFunc) lsp_range_gee_hashable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	static const GInterfaceInfo gee_comparable_info = { (GInterfaceInitFunc) lsp_range_gee_comparable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType lsp_range_type_id;
	lsp_range_type_id = g_type_register_static (G_TYPE_OBJECT, "LspRange", &g_define_type_info, 0);
	g_type_add_interface_static (lsp_range_type_id, GEE_TYPE_HASHABLE, &gee_hashable_info);
	g_type_add_interface_static (lsp_range_type_id, GEE_TYPE_COMPARABLE, &gee_comparable_info);
	LspRange_private_offset = g_type_add_instance_private (lsp_range_type_id, sizeof (LspRangePrivate));
	return lsp_range_type_id;
}

GType
lsp_range_get_type (void)
{
	static gsize lsp_range_type_id__once = 0;
	if (g_once_init_enter (&lsp_range_type_id__once)) {
		GType lsp_range_type_id;
		lsp_range_type_id = lsp_range_get_type_once ();
		g_once_init_leave (&lsp_range_type_id__once, lsp_range_type_id);
	}
	return lsp_range_type_id__once;
}

static void
_vala_lsp_range_get_property (GObject * object,
                              guint property_id,
                              GValue * value,
                              GParamSpec * pspec)
{
	LspRange * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_RANGE, LspRange);
#line 107 "../src/protocol.vala"
	switch (property_id) {
#line 107 "../src/protocol.vala"
		case LSP_RANGE_START_PROPERTY:
#line 107 "../src/protocol.vala"
		g_value_set_object (value, lsp_range_get_start (self));
#line 107 "../src/protocol.vala"
		break;
#line 107 "../src/protocol.vala"
		case LSP_RANGE_END_PROPERTY:
#line 107 "../src/protocol.vala"
		g_value_set_object (value, lsp_range_get_end (self));
#line 107 "../src/protocol.vala"
		break;
#line 4372 "protocol.c"
		default:
#line 107 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 107 "../src/protocol.vala"
		break;
#line 4378 "protocol.c"
	}
}

static void
_vala_lsp_range_set_property (GObject * object,
                              guint property_id,
                              const GValue * value,
                              GParamSpec * pspec)
{
	LspRange * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_RANGE, LspRange);
#line 107 "../src/protocol.vala"
	switch (property_id) {
#line 107 "../src/protocol.vala"
		case LSP_RANGE_START_PROPERTY:
#line 107 "../src/protocol.vala"
		lsp_range_set_start (self, g_value_get_object (value));
#line 107 "../src/protocol.vala"
		break;
#line 107 "../src/protocol.vala"
		case LSP_RANGE_END_PROPERTY:
#line 107 "../src/protocol.vala"
		lsp_range_set_end (self, g_value_get_object (value));
#line 107 "../src/protocol.vala"
		break;
#line 4404 "protocol.c"
		default:
#line 107 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 107 "../src/protocol.vala"
		break;
#line 4410 "protocol.c"
	}
}

static inline gpointer
lsp_diagnostic_get_instance_private (LspDiagnostic* self)
{
	return G_STRUCT_MEMBER_P (self, LspDiagnostic_private_offset);
}

LspDiagnostic*
lsp_diagnostic_construct (GType object_type)
{
	LspDiagnostic * self = NULL;
#line 154 "../src/protocol.vala"
	self = (LspDiagnostic*) g_object_new (object_type, NULL);
#line 154 "../src/protocol.vala"
	return self;
#line 4428 "protocol.c"
}

LspDiagnostic*
lsp_diagnostic_new (void)
{
#line 154 "../src/protocol.vala"
	return lsp_diagnostic_construct (LSP_TYPE_DIAGNOSTIC);
#line 4436 "protocol.c"
}

LspRange*
lsp_diagnostic_get_range (LspDiagnostic* self)
{
	LspRange* result;
	LspRange* _tmp0_;
#line 158 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 158 "../src/protocol.vala"
	_tmp0_ = self->priv->_range;
#line 158 "../src/protocol.vala"
	result = _tmp0_;
#line 158 "../src/protocol.vala"
	return result;
#line 4452 "protocol.c"
}

void
lsp_diagnostic_set_range (LspDiagnostic* self,
                          LspRange* value)
{
	LspRange* old_value;
#line 158 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 158 "../src/protocol.vala"
	old_value = lsp_diagnostic_get_range (self);
#line 158 "../src/protocol.vala"
	if (old_value != value) {
#line 4466 "protocol.c"
		LspRange* _tmp0_;
#line 158 "../src/protocol.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 158 "../src/protocol.vala"
		_g_object_unref0 (self->priv->_range);
#line 158 "../src/protocol.vala"
		self->priv->_range = _tmp0_;
#line 158 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_diagnostic_properties[LSP_DIAGNOSTIC_RANGE_PROPERTY]);
#line 4476 "protocol.c"
	}
}

LspDiagnosticSeverity
lsp_diagnostic_get_severity (LspDiagnostic* self)
{
	LspDiagnosticSeverity result;
#line 164 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 164 "../src/protocol.vala"
	result = self->priv->_severity;
#line 164 "../src/protocol.vala"
	return result;
#line 4490 "protocol.c"
}

void
lsp_diagnostic_set_severity (LspDiagnostic* self,
                             LspDiagnosticSeverity value)
{
	LspDiagnosticSeverity old_value;
#line 164 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 164 "../src/protocol.vala"
	old_value = lsp_diagnostic_get_severity (self);
#line 164 "../src/protocol.vala"
	if (old_value != value) {
#line 164 "../src/protocol.vala"
		self->priv->_severity = value;
#line 164 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_diagnostic_properties[LSP_DIAGNOSTIC_SEVERITY_PROPERTY]);
#line 4508 "protocol.c"
	}
}

const gchar*
lsp_diagnostic_get_code (LspDiagnostic* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 169 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 169 "../src/protocol.vala"
	_tmp0_ = self->priv->_code;
#line 169 "../src/protocol.vala"
	result = _tmp0_;
#line 169 "../src/protocol.vala"
	return result;
#line 4525 "protocol.c"
}

void
lsp_diagnostic_set_code (LspDiagnostic* self,
                         const gchar* value)
{
	gchar* old_value;
#line 169 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 169 "../src/protocol.vala"
	old_value = lsp_diagnostic_get_code (self);
#line 169 "../src/protocol.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 4539 "protocol.c"
		gchar* _tmp0_;
#line 169 "../src/protocol.vala"
		_tmp0_ = g_strdup (value);
#line 169 "../src/protocol.vala"
		_g_free0 (self->priv->_code);
#line 169 "../src/protocol.vala"
		self->priv->_code = _tmp0_;
#line 169 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_diagnostic_properties[LSP_DIAGNOSTIC_CODE_PROPERTY]);
#line 4549 "protocol.c"
	}
}

const gchar*
lsp_diagnostic_get_source (LspDiagnostic* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 175 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 175 "../src/protocol.vala"
	_tmp0_ = self->priv->_source;
#line 175 "../src/protocol.vala"
	result = _tmp0_;
#line 175 "../src/protocol.vala"
	return result;
#line 4566 "protocol.c"
}

void
lsp_diagnostic_set_source (LspDiagnostic* self,
                           const gchar* value)
{
	gchar* old_value;
#line 175 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 175 "../src/protocol.vala"
	old_value = lsp_diagnostic_get_source (self);
#line 175 "../src/protocol.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 4580 "protocol.c"
		gchar* _tmp0_;
#line 175 "../src/protocol.vala"
		_tmp0_ = g_strdup (value);
#line 175 "../src/protocol.vala"
		_g_free0 (self->priv->_source);
#line 175 "../src/protocol.vala"
		self->priv->_source = _tmp0_;
#line 175 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_diagnostic_properties[LSP_DIAGNOSTIC_SOURCE_PROPERTY]);
#line 4590 "protocol.c"
	}
}

const gchar*
lsp_diagnostic_get_message (LspDiagnostic* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 180 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 180 "../src/protocol.vala"
	_tmp0_ = self->priv->_message;
#line 180 "../src/protocol.vala"
	result = _tmp0_;
#line 180 "../src/protocol.vala"
	return result;
#line 4607 "protocol.c"
}

void
lsp_diagnostic_set_message (LspDiagnostic* self,
                            const gchar* value)
{
	gchar* old_value;
#line 180 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 180 "../src/protocol.vala"
	old_value = lsp_diagnostic_get_message (self);
#line 180 "../src/protocol.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 4621 "protocol.c"
		gchar* _tmp0_;
#line 180 "../src/protocol.vala"
		_tmp0_ = g_strdup (value);
#line 180 "../src/protocol.vala"
		_g_free0 (self->priv->_message);
#line 180 "../src/protocol.vala"
		self->priv->_message = _tmp0_;
#line 180 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_diagnostic_properties[LSP_DIAGNOSTIC_MESSAGE_PROPERTY]);
#line 4631 "protocol.c"
	}
}

static void
lsp_diagnostic_class_init (LspDiagnosticClass * klass,
                           gpointer klass_data)
{
#line 154 "../src/protocol.vala"
	lsp_diagnostic_parent_class = g_type_class_peek_parent (klass);
#line 154 "../src/protocol.vala"
	g_type_class_adjust_private_offset (klass, &LspDiagnostic_private_offset);
#line 154 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_lsp_diagnostic_get_property;
#line 154 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_lsp_diagnostic_set_property;
#line 154 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->finalize = lsp_diagnostic_finalize;
#line 4649 "protocol.c"
	/**
	         * The range at which the message applies.
	         */
#line 154 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_DIAGNOSTIC_RANGE_PROPERTY, lsp_diagnostic_properties[LSP_DIAGNOSTIC_RANGE_PROPERTY] = g_param_spec_object ("range", "range", "range", LSP_TYPE_RANGE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 4655 "protocol.c"
	/**
	         * The diagnostic's severity. Can be omitted. If omitted it is up to the
	         * client to interpret diagnostics as error, warning, info or hint.
	         */
#line 154 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_DIAGNOSTIC_SEVERITY_PROPERTY, lsp_diagnostic_properties[LSP_DIAGNOSTIC_SEVERITY_PROPERTY] = g_param_spec_enum ("severity", "severity", "severity", LSP_TYPE_DIAGNOSTIC_SEVERITY, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 4662 "protocol.c"
	/**
	         * The diagnostic's code. Can be omitted.
	         */
#line 154 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_DIAGNOSTIC_CODE_PROPERTY, lsp_diagnostic_properties[LSP_DIAGNOSTIC_CODE_PROPERTY] = g_param_spec_string ("code", "code", "code", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 4668 "protocol.c"
	/**
	         * A human-readable string describing the source of this
	         * diagnostic, e.g. 'typescript' or 'super lint'.
	         */
#line 154 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_DIAGNOSTIC_SOURCE_PROPERTY, lsp_diagnostic_properties[LSP_DIAGNOSTIC_SOURCE_PROPERTY] = g_param_spec_string ("source", "source", "source", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 4675 "protocol.c"
	/**
	         * The diagnostic's message.
	         */
#line 154 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_DIAGNOSTIC_MESSAGE_PROPERTY, lsp_diagnostic_properties[LSP_DIAGNOSTIC_MESSAGE_PROPERTY] = g_param_spec_string ("message", "message", "message", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 4681 "protocol.c"
}

static void
lsp_diagnostic_instance_init (LspDiagnostic * self,
                              gpointer klass)
{
#line 154 "../src/protocol.vala"
	self->priv = lsp_diagnostic_get_instance_private (self);
#line 4690 "protocol.c"
}

static void
lsp_diagnostic_finalize (GObject * obj)
{
	LspDiagnostic * self;
#line 154 "../src/protocol.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, LSP_TYPE_DIAGNOSTIC, LspDiagnostic);
#line 158 "../src/protocol.vala"
	_g_object_unref0 (self->priv->_range);
#line 169 "../src/protocol.vala"
	_g_free0 (self->priv->_code);
#line 175 "../src/protocol.vala"
	_g_free0 (self->priv->_source);
#line 180 "../src/protocol.vala"
	_g_free0 (self->priv->_message);
#line 154 "../src/protocol.vala"
	G_OBJECT_CLASS (lsp_diagnostic_parent_class)->finalize (obj);
#line 4709 "protocol.c"
}

 G_GNUC_NO_INLINE static GType
lsp_diagnostic_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (LspDiagnosticClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) lsp_diagnostic_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LspDiagnostic), 0, (GInstanceInitFunc) lsp_diagnostic_instance_init, NULL };
	GType lsp_diagnostic_type_id;
	lsp_diagnostic_type_id = g_type_register_static (G_TYPE_OBJECT, "LspDiagnostic", &g_define_type_info, 0);
	LspDiagnostic_private_offset = g_type_add_instance_private (lsp_diagnostic_type_id, sizeof (LspDiagnosticPrivate));
	return lsp_diagnostic_type_id;
}

GType
lsp_diagnostic_get_type (void)
{
	static gsize lsp_diagnostic_type_id__once = 0;
	if (g_once_init_enter (&lsp_diagnostic_type_id__once)) {
		GType lsp_diagnostic_type_id;
		lsp_diagnostic_type_id = lsp_diagnostic_get_type_once ();
		g_once_init_leave (&lsp_diagnostic_type_id__once, lsp_diagnostic_type_id);
	}
	return lsp_diagnostic_type_id__once;
}

static void
_vala_lsp_diagnostic_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec)
{
	LspDiagnostic * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_DIAGNOSTIC, LspDiagnostic);
#line 154 "../src/protocol.vala"
	switch (property_id) {
#line 154 "../src/protocol.vala"
		case LSP_DIAGNOSTIC_RANGE_PROPERTY:
#line 154 "../src/protocol.vala"
		g_value_set_object (value, lsp_diagnostic_get_range (self));
#line 154 "../src/protocol.vala"
		break;
#line 154 "../src/protocol.vala"
		case LSP_DIAGNOSTIC_SEVERITY_PROPERTY:
#line 154 "../src/protocol.vala"
		g_value_set_enum (value, lsp_diagnostic_get_severity (self));
#line 154 "../src/protocol.vala"
		break;
#line 154 "../src/protocol.vala"
		case LSP_DIAGNOSTIC_CODE_PROPERTY:
#line 154 "../src/protocol.vala"
		g_value_set_string (value, lsp_diagnostic_get_code (self));
#line 154 "../src/protocol.vala"
		break;
#line 154 "../src/protocol.vala"
		case LSP_DIAGNOSTIC_SOURCE_PROPERTY:
#line 154 "../src/protocol.vala"
		g_value_set_string (value, lsp_diagnostic_get_source (self));
#line 154 "../src/protocol.vala"
		break;
#line 154 "../src/protocol.vala"
		case LSP_DIAGNOSTIC_MESSAGE_PROPERTY:
#line 154 "../src/protocol.vala"
		g_value_set_string (value, lsp_diagnostic_get_message (self));
#line 154 "../src/protocol.vala"
		break;
#line 4774 "protocol.c"
		default:
#line 154 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 154 "../src/protocol.vala"
		break;
#line 4780 "protocol.c"
	}
}

static void
_vala_lsp_diagnostic_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec)
{
	LspDiagnostic * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_DIAGNOSTIC, LspDiagnostic);
#line 154 "../src/protocol.vala"
	switch (property_id) {
#line 154 "../src/protocol.vala"
		case LSP_DIAGNOSTIC_RANGE_PROPERTY:
#line 154 "../src/protocol.vala"
		lsp_diagnostic_set_range (self, g_value_get_object (value));
#line 154 "../src/protocol.vala"
		break;
#line 154 "../src/protocol.vala"
		case LSP_DIAGNOSTIC_SEVERITY_PROPERTY:
#line 154 "../src/protocol.vala"
		lsp_diagnostic_set_severity (self, g_value_get_enum (value));
#line 154 "../src/protocol.vala"
		break;
#line 154 "../src/protocol.vala"
		case LSP_DIAGNOSTIC_CODE_PROPERTY:
#line 154 "../src/protocol.vala"
		lsp_diagnostic_set_code (self, g_value_get_string (value));
#line 154 "../src/protocol.vala"
		break;
#line 154 "../src/protocol.vala"
		case LSP_DIAGNOSTIC_SOURCE_PROPERTY:
#line 154 "../src/protocol.vala"
		lsp_diagnostic_set_source (self, g_value_get_string (value));
#line 154 "../src/protocol.vala"
		break;
#line 154 "../src/protocol.vala"
		case LSP_DIAGNOSTIC_MESSAGE_PROPERTY:
#line 154 "../src/protocol.vala"
		lsp_diagnostic_set_message (self, g_value_get_string (value));
#line 154 "../src/protocol.vala"
		break;
#line 4824 "protocol.c"
		default:
#line 154 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 154 "../src/protocol.vala"
		break;
#line 4830 "protocol.c"
	}
}

static inline gpointer
lsp_text_document_content_change_event_get_instance_private (LspTextDocumentContentChangeEvent* self)
{
	return G_STRUCT_MEMBER_P (self, LspTextDocumentContentChangeEvent_private_offset);
}

LspTextDocumentContentChangeEvent*
lsp_text_document_content_change_event_construct (GType object_type)
{
	LspTextDocumentContentChangeEvent * self = NULL;
#line 187 "../src/protocol.vala"
	self = (LspTextDocumentContentChangeEvent*) g_object_new (object_type, NULL);
#line 187 "../src/protocol.vala"
	return self;
#line 4848 "protocol.c"
}

LspTextDocumentContentChangeEvent*
lsp_text_document_content_change_event_new (void)
{
#line 187 "../src/protocol.vala"
	return lsp_text_document_content_change_event_construct (LSP_TYPE_TEXT_DOCUMENT_CONTENT_CHANGE_EVENT);
#line 4856 "protocol.c"
}

LspRange*
lsp_text_document_content_change_event_get_range (LspTextDocumentContentChangeEvent* self)
{
	LspRange* result;
	LspRange* _tmp0_;
#line 188 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 188 "../src/protocol.vala"
	_tmp0_ = self->priv->_range;
#line 188 "../src/protocol.vala"
	result = _tmp0_;
#line 188 "../src/protocol.vala"
	return result;
#line 4872 "protocol.c"
}

void
lsp_text_document_content_change_event_set_range (LspTextDocumentContentChangeEvent* self,
                                                  LspRange* value)
{
	LspRange* old_value;
#line 188 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 188 "../src/protocol.vala"
	old_value = lsp_text_document_content_change_event_get_range (self);
#line 188 "../src/protocol.vala"
	if (old_value != value) {
#line 4886 "protocol.c"
		LspRange* _tmp0_;
#line 188 "../src/protocol.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 188 "../src/protocol.vala"
		_g_object_unref0 (self->priv->_range);
#line 188 "../src/protocol.vala"
		self->priv->_range = _tmp0_;
#line 188 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_text_document_content_change_event_properties[LSP_TEXT_DOCUMENT_CONTENT_CHANGE_EVENT_RANGE_PROPERTY]);
#line 4896 "protocol.c"
	}
}

gint
lsp_text_document_content_change_event_get_rangeLength (LspTextDocumentContentChangeEvent* self)
{
	gint result;
#line 189 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 189 "../src/protocol.vala"
	result = self->priv->_rangeLength;
#line 189 "../src/protocol.vala"
	return result;
#line 4910 "protocol.c"
}

void
lsp_text_document_content_change_event_set_rangeLength (LspTextDocumentContentChangeEvent* self,
                                                        gint value)
{
	gint old_value;
#line 189 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 189 "../src/protocol.vala"
	old_value = lsp_text_document_content_change_event_get_rangeLength (self);
#line 189 "../src/protocol.vala"
	if (old_value != value) {
#line 189 "../src/protocol.vala"
		self->priv->_rangeLength = value;
#line 189 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_text_document_content_change_event_properties[LSP_TEXT_DOCUMENT_CONTENT_CHANGE_EVENT_RANGE_LENGTH_PROPERTY]);
#line 4928 "protocol.c"
	}
}

const gchar*
lsp_text_document_content_change_event_get_text (LspTextDocumentContentChangeEvent* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 190 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 190 "../src/protocol.vala"
	_tmp0_ = self->priv->_text;
#line 190 "../src/protocol.vala"
	result = _tmp0_;
#line 190 "../src/protocol.vala"
	return result;
#line 4945 "protocol.c"
}

void
lsp_text_document_content_change_event_set_text (LspTextDocumentContentChangeEvent* self,
                                                 const gchar* value)
{
	gchar* old_value;
#line 190 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 190 "../src/protocol.vala"
	old_value = lsp_text_document_content_change_event_get_text (self);
#line 190 "../src/protocol.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 4959 "protocol.c"
		gchar* _tmp0_;
#line 190 "../src/protocol.vala"
		_tmp0_ = g_strdup (value);
#line 190 "../src/protocol.vala"
		_g_free0 (self->priv->_text);
#line 190 "../src/protocol.vala"
		self->priv->_text = _tmp0_;
#line 190 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_text_document_content_change_event_properties[LSP_TEXT_DOCUMENT_CONTENT_CHANGE_EVENT_TEXT_PROPERTY]);
#line 4969 "protocol.c"
	}
}

static void
lsp_text_document_content_change_event_class_init (LspTextDocumentContentChangeEventClass * klass,
                                                   gpointer klass_data)
{
#line 187 "../src/protocol.vala"
	lsp_text_document_content_change_event_parent_class = g_type_class_peek_parent (klass);
#line 187 "../src/protocol.vala"
	g_type_class_adjust_private_offset (klass, &LspTextDocumentContentChangeEvent_private_offset);
#line 187 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_lsp_text_document_content_change_event_get_property;
#line 187 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_lsp_text_document_content_change_event_set_property;
#line 187 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->finalize = lsp_text_document_content_change_event_finalize;
#line 187 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_TEXT_DOCUMENT_CONTENT_CHANGE_EVENT_RANGE_PROPERTY, lsp_text_document_content_change_event_properties[LSP_TEXT_DOCUMENT_CONTENT_CHANGE_EVENT_RANGE_PROPERTY] = g_param_spec_object ("range", "range", "range", LSP_TYPE_RANGE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 187 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_TEXT_DOCUMENT_CONTENT_CHANGE_EVENT_RANGE_LENGTH_PROPERTY, lsp_text_document_content_change_event_properties[LSP_TEXT_DOCUMENT_CONTENT_CHANGE_EVENT_RANGE_LENGTH_PROPERTY] = g_param_spec_int ("rangeLength", "rangeLength", "rangeLength", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 187 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_TEXT_DOCUMENT_CONTENT_CHANGE_EVENT_TEXT_PROPERTY, lsp_text_document_content_change_event_properties[LSP_TEXT_DOCUMENT_CONTENT_CHANGE_EVENT_TEXT_PROPERTY] = g_param_spec_string ("text", "text", "text", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 4993 "protocol.c"
}

static void
lsp_text_document_content_change_event_instance_init (LspTextDocumentContentChangeEvent * self,
                                                      gpointer klass)
{
#line 187 "../src/protocol.vala"
	self->priv = lsp_text_document_content_change_event_get_instance_private (self);
#line 5002 "protocol.c"
}

static void
lsp_text_document_content_change_event_finalize (GObject * obj)
{
	LspTextDocumentContentChangeEvent * self;
#line 187 "../src/protocol.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, LSP_TYPE_TEXT_DOCUMENT_CONTENT_CHANGE_EVENT, LspTextDocumentContentChangeEvent);
#line 188 "../src/protocol.vala"
	_g_object_unref0 (self->priv->_range);
#line 190 "../src/protocol.vala"
	_g_free0 (self->priv->_text);
#line 187 "../src/protocol.vala"
	G_OBJECT_CLASS (lsp_text_document_content_change_event_parent_class)->finalize (obj);
#line 5017 "protocol.c"
}

/**
     * An event describing a change to a text document. If range and rangeLength are omitted
     * the new text is considered to be the full content of the document.
     */
 G_GNUC_NO_INLINE static GType
lsp_text_document_content_change_event_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (LspTextDocumentContentChangeEventClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) lsp_text_document_content_change_event_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LspTextDocumentContentChangeEvent), 0, (GInstanceInitFunc) lsp_text_document_content_change_event_instance_init, NULL };
	GType lsp_text_document_content_change_event_type_id;
	lsp_text_document_content_change_event_type_id = g_type_register_static (G_TYPE_OBJECT, "LspTextDocumentContentChangeEvent", &g_define_type_info, 0);
	LspTextDocumentContentChangeEvent_private_offset = g_type_add_instance_private (lsp_text_document_content_change_event_type_id, sizeof (LspTextDocumentContentChangeEventPrivate));
	return lsp_text_document_content_change_event_type_id;
}

GType
lsp_text_document_content_change_event_get_type (void)
{
	static gsize lsp_text_document_content_change_event_type_id__once = 0;
	if (g_once_init_enter (&lsp_text_document_content_change_event_type_id__once)) {
		GType lsp_text_document_content_change_event_type_id;
		lsp_text_document_content_change_event_type_id = lsp_text_document_content_change_event_get_type_once ();
		g_once_init_leave (&lsp_text_document_content_change_event_type_id__once, lsp_text_document_content_change_event_type_id);
	}
	return lsp_text_document_content_change_event_type_id__once;
}

static void
_vala_lsp_text_document_content_change_event_get_property (GObject * object,
                                                           guint property_id,
                                                           GValue * value,
                                                           GParamSpec * pspec)
{
	LspTextDocumentContentChangeEvent * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_TEXT_DOCUMENT_CONTENT_CHANGE_EVENT, LspTextDocumentContentChangeEvent);
#line 187 "../src/protocol.vala"
	switch (property_id) {
#line 187 "../src/protocol.vala"
		case LSP_TEXT_DOCUMENT_CONTENT_CHANGE_EVENT_RANGE_PROPERTY:
#line 187 "../src/protocol.vala"
		g_value_set_object (value, lsp_text_document_content_change_event_get_range (self));
#line 187 "../src/protocol.vala"
		break;
#line 187 "../src/protocol.vala"
		case LSP_TEXT_DOCUMENT_CONTENT_CHANGE_EVENT_RANGE_LENGTH_PROPERTY:
#line 187 "../src/protocol.vala"
		g_value_set_int (value, lsp_text_document_content_change_event_get_rangeLength (self));
#line 187 "../src/protocol.vala"
		break;
#line 187 "../src/protocol.vala"
		case LSP_TEXT_DOCUMENT_CONTENT_CHANGE_EVENT_TEXT_PROPERTY:
#line 187 "../src/protocol.vala"
		g_value_set_string (value, lsp_text_document_content_change_event_get_text (self));
#line 187 "../src/protocol.vala"
		break;
#line 5074 "protocol.c"
		default:
#line 187 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 187 "../src/protocol.vala"
		break;
#line 5080 "protocol.c"
	}
}

static void
_vala_lsp_text_document_content_change_event_set_property (GObject * object,
                                                           guint property_id,
                                                           const GValue * value,
                                                           GParamSpec * pspec)
{
	LspTextDocumentContentChangeEvent * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_TEXT_DOCUMENT_CONTENT_CHANGE_EVENT, LspTextDocumentContentChangeEvent);
#line 187 "../src/protocol.vala"
	switch (property_id) {
#line 187 "../src/protocol.vala"
		case LSP_TEXT_DOCUMENT_CONTENT_CHANGE_EVENT_RANGE_PROPERTY:
#line 187 "../src/protocol.vala"
		lsp_text_document_content_change_event_set_range (self, g_value_get_object (value));
#line 187 "../src/protocol.vala"
		break;
#line 187 "../src/protocol.vala"
		case LSP_TEXT_DOCUMENT_CONTENT_CHANGE_EVENT_RANGE_LENGTH_PROPERTY:
#line 187 "../src/protocol.vala"
		lsp_text_document_content_change_event_set_rangeLength (self, g_value_get_int (value));
#line 187 "../src/protocol.vala"
		break;
#line 187 "../src/protocol.vala"
		case LSP_TEXT_DOCUMENT_CONTENT_CHANGE_EVENT_TEXT_PROPERTY:
#line 187 "../src/protocol.vala"
		lsp_text_document_content_change_event_set_text (self, g_value_get_string (value));
#line 187 "../src/protocol.vala"
		break;
#line 5112 "protocol.c"
		default:
#line 187 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 187 "../src/protocol.vala"
		break;
#line 5118 "protocol.c"
	}
}

 G_GNUC_NO_INLINE static GType
lsp_message_type_get_type_once (void)
{
	static const GEnumValue values[] = {{LSP_MESSAGE_TYPE_Error, "LSP_MESSAGE_TYPE_Error", "error"}, {LSP_MESSAGE_TYPE_Warning, "LSP_MESSAGE_TYPE_Warning", "warning"}, {LSP_MESSAGE_TYPE_Info, "LSP_MESSAGE_TYPE_Info", "info"}, {LSP_MESSAGE_TYPE_Log, "LSP_MESSAGE_TYPE_Log", "log"}, {0, NULL, NULL}};
	GType lsp_message_type_type_id;
	lsp_message_type_type_id = g_enum_register_static ("LspMessageType", values);
	return lsp_message_type_type_id;
}

GType
lsp_message_type_get_type (void)
{
	static gsize lsp_message_type_type_id__once = 0;
	if (g_once_init_enter (&lsp_message_type_type_id__once)) {
		GType lsp_message_type_type_id;
		lsp_message_type_type_id = lsp_message_type_get_type_once ();
		g_once_init_leave (&lsp_message_type_type_id__once, lsp_message_type_type_id);
	}
	return lsp_message_type_type_id__once;
}

static inline gpointer
lsp_text_document_identifier_get_instance_private (LspTextDocumentIdentifier* self)
{
	return G_STRUCT_MEMBER_P (self, LspTextDocumentIdentifier_private_offset);
}

LspTextDocumentIdentifier*
lsp_text_document_identifier_construct (GType object_type)
{
	LspTextDocumentIdentifier * self = NULL;
#line 212 "../src/protocol.vala"
	self = (LspTextDocumentIdentifier*) g_object_new (object_type, NULL);
#line 212 "../src/protocol.vala"
	return self;
#line 5157 "protocol.c"
}

LspTextDocumentIdentifier*
lsp_text_document_identifier_new (void)
{
#line 212 "../src/protocol.vala"
	return lsp_text_document_identifier_construct (LSP_TYPE_TEXT_DOCUMENT_IDENTIFIER);
#line 5165 "protocol.c"
}

const gchar*
lsp_text_document_identifier_get_uri (LspTextDocumentIdentifier* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 213 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 213 "../src/protocol.vala"
	_tmp0_ = self->priv->_uri;
#line 213 "../src/protocol.vala"
	result = _tmp0_;
#line 213 "../src/protocol.vala"
	return result;
#line 5181 "protocol.c"
}

void
lsp_text_document_identifier_set_uri (LspTextDocumentIdentifier* self,
                                      const gchar* value)
{
	gchar* old_value;
#line 213 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 213 "../src/protocol.vala"
	old_value = lsp_text_document_identifier_get_uri (self);
#line 213 "../src/protocol.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 5195 "protocol.c"
		gchar* _tmp0_;
#line 213 "../src/protocol.vala"
		_tmp0_ = g_strdup (value);
#line 213 "../src/protocol.vala"
		_g_free0 (self->priv->_uri);
#line 213 "../src/protocol.vala"
		self->priv->_uri = _tmp0_;
#line 213 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_text_document_identifier_properties[LSP_TEXT_DOCUMENT_IDENTIFIER_URI_PROPERTY]);
#line 5205 "protocol.c"
	}
}

static void
lsp_text_document_identifier_class_init (LspTextDocumentIdentifierClass * klass,
                                         gpointer klass_data)
{
#line 212 "../src/protocol.vala"
	lsp_text_document_identifier_parent_class = g_type_class_peek_parent (klass);
#line 212 "../src/protocol.vala"
	g_type_class_adjust_private_offset (klass, &LspTextDocumentIdentifier_private_offset);
#line 212 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_lsp_text_document_identifier_get_property;
#line 212 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_lsp_text_document_identifier_set_property;
#line 212 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->finalize = lsp_text_document_identifier_finalize;
#line 212 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_TEXT_DOCUMENT_IDENTIFIER_URI_PROPERTY, lsp_text_document_identifier_properties[LSP_TEXT_DOCUMENT_IDENTIFIER_URI_PROPERTY] = g_param_spec_string ("uri", "uri", "uri", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 5225 "protocol.c"
}

static void
lsp_text_document_identifier_instance_init (LspTextDocumentIdentifier * self,
                                            gpointer klass)
{
#line 212 "../src/protocol.vala"
	self->priv = lsp_text_document_identifier_get_instance_private (self);
#line 5234 "protocol.c"
}

static void
lsp_text_document_identifier_finalize (GObject * obj)
{
	LspTextDocumentIdentifier * self;
#line 212 "../src/protocol.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, LSP_TYPE_TEXT_DOCUMENT_IDENTIFIER, LspTextDocumentIdentifier);
#line 213 "../src/protocol.vala"
	_g_free0 (self->priv->_uri);
#line 212 "../src/protocol.vala"
	G_OBJECT_CLASS (lsp_text_document_identifier_parent_class)->finalize (obj);
#line 5247 "protocol.c"
}

 G_GNUC_NO_INLINE static GType
lsp_text_document_identifier_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (LspTextDocumentIdentifierClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) lsp_text_document_identifier_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LspTextDocumentIdentifier), 0, (GInstanceInitFunc) lsp_text_document_identifier_instance_init, NULL };
	GType lsp_text_document_identifier_type_id;
	lsp_text_document_identifier_type_id = g_type_register_static (G_TYPE_OBJECT, "LspTextDocumentIdentifier", &g_define_type_info, 0);
	LspTextDocumentIdentifier_private_offset = g_type_add_instance_private (lsp_text_document_identifier_type_id, sizeof (LspTextDocumentIdentifierPrivate));
	return lsp_text_document_identifier_type_id;
}

GType
lsp_text_document_identifier_get_type (void)
{
	static gsize lsp_text_document_identifier_type_id__once = 0;
	if (g_once_init_enter (&lsp_text_document_identifier_type_id__once)) {
		GType lsp_text_document_identifier_type_id;
		lsp_text_document_identifier_type_id = lsp_text_document_identifier_get_type_once ();
		g_once_init_leave (&lsp_text_document_identifier_type_id__once, lsp_text_document_identifier_type_id);
	}
	return lsp_text_document_identifier_type_id__once;
}

static void
_vala_lsp_text_document_identifier_get_property (GObject * object,
                                                 guint property_id,
                                                 GValue * value,
                                                 GParamSpec * pspec)
{
	LspTextDocumentIdentifier * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_TEXT_DOCUMENT_IDENTIFIER, LspTextDocumentIdentifier);
#line 212 "../src/protocol.vala"
	switch (property_id) {
#line 212 "../src/protocol.vala"
		case LSP_TEXT_DOCUMENT_IDENTIFIER_URI_PROPERTY:
#line 212 "../src/protocol.vala"
		g_value_set_string (value, lsp_text_document_identifier_get_uri (self));
#line 212 "../src/protocol.vala"
		break;
#line 5288 "protocol.c"
		default:
#line 212 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 212 "../src/protocol.vala"
		break;
#line 5294 "protocol.c"
	}
}

static void
_vala_lsp_text_document_identifier_set_property (GObject * object,
                                                 guint property_id,
                                                 const GValue * value,
                                                 GParamSpec * pspec)
{
	LspTextDocumentIdentifier * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_TEXT_DOCUMENT_IDENTIFIER, LspTextDocumentIdentifier);
#line 212 "../src/protocol.vala"
	switch (property_id) {
#line 212 "../src/protocol.vala"
		case LSP_TEXT_DOCUMENT_IDENTIFIER_URI_PROPERTY:
#line 212 "../src/protocol.vala"
		lsp_text_document_identifier_set_uri (self, g_value_get_string (value));
#line 212 "../src/protocol.vala"
		break;
#line 5314 "protocol.c"
		default:
#line 212 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 212 "../src/protocol.vala"
		break;
#line 5320 "protocol.c"
	}
}

static inline gpointer
lsp_versioned_text_document_identifier_get_instance_private (LspVersionedTextDocumentIdentifier* self)
{
	return G_STRUCT_MEMBER_P (self, LspVersionedTextDocumentIdentifier_private_offset);
}

LspVersionedTextDocumentIdentifier*
lsp_versioned_text_document_identifier_construct (GType object_type)
{
	LspVersionedTextDocumentIdentifier * self = NULL;
#line 216 "../src/protocol.vala"
	self = (LspVersionedTextDocumentIdentifier*) lsp_text_document_identifier_construct (object_type);
#line 216 "../src/protocol.vala"
	return self;
#line 5338 "protocol.c"
}

LspVersionedTextDocumentIdentifier*
lsp_versioned_text_document_identifier_new (void)
{
#line 216 "../src/protocol.vala"
	return lsp_versioned_text_document_identifier_construct (LSP_TYPE_VERSIONED_TEXT_DOCUMENT_IDENTIFIER);
#line 5346 "protocol.c"
}

gint
lsp_versioned_text_document_identifier_get_version (LspVersionedTextDocumentIdentifier* self)
{
	gint result;
#line 227 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 227 "../src/protocol.vala"
	result = self->priv->_version;
#line 227 "../src/protocol.vala"
	return result;
#line 5359 "protocol.c"
}

void
lsp_versioned_text_document_identifier_set_version (LspVersionedTextDocumentIdentifier* self,
                                                    gint value)
{
	gint old_value;
#line 227 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 227 "../src/protocol.vala"
	old_value = lsp_versioned_text_document_identifier_get_version (self);
#line 227 "../src/protocol.vala"
	if (old_value != value) {
#line 227 "../src/protocol.vala"
		self->priv->_version = value;
#line 227 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_versioned_text_document_identifier_properties[LSP_VERSIONED_TEXT_DOCUMENT_IDENTIFIER_VERSION_PROPERTY]);
#line 5377 "protocol.c"
	}
}

static void
lsp_versioned_text_document_identifier_class_init (LspVersionedTextDocumentIdentifierClass * klass,
                                                   gpointer klass_data)
{
#line 216 "../src/protocol.vala"
	lsp_versioned_text_document_identifier_parent_class = g_type_class_peek_parent (klass);
#line 216 "../src/protocol.vala"
	g_type_class_adjust_private_offset (klass, &LspVersionedTextDocumentIdentifier_private_offset);
#line 216 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_lsp_versioned_text_document_identifier_get_property;
#line 216 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_lsp_versioned_text_document_identifier_set_property;
#line 216 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->finalize = lsp_versioned_text_document_identifier_finalize;
#line 5395 "protocol.c"
	/**
	         * The version number of this document. If a versioned text document identifier
	         * is sent from the server to the client and the file is not open in the editor
	         * (the server has not received an open notification before) the server can send
	         * `null` to indicate that the version is known and the content on disk is the
	         * master (as speced with document content ownership).
	         *
	         * The version number of a document will increase after each change, including
	         * undo/redo. The number doesn't need to be consecutive.
	         */
#line 216 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_VERSIONED_TEXT_DOCUMENT_IDENTIFIER_VERSION_PROPERTY, lsp_versioned_text_document_identifier_properties[LSP_VERSIONED_TEXT_DOCUMENT_IDENTIFIER_VERSION_PROPERTY] = g_param_spec_int ("version", "version", "version", G_MININT, G_MAXINT, -1, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 5408 "protocol.c"
}

static void
lsp_versioned_text_document_identifier_instance_init (LspVersionedTextDocumentIdentifier * self,
                                                      gpointer klass)
{
#line 216 "../src/protocol.vala"
	self->priv = lsp_versioned_text_document_identifier_get_instance_private (self);
#line 227 "../src/protocol.vala"
	self->priv->_version = -1;
#line 5419 "protocol.c"
}

static void
lsp_versioned_text_document_identifier_finalize (GObject * obj)
{
	LspVersionedTextDocumentIdentifier * self;
#line 216 "../src/protocol.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, LSP_TYPE_VERSIONED_TEXT_DOCUMENT_IDENTIFIER, LspVersionedTextDocumentIdentifier);
#line 216 "../src/protocol.vala"
	G_OBJECT_CLASS (lsp_versioned_text_document_identifier_parent_class)->finalize (obj);
#line 5430 "protocol.c"
}

 G_GNUC_NO_INLINE static GType
lsp_versioned_text_document_identifier_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (LspVersionedTextDocumentIdentifierClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) lsp_versioned_text_document_identifier_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LspVersionedTextDocumentIdentifier), 0, (GInstanceInitFunc) lsp_versioned_text_document_identifier_instance_init, NULL };
	GType lsp_versioned_text_document_identifier_type_id;
	lsp_versioned_text_document_identifier_type_id = g_type_register_static (LSP_TYPE_TEXT_DOCUMENT_IDENTIFIER, "LspVersionedTextDocumentIdentifier", &g_define_type_info, 0);
	LspVersionedTextDocumentIdentifier_private_offset = g_type_add_instance_private (lsp_versioned_text_document_identifier_type_id, sizeof (LspVersionedTextDocumentIdentifierPrivate));
	return lsp_versioned_text_document_identifier_type_id;
}

GType
lsp_versioned_text_document_identifier_get_type (void)
{
	static gsize lsp_versioned_text_document_identifier_type_id__once = 0;
	if (g_once_init_enter (&lsp_versioned_text_document_identifier_type_id__once)) {
		GType lsp_versioned_text_document_identifier_type_id;
		lsp_versioned_text_document_identifier_type_id = lsp_versioned_text_document_identifier_get_type_once ();
		g_once_init_leave (&lsp_versioned_text_document_identifier_type_id__once, lsp_versioned_text_document_identifier_type_id);
	}
	return lsp_versioned_text_document_identifier_type_id__once;
}

static void
_vala_lsp_versioned_text_document_identifier_get_property (GObject * object,
                                                           guint property_id,
                                                           GValue * value,
                                                           GParamSpec * pspec)
{
	LspVersionedTextDocumentIdentifier * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_VERSIONED_TEXT_DOCUMENT_IDENTIFIER, LspVersionedTextDocumentIdentifier);
#line 216 "../src/protocol.vala"
	switch (property_id) {
#line 216 "../src/protocol.vala"
		case LSP_VERSIONED_TEXT_DOCUMENT_IDENTIFIER_VERSION_PROPERTY:
#line 216 "../src/protocol.vala"
		g_value_set_int (value, lsp_versioned_text_document_identifier_get_version (self));
#line 216 "../src/protocol.vala"
		break;
#line 5471 "protocol.c"
		default:
#line 216 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 216 "../src/protocol.vala"
		break;
#line 5477 "protocol.c"
	}
}

static void
_vala_lsp_versioned_text_document_identifier_set_property (GObject * object,
                                                           guint property_id,
                                                           const GValue * value,
                                                           GParamSpec * pspec)
{
	LspVersionedTextDocumentIdentifier * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_VERSIONED_TEXT_DOCUMENT_IDENTIFIER, LspVersionedTextDocumentIdentifier);
#line 216 "../src/protocol.vala"
	switch (property_id) {
#line 216 "../src/protocol.vala"
		case LSP_VERSIONED_TEXT_DOCUMENT_IDENTIFIER_VERSION_PROPERTY:
#line 216 "../src/protocol.vala"
		lsp_versioned_text_document_identifier_set_version (self, g_value_get_int (value));
#line 216 "../src/protocol.vala"
		break;
#line 5497 "protocol.c"
		default:
#line 216 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 216 "../src/protocol.vala"
		break;
#line 5503 "protocol.c"
	}
}

static inline gpointer
lsp_text_document_position_params_get_instance_private (LspTextDocumentPositionParams* self)
{
	return G_STRUCT_MEMBER_P (self, LspTextDocumentPositionParams_private_offset);
}

LspTextDocumentPositionParams*
lsp_text_document_position_params_construct (GType object_type)
{
	LspTextDocumentPositionParams * self = NULL;
#line 230 "../src/protocol.vala"
	self = (LspTextDocumentPositionParams*) g_object_new (object_type, NULL);
#line 230 "../src/protocol.vala"
	return self;
#line 5521 "protocol.c"
}

LspTextDocumentPositionParams*
lsp_text_document_position_params_new (void)
{
#line 230 "../src/protocol.vala"
	return lsp_text_document_position_params_construct (LSP_TYPE_TEXT_DOCUMENT_POSITION_PARAMS);
#line 5529 "protocol.c"
}

LspTextDocumentIdentifier*
lsp_text_document_position_params_get_textDocument (LspTextDocumentPositionParams* self)
{
	LspTextDocumentIdentifier* result;
	LspTextDocumentIdentifier* _tmp0_;
#line 231 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 231 "../src/protocol.vala"
	_tmp0_ = self->priv->_textDocument;
#line 231 "../src/protocol.vala"
	result = _tmp0_;
#line 231 "../src/protocol.vala"
	return result;
#line 5545 "protocol.c"
}

void
lsp_text_document_position_params_set_textDocument (LspTextDocumentPositionParams* self,
                                                    LspTextDocumentIdentifier* value)
{
	LspTextDocumentIdentifier* old_value;
#line 231 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 231 "../src/protocol.vala"
	old_value = lsp_text_document_position_params_get_textDocument (self);
#line 231 "../src/protocol.vala"
	if (old_value != value) {
#line 5559 "protocol.c"
		LspTextDocumentIdentifier* _tmp0_;
#line 231 "../src/protocol.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 231 "../src/protocol.vala"
		_g_object_unref0 (self->priv->_textDocument);
#line 231 "../src/protocol.vala"
		self->priv->_textDocument = _tmp0_;
#line 231 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_text_document_position_params_properties[LSP_TEXT_DOCUMENT_POSITION_PARAMS_TEXT_DOCUMENT_PROPERTY]);
#line 5569 "protocol.c"
	}
}

LspPosition*
lsp_text_document_position_params_get_position (LspTextDocumentPositionParams* self)
{
	LspPosition* result;
	LspPosition* _tmp0_;
#line 232 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 232 "../src/protocol.vala"
	_tmp0_ = self->priv->_position;
#line 232 "../src/protocol.vala"
	result = _tmp0_;
#line 232 "../src/protocol.vala"
	return result;
#line 5586 "protocol.c"
}

void
lsp_text_document_position_params_set_position (LspTextDocumentPositionParams* self,
                                                LspPosition* value)
{
	LspPosition* old_value;
#line 232 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 232 "../src/protocol.vala"
	old_value = lsp_text_document_position_params_get_position (self);
#line 232 "../src/protocol.vala"
	if (old_value != value) {
#line 5600 "protocol.c"
		LspPosition* _tmp0_;
#line 232 "../src/protocol.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 232 "../src/protocol.vala"
		_g_object_unref0 (self->priv->_position);
#line 232 "../src/protocol.vala"
		self->priv->_position = _tmp0_;
#line 232 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_text_document_position_params_properties[LSP_TEXT_DOCUMENT_POSITION_PARAMS_POSITION_PROPERTY]);
#line 5610 "protocol.c"
	}
}

static void
lsp_text_document_position_params_class_init (LspTextDocumentPositionParamsClass * klass,
                                              gpointer klass_data)
{
#line 230 "../src/protocol.vala"
	lsp_text_document_position_params_parent_class = g_type_class_peek_parent (klass);
#line 230 "../src/protocol.vala"
	g_type_class_adjust_private_offset (klass, &LspTextDocumentPositionParams_private_offset);
#line 230 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_lsp_text_document_position_params_get_property;
#line 230 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_lsp_text_document_position_params_set_property;
#line 230 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->finalize = lsp_text_document_position_params_finalize;
#line 230 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_TEXT_DOCUMENT_POSITION_PARAMS_TEXT_DOCUMENT_PROPERTY, lsp_text_document_position_params_properties[LSP_TEXT_DOCUMENT_POSITION_PARAMS_TEXT_DOCUMENT_PROPERTY] = g_param_spec_object ("textDocument", "textDocument", "textDocument", LSP_TYPE_TEXT_DOCUMENT_IDENTIFIER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 230 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_TEXT_DOCUMENT_POSITION_PARAMS_POSITION_PROPERTY, lsp_text_document_position_params_properties[LSP_TEXT_DOCUMENT_POSITION_PARAMS_POSITION_PROPERTY] = g_param_spec_object ("position", "position", "position", LSP_TYPE_POSITION, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 5632 "protocol.c"
}

static void
lsp_text_document_position_params_instance_init (LspTextDocumentPositionParams * self,
                                                 gpointer klass)
{
#line 230 "../src/protocol.vala"
	self->priv = lsp_text_document_position_params_get_instance_private (self);
#line 5641 "protocol.c"
}

static void
lsp_text_document_position_params_finalize (GObject * obj)
{
	LspTextDocumentPositionParams * self;
#line 230 "../src/protocol.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, LSP_TYPE_TEXT_DOCUMENT_POSITION_PARAMS, LspTextDocumentPositionParams);
#line 231 "../src/protocol.vala"
	_g_object_unref0 (self->priv->_textDocument);
#line 232 "../src/protocol.vala"
	_g_object_unref0 (self->priv->_position);
#line 230 "../src/protocol.vala"
	G_OBJECT_CLASS (lsp_text_document_position_params_parent_class)->finalize (obj);
#line 5656 "protocol.c"
}

 G_GNUC_NO_INLINE static GType
lsp_text_document_position_params_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (LspTextDocumentPositionParamsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) lsp_text_document_position_params_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LspTextDocumentPositionParams), 0, (GInstanceInitFunc) lsp_text_document_position_params_instance_init, NULL };
	GType lsp_text_document_position_params_type_id;
	lsp_text_document_position_params_type_id = g_type_register_static (G_TYPE_OBJECT, "LspTextDocumentPositionParams", &g_define_type_info, 0);
	LspTextDocumentPositionParams_private_offset = g_type_add_instance_private (lsp_text_document_position_params_type_id, sizeof (LspTextDocumentPositionParamsPrivate));
	return lsp_text_document_position_params_type_id;
}

GType
lsp_text_document_position_params_get_type (void)
{
	static gsize lsp_text_document_position_params_type_id__once = 0;
	if (g_once_init_enter (&lsp_text_document_position_params_type_id__once)) {
		GType lsp_text_document_position_params_type_id;
		lsp_text_document_position_params_type_id = lsp_text_document_position_params_get_type_once ();
		g_once_init_leave (&lsp_text_document_position_params_type_id__once, lsp_text_document_position_params_type_id);
	}
	return lsp_text_document_position_params_type_id__once;
}

static void
_vala_lsp_text_document_position_params_get_property (GObject * object,
                                                      guint property_id,
                                                      GValue * value,
                                                      GParamSpec * pspec)
{
	LspTextDocumentPositionParams * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_TEXT_DOCUMENT_POSITION_PARAMS, LspTextDocumentPositionParams);
#line 230 "../src/protocol.vala"
	switch (property_id) {
#line 230 "../src/protocol.vala"
		case LSP_TEXT_DOCUMENT_POSITION_PARAMS_TEXT_DOCUMENT_PROPERTY:
#line 230 "../src/protocol.vala"
		g_value_set_object (value, lsp_text_document_position_params_get_textDocument (self));
#line 230 "../src/protocol.vala"
		break;
#line 230 "../src/protocol.vala"
		case LSP_TEXT_DOCUMENT_POSITION_PARAMS_POSITION_PROPERTY:
#line 230 "../src/protocol.vala"
		g_value_set_object (value, lsp_text_document_position_params_get_position (self));
#line 230 "../src/protocol.vala"
		break;
#line 5703 "protocol.c"
		default:
#line 230 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 230 "../src/protocol.vala"
		break;
#line 5709 "protocol.c"
	}
}

static void
_vala_lsp_text_document_position_params_set_property (GObject * object,
                                                      guint property_id,
                                                      const GValue * value,
                                                      GParamSpec * pspec)
{
	LspTextDocumentPositionParams * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_TEXT_DOCUMENT_POSITION_PARAMS, LspTextDocumentPositionParams);
#line 230 "../src/protocol.vala"
	switch (property_id) {
#line 230 "../src/protocol.vala"
		case LSP_TEXT_DOCUMENT_POSITION_PARAMS_TEXT_DOCUMENT_PROPERTY:
#line 230 "../src/protocol.vala"
		lsp_text_document_position_params_set_textDocument (self, g_value_get_object (value));
#line 230 "../src/protocol.vala"
		break;
#line 230 "../src/protocol.vala"
		case LSP_TEXT_DOCUMENT_POSITION_PARAMS_POSITION_PROPERTY:
#line 230 "../src/protocol.vala"
		lsp_text_document_position_params_set_position (self, g_value_get_object (value));
#line 230 "../src/protocol.vala"
		break;
#line 5735 "protocol.c"
		default:
#line 230 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 230 "../src/protocol.vala"
		break;
#line 5741 "protocol.c"
	}
}

static inline gpointer
lsp_reference_params_get_instance_private (LspReferenceParams* self)
{
	return G_STRUCT_MEMBER_P (self, LspReferenceParams_private_offset);
}

LspReferenceParams*
lsp_reference_params_construct (GType object_type)
{
	LspReferenceParams * self = NULL;
#line 235 "../src/protocol.vala"
	self = (LspReferenceParams*) lsp_text_document_position_params_construct (object_type);
#line 235 "../src/protocol.vala"
	return self;
#line 5759 "protocol.c"
}

LspReferenceParams*
lsp_reference_params_new (void)
{
#line 235 "../src/protocol.vala"
	return lsp_reference_params_construct (LSP_TYPE_REFERENCE_PARAMS);
#line 5767 "protocol.c"
}

LspReferenceParamsReferenceContext*
lsp_reference_params_get_context (LspReferenceParams* self)
{
	LspReferenceParamsReferenceContext* result;
	LspReferenceParamsReferenceContext* _tmp0_;
#line 239 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 239 "../src/protocol.vala"
	_tmp0_ = self->priv->_context;
#line 239 "../src/protocol.vala"
	result = _tmp0_;
#line 239 "../src/protocol.vala"
	return result;
#line 5783 "protocol.c"
}

void
lsp_reference_params_set_context (LspReferenceParams* self,
                                  LspReferenceParamsReferenceContext* value)
{
	LspReferenceParamsReferenceContext* old_value;
#line 239 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 239 "../src/protocol.vala"
	old_value = lsp_reference_params_get_context (self);
#line 239 "../src/protocol.vala"
	if (old_value != value) {
#line 5797 "protocol.c"
		LspReferenceParamsReferenceContext* _tmp0_;
#line 239 "../src/protocol.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 239 "../src/protocol.vala"
		_g_object_unref0 (self->priv->_context);
#line 239 "../src/protocol.vala"
		self->priv->_context = _tmp0_;
#line 239 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_reference_params_properties[LSP_REFERENCE_PARAMS_CONTEXT_PROPERTY]);
#line 5807 "protocol.c"
	}
}

static inline gpointer
lsp_reference_params_reference_context_get_instance_private (LspReferenceParamsReferenceContext* self)
{
	return G_STRUCT_MEMBER_P (self, LspReferenceParamsReferenceContext_private_offset);
}

LspReferenceParamsReferenceContext*
lsp_reference_params_reference_context_construct (GType object_type)
{
	LspReferenceParamsReferenceContext * self = NULL;
#line 236 "../src/protocol.vala"
	self = (LspReferenceParamsReferenceContext*) g_object_new (object_type, NULL);
#line 236 "../src/protocol.vala"
	return self;
#line 5825 "protocol.c"
}

LspReferenceParamsReferenceContext*
lsp_reference_params_reference_context_new (void)
{
#line 236 "../src/protocol.vala"
	return lsp_reference_params_reference_context_construct (LSP_REFERENCE_PARAMS_TYPE_REFERENCE_CONTEXT);
#line 5833 "protocol.c"
}

gboolean
lsp_reference_params_reference_context_get_includeDeclaration (LspReferenceParamsReferenceContext* self)
{
	gboolean result;
#line 237 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 237 "../src/protocol.vala"
	result = self->priv->_includeDeclaration;
#line 237 "../src/protocol.vala"
	return result;
#line 5846 "protocol.c"
}

void
lsp_reference_params_reference_context_set_includeDeclaration (LspReferenceParamsReferenceContext* self,
                                                               gboolean value)
{
	gboolean old_value;
#line 237 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 237 "../src/protocol.vala"
	old_value = lsp_reference_params_reference_context_get_includeDeclaration (self);
#line 237 "../src/protocol.vala"
	if (old_value != value) {
#line 237 "../src/protocol.vala"
		self->priv->_includeDeclaration = value;
#line 237 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_reference_params_reference_context_properties[LSP_REFERENCE_PARAMS_REFERENCE_CONTEXT_INCLUDE_DECLARATION_PROPERTY]);
#line 5864 "protocol.c"
	}
}

static void
lsp_reference_params_reference_context_class_init (LspReferenceParamsReferenceContextClass * klass,
                                                   gpointer klass_data)
{
#line 236 "../src/protocol.vala"
	lsp_reference_params_reference_context_parent_class = g_type_class_peek_parent (klass);
#line 236 "../src/protocol.vala"
	g_type_class_adjust_private_offset (klass, &LspReferenceParamsReferenceContext_private_offset);
#line 236 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_lsp_reference_params_reference_context_get_property;
#line 236 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_lsp_reference_params_reference_context_set_property;
#line 236 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->finalize = lsp_reference_params_reference_context_finalize;
#line 236 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_REFERENCE_PARAMS_REFERENCE_CONTEXT_INCLUDE_DECLARATION_PROPERTY, lsp_reference_params_reference_context_properties[LSP_REFERENCE_PARAMS_REFERENCE_CONTEXT_INCLUDE_DECLARATION_PROPERTY] = g_param_spec_boolean ("includeDeclaration", "includeDeclaration", "includeDeclaration", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 5884 "protocol.c"
}

static void
lsp_reference_params_reference_context_instance_init (LspReferenceParamsReferenceContext * self,
                                                      gpointer klass)
{
#line 236 "../src/protocol.vala"
	self->priv = lsp_reference_params_reference_context_get_instance_private (self);
#line 5893 "protocol.c"
}

static void
lsp_reference_params_reference_context_finalize (GObject * obj)
{
	LspReferenceParamsReferenceContext * self;
#line 236 "../src/protocol.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, LSP_REFERENCE_PARAMS_TYPE_REFERENCE_CONTEXT, LspReferenceParamsReferenceContext);
#line 236 "../src/protocol.vala"
	G_OBJECT_CLASS (lsp_reference_params_reference_context_parent_class)->finalize (obj);
#line 5904 "protocol.c"
}

 G_GNUC_NO_INLINE static GType
lsp_reference_params_reference_context_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (LspReferenceParamsReferenceContextClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) lsp_reference_params_reference_context_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LspReferenceParamsReferenceContext), 0, (GInstanceInitFunc) lsp_reference_params_reference_context_instance_init, NULL };
	GType lsp_reference_params_reference_context_type_id;
	lsp_reference_params_reference_context_type_id = g_type_register_static (G_TYPE_OBJECT, "LspReferenceParamsReferenceContext", &g_define_type_info, 0);
	LspReferenceParamsReferenceContext_private_offset = g_type_add_instance_private (lsp_reference_params_reference_context_type_id, sizeof (LspReferenceParamsReferenceContextPrivate));
	return lsp_reference_params_reference_context_type_id;
}

GType
lsp_reference_params_reference_context_get_type (void)
{
	static gsize lsp_reference_params_reference_context_type_id__once = 0;
	if (g_once_init_enter (&lsp_reference_params_reference_context_type_id__once)) {
		GType lsp_reference_params_reference_context_type_id;
		lsp_reference_params_reference_context_type_id = lsp_reference_params_reference_context_get_type_once ();
		g_once_init_leave (&lsp_reference_params_reference_context_type_id__once, lsp_reference_params_reference_context_type_id);
	}
	return lsp_reference_params_reference_context_type_id__once;
}

static void
_vala_lsp_reference_params_reference_context_get_property (GObject * object,
                                                           guint property_id,
                                                           GValue * value,
                                                           GParamSpec * pspec)
{
	LspReferenceParamsReferenceContext * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_REFERENCE_PARAMS_TYPE_REFERENCE_CONTEXT, LspReferenceParamsReferenceContext);
#line 236 "../src/protocol.vala"
	switch (property_id) {
#line 236 "../src/protocol.vala"
		case LSP_REFERENCE_PARAMS_REFERENCE_CONTEXT_INCLUDE_DECLARATION_PROPERTY:
#line 236 "../src/protocol.vala"
		g_value_set_boolean (value, lsp_reference_params_reference_context_get_includeDeclaration (self));
#line 236 "../src/protocol.vala"
		break;
#line 5945 "protocol.c"
		default:
#line 236 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 236 "../src/protocol.vala"
		break;
#line 5951 "protocol.c"
	}
}

static void
_vala_lsp_reference_params_reference_context_set_property (GObject * object,
                                                           guint property_id,
                                                           const GValue * value,
                                                           GParamSpec * pspec)
{
	LspReferenceParamsReferenceContext * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_REFERENCE_PARAMS_TYPE_REFERENCE_CONTEXT, LspReferenceParamsReferenceContext);
#line 236 "../src/protocol.vala"
	switch (property_id) {
#line 236 "../src/protocol.vala"
		case LSP_REFERENCE_PARAMS_REFERENCE_CONTEXT_INCLUDE_DECLARATION_PROPERTY:
#line 236 "../src/protocol.vala"
		lsp_reference_params_reference_context_set_includeDeclaration (self, g_value_get_boolean (value));
#line 236 "../src/protocol.vala"
		break;
#line 5971 "protocol.c"
		default:
#line 236 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 236 "../src/protocol.vala"
		break;
#line 5977 "protocol.c"
	}
}

static void
lsp_reference_params_class_init (LspReferenceParamsClass * klass,
                                 gpointer klass_data)
{
#line 235 "../src/protocol.vala"
	lsp_reference_params_parent_class = g_type_class_peek_parent (klass);
#line 235 "../src/protocol.vala"
	g_type_class_adjust_private_offset (klass, &LspReferenceParams_private_offset);
#line 235 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_lsp_reference_params_get_property;
#line 235 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_lsp_reference_params_set_property;
#line 235 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->finalize = lsp_reference_params_finalize;
#line 235 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_REFERENCE_PARAMS_CONTEXT_PROPERTY, lsp_reference_params_properties[LSP_REFERENCE_PARAMS_CONTEXT_PROPERTY] = g_param_spec_object ("context", "context", "context", LSP_REFERENCE_PARAMS_TYPE_REFERENCE_CONTEXT, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 5997 "protocol.c"
}

static void
lsp_reference_params_instance_init (LspReferenceParams * self,
                                    gpointer klass)
{
#line 235 "../src/protocol.vala"
	self->priv = lsp_reference_params_get_instance_private (self);
#line 6006 "protocol.c"
}

static void
lsp_reference_params_finalize (GObject * obj)
{
	LspReferenceParams * self;
#line 235 "../src/protocol.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, LSP_TYPE_REFERENCE_PARAMS, LspReferenceParams);
#line 239 "../src/protocol.vala"
	_g_object_unref0 (self->priv->_context);
#line 235 "../src/protocol.vala"
	G_OBJECT_CLASS (lsp_reference_params_parent_class)->finalize (obj);
#line 6019 "protocol.c"
}

 G_GNUC_NO_INLINE static GType
lsp_reference_params_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (LspReferenceParamsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) lsp_reference_params_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LspReferenceParams), 0, (GInstanceInitFunc) lsp_reference_params_instance_init, NULL };
	GType lsp_reference_params_type_id;
	lsp_reference_params_type_id = g_type_register_static (LSP_TYPE_TEXT_DOCUMENT_POSITION_PARAMS, "LspReferenceParams", &g_define_type_info, 0);
	LspReferenceParams_private_offset = g_type_add_instance_private (lsp_reference_params_type_id, sizeof (LspReferenceParamsPrivate));
	return lsp_reference_params_type_id;
}

GType
lsp_reference_params_get_type (void)
{
	static gsize lsp_reference_params_type_id__once = 0;
	if (g_once_init_enter (&lsp_reference_params_type_id__once)) {
		GType lsp_reference_params_type_id;
		lsp_reference_params_type_id = lsp_reference_params_get_type_once ();
		g_once_init_leave (&lsp_reference_params_type_id__once, lsp_reference_params_type_id);
	}
	return lsp_reference_params_type_id__once;
}

static void
_vala_lsp_reference_params_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec)
{
	LspReferenceParams * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_REFERENCE_PARAMS, LspReferenceParams);
#line 235 "../src/protocol.vala"
	switch (property_id) {
#line 235 "../src/protocol.vala"
		case LSP_REFERENCE_PARAMS_CONTEXT_PROPERTY:
#line 235 "../src/protocol.vala"
		g_value_set_object (value, lsp_reference_params_get_context (self));
#line 235 "../src/protocol.vala"
		break;
#line 6060 "protocol.c"
		default:
#line 235 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 235 "../src/protocol.vala"
		break;
#line 6066 "protocol.c"
	}
}

static void
_vala_lsp_reference_params_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec)
{
	LspReferenceParams * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_REFERENCE_PARAMS, LspReferenceParams);
#line 235 "../src/protocol.vala"
	switch (property_id) {
#line 235 "../src/protocol.vala"
		case LSP_REFERENCE_PARAMS_CONTEXT_PROPERTY:
#line 235 "../src/protocol.vala"
		lsp_reference_params_set_context (self, g_value_get_object (value));
#line 235 "../src/protocol.vala"
		break;
#line 6086 "protocol.c"
		default:
#line 235 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 235 "../src/protocol.vala"
		break;
#line 6092 "protocol.c"
	}
}

static inline gpointer
lsp_location_get_instance_private (LspLocation* self)
{
	return G_STRUCT_MEMBER_P (self, LspLocation_private_offset);
}

LspLocation*
lsp_location_construct_from_sourceref (GType object_type,
                                       ValaSourceReference* sref)
{
	LspLocation * self = NULL;
	ValaSourceFile* _tmp0_;
	ValaSourceFile* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	LspRange* _tmp4_;
	LspRange* _tmp5_;
#line 246 "../src/protocol.vala"
	g_return_val_if_fail (sref != NULL, NULL);
#line 247 "../src/protocol.vala"
	_tmp0_ = vala_source_reference_get_file (sref);
#line 247 "../src/protocol.vala"
	_tmp1_ = _tmp0_;
#line 247 "../src/protocol.vala"
	_tmp2_ = vala_source_file_get_filename (_tmp1_);
#line 247 "../src/protocol.vala"
	_tmp3_ = _tmp2_;
#line 247 "../src/protocol.vala"
	_tmp4_ = lsp_range_new_from_sourceref (sref);
#line 247 "../src/protocol.vala"
	if (_tmp4_) {
#line 247 "../src/protocol.vala"
		g_object_set_data ((GObject *) _tmp4_, "vala-creation-function", "Lsp.Location.from_sourceref");
#line 6129 "protocol.c"
	}
#line 247 "../src/protocol.vala"
	_tmp5_ = _tmp4_;
#line 247 "../src/protocol.vala"
	self = (LspLocation*) lsp_location_construct (object_type, _tmp3_, _tmp5_);
#line 247 "../src/protocol.vala"
	_g_object_unref0 (_tmp5_);
#line 246 "../src/protocol.vala"
	return self;
#line 6139 "protocol.c"
}

LspLocation*
lsp_location_new_from_sourceref (ValaSourceReference* sref)
{
#line 246 "../src/protocol.vala"
	return lsp_location_construct_from_sourceref (LSP_TYPE_LOCATION, sref);
#line 6147 "protocol.c"
}

LspLocation*
lsp_location_construct (GType object_type,
                        const gchar* filename,
                        LspRange* range)
{
	LspLocation * self = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 250 "../src/protocol.vala"
	g_return_val_if_fail (filename != NULL, NULL);
#line 250 "../src/protocol.vala"
	g_return_val_if_fail (range != NULL, NULL);
#line 250 "../src/protocol.vala"
	self = (LspLocation*) g_object_new (object_type, NULL);
#line 251 "../src/protocol.vala"
	_tmp0_ = g_file_new_for_commandline_arg (filename);
#line 251 "../src/protocol.vala"
	_tmp1_ = _tmp0_;
#line 251 "../src/protocol.vala"
	_tmp2_ = g_file_get_uri (_tmp1_);
#line 251 "../src/protocol.vala"
	_tmp3_ = _tmp2_;
#line 251 "../src/protocol.vala"
	lsp_location_set_uri (self, _tmp3_);
#line 251 "../src/protocol.vala"
	_g_free0 (_tmp3_);
#line 251 "../src/protocol.vala"
	_g_object_unref0 (_tmp1_);
#line 252 "../src/protocol.vala"
	lsp_location_set_range (self, range);
#line 250 "../src/protocol.vala"
	return self;
#line 6184 "protocol.c"
}

LspLocation*
lsp_location_new (const gchar* filename,
                  LspRange* range)
{
#line 250 "../src/protocol.vala"
	return lsp_location_construct (LSP_TYPE_LOCATION, filename, range);
#line 6193 "protocol.c"
}

const gchar*
lsp_location_get_uri (LspLocation* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 243 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 243 "../src/protocol.vala"
	_tmp0_ = self->priv->_uri;
#line 243 "../src/protocol.vala"
	result = _tmp0_;
#line 243 "../src/protocol.vala"
	return result;
#line 6209 "protocol.c"
}

void
lsp_location_set_uri (LspLocation* self,
                      const gchar* value)
{
	gchar* old_value;
#line 243 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 243 "../src/protocol.vala"
	old_value = lsp_location_get_uri (self);
#line 243 "../src/protocol.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 6223 "protocol.c"
		gchar* _tmp0_;
#line 243 "../src/protocol.vala"
		_tmp0_ = g_strdup (value);
#line 243 "../src/protocol.vala"
		_g_free0 (self->priv->_uri);
#line 243 "../src/protocol.vala"
		self->priv->_uri = _tmp0_;
#line 243 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_location_properties[LSP_LOCATION_URI_PROPERTY]);
#line 6233 "protocol.c"
	}
}

LspRange*
lsp_location_get_range (LspLocation* self)
{
	LspRange* result;
	LspRange* _tmp0_;
#line 244 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 244 "../src/protocol.vala"
	_tmp0_ = self->priv->_range;
#line 244 "../src/protocol.vala"
	result = _tmp0_;
#line 244 "../src/protocol.vala"
	return result;
#line 6250 "protocol.c"
}

void
lsp_location_set_range (LspLocation* self,
                        LspRange* value)
{
	LspRange* old_value;
#line 244 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 244 "../src/protocol.vala"
	old_value = lsp_location_get_range (self);
#line 244 "../src/protocol.vala"
	if (old_value != value) {
#line 6264 "protocol.c"
		LspRange* _tmp0_;
#line 244 "../src/protocol.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 244 "../src/protocol.vala"
		_g_object_unref0 (self->priv->_range);
#line 244 "../src/protocol.vala"
		self->priv->_range = _tmp0_;
#line 244 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_location_properties[LSP_LOCATION_RANGE_PROPERTY]);
#line 6274 "protocol.c"
	}
}

static void
lsp_location_class_init (LspLocationClass * klass,
                         gpointer klass_data)
{
#line 242 "../src/protocol.vala"
	lsp_location_parent_class = g_type_class_peek_parent (klass);
#line 242 "../src/protocol.vala"
	g_type_class_adjust_private_offset (klass, &LspLocation_private_offset);
#line 242 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_lsp_location_get_property;
#line 242 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_lsp_location_set_property;
#line 242 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->finalize = lsp_location_finalize;
#line 242 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_LOCATION_URI_PROPERTY, lsp_location_properties[LSP_LOCATION_URI_PROPERTY] = g_param_spec_string ("uri", "uri", "uri", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 242 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_LOCATION_RANGE_PROPERTY, lsp_location_properties[LSP_LOCATION_RANGE_PROPERTY] = g_param_spec_object ("range", "range", "range", LSP_TYPE_RANGE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 6296 "protocol.c"
}

static void
lsp_location_instance_init (LspLocation * self,
                            gpointer klass)
{
#line 242 "../src/protocol.vala"
	self->priv = lsp_location_get_instance_private (self);
#line 6305 "protocol.c"
}

static void
lsp_location_finalize (GObject * obj)
{
	LspLocation * self;
#line 242 "../src/protocol.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, LSP_TYPE_LOCATION, LspLocation);
#line 243 "../src/protocol.vala"
	_g_free0 (self->priv->_uri);
#line 244 "../src/protocol.vala"
	_g_object_unref0 (self->priv->_range);
#line 242 "../src/protocol.vala"
	G_OBJECT_CLASS (lsp_location_parent_class)->finalize (obj);
#line 6320 "protocol.c"
}

 G_GNUC_NO_INLINE static GType
lsp_location_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (LspLocationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) lsp_location_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LspLocation), 0, (GInstanceInitFunc) lsp_location_instance_init, NULL };
	GType lsp_location_type_id;
	lsp_location_type_id = g_type_register_static (G_TYPE_OBJECT, "LspLocation", &g_define_type_info, 0);
	LspLocation_private_offset = g_type_add_instance_private (lsp_location_type_id, sizeof (LspLocationPrivate));
	return lsp_location_type_id;
}

GType
lsp_location_get_type (void)
{
	static gsize lsp_location_type_id__once = 0;
	if (g_once_init_enter (&lsp_location_type_id__once)) {
		GType lsp_location_type_id;
		lsp_location_type_id = lsp_location_get_type_once ();
		g_once_init_leave (&lsp_location_type_id__once, lsp_location_type_id);
	}
	return lsp_location_type_id__once;
}

static void
_vala_lsp_location_get_property (GObject * object,
                                 guint property_id,
                                 GValue * value,
                                 GParamSpec * pspec)
{
	LspLocation * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_LOCATION, LspLocation);
#line 242 "../src/protocol.vala"
	switch (property_id) {
#line 242 "../src/protocol.vala"
		case LSP_LOCATION_URI_PROPERTY:
#line 242 "../src/protocol.vala"
		g_value_set_string (value, lsp_location_get_uri (self));
#line 242 "../src/protocol.vala"
		break;
#line 242 "../src/protocol.vala"
		case LSP_LOCATION_RANGE_PROPERTY:
#line 242 "../src/protocol.vala"
		g_value_set_object (value, lsp_location_get_range (self));
#line 242 "../src/protocol.vala"
		break;
#line 6367 "protocol.c"
		default:
#line 242 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 242 "../src/protocol.vala"
		break;
#line 6373 "protocol.c"
	}
}

static void
_vala_lsp_location_set_property (GObject * object,
                                 guint property_id,
                                 const GValue * value,
                                 GParamSpec * pspec)
{
	LspLocation * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_LOCATION, LspLocation);
#line 242 "../src/protocol.vala"
	switch (property_id) {
#line 242 "../src/protocol.vala"
		case LSP_LOCATION_URI_PROPERTY:
#line 242 "../src/protocol.vala"
		lsp_location_set_uri (self, g_value_get_string (value));
#line 242 "../src/protocol.vala"
		break;
#line 242 "../src/protocol.vala"
		case LSP_LOCATION_RANGE_PROPERTY:
#line 242 "../src/protocol.vala"
		lsp_location_set_range (self, g_value_get_object (value));
#line 242 "../src/protocol.vala"
		break;
#line 6399 "protocol.c"
		default:
#line 242 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 242 "../src/protocol.vala"
		break;
#line 6405 "protocol.c"
	}
}

 G_GNUC_NO_INLINE static GType
lsp_document_highlight_kind_get_type_once (void)
{
	static const GEnumValue values[] = {{LSP_DOCUMENT_HIGHLIGHT_KIND_Text, "LSP_DOCUMENT_HIGHLIGHT_KIND_Text", "text"}, {LSP_DOCUMENT_HIGHLIGHT_KIND_Read, "LSP_DOCUMENT_HIGHLIGHT_KIND_Read", "read"}, {LSP_DOCUMENT_HIGHLIGHT_KIND_Write, "LSP_DOCUMENT_HIGHLIGHT_KIND_Write", "write"}, {0, NULL, NULL}};
	GType lsp_document_highlight_kind_type_id;
	lsp_document_highlight_kind_type_id = g_enum_register_static ("LspDocumentHighlightKind", values);
	return lsp_document_highlight_kind_type_id;
}

GType
lsp_document_highlight_kind_get_type (void)
{
	static gsize lsp_document_highlight_kind_type_id__once = 0;
	if (g_once_init_enter (&lsp_document_highlight_kind_type_id__once)) {
		GType lsp_document_highlight_kind_type_id;
		lsp_document_highlight_kind_type_id = lsp_document_highlight_kind_get_type_once ();
		g_once_init_leave (&lsp_document_highlight_kind_type_id__once, lsp_document_highlight_kind_type_id);
	}
	return lsp_document_highlight_kind_type_id__once;
}

static inline gpointer
lsp_document_highlight_get_instance_private (LspDocumentHighlight* self)
{
	return G_STRUCT_MEMBER_P (self, LspDocumentHighlight_private_offset);
}

LspDocumentHighlight*
lsp_document_highlight_construct (GType object_type)
{
	LspDocumentHighlight * self = NULL;
#line 263 "../src/protocol.vala"
	self = (LspDocumentHighlight*) g_object_new (object_type, NULL);
#line 263 "../src/protocol.vala"
	return self;
#line 6444 "protocol.c"
}

LspDocumentHighlight*
lsp_document_highlight_new (void)
{
#line 263 "../src/protocol.vala"
	return lsp_document_highlight_construct (LSP_TYPE_DOCUMENT_HIGHLIGHT);
#line 6452 "protocol.c"
}

LspRange*
lsp_document_highlight_get_range (LspDocumentHighlight* self)
{
	LspRange* result;
	LspRange* _tmp0_;
#line 264 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 264 "../src/protocol.vala"
	_tmp0_ = self->priv->_range;
#line 264 "../src/protocol.vala"
	result = _tmp0_;
#line 264 "../src/protocol.vala"
	return result;
#line 6468 "protocol.c"
}

void
lsp_document_highlight_set_range (LspDocumentHighlight* self,
                                  LspRange* value)
{
	LspRange* old_value;
#line 264 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 264 "../src/protocol.vala"
	old_value = lsp_document_highlight_get_range (self);
#line 264 "../src/protocol.vala"
	if (old_value != value) {
#line 6482 "protocol.c"
		LspRange* _tmp0_;
#line 264 "../src/protocol.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 264 "../src/protocol.vala"
		_g_object_unref0 (self->priv->_range);
#line 264 "../src/protocol.vala"
		self->priv->_range = _tmp0_;
#line 264 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_document_highlight_properties[LSP_DOCUMENT_HIGHLIGHT_RANGE_PROPERTY]);
#line 6492 "protocol.c"
	}
}

LspDocumentHighlightKind
lsp_document_highlight_get_kind (LspDocumentHighlight* self)
{
	LspDocumentHighlightKind result;
#line 265 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, LSP_DOCUMENT_HIGHLIGHT_KIND_Text);
#line 265 "../src/protocol.vala"
	result = self->priv->_kind;
#line 265 "../src/protocol.vala"
	return result;
#line 6506 "protocol.c"
}

void
lsp_document_highlight_set_kind (LspDocumentHighlight* self,
                                 LspDocumentHighlightKind value)
{
	LspDocumentHighlightKind old_value;
#line 265 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 265 "../src/protocol.vala"
	old_value = lsp_document_highlight_get_kind (self);
#line 265 "../src/protocol.vala"
	if (old_value != value) {
#line 265 "../src/protocol.vala"
		self->priv->_kind = value;
#line 265 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_document_highlight_properties[LSP_DOCUMENT_HIGHLIGHT_KIND_PROPERTY]);
#line 6524 "protocol.c"
	}
}

static void
lsp_document_highlight_class_init (LspDocumentHighlightClass * klass,
                                   gpointer klass_data)
{
#line 263 "../src/protocol.vala"
	lsp_document_highlight_parent_class = g_type_class_peek_parent (klass);
#line 263 "../src/protocol.vala"
	g_type_class_adjust_private_offset (klass, &LspDocumentHighlight_private_offset);
#line 263 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_lsp_document_highlight_get_property;
#line 263 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_lsp_document_highlight_set_property;
#line 263 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->finalize = lsp_document_highlight_finalize;
#line 263 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_DOCUMENT_HIGHLIGHT_RANGE_PROPERTY, lsp_document_highlight_properties[LSP_DOCUMENT_HIGHLIGHT_RANGE_PROPERTY] = g_param_spec_object ("range", "range", "range", LSP_TYPE_RANGE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 263 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_DOCUMENT_HIGHLIGHT_KIND_PROPERTY, lsp_document_highlight_properties[LSP_DOCUMENT_HIGHLIGHT_KIND_PROPERTY] = g_param_spec_enum ("kind", "kind", "kind", LSP_TYPE_DOCUMENT_HIGHLIGHT_KIND, LSP_DOCUMENT_HIGHLIGHT_KIND_Text, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 6546 "protocol.c"
}

static void
lsp_document_highlight_instance_init (LspDocumentHighlight * self,
                                      gpointer klass)
{
#line 263 "../src/protocol.vala"
	self->priv = lsp_document_highlight_get_instance_private (self);
#line 6555 "protocol.c"
}

static void
lsp_document_highlight_finalize (GObject * obj)
{
	LspDocumentHighlight * self;
#line 263 "../src/protocol.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, LSP_TYPE_DOCUMENT_HIGHLIGHT, LspDocumentHighlight);
#line 264 "../src/protocol.vala"
	_g_object_unref0 (self->priv->_range);
#line 263 "../src/protocol.vala"
	G_OBJECT_CLASS (lsp_document_highlight_parent_class)->finalize (obj);
#line 6568 "protocol.c"
}

 G_GNUC_NO_INLINE static GType
lsp_document_highlight_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (LspDocumentHighlightClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) lsp_document_highlight_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LspDocumentHighlight), 0, (GInstanceInitFunc) lsp_document_highlight_instance_init, NULL };
	GType lsp_document_highlight_type_id;
	lsp_document_highlight_type_id = g_type_register_static (G_TYPE_OBJECT, "LspDocumentHighlight", &g_define_type_info, 0);
	LspDocumentHighlight_private_offset = g_type_add_instance_private (lsp_document_highlight_type_id, sizeof (LspDocumentHighlightPrivate));
	return lsp_document_highlight_type_id;
}

GType
lsp_document_highlight_get_type (void)
{
	static gsize lsp_document_highlight_type_id__once = 0;
	if (g_once_init_enter (&lsp_document_highlight_type_id__once)) {
		GType lsp_document_highlight_type_id;
		lsp_document_highlight_type_id = lsp_document_highlight_get_type_once ();
		g_once_init_leave (&lsp_document_highlight_type_id__once, lsp_document_highlight_type_id);
	}
	return lsp_document_highlight_type_id__once;
}

static void
_vala_lsp_document_highlight_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec)
{
	LspDocumentHighlight * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_DOCUMENT_HIGHLIGHT, LspDocumentHighlight);
#line 263 "../src/protocol.vala"
	switch (property_id) {
#line 263 "../src/protocol.vala"
		case LSP_DOCUMENT_HIGHLIGHT_RANGE_PROPERTY:
#line 263 "../src/protocol.vala"
		g_value_set_object (value, lsp_document_highlight_get_range (self));
#line 263 "../src/protocol.vala"
		break;
#line 263 "../src/protocol.vala"
		case LSP_DOCUMENT_HIGHLIGHT_KIND_PROPERTY:
#line 263 "../src/protocol.vala"
		g_value_set_enum (value, lsp_document_highlight_get_kind (self));
#line 263 "../src/protocol.vala"
		break;
#line 6615 "protocol.c"
		default:
#line 263 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 263 "../src/protocol.vala"
		break;
#line 6621 "protocol.c"
	}
}

static void
_vala_lsp_document_highlight_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec)
{
	LspDocumentHighlight * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_DOCUMENT_HIGHLIGHT, LspDocumentHighlight);
#line 263 "../src/protocol.vala"
	switch (property_id) {
#line 263 "../src/protocol.vala"
		case LSP_DOCUMENT_HIGHLIGHT_RANGE_PROPERTY:
#line 263 "../src/protocol.vala"
		lsp_document_highlight_set_range (self, g_value_get_object (value));
#line 263 "../src/protocol.vala"
		break;
#line 263 "../src/protocol.vala"
		case LSP_DOCUMENT_HIGHLIGHT_KIND_PROPERTY:
#line 263 "../src/protocol.vala"
		lsp_document_highlight_set_kind (self, g_value_get_enum (value));
#line 263 "../src/protocol.vala"
		break;
#line 6647 "protocol.c"
		default:
#line 263 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 263 "../src/protocol.vala"
		break;
#line 6653 "protocol.c"
	}
}

static inline gpointer
lsp_document_symbol_params_get_instance_private (LspDocumentSymbolParams* self)
{
	return G_STRUCT_MEMBER_P (self, LspDocumentSymbolParams_private_offset);
}

LspDocumentSymbolParams*
lsp_document_symbol_params_construct (GType object_type)
{
	LspDocumentSymbolParams * self = NULL;
#line 268 "../src/protocol.vala"
	self = (LspDocumentSymbolParams*) g_object_new (object_type, NULL);
#line 268 "../src/protocol.vala"
	return self;
#line 6671 "protocol.c"
}

LspDocumentSymbolParams*
lsp_document_symbol_params_new (void)
{
#line 268 "../src/protocol.vala"
	return lsp_document_symbol_params_construct (LSP_TYPE_DOCUMENT_SYMBOL_PARAMS);
#line 6679 "protocol.c"
}

LspTextDocumentIdentifier*
lsp_document_symbol_params_get_textDocument (LspDocumentSymbolParams* self)
{
	LspTextDocumentIdentifier* result;
	LspTextDocumentIdentifier* _tmp0_;
#line 269 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 269 "../src/protocol.vala"
	_tmp0_ = self->priv->_textDocument;
#line 269 "../src/protocol.vala"
	result = _tmp0_;
#line 269 "../src/protocol.vala"
	return result;
#line 6695 "protocol.c"
}

void
lsp_document_symbol_params_set_textDocument (LspDocumentSymbolParams* self,
                                             LspTextDocumentIdentifier* value)
{
	LspTextDocumentIdentifier* old_value;
#line 269 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 269 "../src/protocol.vala"
	old_value = lsp_document_symbol_params_get_textDocument (self);
#line 269 "../src/protocol.vala"
	if (old_value != value) {
#line 6709 "protocol.c"
		LspTextDocumentIdentifier* _tmp0_;
#line 269 "../src/protocol.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 269 "../src/protocol.vala"
		_g_object_unref0 (self->priv->_textDocument);
#line 269 "../src/protocol.vala"
		self->priv->_textDocument = _tmp0_;
#line 269 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_document_symbol_params_properties[LSP_DOCUMENT_SYMBOL_PARAMS_TEXT_DOCUMENT_PROPERTY]);
#line 6719 "protocol.c"
	}
}

static void
lsp_document_symbol_params_class_init (LspDocumentSymbolParamsClass * klass,
                                       gpointer klass_data)
{
#line 268 "../src/protocol.vala"
	lsp_document_symbol_params_parent_class = g_type_class_peek_parent (klass);
#line 268 "../src/protocol.vala"
	g_type_class_adjust_private_offset (klass, &LspDocumentSymbolParams_private_offset);
#line 268 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_lsp_document_symbol_params_get_property;
#line 268 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_lsp_document_symbol_params_set_property;
#line 268 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->finalize = lsp_document_symbol_params_finalize;
#line 268 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_DOCUMENT_SYMBOL_PARAMS_TEXT_DOCUMENT_PROPERTY, lsp_document_symbol_params_properties[LSP_DOCUMENT_SYMBOL_PARAMS_TEXT_DOCUMENT_PROPERTY] = g_param_spec_object ("textDocument", "textDocument", "textDocument", LSP_TYPE_TEXT_DOCUMENT_IDENTIFIER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 6739 "protocol.c"
}

static void
lsp_document_symbol_params_instance_init (LspDocumentSymbolParams * self,
                                          gpointer klass)
{
#line 268 "../src/protocol.vala"
	self->priv = lsp_document_symbol_params_get_instance_private (self);
#line 6748 "protocol.c"
}

static void
lsp_document_symbol_params_finalize (GObject * obj)
{
	LspDocumentSymbolParams * self;
#line 268 "../src/protocol.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, LSP_TYPE_DOCUMENT_SYMBOL_PARAMS, LspDocumentSymbolParams);
#line 269 "../src/protocol.vala"
	_g_object_unref0 (self->priv->_textDocument);
#line 268 "../src/protocol.vala"
	G_OBJECT_CLASS (lsp_document_symbol_params_parent_class)->finalize (obj);
#line 6761 "protocol.c"
}

 G_GNUC_NO_INLINE static GType
lsp_document_symbol_params_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (LspDocumentSymbolParamsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) lsp_document_symbol_params_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LspDocumentSymbolParams), 0, (GInstanceInitFunc) lsp_document_symbol_params_instance_init, NULL };
	GType lsp_document_symbol_params_type_id;
	lsp_document_symbol_params_type_id = g_type_register_static (G_TYPE_OBJECT, "LspDocumentSymbolParams", &g_define_type_info, 0);
	LspDocumentSymbolParams_private_offset = g_type_add_instance_private (lsp_document_symbol_params_type_id, sizeof (LspDocumentSymbolParamsPrivate));
	return lsp_document_symbol_params_type_id;
}

GType
lsp_document_symbol_params_get_type (void)
{
	static gsize lsp_document_symbol_params_type_id__once = 0;
	if (g_once_init_enter (&lsp_document_symbol_params_type_id__once)) {
		GType lsp_document_symbol_params_type_id;
		lsp_document_symbol_params_type_id = lsp_document_symbol_params_get_type_once ();
		g_once_init_leave (&lsp_document_symbol_params_type_id__once, lsp_document_symbol_params_type_id);
	}
	return lsp_document_symbol_params_type_id__once;
}

static void
_vala_lsp_document_symbol_params_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec)
{
	LspDocumentSymbolParams * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_DOCUMENT_SYMBOL_PARAMS, LspDocumentSymbolParams);
#line 268 "../src/protocol.vala"
	switch (property_id) {
#line 268 "../src/protocol.vala"
		case LSP_DOCUMENT_SYMBOL_PARAMS_TEXT_DOCUMENT_PROPERTY:
#line 268 "../src/protocol.vala"
		g_value_set_object (value, lsp_document_symbol_params_get_textDocument (self));
#line 268 "../src/protocol.vala"
		break;
#line 6802 "protocol.c"
		default:
#line 268 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 268 "../src/protocol.vala"
		break;
#line 6808 "protocol.c"
	}
}

static void
_vala_lsp_document_symbol_params_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec)
{
	LspDocumentSymbolParams * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_DOCUMENT_SYMBOL_PARAMS, LspDocumentSymbolParams);
#line 268 "../src/protocol.vala"
	switch (property_id) {
#line 268 "../src/protocol.vala"
		case LSP_DOCUMENT_SYMBOL_PARAMS_TEXT_DOCUMENT_PROPERTY:
#line 268 "../src/protocol.vala"
		lsp_document_symbol_params_set_textDocument (self, g_value_get_object (value));
#line 268 "../src/protocol.vala"
		break;
#line 6828 "protocol.c"
		default:
#line 268 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 268 "../src/protocol.vala"
		break;
#line 6834 "protocol.c"
	}
}

static inline gpointer
lsp_document_symbol_get_instance_private (LspDocumentSymbol* self)
{
	return G_STRUCT_MEMBER_P (self, LspDocumentSymbol_private_offset);
}

static LspDocumentSymbol*
lsp_document_symbol_construct (GType object_type)
{
	LspDocumentSymbol * self = NULL;
#line 291 "../src/protocol.vala"
	self = (LspDocumentSymbol*) g_object_new (object_type, NULL);
#line 291 "../src/protocol.vala"
	return self;
#line 6852 "protocol.c"
}

static LspDocumentSymbol*
lsp_document_symbol_new (void)
{
#line 291 "../src/protocol.vala"
	return lsp_document_symbol_construct (LSP_TYPE_DOCUMENT_SYMBOL);
#line 6860 "protocol.c"
}

/**
         * @param type the data type containing this symbol, if there was one (not available for Namespaces, for example)
         * @param sym the symbol
         */
static gpointer
_vala_code_node_ref0 (gpointer self)
{
#line 301 "../src/protocol.vala"
	return self ? vala_code_node_ref (self) : NULL;
#line 6872 "protocol.c"
}

static gpointer
_vala_source_reference_ref0 (gpointer self)
{
#line 302 "../src/protocol.vala"
	return self ? vala_source_reference_ref (self) : NULL;
#line 6880 "protocol.c"
}

LspDocumentSymbol*
lsp_document_symbol_construct_from_vala_symbol (GType object_type,
                                                ValaDataType* type,
                                                ValaSymbol* sym,
                                                LspSymbolKind kind)
{
	LspDocumentSymbol * self = NULL;
	const gchar* _tmp0_ = NULL;
	ValaSymbol* _tmp1_;
	ValaSymbol* _tmp2_;
	gchar* _tmp7_;
	ValaSourceReference* _tmp8_;
	ValaSourceReference* _tmp9_;
	LspRange* _tmp10_;
	const gchar* _tmp51_;
	const gchar* _tmp52_;
	gchar* _tmp53_;
	gchar* _tmp54_;
	ValaSourceReference* _tmp55_;
	ValaSourceReference* _tmp56_;
	LspRange* _tmp57_;
	LspRange* _tmp58_;
	ValaVersionAttribute* _tmp59_;
	ValaVersionAttribute* _tmp60_;
	gboolean _tmp61_;
	gboolean _tmp62_;
#line 297 "../src/protocol.vala"
	g_return_val_if_fail (sym != NULL, NULL);
#line 297 "../src/protocol.vala"
	self = (LspDocumentSymbol*) g_object_new (object_type, NULL);
#line 298 "../src/protocol.vala"
	_tmp1_ = vala_symbol_get_parent_symbol (sym);
#line 298 "../src/protocol.vala"
	_tmp2_ = _tmp1_;
#line 298 "../src/protocol.vala"
	if (_tmp2_ != NULL) {
#line 6919 "protocol.c"
		ValaSymbol* _tmp3_;
		ValaSymbol* _tmp4_;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
#line 298 "../src/protocol.vala"
		_tmp3_ = vala_symbol_get_parent_symbol (sym);
#line 298 "../src/protocol.vala"
		_tmp4_ = _tmp3_;
#line 298 "../src/protocol.vala"
		_tmp5_ = vala_symbol_get_name (_tmp4_);
#line 298 "../src/protocol.vala"
		_tmp6_ = _tmp5_;
#line 298 "../src/protocol.vala"
		_tmp0_ = _tmp6_;
#line 6934 "protocol.c"
	} else {
#line 298 "../src/protocol.vala"
		_tmp0_ = NULL;
#line 6938 "protocol.c"
	}
#line 298 "../src/protocol.vala"
	_tmp7_ = g_strdup (_tmp0_);
#line 298 "../src/protocol.vala"
	_g_free0 (self->parent_name);
#line 298 "../src/protocol.vala"
	self->parent_name = _tmp7_;
#line 299 "../src/protocol.vala"
	_tmp8_ = vala_code_node_get_source_reference ((ValaCodeNode*) sym);
#line 299 "../src/protocol.vala"
	_tmp9_ = _tmp8_;
#line 299 "../src/protocol.vala"
	_tmp10_ = lsp_range_new_from_sourceref (_tmp9_);
#line 299 "../src/protocol.vala"
	if (_tmp10_) {
#line 299 "../src/protocol.vala"
		g_object_set_data ((GObject *) _tmp10_, "vala-creation-function", "Lsp.DocumentSymbol.from_vala_symbol");
#line 6956 "protocol.c"
	}
#line 299 "../src/protocol.vala"
	_g_object_unref0 (self->priv->_initial_range);
#line 299 "../src/protocol.vala"
	self->priv->_initial_range = _tmp10_;
#line 300 "../src/protocol.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (sym, VALA_TYPE_SUBROUTINE)) {
#line 6964 "protocol.c"
		ValaSubroutine* sub = NULL;
		ValaSubroutine* _tmp11_;
		ValaSourceReference* _tmp12_ = NULL;
		ValaSubroutine* _tmp13_;
		ValaBlock* _tmp14_;
		ValaBlock* _tmp15_;
		ValaSourceReference* body_sref = NULL;
		ValaSourceReference* _tmp21_;
		gboolean _tmp22_ = FALSE;
		ValaSourceReference* _tmp23_;
#line 301 "../src/protocol.vala"
		_tmp11_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (sym, VALA_TYPE_SUBROUTINE, ValaSubroutine));
#line 301 "../src/protocol.vala"
		sub = _tmp11_;
#line 302 "../src/protocol.vala"
		_tmp13_ = sub;
#line 302 "../src/protocol.vala"
		_tmp14_ = vala_subroutine_get_body (_tmp13_);
#line 302 "../src/protocol.vala"
		_tmp15_ = _tmp14_;
#line 302 "../src/protocol.vala"
		if (_tmp15_ != NULL) {
#line 6987 "protocol.c"
			ValaSubroutine* _tmp16_;
			ValaBlock* _tmp17_;
			ValaBlock* _tmp18_;
			ValaSourceReference* _tmp19_;
			ValaSourceReference* _tmp20_;
#line 302 "../src/protocol.vala"
			_tmp16_ = sub;
#line 302 "../src/protocol.vala"
			_tmp17_ = vala_subroutine_get_body (_tmp16_);
#line 302 "../src/protocol.vala"
			_tmp18_ = _tmp17_;
#line 302 "../src/protocol.vala"
			_tmp19_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp18_);
#line 302 "../src/protocol.vala"
			_tmp20_ = _tmp19_;
#line 302 "../src/protocol.vala"
			_tmp12_ = _tmp20_;
#line 7005 "protocol.c"
		} else {
#line 302 "../src/protocol.vala"
			_tmp12_ = NULL;
#line 7009 "protocol.c"
		}
#line 302 "../src/protocol.vala"
		_tmp21_ = _vala_source_reference_ref0 (_tmp12_);
#line 302 "../src/protocol.vala"
		body_sref = _tmp21_;
#line 305 "../src/protocol.vala"
		_tmp23_ = body_sref;
#line 305 "../src/protocol.vala"
		if (_tmp23_ != NULL) {
#line 7019 "protocol.c"
			gboolean _tmp24_ = FALSE;
			ValaSourceReference* _tmp25_;
			ValaSourceLocation _tmp26_ = {0};
			ValaSourceLocation _tmp27_;
			ValaSourceReference* _tmp28_;
			ValaSourceLocation _tmp29_ = {0};
			ValaSourceLocation _tmp30_;
#line 305 "../src/protocol.vala"
			_tmp25_ = body_sref;
#line 305 "../src/protocol.vala"
			vala_source_reference_get_begin (_tmp25_, &_tmp26_);
#line 305 "../src/protocol.vala"
			_tmp27_ = _tmp26_;
#line 305 "../src/protocol.vala"
			_tmp28_ = body_sref;
#line 305 "../src/protocol.vala"
			vala_source_reference_get_end (_tmp28_, &_tmp29_);
#line 305 "../src/protocol.vala"
			_tmp30_ = _tmp29_;
#line 305 "../src/protocol.vala"
			if (_tmp27_.line < _tmp30_.line) {
#line 305 "../src/protocol.vala"
				_tmp24_ = TRUE;
#line 7043 "protocol.c"
			} else {
				gboolean _tmp31_ = FALSE;
				ValaSourceReference* _tmp32_;
				ValaSourceLocation _tmp33_ = {0};
				ValaSourceLocation _tmp34_;
				ValaSourceReference* _tmp35_;
				ValaSourceLocation _tmp36_ = {0};
				ValaSourceLocation _tmp37_;
#line 306 "../src/protocol.vala"
				_tmp32_ = body_sref;
#line 306 "../src/protocol.vala"
				vala_source_reference_get_begin (_tmp32_, &_tmp33_);
#line 306 "../src/protocol.vala"
				_tmp34_ = _tmp33_;
#line 306 "../src/protocol.vala"
				_tmp35_ = body_sref;
#line 306 "../src/protocol.vala"
				vala_source_reference_get_end (_tmp35_, &_tmp36_);
#line 306 "../src/protocol.vala"
				_tmp37_ = _tmp36_;
#line 306 "../src/protocol.vala"
				if (_tmp34_.line == _tmp37_.line) {
#line 7066 "protocol.c"
					ValaSourceReference* _tmp38_;
					ValaSourceLocation _tmp39_ = {0};
					ValaSourceLocation _tmp40_;
					gchar* _tmp41_;
					ValaSourceReference* _tmp42_;
					ValaSourceLocation _tmp43_ = {0};
					ValaSourceLocation _tmp44_;
					gchar* _tmp45_;
#line 306 "../src/protocol.vala"
					_tmp38_ = body_sref;
#line 306 "../src/protocol.vala"
					vala_source_reference_get_begin (_tmp38_, &_tmp39_);
#line 306 "../src/protocol.vala"
					_tmp40_ = _tmp39_;
#line 306 "../src/protocol.vala"
					_tmp41_ = _tmp40_.pos;
#line 306 "../src/protocol.vala"
					_tmp42_ = body_sref;
#line 306 "../src/protocol.vala"
					vala_source_reference_get_end (_tmp42_, &_tmp43_);
#line 306 "../src/protocol.vala"
					_tmp44_ = _tmp43_;
#line 306 "../src/protocol.vala"
					_tmp45_ = _tmp44_.pos;
#line 306 "../src/protocol.vala"
					_tmp31_ = _tmp41_ <= _tmp45_;
#line 7093 "protocol.c"
				} else {
#line 306 "../src/protocol.vala"
					_tmp31_ = FALSE;
#line 7097 "protocol.c"
				}
#line 306 "../src/protocol.vala"
				_tmp24_ = _tmp31_;
#line 7101 "protocol.c"
			}
#line 305 "../src/protocol.vala"
			_tmp22_ = _tmp24_;
#line 7105 "protocol.c"
		} else {
#line 305 "../src/protocol.vala"
			_tmp22_ = FALSE;
#line 7109 "protocol.c"
		}
#line 305 "../src/protocol.vala"
		if (_tmp22_) {
#line 7113 "protocol.c"
			LspRange* _tmp46_;
			ValaSourceReference* _tmp47_;
			LspRange* _tmp48_;
			LspRange* _tmp49_;
			LspRange* _tmp50_;
#line 307 "../src/protocol.vala"
			_tmp46_ = self->priv->_initial_range;
#line 307 "../src/protocol.vala"
			_tmp47_ = body_sref;
#line 307 "../src/protocol.vala"
			_tmp48_ = lsp_range_new_from_sourceref (_tmp47_);
#line 307 "../src/protocol.vala"
			if (_tmp48_) {
#line 307 "../src/protocol.vala"
				g_object_set_data ((GObject *) _tmp48_, "vala-creation-function", "Lsp.DocumentSymbol.from_vala_symbol");
#line 7129 "protocol.c"
			}
#line 307 "../src/protocol.vala"
			_tmp49_ = _tmp48_;
#line 307 "../src/protocol.vala"
			_tmp50_ = lsp_range_union (_tmp46_, _tmp49_);
#line 307 "../src/protocol.vala"
			_g_object_unref0 (self->priv->_initial_range);
#line 307 "../src/protocol.vala"
			self->priv->_initial_range = _tmp50_;
#line 307 "../src/protocol.vala"
			_g_object_unref0 (_tmp49_);
#line 7141 "protocol.c"
		}
#line 300 "../src/protocol.vala"
		_vala_source_reference_unref0 (body_sref);
#line 300 "../src/protocol.vala"
		_vala_code_node_unref0 (sub);
#line 7147 "protocol.c"
	}
#line 310 "../src/protocol.vala"
	_tmp51_ = vala_symbol_get_name (sym);
#line 310 "../src/protocol.vala"
	_tmp52_ = _tmp51_;
#line 310 "../src/protocol.vala"
	lsp_document_symbol_set_name (self, _tmp52_);
#line 311 "../src/protocol.vala"
	_tmp53_ = vls_code_help_get_symbol_representation (type, sym, NULL, FALSE, NULL, NULL, TRUE, FALSE, NULL, TRUE);
#line 311 "../src/protocol.vala"
	_tmp54_ = _tmp53_;
#line 311 "../src/protocol.vala"
	lsp_document_symbol_set_detail (self, _tmp54_);
#line 311 "../src/protocol.vala"
	_g_free0 (_tmp54_);
#line 312 "../src/protocol.vala"
	lsp_document_symbol_set_kind (self, kind);
#line 313 "../src/protocol.vala"
	_tmp55_ = vala_code_node_get_source_reference ((ValaCodeNode*) sym);
#line 313 "../src/protocol.vala"
	_tmp56_ = _tmp55_;
#line 313 "../src/protocol.vala"
	_tmp57_ = lsp_range_new_from_sourceref (_tmp56_);
#line 313 "../src/protocol.vala"
	if (_tmp57_) {
#line 313 "../src/protocol.vala"
		g_object_set_data ((GObject *) _tmp57_, "vala-creation-function", "Lsp.DocumentSymbol.from_vala_symbol");
#line 7175 "protocol.c"
	}
#line 313 "../src/protocol.vala"
	_tmp58_ = _tmp57_;
#line 313 "../src/protocol.vala"
	lsp_document_symbol_set_selectionRange (self, _tmp58_);
#line 313 "../src/protocol.vala"
	_g_object_unref0 (_tmp58_);
#line 314 "../src/protocol.vala"
	_tmp59_ = vala_symbol_get_version (sym);
#line 314 "../src/protocol.vala"
	_tmp60_ = _tmp59_;
#line 314 "../src/protocol.vala"
	_tmp61_ = vala_version_attribute_get_deprecated (_tmp60_);
#line 314 "../src/protocol.vala"
	_tmp62_ = _tmp61_;
#line 314 "../src/protocol.vala"
	lsp_document_symbol_set_deprecated (self, _tmp62_);
#line 297 "../src/protocol.vala"
	return self;
#line 7195 "protocol.c"
}

LspDocumentSymbol*
lsp_document_symbol_new_from_vala_symbol (ValaDataType* type,
                                          ValaSymbol* sym,
                                          LspSymbolKind kind)
{
#line 297 "../src/protocol.vala"
	return lsp_document_symbol_construct_from_vala_symbol (LSP_TYPE_DOCUMENT_SYMBOL, type, sym, kind);
#line 7205 "protocol.c"
}

static void
lsp_document_symbol_real_json_serializable_set_property (JsonSerializable* base,
                                                         GParamSpec* pspec,
                                                         GValue* value)
{
	LspDocumentSymbol * self;
	const gchar* _tmp0_;
	GValue _tmp1_;
#line 317 "../src/protocol.vala"
	self = (LspDocumentSymbol*) base;
#line 317 "../src/protocol.vala"
	g_return_if_fail (pspec != NULL);
#line 317 "../src/protocol.vala"
	g_return_if_fail (value != NULL);
#line 318 "../src/protocol.vala"
	_tmp0_ = g_param_spec_get_name (pspec);
#line 318 "../src/protocol.vala"
	_tmp1_ = *value;
#line 318 "../src/protocol.vala"
	g_object_set_property (G_TYPE_CHECK_INSTANCE_CAST (self, G_TYPE_OBJECT, GObject), _tmp0_, &_tmp1_);
#line 7228 "protocol.c"
}

static void
lsp_document_symbol_real_json_serializable_get_property (JsonSerializable* base,
                                                         GParamSpec* pspec,
                                                         GValue* result)
{
	LspDocumentSymbol * self;
	GValue val = {0};
	GValue _tmp0_ = {0};
	const gchar* _tmp1_;
#line 321 "../src/protocol.vala"
	self = (LspDocumentSymbol*) base;
#line 321 "../src/protocol.vala"
	g_return_if_fail (pspec != NULL);
#line 322 "../src/protocol.vala"
	g_value_init (&_tmp0_, pspec->value_type);
#line 322 "../src/protocol.vala"
	val = _tmp0_;
#line 323 "../src/protocol.vala"
	_tmp1_ = g_param_spec_get_name (pspec);
#line 323 "../src/protocol.vala"
	g_object_get_property (G_TYPE_CHECK_INSTANCE_CAST (self, G_TYPE_OBJECT, GObject), _tmp1_, &val);
#line 324 "../src/protocol.vala"
	*result = val;
#line 324 "../src/protocol.vala"
	return;
#line 7256 "protocol.c"
}

static GParamSpec*
lsp_document_symbol_real_find_property (JsonSerializable* base,
                                        const gchar* name)
{
	LspDocumentSymbol * self;
	GObjectClass* _tmp0_;
	GParamSpec* _tmp1_;
	GParamSpec* result;
#line 327 "../src/protocol.vala"
	self = (LspDocumentSymbol*) base;
#line 327 "../src/protocol.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 328 "../src/protocol.vala"
	_tmp0_ = G_OBJECT_GET_CLASS ((GObject*) self);
#line 328 "../src/protocol.vala"
	_tmp1_ = g_object_class_find_property (_tmp0_, name);
#line 328 "../src/protocol.vala"
	result = _tmp1_;
#line 328 "../src/protocol.vala"
	return result;
#line 7279 "protocol.c"
}

static gpointer
_json_array_ref0 (gpointer self)
{
#line 336 "../src/protocol.vala"
	return self ? json_array_ref (self) : NULL;
#line 7287 "protocol.c"
}

static JsonNode*
lsp_document_symbol_real_serialize_property (JsonSerializable* base,
                                             const gchar* property_name,
                                             GValue* value,
                                             GParamSpec* pspec)
{
	LspDocumentSymbol * self;
	JsonNode* node = NULL;
	JsonNode* _tmp2_;
	JsonNode* _tmp3_;
	JsonArray* _tmp4_;
	JsonArray* _tmp5_;
	JsonArray* array = NULL;
	JsonNode* _tmp6_;
	JsonArray* _tmp7_;
	JsonArray* _tmp8_;
	JsonNode* result;
#line 331 "../src/protocol.vala"
	self = (LspDocumentSymbol*) base;
#line 331 "../src/protocol.vala"
	g_return_val_if_fail (property_name != NULL, NULL);
#line 331 "../src/protocol.vala"
	g_return_val_if_fail (value != NULL, NULL);
#line 331 "../src/protocol.vala"
	g_return_val_if_fail (pspec != NULL, NULL);
#line 332 "../src/protocol.vala"
	if (g_strcmp0 (property_name, "children") != 0) {
#line 7317 "protocol.c"
		GValue _tmp0_;
		JsonNode* _tmp1_;
#line 333 "../src/protocol.vala"
		_tmp0_ = *value;
#line 333 "../src/protocol.vala"
		_tmp1_ = json_serializable_default_serialize_property ((JsonSerializable*) self, property_name, &_tmp0_, pspec);
#line 333 "../src/protocol.vala"
		result = _tmp1_;
#line 333 "../src/protocol.vala"
		return result;
#line 7328 "protocol.c"
	}
#line 334 "../src/protocol.vala"
	_tmp2_ = json_node_new (JSON_NODE_ARRAY);
#line 334 "../src/protocol.vala"
	node = _tmp2_;
#line 335 "../src/protocol.vala"
	_tmp3_ = node;
#line 335 "../src/protocol.vala"
	_tmp4_ = json_array_new ();
#line 335 "../src/protocol.vala"
	_tmp5_ = _tmp4_;
#line 335 "../src/protocol.vala"
	json_node_init_array (_tmp3_, _tmp5_);
#line 335 "../src/protocol.vala"
	_json_array_unref0 (_tmp5_);
#line 336 "../src/protocol.vala"
	_tmp6_ = node;
#line 336 "../src/protocol.vala"
	_tmp7_ = json_node_get_array (_tmp6_);
#line 336 "../src/protocol.vala"
	_tmp8_ = _json_array_ref0 (_tmp7_);
#line 336 "../src/protocol.vala"
	array = _tmp8_;
#line 7352 "protocol.c"
	{
		GeeList* _child_list = NULL;
		GeeList* _tmp9_;
		gint _child_size = 0;
		GeeList* _tmp10_;
		gint _tmp11_;
		gint _tmp12_;
		gint _child_index = 0;
#line 337 "../src/protocol.vala"
		_tmp9_ = self->priv->_children;
#line 337 "../src/protocol.vala"
		_child_list = _tmp9_;
#line 337 "../src/protocol.vala"
		_tmp10_ = _child_list;
#line 337 "../src/protocol.vala"
		_tmp11_ = gee_collection_get_size ((GeeCollection*) _tmp10_);
#line 337 "../src/protocol.vala"
		_tmp12_ = _tmp11_;
#line 337 "../src/protocol.vala"
		_child_size = _tmp12_;
#line 337 "../src/protocol.vala"
		_child_index = -1;
#line 337 "../src/protocol.vala"
		while (TRUE) {
#line 7377 "protocol.c"
			gint _tmp13_;
			gint _tmp14_;
			LspDocumentSymbol* child = NULL;
			GeeList* _tmp15_;
			gpointer _tmp16_;
			JsonArray* _tmp17_;
			LspDocumentSymbol* _tmp18_;
			JsonNode* _tmp19_;
#line 337 "../src/protocol.vala"
			_child_index = _child_index + 1;
#line 337 "../src/protocol.vala"
			_tmp13_ = _child_index;
#line 337 "../src/protocol.vala"
			_tmp14_ = _child_size;
#line 337 "../src/protocol.vala"
			if (!(_tmp13_ < _tmp14_)) {
#line 337 "../src/protocol.vala"
				break;
#line 7396 "protocol.c"
			}
#line 337 "../src/protocol.vala"
			_tmp15_ = _child_list;
#line 337 "../src/protocol.vala"
			_tmp16_ = gee_list_get (_tmp15_, _child_index);
#line 337 "../src/protocol.vala"
			child = (LspDocumentSymbol*) _tmp16_;
#line 338 "../src/protocol.vala"
			_tmp17_ = array;
#line 338 "../src/protocol.vala"
			_tmp18_ = child;
#line 338 "../src/protocol.vala"
			_tmp19_ = json_gobject_serialize ((GObject*) _tmp18_);
#line 338 "../src/protocol.vala"
			json_array_add_element (_tmp17_, _tmp19_);
#line 337 "../src/protocol.vala"
			_g_object_unref0 (child);
#line 7414 "protocol.c"
		}
	}
#line 339 "../src/protocol.vala"
	result = node;
#line 339 "../src/protocol.vala"
	_json_array_unref0 (array);
#line 339 "../src/protocol.vala"
	return result;
#line 7423 "protocol.c"
}

static gboolean
lsp_document_symbol_real_deserialize_property (JsonSerializable* base,
                                               const gchar* property_name,
                                               GValue* value,
                                               GParamSpec* pspec,
                                               JsonNode* property_node)
{
	LspDocumentSymbol * self;
	GValue _vala_value = {0};
#line 342 "../src/protocol.vala"
	self = (LspDocumentSymbol*) base;
#line 342 "../src/protocol.vala"
	g_return_val_if_fail (property_name != NULL, FALSE);
#line 342 "../src/protocol.vala"
	g_return_val_if_fail (pspec != NULL, FALSE);
#line 342 "../src/protocol.vala"
	g_return_val_if_fail (property_node != NULL, FALSE);
#line 343 "../src/protocol.vala"
	g_error ("protocol.vala:343: deserialization not supported");
#line 7445 "protocol.c"
}

const gchar*
lsp_document_symbol_get_name (LspDocumentSymbol* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 274 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 274 "../src/protocol.vala"
	_tmp0_ = self->priv->_name;
#line 274 "../src/protocol.vala"
	result = _tmp0_;
#line 274 "../src/protocol.vala"
	return result;
#line 7461 "protocol.c"
}

void
lsp_document_symbol_set_name (LspDocumentSymbol* self,
                              const gchar* value)
{
	gchar* old_value;
#line 274 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 274 "../src/protocol.vala"
	old_value = lsp_document_symbol_get_name (self);
#line 274 "../src/protocol.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 7475 "protocol.c"
		gchar* _tmp0_;
#line 274 "../src/protocol.vala"
		_tmp0_ = g_strdup (value);
#line 274 "../src/protocol.vala"
		_g_free0 (self->priv->_name);
#line 274 "../src/protocol.vala"
		self->priv->_name = _tmp0_;
#line 274 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_document_symbol_properties[LSP_DOCUMENT_SYMBOL_NAME_PROPERTY]);
#line 7485 "protocol.c"
	}
}

const gchar*
lsp_document_symbol_get_detail (LspDocumentSymbol* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 275 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 275 "../src/protocol.vala"
	_tmp0_ = self->priv->_detail;
#line 275 "../src/protocol.vala"
	result = _tmp0_;
#line 275 "../src/protocol.vala"
	return result;
#line 7502 "protocol.c"
}

void
lsp_document_symbol_set_detail (LspDocumentSymbol* self,
                                const gchar* value)
{
	gchar* old_value;
#line 275 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 275 "../src/protocol.vala"
	old_value = lsp_document_symbol_get_detail (self);
#line 275 "../src/protocol.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 7516 "protocol.c"
		gchar* _tmp0_;
#line 275 "../src/protocol.vala"
		_tmp0_ = g_strdup (value);
#line 275 "../src/protocol.vala"
		_g_free0 (self->priv->_detail);
#line 275 "../src/protocol.vala"
		self->priv->_detail = _tmp0_;
#line 275 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_document_symbol_properties[LSP_DOCUMENT_SYMBOL_DETAIL_PROPERTY]);
#line 7526 "protocol.c"
	}
}

LspSymbolKind
lsp_document_symbol_get_kind (LspDocumentSymbol* self)
{
	LspSymbolKind result;
#line 276 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, LSP_SYMBOL_KIND_Variable);
#line 276 "../src/protocol.vala"
	result = self->priv->_kind;
#line 276 "../src/protocol.vala"
	return result;
#line 7540 "protocol.c"
}

void
lsp_document_symbol_set_kind (LspDocumentSymbol* self,
                              LspSymbolKind value)
{
	LspSymbolKind old_value;
#line 276 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 276 "../src/protocol.vala"
	old_value = lsp_document_symbol_get_kind (self);
#line 276 "../src/protocol.vala"
	if (old_value != value) {
#line 276 "../src/protocol.vala"
		self->priv->_kind = value;
#line 276 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_document_symbol_properties[LSP_DOCUMENT_SYMBOL_KIND_PROPERTY]);
#line 7558 "protocol.c"
	}
}

gboolean
lsp_document_symbol_get_deprecated (LspDocumentSymbol* self)
{
	gboolean result;
#line 277 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 277 "../src/protocol.vala"
	result = self->priv->_deprecated;
#line 277 "../src/protocol.vala"
	return result;
#line 7572 "protocol.c"
}

void
lsp_document_symbol_set_deprecated (LspDocumentSymbol* self,
                                    gboolean value)
{
	gboolean old_value;
#line 277 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 277 "../src/protocol.vala"
	old_value = lsp_document_symbol_get_deprecated (self);
#line 277 "../src/protocol.vala"
	if (old_value != value) {
#line 277 "../src/protocol.vala"
		self->priv->_deprecated = value;
#line 277 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_document_symbol_properties[LSP_DOCUMENT_SYMBOL_DEPRECATED_PROPERTY]);
#line 7590 "protocol.c"
	}
}

static LspRange*
_lsp_document_symbol_range___lambda5_ (LspDocumentSymbol* self,
                                       LspDocumentSymbol* child,
                                       LspRange* current_range)
{
	LspRange* _tmp0_;
	LspRange* _tmp1_;
	LspRange* _tmp2_;
	LspRange* _tmp3_;
	LspRange* _tmp4_;
	LspRange* result;
#line 284 "../src/protocol.vala"
	g_return_val_if_fail (child != NULL, NULL);
#line 284 "../src/protocol.vala"
	g_return_val_if_fail (current_range != NULL, NULL);
#line 284 "../src/protocol.vala"
	_tmp0_ = lsp_document_symbol_get_range (child);
#line 284 "../src/protocol.vala"
	_tmp1_ = _tmp0_;
#line 284 "../src/protocol.vala"
	_tmp2_ = _tmp1_;
#line 284 "../src/protocol.vala"
	_tmp3_ = lsp_range_union (current_range, _tmp2_);
#line 284 "../src/protocol.vala"
	_tmp4_ = _tmp3_;
#line 284 "../src/protocol.vala"
	_g_object_unref0 (_tmp2_);
#line 284 "../src/protocol.vala"
	result = _tmp4_;
#line 284 "../src/protocol.vala"
	_g_object_unref0 (child);
#line 284 "../src/protocol.vala"
	_g_object_unref0 (current_range);
#line 284 "../src/protocol.vala"
	return result;
#line 7629 "protocol.c"
}

static gpointer
__lsp_document_symbol_range___lambda5__gee_fold_func (gpointer g,
                                                      gpointer a,
                                                      gpointer self)
{
	gpointer result;
	result = _lsp_document_symbol_range___lambda5_ ((LspDocumentSymbol*) self, (LspDocumentSymbol*) g, (LspRange*) a);
#line 284 "../src/protocol.vala"
	return result;
#line 7641 "protocol.c"
}

LspRange*
lsp_document_symbol_get_range (LspDocumentSymbol* self)
{
	LspRange* result;
	LspRange* _tmp0_;
	GeeList* _tmp6_;
	LspRange* _tmp7_;
	LspRange* _tmp8_;
	gpointer _tmp9_;
#line 280 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 281 "../src/protocol.vala"
	_tmp0_ = self->priv->_initial_range;
#line 281 "../src/protocol.vala"
	if (_tmp0_ == NULL) {
#line 7659 "protocol.c"
		GeeList* _tmp1_;
		gpointer _tmp2_;
		LspDocumentSymbol* _tmp3_;
		ValaSourceReference* _tmp4_;
		LspRange* _tmp5_;
#line 282 "../src/protocol.vala"
		_tmp1_ = self->priv->_children;
#line 282 "../src/protocol.vala"
		_tmp2_ = gee_list_first (_tmp1_);
#line 282 "../src/protocol.vala"
		_tmp3_ = (LspDocumentSymbol*) _tmp2_;
#line 282 "../src/protocol.vala"
		_tmp4_ = _tmp3_->priv->_source_reference;
#line 282 "../src/protocol.vala"
		_tmp5_ = lsp_range_new_from_sourceref (_tmp4_);
#line 282 "../src/protocol.vala"
		if (_tmp5_) {
#line 282 "../src/protocol.vala"
			g_object_set_data ((GObject *) _tmp5_, "vala-creation-function", "Lsp.DocumentSymbol.range");
#line 7679 "protocol.c"
		}
#line 282 "../src/protocol.vala"
		_g_object_unref0 (self->priv->_initial_range);
#line 282 "../src/protocol.vala"
		self->priv->_initial_range = _tmp5_;
#line 282 "../src/protocol.vala"
		_g_object_unref0 (_tmp3_);
#line 7687 "protocol.c"
	}
#line 284 "../src/protocol.vala"
	_tmp6_ = self->priv->_children;
#line 284 "../src/protocol.vala"
	_tmp7_ = self->priv->_initial_range;
#line 284 "../src/protocol.vala"
	_tmp8_ = _g_object_ref0 (_tmp7_);
#line 284 "../src/protocol.vala"
	_tmp9_ = gee_traversable_fold ((GeeTraversable*) _tmp6_, LSP_TYPE_RANGE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, __lsp_document_symbol_range___lambda5__gee_fold_func, self, _tmp8_);
#line 284 "../src/protocol.vala"
	result = (LspRange*) _tmp9_;
#line 284 "../src/protocol.vala"
	return result;
#line 7701 "protocol.c"
}

LspRange*
lsp_document_symbol_get_selectionRange (LspDocumentSymbol* self)
{
	LspRange* result;
	LspRange* _tmp0_;
#line 287 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 287 "../src/protocol.vala"
	_tmp0_ = self->priv->_selectionRange;
#line 287 "../src/protocol.vala"
	result = _tmp0_;
#line 287 "../src/protocol.vala"
	return result;
#line 7717 "protocol.c"
}

void
lsp_document_symbol_set_selectionRange (LspDocumentSymbol* self,
                                        LspRange* value)
{
	LspRange* old_value;
#line 287 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 287 "../src/protocol.vala"
	old_value = lsp_document_symbol_get_selectionRange (self);
#line 287 "../src/protocol.vala"
	if (old_value != value) {
#line 7731 "protocol.c"
		LspRange* _tmp0_;
#line 287 "../src/protocol.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 287 "../src/protocol.vala"
		_g_object_unref0 (self->priv->_selectionRange);
#line 287 "../src/protocol.vala"
		self->priv->_selectionRange = _tmp0_;
#line 287 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_document_symbol_properties[LSP_DOCUMENT_SYMBOL_SELECTION_RANGE_PROPERTY]);
#line 7741 "protocol.c"
	}
}

GeeList*
lsp_document_symbol_get_children (LspDocumentSymbol* self)
{
	GeeList* result;
	GeeList* _tmp0_;
#line 288 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 288 "../src/protocol.vala"
	_tmp0_ = self->priv->_children;
#line 288 "../src/protocol.vala"
	result = _tmp0_;
#line 288 "../src/protocol.vala"
	return result;
#line 7758 "protocol.c"
}

static void
lsp_document_symbol_set_children (LspDocumentSymbol* self,
                                  GeeList* value)
{
	GeeList* old_value;
#line 288 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 288 "../src/protocol.vala"
	old_value = lsp_document_symbol_get_children (self);
#line 288 "../src/protocol.vala"
	if (old_value != value) {
#line 7772 "protocol.c"
		GeeList* _tmp0_;
#line 288 "../src/protocol.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 288 "../src/protocol.vala"
		_g_object_unref0 (self->priv->_children);
#line 288 "../src/protocol.vala"
		self->priv->_children = _tmp0_;
#line 288 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_document_symbol_properties[LSP_DOCUMENT_SYMBOL_CHILDREN_PROPERTY]);
#line 7782 "protocol.c"
	}
}

static void
lsp_document_symbol_class_init (LspDocumentSymbolClass * klass,
                                gpointer klass_data)
{
#line 272 "../src/protocol.vala"
	lsp_document_symbol_parent_class = g_type_class_peek_parent (klass);
#line 272 "../src/protocol.vala"
	g_type_class_adjust_private_offset (klass, &LspDocumentSymbol_private_offset);
#line 272 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_lsp_document_symbol_get_property;
#line 272 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_lsp_document_symbol_set_property;
#line 272 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->finalize = lsp_document_symbol_finalize;
#line 272 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_DOCUMENT_SYMBOL_NAME_PROPERTY, lsp_document_symbol_properties[LSP_DOCUMENT_SYMBOL_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 272 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_DOCUMENT_SYMBOL_DETAIL_PROPERTY, lsp_document_symbol_properties[LSP_DOCUMENT_SYMBOL_DETAIL_PROPERTY] = g_param_spec_string ("detail", "detail", "detail", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 272 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_DOCUMENT_SYMBOL_KIND_PROPERTY, lsp_document_symbol_properties[LSP_DOCUMENT_SYMBOL_KIND_PROPERTY] = g_param_spec_enum ("kind", "kind", "kind", LSP_TYPE_SYMBOL_KIND, LSP_SYMBOL_KIND_Variable, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 272 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_DOCUMENT_SYMBOL_DEPRECATED_PROPERTY, lsp_document_symbol_properties[LSP_DOCUMENT_SYMBOL_DEPRECATED_PROPERTY] = g_param_spec_boolean ("deprecated", "deprecated", "deprecated", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 272 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_DOCUMENT_SYMBOL_RANGE_PROPERTY, lsp_document_symbol_properties[LSP_DOCUMENT_SYMBOL_RANGE_PROPERTY] = g_param_spec_object ("range", "range", "range", LSP_TYPE_RANGE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 272 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_DOCUMENT_SYMBOL_SELECTION_RANGE_PROPERTY, lsp_document_symbol_properties[LSP_DOCUMENT_SYMBOL_SELECTION_RANGE_PROPERTY] = g_param_spec_object ("selectionRange", "selectionRange", "selectionRange", LSP_TYPE_RANGE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 272 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_DOCUMENT_SYMBOL_CHILDREN_PROPERTY, lsp_document_symbol_properties[LSP_DOCUMENT_SYMBOL_CHILDREN_PROPERTY] = g_param_spec_object ("children", "children", "children", GEE_TYPE_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 7814 "protocol.c"
}

static void
lsp_document_symbol_json_serializable_interface_init (JsonSerializableIface * iface,
                                                      gpointer iface_data)
{
#line 272 "../src/protocol.vala"
	lsp_document_symbol_json_serializable_parent_iface = g_type_interface_peek_parent (iface);
#line 272 "../src/protocol.vala"
	iface->set_property = (void (*) (JsonSerializable*, GParamSpec*, GValue*)) lsp_document_symbol_real_json_serializable_set_property;
#line 272 "../src/protocol.vala"
	iface->get_property = (void (*) (JsonSerializable*, GParamSpec*, GValue*)) lsp_document_symbol_real_json_serializable_get_property;
#line 272 "../src/protocol.vala"
	iface->find_property = (GParamSpec* (*) (JsonSerializable*, const gchar*)) lsp_document_symbol_real_find_property;
#line 272 "../src/protocol.vala"
	iface->serialize_property = (JsonNode* (*) (JsonSerializable*, const gchar*, GValue*, GParamSpec*)) lsp_document_symbol_real_serialize_property;
#line 272 "../src/protocol.vala"
	iface->deserialize_property = (gboolean (*) (JsonSerializable*, const gchar*, GValue*, GParamSpec*, JsonNode*)) lsp_document_symbol_real_deserialize_property;
#line 7833 "protocol.c"
}

static void
lsp_document_symbol_instance_init (LspDocumentSymbol * self,
                                   gpointer klass)
{
	GeeLinkedList* _tmp0_;
#line 272 "../src/protocol.vala"
	self->priv = lsp_document_symbol_get_instance_private (self);
#line 288 "../src/protocol.vala"
	_tmp0_ = gee_linked_list_new (LSP_TYPE_DOCUMENT_SYMBOL, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 288 "../src/protocol.vala"
	if (_tmp0_) {
#line 288 "../src/protocol.vala"
		g_object_set_data ((GObject *) _tmp0_, "vala-creation-function", "");
#line 7849 "protocol.c"
	}
#line 288 "../src/protocol.vala"
	self->priv->_children = (GeeList*) _tmp0_;
#line 7853 "protocol.c"
}

static void
lsp_document_symbol_finalize (GObject * obj)
{
	LspDocumentSymbol * self;
#line 272 "../src/protocol.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, LSP_TYPE_DOCUMENT_SYMBOL, LspDocumentSymbol);
#line 273 "../src/protocol.vala"
	_vala_source_reference_unref0 (self->priv->_source_reference);
#line 274 "../src/protocol.vala"
	_g_free0 (self->priv->_name);
#line 275 "../src/protocol.vala"
	_g_free0 (self->priv->_detail);
#line 278 "../src/protocol.vala"
	_g_object_unref0 (self->priv->_initial_range);
#line 287 "../src/protocol.vala"
	_g_object_unref0 (self->priv->_selectionRange);
#line 288 "../src/protocol.vala"
	_g_object_unref0 (self->priv->_children);
#line 289 "../src/protocol.vala"
	_g_free0 (self->parent_name);
#line 272 "../src/protocol.vala"
	G_OBJECT_CLASS (lsp_document_symbol_parent_class)->finalize (obj);
#line 7878 "protocol.c"
}

 G_GNUC_NO_INLINE static GType
lsp_document_symbol_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (LspDocumentSymbolClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) lsp_document_symbol_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LspDocumentSymbol), 0, (GInstanceInitFunc) lsp_document_symbol_instance_init, NULL };
	static const GInterfaceInfo json_serializable_info = { (GInterfaceInitFunc) lsp_document_symbol_json_serializable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType lsp_document_symbol_type_id;
	lsp_document_symbol_type_id = g_type_register_static (G_TYPE_OBJECT, "LspDocumentSymbol", &g_define_type_info, 0);
	g_type_add_interface_static (lsp_document_symbol_type_id, json_serializable_get_type (), &json_serializable_info);
	LspDocumentSymbol_private_offset = g_type_add_instance_private (lsp_document_symbol_type_id, sizeof (LspDocumentSymbolPrivate));
	return lsp_document_symbol_type_id;
}

GType
lsp_document_symbol_get_type (void)
{
	static gsize lsp_document_symbol_type_id__once = 0;
	if (g_once_init_enter (&lsp_document_symbol_type_id__once)) {
		GType lsp_document_symbol_type_id;
		lsp_document_symbol_type_id = lsp_document_symbol_get_type_once ();
		g_once_init_leave (&lsp_document_symbol_type_id__once, lsp_document_symbol_type_id);
	}
	return lsp_document_symbol_type_id__once;
}

static void
_vala_lsp_document_symbol_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec)
{
	LspDocumentSymbol * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_DOCUMENT_SYMBOL, LspDocumentSymbol);
#line 272 "../src/protocol.vala"
	switch (property_id) {
#line 272 "../src/protocol.vala"
		case LSP_DOCUMENT_SYMBOL_NAME_PROPERTY:
#line 272 "../src/protocol.vala"
		g_value_set_string (value, lsp_document_symbol_get_name (self));
#line 272 "../src/protocol.vala"
		break;
#line 272 "../src/protocol.vala"
		case LSP_DOCUMENT_SYMBOL_DETAIL_PROPERTY:
#line 272 "../src/protocol.vala"
		g_value_set_string (value, lsp_document_symbol_get_detail (self));
#line 272 "../src/protocol.vala"
		break;
#line 272 "../src/protocol.vala"
		case LSP_DOCUMENT_SYMBOL_KIND_PROPERTY:
#line 272 "../src/protocol.vala"
		g_value_set_enum (value, lsp_document_symbol_get_kind (self));
#line 272 "../src/protocol.vala"
		break;
#line 272 "../src/protocol.vala"
		case LSP_DOCUMENT_SYMBOL_DEPRECATED_PROPERTY:
#line 272 "../src/protocol.vala"
		g_value_set_boolean (value, lsp_document_symbol_get_deprecated (self));
#line 272 "../src/protocol.vala"
		break;
#line 272 "../src/protocol.vala"
		case LSP_DOCUMENT_SYMBOL_RANGE_PROPERTY:
#line 272 "../src/protocol.vala"
		g_value_take_object (value, lsp_document_symbol_get_range (self));
#line 272 "../src/protocol.vala"
		break;
#line 272 "../src/protocol.vala"
		case LSP_DOCUMENT_SYMBOL_SELECTION_RANGE_PROPERTY:
#line 272 "../src/protocol.vala"
		g_value_set_object (value, lsp_document_symbol_get_selectionRange (self));
#line 272 "../src/protocol.vala"
		break;
#line 272 "../src/protocol.vala"
		case LSP_DOCUMENT_SYMBOL_CHILDREN_PROPERTY:
#line 272 "../src/protocol.vala"
		g_value_set_object (value, lsp_document_symbol_get_children (self));
#line 272 "../src/protocol.vala"
		break;
#line 7957 "protocol.c"
		default:
#line 272 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 272 "../src/protocol.vala"
		break;
#line 7963 "protocol.c"
	}
}

static void
_vala_lsp_document_symbol_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec)
{
	LspDocumentSymbol * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_DOCUMENT_SYMBOL, LspDocumentSymbol);
#line 272 "../src/protocol.vala"
	switch (property_id) {
#line 272 "../src/protocol.vala"
		case LSP_DOCUMENT_SYMBOL_NAME_PROPERTY:
#line 272 "../src/protocol.vala"
		lsp_document_symbol_set_name (self, g_value_get_string (value));
#line 272 "../src/protocol.vala"
		break;
#line 272 "../src/protocol.vala"
		case LSP_DOCUMENT_SYMBOL_DETAIL_PROPERTY:
#line 272 "../src/protocol.vala"
		lsp_document_symbol_set_detail (self, g_value_get_string (value));
#line 272 "../src/protocol.vala"
		break;
#line 272 "../src/protocol.vala"
		case LSP_DOCUMENT_SYMBOL_KIND_PROPERTY:
#line 272 "../src/protocol.vala"
		lsp_document_symbol_set_kind (self, g_value_get_enum (value));
#line 272 "../src/protocol.vala"
		break;
#line 272 "../src/protocol.vala"
		case LSP_DOCUMENT_SYMBOL_DEPRECATED_PROPERTY:
#line 272 "../src/protocol.vala"
		lsp_document_symbol_set_deprecated (self, g_value_get_boolean (value));
#line 272 "../src/protocol.vala"
		break;
#line 272 "../src/protocol.vala"
		case LSP_DOCUMENT_SYMBOL_SELECTION_RANGE_PROPERTY:
#line 272 "../src/protocol.vala"
		lsp_document_symbol_set_selectionRange (self, g_value_get_object (value));
#line 272 "../src/protocol.vala"
		break;
#line 272 "../src/protocol.vala"
		case LSP_DOCUMENT_SYMBOL_CHILDREN_PROPERTY:
#line 272 "../src/protocol.vala"
		lsp_document_symbol_set_children (self, g_value_get_object (value));
#line 272 "../src/protocol.vala"
		break;
#line 8013 "protocol.c"
		default:
#line 272 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 272 "../src/protocol.vala"
		break;
#line 8019 "protocol.c"
	}
}

static inline gpointer
lsp_symbol_information_get_instance_private (LspSymbolInformation* self)
{
	return G_STRUCT_MEMBER_P (self, LspSymbolInformation_private_offset);
}

LspSymbolInformation*
lsp_symbol_information_construct_from_document_symbol (GType object_type,
                                                       LspDocumentSymbol* dsym,
                                                       const gchar* uri)
{
	LspSymbolInformation * self = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	LspSymbolKind _tmp2_;
	LspSymbolKind _tmp3_;
	LspRange* _tmp4_;
	LspRange* _tmp5_;
	LspRange* _tmp6_;
	LspLocation* _tmp7_;
	LspLocation* _tmp8_;
	const gchar* _tmp9_;
#line 353 "../src/protocol.vala"
	g_return_val_if_fail (dsym != NULL, NULL);
#line 353 "../src/protocol.vala"
	g_return_val_if_fail (uri != NULL, NULL);
#line 353 "../src/protocol.vala"
	self = (LspSymbolInformation*) g_object_new (object_type, NULL);
#line 354 "../src/protocol.vala"
	_tmp0_ = lsp_document_symbol_get_name (dsym);
#line 354 "../src/protocol.vala"
	_tmp1_ = _tmp0_;
#line 354 "../src/protocol.vala"
	lsp_symbol_information_set_name (self, _tmp1_);
#line 355 "../src/protocol.vala"
	_tmp2_ = lsp_document_symbol_get_kind (dsym);
#line 355 "../src/protocol.vala"
	_tmp3_ = _tmp2_;
#line 355 "../src/protocol.vala"
	lsp_symbol_information_set_kind (self, _tmp3_);
#line 356 "../src/protocol.vala"
	_tmp4_ = lsp_document_symbol_get_range (dsym);
#line 356 "../src/protocol.vala"
	_tmp5_ = _tmp4_;
#line 356 "../src/protocol.vala"
	_tmp6_ = _tmp5_;
#line 356 "../src/protocol.vala"
	_tmp7_ = lsp_location_new (uri, _tmp6_);
#line 356 "../src/protocol.vala"
	if (_tmp7_) {
#line 356 "../src/protocol.vala"
		g_object_set_data ((GObject *) _tmp7_, "vala-creation-function", "Lsp.SymbolInformation.from_document_symbol");
#line 8075 "protocol.c"
	}
#line 356 "../src/protocol.vala"
	_tmp8_ = _tmp7_;
#line 356 "../src/protocol.vala"
	lsp_symbol_information_set_location (self, _tmp8_);
#line 356 "../src/protocol.vala"
	_g_object_unref0 (_tmp8_);
#line 356 "../src/protocol.vala"
	_g_object_unref0 (_tmp6_);
#line 357 "../src/protocol.vala"
	_tmp9_ = dsym->parent_name;
#line 357 "../src/protocol.vala"
	lsp_symbol_information_set_containerName (self, _tmp9_);
#line 353 "../src/protocol.vala"
	return self;
#line 8091 "protocol.c"
}

LspSymbolInformation*
lsp_symbol_information_new_from_document_symbol (LspDocumentSymbol* dsym,
                                                 const gchar* uri)
{
#line 353 "../src/protocol.vala"
	return lsp_symbol_information_construct_from_document_symbol (LSP_TYPE_SYMBOL_INFORMATION, dsym, uri);
#line 8100 "protocol.c"
}

LspSymbolInformation*
lsp_symbol_information_construct (GType object_type)
{
	LspSymbolInformation * self = NULL;
#line 347 "../src/protocol.vala"
	self = (LspSymbolInformation*) g_object_new (object_type, NULL);
#line 347 "../src/protocol.vala"
	return self;
#line 8111 "protocol.c"
}

LspSymbolInformation*
lsp_symbol_information_new (void)
{
#line 347 "../src/protocol.vala"
	return lsp_symbol_information_construct (LSP_TYPE_SYMBOL_INFORMATION);
#line 8119 "protocol.c"
}

const gchar*
lsp_symbol_information_get_name (LspSymbolInformation* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 348 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 348 "../src/protocol.vala"
	_tmp0_ = self->priv->_name;
#line 348 "../src/protocol.vala"
	result = _tmp0_;
#line 348 "../src/protocol.vala"
	return result;
#line 8135 "protocol.c"
}

void
lsp_symbol_information_set_name (LspSymbolInformation* self,
                                 const gchar* value)
{
	gchar* old_value;
#line 348 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 348 "../src/protocol.vala"
	old_value = lsp_symbol_information_get_name (self);
#line 348 "../src/protocol.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 8149 "protocol.c"
		gchar* _tmp0_;
#line 348 "../src/protocol.vala"
		_tmp0_ = g_strdup (value);
#line 348 "../src/protocol.vala"
		_g_free0 (self->priv->_name);
#line 348 "../src/protocol.vala"
		self->priv->_name = _tmp0_;
#line 348 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_symbol_information_properties[LSP_SYMBOL_INFORMATION_NAME_PROPERTY]);
#line 8159 "protocol.c"
	}
}

LspSymbolKind
lsp_symbol_information_get_kind (LspSymbolInformation* self)
{
	LspSymbolKind result;
#line 349 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, LSP_SYMBOL_KIND_Variable);
#line 349 "../src/protocol.vala"
	result = self->priv->_kind;
#line 349 "../src/protocol.vala"
	return result;
#line 8173 "protocol.c"
}

void
lsp_symbol_information_set_kind (LspSymbolInformation* self,
                                 LspSymbolKind value)
{
	LspSymbolKind old_value;
#line 349 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 349 "../src/protocol.vala"
	old_value = lsp_symbol_information_get_kind (self);
#line 349 "../src/protocol.vala"
	if (old_value != value) {
#line 349 "../src/protocol.vala"
		self->priv->_kind = value;
#line 349 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_symbol_information_properties[LSP_SYMBOL_INFORMATION_KIND_PROPERTY]);
#line 8191 "protocol.c"
	}
}

LspLocation*
lsp_symbol_information_get_location (LspSymbolInformation* self)
{
	LspLocation* result;
	LspLocation* _tmp0_;
#line 350 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 350 "../src/protocol.vala"
	_tmp0_ = self->priv->_location;
#line 350 "../src/protocol.vala"
	result = _tmp0_;
#line 350 "../src/protocol.vala"
	return result;
#line 8208 "protocol.c"
}

void
lsp_symbol_information_set_location (LspSymbolInformation* self,
                                     LspLocation* value)
{
	LspLocation* old_value;
#line 350 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 350 "../src/protocol.vala"
	old_value = lsp_symbol_information_get_location (self);
#line 350 "../src/protocol.vala"
	if (old_value != value) {
#line 8222 "protocol.c"
		LspLocation* _tmp0_;
#line 350 "../src/protocol.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 350 "../src/protocol.vala"
		_g_object_unref0 (self->priv->_location);
#line 350 "../src/protocol.vala"
		self->priv->_location = _tmp0_;
#line 350 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_symbol_information_properties[LSP_SYMBOL_INFORMATION_LOCATION_PROPERTY]);
#line 8232 "protocol.c"
	}
}

const gchar*
lsp_symbol_information_get_containerName (LspSymbolInformation* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 351 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 351 "../src/protocol.vala"
	_tmp0_ = self->priv->_containerName;
#line 351 "../src/protocol.vala"
	result = _tmp0_;
#line 351 "../src/protocol.vala"
	return result;
#line 8249 "protocol.c"
}

void
lsp_symbol_information_set_containerName (LspSymbolInformation* self,
                                          const gchar* value)
{
	gchar* old_value;
#line 351 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 351 "../src/protocol.vala"
	old_value = lsp_symbol_information_get_containerName (self);
#line 351 "../src/protocol.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 8263 "protocol.c"
		gchar* _tmp0_;
#line 351 "../src/protocol.vala"
		_tmp0_ = g_strdup (value);
#line 351 "../src/protocol.vala"
		_g_free0 (self->priv->_containerName);
#line 351 "../src/protocol.vala"
		self->priv->_containerName = _tmp0_;
#line 351 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_symbol_information_properties[LSP_SYMBOL_INFORMATION_CONTAINER_NAME_PROPERTY]);
#line 8273 "protocol.c"
	}
}

static void
lsp_symbol_information_class_init (LspSymbolInformationClass * klass,
                                   gpointer klass_data)
{
#line 347 "../src/protocol.vala"
	lsp_symbol_information_parent_class = g_type_class_peek_parent (klass);
#line 347 "../src/protocol.vala"
	g_type_class_adjust_private_offset (klass, &LspSymbolInformation_private_offset);
#line 347 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_lsp_symbol_information_get_property;
#line 347 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_lsp_symbol_information_set_property;
#line 347 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->finalize = lsp_symbol_information_finalize;
#line 347 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_SYMBOL_INFORMATION_NAME_PROPERTY, lsp_symbol_information_properties[LSP_SYMBOL_INFORMATION_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 347 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_SYMBOL_INFORMATION_KIND_PROPERTY, lsp_symbol_information_properties[LSP_SYMBOL_INFORMATION_KIND_PROPERTY] = g_param_spec_enum ("kind", "kind", "kind", LSP_TYPE_SYMBOL_KIND, LSP_SYMBOL_KIND_Variable, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 347 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_SYMBOL_INFORMATION_LOCATION_PROPERTY, lsp_symbol_information_properties[LSP_SYMBOL_INFORMATION_LOCATION_PROPERTY] = g_param_spec_object ("location", "location", "location", LSP_TYPE_LOCATION, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 347 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_SYMBOL_INFORMATION_CONTAINER_NAME_PROPERTY, lsp_symbol_information_properties[LSP_SYMBOL_INFORMATION_CONTAINER_NAME_PROPERTY] = g_param_spec_string ("containerName", "containerName", "containerName", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 8299 "protocol.c"
}

static void
lsp_symbol_information_instance_init (LspSymbolInformation * self,
                                      gpointer klass)
{
#line 347 "../src/protocol.vala"
	self->priv = lsp_symbol_information_get_instance_private (self);
#line 8308 "protocol.c"
}

static void
lsp_symbol_information_finalize (GObject * obj)
{
	LspSymbolInformation * self;
#line 347 "../src/protocol.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, LSP_TYPE_SYMBOL_INFORMATION, LspSymbolInformation);
#line 348 "../src/protocol.vala"
	_g_free0 (self->priv->_name);
#line 350 "../src/protocol.vala"
	_g_object_unref0 (self->priv->_location);
#line 351 "../src/protocol.vala"
	_g_free0 (self->priv->_containerName);
#line 347 "../src/protocol.vala"
	G_OBJECT_CLASS (lsp_symbol_information_parent_class)->finalize (obj);
#line 8325 "protocol.c"
}

 G_GNUC_NO_INLINE static GType
lsp_symbol_information_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (LspSymbolInformationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) lsp_symbol_information_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LspSymbolInformation), 0, (GInstanceInitFunc) lsp_symbol_information_instance_init, NULL };
	GType lsp_symbol_information_type_id;
	lsp_symbol_information_type_id = g_type_register_static (G_TYPE_OBJECT, "LspSymbolInformation", &g_define_type_info, 0);
	LspSymbolInformation_private_offset = g_type_add_instance_private (lsp_symbol_information_type_id, sizeof (LspSymbolInformationPrivate));
	return lsp_symbol_information_type_id;
}

GType
lsp_symbol_information_get_type (void)
{
	static gsize lsp_symbol_information_type_id__once = 0;
	if (g_once_init_enter (&lsp_symbol_information_type_id__once)) {
		GType lsp_symbol_information_type_id;
		lsp_symbol_information_type_id = lsp_symbol_information_get_type_once ();
		g_once_init_leave (&lsp_symbol_information_type_id__once, lsp_symbol_information_type_id);
	}
	return lsp_symbol_information_type_id__once;
}

static void
_vala_lsp_symbol_information_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec)
{
	LspSymbolInformation * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_SYMBOL_INFORMATION, LspSymbolInformation);
#line 347 "../src/protocol.vala"
	switch (property_id) {
#line 347 "../src/protocol.vala"
		case LSP_SYMBOL_INFORMATION_NAME_PROPERTY:
#line 347 "../src/protocol.vala"
		g_value_set_string (value, lsp_symbol_information_get_name (self));
#line 347 "../src/protocol.vala"
		break;
#line 347 "../src/protocol.vala"
		case LSP_SYMBOL_INFORMATION_KIND_PROPERTY:
#line 347 "../src/protocol.vala"
		g_value_set_enum (value, lsp_symbol_information_get_kind (self));
#line 347 "../src/protocol.vala"
		break;
#line 347 "../src/protocol.vala"
		case LSP_SYMBOL_INFORMATION_LOCATION_PROPERTY:
#line 347 "../src/protocol.vala"
		g_value_set_object (value, lsp_symbol_information_get_location (self));
#line 347 "../src/protocol.vala"
		break;
#line 347 "../src/protocol.vala"
		case LSP_SYMBOL_INFORMATION_CONTAINER_NAME_PROPERTY:
#line 347 "../src/protocol.vala"
		g_value_set_string (value, lsp_symbol_information_get_containerName (self));
#line 347 "../src/protocol.vala"
		break;
#line 8384 "protocol.c"
		default:
#line 347 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 347 "../src/protocol.vala"
		break;
#line 8390 "protocol.c"
	}
}

static void
_vala_lsp_symbol_information_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec)
{
	LspSymbolInformation * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_SYMBOL_INFORMATION, LspSymbolInformation);
#line 347 "../src/protocol.vala"
	switch (property_id) {
#line 347 "../src/protocol.vala"
		case LSP_SYMBOL_INFORMATION_NAME_PROPERTY:
#line 347 "../src/protocol.vala"
		lsp_symbol_information_set_name (self, g_value_get_string (value));
#line 347 "../src/protocol.vala"
		break;
#line 347 "../src/protocol.vala"
		case LSP_SYMBOL_INFORMATION_KIND_PROPERTY:
#line 347 "../src/protocol.vala"
		lsp_symbol_information_set_kind (self, g_value_get_enum (value));
#line 347 "../src/protocol.vala"
		break;
#line 347 "../src/protocol.vala"
		case LSP_SYMBOL_INFORMATION_LOCATION_PROPERTY:
#line 347 "../src/protocol.vala"
		lsp_symbol_information_set_location (self, g_value_get_object (value));
#line 347 "../src/protocol.vala"
		break;
#line 347 "../src/protocol.vala"
		case LSP_SYMBOL_INFORMATION_CONTAINER_NAME_PROPERTY:
#line 347 "../src/protocol.vala"
		lsp_symbol_information_set_containerName (self, g_value_get_string (value));
#line 347 "../src/protocol.vala"
		break;
#line 8428 "protocol.c"
		default:
#line 347 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 347 "../src/protocol.vala"
		break;
#line 8434 "protocol.c"
	}
}

 G_GNUC_NO_INLINE static GType
lsp_symbol_kind_get_type_once (void)
{
	static const GEnumValue values[] = {{LSP_SYMBOL_KIND_File, "LSP_SYMBOL_KIND_File", "file"}, {LSP_SYMBOL_KIND_Module, "LSP_SYMBOL_KIND_Module", "module"}, {LSP_SYMBOL_KIND_Namespace, "LSP_SYMBOL_KIND_Namespace", "namespace"}, {LSP_SYMBOL_KIND_Package, "LSP_SYMBOL_KIND_Package", "package"}, {LSP_SYMBOL_KIND_Class, "LSP_SYMBOL_KIND_Class", "class"}, {LSP_SYMBOL_KIND_Method, "LSP_SYMBOL_KIND_Method", "method"}, {LSP_SYMBOL_KIND_Property, "LSP_SYMBOL_KIND_Property", "property"}, {LSP_SYMBOL_KIND_Field, "LSP_SYMBOL_KIND_Field", "field"}, {LSP_SYMBOL_KIND_Constructor, "LSP_SYMBOL_KIND_Constructor", "constructor"}, {LSP_SYMBOL_KIND_Enum, "LSP_SYMBOL_KIND_Enum", "enum"}, {LSP_SYMBOL_KIND_Interface, "LSP_SYMBOL_KIND_Interface", "interface"}, {LSP_SYMBOL_KIND_Function, "LSP_SYMBOL_KIND_Function", "function"}, {LSP_SYMBOL_KIND_Variable, "LSP_SYMBOL_KIND_Variable", "variable"}, {LSP_SYMBOL_KIND_Constant, "LSP_SYMBOL_KIND_Constant", "constant"}, {LSP_SYMBOL_KIND_String, "LSP_SYMBOL_KIND_String", "string"}, {LSP_SYMBOL_KIND_Number, "LSP_SYMBOL_KIND_Number", "number"}, {LSP_SYMBOL_KIND_Boolean, "LSP_SYMBOL_KIND_Boolean", "boolean"}, {LSP_SYMBOL_KIND_Array, "LSP_SYMBOL_KIND_Array", "array"}, {LSP_SYMBOL_KIND_Object, "LSP_SYMBOL_KIND_Object", "object"}, {LSP_SYMBOL_KIND_Key, "LSP_SYMBOL_KIND_Key", "key"}, {LSP_SYMBOL_KIND_Null, "LSP_SYMBOL_KIND_Null", "null"}, {LSP_SYMBOL_KIND_EnumMember, "LSP_SYMBOL_KIND_EnumMember", "enummember"}, {LSP_SYMBOL_KIND_Struct, "LSP_SYMBOL_KIND_Struct", "struct"}, {LSP_SYMBOL_KIND_Event, "LSP_SYMBOL_KIND_Event", "event"}, {LSP_SYMBOL_KIND_Operator, "LSP_SYMBOL_KIND_Operator", "operator"}, {LSP_SYMBOL_KIND_TypeParameter, "LSP_SYMBOL_KIND_TypeParameter", "typeparameter"}, {0, NULL, NULL}};
	GType lsp_symbol_kind_type_id;
	lsp_symbol_kind_type_id = g_enum_register_static ("LspSymbolKind", values);
	return lsp_symbol_kind_type_id;
}

GType
lsp_symbol_kind_get_type (void)
{
	static gsize lsp_symbol_kind_type_id__once = 0;
	if (g_once_init_enter (&lsp_symbol_kind_type_id__once)) {
		GType lsp_symbol_kind_type_id;
		lsp_symbol_kind_type_id = lsp_symbol_kind_get_type_once ();
		g_once_init_leave (&lsp_symbol_kind_type_id__once, lsp_symbol_kind_type_id);
	}
	return lsp_symbol_kind_type_id__once;
}

static inline gpointer
lsp_completion_list_get_instance_private (LspCompletionList* self)
{
	return G_STRUCT_MEMBER_P (self, LspCompletionList_private_offset);
}

static void
lsp_completion_list_real_json_serializable_set_property (JsonSerializable* base,
                                                         GParamSpec* pspec,
                                                         GValue* value)
{
	LspCompletionList * self;
	const gchar* _tmp0_;
	GValue _tmp1_;
#line 395 "../src/protocol.vala"
	self = (LspCompletionList*) base;
#line 395 "../src/protocol.vala"
	g_return_if_fail (pspec != NULL);
#line 395 "../src/protocol.vala"
	g_return_if_fail (value != NULL);
#line 396 "../src/protocol.vala"
	_tmp0_ = g_param_spec_get_name (pspec);
#line 396 "../src/protocol.vala"
	_tmp1_ = *value;
#line 396 "../src/protocol.vala"
	g_object_set_property (G_TYPE_CHECK_INSTANCE_CAST (self, G_TYPE_OBJECT, GObject), _tmp0_, &_tmp1_);
#line 8485 "protocol.c"
}

static void
lsp_completion_list_real_json_serializable_get_property (JsonSerializable* base,
                                                         GParamSpec* pspec,
                                                         GValue* result)
{
	LspCompletionList * self;
	GValue val = {0};
	GValue _tmp0_ = {0};
	const gchar* _tmp1_;
#line 399 "../src/protocol.vala"
	self = (LspCompletionList*) base;
#line 399 "../src/protocol.vala"
	g_return_if_fail (pspec != NULL);
#line 400 "../src/protocol.vala"
	g_value_init (&_tmp0_, pspec->value_type);
#line 400 "../src/protocol.vala"
	val = _tmp0_;
#line 401 "../src/protocol.vala"
	_tmp1_ = g_param_spec_get_name (pspec);
#line 401 "../src/protocol.vala"
	g_object_get_property (G_TYPE_CHECK_INSTANCE_CAST (self, G_TYPE_OBJECT, GObject), _tmp1_, &val);
#line 402 "../src/protocol.vala"
	*result = val;
#line 402 "../src/protocol.vala"
	return;
#line 8513 "protocol.c"
}

static GParamSpec*
lsp_completion_list_real_find_property (JsonSerializable* base,
                                        const gchar* name)
{
	LspCompletionList * self;
	GObjectClass* _tmp0_;
	GParamSpec* _tmp1_;
	GParamSpec* result;
#line 405 "../src/protocol.vala"
	self = (LspCompletionList*) base;
#line 405 "../src/protocol.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 406 "../src/protocol.vala"
	_tmp0_ = G_OBJECT_GET_CLASS ((GObject*) self);
#line 406 "../src/protocol.vala"
	_tmp1_ = g_object_class_find_property (_tmp0_, name);
#line 406 "../src/protocol.vala"
	result = _tmp1_;
#line 406 "../src/protocol.vala"
	return result;
#line 8536 "protocol.c"
}

static JsonNode*
lsp_completion_list_real_serialize_property (JsonSerializable* base,
                                             const gchar* property_name,
                                             GValue* value,
                                             GParamSpec* pspec)
{
	LspCompletionList * self;
	JsonNode* node = NULL;
	JsonNode* _tmp2_;
	JsonNode* _tmp3_;
	JsonArray* _tmp4_;
	JsonArray* _tmp5_;
	JsonArray* array = NULL;
	JsonNode* _tmp6_;
	JsonArray* _tmp7_;
	JsonArray* _tmp8_;
	JsonNode* result;
#line 409 "../src/protocol.vala"
	self = (LspCompletionList*) base;
#line 409 "../src/protocol.vala"
	g_return_val_if_fail (property_name != NULL, NULL);
#line 409 "../src/protocol.vala"
	g_return_val_if_fail (value != NULL, NULL);
#line 409 "../src/protocol.vala"
	g_return_val_if_fail (pspec != NULL, NULL);
#line 410 "../src/protocol.vala"
	if (g_strcmp0 (property_name, "items") != 0) {
#line 8566 "protocol.c"
		GValue _tmp0_;
		JsonNode* _tmp1_;
#line 411 "../src/protocol.vala"
		_tmp0_ = *value;
#line 411 "../src/protocol.vala"
		_tmp1_ = json_serializable_default_serialize_property ((JsonSerializable*) self, property_name, &_tmp0_, pspec);
#line 411 "../src/protocol.vala"
		result = _tmp1_;
#line 411 "../src/protocol.vala"
		return result;
#line 8577 "protocol.c"
	}
#line 412 "../src/protocol.vala"
	_tmp2_ = json_node_new (JSON_NODE_ARRAY);
#line 412 "../src/protocol.vala"
	node = _tmp2_;
#line 413 "../src/protocol.vala"
	_tmp3_ = node;
#line 413 "../src/protocol.vala"
	_tmp4_ = json_array_new ();
#line 413 "../src/protocol.vala"
	_tmp5_ = _tmp4_;
#line 413 "../src/protocol.vala"
	json_node_init_array (_tmp3_, _tmp5_);
#line 413 "../src/protocol.vala"
	_json_array_unref0 (_tmp5_);
#line 414 "../src/protocol.vala"
	_tmp6_ = node;
#line 414 "../src/protocol.vala"
	_tmp7_ = json_node_get_array (_tmp6_);
#line 414 "../src/protocol.vala"
	_tmp8_ = _json_array_ref0 (_tmp7_);
#line 414 "../src/protocol.vala"
	array = _tmp8_;
#line 8601 "protocol.c"
	{
		GeeList* _child_list = NULL;
		GeeList* _tmp9_;
		gint _child_size = 0;
		GeeList* _tmp10_;
		gint _tmp11_;
		gint _tmp12_;
		gint _child_index = 0;
#line 415 "../src/protocol.vala"
		_tmp9_ = self->priv->_items;
#line 415 "../src/protocol.vala"
		_child_list = _tmp9_;
#line 415 "../src/protocol.vala"
		_tmp10_ = _child_list;
#line 415 "../src/protocol.vala"
		_tmp11_ = gee_collection_get_size ((GeeCollection*) _tmp10_);
#line 415 "../src/protocol.vala"
		_tmp12_ = _tmp11_;
#line 415 "../src/protocol.vala"
		_child_size = _tmp12_;
#line 415 "../src/protocol.vala"
		_child_index = -1;
#line 415 "../src/protocol.vala"
		while (TRUE) {
#line 8626 "protocol.c"
			gint _tmp13_;
			gint _tmp14_;
			LspCompletionItem* child = NULL;
			GeeList* _tmp15_;
			gpointer _tmp16_;
			JsonArray* _tmp17_;
			LspCompletionItem* _tmp18_;
			JsonNode* _tmp19_;
#line 415 "../src/protocol.vala"
			_child_index = _child_index + 1;
#line 415 "../src/protocol.vala"
			_tmp13_ = _child_index;
#line 415 "../src/protocol.vala"
			_tmp14_ = _child_size;
#line 415 "../src/protocol.vala"
			if (!(_tmp13_ < _tmp14_)) {
#line 415 "../src/protocol.vala"
				break;
#line 8645 "protocol.c"
			}
#line 415 "../src/protocol.vala"
			_tmp15_ = _child_list;
#line 415 "../src/protocol.vala"
			_tmp16_ = gee_list_get (_tmp15_, _child_index);
#line 415 "../src/protocol.vala"
			child = (LspCompletionItem*) _tmp16_;
#line 416 "../src/protocol.vala"
			_tmp17_ = array;
#line 416 "../src/protocol.vala"
			_tmp18_ = child;
#line 416 "../src/protocol.vala"
			_tmp19_ = json_gobject_serialize ((GObject*) _tmp18_);
#line 416 "../src/protocol.vala"
			json_array_add_element (_tmp17_, _tmp19_);
#line 415 "../src/protocol.vala"
			_g_object_unref0 (child);
#line 8663 "protocol.c"
		}
	}
#line 417 "../src/protocol.vala"
	result = node;
#line 417 "../src/protocol.vala"
	_json_array_unref0 (array);
#line 417 "../src/protocol.vala"
	return result;
#line 8672 "protocol.c"
}

static gboolean
lsp_completion_list_real_deserialize_property (JsonSerializable* base,
                                               const gchar* property_name,
                                               GValue* value,
                                               GParamSpec* pspec,
                                               JsonNode* property_node)
{
	LspCompletionList * self;
	GValue _vala_value = {0};
#line 420 "../src/protocol.vala"
	self = (LspCompletionList*) base;
#line 420 "../src/protocol.vala"
	g_return_val_if_fail (property_name != NULL, FALSE);
#line 420 "../src/protocol.vala"
	g_return_val_if_fail (pspec != NULL, FALSE);
#line 420 "../src/protocol.vala"
	g_return_val_if_fail (property_node != NULL, FALSE);
#line 421 "../src/protocol.vala"
	g_error ("protocol.vala:421: deserialization not supported");
#line 8694 "protocol.c"
}

LspCompletionList*
lsp_completion_list_construct (GType object_type)
{
	LspCompletionList * self = NULL;
#line 391 "../src/protocol.vala"
	self = (LspCompletionList*) g_object_new (object_type, NULL);
#line 391 "../src/protocol.vala"
	return self;
#line 8705 "protocol.c"
}

LspCompletionList*
lsp_completion_list_new (void)
{
#line 391 "../src/protocol.vala"
	return lsp_completion_list_construct (LSP_TYPE_COMPLETION_LIST);
#line 8713 "protocol.c"
}

gboolean
lsp_completion_list_get_isIncomplete (LspCompletionList* self)
{
	gboolean result;
#line 392 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 392 "../src/protocol.vala"
	result = self->priv->_isIncomplete;
#line 392 "../src/protocol.vala"
	return result;
#line 8726 "protocol.c"
}

void
lsp_completion_list_set_isIncomplete (LspCompletionList* self,
                                      gboolean value)
{
	gboolean old_value;
#line 392 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 392 "../src/protocol.vala"
	old_value = lsp_completion_list_get_isIncomplete (self);
#line 392 "../src/protocol.vala"
	if (old_value != value) {
#line 392 "../src/protocol.vala"
		self->priv->_isIncomplete = value;
#line 392 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_completion_list_properties[LSP_COMPLETION_LIST_IS_INCOMPLETE_PROPERTY]);
#line 8744 "protocol.c"
	}
}

GeeList*
lsp_completion_list_get_items (LspCompletionList* self)
{
	GeeList* result;
	GeeList* _tmp0_;
#line 393 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 393 "../src/protocol.vala"
	_tmp0_ = self->priv->_items;
#line 393 "../src/protocol.vala"
	result = _tmp0_;
#line 393 "../src/protocol.vala"
	return result;
#line 8761 "protocol.c"
}

static void
lsp_completion_list_set_items (LspCompletionList* self,
                               GeeList* value)
{
	GeeList* old_value;
#line 393 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 393 "../src/protocol.vala"
	old_value = lsp_completion_list_get_items (self);
#line 393 "../src/protocol.vala"
	if (old_value != value) {
#line 8775 "protocol.c"
		GeeList* _tmp0_;
#line 393 "../src/protocol.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 393 "../src/protocol.vala"
		_g_object_unref0 (self->priv->_items);
#line 393 "../src/protocol.vala"
		self->priv->_items = _tmp0_;
#line 393 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_completion_list_properties[LSP_COMPLETION_LIST_ITEMS_PROPERTY]);
#line 8785 "protocol.c"
	}
}

static void
lsp_completion_list_class_init (LspCompletionListClass * klass,
                                gpointer klass_data)
{
#line 391 "../src/protocol.vala"
	lsp_completion_list_parent_class = g_type_class_peek_parent (klass);
#line 391 "../src/protocol.vala"
	g_type_class_adjust_private_offset (klass, &LspCompletionList_private_offset);
#line 391 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_lsp_completion_list_get_property;
#line 391 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_lsp_completion_list_set_property;
#line 391 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->finalize = lsp_completion_list_finalize;
#line 391 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_COMPLETION_LIST_IS_INCOMPLETE_PROPERTY, lsp_completion_list_properties[LSP_COMPLETION_LIST_IS_INCOMPLETE_PROPERTY] = g_param_spec_boolean ("isIncomplete", "isIncomplete", "isIncomplete", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 391 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_COMPLETION_LIST_ITEMS_PROPERTY, lsp_completion_list_properties[LSP_COMPLETION_LIST_ITEMS_PROPERTY] = g_param_spec_object ("items", "items", "items", GEE_TYPE_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 8807 "protocol.c"
}

static void
lsp_completion_list_json_serializable_interface_init (JsonSerializableIface * iface,
                                                      gpointer iface_data)
{
#line 391 "../src/protocol.vala"
	lsp_completion_list_json_serializable_parent_iface = g_type_interface_peek_parent (iface);
#line 391 "../src/protocol.vala"
	iface->set_property = (void (*) (JsonSerializable*, GParamSpec*, GValue*)) lsp_completion_list_real_json_serializable_set_property;
#line 391 "../src/protocol.vala"
	iface->get_property = (void (*) (JsonSerializable*, GParamSpec*, GValue*)) lsp_completion_list_real_json_serializable_get_property;
#line 391 "../src/protocol.vala"
	iface->find_property = (GParamSpec* (*) (JsonSerializable*, const gchar*)) lsp_completion_list_real_find_property;
#line 391 "../src/protocol.vala"
	iface->serialize_property = (JsonNode* (*) (JsonSerializable*, const gchar*, GValue*, GParamSpec*)) lsp_completion_list_real_serialize_property;
#line 391 "../src/protocol.vala"
	iface->deserialize_property = (gboolean (*) (JsonSerializable*, const gchar*, GValue*, GParamSpec*, JsonNode*)) lsp_completion_list_real_deserialize_property;
#line 8826 "protocol.c"
}

static void
lsp_completion_list_instance_init (LspCompletionList * self,
                                   gpointer klass)
{
	GeeLinkedList* _tmp0_;
#line 391 "../src/protocol.vala"
	self->priv = lsp_completion_list_get_instance_private (self);
#line 393 "../src/protocol.vala"
	_tmp0_ = gee_linked_list_new (LSP_TYPE_COMPLETION_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 393 "../src/protocol.vala"
	if (_tmp0_) {
#line 393 "../src/protocol.vala"
		g_object_set_data ((GObject *) _tmp0_, "vala-creation-function", "");
#line 8842 "protocol.c"
	}
#line 393 "../src/protocol.vala"
	self->priv->_items = (GeeList*) _tmp0_;
#line 8846 "protocol.c"
}

static void
lsp_completion_list_finalize (GObject * obj)
{
	LspCompletionList * self;
#line 391 "../src/protocol.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, LSP_TYPE_COMPLETION_LIST, LspCompletionList);
#line 393 "../src/protocol.vala"
	_g_object_unref0 (self->priv->_items);
#line 391 "../src/protocol.vala"
	G_OBJECT_CLASS (lsp_completion_list_parent_class)->finalize (obj);
#line 8859 "protocol.c"
}

 G_GNUC_NO_INLINE static GType
lsp_completion_list_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (LspCompletionListClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) lsp_completion_list_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LspCompletionList), 0, (GInstanceInitFunc) lsp_completion_list_instance_init, NULL };
	static const GInterfaceInfo json_serializable_info = { (GInterfaceInitFunc) lsp_completion_list_json_serializable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType lsp_completion_list_type_id;
	lsp_completion_list_type_id = g_type_register_static (G_TYPE_OBJECT, "LspCompletionList", &g_define_type_info, 0);
	g_type_add_interface_static (lsp_completion_list_type_id, json_serializable_get_type (), &json_serializable_info);
	LspCompletionList_private_offset = g_type_add_instance_private (lsp_completion_list_type_id, sizeof (LspCompletionListPrivate));
	return lsp_completion_list_type_id;
}

GType
lsp_completion_list_get_type (void)
{
	static gsize lsp_completion_list_type_id__once = 0;
	if (g_once_init_enter (&lsp_completion_list_type_id__once)) {
		GType lsp_completion_list_type_id;
		lsp_completion_list_type_id = lsp_completion_list_get_type_once ();
		g_once_init_leave (&lsp_completion_list_type_id__once, lsp_completion_list_type_id);
	}
	return lsp_completion_list_type_id__once;
}

static void
_vala_lsp_completion_list_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec)
{
	LspCompletionList * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_COMPLETION_LIST, LspCompletionList);
#line 391 "../src/protocol.vala"
	switch (property_id) {
#line 391 "../src/protocol.vala"
		case LSP_COMPLETION_LIST_IS_INCOMPLETE_PROPERTY:
#line 391 "../src/protocol.vala"
		g_value_set_boolean (value, lsp_completion_list_get_isIncomplete (self));
#line 391 "../src/protocol.vala"
		break;
#line 391 "../src/protocol.vala"
		case LSP_COMPLETION_LIST_ITEMS_PROPERTY:
#line 391 "../src/protocol.vala"
		g_value_set_object (value, lsp_completion_list_get_items (self));
#line 391 "../src/protocol.vala"
		break;
#line 8908 "protocol.c"
		default:
#line 391 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 391 "../src/protocol.vala"
		break;
#line 8914 "protocol.c"
	}
}

static void
_vala_lsp_completion_list_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec)
{
	LspCompletionList * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_COMPLETION_LIST, LspCompletionList);
#line 391 "../src/protocol.vala"
	switch (property_id) {
#line 391 "../src/protocol.vala"
		case LSP_COMPLETION_LIST_IS_INCOMPLETE_PROPERTY:
#line 391 "../src/protocol.vala"
		lsp_completion_list_set_isIncomplete (self, g_value_get_boolean (value));
#line 391 "../src/protocol.vala"
		break;
#line 391 "../src/protocol.vala"
		case LSP_COMPLETION_LIST_ITEMS_PROPERTY:
#line 391 "../src/protocol.vala"
		lsp_completion_list_set_items (self, g_value_get_object (value));
#line 391 "../src/protocol.vala"
		break;
#line 8940 "protocol.c"
		default:
#line 391 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 391 "../src/protocol.vala"
		break;
#line 8946 "protocol.c"
	}
}

 G_GNUC_NO_INLINE static GType
lsp_completion_trigger_kind_get_type_once (void)
{
	static const GEnumValue values[] = {{LSP_COMPLETION_TRIGGER_KIND_Invoked, "LSP_COMPLETION_TRIGGER_KIND_Invoked", "invoked"}, {LSP_COMPLETION_TRIGGER_KIND_TriggerCharacter, "LSP_COMPLETION_TRIGGER_KIND_TriggerCharacter", "triggercharacter"}, {LSP_COMPLETION_TRIGGER_KIND_TriggerForIncompleteCompletions, "LSP_COMPLETION_TRIGGER_KIND_TriggerForIncompleteCompletions", "triggerforincompletecompletions"}, {0, NULL, NULL}};
	GType lsp_completion_trigger_kind_type_id;
	lsp_completion_trigger_kind_type_id = g_enum_register_static ("LspCompletionTriggerKind", values);
	return lsp_completion_trigger_kind_type_id;
}

GType
lsp_completion_trigger_kind_get_type (void)
{
	static gsize lsp_completion_trigger_kind_type_id__once = 0;
	if (g_once_init_enter (&lsp_completion_trigger_kind_type_id__once)) {
		GType lsp_completion_trigger_kind_type_id;
		lsp_completion_trigger_kind_type_id = lsp_completion_trigger_kind_get_type_once ();
		g_once_init_leave (&lsp_completion_trigger_kind_type_id__once, lsp_completion_trigger_kind_type_id);
	}
	return lsp_completion_trigger_kind_type_id__once;
}

static inline gpointer
lsp_completion_context_get_instance_private (LspCompletionContext* self)
{
	return G_STRUCT_MEMBER_P (self, LspCompletionContext_private_offset);
}

LspCompletionContext*
lsp_completion_context_construct (GType object_type)
{
	LspCompletionContext * self = NULL;
#line 445 "../src/protocol.vala"
	self = (LspCompletionContext*) g_object_new (object_type, NULL);
#line 445 "../src/protocol.vala"
	return self;
#line 8985 "protocol.c"
}

LspCompletionContext*
lsp_completion_context_new (void)
{
#line 445 "../src/protocol.vala"
	return lsp_completion_context_construct (LSP_TYPE_COMPLETION_CONTEXT);
#line 8993 "protocol.c"
}

LspCompletionTriggerKind
lsp_completion_context_get_triggerKind (LspCompletionContext* self)
{
	LspCompletionTriggerKind result;
#line 446 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, LSP_COMPLETION_TRIGGER_KIND_Invoked);
#line 446 "../src/protocol.vala"
	result = self->priv->_triggerKind;
#line 446 "../src/protocol.vala"
	return result;
#line 9006 "protocol.c"
}

void
lsp_completion_context_set_triggerKind (LspCompletionContext* self,
                                        LspCompletionTriggerKind value)
{
	LspCompletionTriggerKind old_value;
#line 446 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 446 "../src/protocol.vala"
	old_value = lsp_completion_context_get_triggerKind (self);
#line 446 "../src/protocol.vala"
	if (old_value != value) {
#line 446 "../src/protocol.vala"
		self->priv->_triggerKind = value;
#line 446 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_completion_context_properties[LSP_COMPLETION_CONTEXT_TRIGGER_KIND_PROPERTY]);
#line 9024 "protocol.c"
	}
}

const gchar*
lsp_completion_context_get_triggerCharacter (LspCompletionContext* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 447 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 447 "../src/protocol.vala"
	_tmp0_ = self->priv->_triggerCharacter;
#line 447 "../src/protocol.vala"
	result = _tmp0_;
#line 447 "../src/protocol.vala"
	return result;
#line 9041 "protocol.c"
}

void
lsp_completion_context_set_triggerCharacter (LspCompletionContext* self,
                                             const gchar* value)
{
	gchar* old_value;
#line 447 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 447 "../src/protocol.vala"
	old_value = lsp_completion_context_get_triggerCharacter (self);
#line 447 "../src/protocol.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 9055 "protocol.c"
		gchar* _tmp0_;
#line 447 "../src/protocol.vala"
		_tmp0_ = g_strdup (value);
#line 447 "../src/protocol.vala"
		_g_free0 (self->priv->_triggerCharacter);
#line 447 "../src/protocol.vala"
		self->priv->_triggerCharacter = _tmp0_;
#line 447 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_completion_context_properties[LSP_COMPLETION_CONTEXT_TRIGGER_CHARACTER_PROPERTY]);
#line 9065 "protocol.c"
	}
}

static void
lsp_completion_context_class_init (LspCompletionContextClass * klass,
                                   gpointer klass_data)
{
#line 445 "../src/protocol.vala"
	lsp_completion_context_parent_class = g_type_class_peek_parent (klass);
#line 445 "../src/protocol.vala"
	g_type_class_adjust_private_offset (klass, &LspCompletionContext_private_offset);
#line 445 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_lsp_completion_context_get_property;
#line 445 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_lsp_completion_context_set_property;
#line 445 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->finalize = lsp_completion_context_finalize;
#line 445 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_COMPLETION_CONTEXT_TRIGGER_KIND_PROPERTY, lsp_completion_context_properties[LSP_COMPLETION_CONTEXT_TRIGGER_KIND_PROPERTY] = g_param_spec_enum ("triggerKind", "triggerKind", "triggerKind", LSP_TYPE_COMPLETION_TRIGGER_KIND, LSP_COMPLETION_TRIGGER_KIND_Invoked, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 445 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_COMPLETION_CONTEXT_TRIGGER_CHARACTER_PROPERTY, lsp_completion_context_properties[LSP_COMPLETION_CONTEXT_TRIGGER_CHARACTER_PROPERTY] = g_param_spec_string ("triggerCharacter", "triggerCharacter", "triggerCharacter", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 9087 "protocol.c"
}

static void
lsp_completion_context_instance_init (LspCompletionContext * self,
                                      gpointer klass)
{
#line 445 "../src/protocol.vala"
	self->priv = lsp_completion_context_get_instance_private (self);
#line 9096 "protocol.c"
}

static void
lsp_completion_context_finalize (GObject * obj)
{
	LspCompletionContext * self;
#line 445 "../src/protocol.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, LSP_TYPE_COMPLETION_CONTEXT, LspCompletionContext);
#line 447 "../src/protocol.vala"
	_g_free0 (self->priv->_triggerCharacter);
#line 445 "../src/protocol.vala"
	G_OBJECT_CLASS (lsp_completion_context_parent_class)->finalize (obj);
#line 9109 "protocol.c"
}

 G_GNUC_NO_INLINE static GType
lsp_completion_context_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (LspCompletionContextClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) lsp_completion_context_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LspCompletionContext), 0, (GInstanceInitFunc) lsp_completion_context_instance_init, NULL };
	GType lsp_completion_context_type_id;
	lsp_completion_context_type_id = g_type_register_static (G_TYPE_OBJECT, "LspCompletionContext", &g_define_type_info, 0);
	LspCompletionContext_private_offset = g_type_add_instance_private (lsp_completion_context_type_id, sizeof (LspCompletionContextPrivate));
	return lsp_completion_context_type_id;
}

GType
lsp_completion_context_get_type (void)
{
	static gsize lsp_completion_context_type_id__once = 0;
	if (g_once_init_enter (&lsp_completion_context_type_id__once)) {
		GType lsp_completion_context_type_id;
		lsp_completion_context_type_id = lsp_completion_context_get_type_once ();
		g_once_init_leave (&lsp_completion_context_type_id__once, lsp_completion_context_type_id);
	}
	return lsp_completion_context_type_id__once;
}

static void
_vala_lsp_completion_context_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec)
{
	LspCompletionContext * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_COMPLETION_CONTEXT, LspCompletionContext);
#line 445 "../src/protocol.vala"
	switch (property_id) {
#line 445 "../src/protocol.vala"
		case LSP_COMPLETION_CONTEXT_TRIGGER_KIND_PROPERTY:
#line 445 "../src/protocol.vala"
		g_value_set_enum (value, lsp_completion_context_get_triggerKind (self));
#line 445 "../src/protocol.vala"
		break;
#line 445 "../src/protocol.vala"
		case LSP_COMPLETION_CONTEXT_TRIGGER_CHARACTER_PROPERTY:
#line 445 "../src/protocol.vala"
		g_value_set_string (value, lsp_completion_context_get_triggerCharacter (self));
#line 445 "../src/protocol.vala"
		break;
#line 9156 "protocol.c"
		default:
#line 445 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 445 "../src/protocol.vala"
		break;
#line 9162 "protocol.c"
	}
}

static void
_vala_lsp_completion_context_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec)
{
	LspCompletionContext * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_COMPLETION_CONTEXT, LspCompletionContext);
#line 445 "../src/protocol.vala"
	switch (property_id) {
#line 445 "../src/protocol.vala"
		case LSP_COMPLETION_CONTEXT_TRIGGER_KIND_PROPERTY:
#line 445 "../src/protocol.vala"
		lsp_completion_context_set_triggerKind (self, g_value_get_enum (value));
#line 445 "../src/protocol.vala"
		break;
#line 445 "../src/protocol.vala"
		case LSP_COMPLETION_CONTEXT_TRIGGER_CHARACTER_PROPERTY:
#line 445 "../src/protocol.vala"
		lsp_completion_context_set_triggerCharacter (self, g_value_get_string (value));
#line 445 "../src/protocol.vala"
		break;
#line 9188 "protocol.c"
		default:
#line 445 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 445 "../src/protocol.vala"
		break;
#line 9194 "protocol.c"
	}
}

static inline gpointer
lsp_completion_params_get_instance_private (LspCompletionParams* self)
{
	return G_STRUCT_MEMBER_P (self, LspCompletionParams_private_offset);
}

LspCompletionParams*
lsp_completion_params_construct (GType object_type)
{
	LspCompletionParams * self = NULL;
#line 450 "../src/protocol.vala"
	self = (LspCompletionParams*) lsp_text_document_position_params_construct (object_type);
#line 450 "../src/protocol.vala"
	return self;
#line 9212 "protocol.c"
}

LspCompletionParams*
lsp_completion_params_new (void)
{
#line 450 "../src/protocol.vala"
	return lsp_completion_params_construct (LSP_TYPE_COMPLETION_PARAMS);
#line 9220 "protocol.c"
}

LspCompletionContext*
lsp_completion_params_get_context (LspCompletionParams* self)
{
	LspCompletionContext* result;
	LspCompletionContext* _tmp0_;
#line 455 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 455 "../src/protocol.vala"
	_tmp0_ = self->priv->_context;
#line 455 "../src/protocol.vala"
	result = _tmp0_;
#line 455 "../src/protocol.vala"
	return result;
#line 9236 "protocol.c"
}

void
lsp_completion_params_set_context (LspCompletionParams* self,
                                   LspCompletionContext* value)
{
	LspCompletionContext* old_value;
#line 455 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 455 "../src/protocol.vala"
	old_value = lsp_completion_params_get_context (self);
#line 455 "../src/protocol.vala"
	if (old_value != value) {
#line 9250 "protocol.c"
		LspCompletionContext* _tmp0_;
#line 455 "../src/protocol.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 455 "../src/protocol.vala"
		_g_object_unref0 (self->priv->_context);
#line 455 "../src/protocol.vala"
		self->priv->_context = _tmp0_;
#line 455 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_completion_params_properties[LSP_COMPLETION_PARAMS_CONTEXT_PROPERTY]);
#line 9260 "protocol.c"
	}
}

static void
lsp_completion_params_class_init (LspCompletionParamsClass * klass,
                                  gpointer klass_data)
{
#line 450 "../src/protocol.vala"
	lsp_completion_params_parent_class = g_type_class_peek_parent (klass);
#line 450 "../src/protocol.vala"
	g_type_class_adjust_private_offset (klass, &LspCompletionParams_private_offset);
#line 450 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_lsp_completion_params_get_property;
#line 450 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_lsp_completion_params_set_property;
#line 450 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->finalize = lsp_completion_params_finalize;
#line 9278 "protocol.c"
	/**
	         * The completion context. This is only available if the client specifies
	         * to send this using `ClientCapabilities.textDocument.completion.contextSupport === true`
	         */
#line 450 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_COMPLETION_PARAMS_CONTEXT_PROPERTY, lsp_completion_params_properties[LSP_COMPLETION_PARAMS_CONTEXT_PROPERTY] = g_param_spec_object ("context", "context", "context", LSP_TYPE_COMPLETION_CONTEXT, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 9285 "protocol.c"
}

static void
lsp_completion_params_instance_init (LspCompletionParams * self,
                                     gpointer klass)
{
#line 450 "../src/protocol.vala"
	self->priv = lsp_completion_params_get_instance_private (self);
#line 9294 "protocol.c"
}

static void
lsp_completion_params_finalize (GObject * obj)
{
	LspCompletionParams * self;
#line 450 "../src/protocol.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, LSP_TYPE_COMPLETION_PARAMS, LspCompletionParams);
#line 455 "../src/protocol.vala"
	_g_object_unref0 (self->priv->_context);
#line 450 "../src/protocol.vala"
	G_OBJECT_CLASS (lsp_completion_params_parent_class)->finalize (obj);
#line 9307 "protocol.c"
}

 G_GNUC_NO_INLINE static GType
lsp_completion_params_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (LspCompletionParamsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) lsp_completion_params_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LspCompletionParams), 0, (GInstanceInitFunc) lsp_completion_params_instance_init, NULL };
	GType lsp_completion_params_type_id;
	lsp_completion_params_type_id = g_type_register_static (LSP_TYPE_TEXT_DOCUMENT_POSITION_PARAMS, "LspCompletionParams", &g_define_type_info, 0);
	LspCompletionParams_private_offset = g_type_add_instance_private (lsp_completion_params_type_id, sizeof (LspCompletionParamsPrivate));
	return lsp_completion_params_type_id;
}

GType
lsp_completion_params_get_type (void)
{
	static gsize lsp_completion_params_type_id__once = 0;
	if (g_once_init_enter (&lsp_completion_params_type_id__once)) {
		GType lsp_completion_params_type_id;
		lsp_completion_params_type_id = lsp_completion_params_get_type_once ();
		g_once_init_leave (&lsp_completion_params_type_id__once, lsp_completion_params_type_id);
	}
	return lsp_completion_params_type_id__once;
}

static void
_vala_lsp_completion_params_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec)
{
	LspCompletionParams * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_COMPLETION_PARAMS, LspCompletionParams);
#line 450 "../src/protocol.vala"
	switch (property_id) {
#line 450 "../src/protocol.vala"
		case LSP_COMPLETION_PARAMS_CONTEXT_PROPERTY:
#line 450 "../src/protocol.vala"
		g_value_set_object (value, lsp_completion_params_get_context (self));
#line 450 "../src/protocol.vala"
		break;
#line 9348 "protocol.c"
		default:
#line 450 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 450 "../src/protocol.vala"
		break;
#line 9354 "protocol.c"
	}
}

static void
_vala_lsp_completion_params_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec)
{
	LspCompletionParams * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_COMPLETION_PARAMS, LspCompletionParams);
#line 450 "../src/protocol.vala"
	switch (property_id) {
#line 450 "../src/protocol.vala"
		case LSP_COMPLETION_PARAMS_CONTEXT_PROPERTY:
#line 450 "../src/protocol.vala"
		lsp_completion_params_set_context (self, g_value_get_object (value));
#line 450 "../src/protocol.vala"
		break;
#line 9374 "protocol.c"
		default:
#line 450 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 450 "../src/protocol.vala"
		break;
#line 9380 "protocol.c"
	}
}

 G_GNUC_NO_INLINE static GType
lsp_completion_item_tag_get_type_once (void)
{
	static const GEnumValue values[] = {{LSP_COMPLETION_ITEM_TAG_Deprecated, "LSP_COMPLETION_ITEM_TAG_Deprecated", "deprecated"}, {0, NULL, NULL}};
	GType lsp_completion_item_tag_type_id;
	lsp_completion_item_tag_type_id = g_enum_register_static ("LspCompletionItemTag", values);
	return lsp_completion_item_tag_type_id;
}

GType
lsp_completion_item_tag_get_type (void)
{
	static gsize lsp_completion_item_tag_type_id__once = 0;
	if (g_once_init_enter (&lsp_completion_item_tag_type_id__once)) {
		GType lsp_completion_item_tag_type_id;
		lsp_completion_item_tag_type_id = lsp_completion_item_tag_get_type_once ();
		g_once_init_leave (&lsp_completion_item_tag_type_id__once, lsp_completion_item_tag_type_id);
	}
	return lsp_completion_item_tag_type_id__once;
}

 G_GNUC_NO_INLINE static GType
lsp_insert_text_format_get_type_once (void)
{
	static const GEnumValue values[] = {{LSP_INSERT_TEXT_FORMAT_PlainText, "LSP_INSERT_TEXT_FORMAT_PlainText", "plaintext"}, {LSP_INSERT_TEXT_FORMAT_Snippet, "LSP_INSERT_TEXT_FORMAT_Snippet", "snippet"}, {0, NULL, NULL}};
	GType lsp_insert_text_format_type_id;
	lsp_insert_text_format_type_id = g_enum_register_static ("LspInsertTextFormat", values);
	return lsp_insert_text_format_type_id;
}

GType
lsp_insert_text_format_get_type (void)
{
	static gsize lsp_insert_text_format_type_id__once = 0;
	if (g_once_init_enter (&lsp_insert_text_format_type_id__once)) {
		GType lsp_insert_text_format_type_id;
		lsp_insert_text_format_type_id = lsp_insert_text_format_get_type_once ();
		g_once_init_leave (&lsp_insert_text_format_type_id__once, lsp_insert_text_format_type_id);
	}
	return lsp_insert_text_format_type_id__once;
}

static inline gpointer
lsp_completion_item_get_instance_private (LspCompletionItem* self)
{
	return G_STRUCT_MEMBER_P (self, LspCompletionItem_private_offset);
}

static LspCompletionItem*
lsp_completion_item_construct (GType object_type)
{
	LspCompletionItem * self = NULL;
#line 492 "../src/protocol.vala"
	self = (LspCompletionItem*) g_object_new (object_type, NULL);
#line 492 "../src/protocol.vala"
	return self;
#line 9440 "protocol.c"
}

static LspCompletionItem*
lsp_completion_item_new (void)
{
#line 492 "../src/protocol.vala"
	return lsp_completion_item_construct (LSP_TYPE_COMPLETION_ITEM);
#line 9448 "protocol.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1585 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1585 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1585 "glib-2.0.vapi"
	return result;
#line 9467 "protocol.c"
}

LspCompletionItem*
lsp_completion_item_construct_keyword (GType object_type,
                                       const gchar* keyword,
                                       const gchar* insert_text,
                                       const gchar* documentation)
{
	LspCompletionItem * self = NULL;
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	LspCompletionItemKind _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
#line 494 "../src/protocol.vala"
	g_return_val_if_fail (keyword != NULL, NULL);
#line 494 "../src/protocol.vala"
	self = (LspCompletionItem*) g_object_new (object_type, NULL);
#line 495 "../src/protocol.vala"
	lsp_completion_item_set_label (self, keyword);
#line 496 "../src/protocol.vala"
	lsp_completion_item_set_kind (self, LSP_COMPLETION_ITEM_KIND_Keyword);
#line 497 "../src/protocol.vala"
	lsp_completion_item_set_insertText (self, insert_text);
#line 498 "../src/protocol.vala"
	if (insert_text != NULL) {
#line 9496 "protocol.c"
		gboolean _tmp1_ = FALSE;
#line 498 "../src/protocol.vala"
		if (string_contains (insert_text, "$0")) {
#line 498 "../src/protocol.vala"
			_tmp1_ = TRUE;
#line 9502 "protocol.c"
		} else {
#line 498 "../src/protocol.vala"
			_tmp1_ = string_contains (insert_text, "${0");
#line 9506 "protocol.c"
		}
#line 498 "../src/protocol.vala"
		_tmp0_ = _tmp1_;
#line 9510 "protocol.c"
	} else {
#line 498 "../src/protocol.vala"
		_tmp0_ = FALSE;
#line 9514 "protocol.c"
	}
#line 498 "../src/protocol.vala"
	if (_tmp0_) {
#line 499 "../src/protocol.vala"
		lsp_completion_item_set_insertTextFormat (self, LSP_INSERT_TEXT_FORMAT_Snippet);
#line 9520 "protocol.c"
	}
#line 500 "../src/protocol.vala"
	if (documentation != NULL) {
#line 9524 "protocol.c"
		LspMarkupContent* _tmp2_;
		LspMarkupContent* _tmp3_;
#line 501 "../src/protocol.vala"
		_tmp2_ = lsp_markup_content_new_from_plaintext (documentation);
#line 501 "../src/protocol.vala"
		if (_tmp2_) {
#line 501 "../src/protocol.vala"
			g_object_set_data ((GObject *) _tmp2_, "vala-creation-function", "Lsp.CompletionItem.keyword");
#line 9533 "protocol.c"
		}
#line 501 "../src/protocol.vala"
		_tmp3_ = _tmp2_;
#line 501 "../src/protocol.vala"
		lsp_completion_item_set_documentation (self, _tmp3_);
#line 501 "../src/protocol.vala"
		_g_object_unref0 (_tmp3_);
#line 9541 "protocol.c"
	}
#line 502 "../src/protocol.vala"
	_tmp4_ = self->priv->_label;
#line 502 "../src/protocol.vala"
	_tmp5_ = string_to_string (_tmp4_);
#line 502 "../src/protocol.vala"
	_tmp6_ = self->priv->_kind;
#line 502 "../src/protocol.vala"
	_tmp7_ = g_enum_to_string (LSP_TYPE_COMPLETION_ITEM_KIND, _tmp6_);
#line 502 "../src/protocol.vala"
	_tmp8_ = g_strconcat (_tmp5_, " ", _tmp7_, NULL);
#line 502 "../src/protocol.vala"
	_tmp9_ = _tmp8_;
#line 502 "../src/protocol.vala"
	self->priv->_hash = g_str_hash (_tmp9_);
#line 502 "../src/protocol.vala"
	_g_free0 (_tmp9_);
#line 502 "../src/protocol.vala"
	_g_free0 (_tmp7_);
#line 494 "../src/protocol.vala"
	return self;
#line 9563 "protocol.c"
}

LspCompletionItem*
lsp_completion_item_new_keyword (const gchar* keyword,
                                 const gchar* insert_text,
                                 const gchar* documentation)
{
#line 494 "../src/protocol.vala"
	return lsp_completion_item_construct_keyword (LSP_TYPE_COMPLETION_ITEM, keyword, insert_text, documentation);
#line 9573 "protocol.c"
}

/**
         * A completion suggestion from an existing Vala symbol.
         * 
         * @param instance_type the parent data type of data type of the expression where this symbol appears, or null
         * @param sym the symbol itself
         * @param scope the scope to display this in
         * @param kind the kind of completion to display
         * @param documentation the documentation to display
         * @param label_override if non-null, override the displayed symbol name with this
         */
LspCompletionItem*
lsp_completion_item_construct_from_symbol (GType object_type,
                                           ValaDataType* instance_type,
                                           ValaSymbol* sym,
                                           ValaScope* scope,
                                           LspCompletionItemKind kind,
                                           VlsDocComment* documentation,
                                           const gchar* label_override)
{
	LspCompletionItem * self = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	ValaAttribute* version = NULL;
	ValaAttribute* _tmp14_;
	ValaAttribute* _tmp15_;
	gboolean _tmp16_ = FALSE;
	ValaAttribute* _tmp17_;
#line 515 "../src/protocol.vala"
	g_return_val_if_fail (sym != NULL, NULL);
#line 515 "../src/protocol.vala"
	self = (LspCompletionItem*) g_object_new (object_type, NULL);
#line 517 "../src/protocol.vala"
	_tmp0_ = label_override;
#line 517 "../src/protocol.vala"
	if (_tmp0_ == NULL) {
#line 9617 "protocol.c"
		const gchar* _tmp1_;
		const gchar* _tmp2_;
#line 517 "../src/protocol.vala"
		_tmp1_ = vala_symbol_get_name (sym);
#line 517 "../src/protocol.vala"
		_tmp2_ = _tmp1_;
#line 517 "../src/protocol.vala"
		_tmp0_ = _tmp2_;
#line 9626 "protocol.c"
	}
#line 517 "../src/protocol.vala"
	lsp_completion_item_set_label (self, _tmp0_);
#line 518 "../src/protocol.vala"
	lsp_completion_item_set_kind (self, kind);
#line 519 "../src/protocol.vala"
	_tmp3_ = vls_code_help_get_symbol_representation (instance_type, sym, scope, TRUE, NULL, label_override, FALSE, FALSE, NULL, TRUE);
#line 519 "../src/protocol.vala"
	_tmp4_ = _tmp3_;
#line 519 "../src/protocol.vala"
	lsp_completion_item_set_detail (self, _tmp4_);
#line 519 "../src/protocol.vala"
	_g_free0 (_tmp4_);
#line 520 "../src/protocol.vala"
	_tmp5_ = self->priv->_label;
#line 520 "../src/protocol.vala"
	_tmp6_ = string_to_string (_tmp5_);
#line 520 "../src/protocol.vala"
	_tmp7_ = g_enum_to_string (LSP_TYPE_COMPLETION_ITEM_KIND, kind);
#line 520 "../src/protocol.vala"
	_tmp8_ = g_strconcat (_tmp6_, " ", _tmp7_, NULL);
#line 520 "../src/protocol.vala"
	_tmp9_ = _tmp8_;
#line 520 "../src/protocol.vala"
	self->priv->_hash = g_str_hash (_tmp9_);
#line 520 "../src/protocol.vala"
	_g_free0 (_tmp9_);
#line 520 "../src/protocol.vala"
	_g_free0 (_tmp7_);
#line 522 "../src/protocol.vala"
	if (documentation != NULL) {
#line 9658 "protocol.c"
		const gchar* _tmp10_;
		const gchar* _tmp11_;
		LspMarkupContent* _tmp12_;
		LspMarkupContent* _tmp13_;
#line 523 "../src/protocol.vala"
		_tmp10_ = vls_doc_comment_get_body (documentation);
#line 523 "../src/protocol.vala"
		_tmp11_ = _tmp10_;
#line 523 "../src/protocol.vala"
		_tmp12_ = lsp_markup_content_new_from_markdown (_tmp11_);
#line 523 "../src/protocol.vala"
		if (_tmp12_) {
#line 523 "../src/protocol.vala"
			g_object_set_data ((GObject *) _tmp12_, "vala-creation-function", "Lsp.CompletionItem.from_symbol");
#line 9673 "protocol.c"
		}
#line 523 "../src/protocol.vala"
		_tmp13_ = _tmp12_;
#line 523 "../src/protocol.vala"
		lsp_completion_item_set_documentation (self, _tmp13_);
#line 523 "../src/protocol.vala"
		_g_object_unref0 (_tmp13_);
#line 9681 "protocol.c"
	}
#line 525 "../src/protocol.vala"
	_tmp14_ = vala_code_node_get_attribute ((ValaCodeNode*) sym, "Version");
#line 525 "../src/protocol.vala"
	_tmp15_ = _vala_code_node_ref0 (_tmp14_);
#line 525 "../src/protocol.vala"
	version = _tmp15_;
#line 526 "../src/protocol.vala"
	_tmp17_ = version;
#line 526 "../src/protocol.vala"
	if (_tmp17_ != NULL) {
#line 9693 "protocol.c"
		gboolean _tmp18_ = FALSE;
		ValaAttribute* _tmp19_;
#line 526 "../src/protocol.vala"
		_tmp19_ = version;
#line 526 "../src/protocol.vala"
		if (vala_attribute_get_bool (_tmp19_, "deprecated", FALSE)) {
#line 526 "../src/protocol.vala"
			_tmp18_ = TRUE;
#line 9702 "protocol.c"
		} else {
			ValaAttribute* _tmp20_;
			gchar* _tmp21_;
			gchar* _tmp22_;
#line 526 "../src/protocol.vala"
			_tmp20_ = version;
#line 526 "../src/protocol.vala"
			_tmp21_ = vala_attribute_get_string (_tmp20_, "deprecated_since", NULL);
#line 526 "../src/protocol.vala"
			_tmp22_ = _tmp21_;
#line 526 "../src/protocol.vala"
			_tmp18_ = _tmp22_ != NULL;
#line 526 "../src/protocol.vala"
			_g_free0 (_tmp22_);
#line 9717 "protocol.c"
		}
#line 526 "../src/protocol.vala"
		_tmp16_ = _tmp18_;
#line 9721 "protocol.c"
	} else {
#line 526 "../src/protocol.vala"
		_tmp16_ = FALSE;
#line 9725 "protocol.c"
	}
#line 526 "../src/protocol.vala"
	if (_tmp16_) {
#line 9729 "protocol.c"
		GeeList* _tmp23_;
#line 527 "../src/protocol.vala"
		_tmp23_ = self->priv->_tags;
#line 527 "../src/protocol.vala"
		gee_collection_add ((GeeCollection*) _tmp23_, (gpointer) ((gintptr) LSP_COMPLETION_ITEM_TAG_Deprecated));
#line 528 "../src/protocol.vala"
		lsp_completion_item_set_deprecated (self, TRUE);
#line 9737 "protocol.c"
	}
#line 515 "../src/protocol.vala"
	_vala_code_node_unref0 (version);
#line 515 "../src/protocol.vala"
	return self;
#line 9743 "protocol.c"
}

LspCompletionItem*
lsp_completion_item_new_from_symbol (ValaDataType* instance_type,
                                     ValaSymbol* sym,
                                     ValaScope* scope,
                                     LspCompletionItemKind kind,
                                     VlsDocComment* documentation,
                                     const gchar* label_override)
{
#line 515 "../src/protocol.vala"
	return lsp_completion_item_construct_from_symbol (LSP_TYPE_COMPLETION_ITEM, instance_type, sym, scope, kind, documentation, label_override);
#line 9756 "protocol.c"
}

/**
         * A completion suggestion from a data type and a synthetic symbol name.
         *
         * @param symbol_type       the data type of the symbol
         * @param symbol_name       the name of the synthetic symbol
         * @param scope             the scope that this completion item is displayed in, or null
         * @param kind              the type of completion to display
         * @param documentation     the documentation for this symbol, or null
         */
LspCompletionItem*
lsp_completion_item_construct_from_synthetic_symbol (GType object_type,
                                                     ValaDataType* symbol_type,
                                                     const gchar* symbol_name,
                                                     ValaScope* scope,
                                                     LspCompletionItemKind kind,
                                                     VlsDocComment* documentation)
{
	LspCompletionItem * self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
#line 541 "../src/protocol.vala"
	g_return_val_if_fail (symbol_type != NULL, NULL);
#line 541 "../src/protocol.vala"
	g_return_val_if_fail (symbol_name != NULL, NULL);
#line 541 "../src/protocol.vala"
	self = (LspCompletionItem*) g_object_new (object_type, NULL);
#line 543 "../src/protocol.vala"
	lsp_completion_item_set_label (self, symbol_name);
#line 544 "../src/protocol.vala"
	lsp_completion_item_set_kind (self, kind);
#line 545 "../src/protocol.vala"
	_tmp0_ = vls_code_help_get_symbol_representation (symbol_type, NULL, scope, TRUE, NULL, NULL, FALSE, FALSE, NULL, TRUE);
#line 545 "../src/protocol.vala"
	_tmp1_ = _tmp0_;
#line 545 "../src/protocol.vala"
	_tmp2_ = string_to_string (_tmp1_);
#line 545 "../src/protocol.vala"
	_tmp3_ = string_to_string (symbol_name);
#line 545 "../src/protocol.vala"
	_tmp4_ = g_strconcat (_tmp2_, " ", _tmp3_, NULL);
#line 545 "../src/protocol.vala"
	_tmp5_ = _tmp4_;
#line 545 "../src/protocol.vala"
	lsp_completion_item_set_detail (self, _tmp5_);
#line 545 "../src/protocol.vala"
	_g_free0 (_tmp5_);
#line 545 "../src/protocol.vala"
	_g_free0 (_tmp1_);
#line 546 "../src/protocol.vala"
	_tmp6_ = self->priv->_label;
#line 546 "../src/protocol.vala"
	_tmp7_ = string_to_string (_tmp6_);
#line 546 "../src/protocol.vala"
	_tmp8_ = g_enum_to_string (LSP_TYPE_COMPLETION_ITEM_KIND, kind);
#line 546 "../src/protocol.vala"
	_tmp9_ = g_strconcat (_tmp7_, " ", _tmp8_, NULL);
#line 546 "../src/protocol.vala"
	_tmp10_ = _tmp9_;
#line 546 "../src/protocol.vala"
	self->priv->_hash = g_str_hash (_tmp10_);
#line 546 "../src/protocol.vala"
	_g_free0 (_tmp10_);
#line 546 "../src/protocol.vala"
	_g_free0 (_tmp8_);
#line 548 "../src/protocol.vala"
	if (documentation != NULL) {
#line 9834 "protocol.c"
		const gchar* _tmp11_;
		const gchar* _tmp12_;
		LspMarkupContent* _tmp13_;
		LspMarkupContent* _tmp14_;
#line 549 "../src/protocol.vala"
		_tmp11_ = vls_doc_comment_get_body (documentation);
#line 549 "../src/protocol.vala"
		_tmp12_ = _tmp11_;
#line 549 "../src/protocol.vala"
		_tmp13_ = lsp_markup_content_new_from_markdown (_tmp12_);
#line 549 "../src/protocol.vala"
		if (_tmp13_) {
#line 549 "../src/protocol.vala"
			g_object_set_data ((GObject *) _tmp13_, "vala-creation-function", "Lsp.CompletionItem.from_synthetic_symbol");
#line 9849 "protocol.c"
		}
#line 549 "../src/protocol.vala"
		_tmp14_ = _tmp13_;
#line 549 "../src/protocol.vala"
		lsp_completion_item_set_documentation (self, _tmp14_);
#line 549 "../src/protocol.vala"
		_g_object_unref0 (_tmp14_);
#line 9857 "protocol.c"
	}
#line 541 "../src/protocol.vala"
	return self;
#line 9861 "protocol.c"
}

LspCompletionItem*
lsp_completion_item_new_from_synthetic_symbol (ValaDataType* symbol_type,
                                               const gchar* symbol_name,
                                               ValaScope* scope,
                                               LspCompletionItemKind kind,
                                               VlsDocComment* documentation)
{
#line 541 "../src/protocol.vala"
	return lsp_completion_item_construct_from_synthetic_symbol (LSP_TYPE_COMPLETION_ITEM, symbol_type, symbol_name, scope, kind, documentation);
#line 9873 "protocol.c"
}

LspCompletionItem*
lsp_completion_item_construct_from_unimplemented_symbol (GType object_type,
                                                         ValaSymbol* sym,
                                                         const gchar* label,
                                                         LspCompletionItemKind kind,
                                                         const gchar* insert_text,
                                                         VlsDocComment* documentation)
{
	LspCompletionItem * self = NULL;
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
#line 552 "../src/protocol.vala"
	g_return_val_if_fail (sym != NULL, NULL);
#line 552 "../src/protocol.vala"
	g_return_val_if_fail (label != NULL, NULL);
#line 552 "../src/protocol.vala"
	g_return_val_if_fail (insert_text != NULL, NULL);
#line 552 "../src/protocol.vala"
	self = (LspCompletionItem*) g_object_new (object_type, NULL);
#line 556 "../src/protocol.vala"
	lsp_completion_item_set_label (self, label);
#line 557 "../src/protocol.vala"
	lsp_completion_item_set_kind (self, kind);
#line 558 "../src/protocol.vala"
	lsp_completion_item_set_insertText (self, insert_text);
#line 559 "../src/protocol.vala"
	if (string_contains (insert_text, "$0")) {
#line 559 "../src/protocol.vala"
		_tmp0_ = TRUE;
#line 9908 "protocol.c"
	} else {
#line 559 "../src/protocol.vala"
		_tmp0_ = string_contains (insert_text, "${0");
#line 9912 "protocol.c"
	}
#line 559 "../src/protocol.vala"
	if (_tmp0_) {
#line 560 "../src/protocol.vala"
		lsp_completion_item_set_insertTextFormat (self, LSP_INSERT_TEXT_FORMAT_Snippet);
#line 9918 "protocol.c"
	}
#line 561 "../src/protocol.vala"
	_tmp1_ = string_to_string (label);
#line 561 "../src/protocol.vala"
	_tmp2_ = g_enum_to_string (LSP_TYPE_COMPLETION_ITEM_KIND, kind);
#line 561 "../src/protocol.vala"
	_tmp3_ = g_strconcat (_tmp1_, " ", _tmp2_, NULL);
#line 561 "../src/protocol.vala"
	_tmp4_ = _tmp3_;
#line 561 "../src/protocol.vala"
	self->priv->_hash = g_str_hash (_tmp4_);
#line 561 "../src/protocol.vala"
	_g_free0 (_tmp4_);
#line 561 "../src/protocol.vala"
	_g_free0 (_tmp2_);
#line 562 "../src/protocol.vala"
	if (documentation != NULL) {
#line 9936 "protocol.c"
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		LspMarkupContent* _tmp7_;
		LspMarkupContent* _tmp8_;
#line 563 "../src/protocol.vala"
		_tmp5_ = vls_doc_comment_get_body (documentation);
#line 563 "../src/protocol.vala"
		_tmp6_ = _tmp5_;
#line 563 "../src/protocol.vala"
		_tmp7_ = lsp_markup_content_new_from_markdown (_tmp6_);
#line 563 "../src/protocol.vala"
		if (_tmp7_) {
#line 563 "../src/protocol.vala"
			g_object_set_data ((GObject *) _tmp7_, "vala-creation-function", "Lsp.CompletionItem.from_unimplemented_symbol");
#line 9951 "protocol.c"
		}
#line 563 "../src/protocol.vala"
		_tmp8_ = _tmp7_;
#line 563 "../src/protocol.vala"
		lsp_completion_item_set_documentation (self, _tmp8_);
#line 563 "../src/protocol.vala"
		_g_object_unref0 (_tmp8_);
#line 9959 "protocol.c"
	}
#line 552 "../src/protocol.vala"
	return self;
#line 9963 "protocol.c"
}

LspCompletionItem*
lsp_completion_item_new_from_unimplemented_symbol (ValaSymbol* sym,
                                                   const gchar* label,
                                                   LspCompletionItemKind kind,
                                                   const gchar* insert_text,
                                                   VlsDocComment* documentation)
{
#line 552 "../src/protocol.vala"
	return lsp_completion_item_construct_from_unimplemented_symbol (LSP_TYPE_COMPLETION_ITEM, sym, label, kind, insert_text, documentation);
#line 9975 "protocol.c"
}

static guint
lsp_completion_item_real_hash (GeeHashable* base)
{
	LspCompletionItem * self;
	guint result;
#line 566 "../src/protocol.vala"
	self = (LspCompletionItem*) base;
#line 567 "../src/protocol.vala"
	result = self->priv->_hash;
#line 567 "../src/protocol.vala"
	return result;
#line 9989 "protocol.c"
}

static gboolean
lsp_completion_item_real_equal_to (GeeHashable* base,
                                   LspCompletionItem* other)
{
	LspCompletionItem * self;
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gboolean result;
#line 570 "../src/protocol.vala"
	self = (LspCompletionItem*) base;
#line 570 "../src/protocol.vala"
	g_return_val_if_fail (other != NULL, FALSE);
#line 571 "../src/protocol.vala"
	_tmp1_ = other->priv->_label;
#line 571 "../src/protocol.vala"
	_tmp2_ = self->priv->_label;
#line 571 "../src/protocol.vala"
	if (g_strcmp0 (_tmp1_, _tmp2_) == 0) {
#line 10011 "protocol.c"
		LspCompletionItemKind _tmp3_;
		LspCompletionItemKind _tmp4_;
#line 571 "../src/protocol.vala"
		_tmp3_ = other->priv->_kind;
#line 571 "../src/protocol.vala"
		_tmp4_ = self->priv->_kind;
#line 571 "../src/protocol.vala"
		_tmp0_ = _tmp3_ == _tmp4_;
#line 10020 "protocol.c"
	} else {
#line 571 "../src/protocol.vala"
		_tmp0_ = FALSE;
#line 10024 "protocol.c"
	}
#line 571 "../src/protocol.vala"
	result = _tmp0_;
#line 571 "../src/protocol.vala"
	return result;
#line 10030 "protocol.c"
}

static void
lsp_completion_item_real_json_serializable_set_property (JsonSerializable* base,
                                                         GParamSpec* pspec,
                                                         GValue* value)
{
	LspCompletionItem * self;
	const gchar* _tmp0_;
	GValue _tmp1_;
#line 574 "../src/protocol.vala"
	self = (LspCompletionItem*) base;
#line 574 "../src/protocol.vala"
	g_return_if_fail (pspec != NULL);
#line 574 "../src/protocol.vala"
	g_return_if_fail (value != NULL);
#line 575 "../src/protocol.vala"
	_tmp0_ = g_param_spec_get_name (pspec);
#line 575 "../src/protocol.vala"
	_tmp1_ = *value;
#line 575 "../src/protocol.vala"
	g_object_set_property (G_TYPE_CHECK_INSTANCE_CAST (self, G_TYPE_OBJECT, GObject), _tmp0_, &_tmp1_);
#line 10053 "protocol.c"
}

static void
lsp_completion_item_real_json_serializable_get_property (JsonSerializable* base,
                                                         GParamSpec* pspec,
                                                         GValue* result)
{
	LspCompletionItem * self;
	GValue val = {0};
	GValue _tmp0_ = {0};
	const gchar* _tmp1_;
#line 578 "../src/protocol.vala"
	self = (LspCompletionItem*) base;
#line 578 "../src/protocol.vala"
	g_return_if_fail (pspec != NULL);
#line 579 "../src/protocol.vala"
	g_value_init (&_tmp0_, pspec->value_type);
#line 579 "../src/protocol.vala"
	val = _tmp0_;
#line 580 "../src/protocol.vala"
	_tmp1_ = g_param_spec_get_name (pspec);
#line 580 "../src/protocol.vala"
	g_object_get_property (G_TYPE_CHECK_INSTANCE_CAST (self, G_TYPE_OBJECT, GObject), _tmp1_, &val);
#line 581 "../src/protocol.vala"
	*result = val;
#line 581 "../src/protocol.vala"
	return;
#line 10081 "protocol.c"
}

static GParamSpec*
lsp_completion_item_real_find_property (JsonSerializable* base,
                                        const gchar* name)
{
	LspCompletionItem * self;
	GObjectClass* _tmp0_;
	GParamSpec* _tmp1_;
	GParamSpec* result;
#line 584 "../src/protocol.vala"
	self = (LspCompletionItem*) base;
#line 584 "../src/protocol.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 585 "../src/protocol.vala"
	_tmp0_ = G_OBJECT_GET_CLASS ((GObject*) self);
#line 585 "../src/protocol.vala"
	_tmp1_ = g_object_class_find_property (_tmp0_, name);
#line 585 "../src/protocol.vala"
	result = _tmp1_;
#line 585 "../src/protocol.vala"
	return result;
#line 10104 "protocol.c"
}

static JsonNode*
lsp_completion_item_real_serialize_property (JsonSerializable* base,
                                             const gchar* property_name,
                                             GValue* value,
                                             GParamSpec* pspec)
{
	LspCompletionItem * self;
	JsonNode* node = NULL;
	JsonNode* _tmp2_;
	JsonNode* _tmp3_;
	JsonArray* _tmp4_;
	JsonArray* _tmp5_;
	JsonArray* array = NULL;
	JsonNode* _tmp6_;
	JsonArray* _tmp7_;
	JsonArray* _tmp8_;
	JsonNode* result;
#line 588 "../src/protocol.vala"
	self = (LspCompletionItem*) base;
#line 588 "../src/protocol.vala"
	g_return_val_if_fail (property_name != NULL, NULL);
#line 588 "../src/protocol.vala"
	g_return_val_if_fail (value != NULL, NULL);
#line 588 "../src/protocol.vala"
	g_return_val_if_fail (pspec != NULL, NULL);
#line 589 "../src/protocol.vala"
	if (g_strcmp0 (property_name, "tags") != 0) {
#line 10134 "protocol.c"
		GValue _tmp0_;
		JsonNode* _tmp1_;
#line 590 "../src/protocol.vala"
		_tmp0_ = *value;
#line 590 "../src/protocol.vala"
		_tmp1_ = json_serializable_default_serialize_property ((JsonSerializable*) self, property_name, &_tmp0_, pspec);
#line 590 "../src/protocol.vala"
		result = _tmp1_;
#line 590 "../src/protocol.vala"
		return result;
#line 10145 "protocol.c"
	}
#line 592 "../src/protocol.vala"
	_tmp2_ = json_node_new (JSON_NODE_ARRAY);
#line 592 "../src/protocol.vala"
	node = _tmp2_;
#line 593 "../src/protocol.vala"
	_tmp3_ = node;
#line 593 "../src/protocol.vala"
	_tmp4_ = json_array_new ();
#line 593 "../src/protocol.vala"
	_tmp5_ = _tmp4_;
#line 593 "../src/protocol.vala"
	json_node_init_array (_tmp3_, _tmp5_);
#line 593 "../src/protocol.vala"
	_json_array_unref0 (_tmp5_);
#line 594 "../src/protocol.vala"
	_tmp6_ = node;
#line 594 "../src/protocol.vala"
	_tmp7_ = json_node_get_array (_tmp6_);
#line 594 "../src/protocol.vala"
	_tmp8_ = _json_array_ref0 (_tmp7_);
#line 594 "../src/protocol.vala"
	array = _tmp8_;
#line 10169 "protocol.c"
	{
		GeeList* _tag_list = NULL;
		GeeList* _tmp9_;
		gint _tag_size = 0;
		GeeList* _tmp10_;
		gint _tmp11_;
		gint _tmp12_;
		gint _tag_index = 0;
#line 595 "../src/protocol.vala"
		_tmp9_ = self->priv->_tags;
#line 595 "../src/protocol.vala"
		_tag_list = _tmp9_;
#line 595 "../src/protocol.vala"
		_tmp10_ = _tag_list;
#line 595 "../src/protocol.vala"
		_tmp11_ = gee_collection_get_size ((GeeCollection*) _tmp10_);
#line 595 "../src/protocol.vala"
		_tmp12_ = _tmp11_;
#line 595 "../src/protocol.vala"
		_tag_size = _tmp12_;
#line 595 "../src/protocol.vala"
		_tag_index = -1;
#line 595 "../src/protocol.vala"
		while (TRUE) {
#line 10194 "protocol.c"
			gint _tmp13_;
			gint _tmp14_;
			LspCompletionItemTag tag = 0;
			GeeList* _tmp15_;
			gpointer _tmp16_;
			JsonArray* _tmp17_;
#line 595 "../src/protocol.vala"
			_tag_index = _tag_index + 1;
#line 595 "../src/protocol.vala"
			_tmp13_ = _tag_index;
#line 595 "../src/protocol.vala"
			_tmp14_ = _tag_size;
#line 595 "../src/protocol.vala"
			if (!(_tmp13_ < _tmp14_)) {
#line 595 "../src/protocol.vala"
				break;
#line 10211 "protocol.c"
			}
#line 595 "../src/protocol.vala"
			_tmp15_ = _tag_list;
#line 595 "../src/protocol.vala"
			_tmp16_ = gee_list_get (_tmp15_, _tag_index);
#line 595 "../src/protocol.vala"
			tag = (LspCompletionItemTag) ((gintptr) _tmp16_);
#line 596 "../src/protocol.vala"
			_tmp17_ = array;
#line 596 "../src/protocol.vala"
			json_array_add_int_element (_tmp17_, (gint64) tag);
#line 10223 "protocol.c"
		}
	}
#line 599 "../src/protocol.vala"
	result = node;
#line 599 "../src/protocol.vala"
	_json_array_unref0 (array);
#line 599 "../src/protocol.vala"
	return result;
#line 10232 "protocol.c"
}

static gboolean
lsp_completion_item_real_deserialize_property (JsonSerializable* base,
                                               const gchar* property_name,
                                               GValue* value,
                                               GParamSpec* pspec,
                                               JsonNode* property_node)
{
	LspCompletionItem * self;
	GValue _vala_value = {0};
#line 602 "../src/protocol.vala"
	self = (LspCompletionItem*) base;
#line 602 "../src/protocol.vala"
	g_return_val_if_fail (property_name != NULL, FALSE);
#line 602 "../src/protocol.vala"
	g_return_val_if_fail (pspec != NULL, FALSE);
#line 602 "../src/protocol.vala"
	g_return_val_if_fail (property_node != NULL, FALSE);
#line 603 "../src/protocol.vala"
	g_error ("protocol.vala:603: deserialization not supported");
#line 10254 "protocol.c"
}

const gchar*
lsp_completion_item_get_label (LspCompletionItem* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 482 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 482 "../src/protocol.vala"
	_tmp0_ = self->priv->_label;
#line 482 "../src/protocol.vala"
	result = _tmp0_;
#line 482 "../src/protocol.vala"
	return result;
#line 10270 "protocol.c"
}

void
lsp_completion_item_set_label (LspCompletionItem* self,
                               const gchar* value)
{
	gchar* old_value;
#line 482 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 482 "../src/protocol.vala"
	old_value = lsp_completion_item_get_label (self);
#line 482 "../src/protocol.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 10284 "protocol.c"
		gchar* _tmp0_;
#line 482 "../src/protocol.vala"
		_tmp0_ = g_strdup (value);
#line 482 "../src/protocol.vala"
		_g_free0 (self->priv->_label);
#line 482 "../src/protocol.vala"
		self->priv->_label = _tmp0_;
#line 482 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_completion_item_properties[LSP_COMPLETION_ITEM_LABEL_PROPERTY]);
#line 10294 "protocol.c"
	}
}

LspCompletionItemKind
lsp_completion_item_get_kind (LspCompletionItem* self)
{
	LspCompletionItemKind result;
#line 483 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, LSP_COMPLETION_ITEM_KIND_Text);
#line 483 "../src/protocol.vala"
	result = self->priv->_kind;
#line 483 "../src/protocol.vala"
	return result;
#line 10308 "protocol.c"
}

void
lsp_completion_item_set_kind (LspCompletionItem* self,
                              LspCompletionItemKind value)
{
	LspCompletionItemKind old_value;
#line 483 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 483 "../src/protocol.vala"
	old_value = lsp_completion_item_get_kind (self);
#line 483 "../src/protocol.vala"
	if (old_value != value) {
#line 483 "../src/protocol.vala"
		self->priv->_kind = value;
#line 483 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_completion_item_properties[LSP_COMPLETION_ITEM_KIND_PROPERTY]);
#line 10326 "protocol.c"
	}
}

const gchar*
lsp_completion_item_get_detail (LspCompletionItem* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 484 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 484 "../src/protocol.vala"
	_tmp0_ = self->priv->_detail;
#line 484 "../src/protocol.vala"
	result = _tmp0_;
#line 484 "../src/protocol.vala"
	return result;
#line 10343 "protocol.c"
}

void
lsp_completion_item_set_detail (LspCompletionItem* self,
                                const gchar* value)
{
	gchar* old_value;
#line 484 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 484 "../src/protocol.vala"
	old_value = lsp_completion_item_get_detail (self);
#line 484 "../src/protocol.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 10357 "protocol.c"
		gchar* _tmp0_;
#line 484 "../src/protocol.vala"
		_tmp0_ = g_strdup (value);
#line 484 "../src/protocol.vala"
		_g_free0 (self->priv->_detail);
#line 484 "../src/protocol.vala"
		self->priv->_detail = _tmp0_;
#line 484 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_completion_item_properties[LSP_COMPLETION_ITEM_DETAIL_PROPERTY]);
#line 10367 "protocol.c"
	}
}

LspMarkupContent*
lsp_completion_item_get_documentation (LspCompletionItem* self)
{
	LspMarkupContent* result;
	LspMarkupContent* _tmp0_;
#line 485 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 485 "../src/protocol.vala"
	_tmp0_ = self->priv->_documentation;
#line 485 "../src/protocol.vala"
	result = _tmp0_;
#line 485 "../src/protocol.vala"
	return result;
#line 10384 "protocol.c"
}

void
lsp_completion_item_set_documentation (LspCompletionItem* self,
                                       LspMarkupContent* value)
{
	LspMarkupContent* old_value;
#line 485 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 485 "../src/protocol.vala"
	old_value = lsp_completion_item_get_documentation (self);
#line 485 "../src/protocol.vala"
	if (old_value != value) {
#line 10398 "protocol.c"
		LspMarkupContent* _tmp0_;
#line 485 "../src/protocol.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 485 "../src/protocol.vala"
		_g_object_unref0 (self->priv->_documentation);
#line 485 "../src/protocol.vala"
		self->priv->_documentation = _tmp0_;
#line 485 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_completion_item_properties[LSP_COMPLETION_ITEM_DOCUMENTATION_PROPERTY]);
#line 10408 "protocol.c"
	}
}

gboolean
lsp_completion_item_get_deprecated (LspCompletionItem* self)
{
	gboolean result;
#line 486 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 486 "../src/protocol.vala"
	result = self->priv->_deprecated;
#line 486 "../src/protocol.vala"
	return result;
#line 10422 "protocol.c"
}

void
lsp_completion_item_set_deprecated (LspCompletionItem* self,
                                    gboolean value)
{
	gboolean old_value;
#line 486 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 486 "../src/protocol.vala"
	old_value = lsp_completion_item_get_deprecated (self);
#line 486 "../src/protocol.vala"
	if (old_value != value) {
#line 486 "../src/protocol.vala"
		self->priv->_deprecated = value;
#line 486 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_completion_item_properties[LSP_COMPLETION_ITEM_DEPRECATED_PROPERTY]);
#line 10440 "protocol.c"
	}
}

GeeList*
lsp_completion_item_get_tags (LspCompletionItem* self)
{
	GeeList* result;
	GeeList* _tmp0_;
#line 487 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 487 "../src/protocol.vala"
	_tmp0_ = self->priv->_tags;
#line 487 "../src/protocol.vala"
	result = _tmp0_;
#line 487 "../src/protocol.vala"
	return result;
#line 10457 "protocol.c"
}

static void
lsp_completion_item_set_tags (LspCompletionItem* self,
                              GeeList* value)
{
	GeeList* old_value;
#line 487 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 487 "../src/protocol.vala"
	old_value = lsp_completion_item_get_tags (self);
#line 487 "../src/protocol.vala"
	if (old_value != value) {
#line 10471 "protocol.c"
		GeeList* _tmp0_;
#line 487 "../src/protocol.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 487 "../src/protocol.vala"
		_g_object_unref0 (self->priv->_tags);
#line 487 "../src/protocol.vala"
		self->priv->_tags = _tmp0_;
#line 487 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_completion_item_properties[LSP_COMPLETION_ITEM_TAGS_PROPERTY]);
#line 10481 "protocol.c"
	}
}

const gchar*
lsp_completion_item_get_insertText (LspCompletionItem* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 488 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 488 "../src/protocol.vala"
	_tmp0_ = self->priv->_insertText;
#line 488 "../src/protocol.vala"
	result = _tmp0_;
#line 488 "../src/protocol.vala"
	return result;
#line 10498 "protocol.c"
}

void
lsp_completion_item_set_insertText (LspCompletionItem* self,
                                    const gchar* value)
{
	gchar* old_value;
#line 488 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 488 "../src/protocol.vala"
	old_value = lsp_completion_item_get_insertText (self);
#line 488 "../src/protocol.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 10512 "protocol.c"
		gchar* _tmp0_;
#line 488 "../src/protocol.vala"
		_tmp0_ = g_strdup (value);
#line 488 "../src/protocol.vala"
		_g_free0 (self->priv->_insertText);
#line 488 "../src/protocol.vala"
		self->priv->_insertText = _tmp0_;
#line 488 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_completion_item_properties[LSP_COMPLETION_ITEM_INSERT_TEXT_PROPERTY]);
#line 10522 "protocol.c"
	}
}

LspInsertTextFormat
lsp_completion_item_get_insertTextFormat (LspCompletionItem* self)
{
	LspInsertTextFormat result;
#line 489 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, LSP_INSERT_TEXT_FORMAT_PlainText);
#line 489 "../src/protocol.vala"
	result = self->priv->_insertTextFormat;
#line 489 "../src/protocol.vala"
	return result;
#line 10536 "protocol.c"
}

void
lsp_completion_item_set_insertTextFormat (LspCompletionItem* self,
                                          LspInsertTextFormat value)
{
	LspInsertTextFormat old_value;
#line 489 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 489 "../src/protocol.vala"
	old_value = lsp_completion_item_get_insertTextFormat (self);
#line 489 "../src/protocol.vala"
	if (old_value != value) {
#line 489 "../src/protocol.vala"
		self->priv->_insertTextFormat = value;
#line 489 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_completion_item_properties[LSP_COMPLETION_ITEM_INSERT_TEXT_FORMAT_PROPERTY]);
#line 10554 "protocol.c"
	}
}

static void
lsp_completion_item_class_init (LspCompletionItemClass * klass,
                                gpointer klass_data)
{
#line 481 "../src/protocol.vala"
	lsp_completion_item_parent_class = g_type_class_peek_parent (klass);
#line 481 "../src/protocol.vala"
	g_type_class_adjust_private_offset (klass, &LspCompletionItem_private_offset);
#line 481 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_lsp_completion_item_get_property;
#line 481 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_lsp_completion_item_set_property;
#line 481 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->finalize = lsp_completion_item_finalize;
#line 481 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_COMPLETION_ITEM_LABEL_PROPERTY, lsp_completion_item_properties[LSP_COMPLETION_ITEM_LABEL_PROPERTY] = g_param_spec_string ("label", "label", "label", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 481 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_COMPLETION_ITEM_KIND_PROPERTY, lsp_completion_item_properties[LSP_COMPLETION_ITEM_KIND_PROPERTY] = g_param_spec_enum ("kind", "kind", "kind", LSP_TYPE_COMPLETION_ITEM_KIND, LSP_COMPLETION_ITEM_KIND_Text, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 481 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_COMPLETION_ITEM_DETAIL_PROPERTY, lsp_completion_item_properties[LSP_COMPLETION_ITEM_DETAIL_PROPERTY] = g_param_spec_string ("detail", "detail", "detail", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 481 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_COMPLETION_ITEM_DOCUMENTATION_PROPERTY, lsp_completion_item_properties[LSP_COMPLETION_ITEM_DOCUMENTATION_PROPERTY] = g_param_spec_object ("documentation", "documentation", "documentation", LSP_TYPE_MARKUP_CONTENT, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 481 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_COMPLETION_ITEM_DEPRECATED_PROPERTY, lsp_completion_item_properties[LSP_COMPLETION_ITEM_DEPRECATED_PROPERTY] = g_param_spec_boolean ("deprecated", "deprecated", "deprecated", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 481 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_COMPLETION_ITEM_TAGS_PROPERTY, lsp_completion_item_properties[LSP_COMPLETION_ITEM_TAGS_PROPERTY] = g_param_spec_object ("tags", "tags", "tags", GEE_TYPE_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 481 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_COMPLETION_ITEM_INSERT_TEXT_PROPERTY, lsp_completion_item_properties[LSP_COMPLETION_ITEM_INSERT_TEXT_PROPERTY] = g_param_spec_string ("insertText", "insertText", "insertText", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 481 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_COMPLETION_ITEM_INSERT_TEXT_FORMAT_PROPERTY, lsp_completion_item_properties[LSP_COMPLETION_ITEM_INSERT_TEXT_FORMAT_PROPERTY] = g_param_spec_enum ("insertTextFormat", "insertTextFormat", "insertTextFormat", LSP_TYPE_INSERT_TEXT_FORMAT, LSP_INSERT_TEXT_FORMAT_PlainText, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 10588 "protocol.c"
}

static void
lsp_completion_item_gee_hashable_interface_init (GeeHashableIface * iface,
                                                 gpointer iface_data)
{
#line 481 "../src/protocol.vala"
	lsp_completion_item_gee_hashable_parent_iface = g_type_interface_peek_parent (iface);
#line 481 "../src/protocol.vala"
	iface->hash = (guint (*) (GeeHashable*)) lsp_completion_item_real_hash;
#line 481 "../src/protocol.vala"
	iface->equal_to = (gboolean (*) (GeeHashable*, gconstpointer)) lsp_completion_item_real_equal_to;
#line 10601 "protocol.c"
}

static void
lsp_completion_item_json_serializable_interface_init (JsonSerializableIface * iface,
                                                      gpointer iface_data)
{
#line 481 "../src/protocol.vala"
	lsp_completion_item_json_serializable_parent_iface = g_type_interface_peek_parent (iface);
#line 481 "../src/protocol.vala"
	iface->set_property = (void (*) (JsonSerializable*, GParamSpec*, GValue*)) lsp_completion_item_real_json_serializable_set_property;
#line 481 "../src/protocol.vala"
	iface->get_property = (void (*) (JsonSerializable*, GParamSpec*, GValue*)) lsp_completion_item_real_json_serializable_get_property;
#line 481 "../src/protocol.vala"
	iface->find_property = (GParamSpec* (*) (JsonSerializable*, const gchar*)) lsp_completion_item_real_find_property;
#line 481 "../src/protocol.vala"
	iface->serialize_property = (JsonNode* (*) (JsonSerializable*, const gchar*, GValue*, GParamSpec*)) lsp_completion_item_real_serialize_property;
#line 481 "../src/protocol.vala"
	iface->deserialize_property = (gboolean (*) (JsonSerializable*, const gchar*, GValue*, GParamSpec*, JsonNode*)) lsp_completion_item_real_deserialize_property;
#line 10620 "protocol.c"
}

static void
lsp_completion_item_instance_init (LspCompletionItem * self,
                                   gpointer klass)
{
	GeeArrayList* _tmp0_;
#line 481 "../src/protocol.vala"
	self->priv = lsp_completion_item_get_instance_private (self);
#line 487 "../src/protocol.vala"
	_tmp0_ = gee_array_list_new (LSP_TYPE_COMPLETION_ITEM_TAG, NULL, NULL, NULL, NULL, NULL);
#line 487 "../src/protocol.vala"
	if (_tmp0_) {
#line 487 "../src/protocol.vala"
		g_object_set_data ((GObject *) _tmp0_, "vala-creation-function", "");
#line 10636 "protocol.c"
	}
#line 487 "../src/protocol.vala"
	self->priv->_tags = (GeeList*) _tmp0_;
#line 489 "../src/protocol.vala"
	self->priv->_insertTextFormat = LSP_INSERT_TEXT_FORMAT_PlainText;
#line 10642 "protocol.c"
}

static void
lsp_completion_item_finalize (GObject * obj)
{
	LspCompletionItem * self;
#line 481 "../src/protocol.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, LSP_TYPE_COMPLETION_ITEM, LspCompletionItem);
#line 482 "../src/protocol.vala"
	_g_free0 (self->priv->_label);
#line 484 "../src/protocol.vala"
	_g_free0 (self->priv->_detail);
#line 485 "../src/protocol.vala"
	_g_object_unref0 (self->priv->_documentation);
#line 487 "../src/protocol.vala"
	_g_object_unref0 (self->priv->_tags);
#line 488 "../src/protocol.vala"
	_g_free0 (self->priv->_insertText);
#line 481 "../src/protocol.vala"
	G_OBJECT_CLASS (lsp_completion_item_parent_class)->finalize (obj);
#line 10663 "protocol.c"
}

 G_GNUC_NO_INLINE static GType
lsp_completion_item_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (LspCompletionItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) lsp_completion_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LspCompletionItem), 0, (GInstanceInitFunc) lsp_completion_item_instance_init, NULL };
	static const GInterfaceInfo gee_hashable_info = { (GInterfaceInitFunc) lsp_completion_item_gee_hashable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	static const GInterfaceInfo json_serializable_info = { (GInterfaceInitFunc) lsp_completion_item_json_serializable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType lsp_completion_item_type_id;
	lsp_completion_item_type_id = g_type_register_static (G_TYPE_OBJECT, "LspCompletionItem", &g_define_type_info, 0);
	g_type_add_interface_static (lsp_completion_item_type_id, GEE_TYPE_HASHABLE, &gee_hashable_info);
	g_type_add_interface_static (lsp_completion_item_type_id, json_serializable_get_type (), &json_serializable_info);
	LspCompletionItem_private_offset = g_type_add_instance_private (lsp_completion_item_type_id, sizeof (LspCompletionItemPrivate));
	return lsp_completion_item_type_id;
}

GType
lsp_completion_item_get_type (void)
{
	static gsize lsp_completion_item_type_id__once = 0;
	if (g_once_init_enter (&lsp_completion_item_type_id__once)) {
		GType lsp_completion_item_type_id;
		lsp_completion_item_type_id = lsp_completion_item_get_type_once ();
		g_once_init_leave (&lsp_completion_item_type_id__once, lsp_completion_item_type_id);
	}
	return lsp_completion_item_type_id__once;
}

static void
_vala_lsp_completion_item_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec)
{
	LspCompletionItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_COMPLETION_ITEM, LspCompletionItem);
#line 481 "../src/protocol.vala"
	switch (property_id) {
#line 481 "../src/protocol.vala"
		case LSP_COMPLETION_ITEM_LABEL_PROPERTY:
#line 481 "../src/protocol.vala"
		g_value_set_string (value, lsp_completion_item_get_label (self));
#line 481 "../src/protocol.vala"
		break;
#line 481 "../src/protocol.vala"
		case LSP_COMPLETION_ITEM_KIND_PROPERTY:
#line 481 "../src/protocol.vala"
		g_value_set_enum (value, lsp_completion_item_get_kind (self));
#line 481 "../src/protocol.vala"
		break;
#line 481 "../src/protocol.vala"
		case LSP_COMPLETION_ITEM_DETAIL_PROPERTY:
#line 481 "../src/protocol.vala"
		g_value_set_string (value, lsp_completion_item_get_detail (self));
#line 481 "../src/protocol.vala"
		break;
#line 481 "../src/protocol.vala"
		case LSP_COMPLETION_ITEM_DOCUMENTATION_PROPERTY:
#line 481 "../src/protocol.vala"
		g_value_set_object (value, lsp_completion_item_get_documentation (self));
#line 481 "../src/protocol.vala"
		break;
#line 481 "../src/protocol.vala"
		case LSP_COMPLETION_ITEM_DEPRECATED_PROPERTY:
#line 481 "../src/protocol.vala"
		g_value_set_boolean (value, lsp_completion_item_get_deprecated (self));
#line 481 "../src/protocol.vala"
		break;
#line 481 "../src/protocol.vala"
		case LSP_COMPLETION_ITEM_TAGS_PROPERTY:
#line 481 "../src/protocol.vala"
		g_value_set_object (value, lsp_completion_item_get_tags (self));
#line 481 "../src/protocol.vala"
		break;
#line 481 "../src/protocol.vala"
		case LSP_COMPLETION_ITEM_INSERT_TEXT_PROPERTY:
#line 481 "../src/protocol.vala"
		g_value_set_string (value, lsp_completion_item_get_insertText (self));
#line 481 "../src/protocol.vala"
		break;
#line 481 "../src/protocol.vala"
		case LSP_COMPLETION_ITEM_INSERT_TEXT_FORMAT_PROPERTY:
#line 481 "../src/protocol.vala"
		g_value_set_enum (value, lsp_completion_item_get_insertTextFormat (self));
#line 481 "../src/protocol.vala"
		break;
#line 10750 "protocol.c"
		default:
#line 481 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 481 "../src/protocol.vala"
		break;
#line 10756 "protocol.c"
	}
}

static void
_vala_lsp_completion_item_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec)
{
	LspCompletionItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_COMPLETION_ITEM, LspCompletionItem);
#line 481 "../src/protocol.vala"
	switch (property_id) {
#line 481 "../src/protocol.vala"
		case LSP_COMPLETION_ITEM_LABEL_PROPERTY:
#line 481 "../src/protocol.vala"
		lsp_completion_item_set_label (self, g_value_get_string (value));
#line 481 "../src/protocol.vala"
		break;
#line 481 "../src/protocol.vala"
		case LSP_COMPLETION_ITEM_KIND_PROPERTY:
#line 481 "../src/protocol.vala"
		lsp_completion_item_set_kind (self, g_value_get_enum (value));
#line 481 "../src/protocol.vala"
		break;
#line 481 "../src/protocol.vala"
		case LSP_COMPLETION_ITEM_DETAIL_PROPERTY:
#line 481 "../src/protocol.vala"
		lsp_completion_item_set_detail (self, g_value_get_string (value));
#line 481 "../src/protocol.vala"
		break;
#line 481 "../src/protocol.vala"
		case LSP_COMPLETION_ITEM_DOCUMENTATION_PROPERTY:
#line 481 "../src/protocol.vala"
		lsp_completion_item_set_documentation (self, g_value_get_object (value));
#line 481 "../src/protocol.vala"
		break;
#line 481 "../src/protocol.vala"
		case LSP_COMPLETION_ITEM_DEPRECATED_PROPERTY:
#line 481 "../src/protocol.vala"
		lsp_completion_item_set_deprecated (self, g_value_get_boolean (value));
#line 481 "../src/protocol.vala"
		break;
#line 481 "../src/protocol.vala"
		case LSP_COMPLETION_ITEM_TAGS_PROPERTY:
#line 481 "../src/protocol.vala"
		lsp_completion_item_set_tags (self, g_value_get_object (value));
#line 481 "../src/protocol.vala"
		break;
#line 481 "../src/protocol.vala"
		case LSP_COMPLETION_ITEM_INSERT_TEXT_PROPERTY:
#line 481 "../src/protocol.vala"
		lsp_completion_item_set_insertText (self, g_value_get_string (value));
#line 481 "../src/protocol.vala"
		break;
#line 481 "../src/protocol.vala"
		case LSP_COMPLETION_ITEM_INSERT_TEXT_FORMAT_PROPERTY:
#line 481 "../src/protocol.vala"
		lsp_completion_item_set_insertTextFormat (self, g_value_get_enum (value));
#line 481 "../src/protocol.vala"
		break;
#line 10818 "protocol.c"
		default:
#line 481 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 481 "../src/protocol.vala"
		break;
#line 10824 "protocol.c"
	}
}

static inline gpointer
lsp_markup_content_get_instance_private (LspMarkupContent* self)
{
	return G_STRUCT_MEMBER_P (self, LspMarkupContent_private_offset);
}

static LspMarkupContent*
lsp_markup_content_construct (GType object_type)
{
	LspMarkupContent * self = NULL;
#line 611 "../src/protocol.vala"
	self = (LspMarkupContent*) g_object_new (object_type, NULL);
#line 611 "../src/protocol.vala"
	return self;
#line 10842 "protocol.c"
}

static LspMarkupContent*
lsp_markup_content_new (void)
{
#line 611 "../src/protocol.vala"
	return lsp_markup_content_construct (LSP_TYPE_MARKUP_CONTENT);
#line 10850 "protocol.c"
}

/**
         * Create a MarkupContent with plain text.
         */
LspMarkupContent*
lsp_markup_content_construct_from_plaintext (GType object_type,
                                             const gchar* doc)
{
	LspMarkupContent * self = NULL;
#line 616 "../src/protocol.vala"
	g_return_val_if_fail (doc != NULL, NULL);
#line 616 "../src/protocol.vala"
	self = (LspMarkupContent*) g_object_new (object_type, NULL);
#line 617 "../src/protocol.vala"
	lsp_markup_content_set_kind (self, "plaintext");
#line 618 "../src/protocol.vala"
	lsp_markup_content_set_value (self, doc);
#line 616 "../src/protocol.vala"
	return self;
#line 10871 "protocol.c"
}

LspMarkupContent*
lsp_markup_content_new_from_plaintext (const gchar* doc)
{
#line 616 "../src/protocol.vala"
	return lsp_markup_content_construct_from_plaintext (LSP_TYPE_MARKUP_CONTENT, doc);
#line 10879 "protocol.c"
}

/**
         * Create a MarkupContent with markdown text.
         */
LspMarkupContent*
lsp_markup_content_construct_from_markdown (GType object_type,
                                            const gchar* doc)
{
	LspMarkupContent * self = NULL;
#line 624 "../src/protocol.vala"
	g_return_val_if_fail (doc != NULL, NULL);
#line 624 "../src/protocol.vala"
	self = (LspMarkupContent*) g_object_new (object_type, NULL);
#line 625 "../src/protocol.vala"
	lsp_markup_content_set_kind (self, "markdown");
#line 626 "../src/protocol.vala"
	lsp_markup_content_set_value (self, doc);
#line 624 "../src/protocol.vala"
	return self;
#line 10900 "protocol.c"
}

LspMarkupContent*
lsp_markup_content_new_from_markdown (const gchar* doc)
{
#line 624 "../src/protocol.vala"
	return lsp_markup_content_construct_from_markdown (LSP_TYPE_MARKUP_CONTENT, doc);
#line 10908 "protocol.c"
}

const gchar*
lsp_markup_content_get_kind (LspMarkupContent* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 608 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 608 "../src/protocol.vala"
	_tmp0_ = self->priv->_kind;
#line 608 "../src/protocol.vala"
	result = _tmp0_;
#line 608 "../src/protocol.vala"
	return result;
#line 10924 "protocol.c"
}

void
lsp_markup_content_set_kind (LspMarkupContent* self,
                             const gchar* value)
{
	gchar* old_value;
#line 608 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 608 "../src/protocol.vala"
	old_value = lsp_markup_content_get_kind (self);
#line 608 "../src/protocol.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 10938 "protocol.c"
		gchar* _tmp0_;
#line 608 "../src/protocol.vala"
		_tmp0_ = g_strdup (value);
#line 608 "../src/protocol.vala"
		_g_free0 (self->priv->_kind);
#line 608 "../src/protocol.vala"
		self->priv->_kind = _tmp0_;
#line 608 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_markup_content_properties[LSP_MARKUP_CONTENT_KIND_PROPERTY]);
#line 10948 "protocol.c"
	}
}

const gchar*
lsp_markup_content_get_value (LspMarkupContent* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 609 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 609 "../src/protocol.vala"
	_tmp0_ = self->priv->_value;
#line 609 "../src/protocol.vala"
	result = _tmp0_;
#line 609 "../src/protocol.vala"
	return result;
#line 10965 "protocol.c"
}

void
lsp_markup_content_set_value (LspMarkupContent* self,
                              const gchar* value)
{
	gchar* old_value;
#line 609 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 609 "../src/protocol.vala"
	old_value = lsp_markup_content_get_value (self);
#line 609 "../src/protocol.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 10979 "protocol.c"
		gchar* _tmp0_;
#line 609 "../src/protocol.vala"
		_tmp0_ = g_strdup (value);
#line 609 "../src/protocol.vala"
		_g_free0 (self->priv->_value);
#line 609 "../src/protocol.vala"
		self->priv->_value = _tmp0_;
#line 609 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_markup_content_properties[LSP_MARKUP_CONTENT_VALUE_PROPERTY]);
#line 10989 "protocol.c"
	}
}

static void
lsp_markup_content_class_init (LspMarkupContentClass * klass,
                               gpointer klass_data)
{
#line 607 "../src/protocol.vala"
	lsp_markup_content_parent_class = g_type_class_peek_parent (klass);
#line 607 "../src/protocol.vala"
	g_type_class_adjust_private_offset (klass, &LspMarkupContent_private_offset);
#line 607 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_lsp_markup_content_get_property;
#line 607 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_lsp_markup_content_set_property;
#line 607 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->finalize = lsp_markup_content_finalize;
#line 607 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_MARKUP_CONTENT_KIND_PROPERTY, lsp_markup_content_properties[LSP_MARKUP_CONTENT_KIND_PROPERTY] = g_param_spec_string ("kind", "kind", "kind", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 607 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_MARKUP_CONTENT_VALUE_PROPERTY, lsp_markup_content_properties[LSP_MARKUP_CONTENT_VALUE_PROPERTY] = g_param_spec_string ("value", "value", "value", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 11011 "protocol.c"
}

static void
lsp_markup_content_instance_init (LspMarkupContent * self,
                                  gpointer klass)
{
#line 607 "../src/protocol.vala"
	self->priv = lsp_markup_content_get_instance_private (self);
#line 11020 "protocol.c"
}

static void
lsp_markup_content_finalize (GObject * obj)
{
	LspMarkupContent * self;
#line 607 "../src/protocol.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, LSP_TYPE_MARKUP_CONTENT, LspMarkupContent);
#line 608 "../src/protocol.vala"
	_g_free0 (self->priv->_kind);
#line 609 "../src/protocol.vala"
	_g_free0 (self->priv->_value);
#line 607 "../src/protocol.vala"
	G_OBJECT_CLASS (lsp_markup_content_parent_class)->finalize (obj);
#line 11035 "protocol.c"
}

 G_GNUC_NO_INLINE static GType
lsp_markup_content_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (LspMarkupContentClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) lsp_markup_content_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LspMarkupContent), 0, (GInstanceInitFunc) lsp_markup_content_instance_init, NULL };
	GType lsp_markup_content_type_id;
	lsp_markup_content_type_id = g_type_register_static (G_TYPE_OBJECT, "LspMarkupContent", &g_define_type_info, 0);
	LspMarkupContent_private_offset = g_type_add_instance_private (lsp_markup_content_type_id, sizeof (LspMarkupContentPrivate));
	return lsp_markup_content_type_id;
}

GType
lsp_markup_content_get_type (void)
{
	static gsize lsp_markup_content_type_id__once = 0;
	if (g_once_init_enter (&lsp_markup_content_type_id__once)) {
		GType lsp_markup_content_type_id;
		lsp_markup_content_type_id = lsp_markup_content_get_type_once ();
		g_once_init_leave (&lsp_markup_content_type_id__once, lsp_markup_content_type_id);
	}
	return lsp_markup_content_type_id__once;
}

static void
_vala_lsp_markup_content_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec)
{
	LspMarkupContent * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_MARKUP_CONTENT, LspMarkupContent);
#line 607 "../src/protocol.vala"
	switch (property_id) {
#line 607 "../src/protocol.vala"
		case LSP_MARKUP_CONTENT_KIND_PROPERTY:
#line 607 "../src/protocol.vala"
		g_value_set_string (value, lsp_markup_content_get_kind (self));
#line 607 "../src/protocol.vala"
		break;
#line 607 "../src/protocol.vala"
		case LSP_MARKUP_CONTENT_VALUE_PROPERTY:
#line 607 "../src/protocol.vala"
		g_value_set_string (value, lsp_markup_content_get_value (self));
#line 607 "../src/protocol.vala"
		break;
#line 11082 "protocol.c"
		default:
#line 607 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 607 "../src/protocol.vala"
		break;
#line 11088 "protocol.c"
	}
}

static void
_vala_lsp_markup_content_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec)
{
	LspMarkupContent * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_MARKUP_CONTENT, LspMarkupContent);
#line 607 "../src/protocol.vala"
	switch (property_id) {
#line 607 "../src/protocol.vala"
		case LSP_MARKUP_CONTENT_KIND_PROPERTY:
#line 607 "../src/protocol.vala"
		lsp_markup_content_set_kind (self, g_value_get_string (value));
#line 607 "../src/protocol.vala"
		break;
#line 607 "../src/protocol.vala"
		case LSP_MARKUP_CONTENT_VALUE_PROPERTY:
#line 607 "../src/protocol.vala"
		lsp_markup_content_set_value (self, g_value_get_string (value));
#line 607 "../src/protocol.vala"
		break;
#line 11114 "protocol.c"
		default:
#line 607 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 607 "../src/protocol.vala"
		break;
#line 11120 "protocol.c"
	}
}

 G_GNUC_NO_INLINE static GType
lsp_completion_item_kind_get_type_once (void)
{
	static const GEnumValue values[] = {{LSP_COMPLETION_ITEM_KIND_Text, "LSP_COMPLETION_ITEM_KIND_Text", "text"}, {LSP_COMPLETION_ITEM_KIND_Method, "LSP_COMPLETION_ITEM_KIND_Method", "method"}, {LSP_COMPLETION_ITEM_KIND_Function, "LSP_COMPLETION_ITEM_KIND_Function", "function"}, {LSP_COMPLETION_ITEM_KIND_Constructor, "LSP_COMPLETION_ITEM_KIND_Constructor", "constructor"}, {LSP_COMPLETION_ITEM_KIND_Field, "LSP_COMPLETION_ITEM_KIND_Field", "field"}, {LSP_COMPLETION_ITEM_KIND_Variable, "LSP_COMPLETION_ITEM_KIND_Variable", "variable"}, {LSP_COMPLETION_ITEM_KIND_Class, "LSP_COMPLETION_ITEM_KIND_Class", "class"}, {LSP_COMPLETION_ITEM_KIND_Interface, "LSP_COMPLETION_ITEM_KIND_Interface", "interface"}, {LSP_COMPLETION_ITEM_KIND_Module, "LSP_COMPLETION_ITEM_KIND_Module", "module"}, {LSP_COMPLETION_ITEM_KIND_Property, "LSP_COMPLETION_ITEM_KIND_Property", "property"}, {LSP_COMPLETION_ITEM_KIND_Unit, "LSP_COMPLETION_ITEM_KIND_Unit", "unit"}, {LSP_COMPLETION_ITEM_KIND_Value, "LSP_COMPLETION_ITEM_KIND_Value", "value"}, {LSP_COMPLETION_ITEM_KIND_Enum, "LSP_COMPLETION_ITEM_KIND_Enum", "enum"}, {LSP_COMPLETION_ITEM_KIND_Keyword, "LSP_COMPLETION_ITEM_KIND_Keyword", "keyword"}, {LSP_COMPLETION_ITEM_KIND_Snippet, "LSP_COMPLETION_ITEM_KIND_Snippet", "snippet"}, {LSP_COMPLETION_ITEM_KIND_Color, "LSP_COMPLETION_ITEM_KIND_Color", "color"}, {LSP_COMPLETION_ITEM_KIND_File, "LSP_COMPLETION_ITEM_KIND_File", "file"}, {LSP_COMPLETION_ITEM_KIND_Reference, "LSP_COMPLETION_ITEM_KIND_Reference", "reference"}, {LSP_COMPLETION_ITEM_KIND_Folder, "LSP_COMPLETION_ITEM_KIND_Folder", "folder"}, {LSP_COMPLETION_ITEM_KIND_EnumMember, "LSP_COMPLETION_ITEM_KIND_EnumMember", "enummember"}, {LSP_COMPLETION_ITEM_KIND_Constant, "LSP_COMPLETION_ITEM_KIND_Constant", "constant"}, {LSP_COMPLETION_ITEM_KIND_Struct, "LSP_COMPLETION_ITEM_KIND_Struct", "struct"}, {LSP_COMPLETION_ITEM_KIND_Event, "LSP_COMPLETION_ITEM_KIND_Event", "event"}, {LSP_COMPLETION_ITEM_KIND_Operator, "LSP_COMPLETION_ITEM_KIND_Operator", "operator"}, {LSP_COMPLETION_ITEM_KIND_TypeParameter, "LSP_COMPLETION_ITEM_KIND_TypeParameter", "typeparameter"}, {0, NULL, NULL}};
	GType lsp_completion_item_kind_type_id;
	lsp_completion_item_kind_type_id = g_enum_register_static ("LspCompletionItemKind", values);
	return lsp_completion_item_kind_type_id;
}

GType
lsp_completion_item_kind_get_type (void)
{
	static gsize lsp_completion_item_kind_type_id__once = 0;
	if (g_once_init_enter (&lsp_completion_item_kind_type_id__once)) {
		GType lsp_completion_item_kind_type_id;
		lsp_completion_item_kind_type_id = lsp_completion_item_kind_get_type_once ();
		g_once_init_leave (&lsp_completion_item_kind_type_id__once, lsp_completion_item_kind_type_id);
	}
	return lsp_completion_item_kind_type_id__once;
}

static inline gpointer
lsp_document_symbol_capabilities_get_instance_private (LspDocumentSymbolCapabilities* self)
{
	return G_STRUCT_MEMBER_P (self, LspDocumentSymbolCapabilities_private_offset);
}

LspDocumentSymbolCapabilities*
lsp_document_symbol_capabilities_construct (GType object_type)
{
	LspDocumentSymbolCapabilities * self = NULL;
#line 662 "../src/protocol.vala"
	self = (LspDocumentSymbolCapabilities*) g_object_new (object_type, NULL);
#line 662 "../src/protocol.vala"
	return self;
#line 11159 "protocol.c"
}

LspDocumentSymbolCapabilities*
lsp_document_symbol_capabilities_new (void)
{
#line 662 "../src/protocol.vala"
	return lsp_document_symbol_capabilities_construct (LSP_TYPE_DOCUMENT_SYMBOL_CAPABILITIES);
#line 11167 "protocol.c"
}

gboolean
lsp_document_symbol_capabilities_get_hierarchicalDocumentSymbolSupport (LspDocumentSymbolCapabilities* self)
{
	gboolean result;
#line 663 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 663 "../src/protocol.vala"
	result = self->priv->_hierarchicalDocumentSymbolSupport;
#line 663 "../src/protocol.vala"
	return result;
#line 11180 "protocol.c"
}

void
lsp_document_symbol_capabilities_set_hierarchicalDocumentSymbolSupport (LspDocumentSymbolCapabilities* self,
                                                                        gboolean value)
{
	gboolean old_value;
#line 663 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 663 "../src/protocol.vala"
	old_value = lsp_document_symbol_capabilities_get_hierarchicalDocumentSymbolSupport (self);
#line 663 "../src/protocol.vala"
	if (old_value != value) {
#line 663 "../src/protocol.vala"
		self->priv->_hierarchicalDocumentSymbolSupport = value;
#line 663 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_document_symbol_capabilities_properties[LSP_DOCUMENT_SYMBOL_CAPABILITIES_HIERARCHICAL_DOCUMENT_SYMBOL_SUPPORT_PROPERTY]);
#line 11198 "protocol.c"
	}
}

static void
lsp_document_symbol_capabilities_class_init (LspDocumentSymbolCapabilitiesClass * klass,
                                             gpointer klass_data)
{
#line 662 "../src/protocol.vala"
	lsp_document_symbol_capabilities_parent_class = g_type_class_peek_parent (klass);
#line 662 "../src/protocol.vala"
	g_type_class_adjust_private_offset (klass, &LspDocumentSymbolCapabilities_private_offset);
#line 662 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_lsp_document_symbol_capabilities_get_property;
#line 662 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_lsp_document_symbol_capabilities_set_property;
#line 662 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->finalize = lsp_document_symbol_capabilities_finalize;
#line 662 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_DOCUMENT_SYMBOL_CAPABILITIES_HIERARCHICAL_DOCUMENT_SYMBOL_SUPPORT_PROPERTY, lsp_document_symbol_capabilities_properties[LSP_DOCUMENT_SYMBOL_CAPABILITIES_HIERARCHICAL_DOCUMENT_SYMBOL_SUPPORT_PROPERTY] = g_param_spec_boolean ("hierarchicalDocumentSymbolSupport", "hierarchicalDocumentSymbolSupport", "hierarchicalDocumentSymbolSupport", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 11218 "protocol.c"
}

static void
lsp_document_symbol_capabilities_instance_init (LspDocumentSymbolCapabilities * self,
                                                gpointer klass)
{
#line 662 "../src/protocol.vala"
	self->priv = lsp_document_symbol_capabilities_get_instance_private (self);
#line 11227 "protocol.c"
}

static void
lsp_document_symbol_capabilities_finalize (GObject * obj)
{
	LspDocumentSymbolCapabilities * self;
#line 662 "../src/protocol.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, LSP_TYPE_DOCUMENT_SYMBOL_CAPABILITIES, LspDocumentSymbolCapabilities);
#line 662 "../src/protocol.vala"
	G_OBJECT_CLASS (lsp_document_symbol_capabilities_parent_class)->finalize (obj);
#line 11238 "protocol.c"
}

/**
     * Capabilities of the client/editor for `textDocument/documentSymbol`
     */
 G_GNUC_NO_INLINE static GType
lsp_document_symbol_capabilities_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (LspDocumentSymbolCapabilitiesClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) lsp_document_symbol_capabilities_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LspDocumentSymbolCapabilities), 0, (GInstanceInitFunc) lsp_document_symbol_capabilities_instance_init, NULL };
	GType lsp_document_symbol_capabilities_type_id;
	lsp_document_symbol_capabilities_type_id = g_type_register_static (G_TYPE_OBJECT, "LspDocumentSymbolCapabilities", &g_define_type_info, 0);
	LspDocumentSymbolCapabilities_private_offset = g_type_add_instance_private (lsp_document_symbol_capabilities_type_id, sizeof (LspDocumentSymbolCapabilitiesPrivate));
	return lsp_document_symbol_capabilities_type_id;
}

GType
lsp_document_symbol_capabilities_get_type (void)
{
	static gsize lsp_document_symbol_capabilities_type_id__once = 0;
	if (g_once_init_enter (&lsp_document_symbol_capabilities_type_id__once)) {
		GType lsp_document_symbol_capabilities_type_id;
		lsp_document_symbol_capabilities_type_id = lsp_document_symbol_capabilities_get_type_once ();
		g_once_init_leave (&lsp_document_symbol_capabilities_type_id__once, lsp_document_symbol_capabilities_type_id);
	}
	return lsp_document_symbol_capabilities_type_id__once;
}

static void
_vala_lsp_document_symbol_capabilities_get_property (GObject * object,
                                                     guint property_id,
                                                     GValue * value,
                                                     GParamSpec * pspec)
{
	LspDocumentSymbolCapabilities * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_DOCUMENT_SYMBOL_CAPABILITIES, LspDocumentSymbolCapabilities);
#line 662 "../src/protocol.vala"
	switch (property_id) {
#line 662 "../src/protocol.vala"
		case LSP_DOCUMENT_SYMBOL_CAPABILITIES_HIERARCHICAL_DOCUMENT_SYMBOL_SUPPORT_PROPERTY:
#line 662 "../src/protocol.vala"
		g_value_set_boolean (value, lsp_document_symbol_capabilities_get_hierarchicalDocumentSymbolSupport (self));
#line 662 "../src/protocol.vala"
		break;
#line 11282 "protocol.c"
		default:
#line 662 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 662 "../src/protocol.vala"
		break;
#line 11288 "protocol.c"
	}
}

static void
_vala_lsp_document_symbol_capabilities_set_property (GObject * object,
                                                     guint property_id,
                                                     const GValue * value,
                                                     GParamSpec * pspec)
{
	LspDocumentSymbolCapabilities * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_DOCUMENT_SYMBOL_CAPABILITIES, LspDocumentSymbolCapabilities);
#line 662 "../src/protocol.vala"
	switch (property_id) {
#line 662 "../src/protocol.vala"
		case LSP_DOCUMENT_SYMBOL_CAPABILITIES_HIERARCHICAL_DOCUMENT_SYMBOL_SUPPORT_PROPERTY:
#line 662 "../src/protocol.vala"
		lsp_document_symbol_capabilities_set_hierarchicalDocumentSymbolSupport (self, g_value_get_boolean (value));
#line 662 "../src/protocol.vala"
		break;
#line 11308 "protocol.c"
		default:
#line 662 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 662 "../src/protocol.vala"
		break;
#line 11314 "protocol.c"
	}
}

static inline gpointer
lsp_rename_client_capabilities_get_instance_private (LspRenameClientCapabilities* self)
{
	return G_STRUCT_MEMBER_P (self, LspRenameClientCapabilities_private_offset);
}

LspRenameClientCapabilities*
lsp_rename_client_capabilities_construct (GType object_type)
{
	LspRenameClientCapabilities * self = NULL;
#line 669 "../src/protocol.vala"
	self = (LspRenameClientCapabilities*) g_object_new (object_type, NULL);
#line 669 "../src/protocol.vala"
	return self;
#line 11332 "protocol.c"
}

LspRenameClientCapabilities*
lsp_rename_client_capabilities_new (void)
{
#line 669 "../src/protocol.vala"
	return lsp_rename_client_capabilities_construct (LSP_TYPE_RENAME_CLIENT_CAPABILITIES);
#line 11340 "protocol.c"
}

gboolean
lsp_rename_client_capabilities_get_prepareSupport (LspRenameClientCapabilities* self)
{
	gboolean result;
#line 670 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 670 "../src/protocol.vala"
	result = self->priv->_prepareSupport;
#line 670 "../src/protocol.vala"
	return result;
#line 11353 "protocol.c"
}

void
lsp_rename_client_capabilities_set_prepareSupport (LspRenameClientCapabilities* self,
                                                   gboolean value)
{
	gboolean old_value;
#line 670 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 670 "../src/protocol.vala"
	old_value = lsp_rename_client_capabilities_get_prepareSupport (self);
#line 670 "../src/protocol.vala"
	if (old_value != value) {
#line 670 "../src/protocol.vala"
		self->priv->_prepareSupport = value;
#line 670 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_rename_client_capabilities_properties[LSP_RENAME_CLIENT_CAPABILITIES_PREPARE_SUPPORT_PROPERTY]);
#line 11371 "protocol.c"
	}
}

static void
lsp_rename_client_capabilities_class_init (LspRenameClientCapabilitiesClass * klass,
                                           gpointer klass_data)
{
#line 669 "../src/protocol.vala"
	lsp_rename_client_capabilities_parent_class = g_type_class_peek_parent (klass);
#line 669 "../src/protocol.vala"
	g_type_class_adjust_private_offset (klass, &LspRenameClientCapabilities_private_offset);
#line 669 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_lsp_rename_client_capabilities_get_property;
#line 669 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_lsp_rename_client_capabilities_set_property;
#line 669 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->finalize = lsp_rename_client_capabilities_finalize;
#line 669 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_RENAME_CLIENT_CAPABILITIES_PREPARE_SUPPORT_PROPERTY, lsp_rename_client_capabilities_properties[LSP_RENAME_CLIENT_CAPABILITIES_PREPARE_SUPPORT_PROPERTY] = g_param_spec_boolean ("prepareSupport", "prepareSupport", "prepareSupport", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 11391 "protocol.c"
}

static void
lsp_rename_client_capabilities_instance_init (LspRenameClientCapabilities * self,
                                              gpointer klass)
{
#line 669 "../src/protocol.vala"
	self->priv = lsp_rename_client_capabilities_get_instance_private (self);
#line 11400 "protocol.c"
}

static void
lsp_rename_client_capabilities_finalize (GObject * obj)
{
	LspRenameClientCapabilities * self;
#line 669 "../src/protocol.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, LSP_TYPE_RENAME_CLIENT_CAPABILITIES, LspRenameClientCapabilities);
#line 669 "../src/protocol.vala"
	G_OBJECT_CLASS (lsp_rename_client_capabilities_parent_class)->finalize (obj);
#line 11411 "protocol.c"
}

/**
     * Capabilities of the client/editor for `textDocument/rename`
     */
 G_GNUC_NO_INLINE static GType
lsp_rename_client_capabilities_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (LspRenameClientCapabilitiesClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) lsp_rename_client_capabilities_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LspRenameClientCapabilities), 0, (GInstanceInitFunc) lsp_rename_client_capabilities_instance_init, NULL };
	GType lsp_rename_client_capabilities_type_id;
	lsp_rename_client_capabilities_type_id = g_type_register_static (G_TYPE_OBJECT, "LspRenameClientCapabilities", &g_define_type_info, 0);
	LspRenameClientCapabilities_private_offset = g_type_add_instance_private (lsp_rename_client_capabilities_type_id, sizeof (LspRenameClientCapabilitiesPrivate));
	return lsp_rename_client_capabilities_type_id;
}

GType
lsp_rename_client_capabilities_get_type (void)
{
	static gsize lsp_rename_client_capabilities_type_id__once = 0;
	if (g_once_init_enter (&lsp_rename_client_capabilities_type_id__once)) {
		GType lsp_rename_client_capabilities_type_id;
		lsp_rename_client_capabilities_type_id = lsp_rename_client_capabilities_get_type_once ();
		g_once_init_leave (&lsp_rename_client_capabilities_type_id__once, lsp_rename_client_capabilities_type_id);
	}
	return lsp_rename_client_capabilities_type_id__once;
}

static void
_vala_lsp_rename_client_capabilities_get_property (GObject * object,
                                                   guint property_id,
                                                   GValue * value,
                                                   GParamSpec * pspec)
{
	LspRenameClientCapabilities * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_RENAME_CLIENT_CAPABILITIES, LspRenameClientCapabilities);
#line 669 "../src/protocol.vala"
	switch (property_id) {
#line 669 "../src/protocol.vala"
		case LSP_RENAME_CLIENT_CAPABILITIES_PREPARE_SUPPORT_PROPERTY:
#line 669 "../src/protocol.vala"
		g_value_set_boolean (value, lsp_rename_client_capabilities_get_prepareSupport (self));
#line 669 "../src/protocol.vala"
		break;
#line 11455 "protocol.c"
		default:
#line 669 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 669 "../src/protocol.vala"
		break;
#line 11461 "protocol.c"
	}
}

static void
_vala_lsp_rename_client_capabilities_set_property (GObject * object,
                                                   guint property_id,
                                                   const GValue * value,
                                                   GParamSpec * pspec)
{
	LspRenameClientCapabilities * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_RENAME_CLIENT_CAPABILITIES, LspRenameClientCapabilities);
#line 669 "../src/protocol.vala"
	switch (property_id) {
#line 669 "../src/protocol.vala"
		case LSP_RENAME_CLIENT_CAPABILITIES_PREPARE_SUPPORT_PROPERTY:
#line 669 "../src/protocol.vala"
		lsp_rename_client_capabilities_set_prepareSupport (self, g_value_get_boolean (value));
#line 669 "../src/protocol.vala"
		break;
#line 11481 "protocol.c"
		default:
#line 669 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 669 "../src/protocol.vala"
		break;
#line 11487 "protocol.c"
	}
}

static inline gpointer
lsp_text_document_client_capabilities_get_instance_private (LspTextDocumentClientCapabilities* self)
{
	return G_STRUCT_MEMBER_P (self, LspTextDocumentClientCapabilities_private_offset);
}

LspTextDocumentClientCapabilities*
lsp_text_document_client_capabilities_construct (GType object_type)
{
	LspTextDocumentClientCapabilities * self = NULL;
#line 676 "../src/protocol.vala"
	self = (LspTextDocumentClientCapabilities*) g_object_new (object_type, NULL);
#line 676 "../src/protocol.vala"
	return self;
#line 11505 "protocol.c"
}

LspTextDocumentClientCapabilities*
lsp_text_document_client_capabilities_new (void)
{
#line 676 "../src/protocol.vala"
	return lsp_text_document_client_capabilities_construct (LSP_TYPE_TEXT_DOCUMENT_CLIENT_CAPABILITIES);
#line 11513 "protocol.c"
}

LspDocumentSymbolCapabilities*
lsp_text_document_client_capabilities_get_documentSymbol (LspTextDocumentClientCapabilities* self)
{
	LspDocumentSymbolCapabilities* result;
	LspDocumentSymbolCapabilities* _tmp0_;
#line 677 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 677 "../src/protocol.vala"
	_tmp0_ = self->priv->_documentSymbol;
#line 677 "../src/protocol.vala"
	result = _tmp0_;
#line 677 "../src/protocol.vala"
	return result;
#line 11529 "protocol.c"
}

void
lsp_text_document_client_capabilities_set_documentSymbol (LspTextDocumentClientCapabilities* self,
                                                          LspDocumentSymbolCapabilities* value)
{
	LspDocumentSymbolCapabilities* old_value;
#line 677 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 677 "../src/protocol.vala"
	old_value = lsp_text_document_client_capabilities_get_documentSymbol (self);
#line 677 "../src/protocol.vala"
	if (old_value != value) {
#line 11543 "protocol.c"
		LspDocumentSymbolCapabilities* _tmp0_;
#line 677 "../src/protocol.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 677 "../src/protocol.vala"
		_g_object_unref0 (self->priv->_documentSymbol);
#line 677 "../src/protocol.vala"
		self->priv->_documentSymbol = _tmp0_;
#line 677 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_text_document_client_capabilities_properties[LSP_TEXT_DOCUMENT_CLIENT_CAPABILITIES_DOCUMENT_SYMBOL_PROPERTY]);
#line 11553 "protocol.c"
	}
}

LspRenameClientCapabilities*
lsp_text_document_client_capabilities_get_rename (LspTextDocumentClientCapabilities* self)
{
	LspRenameClientCapabilities* result;
	LspRenameClientCapabilities* _tmp0_;
#line 678 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 678 "../src/protocol.vala"
	_tmp0_ = self->priv->_rename;
#line 678 "../src/protocol.vala"
	result = _tmp0_;
#line 678 "../src/protocol.vala"
	return result;
#line 11570 "protocol.c"
}

void
lsp_text_document_client_capabilities_set_rename (LspTextDocumentClientCapabilities* self,
                                                  LspRenameClientCapabilities* value)
{
	LspRenameClientCapabilities* old_value;
#line 678 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 678 "../src/protocol.vala"
	old_value = lsp_text_document_client_capabilities_get_rename (self);
#line 678 "../src/protocol.vala"
	if (old_value != value) {
#line 11584 "protocol.c"
		LspRenameClientCapabilities* _tmp0_;
#line 678 "../src/protocol.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 678 "../src/protocol.vala"
		_g_object_unref0 (self->priv->_rename);
#line 678 "../src/protocol.vala"
		self->priv->_rename = _tmp0_;
#line 678 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_text_document_client_capabilities_properties[LSP_TEXT_DOCUMENT_CLIENT_CAPABILITIES_RENAME_PROPERTY]);
#line 11594 "protocol.c"
	}
}

static void
lsp_text_document_client_capabilities_class_init (LspTextDocumentClientCapabilitiesClass * klass,
                                                  gpointer klass_data)
{
#line 676 "../src/protocol.vala"
	lsp_text_document_client_capabilities_parent_class = g_type_class_peek_parent (klass);
#line 676 "../src/protocol.vala"
	g_type_class_adjust_private_offset (klass, &LspTextDocumentClientCapabilities_private_offset);
#line 676 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_lsp_text_document_client_capabilities_get_property;
#line 676 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_lsp_text_document_client_capabilities_set_property;
#line 676 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->finalize = lsp_text_document_client_capabilities_finalize;
#line 676 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_TEXT_DOCUMENT_CLIENT_CAPABILITIES_DOCUMENT_SYMBOL_PROPERTY, lsp_text_document_client_capabilities_properties[LSP_TEXT_DOCUMENT_CLIENT_CAPABILITIES_DOCUMENT_SYMBOL_PROPERTY] = g_param_spec_object ("documentSymbol", "documentSymbol", "documentSymbol", LSP_TYPE_DOCUMENT_SYMBOL_CAPABILITIES, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 676 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_TEXT_DOCUMENT_CLIENT_CAPABILITIES_RENAME_PROPERTY, lsp_text_document_client_capabilities_properties[LSP_TEXT_DOCUMENT_CLIENT_CAPABILITIES_RENAME_PROPERTY] = g_param_spec_object ("rename", "rename", "rename", LSP_TYPE_RENAME_CLIENT_CAPABILITIES, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 11616 "protocol.c"
}

static void
lsp_text_document_client_capabilities_instance_init (LspTextDocumentClientCapabilities * self,
                                                     gpointer klass)
{
	LspDocumentSymbolCapabilities* _tmp0_;
	LspRenameClientCapabilities* _tmp1_;
#line 676 "../src/protocol.vala"
	self->priv = lsp_text_document_client_capabilities_get_instance_private (self);
#line 677 "../src/protocol.vala"
	_tmp0_ = lsp_document_symbol_capabilities_new ();
#line 677 "../src/protocol.vala"
	if (_tmp0_) {
#line 677 "../src/protocol.vala"
		g_object_set_data ((GObject *) _tmp0_, "vala-creation-function", "");
#line 11633 "protocol.c"
	}
#line 677 "../src/protocol.vala"
	self->priv->_documentSymbol = _tmp0_;
#line 678 "../src/protocol.vala"
	_tmp1_ = lsp_rename_client_capabilities_new ();
#line 678 "../src/protocol.vala"
	if (_tmp1_) {
#line 678 "../src/protocol.vala"
		g_object_set_data ((GObject *) _tmp1_, "vala-creation-function", "");
#line 11643 "protocol.c"
	}
#line 678 "../src/protocol.vala"
	self->priv->_rename = _tmp1_;
#line 11647 "protocol.c"
}

static void
lsp_text_document_client_capabilities_finalize (GObject * obj)
{
	LspTextDocumentClientCapabilities * self;
#line 676 "../src/protocol.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, LSP_TYPE_TEXT_DOCUMENT_CLIENT_CAPABILITIES, LspTextDocumentClientCapabilities);
#line 677 "../src/protocol.vala"
	_g_object_unref0 (self->priv->_documentSymbol);
#line 678 "../src/protocol.vala"
	_g_object_unref0 (self->priv->_rename);
#line 676 "../src/protocol.vala"
	G_OBJECT_CLASS (lsp_text_document_client_capabilities_parent_class)->finalize (obj);
#line 11662 "protocol.c"
}

/**
     * Capabilities of the client/editor pertaining to language features.
     */
 G_GNUC_NO_INLINE static GType
lsp_text_document_client_capabilities_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (LspTextDocumentClientCapabilitiesClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) lsp_text_document_client_capabilities_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LspTextDocumentClientCapabilities), 0, (GInstanceInitFunc) lsp_text_document_client_capabilities_instance_init, NULL };
	GType lsp_text_document_client_capabilities_type_id;
	lsp_text_document_client_capabilities_type_id = g_type_register_static (G_TYPE_OBJECT, "LspTextDocumentClientCapabilities", &g_define_type_info, 0);
	LspTextDocumentClientCapabilities_private_offset = g_type_add_instance_private (lsp_text_document_client_capabilities_type_id, sizeof (LspTextDocumentClientCapabilitiesPrivate));
	return lsp_text_document_client_capabilities_type_id;
}

GType
lsp_text_document_client_capabilities_get_type (void)
{
	static gsize lsp_text_document_client_capabilities_type_id__once = 0;
	if (g_once_init_enter (&lsp_text_document_client_capabilities_type_id__once)) {
		GType lsp_text_document_client_capabilities_type_id;
		lsp_text_document_client_capabilities_type_id = lsp_text_document_client_capabilities_get_type_once ();
		g_once_init_leave (&lsp_text_document_client_capabilities_type_id__once, lsp_text_document_client_capabilities_type_id);
	}
	return lsp_text_document_client_capabilities_type_id__once;
}

static void
_vala_lsp_text_document_client_capabilities_get_property (GObject * object,
                                                          guint property_id,
                                                          GValue * value,
                                                          GParamSpec * pspec)
{
	LspTextDocumentClientCapabilities * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_TEXT_DOCUMENT_CLIENT_CAPABILITIES, LspTextDocumentClientCapabilities);
#line 676 "../src/protocol.vala"
	switch (property_id) {
#line 676 "../src/protocol.vala"
		case LSP_TEXT_DOCUMENT_CLIENT_CAPABILITIES_DOCUMENT_SYMBOL_PROPERTY:
#line 676 "../src/protocol.vala"
		g_value_set_object (value, lsp_text_document_client_capabilities_get_documentSymbol (self));
#line 676 "../src/protocol.vala"
		break;
#line 676 "../src/protocol.vala"
		case LSP_TEXT_DOCUMENT_CLIENT_CAPABILITIES_RENAME_PROPERTY:
#line 676 "../src/protocol.vala"
		g_value_set_object (value, lsp_text_document_client_capabilities_get_rename (self));
#line 676 "../src/protocol.vala"
		break;
#line 11712 "protocol.c"
		default:
#line 676 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 676 "../src/protocol.vala"
		break;
#line 11718 "protocol.c"
	}
}

static void
_vala_lsp_text_document_client_capabilities_set_property (GObject * object,
                                                          guint property_id,
                                                          const GValue * value,
                                                          GParamSpec * pspec)
{
	LspTextDocumentClientCapabilities * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_TEXT_DOCUMENT_CLIENT_CAPABILITIES, LspTextDocumentClientCapabilities);
#line 676 "../src/protocol.vala"
	switch (property_id) {
#line 676 "../src/protocol.vala"
		case LSP_TEXT_DOCUMENT_CLIENT_CAPABILITIES_DOCUMENT_SYMBOL_PROPERTY:
#line 676 "../src/protocol.vala"
		lsp_text_document_client_capabilities_set_documentSymbol (self, g_value_get_object (value));
#line 676 "../src/protocol.vala"
		break;
#line 676 "../src/protocol.vala"
		case LSP_TEXT_DOCUMENT_CLIENT_CAPABILITIES_RENAME_PROPERTY:
#line 676 "../src/protocol.vala"
		lsp_text_document_client_capabilities_set_rename (self, g_value_get_object (value));
#line 676 "../src/protocol.vala"
		break;
#line 11744 "protocol.c"
		default:
#line 676 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 676 "../src/protocol.vala"
		break;
#line 11750 "protocol.c"
	}
}

static inline gpointer
lsp_client_capabilities_get_instance_private (LspClientCapabilities* self)
{
	return G_STRUCT_MEMBER_P (self, LspClientCapabilities_private_offset);
}

LspClientCapabilities*
lsp_client_capabilities_construct (GType object_type)
{
	LspClientCapabilities * self = NULL;
#line 684 "../src/protocol.vala"
	self = (LspClientCapabilities*) g_object_new (object_type, NULL);
#line 684 "../src/protocol.vala"
	return self;
#line 11768 "protocol.c"
}

LspClientCapabilities*
lsp_client_capabilities_new (void)
{
#line 684 "../src/protocol.vala"
	return lsp_client_capabilities_construct (LSP_TYPE_CLIENT_CAPABILITIES);
#line 11776 "protocol.c"
}

LspTextDocumentClientCapabilities*
lsp_client_capabilities_get_textDocument (LspClientCapabilities* self)
{
	LspTextDocumentClientCapabilities* result;
	LspTextDocumentClientCapabilities* _tmp0_;
#line 685 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 685 "../src/protocol.vala"
	_tmp0_ = self->priv->_textDocument;
#line 685 "../src/protocol.vala"
	result = _tmp0_;
#line 685 "../src/protocol.vala"
	return result;
#line 11792 "protocol.c"
}

void
lsp_client_capabilities_set_textDocument (LspClientCapabilities* self,
                                          LspTextDocumentClientCapabilities* value)
{
	LspTextDocumentClientCapabilities* old_value;
#line 685 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 685 "../src/protocol.vala"
	old_value = lsp_client_capabilities_get_textDocument (self);
#line 685 "../src/protocol.vala"
	if (old_value != value) {
#line 11806 "protocol.c"
		LspTextDocumentClientCapabilities* _tmp0_;
#line 685 "../src/protocol.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 685 "../src/protocol.vala"
		_g_object_unref0 (self->priv->_textDocument);
#line 685 "../src/protocol.vala"
		self->priv->_textDocument = _tmp0_;
#line 685 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_client_capabilities_properties[LSP_CLIENT_CAPABILITIES_TEXT_DOCUMENT_PROPERTY]);
#line 11816 "protocol.c"
	}
}

static void
lsp_client_capabilities_class_init (LspClientCapabilitiesClass * klass,
                                    gpointer klass_data)
{
#line 684 "../src/protocol.vala"
	lsp_client_capabilities_parent_class = g_type_class_peek_parent (klass);
#line 684 "../src/protocol.vala"
	g_type_class_adjust_private_offset (klass, &LspClientCapabilities_private_offset);
#line 684 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_lsp_client_capabilities_get_property;
#line 684 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_lsp_client_capabilities_set_property;
#line 684 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->finalize = lsp_client_capabilities_finalize;
#line 684 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_CLIENT_CAPABILITIES_TEXT_DOCUMENT_PROPERTY, lsp_client_capabilities_properties[LSP_CLIENT_CAPABILITIES_TEXT_DOCUMENT_PROPERTY] = g_param_spec_object ("textDocument", "textDocument", "textDocument", LSP_TYPE_TEXT_DOCUMENT_CLIENT_CAPABILITIES, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 11836 "protocol.c"
}

static void
lsp_client_capabilities_instance_init (LspClientCapabilities * self,
                                       gpointer klass)
{
	LspTextDocumentClientCapabilities* _tmp0_;
#line 684 "../src/protocol.vala"
	self->priv = lsp_client_capabilities_get_instance_private (self);
#line 685 "../src/protocol.vala"
	_tmp0_ = lsp_text_document_client_capabilities_new ();
#line 685 "../src/protocol.vala"
	if (_tmp0_) {
#line 685 "../src/protocol.vala"
		g_object_set_data ((GObject *) _tmp0_, "vala-creation-function", "");
#line 11852 "protocol.c"
	}
#line 685 "../src/protocol.vala"
	self->priv->_textDocument = _tmp0_;
#line 11856 "protocol.c"
}

static void
lsp_client_capabilities_finalize (GObject * obj)
{
	LspClientCapabilities * self;
#line 684 "../src/protocol.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, LSP_TYPE_CLIENT_CAPABILITIES, LspClientCapabilities);
#line 685 "../src/protocol.vala"
	_g_object_unref0 (self->priv->_textDocument);
#line 684 "../src/protocol.vala"
	G_OBJECT_CLASS (lsp_client_capabilities_parent_class)->finalize (obj);
#line 11869 "protocol.c"
}

/**
     * Capabilities of the client/editor.
     */
 G_GNUC_NO_INLINE static GType
lsp_client_capabilities_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (LspClientCapabilitiesClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) lsp_client_capabilities_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LspClientCapabilities), 0, (GInstanceInitFunc) lsp_client_capabilities_instance_init, NULL };
	GType lsp_client_capabilities_type_id;
	lsp_client_capabilities_type_id = g_type_register_static (G_TYPE_OBJECT, "LspClientCapabilities", &g_define_type_info, 0);
	LspClientCapabilities_private_offset = g_type_add_instance_private (lsp_client_capabilities_type_id, sizeof (LspClientCapabilitiesPrivate));
	return lsp_client_capabilities_type_id;
}

GType
lsp_client_capabilities_get_type (void)
{
	static gsize lsp_client_capabilities_type_id__once = 0;
	if (g_once_init_enter (&lsp_client_capabilities_type_id__once)) {
		GType lsp_client_capabilities_type_id;
		lsp_client_capabilities_type_id = lsp_client_capabilities_get_type_once ();
		g_once_init_leave (&lsp_client_capabilities_type_id__once, lsp_client_capabilities_type_id);
	}
	return lsp_client_capabilities_type_id__once;
}

static void
_vala_lsp_client_capabilities_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec)
{
	LspClientCapabilities * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_CLIENT_CAPABILITIES, LspClientCapabilities);
#line 684 "../src/protocol.vala"
	switch (property_id) {
#line 684 "../src/protocol.vala"
		case LSP_CLIENT_CAPABILITIES_TEXT_DOCUMENT_PROPERTY:
#line 684 "../src/protocol.vala"
		g_value_set_object (value, lsp_client_capabilities_get_textDocument (self));
#line 684 "../src/protocol.vala"
		break;
#line 11913 "protocol.c"
		default:
#line 684 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 684 "../src/protocol.vala"
		break;
#line 11919 "protocol.c"
	}
}

static void
_vala_lsp_client_capabilities_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec)
{
	LspClientCapabilities * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_CLIENT_CAPABILITIES, LspClientCapabilities);
#line 684 "../src/protocol.vala"
	switch (property_id) {
#line 684 "../src/protocol.vala"
		case LSP_CLIENT_CAPABILITIES_TEXT_DOCUMENT_PROPERTY:
#line 684 "../src/protocol.vala"
		lsp_client_capabilities_set_textDocument (self, g_value_get_object (value));
#line 684 "../src/protocol.vala"
		break;
#line 11939 "protocol.c"
		default:
#line 684 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 684 "../src/protocol.vala"
		break;
#line 11945 "protocol.c"
	}
}

static inline gpointer
lsp_initialize_params_get_instance_private (LspInitializeParams* self)
{
	return G_STRUCT_MEMBER_P (self, LspInitializeParams_private_offset);
}

LspInitializeParams*
lsp_initialize_params_construct (GType object_type)
{
	LspInitializeParams * self = NULL;
#line 688 "../src/protocol.vala"
	self = (LspInitializeParams*) g_object_new (object_type, NULL);
#line 688 "../src/protocol.vala"
	return self;
#line 11963 "protocol.c"
}

LspInitializeParams*
lsp_initialize_params_new (void)
{
#line 688 "../src/protocol.vala"
	return lsp_initialize_params_construct (LSP_TYPE_INITIALIZE_PARAMS);
#line 11971 "protocol.c"
}

gint
lsp_initialize_params_get_processId (LspInitializeParams* self)
{
	gint result;
#line 689 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 689 "../src/protocol.vala"
	result = self->priv->_processId;
#line 689 "../src/protocol.vala"
	return result;
#line 11984 "protocol.c"
}

void
lsp_initialize_params_set_processId (LspInitializeParams* self,
                                     gint value)
{
	gint old_value;
#line 689 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 689 "../src/protocol.vala"
	old_value = lsp_initialize_params_get_processId (self);
#line 689 "../src/protocol.vala"
	if (old_value != value) {
#line 689 "../src/protocol.vala"
		self->priv->_processId = value;
#line 689 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_initialize_params_properties[LSP_INITIALIZE_PARAMS_PROCESS_ID_PROPERTY]);
#line 12002 "protocol.c"
	}
}

const gchar*
lsp_initialize_params_get_rootPath (LspInitializeParams* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 690 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 690 "../src/protocol.vala"
	_tmp0_ = self->priv->_rootPath;
#line 690 "../src/protocol.vala"
	result = _tmp0_;
#line 690 "../src/protocol.vala"
	return result;
#line 12019 "protocol.c"
}

void
lsp_initialize_params_set_rootPath (LspInitializeParams* self,
                                    const gchar* value)
{
	gchar* old_value;
#line 690 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 690 "../src/protocol.vala"
	old_value = lsp_initialize_params_get_rootPath (self);
#line 690 "../src/protocol.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 12033 "protocol.c"
		gchar* _tmp0_;
#line 690 "../src/protocol.vala"
		_tmp0_ = g_strdup (value);
#line 690 "../src/protocol.vala"
		_g_free0 (self->priv->_rootPath);
#line 690 "../src/protocol.vala"
		self->priv->_rootPath = _tmp0_;
#line 690 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_initialize_params_properties[LSP_INITIALIZE_PARAMS_ROOT_PATH_PROPERTY]);
#line 12043 "protocol.c"
	}
}

const gchar*
lsp_initialize_params_get_rootUri (LspInitializeParams* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 691 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 691 "../src/protocol.vala"
	_tmp0_ = self->priv->_rootUri;
#line 691 "../src/protocol.vala"
	result = _tmp0_;
#line 691 "../src/protocol.vala"
	return result;
#line 12060 "protocol.c"
}

void
lsp_initialize_params_set_rootUri (LspInitializeParams* self,
                                   const gchar* value)
{
	gchar* old_value;
#line 691 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 691 "../src/protocol.vala"
	old_value = lsp_initialize_params_get_rootUri (self);
#line 691 "../src/protocol.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 12074 "protocol.c"
		gchar* _tmp0_;
#line 691 "../src/protocol.vala"
		_tmp0_ = g_strdup (value);
#line 691 "../src/protocol.vala"
		_g_free0 (self->priv->_rootUri);
#line 691 "../src/protocol.vala"
		self->priv->_rootUri = _tmp0_;
#line 691 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_initialize_params_properties[LSP_INITIALIZE_PARAMS_ROOT_URI_PROPERTY]);
#line 12084 "protocol.c"
	}
}

LspClientCapabilities*
lsp_initialize_params_get_capabilities (LspInitializeParams* self)
{
	LspClientCapabilities* result;
	LspClientCapabilities* _tmp0_;
#line 692 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 692 "../src/protocol.vala"
	_tmp0_ = self->priv->_capabilities;
#line 692 "../src/protocol.vala"
	result = _tmp0_;
#line 692 "../src/protocol.vala"
	return result;
#line 12101 "protocol.c"
}

void
lsp_initialize_params_set_capabilities (LspInitializeParams* self,
                                        LspClientCapabilities* value)
{
	LspClientCapabilities* old_value;
#line 692 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 692 "../src/protocol.vala"
	old_value = lsp_initialize_params_get_capabilities (self);
#line 692 "../src/protocol.vala"
	if (old_value != value) {
#line 12115 "protocol.c"
		LspClientCapabilities* _tmp0_;
#line 692 "../src/protocol.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 692 "../src/protocol.vala"
		_g_object_unref0 (self->priv->_capabilities);
#line 692 "../src/protocol.vala"
		self->priv->_capabilities = _tmp0_;
#line 692 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_initialize_params_properties[LSP_INITIALIZE_PARAMS_CAPABILITIES_PROPERTY]);
#line 12125 "protocol.c"
	}
}

static void
lsp_initialize_params_class_init (LspInitializeParamsClass * klass,
                                  gpointer klass_data)
{
#line 688 "../src/protocol.vala"
	lsp_initialize_params_parent_class = g_type_class_peek_parent (klass);
#line 688 "../src/protocol.vala"
	g_type_class_adjust_private_offset (klass, &LspInitializeParams_private_offset);
#line 688 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_lsp_initialize_params_get_property;
#line 688 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_lsp_initialize_params_set_property;
#line 688 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->finalize = lsp_initialize_params_finalize;
#line 688 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_INITIALIZE_PARAMS_PROCESS_ID_PROPERTY, lsp_initialize_params_properties[LSP_INITIALIZE_PARAMS_PROCESS_ID_PROPERTY] = g_param_spec_int ("processId", "processId", "processId", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 688 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_INITIALIZE_PARAMS_ROOT_PATH_PROPERTY, lsp_initialize_params_properties[LSP_INITIALIZE_PARAMS_ROOT_PATH_PROPERTY] = g_param_spec_string ("rootPath", "rootPath", "rootPath", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 688 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_INITIALIZE_PARAMS_ROOT_URI_PROPERTY, lsp_initialize_params_properties[LSP_INITIALIZE_PARAMS_ROOT_URI_PROPERTY] = g_param_spec_string ("rootUri", "rootUri", "rootUri", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 688 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_INITIALIZE_PARAMS_CAPABILITIES_PROPERTY, lsp_initialize_params_properties[LSP_INITIALIZE_PARAMS_CAPABILITIES_PROPERTY] = g_param_spec_object ("capabilities", "capabilities", "capabilities", LSP_TYPE_CLIENT_CAPABILITIES, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 12151 "protocol.c"
}

static void
lsp_initialize_params_instance_init (LspInitializeParams * self,
                                     gpointer klass)
{
	LspClientCapabilities* _tmp0_;
#line 688 "../src/protocol.vala"
	self->priv = lsp_initialize_params_get_instance_private (self);
#line 692 "../src/protocol.vala"
	_tmp0_ = lsp_client_capabilities_new ();
#line 692 "../src/protocol.vala"
	if (_tmp0_) {
#line 692 "../src/protocol.vala"
		g_object_set_data ((GObject *) _tmp0_, "vala-creation-function", "");
#line 12167 "protocol.c"
	}
#line 692 "../src/protocol.vala"
	self->priv->_capabilities = _tmp0_;
#line 12171 "protocol.c"
}

static void
lsp_initialize_params_finalize (GObject * obj)
{
	LspInitializeParams * self;
#line 688 "../src/protocol.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, LSP_TYPE_INITIALIZE_PARAMS, LspInitializeParams);
#line 690 "../src/protocol.vala"
	_g_free0 (self->priv->_rootPath);
#line 691 "../src/protocol.vala"
	_g_free0 (self->priv->_rootUri);
#line 692 "../src/protocol.vala"
	_g_object_unref0 (self->priv->_capabilities);
#line 688 "../src/protocol.vala"
	G_OBJECT_CLASS (lsp_initialize_params_parent_class)->finalize (obj);
#line 12188 "protocol.c"
}

 G_GNUC_NO_INLINE static GType
lsp_initialize_params_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (LspInitializeParamsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) lsp_initialize_params_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LspInitializeParams), 0, (GInstanceInitFunc) lsp_initialize_params_instance_init, NULL };
	GType lsp_initialize_params_type_id;
	lsp_initialize_params_type_id = g_type_register_static (G_TYPE_OBJECT, "LspInitializeParams", &g_define_type_info, 0);
	LspInitializeParams_private_offset = g_type_add_instance_private (lsp_initialize_params_type_id, sizeof (LspInitializeParamsPrivate));
	return lsp_initialize_params_type_id;
}

GType
lsp_initialize_params_get_type (void)
{
	static gsize lsp_initialize_params_type_id__once = 0;
	if (g_once_init_enter (&lsp_initialize_params_type_id__once)) {
		GType lsp_initialize_params_type_id;
		lsp_initialize_params_type_id = lsp_initialize_params_get_type_once ();
		g_once_init_leave (&lsp_initialize_params_type_id__once, lsp_initialize_params_type_id);
	}
	return lsp_initialize_params_type_id__once;
}

static void
_vala_lsp_initialize_params_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec)
{
	LspInitializeParams * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_INITIALIZE_PARAMS, LspInitializeParams);
#line 688 "../src/protocol.vala"
	switch (property_id) {
#line 688 "../src/protocol.vala"
		case LSP_INITIALIZE_PARAMS_PROCESS_ID_PROPERTY:
#line 688 "../src/protocol.vala"
		g_value_set_int (value, lsp_initialize_params_get_processId (self));
#line 688 "../src/protocol.vala"
		break;
#line 688 "../src/protocol.vala"
		case LSP_INITIALIZE_PARAMS_ROOT_PATH_PROPERTY:
#line 688 "../src/protocol.vala"
		g_value_set_string (value, lsp_initialize_params_get_rootPath (self));
#line 688 "../src/protocol.vala"
		break;
#line 688 "../src/protocol.vala"
		case LSP_INITIALIZE_PARAMS_ROOT_URI_PROPERTY:
#line 688 "../src/protocol.vala"
		g_value_set_string (value, lsp_initialize_params_get_rootUri (self));
#line 688 "../src/protocol.vala"
		break;
#line 688 "../src/protocol.vala"
		case LSP_INITIALIZE_PARAMS_CAPABILITIES_PROPERTY:
#line 688 "../src/protocol.vala"
		g_value_set_object (value, lsp_initialize_params_get_capabilities (self));
#line 688 "../src/protocol.vala"
		break;
#line 12247 "protocol.c"
		default:
#line 688 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 688 "../src/protocol.vala"
		break;
#line 12253 "protocol.c"
	}
}

static void
_vala_lsp_initialize_params_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec)
{
	LspInitializeParams * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_INITIALIZE_PARAMS, LspInitializeParams);
#line 688 "../src/protocol.vala"
	switch (property_id) {
#line 688 "../src/protocol.vala"
		case LSP_INITIALIZE_PARAMS_PROCESS_ID_PROPERTY:
#line 688 "../src/protocol.vala"
		lsp_initialize_params_set_processId (self, g_value_get_int (value));
#line 688 "../src/protocol.vala"
		break;
#line 688 "../src/protocol.vala"
		case LSP_INITIALIZE_PARAMS_ROOT_PATH_PROPERTY:
#line 688 "../src/protocol.vala"
		lsp_initialize_params_set_rootPath (self, g_value_get_string (value));
#line 688 "../src/protocol.vala"
		break;
#line 688 "../src/protocol.vala"
		case LSP_INITIALIZE_PARAMS_ROOT_URI_PROPERTY:
#line 688 "../src/protocol.vala"
		lsp_initialize_params_set_rootUri (self, g_value_get_string (value));
#line 688 "../src/protocol.vala"
		break;
#line 688 "../src/protocol.vala"
		case LSP_INITIALIZE_PARAMS_CAPABILITIES_PROPERTY:
#line 688 "../src/protocol.vala"
		lsp_initialize_params_set_capabilities (self, g_value_get_object (value));
#line 688 "../src/protocol.vala"
		break;
#line 12291 "protocol.c"
		default:
#line 688 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 688 "../src/protocol.vala"
		break;
#line 12297 "protocol.c"
	}
}

static inline gpointer
lsp_signature_information_get_instance_private (LspSignatureInformation* self)
{
	return G_STRUCT_MEMBER_P (self, LspSignatureInformation_private_offset);
}

static void
lsp_signature_information_real_json_serializable_set_property (JsonSerializable* base,
                                                               GParamSpec* pspec,
                                                               GValue* value)
{
	LspSignatureInformation * self;
	const gchar* _tmp0_;
	GValue _tmp1_;
#line 701 "../src/protocol.vala"
	self = (LspSignatureInformation*) base;
#line 701 "../src/protocol.vala"
	g_return_if_fail (pspec != NULL);
#line 701 "../src/protocol.vala"
	g_return_if_fail (value != NULL);
#line 702 "../src/protocol.vala"
	_tmp0_ = g_param_spec_get_name (pspec);
#line 702 "../src/protocol.vala"
	_tmp1_ = *value;
#line 702 "../src/protocol.vala"
	g_object_set_property (G_TYPE_CHECK_INSTANCE_CAST (self, G_TYPE_OBJECT, GObject), _tmp0_, &_tmp1_);
#line 12327 "protocol.c"
}

static void
lsp_signature_information_real_json_serializable_get_property (JsonSerializable* base,
                                                               GParamSpec* pspec,
                                                               GValue* result)
{
	LspSignatureInformation * self;
	GValue val = {0};
	GValue _tmp0_ = {0};
	const gchar* _tmp1_;
#line 705 "../src/protocol.vala"
	self = (LspSignatureInformation*) base;
#line 705 "../src/protocol.vala"
	g_return_if_fail (pspec != NULL);
#line 706 "../src/protocol.vala"
	g_value_init (&_tmp0_, pspec->value_type);
#line 706 "../src/protocol.vala"
	val = _tmp0_;
#line 707 "../src/protocol.vala"
	_tmp1_ = g_param_spec_get_name (pspec);
#line 707 "../src/protocol.vala"
	g_object_get_property (G_TYPE_CHECK_INSTANCE_CAST (self, G_TYPE_OBJECT, GObject), _tmp1_, &val);
#line 708 "../src/protocol.vala"
	*result = val;
#line 708 "../src/protocol.vala"
	return;
#line 12355 "protocol.c"
}

static GParamSpec*
lsp_signature_information_real_find_property (JsonSerializable* base,
                                              const gchar* name)
{
	LspSignatureInformation * self;
	GObjectClass* _tmp0_;
	GParamSpec* _tmp1_;
	GParamSpec* result;
#line 711 "../src/protocol.vala"
	self = (LspSignatureInformation*) base;
#line 711 "../src/protocol.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 712 "../src/protocol.vala"
	_tmp0_ = G_OBJECT_GET_CLASS ((GObject*) self);
#line 712 "../src/protocol.vala"
	_tmp1_ = g_object_class_find_property (_tmp0_, name);
#line 712 "../src/protocol.vala"
	result = _tmp1_;
#line 712 "../src/protocol.vala"
	return result;
#line 12378 "protocol.c"
}

static JsonNode*
lsp_signature_information_real_serialize_property (JsonSerializable* base,
                                                   const gchar* property_name,
                                                   GValue* value,
                                                   GParamSpec* pspec)
{
	LspSignatureInformation * self;
	JsonNode* node = NULL;
	JsonNode* _tmp2_;
	JsonNode* _tmp3_;
	JsonArray* _tmp4_;
	JsonArray* _tmp5_;
	JsonArray* array = NULL;
	JsonNode* _tmp6_;
	JsonArray* _tmp7_;
	JsonArray* _tmp8_;
	JsonNode* result;
#line 715 "../src/protocol.vala"
	self = (LspSignatureInformation*) base;
#line 715 "../src/protocol.vala"
	g_return_val_if_fail (property_name != NULL, NULL);
#line 715 "../src/protocol.vala"
	g_return_val_if_fail (value != NULL, NULL);
#line 715 "../src/protocol.vala"
	g_return_val_if_fail (pspec != NULL, NULL);
#line 716 "../src/protocol.vala"
	if (g_strcmp0 (property_name, "parameters") != 0) {
#line 12408 "protocol.c"
		GValue _tmp0_;
		JsonNode* _tmp1_;
#line 717 "../src/protocol.vala"
		_tmp0_ = *value;
#line 717 "../src/protocol.vala"
		_tmp1_ = json_serializable_default_serialize_property ((JsonSerializable*) self, property_name, &_tmp0_, pspec);
#line 717 "../src/protocol.vala"
		result = _tmp1_;
#line 717 "../src/protocol.vala"
		return result;
#line 12419 "protocol.c"
	}
#line 718 "../src/protocol.vala"
	_tmp2_ = json_node_new (JSON_NODE_ARRAY);
#line 718 "../src/protocol.vala"
	node = _tmp2_;
#line 719 "../src/protocol.vala"
	_tmp3_ = node;
#line 719 "../src/protocol.vala"
	_tmp4_ = json_array_new ();
#line 719 "../src/protocol.vala"
	_tmp5_ = _tmp4_;
#line 719 "../src/protocol.vala"
	json_node_init_array (_tmp3_, _tmp5_);
#line 719 "../src/protocol.vala"
	_json_array_unref0 (_tmp5_);
#line 720 "../src/protocol.vala"
	_tmp6_ = node;
#line 720 "../src/protocol.vala"
	_tmp7_ = json_node_get_array (_tmp6_);
#line 720 "../src/protocol.vala"
	_tmp8_ = _json_array_ref0 (_tmp7_);
#line 720 "../src/protocol.vala"
	array = _tmp8_;
#line 12443 "protocol.c"
	{
		GeeList* _child_list = NULL;
		GeeList* _tmp9_;
		gint _child_size = 0;
		GeeList* _tmp10_;
		gint _tmp11_;
		gint _tmp12_;
		gint _child_index = 0;
#line 721 "../src/protocol.vala"
		_tmp9_ = self->priv->_parameters;
#line 721 "../src/protocol.vala"
		_child_list = _tmp9_;
#line 721 "../src/protocol.vala"
		_tmp10_ = _child_list;
#line 721 "../src/protocol.vala"
		_tmp11_ = gee_collection_get_size ((GeeCollection*) _tmp10_);
#line 721 "../src/protocol.vala"
		_tmp12_ = _tmp11_;
#line 721 "../src/protocol.vala"
		_child_size = _tmp12_;
#line 721 "../src/protocol.vala"
		_child_index = -1;
#line 721 "../src/protocol.vala"
		while (TRUE) {
#line 12468 "protocol.c"
			gint _tmp13_;
			gint _tmp14_;
			LspParameterInformation* child = NULL;
			GeeList* _tmp15_;
			gpointer _tmp16_;
			JsonArray* _tmp17_;
			LspParameterInformation* _tmp18_;
			JsonNode* _tmp19_;
#line 721 "../src/protocol.vala"
			_child_index = _child_index + 1;
#line 721 "../src/protocol.vala"
			_tmp13_ = _child_index;
#line 721 "../src/protocol.vala"
			_tmp14_ = _child_size;
#line 721 "../src/protocol.vala"
			if (!(_tmp13_ < _tmp14_)) {
#line 721 "../src/protocol.vala"
				break;
#line 12487 "protocol.c"
			}
#line 721 "../src/protocol.vala"
			_tmp15_ = _child_list;
#line 721 "../src/protocol.vala"
			_tmp16_ = gee_list_get (_tmp15_, _child_index);
#line 721 "../src/protocol.vala"
			child = (LspParameterInformation*) _tmp16_;
#line 722 "../src/protocol.vala"
			_tmp17_ = array;
#line 722 "../src/protocol.vala"
			_tmp18_ = child;
#line 722 "../src/protocol.vala"
			_tmp19_ = json_gobject_serialize ((GObject*) _tmp18_);
#line 722 "../src/protocol.vala"
			json_array_add_element (_tmp17_, _tmp19_);
#line 721 "../src/protocol.vala"
			_g_object_unref0 (child);
#line 12505 "protocol.c"
		}
	}
#line 723 "../src/protocol.vala"
	result = node;
#line 723 "../src/protocol.vala"
	_json_array_unref0 (array);
#line 723 "../src/protocol.vala"
	return result;
#line 12514 "protocol.c"
}

static gboolean
lsp_signature_information_real_deserialize_property (JsonSerializable* base,
                                                     const gchar* property_name,
                                                     GValue* value,
                                                     GParamSpec* pspec,
                                                     JsonNode* property_node)
{
	LspSignatureInformation * self;
	GValue _vala_value = {0};
#line 726 "../src/protocol.vala"
	self = (LspSignatureInformation*) base;
#line 726 "../src/protocol.vala"
	g_return_val_if_fail (property_name != NULL, FALSE);
#line 726 "../src/protocol.vala"
	g_return_val_if_fail (pspec != NULL, FALSE);
#line 726 "../src/protocol.vala"
	g_return_val_if_fail (property_node != NULL, FALSE);
#line 727 "../src/protocol.vala"
	g_error ("protocol.vala:727: deserialization not supported");
#line 12536 "protocol.c"
}

LspSignatureInformation*
lsp_signature_information_construct (GType object_type)
{
	LspSignatureInformation * self = NULL;
#line 695 "../src/protocol.vala"
	self = (LspSignatureInformation*) g_object_new (object_type, NULL);
#line 695 "../src/protocol.vala"
	return self;
#line 12547 "protocol.c"
}

LspSignatureInformation*
lsp_signature_information_new (void)
{
#line 695 "../src/protocol.vala"
	return lsp_signature_information_construct (LSP_TYPE_SIGNATURE_INFORMATION);
#line 12555 "protocol.c"
}

const gchar*
lsp_signature_information_get_label (LspSignatureInformation* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 696 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 696 "../src/protocol.vala"
	_tmp0_ = self->priv->_label;
#line 696 "../src/protocol.vala"
	result = _tmp0_;
#line 696 "../src/protocol.vala"
	return result;
#line 12571 "protocol.c"
}

void
lsp_signature_information_set_label (LspSignatureInformation* self,
                                     const gchar* value)
{
	gchar* old_value;
#line 696 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 696 "../src/protocol.vala"
	old_value = lsp_signature_information_get_label (self);
#line 696 "../src/protocol.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 12585 "protocol.c"
		gchar* _tmp0_;
#line 696 "../src/protocol.vala"
		_tmp0_ = g_strdup (value);
#line 696 "../src/protocol.vala"
		_g_free0 (self->priv->_label);
#line 696 "../src/protocol.vala"
		self->priv->_label = _tmp0_;
#line 696 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_signature_information_properties[LSP_SIGNATURE_INFORMATION_LABEL_PROPERTY]);
#line 12595 "protocol.c"
	}
}

LspMarkupContent*
lsp_signature_information_get_documentation (LspSignatureInformation* self)
{
	LspMarkupContent* result;
	LspMarkupContent* _tmp0_;
#line 697 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 697 "../src/protocol.vala"
	_tmp0_ = self->priv->_documentation;
#line 697 "../src/protocol.vala"
	result = _tmp0_;
#line 697 "../src/protocol.vala"
	return result;
#line 12612 "protocol.c"
}

void
lsp_signature_information_set_documentation (LspSignatureInformation* self,
                                             LspMarkupContent* value)
{
	LspMarkupContent* old_value;
#line 697 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 697 "../src/protocol.vala"
	old_value = lsp_signature_information_get_documentation (self);
#line 697 "../src/protocol.vala"
	if (old_value != value) {
#line 12626 "protocol.c"
		LspMarkupContent* _tmp0_;
#line 697 "../src/protocol.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 697 "../src/protocol.vala"
		_g_object_unref0 (self->priv->_documentation);
#line 697 "../src/protocol.vala"
		self->priv->_documentation = _tmp0_;
#line 697 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_signature_information_properties[LSP_SIGNATURE_INFORMATION_DOCUMENTATION_PROPERTY]);
#line 12636 "protocol.c"
	}
}

GeeList*
lsp_signature_information_get_parameters (LspSignatureInformation* self)
{
	GeeList* result;
	GeeList* _tmp0_;
#line 699 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 699 "../src/protocol.vala"
	_tmp0_ = self->priv->_parameters;
#line 699 "../src/protocol.vala"
	result = _tmp0_;
#line 699 "../src/protocol.vala"
	return result;
#line 12653 "protocol.c"
}

static void
lsp_signature_information_set_parameters (LspSignatureInformation* self,
                                          GeeList* value)
{
	GeeList* old_value;
#line 699 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 699 "../src/protocol.vala"
	old_value = lsp_signature_information_get_parameters (self);
#line 699 "../src/protocol.vala"
	if (old_value != value) {
#line 12667 "protocol.c"
		GeeList* _tmp0_;
#line 699 "../src/protocol.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 699 "../src/protocol.vala"
		_g_object_unref0 (self->priv->_parameters);
#line 699 "../src/protocol.vala"
		self->priv->_parameters = _tmp0_;
#line 699 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_signature_information_properties[LSP_SIGNATURE_INFORMATION_PARAMETERS_PROPERTY]);
#line 12677 "protocol.c"
	}
}

static void
lsp_signature_information_class_init (LspSignatureInformationClass * klass,
                                      gpointer klass_data)
{
#line 695 "../src/protocol.vala"
	lsp_signature_information_parent_class = g_type_class_peek_parent (klass);
#line 695 "../src/protocol.vala"
	g_type_class_adjust_private_offset (klass, &LspSignatureInformation_private_offset);
#line 695 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_lsp_signature_information_get_property;
#line 695 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_lsp_signature_information_set_property;
#line 695 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->finalize = lsp_signature_information_finalize;
#line 695 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_SIGNATURE_INFORMATION_LABEL_PROPERTY, lsp_signature_information_properties[LSP_SIGNATURE_INFORMATION_LABEL_PROPERTY] = g_param_spec_string ("label", "label", "label", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 695 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_SIGNATURE_INFORMATION_DOCUMENTATION_PROPERTY, lsp_signature_information_properties[LSP_SIGNATURE_INFORMATION_DOCUMENTATION_PROPERTY] = g_param_spec_object ("documentation", "documentation", "documentation", LSP_TYPE_MARKUP_CONTENT, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 695 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_SIGNATURE_INFORMATION_PARAMETERS_PROPERTY, lsp_signature_information_properties[LSP_SIGNATURE_INFORMATION_PARAMETERS_PROPERTY] = g_param_spec_object ("parameters", "parameters", "parameters", GEE_TYPE_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 12701 "protocol.c"
}

static void
lsp_signature_information_json_serializable_interface_init (JsonSerializableIface * iface,
                                                            gpointer iface_data)
{
#line 695 "../src/protocol.vala"
	lsp_signature_information_json_serializable_parent_iface = g_type_interface_peek_parent (iface);
#line 695 "../src/protocol.vala"
	iface->set_property = (void (*) (JsonSerializable*, GParamSpec*, GValue*)) lsp_signature_information_real_json_serializable_set_property;
#line 695 "../src/protocol.vala"
	iface->get_property = (void (*) (JsonSerializable*, GParamSpec*, GValue*)) lsp_signature_information_real_json_serializable_get_property;
#line 695 "../src/protocol.vala"
	iface->find_property = (GParamSpec* (*) (JsonSerializable*, const gchar*)) lsp_signature_information_real_find_property;
#line 695 "../src/protocol.vala"
	iface->serialize_property = (JsonNode* (*) (JsonSerializable*, const gchar*, GValue*, GParamSpec*)) lsp_signature_information_real_serialize_property;
#line 695 "../src/protocol.vala"
	iface->deserialize_property = (gboolean (*) (JsonSerializable*, const gchar*, GValue*, GParamSpec*, JsonNode*)) lsp_signature_information_real_deserialize_property;
#line 12720 "protocol.c"
}

static void
lsp_signature_information_instance_init (LspSignatureInformation * self,
                                         gpointer klass)
{
	GeeLinkedList* _tmp0_;
#line 695 "../src/protocol.vala"
	self->priv = lsp_signature_information_get_instance_private (self);
#line 699 "../src/protocol.vala"
	_tmp0_ = gee_linked_list_new (LSP_TYPE_PARAMETER_INFORMATION, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 699 "../src/protocol.vala"
	if (_tmp0_) {
#line 699 "../src/protocol.vala"
		g_object_set_data ((GObject *) _tmp0_, "vala-creation-function", "");
#line 12736 "protocol.c"
	}
#line 699 "../src/protocol.vala"
	self->priv->_parameters = (GeeList*) _tmp0_;
#line 12740 "protocol.c"
}

static void
lsp_signature_information_finalize (GObject * obj)
{
	LspSignatureInformation * self;
#line 695 "../src/protocol.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, LSP_TYPE_SIGNATURE_INFORMATION, LspSignatureInformation);
#line 696 "../src/protocol.vala"
	_g_free0 (self->priv->_label);
#line 697 "../src/protocol.vala"
	_g_object_unref0 (self->priv->_documentation);
#line 699 "../src/protocol.vala"
	_g_object_unref0 (self->priv->_parameters);
#line 695 "../src/protocol.vala"
	G_OBJECT_CLASS (lsp_signature_information_parent_class)->finalize (obj);
#line 12757 "protocol.c"
}

 G_GNUC_NO_INLINE static GType
lsp_signature_information_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (LspSignatureInformationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) lsp_signature_information_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LspSignatureInformation), 0, (GInstanceInitFunc) lsp_signature_information_instance_init, NULL };
	static const GInterfaceInfo json_serializable_info = { (GInterfaceInitFunc) lsp_signature_information_json_serializable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType lsp_signature_information_type_id;
	lsp_signature_information_type_id = g_type_register_static (G_TYPE_OBJECT, "LspSignatureInformation", &g_define_type_info, 0);
	g_type_add_interface_static (lsp_signature_information_type_id, json_serializable_get_type (), &json_serializable_info);
	LspSignatureInformation_private_offset = g_type_add_instance_private (lsp_signature_information_type_id, sizeof (LspSignatureInformationPrivate));
	return lsp_signature_information_type_id;
}

GType
lsp_signature_information_get_type (void)
{
	static gsize lsp_signature_information_type_id__once = 0;
	if (g_once_init_enter (&lsp_signature_information_type_id__once)) {
		GType lsp_signature_information_type_id;
		lsp_signature_information_type_id = lsp_signature_information_get_type_once ();
		g_once_init_leave (&lsp_signature_information_type_id__once, lsp_signature_information_type_id);
	}
	return lsp_signature_information_type_id__once;
}

static void
_vala_lsp_signature_information_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec)
{
	LspSignatureInformation * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_SIGNATURE_INFORMATION, LspSignatureInformation);
#line 695 "../src/protocol.vala"
	switch (property_id) {
#line 695 "../src/protocol.vala"
		case LSP_SIGNATURE_INFORMATION_LABEL_PROPERTY:
#line 695 "../src/protocol.vala"
		g_value_set_string (value, lsp_signature_information_get_label (self));
#line 695 "../src/protocol.vala"
		break;
#line 695 "../src/protocol.vala"
		case LSP_SIGNATURE_INFORMATION_DOCUMENTATION_PROPERTY:
#line 695 "../src/protocol.vala"
		g_value_set_object (value, lsp_signature_information_get_documentation (self));
#line 695 "../src/protocol.vala"
		break;
#line 695 "../src/protocol.vala"
		case LSP_SIGNATURE_INFORMATION_PARAMETERS_PROPERTY:
#line 695 "../src/protocol.vala"
		g_value_set_object (value, lsp_signature_information_get_parameters (self));
#line 695 "../src/protocol.vala"
		break;
#line 12812 "protocol.c"
		default:
#line 695 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 695 "../src/protocol.vala"
		break;
#line 12818 "protocol.c"
	}
}

static void
_vala_lsp_signature_information_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec)
{
	LspSignatureInformation * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_SIGNATURE_INFORMATION, LspSignatureInformation);
#line 695 "../src/protocol.vala"
	switch (property_id) {
#line 695 "../src/protocol.vala"
		case LSP_SIGNATURE_INFORMATION_LABEL_PROPERTY:
#line 695 "../src/protocol.vala"
		lsp_signature_information_set_label (self, g_value_get_string (value));
#line 695 "../src/protocol.vala"
		break;
#line 695 "../src/protocol.vala"
		case LSP_SIGNATURE_INFORMATION_DOCUMENTATION_PROPERTY:
#line 695 "../src/protocol.vala"
		lsp_signature_information_set_documentation (self, g_value_get_object (value));
#line 695 "../src/protocol.vala"
		break;
#line 695 "../src/protocol.vala"
		case LSP_SIGNATURE_INFORMATION_PARAMETERS_PROPERTY:
#line 695 "../src/protocol.vala"
		lsp_signature_information_set_parameters (self, g_value_get_object (value));
#line 695 "../src/protocol.vala"
		break;
#line 12850 "protocol.c"
		default:
#line 695 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 695 "../src/protocol.vala"
		break;
#line 12856 "protocol.c"
	}
}

static inline gpointer
lsp_signature_help_get_instance_private (LspSignatureHelp* self)
{
	return G_STRUCT_MEMBER_P (self, LspSignatureHelp_private_offset);
}

static JsonNode*
lsp_signature_help_real_serialize_property (JsonSerializable* base,
                                            const gchar* property_name,
                                            GValue* value,
                                            GParamSpec* pspec)
{
	LspSignatureHelp * self;
	JsonNode* node = NULL;
	JsonNode* _tmp2_;
	JsonNode* _tmp3_;
	JsonArray* _tmp4_;
	JsonArray* _tmp5_;
	JsonArray* array = NULL;
	JsonNode* _tmp6_;
	JsonArray* _tmp7_;
	JsonArray* _tmp8_;
	JsonNode* result;
#line 736 "../src/protocol.vala"
	self = (LspSignatureHelp*) base;
#line 736 "../src/protocol.vala"
	g_return_val_if_fail (property_name != NULL, NULL);
#line 736 "../src/protocol.vala"
	g_return_val_if_fail (value != NULL, NULL);
#line 736 "../src/protocol.vala"
	g_return_val_if_fail (pspec != NULL, NULL);
#line 737 "../src/protocol.vala"
	if (g_strcmp0 (property_name, "signatures") != 0) {
#line 12893 "protocol.c"
		GValue _tmp0_;
		JsonNode* _tmp1_;
#line 738 "../src/protocol.vala"
		_tmp0_ = *value;
#line 738 "../src/protocol.vala"
		_tmp1_ = json_serializable_default_serialize_property ((JsonSerializable*) self, property_name, &_tmp0_, pspec);
#line 738 "../src/protocol.vala"
		result = _tmp1_;
#line 738 "../src/protocol.vala"
		return result;
#line 12904 "protocol.c"
	}
#line 740 "../src/protocol.vala"
	_tmp2_ = json_node_new (JSON_NODE_ARRAY);
#line 740 "../src/protocol.vala"
	node = _tmp2_;
#line 741 "../src/protocol.vala"
	_tmp3_ = node;
#line 741 "../src/protocol.vala"
	_tmp4_ = json_array_new ();
#line 741 "../src/protocol.vala"
	_tmp5_ = _tmp4_;
#line 741 "../src/protocol.vala"
	json_node_init_array (_tmp3_, _tmp5_);
#line 741 "../src/protocol.vala"
	_json_array_unref0 (_tmp5_);
#line 742 "../src/protocol.vala"
	_tmp6_ = node;
#line 742 "../src/protocol.vala"
	_tmp7_ = json_node_get_array (_tmp6_);
#line 742 "../src/protocol.vala"
	_tmp8_ = _json_array_ref0 (_tmp7_);
#line 742 "../src/protocol.vala"
	array = _tmp8_;
#line 12928 "protocol.c"
	{
		GeeIterator* _child_it = NULL;
		GeeCollection* _tmp9_;
		GeeIterator* _tmp10_;
#line 743 "../src/protocol.vala"
		_tmp9_ = self->priv->_signatures;
#line 743 "../src/protocol.vala"
		_tmp10_ = gee_iterable_iterator ((GeeIterable*) _tmp9_);
#line 743 "../src/protocol.vala"
		_child_it = _tmp10_;
#line 743 "../src/protocol.vala"
		while (TRUE) {
#line 12941 "protocol.c"
			GeeIterator* _tmp11_;
			LspSignatureInformation* child = NULL;
			GeeIterator* _tmp12_;
			gpointer _tmp13_;
			JsonArray* _tmp14_;
			LspSignatureInformation* _tmp15_;
			JsonNode* _tmp16_;
#line 743 "../src/protocol.vala"
			_tmp11_ = _child_it;
#line 743 "../src/protocol.vala"
			if (!gee_iterator_next (_tmp11_)) {
#line 743 "../src/protocol.vala"
				break;
#line 12955 "protocol.c"
			}
#line 743 "../src/protocol.vala"
			_tmp12_ = _child_it;
#line 743 "../src/protocol.vala"
			_tmp13_ = gee_iterator_get (_tmp12_);
#line 743 "../src/protocol.vala"
			child = (LspSignatureInformation*) _tmp13_;
#line 744 "../src/protocol.vala"
			_tmp14_ = array;
#line 744 "../src/protocol.vala"
			_tmp15_ = child;
#line 744 "../src/protocol.vala"
			_tmp16_ = json_gobject_serialize ((GObject*) _tmp15_);
#line 744 "../src/protocol.vala"
			json_array_add_element (_tmp14_, _tmp16_);
#line 743 "../src/protocol.vala"
			_g_object_unref0 (child);
#line 12973 "protocol.c"
		}
#line 743 "../src/protocol.vala"
		_g_object_unref0 (_child_it);
#line 12977 "protocol.c"
	}
#line 745 "../src/protocol.vala"
	result = node;
#line 745 "../src/protocol.vala"
	_json_array_unref0 (array);
#line 745 "../src/protocol.vala"
	return result;
#line 12985 "protocol.c"
}

static gboolean
lsp_signature_help_real_deserialize_property (JsonSerializable* base,
                                              const gchar* property_name,
                                              GValue* value,
                                              GParamSpec* pspec,
                                              JsonNode* property_node)
{
	LspSignatureHelp * self;
	GValue _vala_value = {0};
#line 748 "../src/protocol.vala"
	self = (LspSignatureHelp*) base;
#line 748 "../src/protocol.vala"
	g_return_val_if_fail (property_name != NULL, FALSE);
#line 748 "../src/protocol.vala"
	g_return_val_if_fail (pspec != NULL, FALSE);
#line 748 "../src/protocol.vala"
	g_return_val_if_fail (property_node != NULL, FALSE);
#line 749 "../src/protocol.vala"
	g_error ("protocol.vala:749: deserialization not supported");
#line 13007 "protocol.c"
}

LspSignatureHelp*
lsp_signature_help_construct (GType object_type)
{
	LspSignatureHelp * self = NULL;
#line 731 "../src/protocol.vala"
	self = (LspSignatureHelp*) g_object_new (object_type, NULL);
#line 731 "../src/protocol.vala"
	return self;
#line 13018 "protocol.c"
}

LspSignatureHelp*
lsp_signature_help_new (void)
{
#line 731 "../src/protocol.vala"
	return lsp_signature_help_construct (LSP_TYPE_SIGNATURE_HELP);
#line 13026 "protocol.c"
}

GeeCollection*
lsp_signature_help_get_signatures (LspSignatureHelp* self)
{
	GeeCollection* result;
	GeeCollection* _tmp0_;
#line 732 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 732 "../src/protocol.vala"
	_tmp0_ = self->priv->_signatures;
#line 732 "../src/protocol.vala"
	result = _tmp0_;
#line 732 "../src/protocol.vala"
	return result;
#line 13042 "protocol.c"
}

void
lsp_signature_help_set_signatures (LspSignatureHelp* self,
                                   GeeCollection* value)
{
	GeeCollection* old_value;
#line 732 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 732 "../src/protocol.vala"
	old_value = lsp_signature_help_get_signatures (self);
#line 732 "../src/protocol.vala"
	if (old_value != value) {
#line 13056 "protocol.c"
		GeeCollection* _tmp0_;
#line 732 "../src/protocol.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 732 "../src/protocol.vala"
		_g_object_unref0 (self->priv->_signatures);
#line 732 "../src/protocol.vala"
		self->priv->_signatures = _tmp0_;
#line 732 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_signature_help_properties[LSP_SIGNATURE_HELP_SIGNATURES_PROPERTY]);
#line 13066 "protocol.c"
	}
}

gint
lsp_signature_help_get_activeSignature (LspSignatureHelp* self)
{
	gint result;
#line 733 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 733 "../src/protocol.vala"
	result = self->priv->_activeSignature;
#line 733 "../src/protocol.vala"
	return result;
#line 13080 "protocol.c"
}

void
lsp_signature_help_set_activeSignature (LspSignatureHelp* self,
                                        gint value)
{
	gint old_value;
#line 733 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 733 "../src/protocol.vala"
	old_value = lsp_signature_help_get_activeSignature (self);
#line 733 "../src/protocol.vala"
	if (old_value != value) {
#line 733 "../src/protocol.vala"
		self->priv->_activeSignature = value;
#line 733 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_signature_help_properties[LSP_SIGNATURE_HELP_ACTIVE_SIGNATURE_PROPERTY]);
#line 13098 "protocol.c"
	}
}

gint
lsp_signature_help_get_activeParameter (LspSignatureHelp* self)
{
	gint result;
#line 734 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 734 "../src/protocol.vala"
	result = self->priv->_activeParameter;
#line 734 "../src/protocol.vala"
	return result;
#line 13112 "protocol.c"
}

void
lsp_signature_help_set_activeParameter (LspSignatureHelp* self,
                                        gint value)
{
	gint old_value;
#line 734 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 734 "../src/protocol.vala"
	old_value = lsp_signature_help_get_activeParameter (self);
#line 734 "../src/protocol.vala"
	if (old_value != value) {
#line 734 "../src/protocol.vala"
		self->priv->_activeParameter = value;
#line 734 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_signature_help_properties[LSP_SIGNATURE_HELP_ACTIVE_PARAMETER_PROPERTY]);
#line 13130 "protocol.c"
	}
}

static void
lsp_signature_help_class_init (LspSignatureHelpClass * klass,
                               gpointer klass_data)
{
#line 731 "../src/protocol.vala"
	lsp_signature_help_parent_class = g_type_class_peek_parent (klass);
#line 731 "../src/protocol.vala"
	g_type_class_adjust_private_offset (klass, &LspSignatureHelp_private_offset);
#line 731 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_lsp_signature_help_get_property;
#line 731 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_lsp_signature_help_set_property;
#line 731 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->finalize = lsp_signature_help_finalize;
#line 731 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_SIGNATURE_HELP_SIGNATURES_PROPERTY, lsp_signature_help_properties[LSP_SIGNATURE_HELP_SIGNATURES_PROPERTY] = g_param_spec_object ("signatures", "signatures", "signatures", GEE_TYPE_COLLECTION, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 731 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_SIGNATURE_HELP_ACTIVE_SIGNATURE_PROPERTY, lsp_signature_help_properties[LSP_SIGNATURE_HELP_ACTIVE_SIGNATURE_PROPERTY] = g_param_spec_int ("activeSignature", "activeSignature", "activeSignature", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 731 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_SIGNATURE_HELP_ACTIVE_PARAMETER_PROPERTY, lsp_signature_help_properties[LSP_SIGNATURE_HELP_ACTIVE_PARAMETER_PROPERTY] = g_param_spec_int ("activeParameter", "activeParameter", "activeParameter", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 13154 "protocol.c"
}

static void
lsp_signature_help_json_serializable_interface_init (JsonSerializableIface * iface,
                                                     gpointer iface_data)
{
#line 731 "../src/protocol.vala"
	lsp_signature_help_json_serializable_parent_iface = g_type_interface_peek_parent (iface);
#line 731 "../src/protocol.vala"
	iface->serialize_property = (JsonNode* (*) (JsonSerializable*, const gchar*, GValue*, GParamSpec*)) lsp_signature_help_real_serialize_property;
#line 731 "../src/protocol.vala"
	iface->deserialize_property = (gboolean (*) (JsonSerializable*, const gchar*, GValue*, GParamSpec*, JsonNode*)) lsp_signature_help_real_deserialize_property;
#line 13167 "protocol.c"
}

static void
lsp_signature_help_instance_init (LspSignatureHelp * self,
                                  gpointer klass)
{
	GeeArrayList* _tmp0_;
#line 731 "../src/protocol.vala"
	self->priv = lsp_signature_help_get_instance_private (self);
#line 732 "../src/protocol.vala"
	_tmp0_ = gee_array_list_new (LSP_TYPE_SIGNATURE_INFORMATION, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 732 "../src/protocol.vala"
	if (_tmp0_) {
#line 732 "../src/protocol.vala"
		g_object_set_data ((GObject *) _tmp0_, "vala-creation-function", "");
#line 13183 "protocol.c"
	}
#line 732 "../src/protocol.vala"
	self->priv->_signatures = (GeeCollection*) _tmp0_;
#line 13187 "protocol.c"
}

static void
lsp_signature_help_finalize (GObject * obj)
{
	LspSignatureHelp * self;
#line 731 "../src/protocol.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, LSP_TYPE_SIGNATURE_HELP, LspSignatureHelp);
#line 732 "../src/protocol.vala"
	_g_object_unref0 (self->priv->_signatures);
#line 731 "../src/protocol.vala"
	G_OBJECT_CLASS (lsp_signature_help_parent_class)->finalize (obj);
#line 13200 "protocol.c"
}

 G_GNUC_NO_INLINE static GType
lsp_signature_help_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (LspSignatureHelpClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) lsp_signature_help_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LspSignatureHelp), 0, (GInstanceInitFunc) lsp_signature_help_instance_init, NULL };
	static const GInterfaceInfo json_serializable_info = { (GInterfaceInitFunc) lsp_signature_help_json_serializable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType lsp_signature_help_type_id;
	lsp_signature_help_type_id = g_type_register_static (G_TYPE_OBJECT, "LspSignatureHelp", &g_define_type_info, 0);
	g_type_add_interface_static (lsp_signature_help_type_id, json_serializable_get_type (), &json_serializable_info);
	LspSignatureHelp_private_offset = g_type_add_instance_private (lsp_signature_help_type_id, sizeof (LspSignatureHelpPrivate));
	return lsp_signature_help_type_id;
}

GType
lsp_signature_help_get_type (void)
{
	static gsize lsp_signature_help_type_id__once = 0;
	if (g_once_init_enter (&lsp_signature_help_type_id__once)) {
		GType lsp_signature_help_type_id;
		lsp_signature_help_type_id = lsp_signature_help_get_type_once ();
		g_once_init_leave (&lsp_signature_help_type_id__once, lsp_signature_help_type_id);
	}
	return lsp_signature_help_type_id__once;
}

static void
_vala_lsp_signature_help_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec)
{
	LspSignatureHelp * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_SIGNATURE_HELP, LspSignatureHelp);
#line 731 "../src/protocol.vala"
	switch (property_id) {
#line 731 "../src/protocol.vala"
		case LSP_SIGNATURE_HELP_SIGNATURES_PROPERTY:
#line 731 "../src/protocol.vala"
		g_value_set_object (value, lsp_signature_help_get_signatures (self));
#line 731 "../src/protocol.vala"
		break;
#line 731 "../src/protocol.vala"
		case LSP_SIGNATURE_HELP_ACTIVE_SIGNATURE_PROPERTY:
#line 731 "../src/protocol.vala"
		g_value_set_int (value, lsp_signature_help_get_activeSignature (self));
#line 731 "../src/protocol.vala"
		break;
#line 731 "../src/protocol.vala"
		case LSP_SIGNATURE_HELP_ACTIVE_PARAMETER_PROPERTY:
#line 731 "../src/protocol.vala"
		g_value_set_int (value, lsp_signature_help_get_activeParameter (self));
#line 731 "../src/protocol.vala"
		break;
#line 13255 "protocol.c"
		default:
#line 731 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 731 "../src/protocol.vala"
		break;
#line 13261 "protocol.c"
	}
}

static void
_vala_lsp_signature_help_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec)
{
	LspSignatureHelp * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_SIGNATURE_HELP, LspSignatureHelp);
#line 731 "../src/protocol.vala"
	switch (property_id) {
#line 731 "../src/protocol.vala"
		case LSP_SIGNATURE_HELP_SIGNATURES_PROPERTY:
#line 731 "../src/protocol.vala"
		lsp_signature_help_set_signatures (self, g_value_get_object (value));
#line 731 "../src/protocol.vala"
		break;
#line 731 "../src/protocol.vala"
		case LSP_SIGNATURE_HELP_ACTIVE_SIGNATURE_PROPERTY:
#line 731 "../src/protocol.vala"
		lsp_signature_help_set_activeSignature (self, g_value_get_int (value));
#line 731 "../src/protocol.vala"
		break;
#line 731 "../src/protocol.vala"
		case LSP_SIGNATURE_HELP_ACTIVE_PARAMETER_PROPERTY:
#line 731 "../src/protocol.vala"
		lsp_signature_help_set_activeParameter (self, g_value_get_int (value));
#line 731 "../src/protocol.vala"
		break;
#line 13293 "protocol.c"
		default:
#line 731 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 731 "../src/protocol.vala"
		break;
#line 13299 "protocol.c"
	}
}

static inline gpointer
lsp_parameter_information_get_instance_private (LspParameterInformation* self)
{
	return G_STRUCT_MEMBER_P (self, LspParameterInformation_private_offset);
}

LspParameterInformation*
lsp_parameter_information_construct (GType object_type)
{
	LspParameterInformation * self = NULL;
#line 753 "../src/protocol.vala"
	self = (LspParameterInformation*) g_object_new (object_type, NULL);
#line 753 "../src/protocol.vala"
	return self;
#line 13317 "protocol.c"
}

LspParameterInformation*
lsp_parameter_information_new (void)
{
#line 753 "../src/protocol.vala"
	return lsp_parameter_information_construct (LSP_TYPE_PARAMETER_INFORMATION);
#line 13325 "protocol.c"
}

const gchar*
lsp_parameter_information_get_label (LspParameterInformation* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 754 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 754 "../src/protocol.vala"
	_tmp0_ = self->priv->_label;
#line 754 "../src/protocol.vala"
	result = _tmp0_;
#line 754 "../src/protocol.vala"
	return result;
#line 13341 "protocol.c"
}

void
lsp_parameter_information_set_label (LspParameterInformation* self,
                                     const gchar* value)
{
	gchar* old_value;
#line 754 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 754 "../src/protocol.vala"
	old_value = lsp_parameter_information_get_label (self);
#line 754 "../src/protocol.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 13355 "protocol.c"
		gchar* _tmp0_;
#line 754 "../src/protocol.vala"
		_tmp0_ = g_strdup (value);
#line 754 "../src/protocol.vala"
		_g_free0 (self->priv->_label);
#line 754 "../src/protocol.vala"
		self->priv->_label = _tmp0_;
#line 754 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_parameter_information_properties[LSP_PARAMETER_INFORMATION_LABEL_PROPERTY]);
#line 13365 "protocol.c"
	}
}

LspMarkupContent*
lsp_parameter_information_get_documentation (LspParameterInformation* self)
{
	LspMarkupContent* result;
	LspMarkupContent* _tmp0_;
#line 755 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 755 "../src/protocol.vala"
	_tmp0_ = self->priv->_documentation;
#line 755 "../src/protocol.vala"
	result = _tmp0_;
#line 755 "../src/protocol.vala"
	return result;
#line 13382 "protocol.c"
}

void
lsp_parameter_information_set_documentation (LspParameterInformation* self,
                                             LspMarkupContent* value)
{
	LspMarkupContent* old_value;
#line 755 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 755 "../src/protocol.vala"
	old_value = lsp_parameter_information_get_documentation (self);
#line 755 "../src/protocol.vala"
	if (old_value != value) {
#line 13396 "protocol.c"
		LspMarkupContent* _tmp0_;
#line 755 "../src/protocol.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 755 "../src/protocol.vala"
		_g_object_unref0 (self->priv->_documentation);
#line 755 "../src/protocol.vala"
		self->priv->_documentation = _tmp0_;
#line 755 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_parameter_information_properties[LSP_PARAMETER_INFORMATION_DOCUMENTATION_PROPERTY]);
#line 13406 "protocol.c"
	}
}

static void
lsp_parameter_information_class_init (LspParameterInformationClass * klass,
                                      gpointer klass_data)
{
#line 753 "../src/protocol.vala"
	lsp_parameter_information_parent_class = g_type_class_peek_parent (klass);
#line 753 "../src/protocol.vala"
	g_type_class_adjust_private_offset (klass, &LspParameterInformation_private_offset);
#line 753 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_lsp_parameter_information_get_property;
#line 753 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_lsp_parameter_information_set_property;
#line 753 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->finalize = lsp_parameter_information_finalize;
#line 753 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_PARAMETER_INFORMATION_LABEL_PROPERTY, lsp_parameter_information_properties[LSP_PARAMETER_INFORMATION_LABEL_PROPERTY] = g_param_spec_string ("label", "label", "label", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 753 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_PARAMETER_INFORMATION_DOCUMENTATION_PROPERTY, lsp_parameter_information_properties[LSP_PARAMETER_INFORMATION_DOCUMENTATION_PROPERTY] = g_param_spec_object ("documentation", "documentation", "documentation", LSP_TYPE_MARKUP_CONTENT, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 13428 "protocol.c"
}

static void
lsp_parameter_information_instance_init (LspParameterInformation * self,
                                         gpointer klass)
{
#line 753 "../src/protocol.vala"
	self->priv = lsp_parameter_information_get_instance_private (self);
#line 13437 "protocol.c"
}

static void
lsp_parameter_information_finalize (GObject * obj)
{
	LspParameterInformation * self;
#line 753 "../src/protocol.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, LSP_TYPE_PARAMETER_INFORMATION, LspParameterInformation);
#line 754 "../src/protocol.vala"
	_g_free0 (self->priv->_label);
#line 755 "../src/protocol.vala"
	_g_object_unref0 (self->priv->_documentation);
#line 753 "../src/protocol.vala"
	G_OBJECT_CLASS (lsp_parameter_information_parent_class)->finalize (obj);
#line 13452 "protocol.c"
}

 G_GNUC_NO_INLINE static GType
lsp_parameter_information_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (LspParameterInformationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) lsp_parameter_information_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LspParameterInformation), 0, (GInstanceInitFunc) lsp_parameter_information_instance_init, NULL };
	GType lsp_parameter_information_type_id;
	lsp_parameter_information_type_id = g_type_register_static (G_TYPE_OBJECT, "LspParameterInformation", &g_define_type_info, 0);
	LspParameterInformation_private_offset = g_type_add_instance_private (lsp_parameter_information_type_id, sizeof (LspParameterInformationPrivate));
	return lsp_parameter_information_type_id;
}

GType
lsp_parameter_information_get_type (void)
{
	static gsize lsp_parameter_information_type_id__once = 0;
	if (g_once_init_enter (&lsp_parameter_information_type_id__once)) {
		GType lsp_parameter_information_type_id;
		lsp_parameter_information_type_id = lsp_parameter_information_get_type_once ();
		g_once_init_leave (&lsp_parameter_information_type_id__once, lsp_parameter_information_type_id);
	}
	return lsp_parameter_information_type_id__once;
}

static void
_vala_lsp_parameter_information_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec)
{
	LspParameterInformation * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_PARAMETER_INFORMATION, LspParameterInformation);
#line 753 "../src/protocol.vala"
	switch (property_id) {
#line 753 "../src/protocol.vala"
		case LSP_PARAMETER_INFORMATION_LABEL_PROPERTY:
#line 753 "../src/protocol.vala"
		g_value_set_string (value, lsp_parameter_information_get_label (self));
#line 753 "../src/protocol.vala"
		break;
#line 753 "../src/protocol.vala"
		case LSP_PARAMETER_INFORMATION_DOCUMENTATION_PROPERTY:
#line 753 "../src/protocol.vala"
		g_value_set_object (value, lsp_parameter_information_get_documentation (self));
#line 753 "../src/protocol.vala"
		break;
#line 13499 "protocol.c"
		default:
#line 753 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 753 "../src/protocol.vala"
		break;
#line 13505 "protocol.c"
	}
}

static void
_vala_lsp_parameter_information_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec)
{
	LspParameterInformation * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_PARAMETER_INFORMATION, LspParameterInformation);
#line 753 "../src/protocol.vala"
	switch (property_id) {
#line 753 "../src/protocol.vala"
		case LSP_PARAMETER_INFORMATION_LABEL_PROPERTY:
#line 753 "../src/protocol.vala"
		lsp_parameter_information_set_label (self, g_value_get_string (value));
#line 753 "../src/protocol.vala"
		break;
#line 753 "../src/protocol.vala"
		case LSP_PARAMETER_INFORMATION_DOCUMENTATION_PROPERTY:
#line 753 "../src/protocol.vala"
		lsp_parameter_information_set_documentation (self, g_value_get_object (value));
#line 753 "../src/protocol.vala"
		break;
#line 13531 "protocol.c"
		default:
#line 753 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 753 "../src/protocol.vala"
		break;
#line 13537 "protocol.c"
	}
}

static inline gpointer
lsp_marked_string_get_instance_private (LspMarkedString* self)
{
	return G_STRUCT_MEMBER_P (self, LspMarkedString_private_offset);
}

LspMarkedString*
lsp_marked_string_construct (GType object_type)
{
	LspMarkedString * self = NULL;
#line 758 "../src/protocol.vala"
	self = (LspMarkedString*) g_object_new (object_type, NULL);
#line 758 "../src/protocol.vala"
	return self;
#line 13555 "protocol.c"
}

LspMarkedString*
lsp_marked_string_new (void)
{
#line 758 "../src/protocol.vala"
	return lsp_marked_string_construct (LSP_TYPE_MARKED_STRING);
#line 13563 "protocol.c"
}

const gchar*
lsp_marked_string_get_language (LspMarkedString* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 759 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 759 "../src/protocol.vala"
	_tmp0_ = self->priv->_language;
#line 759 "../src/protocol.vala"
	result = _tmp0_;
#line 759 "../src/protocol.vala"
	return result;
#line 13579 "protocol.c"
}

void
lsp_marked_string_set_language (LspMarkedString* self,
                                const gchar* value)
{
	gchar* old_value;
#line 759 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 759 "../src/protocol.vala"
	old_value = lsp_marked_string_get_language (self);
#line 759 "../src/protocol.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 13593 "protocol.c"
		gchar* _tmp0_;
#line 759 "../src/protocol.vala"
		_tmp0_ = g_strdup (value);
#line 759 "../src/protocol.vala"
		_g_free0 (self->priv->_language);
#line 759 "../src/protocol.vala"
		self->priv->_language = _tmp0_;
#line 759 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_marked_string_properties[LSP_MARKED_STRING_LANGUAGE_PROPERTY]);
#line 13603 "protocol.c"
	}
}

const gchar*
lsp_marked_string_get_value (LspMarkedString* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 760 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 760 "../src/protocol.vala"
	_tmp0_ = self->priv->_value;
#line 760 "../src/protocol.vala"
	result = _tmp0_;
#line 760 "../src/protocol.vala"
	return result;
#line 13620 "protocol.c"
}

void
lsp_marked_string_set_value (LspMarkedString* self,
                             const gchar* value)
{
	gchar* old_value;
#line 760 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 760 "../src/protocol.vala"
	old_value = lsp_marked_string_get_value (self);
#line 760 "../src/protocol.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 13634 "protocol.c"
		gchar* _tmp0_;
#line 760 "../src/protocol.vala"
		_tmp0_ = g_strdup (value);
#line 760 "../src/protocol.vala"
		_g_free0 (self->priv->_value);
#line 760 "../src/protocol.vala"
		self->priv->_value = _tmp0_;
#line 760 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_marked_string_properties[LSP_MARKED_STRING_VALUE_PROPERTY]);
#line 13644 "protocol.c"
	}
}

static void
lsp_marked_string_class_init (LspMarkedStringClass * klass,
                              gpointer klass_data)
{
#line 758 "../src/protocol.vala"
	lsp_marked_string_parent_class = g_type_class_peek_parent (klass);
#line 758 "../src/protocol.vala"
	g_type_class_adjust_private_offset (klass, &LspMarkedString_private_offset);
#line 758 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_lsp_marked_string_get_property;
#line 758 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_lsp_marked_string_set_property;
#line 758 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->finalize = lsp_marked_string_finalize;
#line 758 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_MARKED_STRING_LANGUAGE_PROPERTY, lsp_marked_string_properties[LSP_MARKED_STRING_LANGUAGE_PROPERTY] = g_param_spec_string ("language", "language", "language", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 758 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_MARKED_STRING_VALUE_PROPERTY, lsp_marked_string_properties[LSP_MARKED_STRING_VALUE_PROPERTY] = g_param_spec_string ("value", "value", "value", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 13666 "protocol.c"
}

static void
lsp_marked_string_instance_init (LspMarkedString * self,
                                 gpointer klass)
{
#line 758 "../src/protocol.vala"
	self->priv = lsp_marked_string_get_instance_private (self);
#line 13675 "protocol.c"
}

static void
lsp_marked_string_finalize (GObject * obj)
{
	LspMarkedString * self;
#line 758 "../src/protocol.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, LSP_TYPE_MARKED_STRING, LspMarkedString);
#line 759 "../src/protocol.vala"
	_g_free0 (self->priv->_language);
#line 760 "../src/protocol.vala"
	_g_free0 (self->priv->_value);
#line 758 "../src/protocol.vala"
	G_OBJECT_CLASS (lsp_marked_string_parent_class)->finalize (obj);
#line 13690 "protocol.c"
}

 G_GNUC_NO_INLINE static GType
lsp_marked_string_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (LspMarkedStringClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) lsp_marked_string_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LspMarkedString), 0, (GInstanceInitFunc) lsp_marked_string_instance_init, NULL };
	GType lsp_marked_string_type_id;
	lsp_marked_string_type_id = g_type_register_static (G_TYPE_OBJECT, "LspMarkedString", &g_define_type_info, 0);
	LspMarkedString_private_offset = g_type_add_instance_private (lsp_marked_string_type_id, sizeof (LspMarkedStringPrivate));
	return lsp_marked_string_type_id;
}

GType
lsp_marked_string_get_type (void)
{
	static gsize lsp_marked_string_type_id__once = 0;
	if (g_once_init_enter (&lsp_marked_string_type_id__once)) {
		GType lsp_marked_string_type_id;
		lsp_marked_string_type_id = lsp_marked_string_get_type_once ();
		g_once_init_leave (&lsp_marked_string_type_id__once, lsp_marked_string_type_id);
	}
	return lsp_marked_string_type_id__once;
}

static void
_vala_lsp_marked_string_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec)
{
	LspMarkedString * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_MARKED_STRING, LspMarkedString);
#line 758 "../src/protocol.vala"
	switch (property_id) {
#line 758 "../src/protocol.vala"
		case LSP_MARKED_STRING_LANGUAGE_PROPERTY:
#line 758 "../src/protocol.vala"
		g_value_set_string (value, lsp_marked_string_get_language (self));
#line 758 "../src/protocol.vala"
		break;
#line 758 "../src/protocol.vala"
		case LSP_MARKED_STRING_VALUE_PROPERTY:
#line 758 "../src/protocol.vala"
		g_value_set_string (value, lsp_marked_string_get_value (self));
#line 758 "../src/protocol.vala"
		break;
#line 13737 "protocol.c"
		default:
#line 758 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 758 "../src/protocol.vala"
		break;
#line 13743 "protocol.c"
	}
}

static void
_vala_lsp_marked_string_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec)
{
	LspMarkedString * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_MARKED_STRING, LspMarkedString);
#line 758 "../src/protocol.vala"
	switch (property_id) {
#line 758 "../src/protocol.vala"
		case LSP_MARKED_STRING_LANGUAGE_PROPERTY:
#line 758 "../src/protocol.vala"
		lsp_marked_string_set_language (self, g_value_get_string (value));
#line 758 "../src/protocol.vala"
		break;
#line 758 "../src/protocol.vala"
		case LSP_MARKED_STRING_VALUE_PROPERTY:
#line 758 "../src/protocol.vala"
		lsp_marked_string_set_value (self, g_value_get_string (value));
#line 758 "../src/protocol.vala"
		break;
#line 13769 "protocol.c"
		default:
#line 758 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 758 "../src/protocol.vala"
		break;
#line 13775 "protocol.c"
	}
}

static inline gpointer
lsp_hover_get_instance_private (LspHover* self)
{
	return G_STRUCT_MEMBER_P (self, LspHover_private_offset);
}

static void
lsp_hover_real_json_serializable_set_property (JsonSerializable* base,
                                               GParamSpec* pspec,
                                               GValue* value)
{
	LspHover * self;
	const gchar* _tmp0_;
	GValue _tmp1_;
#line 767 "../src/protocol.vala"
	self = (LspHover*) base;
#line 767 "../src/protocol.vala"
	g_return_if_fail (pspec != NULL);
#line 767 "../src/protocol.vala"
	g_return_if_fail (value != NULL);
#line 768 "../src/protocol.vala"
	_tmp0_ = g_param_spec_get_name (pspec);
#line 768 "../src/protocol.vala"
	_tmp1_ = *value;
#line 768 "../src/protocol.vala"
	g_object_set_property (G_TYPE_CHECK_INSTANCE_CAST (self, G_TYPE_OBJECT, GObject), _tmp0_, &_tmp1_);
#line 13805 "protocol.c"
}

static void
lsp_hover_real_json_serializable_get_property (JsonSerializable* base,
                                               GParamSpec* pspec,
                                               GValue* result)
{
	LspHover * self;
	GValue val = {0};
	GValue _tmp0_ = {0};
	const gchar* _tmp1_;
#line 771 "../src/protocol.vala"
	self = (LspHover*) base;
#line 771 "../src/protocol.vala"
	g_return_if_fail (pspec != NULL);
#line 772 "../src/protocol.vala"
	g_value_init (&_tmp0_, pspec->value_type);
#line 772 "../src/protocol.vala"
	val = _tmp0_;
#line 773 "../src/protocol.vala"
	_tmp1_ = g_param_spec_get_name (pspec);
#line 773 "../src/protocol.vala"
	g_object_get_property (G_TYPE_CHECK_INSTANCE_CAST (self, G_TYPE_OBJECT, GObject), _tmp1_, &val);
#line 774 "../src/protocol.vala"
	*result = val;
#line 774 "../src/protocol.vala"
	return;
#line 13833 "protocol.c"
}

static GParamSpec*
lsp_hover_real_find_property (JsonSerializable* base,
                              const gchar* name)
{
	LspHover * self;
	GObjectClass* _tmp0_;
	GParamSpec* _tmp1_;
	GParamSpec* result;
#line 777 "../src/protocol.vala"
	self = (LspHover*) base;
#line 777 "../src/protocol.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 778 "../src/protocol.vala"
	_tmp0_ = G_OBJECT_GET_CLASS ((GObject*) self);
#line 778 "../src/protocol.vala"
	_tmp1_ = g_object_class_find_property (_tmp0_, name);
#line 778 "../src/protocol.vala"
	result = _tmp1_;
#line 778 "../src/protocol.vala"
	return result;
#line 13856 "protocol.c"
}

static JsonNode*
_vala_JsonNode_copy (JsonNode* self)
{
#line 791 "../src/protocol.vala"
	return g_boxed_copy (json_node_get_type (), self);
#line 13864 "protocol.c"
}

static gpointer
__vala_JsonNode_copy0 (gpointer self)
{
#line 791 "../src/protocol.vala"
	return self ? _vala_JsonNode_copy (self) : NULL;
#line 13872 "protocol.c"
}

static void
_vala_JsonNode_free (JsonNode* self)
{
#line 791 "../src/protocol.vala"
	g_boxed_free (json_node_get_type (), self);
#line 13880 "protocol.c"
}

static JsonNode*
lsp_hover_real_serialize_property (JsonSerializable* base,
                                   const gchar* property_name,
                                   GValue* value,
                                   GParamSpec* pspec)
{
	LspHover * self;
	JsonNode* node = NULL;
	JsonNode* _tmp2_;
	JsonNode* _tmp3_;
	JsonArray* _tmp4_;
	JsonArray* _tmp5_;
	JsonArray* array = NULL;
	JsonNode* _tmp6_;
	JsonArray* _tmp7_;
	JsonArray* _tmp8_;
	JsonNode* result;
#line 781 "../src/protocol.vala"
	self = (LspHover*) base;
#line 781 "../src/protocol.vala"
	g_return_val_if_fail (property_name != NULL, NULL);
#line 781 "../src/protocol.vala"
	g_return_val_if_fail (value != NULL, NULL);
#line 781 "../src/protocol.vala"
	g_return_val_if_fail (pspec != NULL, NULL);
#line 782 "../src/protocol.vala"
	if (g_strcmp0 (property_name, "contents") != 0) {
#line 13910 "protocol.c"
		GValue _tmp0_;
		JsonNode* _tmp1_;
#line 783 "../src/protocol.vala"
		_tmp0_ = *value;
#line 783 "../src/protocol.vala"
		_tmp1_ = json_serializable_default_serialize_property ((JsonSerializable*) self, property_name, &_tmp0_, pspec);
#line 783 "../src/protocol.vala"
		result = _tmp1_;
#line 783 "../src/protocol.vala"
		return result;
#line 13921 "protocol.c"
	}
#line 784 "../src/protocol.vala"
	_tmp2_ = json_node_new (JSON_NODE_ARRAY);
#line 784 "../src/protocol.vala"
	node = _tmp2_;
#line 785 "../src/protocol.vala"
	_tmp3_ = node;
#line 785 "../src/protocol.vala"
	_tmp4_ = json_array_new ();
#line 785 "../src/protocol.vala"
	_tmp5_ = _tmp4_;
#line 785 "../src/protocol.vala"
	json_node_init_array (_tmp3_, _tmp5_);
#line 785 "../src/protocol.vala"
	_json_array_unref0 (_tmp5_);
#line 786 "../src/protocol.vala"
	_tmp6_ = node;
#line 786 "../src/protocol.vala"
	_tmp7_ = json_node_get_array (_tmp6_);
#line 786 "../src/protocol.vala"
	_tmp8_ = _json_array_ref0 (_tmp7_);
#line 786 "../src/protocol.vala"
	array = _tmp8_;
#line 13945 "protocol.c"
	{
		GeeList* _child_list = NULL;
		GeeList* _tmp9_;
		gint _child_size = 0;
		GeeList* _tmp10_;
		gint _tmp11_;
		gint _tmp12_;
		gint _child_index = 0;
#line 787 "../src/protocol.vala"
		_tmp9_ = self->priv->_contents;
#line 787 "../src/protocol.vala"
		_child_list = _tmp9_;
#line 787 "../src/protocol.vala"
		_tmp10_ = _child_list;
#line 787 "../src/protocol.vala"
		_tmp11_ = gee_collection_get_size ((GeeCollection*) _tmp10_);
#line 787 "../src/protocol.vala"
		_tmp12_ = _tmp11_;
#line 787 "../src/protocol.vala"
		_child_size = _tmp12_;
#line 787 "../src/protocol.vala"
		_child_index = -1;
#line 787 "../src/protocol.vala"
		while (TRUE) {
#line 13970 "protocol.c"
			gint _tmp13_;
			gint _tmp14_;
			LspMarkedString* child = NULL;
			GeeList* _tmp15_;
			gpointer _tmp16_;
			LspMarkedString* _tmp17_;
			const gchar* _tmp18_;
			const gchar* _tmp19_;
#line 787 "../src/protocol.vala"
			_child_index = _child_index + 1;
#line 787 "../src/protocol.vala"
			_tmp13_ = _child_index;
#line 787 "../src/protocol.vala"
			_tmp14_ = _child_size;
#line 787 "../src/protocol.vala"
			if (!(_tmp13_ < _tmp14_)) {
#line 787 "../src/protocol.vala"
				break;
#line 13989 "protocol.c"
			}
#line 787 "../src/protocol.vala"
			_tmp15_ = _child_list;
#line 787 "../src/protocol.vala"
			_tmp16_ = gee_list_get (_tmp15_, _child_index);
#line 787 "../src/protocol.vala"
			child = (LspMarkedString*) _tmp16_;
#line 788 "../src/protocol.vala"
			_tmp17_ = child;
#line 788 "../src/protocol.vala"
			_tmp18_ = lsp_marked_string_get_language (_tmp17_);
#line 788 "../src/protocol.vala"
			_tmp19_ = _tmp18_;
#line 788 "../src/protocol.vala"
			if (_tmp19_ != NULL) {
#line 14005 "protocol.c"
				JsonArray* _tmp20_;
				LspMarkedString* _tmp21_;
				JsonNode* _tmp22_;
#line 789 "../src/protocol.vala"
				_tmp20_ = array;
#line 789 "../src/protocol.vala"
				_tmp21_ = child;
#line 789 "../src/protocol.vala"
				_tmp22_ = json_gobject_serialize ((GObject*) _tmp21_);
#line 789 "../src/protocol.vala"
				json_array_add_element (_tmp20_, _tmp22_);
#line 14017 "protocol.c"
			} else {
				JsonArray* _tmp23_;
				JsonNode* _tmp24_;
				JsonNode* _tmp25_;
				LspMarkedString* _tmp26_;
				const gchar* _tmp27_;
				const gchar* _tmp28_;
				JsonNode* _tmp29_;
				JsonNode* _tmp30_;
#line 791 "../src/protocol.vala"
				_tmp23_ = array;
#line 791 "../src/protocol.vala"
				_tmp24_ = json_node_new (JSON_NODE_VALUE);
#line 791 "../src/protocol.vala"
				_tmp25_ = _tmp24_;
#line 791 "../src/protocol.vala"
				_tmp26_ = child;
#line 791 "../src/protocol.vala"
				_tmp27_ = lsp_marked_string_get_value (_tmp26_);
#line 791 "../src/protocol.vala"
				_tmp28_ = _tmp27_;
#line 791 "../src/protocol.vala"
				_tmp29_ = json_node_init_string (_tmp25_, _tmp28_);
#line 791 "../src/protocol.vala"
				_tmp30_ = __vala_JsonNode_copy0 (_tmp29_);
#line 791 "../src/protocol.vala"
				json_array_add_element (_tmp23_, _tmp30_);
#line 791 "../src/protocol.vala"
				__vala_JsonNode_free0 (_tmp25_);
#line 14047 "protocol.c"
			}
#line 787 "../src/protocol.vala"
			_g_object_unref0 (child);
#line 14051 "protocol.c"
		}
	}
#line 793 "../src/protocol.vala"
	result = node;
#line 793 "../src/protocol.vala"
	_json_array_unref0 (array);
#line 793 "../src/protocol.vala"
	return result;
#line 14060 "protocol.c"
}

static gboolean
lsp_hover_real_deserialize_property (JsonSerializable* base,
                                     const gchar* property_name,
                                     GValue* value,
                                     GParamSpec* pspec,
                                     JsonNode* property_node)
{
	LspHover * self;
	GValue _vala_value = {0};
#line 796 "../src/protocol.vala"
	self = (LspHover*) base;
#line 796 "../src/protocol.vala"
	g_return_val_if_fail (property_name != NULL, FALSE);
#line 796 "../src/protocol.vala"
	g_return_val_if_fail (pspec != NULL, FALSE);
#line 796 "../src/protocol.vala"
	g_return_val_if_fail (property_node != NULL, FALSE);
#line 797 "../src/protocol.vala"
	g_error ("protocol.vala:797: deserialization not supported");
#line 14082 "protocol.c"
}

LspHover*
lsp_hover_construct (GType object_type)
{
	LspHover * self = NULL;
#line 763 "../src/protocol.vala"
	self = (LspHover*) g_object_new (object_type, NULL);
#line 763 "../src/protocol.vala"
	return self;
#line 14093 "protocol.c"
}

LspHover*
lsp_hover_new (void)
{
#line 763 "../src/protocol.vala"
	return lsp_hover_construct (LSP_TYPE_HOVER);
#line 14101 "protocol.c"
}

GeeList*
lsp_hover_get_contents (LspHover* self)
{
	GeeList* result;
	GeeList* _tmp0_;
#line 764 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 764 "../src/protocol.vala"
	_tmp0_ = self->priv->_contents;
#line 764 "../src/protocol.vala"
	result = _tmp0_;
#line 764 "../src/protocol.vala"
	return result;
#line 14117 "protocol.c"
}

void
lsp_hover_set_contents (LspHover* self,
                        GeeList* value)
{
	GeeList* old_value;
#line 764 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 764 "../src/protocol.vala"
	old_value = lsp_hover_get_contents (self);
#line 764 "../src/protocol.vala"
	if (old_value != value) {
#line 14131 "protocol.c"
		GeeList* _tmp0_;
#line 764 "../src/protocol.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 764 "../src/protocol.vala"
		_g_object_unref0 (self->priv->_contents);
#line 764 "../src/protocol.vala"
		self->priv->_contents = _tmp0_;
#line 764 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_hover_properties[LSP_HOVER_CONTENTS_PROPERTY]);
#line 14141 "protocol.c"
	}
}

LspRange*
lsp_hover_get_range (LspHover* self)
{
	LspRange* result;
	LspRange* _tmp0_;
#line 765 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 765 "../src/protocol.vala"
	_tmp0_ = self->priv->_range;
#line 765 "../src/protocol.vala"
	result = _tmp0_;
#line 765 "../src/protocol.vala"
	return result;
#line 14158 "protocol.c"
}

void
lsp_hover_set_range (LspHover* self,
                     LspRange* value)
{
	LspRange* old_value;
#line 765 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 765 "../src/protocol.vala"
	old_value = lsp_hover_get_range (self);
#line 765 "../src/protocol.vala"
	if (old_value != value) {
#line 14172 "protocol.c"
		LspRange* _tmp0_;
#line 765 "../src/protocol.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 765 "../src/protocol.vala"
		_g_object_unref0 (self->priv->_range);
#line 765 "../src/protocol.vala"
		self->priv->_range = _tmp0_;
#line 765 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_hover_properties[LSP_HOVER_RANGE_PROPERTY]);
#line 14182 "protocol.c"
	}
}

static void
lsp_hover_class_init (LspHoverClass * klass,
                      gpointer klass_data)
{
#line 763 "../src/protocol.vala"
	lsp_hover_parent_class = g_type_class_peek_parent (klass);
#line 763 "../src/protocol.vala"
	g_type_class_adjust_private_offset (klass, &LspHover_private_offset);
#line 763 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_lsp_hover_get_property;
#line 763 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_lsp_hover_set_property;
#line 763 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->finalize = lsp_hover_finalize;
#line 763 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_HOVER_CONTENTS_PROPERTY, lsp_hover_properties[LSP_HOVER_CONTENTS_PROPERTY] = g_param_spec_object ("contents", "contents", "contents", GEE_TYPE_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 763 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_HOVER_RANGE_PROPERTY, lsp_hover_properties[LSP_HOVER_RANGE_PROPERTY] = g_param_spec_object ("range", "range", "range", LSP_TYPE_RANGE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 14204 "protocol.c"
}

static void
lsp_hover_json_serializable_interface_init (JsonSerializableIface * iface,
                                            gpointer iface_data)
{
#line 763 "../src/protocol.vala"
	lsp_hover_json_serializable_parent_iface = g_type_interface_peek_parent (iface);
#line 763 "../src/protocol.vala"
	iface->set_property = (void (*) (JsonSerializable*, GParamSpec*, GValue*)) lsp_hover_real_json_serializable_set_property;
#line 763 "../src/protocol.vala"
	iface->get_property = (void (*) (JsonSerializable*, GParamSpec*, GValue*)) lsp_hover_real_json_serializable_get_property;
#line 763 "../src/protocol.vala"
	iface->find_property = (GParamSpec* (*) (JsonSerializable*, const gchar*)) lsp_hover_real_find_property;
#line 763 "../src/protocol.vala"
	iface->serialize_property = (JsonNode* (*) (JsonSerializable*, const gchar*, GValue*, GParamSpec*)) lsp_hover_real_serialize_property;
#line 763 "../src/protocol.vala"
	iface->deserialize_property = (gboolean (*) (JsonSerializable*, const gchar*, GValue*, GParamSpec*, JsonNode*)) lsp_hover_real_deserialize_property;
#line 14223 "protocol.c"
}

static void
lsp_hover_instance_init (LspHover * self,
                         gpointer klass)
{
	GeeArrayList* _tmp0_;
#line 763 "../src/protocol.vala"
	self->priv = lsp_hover_get_instance_private (self);
#line 764 "../src/protocol.vala"
	_tmp0_ = gee_array_list_new (LSP_TYPE_MARKED_STRING, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 764 "../src/protocol.vala"
	if (_tmp0_) {
#line 764 "../src/protocol.vala"
		g_object_set_data ((GObject *) _tmp0_, "vala-creation-function", "");
#line 14239 "protocol.c"
	}
#line 764 "../src/protocol.vala"
	self->priv->_contents = (GeeList*) _tmp0_;
#line 14243 "protocol.c"
}

static void
lsp_hover_finalize (GObject * obj)
{
	LspHover * self;
#line 763 "../src/protocol.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, LSP_TYPE_HOVER, LspHover);
#line 764 "../src/protocol.vala"
	_g_object_unref0 (self->priv->_contents);
#line 765 "../src/protocol.vala"
	_g_object_unref0 (self->priv->_range);
#line 763 "../src/protocol.vala"
	G_OBJECT_CLASS (lsp_hover_parent_class)->finalize (obj);
#line 14258 "protocol.c"
}

 G_GNUC_NO_INLINE static GType
lsp_hover_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (LspHoverClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) lsp_hover_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LspHover), 0, (GInstanceInitFunc) lsp_hover_instance_init, NULL };
	static const GInterfaceInfo json_serializable_info = { (GInterfaceInitFunc) lsp_hover_json_serializable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType lsp_hover_type_id;
	lsp_hover_type_id = g_type_register_static (G_TYPE_OBJECT, "LspHover", &g_define_type_info, 0);
	g_type_add_interface_static (lsp_hover_type_id, json_serializable_get_type (), &json_serializable_info);
	LspHover_private_offset = g_type_add_instance_private (lsp_hover_type_id, sizeof (LspHoverPrivate));
	return lsp_hover_type_id;
}

GType
lsp_hover_get_type (void)
{
	static gsize lsp_hover_type_id__once = 0;
	if (g_once_init_enter (&lsp_hover_type_id__once)) {
		GType lsp_hover_type_id;
		lsp_hover_type_id = lsp_hover_get_type_once ();
		g_once_init_leave (&lsp_hover_type_id__once, lsp_hover_type_id);
	}
	return lsp_hover_type_id__once;
}

static void
_vala_lsp_hover_get_property (GObject * object,
                              guint property_id,
                              GValue * value,
                              GParamSpec * pspec)
{
	LspHover * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_HOVER, LspHover);
#line 763 "../src/protocol.vala"
	switch (property_id) {
#line 763 "../src/protocol.vala"
		case LSP_HOVER_CONTENTS_PROPERTY:
#line 763 "../src/protocol.vala"
		g_value_set_object (value, lsp_hover_get_contents (self));
#line 763 "../src/protocol.vala"
		break;
#line 763 "../src/protocol.vala"
		case LSP_HOVER_RANGE_PROPERTY:
#line 763 "../src/protocol.vala"
		g_value_set_object (value, lsp_hover_get_range (self));
#line 763 "../src/protocol.vala"
		break;
#line 14307 "protocol.c"
		default:
#line 763 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 763 "../src/protocol.vala"
		break;
#line 14313 "protocol.c"
	}
}

static void
_vala_lsp_hover_set_property (GObject * object,
                              guint property_id,
                              const GValue * value,
                              GParamSpec * pspec)
{
	LspHover * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_HOVER, LspHover);
#line 763 "../src/protocol.vala"
	switch (property_id) {
#line 763 "../src/protocol.vala"
		case LSP_HOVER_CONTENTS_PROPERTY:
#line 763 "../src/protocol.vala"
		lsp_hover_set_contents (self, g_value_get_object (value));
#line 763 "../src/protocol.vala"
		break;
#line 763 "../src/protocol.vala"
		case LSP_HOVER_RANGE_PROPERTY:
#line 763 "../src/protocol.vala"
		lsp_hover_set_range (self, g_value_get_object (value));
#line 763 "../src/protocol.vala"
		break;
#line 14339 "protocol.c"
		default:
#line 763 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 763 "../src/protocol.vala"
		break;
#line 14345 "protocol.c"
	}
}

static inline gpointer
lsp_text_edit_get_instance_private (LspTextEdit* self)
{
	return G_STRUCT_MEMBER_P (self, LspTextEdit_private_offset);
}

LspTextEdit*
lsp_text_edit_construct (GType object_type,
                         LspRange* range,
                         const gchar* new_text)
{
	LspTextEdit * self = NULL;
#line 817 "../src/protocol.vala"
	g_return_val_if_fail (range != NULL, NULL);
#line 817 "../src/protocol.vala"
	g_return_val_if_fail (new_text != NULL, NULL);
#line 817 "../src/protocol.vala"
	self = (LspTextEdit*) g_object_new (object_type, NULL);
#line 818 "../src/protocol.vala"
	lsp_text_edit_set_range (self, range);
#line 819 "../src/protocol.vala"
	lsp_text_edit_set_newText (self, new_text);
#line 817 "../src/protocol.vala"
	return self;
#line 14373 "protocol.c"
}

LspTextEdit*
lsp_text_edit_new (LspRange* range,
                   const gchar* new_text)
{
#line 817 "../src/protocol.vala"
	return lsp_text_edit_construct (LSP_TYPE_TEXT_EDIT, range, new_text);
#line 14382 "protocol.c"
}

LspRange*
lsp_text_edit_get_range (LspTextEdit* self)
{
	LspRange* result;
	LspRange* _tmp0_;
#line 809 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 809 "../src/protocol.vala"
	_tmp0_ = self->priv->_range;
#line 809 "../src/protocol.vala"
	result = _tmp0_;
#line 809 "../src/protocol.vala"
	return result;
#line 14398 "protocol.c"
}

void
lsp_text_edit_set_range (LspTextEdit* self,
                         LspRange* value)
{
	LspRange* old_value;
#line 809 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 809 "../src/protocol.vala"
	old_value = lsp_text_edit_get_range (self);
#line 809 "../src/protocol.vala"
	if (old_value != value) {
#line 14412 "protocol.c"
		LspRange* _tmp0_;
#line 809 "../src/protocol.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 809 "../src/protocol.vala"
		_g_object_unref0 (self->priv->_range);
#line 809 "../src/protocol.vala"
		self->priv->_range = _tmp0_;
#line 809 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_text_edit_properties[LSP_TEXT_EDIT_RANGE_PROPERTY]);
#line 14422 "protocol.c"
	}
}

const gchar*
lsp_text_edit_get_newText (LspTextEdit* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 815 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 815 "../src/protocol.vala"
	_tmp0_ = self->priv->_newText;
#line 815 "../src/protocol.vala"
	result = _tmp0_;
#line 815 "../src/protocol.vala"
	return result;
#line 14439 "protocol.c"
}

void
lsp_text_edit_set_newText (LspTextEdit* self,
                           const gchar* value)
{
	gchar* old_value;
#line 815 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 815 "../src/protocol.vala"
	old_value = lsp_text_edit_get_newText (self);
#line 815 "../src/protocol.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 14453 "protocol.c"
		gchar* _tmp0_;
#line 815 "../src/protocol.vala"
		_tmp0_ = g_strdup (value);
#line 815 "../src/protocol.vala"
		_g_free0 (self->priv->_newText);
#line 815 "../src/protocol.vala"
		self->priv->_newText = _tmp0_;
#line 815 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_text_edit_properties[LSP_TEXT_EDIT_NEW_TEXT_PROPERTY]);
#line 14463 "protocol.c"
	}
}

static void
lsp_text_edit_class_init (LspTextEditClass * klass,
                          gpointer klass_data)
{
#line 804 "../src/protocol.vala"
	lsp_text_edit_parent_class = g_type_class_peek_parent (klass);
#line 804 "../src/protocol.vala"
	g_type_class_adjust_private_offset (klass, &LspTextEdit_private_offset);
#line 804 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_lsp_text_edit_get_property;
#line 804 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_lsp_text_edit_set_property;
#line 804 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->finalize = lsp_text_edit_finalize;
#line 14481 "protocol.c"
	/**
	         * The range of the text document to be manipulated. To insert
	         * text into a document create a range where ``start === end``.
	         */
#line 804 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_TEXT_EDIT_RANGE_PROPERTY, lsp_text_edit_properties[LSP_TEXT_EDIT_RANGE_PROPERTY] = g_param_spec_object ("range", "range", "range", LSP_TYPE_RANGE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 14488 "protocol.c"
	/**
	         * The string to be inserted. For delete operations use an
	         * empty string.
	         */
#line 804 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_TEXT_EDIT_NEW_TEXT_PROPERTY, lsp_text_edit_properties[LSP_TEXT_EDIT_NEW_TEXT_PROPERTY] = g_param_spec_string ("newText", "newText", "newText", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 14495 "protocol.c"
}

static void
lsp_text_edit_instance_init (LspTextEdit * self,
                             gpointer klass)
{
#line 804 "../src/protocol.vala"
	self->priv = lsp_text_edit_get_instance_private (self);
#line 14504 "protocol.c"
}

static void
lsp_text_edit_finalize (GObject * obj)
{
	LspTextEdit * self;
#line 804 "../src/protocol.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, LSP_TYPE_TEXT_EDIT, LspTextEdit);
#line 809 "../src/protocol.vala"
	_g_object_unref0 (self->priv->_range);
#line 815 "../src/protocol.vala"
	_g_free0 (self->priv->_newText);
#line 804 "../src/protocol.vala"
	G_OBJECT_CLASS (lsp_text_edit_parent_class)->finalize (obj);
#line 14519 "protocol.c"
}

/**
     * A textual edit applicable to a text document.
     */
 G_GNUC_NO_INLINE static GType
lsp_text_edit_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (LspTextEditClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) lsp_text_edit_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LspTextEdit), 0, (GInstanceInitFunc) lsp_text_edit_instance_init, NULL };
	GType lsp_text_edit_type_id;
	lsp_text_edit_type_id = g_type_register_static (G_TYPE_OBJECT, "LspTextEdit", &g_define_type_info, 0);
	LspTextEdit_private_offset = g_type_add_instance_private (lsp_text_edit_type_id, sizeof (LspTextEditPrivate));
	return lsp_text_edit_type_id;
}

GType
lsp_text_edit_get_type (void)
{
	static gsize lsp_text_edit_type_id__once = 0;
	if (g_once_init_enter (&lsp_text_edit_type_id__once)) {
		GType lsp_text_edit_type_id;
		lsp_text_edit_type_id = lsp_text_edit_get_type_once ();
		g_once_init_leave (&lsp_text_edit_type_id__once, lsp_text_edit_type_id);
	}
	return lsp_text_edit_type_id__once;
}

static void
_vala_lsp_text_edit_get_property (GObject * object,
                                  guint property_id,
                                  GValue * value,
                                  GParamSpec * pspec)
{
	LspTextEdit * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_TEXT_EDIT, LspTextEdit);
#line 804 "../src/protocol.vala"
	switch (property_id) {
#line 804 "../src/protocol.vala"
		case LSP_TEXT_EDIT_RANGE_PROPERTY:
#line 804 "../src/protocol.vala"
		g_value_set_object (value, lsp_text_edit_get_range (self));
#line 804 "../src/protocol.vala"
		break;
#line 804 "../src/protocol.vala"
		case LSP_TEXT_EDIT_NEW_TEXT_PROPERTY:
#line 804 "../src/protocol.vala"
		g_value_set_string (value, lsp_text_edit_get_newText (self));
#line 804 "../src/protocol.vala"
		break;
#line 14569 "protocol.c"
		default:
#line 804 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 804 "../src/protocol.vala"
		break;
#line 14575 "protocol.c"
	}
}

static void
_vala_lsp_text_edit_set_property (GObject * object,
                                  guint property_id,
                                  const GValue * value,
                                  GParamSpec * pspec)
{
	LspTextEdit * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_TEXT_EDIT, LspTextEdit);
#line 804 "../src/protocol.vala"
	switch (property_id) {
#line 804 "../src/protocol.vala"
		case LSP_TEXT_EDIT_RANGE_PROPERTY:
#line 804 "../src/protocol.vala"
		lsp_text_edit_set_range (self, g_value_get_object (value));
#line 804 "../src/protocol.vala"
		break;
#line 804 "../src/protocol.vala"
		case LSP_TEXT_EDIT_NEW_TEXT_PROPERTY:
#line 804 "../src/protocol.vala"
		lsp_text_edit_set_newText (self, g_value_get_string (value));
#line 804 "../src/protocol.vala"
		break;
#line 14601 "protocol.c"
		default:
#line 804 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 804 "../src/protocol.vala"
		break;
#line 14607 "protocol.c"
	}
}

static inline gpointer
lsp_text_document_edit_get_instance_private (LspTextDocumentEdit* self)
{
	return G_STRUCT_MEMBER_P (self, LspTextDocumentEdit_private_offset);
}

LspTextDocumentEdit*
lsp_text_document_edit_construct (GType object_type,
                                  LspVersionedTextDocumentIdentifier* text_document)
{
	LspTextDocumentEdit * self = NULL;
#line 843 "../src/protocol.vala"
	g_return_val_if_fail (text_document != NULL, NULL);
#line 843 "../src/protocol.vala"
	self = (LspTextDocumentEdit*) g_object_new (object_type, NULL);
#line 844 "../src/protocol.vala"
	lsp_text_document_edit_set_textDocument (self, text_document);
#line 843 "../src/protocol.vala"
	return self;
#line 14630 "protocol.c"
}

LspTextDocumentEdit*
lsp_text_document_edit_new (LspVersionedTextDocumentIdentifier* text_document)
{
#line 843 "../src/protocol.vala"
	return lsp_text_document_edit_construct (LSP_TYPE_TEXT_DOCUMENT_EDIT, text_document);
#line 14638 "protocol.c"
}

static JsonNode*
lsp_text_document_edit_real_serialize_property (JsonSerializable* base,
                                                const gchar* property_name,
                                                GValue* value,
                                                GParamSpec* pspec)
{
	LspTextDocumentEdit * self;
	JsonNode* node = NULL;
	JsonNode* _tmp2_;
	JsonNode* _tmp3_;
	JsonArray* _tmp4_;
	JsonArray* _tmp5_;
	JsonArray* array = NULL;
	JsonNode* _tmp6_;
	JsonArray* _tmp7_;
	JsonArray* _tmp8_;
	JsonNode* result;
#line 847 "../src/protocol.vala"
	self = (LspTextDocumentEdit*) base;
#line 847 "../src/protocol.vala"
	g_return_val_if_fail (property_name != NULL, NULL);
#line 847 "../src/protocol.vala"
	g_return_val_if_fail (value != NULL, NULL);
#line 847 "../src/protocol.vala"
	g_return_val_if_fail (pspec != NULL, NULL);
#line 848 "../src/protocol.vala"
	if (g_strcmp0 (property_name, "edits") != 0) {
#line 14668 "protocol.c"
		GValue _tmp0_;
		JsonNode* _tmp1_;
#line 849 "../src/protocol.vala"
		_tmp0_ = *value;
#line 849 "../src/protocol.vala"
		_tmp1_ = json_serializable_default_serialize_property ((JsonSerializable*) self, property_name, &_tmp0_, pspec);
#line 849 "../src/protocol.vala"
		result = _tmp1_;
#line 849 "../src/protocol.vala"
		return result;
#line 14679 "protocol.c"
	}
#line 851 "../src/protocol.vala"
	_tmp2_ = json_node_new (JSON_NODE_ARRAY);
#line 851 "../src/protocol.vala"
	node = _tmp2_;
#line 852 "../src/protocol.vala"
	_tmp3_ = node;
#line 852 "../src/protocol.vala"
	_tmp4_ = json_array_new ();
#line 852 "../src/protocol.vala"
	_tmp5_ = _tmp4_;
#line 852 "../src/protocol.vala"
	json_node_init_array (_tmp3_, _tmp5_);
#line 852 "../src/protocol.vala"
	_json_array_unref0 (_tmp5_);
#line 853 "../src/protocol.vala"
	_tmp6_ = node;
#line 853 "../src/protocol.vala"
	_tmp7_ = json_node_get_array (_tmp6_);
#line 853 "../src/protocol.vala"
	_tmp8_ = _json_array_ref0 (_tmp7_);
#line 853 "../src/protocol.vala"
	array = _tmp8_;
#line 14703 "protocol.c"
	{
		GeeArrayList* _text_edit_list = NULL;
		GeeArrayList* _tmp9_;
		gint _text_edit_size = 0;
		GeeArrayList* _tmp10_;
		gint _tmp11_;
		gint _tmp12_;
		gint _text_edit_index = 0;
#line 854 "../src/protocol.vala"
		_tmp9_ = self->priv->_edits;
#line 854 "../src/protocol.vala"
		_text_edit_list = _tmp9_;
#line 854 "../src/protocol.vala"
		_tmp10_ = _text_edit_list;
#line 854 "../src/protocol.vala"
		_tmp11_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp10_);
#line 854 "../src/protocol.vala"
		_tmp12_ = _tmp11_;
#line 854 "../src/protocol.vala"
		_text_edit_size = _tmp12_;
#line 854 "../src/protocol.vala"
		_text_edit_index = -1;
#line 854 "../src/protocol.vala"
		while (TRUE) {
#line 14728 "protocol.c"
			gint _tmp13_;
			gint _tmp14_;
			LspTextEdit* text_edit = NULL;
			GeeArrayList* _tmp15_;
			gpointer _tmp16_;
			JsonArray* _tmp17_;
			LspTextEdit* _tmp18_;
			JsonNode* _tmp19_;
#line 854 "../src/protocol.vala"
			_text_edit_index = _text_edit_index + 1;
#line 854 "../src/protocol.vala"
			_tmp13_ = _text_edit_index;
#line 854 "../src/protocol.vala"
			_tmp14_ = _text_edit_size;
#line 854 "../src/protocol.vala"
			if (!(_tmp13_ < _tmp14_)) {
#line 854 "../src/protocol.vala"
				break;
#line 14747 "protocol.c"
			}
#line 854 "../src/protocol.vala"
			_tmp15_ = _text_edit_list;
#line 854 "../src/protocol.vala"
			_tmp16_ = gee_abstract_list_get ((GeeAbstractList*) _tmp15_, _text_edit_index);
#line 854 "../src/protocol.vala"
			text_edit = (LspTextEdit*) _tmp16_;
#line 855 "../src/protocol.vala"
			_tmp17_ = array;
#line 855 "../src/protocol.vala"
			_tmp18_ = text_edit;
#line 855 "../src/protocol.vala"
			_tmp19_ = json_gobject_serialize ((GObject*) _tmp18_);
#line 855 "../src/protocol.vala"
			json_array_add_element (_tmp17_, _tmp19_);
#line 854 "../src/protocol.vala"
			_g_object_unref0 (text_edit);
#line 14765 "protocol.c"
		}
	}
#line 857 "../src/protocol.vala"
	result = node;
#line 857 "../src/protocol.vala"
	_json_array_unref0 (array);
#line 857 "../src/protocol.vala"
	return result;
#line 14774 "protocol.c"
}

static gboolean
lsp_text_document_edit_real_deserialize_property (JsonSerializable* base,
                                                  const gchar* property_name,
                                                  GValue* value,
                                                  GParamSpec* pspec,
                                                  JsonNode* property_node)
{
	LspTextDocumentEdit * self;
	GValue _vala_value = {0};
#line 860 "../src/protocol.vala"
	self = (LspTextDocumentEdit*) base;
#line 860 "../src/protocol.vala"
	g_return_val_if_fail (property_name != NULL, FALSE);
#line 860 "../src/protocol.vala"
	g_return_val_if_fail (pspec != NULL, FALSE);
#line 860 "../src/protocol.vala"
	g_return_val_if_fail (property_node != NULL, FALSE);
#line 861 "../src/protocol.vala"
	g_error ("protocol.vala:861: deserialization not supported");
#line 14796 "protocol.c"
}

LspVersionedTextDocumentIdentifier*
lsp_text_document_edit_get_textDocument (LspTextDocumentEdit* self)
{
	LspVersionedTextDocumentIdentifier* result;
	LspVersionedTextDocumentIdentifier* _tmp0_;
#line 836 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 836 "../src/protocol.vala"
	_tmp0_ = self->priv->_textDocument;
#line 836 "../src/protocol.vala"
	result = _tmp0_;
#line 836 "../src/protocol.vala"
	return result;
#line 14812 "protocol.c"
}

void
lsp_text_document_edit_set_textDocument (LspTextDocumentEdit* self,
                                         LspVersionedTextDocumentIdentifier* value)
{
	LspVersionedTextDocumentIdentifier* old_value;
#line 836 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 836 "../src/protocol.vala"
	old_value = lsp_text_document_edit_get_textDocument (self);
#line 836 "../src/protocol.vala"
	if (old_value != value) {
#line 14826 "protocol.c"
		LspVersionedTextDocumentIdentifier* _tmp0_;
#line 836 "../src/protocol.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 836 "../src/protocol.vala"
		_g_object_unref0 (self->priv->_textDocument);
#line 836 "../src/protocol.vala"
		self->priv->_textDocument = _tmp0_;
#line 836 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_text_document_edit_properties[LSP_TEXT_DOCUMENT_EDIT_TEXT_DOCUMENT_PROPERTY]);
#line 14836 "protocol.c"
	}
}

GeeArrayList*
lsp_text_document_edit_get_edits (LspTextDocumentEdit* self)
{
	GeeArrayList* result;
	GeeArrayList* _tmp0_;
#line 841 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 841 "../src/protocol.vala"
	_tmp0_ = self->priv->_edits;
#line 841 "../src/protocol.vala"
	result = _tmp0_;
#line 841 "../src/protocol.vala"
	return result;
#line 14853 "protocol.c"
}

void
lsp_text_document_edit_set_edits (LspTextDocumentEdit* self,
                                  GeeArrayList* value)
{
	GeeArrayList* old_value;
#line 841 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 841 "../src/protocol.vala"
	old_value = lsp_text_document_edit_get_edits (self);
#line 841 "../src/protocol.vala"
	if (old_value != value) {
#line 14867 "protocol.c"
		GeeArrayList* _tmp0_;
#line 841 "../src/protocol.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 841 "../src/protocol.vala"
		_g_object_unref0 (self->priv->_edits);
#line 841 "../src/protocol.vala"
		self->priv->_edits = _tmp0_;
#line 841 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_text_document_edit_properties[LSP_TEXT_DOCUMENT_EDIT_EDITS_PROPERTY]);
#line 14877 "protocol.c"
	}
}

static void
lsp_text_document_edit_class_init (LspTextDocumentEditClass * klass,
                                   gpointer klass_data)
{
#line 832 "../src/protocol.vala"
	lsp_text_document_edit_parent_class = g_type_class_peek_parent (klass);
#line 832 "../src/protocol.vala"
	g_type_class_adjust_private_offset (klass, &LspTextDocumentEdit_private_offset);
#line 832 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_lsp_text_document_edit_get_property;
#line 832 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_lsp_text_document_edit_set_property;
#line 832 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->finalize = lsp_text_document_edit_finalize;
#line 14895 "protocol.c"
	/**
	         * The text document to change.
	         */
#line 832 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_TEXT_DOCUMENT_EDIT_TEXT_DOCUMENT_PROPERTY, lsp_text_document_edit_properties[LSP_TEXT_DOCUMENT_EDIT_TEXT_DOCUMENT_PROPERTY] = g_param_spec_object ("textDocument", "textDocument", "textDocument", LSP_TYPE_VERSIONED_TEXT_DOCUMENT_IDENTIFIER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 14901 "protocol.c"
	/**
	         * The edits to be applied.
	         */
#line 832 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_TEXT_DOCUMENT_EDIT_EDITS_PROPERTY, lsp_text_document_edit_properties[LSP_TEXT_DOCUMENT_EDIT_EDITS_PROPERTY] = g_param_spec_object ("edits", "edits", "edits", GEE_TYPE_ARRAY_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 14907 "protocol.c"
}

static void
lsp_text_document_edit_json_serializable_interface_init (JsonSerializableIface * iface,
                                                         gpointer iface_data)
{
#line 832 "../src/protocol.vala"
	lsp_text_document_edit_json_serializable_parent_iface = g_type_interface_peek_parent (iface);
#line 832 "../src/protocol.vala"
	iface->serialize_property = (JsonNode* (*) (JsonSerializable*, const gchar*, GValue*, GParamSpec*)) lsp_text_document_edit_real_serialize_property;
#line 832 "../src/protocol.vala"
	iface->deserialize_property = (gboolean (*) (JsonSerializable*, const gchar*, GValue*, GParamSpec*, JsonNode*)) lsp_text_document_edit_real_deserialize_property;
#line 14920 "protocol.c"
}

static void
lsp_text_document_edit_instance_init (LspTextDocumentEdit * self,
                                      gpointer klass)
{
	GeeArrayList* _tmp0_;
#line 832 "../src/protocol.vala"
	self->priv = lsp_text_document_edit_get_instance_private (self);
#line 841 "../src/protocol.vala"
	_tmp0_ = gee_array_list_new (LSP_TYPE_TEXT_EDIT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 841 "../src/protocol.vala"
	if (_tmp0_) {
#line 841 "../src/protocol.vala"
		g_object_set_data ((GObject *) _tmp0_, "vala-creation-function", "");
#line 14936 "protocol.c"
	}
#line 841 "../src/protocol.vala"
	self->priv->_edits = _tmp0_;
#line 14940 "protocol.c"
}

static void
lsp_text_document_edit_finalize (GObject * obj)
{
	LspTextDocumentEdit * self;
#line 832 "../src/protocol.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, LSP_TYPE_TEXT_DOCUMENT_EDIT, LspTextDocumentEdit);
#line 836 "../src/protocol.vala"
	_g_object_unref0 (self->priv->_textDocument);
#line 841 "../src/protocol.vala"
	_g_object_unref0 (self->priv->_edits);
#line 832 "../src/protocol.vala"
	G_OBJECT_CLASS (lsp_text_document_edit_parent_class)->finalize (obj);
#line 14955 "protocol.c"
}

/** 
     * Describes textual changes on a single text document. The text document is
     * referred to as a {@link VersionedTextDocumentIdentifier} to allow clients to
     * check the text document version before an edit is applied. A
     * {@link TextDocumentEdit} describes all changes on a version ``Si`` and after they are
     * applied move the document to version ``Si+1``. So the creator of a
     * {@link TextDocumentEdit} doesn’t need to sort the array of edits or do any kind
     * of ordering. However the edits must be non overlapping.
     */
 G_GNUC_NO_INLINE static GType
lsp_text_document_edit_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (LspTextDocumentEditClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) lsp_text_document_edit_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LspTextDocumentEdit), 0, (GInstanceInitFunc) lsp_text_document_edit_instance_init, NULL };
	static const GInterfaceInfo json_serializable_info = { (GInterfaceInitFunc) lsp_text_document_edit_json_serializable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType lsp_text_document_edit_type_id;
	lsp_text_document_edit_type_id = g_type_register_static (G_TYPE_OBJECT, "LspTextDocumentEdit", &g_define_type_info, 0);
	g_type_add_interface_static (lsp_text_document_edit_type_id, json_serializable_get_type (), &json_serializable_info);
	LspTextDocumentEdit_private_offset = g_type_add_instance_private (lsp_text_document_edit_type_id, sizeof (LspTextDocumentEditPrivate));
	return lsp_text_document_edit_type_id;
}

GType
lsp_text_document_edit_get_type (void)
{
	static gsize lsp_text_document_edit_type_id__once = 0;
	if (g_once_init_enter (&lsp_text_document_edit_type_id__once)) {
		GType lsp_text_document_edit_type_id;
		lsp_text_document_edit_type_id = lsp_text_document_edit_get_type_once ();
		g_once_init_leave (&lsp_text_document_edit_type_id__once, lsp_text_document_edit_type_id);
	}
	return lsp_text_document_edit_type_id__once;
}

static void
_vala_lsp_text_document_edit_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec)
{
	LspTextDocumentEdit * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_TEXT_DOCUMENT_EDIT, LspTextDocumentEdit);
#line 832 "../src/protocol.vala"
	switch (property_id) {
#line 832 "../src/protocol.vala"
		case LSP_TEXT_DOCUMENT_EDIT_TEXT_DOCUMENT_PROPERTY:
#line 832 "../src/protocol.vala"
		g_value_set_object (value, lsp_text_document_edit_get_textDocument (self));
#line 832 "../src/protocol.vala"
		break;
#line 832 "../src/protocol.vala"
		case LSP_TEXT_DOCUMENT_EDIT_EDITS_PROPERTY:
#line 832 "../src/protocol.vala"
		g_value_set_object (value, lsp_text_document_edit_get_edits (self));
#line 832 "../src/protocol.vala"
		break;
#line 15013 "protocol.c"
		default:
#line 832 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 832 "../src/protocol.vala"
		break;
#line 15019 "protocol.c"
	}
}

static void
_vala_lsp_text_document_edit_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec)
{
	LspTextDocumentEdit * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_TEXT_DOCUMENT_EDIT, LspTextDocumentEdit);
#line 832 "../src/protocol.vala"
	switch (property_id) {
#line 832 "../src/protocol.vala"
		case LSP_TEXT_DOCUMENT_EDIT_TEXT_DOCUMENT_PROPERTY:
#line 832 "../src/protocol.vala"
		lsp_text_document_edit_set_textDocument (self, g_value_get_object (value));
#line 832 "../src/protocol.vala"
		break;
#line 832 "../src/protocol.vala"
		case LSP_TEXT_DOCUMENT_EDIT_EDITS_PROPERTY:
#line 832 "../src/protocol.vala"
		lsp_text_document_edit_set_edits (self, g_value_get_object (value));
#line 832 "../src/protocol.vala"
		break;
#line 15045 "protocol.c"
		default:
#line 832 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 832 "../src/protocol.vala"
		break;
#line 15051 "protocol.c"
	}
}

static inline gpointer
lsp_command_like_get_instance_private (LspCommandLike* self)
{
	return G_STRUCT_MEMBER_P (self, LspCommandLike_private_offset);
}

static JsonNode*
lsp_command_like_real_serialize_property (JsonSerializable* base,
                                          const gchar* property_name,
                                          GValue* value,
                                          GParamSpec* pspec)
{
	LspCommandLike * self;
	gboolean _tmp0_ = FALSE;
	JsonArray* array = NULL;
	JsonArray* _tmp4_;
	JsonNode* node = NULL;
	JsonNode* _tmp12_;
	JsonNode* _tmp13_;
	JsonArray* _tmp14_;
	JsonNode* result;
#line 876 "../src/protocol.vala"
	self = (LspCommandLike*) base;
#line 876 "../src/protocol.vala"
	g_return_val_if_fail (property_name != NULL, NULL);
#line 876 "../src/protocol.vala"
	g_return_val_if_fail (value != NULL, NULL);
#line 876 "../src/protocol.vala"
	g_return_val_if_fail (pspec != NULL, NULL);
#line 877 "../src/protocol.vala"
	if (g_strcmp0 (property_name, "arguments") != 0) {
#line 877 "../src/protocol.vala"
		_tmp0_ = TRUE;
#line 15088 "protocol.c"
	} else {
		GArray* _tmp1_;
#line 877 "../src/protocol.vala"
		_tmp1_ = self->priv->_arguments;
#line 877 "../src/protocol.vala"
		_tmp0_ = _tmp1_ == NULL;
#line 15095 "protocol.c"
	}
#line 877 "../src/protocol.vala"
	if (_tmp0_) {
#line 15099 "protocol.c"
		GValue _tmp2_;
		JsonNode* _tmp3_;
#line 878 "../src/protocol.vala"
		_tmp2_ = *value;
#line 878 "../src/protocol.vala"
		_tmp3_ = json_serializable_default_serialize_property ((JsonSerializable*) self, property_name, &_tmp2_, pspec);
#line 878 "../src/protocol.vala"
		result = _tmp3_;
#line 878 "../src/protocol.vala"
		return result;
#line 15110 "protocol.c"
	}
#line 880 "../src/protocol.vala"
	_tmp4_ = json_array_new ();
#line 880 "../src/protocol.vala"
	array = _tmp4_;
#line 15116 "protocol.c"
	{
		gint i = 0;
#line 881 "../src/protocol.vala"
		i = 0;
#line 15121 "protocol.c"
		{
			gboolean _tmp5_ = FALSE;
#line 881 "../src/protocol.vala"
			_tmp5_ = TRUE;
#line 881 "../src/protocol.vala"
			while (TRUE) {
#line 15128 "protocol.c"
				GArray* _tmp7_;
				JsonArray* _tmp8_;
				GArray* _tmp9_;
				GVariant* _tmp10_;
				JsonNode* _tmp11_;
#line 881 "../src/protocol.vala"
				if (!_tmp5_) {
#line 15136 "protocol.c"
					gint _tmp6_;
#line 881 "../src/protocol.vala"
					_tmp6_ = i;
#line 881 "../src/protocol.vala"
					i = _tmp6_ + 1;
#line 15142 "protocol.c"
				}
#line 881 "../src/protocol.vala"
				_tmp5_ = FALSE;
#line 881 "../src/protocol.vala"
				_tmp7_ = self->priv->_arguments;
#line 881 "../src/protocol.vala"
				if (!(((guint) i) < _tmp7_->len)) {
#line 881 "../src/protocol.vala"
					break;
#line 15152 "protocol.c"
				}
#line 882 "../src/protocol.vala"
				_tmp8_ = array;
#line 882 "../src/protocol.vala"
				_tmp9_ = self->priv->_arguments;
#line 882 "../src/protocol.vala"
				_tmp10_ = g_array_index (_tmp9_, GVariant*, (guint) i);
#line 882 "../src/protocol.vala"
				_tmp11_ = json_gvariant_serialize (_tmp10_);
#line 882 "../src/protocol.vala"
				json_array_add_element (_tmp8_, _tmp11_);
#line 15164 "protocol.c"
			}
		}
	}
#line 884 "../src/protocol.vala"
	_tmp12_ = json_node_new (JSON_NODE_ARRAY);
#line 884 "../src/protocol.vala"
	node = _tmp12_;
#line 885 "../src/protocol.vala"
	_tmp13_ = node;
#line 885 "../src/protocol.vala"
	_tmp14_ = array;
#line 885 "../src/protocol.vala"
	json_node_set_array (_tmp13_, _tmp14_);
#line 886 "../src/protocol.vala"
	result = node;
#line 886 "../src/protocol.vala"
	_json_array_unref0 (array);
#line 886 "../src/protocol.vala"
	return result;
#line 15184 "protocol.c"
}

static Block27Data*
block27_data_ref (Block27Data* _data27_)
{
#line 890 "../src/protocol.vala"
	g_atomic_int_inc (&_data27_->_ref_count_);
#line 890 "../src/protocol.vala"
	return _data27_;
#line 15194 "protocol.c"
}

static void
block27_data_unref (void * _userdata_)
{
	Block27Data* _data27_;
	_data27_ = (Block27Data*) _userdata_;
#line 890 "../src/protocol.vala"
	if (g_atomic_int_dec_and_test (&_data27_->_ref_count_)) {
#line 15204 "protocol.c"
		LspCommandLike* self;
#line 890 "../src/protocol.vala"
		self = _data27_->self;
#line 890 "../src/protocol.vala"
		_g_array_unref0 (_data27_->arguments);
#line 890 "../src/protocol.vala"
		_g_object_unref0 (self);
#line 890 "../src/protocol.vala"
		g_slice_free (Block27Data, _data27_);
#line 15214 "protocol.c"
	}
}

static void
_g_variant_unref0_ (gpointer var)
{
#line 897 "../src/protocol.vala"
	(var == NULL) ? NULL : (var = (g_variant_unref (var), NULL));
#line 15223 "protocol.c"
}

static void
_vala_GVariant_free_function_content_of (gpointer data)
{
	GVariant* self;
#line 897 "../src/protocol.vala"
	self = *((GVariant**) data);
#line 897 "../src/protocol.vala"
	_g_variant_unref0_ (self);
#line 15234 "protocol.c"
}

static void
___lambda7_ (Block27Data* _data27_,
             JsonArray* array,
             guint index,
             JsonNode* element)
{
	LspCommandLike* self;
	GError* _inner_error0_ = NULL;
#line 899 "../src/protocol.vala"
	self = _data27_->self;
#line 899 "../src/protocol.vala"
	g_return_if_fail (array != NULL);
#line 899 "../src/protocol.vala"
	g_return_if_fail (element != NULL);
#line 15251 "protocol.c"
	{
		GVariant* _tmp0_ = NULL;
		GVariant* _tmp1_;
		GArray* _tmp2_;
		GVariant* _tmp3_;
#line 901 "../src/protocol.vala"
		_tmp1_ = json_gvariant_deserialize (element, NULL, &_inner_error0_);
#line 901 "../src/protocol.vala"
		_tmp0_ = _tmp1_;
#line 901 "../src/protocol.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 15263 "protocol.c"
			goto __catch0_g_error;
		}
#line 901 "../src/protocol.vala"
		_tmp2_ = _data27_->arguments;
#line 901 "../src/protocol.vala"
		_tmp3_ = _tmp0_;
#line 901 "../src/protocol.vala"
		_tmp0_ = NULL;
#line 901 "../src/protocol.vala"
		if (_tmp3_ != NULL) {
#line 901 "../src/protocol.vala"
			g_variant_ref_sink (_tmp3_);
#line 15276 "protocol.c"
		}
#line 901 "../src/protocol.vala"
		g_array_append_val (_tmp2_, _tmp3_);
#line 900 "../src/protocol.vala"
		_g_variant_unref0 (_tmp0_);
#line 15282 "protocol.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp4_;
		const gchar* _tmp5_;
#line 900 "../src/protocol.vala"
		e = _inner_error0_;
#line 900 "../src/protocol.vala"
		_inner_error0_ = NULL;
#line 903 "../src/protocol.vala"
		_tmp4_ = e;
#line 903 "../src/protocol.vala"
		_tmp5_ = _tmp4_->message;
#line 903 "../src/protocol.vala"
		g_warning ("protocol.vala:903: argument %u to command could not be deserialized: %" \
"s", index, _tmp5_);
#line 900 "../src/protocol.vala"
		_g_error_free0 (e);
#line 15302 "protocol.c"
	}
	__finally0:
#line 900 "../src/protocol.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 900 "../src/protocol.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 900 "../src/protocol.vala"
		g_clear_error (&_inner_error0_);
#line 900 "../src/protocol.vala"
		return;
#line 15313 "protocol.c"
	}
}

static void
____lambda7__json_array_foreach (JsonArray* array,
                                 guint index_,
                                 JsonNode* element_node,
                                 gpointer self)
{
#line 899 "../src/protocol.vala"
	___lambda7_ (self, array, index_, element_node);
#line 15325 "protocol.c"
}

static gboolean
lsp_command_like_real_deserialize_property (JsonSerializable* base,
                                            const gchar* property_name,
                                            GValue* value,
                                            GParamSpec* pspec,
                                            JsonNode* property_node)
{
	LspCommandLike * self;
	GValue _vala_value = {0};
	gboolean result;
#line 889 "../src/protocol.vala"
	self = (LspCommandLike*) base;
#line 889 "../src/protocol.vala"
	g_return_val_if_fail (property_name != NULL, FALSE);
#line 889 "../src/protocol.vala"
	g_return_val_if_fail (pspec != NULL, FALSE);
#line 889 "../src/protocol.vala"
	g_return_val_if_fail (property_node != NULL, FALSE);
#line 890 "../src/protocol.vala"
	if (g_strcmp0 (property_name, "arguments") == 0) {
#line 15348 "protocol.c"
		Block27Data* _data27_;
		GValue _tmp0_ = {0};
		GArray* _tmp2_;
		JsonArray* _tmp3_;
		GArray* _tmp4_;
#line 890 "../src/protocol.vala"
		_data27_ = g_slice_new0 (Block27Data);
#line 890 "../src/protocol.vala"
		_data27_->_ref_count_ = 1;
#line 890 "../src/protocol.vala"
		_data27_->self = g_object_ref (self);
#line 891 "../src/protocol.vala"
		g_value_init (&_tmp0_, G_TYPE_ARRAY);
#line 891 "../src/protocol.vala"
		G_IS_VALUE (&_vala_value) ? (g_value_unset (&_vala_value), NULL) : NULL;
#line 891 "../src/protocol.vala"
		_vala_value = _tmp0_;
#line 892 "../src/protocol.vala"
		if (json_node_get_node_type (property_node) != JSON_NODE_ARRAY) {
#line 15368 "protocol.c"
			gchar* _tmp1_;
#line 893 "../src/protocol.vala"
			_tmp1_ = g_enum_to_string (json_node_type_get_type (), json_node_get_node_type (property_node));
#line 893 "../src/protocol.vala"
			g_warning ("protocol.vala:893: unexpected property node type for 'arguments' %s", _tmp1_);
#line 893 "../src/protocol.vala"
			_g_free0 (_tmp1_);
#line 894 "../src/protocol.vala"
			result = FALSE;
#line 894 "../src/protocol.vala"
			block27_data_unref (_data27_);
#line 894 "../src/protocol.vala"
			_data27_ = NULL;
#line 894 "../src/protocol.vala"
			if (value) {
#line 894 "../src/protocol.vala"
				*value = _vala_value;
#line 15386 "protocol.c"
			} else {
#line 894 "../src/protocol.vala"
				G_IS_VALUE (&_vala_value) ? (g_value_unset (&_vala_value), NULL) : NULL;
#line 15390 "protocol.c"
			}
#line 894 "../src/protocol.vala"
			return result;
#line 15394 "protocol.c"
		}
#line 897 "../src/protocol.vala"
		_tmp2_ = g_array_new (TRUE, TRUE, sizeof (GVariant*));
#line 897 "../src/protocol.vala"
		g_array_set_clear_func (_tmp2_, (GDestroyNotify) _vala_GVariant_free_function_content_of);
#line 897 "../src/protocol.vala"
		_data27_->arguments = _tmp2_;
#line 899 "../src/protocol.vala"
		_tmp3_ = json_node_get_array (property_node);
#line 899 "../src/protocol.vala"
		json_array_foreach_element (_tmp3_, ____lambda7__json_array_foreach, _data27_);
#line 907 "../src/protocol.vala"
		_tmp4_ = _data27_->arguments;
#line 907 "../src/protocol.vala"
		g_value_set_boxed (&_vala_value, _tmp4_);
#line 908 "../src/protocol.vala"
		result = TRUE;
#line 908 "../src/protocol.vala"
		block27_data_unref (_data27_);
#line 908 "../src/protocol.vala"
		_data27_ = NULL;
#line 908 "../src/protocol.vala"
		if (value) {
#line 908 "../src/protocol.vala"
			*value = _vala_value;
#line 15420 "protocol.c"
		} else {
#line 908 "../src/protocol.vala"
			G_IS_VALUE (&_vala_value) ? (g_value_unset (&_vala_value), NULL) : NULL;
#line 15424 "protocol.c"
		}
#line 908 "../src/protocol.vala"
		return result;
#line 15428 "protocol.c"
	} else {
#line 909 "../src/protocol.vala"
		if (g_strcmp0 (property_name, "command") == 0) {
#line 15432 "protocol.c"
			const gchar* _tmp7_;
			GValue _tmp8_ = {0};
#line 911 "../src/protocol.vala"
			if (json_node_get_value_type (property_node) != G_TYPE_STRING) {
#line 15437 "protocol.c"
				GValue _tmp5_ = {0};
				gchar* _tmp6_;
#line 912 "../src/protocol.vala"
				g_value_init (&_tmp5_, G_TYPE_STRING);
#line 912 "../src/protocol.vala"
				g_value_set_string (&_tmp5_, "");
#line 912 "../src/protocol.vala"
				G_IS_VALUE (&_vala_value) ? (g_value_unset (&_vala_value), NULL) : NULL;
#line 912 "../src/protocol.vala"
				_vala_value = _tmp5_;
#line 913 "../src/protocol.vala"
				_tmp6_ = g_enum_to_string (json_node_type_get_type (), json_node_get_node_type (property_node));
#line 913 "../src/protocol.vala"
				g_warning ("protocol.vala:913: unexpected property node type for 'commands' %s", _tmp6_);
#line 913 "../src/protocol.vala"
				_g_free0 (_tmp6_);
#line 914 "../src/protocol.vala"
				result = FALSE;
#line 914 "../src/protocol.vala"
				if (value) {
#line 914 "../src/protocol.vala"
					*value = _vala_value;
#line 15460 "protocol.c"
				} else {
#line 914 "../src/protocol.vala"
					G_IS_VALUE (&_vala_value) ? (g_value_unset (&_vala_value), NULL) : NULL;
#line 15464 "protocol.c"
				}
#line 914 "../src/protocol.vala"
				return result;
#line 15468 "protocol.c"
			}
#line 917 "../src/protocol.vala"
			_tmp7_ = json_node_get_string (property_node);
#line 917 "../src/protocol.vala"
			g_value_init (&_tmp8_, G_TYPE_STRING);
#line 917 "../src/protocol.vala"
			g_value_set_string (&_tmp8_, _tmp7_);
#line 917 "../src/protocol.vala"
			G_IS_VALUE (&_vala_value) ? (g_value_unset (&_vala_value), NULL) : NULL;
#line 917 "../src/protocol.vala"
			_vala_value = _tmp8_;
#line 918 "../src/protocol.vala"
			result = TRUE;
#line 918 "../src/protocol.vala"
			if (value) {
#line 918 "../src/protocol.vala"
				*value = _vala_value;
#line 15486 "protocol.c"
			} else {
#line 918 "../src/protocol.vala"
				G_IS_VALUE (&_vala_value) ? (g_value_unset (&_vala_value), NULL) : NULL;
#line 15490 "protocol.c"
			}
#line 918 "../src/protocol.vala"
			return result;
#line 15494 "protocol.c"
		} else {
			GValue _tmp9_ = {0};
			gboolean _tmp10_;
#line 920 "../src/protocol.vala"
			_tmp10_ = json_serializable_default_deserialize_property ((JsonSerializable*) self, property_name, &_tmp9_, pspec, property_node);
#line 920 "../src/protocol.vala"
			G_IS_VALUE (&_vala_value) ? (g_value_unset (&_vala_value), NULL) : NULL;
#line 920 "../src/protocol.vala"
			_vala_value = _tmp9_;
#line 920 "../src/protocol.vala"
			result = _tmp10_;
#line 920 "../src/protocol.vala"
			if (value) {
#line 920 "../src/protocol.vala"
				*value = _vala_value;
#line 15510 "protocol.c"
			} else {
#line 920 "../src/protocol.vala"
				G_IS_VALUE (&_vala_value) ? (g_value_unset (&_vala_value), NULL) : NULL;
#line 15514 "protocol.c"
			}
#line 920 "../src/protocol.vala"
			return result;
#line 15518 "protocol.c"
		}
	}
}

LspCommandLike*
lsp_command_like_construct (GType object_type)
{
	LspCommandLike * self = NULL;
#line 865 "../src/protocol.vala"
	self = (LspCommandLike*) g_object_new (object_type, NULL);
#line 865 "../src/protocol.vala"
	return self;
#line 15531 "protocol.c"
}

const gchar*
lsp_command_like_get_command (LspCommandLike* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 869 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 869 "../src/protocol.vala"
	_tmp0_ = self->priv->_command;
#line 869 "../src/protocol.vala"
	result = _tmp0_;
#line 869 "../src/protocol.vala"
	return result;
#line 15547 "protocol.c"
}

void
lsp_command_like_set_command (LspCommandLike* self,
                              const gchar* value)
{
	gchar* old_value;
#line 869 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 869 "../src/protocol.vala"
	old_value = lsp_command_like_get_command (self);
#line 869 "../src/protocol.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 15561 "protocol.c"
		gchar* _tmp0_;
#line 869 "../src/protocol.vala"
		_tmp0_ = g_strdup (value);
#line 869 "../src/protocol.vala"
		_g_free0 (self->priv->_command);
#line 869 "../src/protocol.vala"
		self->priv->_command = _tmp0_;
#line 869 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_command_like_properties[LSP_COMMAND_LIKE_COMMAND_PROPERTY]);
#line 15571 "protocol.c"
	}
}

GArray*
lsp_command_like_get_arguments (LspCommandLike* self)
{
	GArray* result;
	GArray* _tmp0_;
#line 874 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 874 "../src/protocol.vala"
	_tmp0_ = self->priv->_arguments;
#line 874 "../src/protocol.vala"
	result = _tmp0_;
#line 874 "../src/protocol.vala"
	return result;
#line 15588 "protocol.c"
}

static gpointer
_g_array_ref0 (gpointer self)
{
#line 874 "../src/protocol.vala"
	return self ? g_array_ref (self) : NULL;
#line 15596 "protocol.c"
}

void
lsp_command_like_set_arguments (LspCommandLike* self,
                                GArray* value)
{
	GArray* old_value;
#line 874 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 874 "../src/protocol.vala"
	old_value = lsp_command_like_get_arguments (self);
#line 874 "../src/protocol.vala"
	if (old_value != value) {
#line 15610 "protocol.c"
		GArray* _tmp0_;
#line 874 "../src/protocol.vala"
		_tmp0_ = _g_array_ref0 (value);
#line 874 "../src/protocol.vala"
		_g_array_unref0 (self->priv->_arguments);
#line 874 "../src/protocol.vala"
		self->priv->_arguments = _tmp0_;
#line 874 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_command_like_properties[LSP_COMMAND_LIKE_ARGUMENTS_PROPERTY]);
#line 15620 "protocol.c"
	}
}

static void
lsp_command_like_class_init (LspCommandLikeClass * klass,
                             gpointer klass_data)
{
#line 865 "../src/protocol.vala"
	lsp_command_like_parent_class = g_type_class_peek_parent (klass);
#line 865 "../src/protocol.vala"
	g_type_class_adjust_private_offset (klass, &LspCommandLike_private_offset);
#line 865 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_lsp_command_like_get_property;
#line 865 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_lsp_command_like_set_property;
#line 865 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->finalize = lsp_command_like_finalize;
#line 15638 "protocol.c"
	/**
	         * The identifier of the actual command handler.
	         */
#line 865 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_COMMAND_LIKE_COMMAND_PROPERTY, lsp_command_like_properties[LSP_COMMAND_LIKE_COMMAND_PROPERTY] = g_param_spec_string ("command", "command", "command", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 15644 "protocol.c"
	/**
	         * Arguments that the command handler should be invoked with.
	         */
#line 865 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_COMMAND_LIKE_ARGUMENTS_PROPERTY, lsp_command_like_properties[LSP_COMMAND_LIKE_ARGUMENTS_PROPERTY] = g_param_spec_boxed ("arguments", "arguments", "arguments", G_TYPE_ARRAY, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 15650 "protocol.c"
}

static void
lsp_command_like_json_serializable_interface_init (JsonSerializableIface * iface,
                                                   gpointer iface_data)
{
#line 865 "../src/protocol.vala"
	lsp_command_like_json_serializable_parent_iface = g_type_interface_peek_parent (iface);
#line 865 "../src/protocol.vala"
	iface->serialize_property = (JsonNode* (*) (JsonSerializable*, const gchar*, GValue*, GParamSpec*)) lsp_command_like_real_serialize_property;
#line 865 "../src/protocol.vala"
	iface->deserialize_property = (gboolean (*) (JsonSerializable*, const gchar*, GValue*, GParamSpec*, JsonNode*)) lsp_command_like_real_deserialize_property;
#line 15663 "protocol.c"
}

static void
lsp_command_like_instance_init (LspCommandLike * self,
                                gpointer klass)
{
#line 865 "../src/protocol.vala"
	self->priv = lsp_command_like_get_instance_private (self);
#line 15672 "protocol.c"
}

static void
lsp_command_like_finalize (GObject * obj)
{
	LspCommandLike * self;
#line 865 "../src/protocol.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, LSP_TYPE_COMMAND_LIKE, LspCommandLike);
#line 869 "../src/protocol.vala"
	_g_free0 (self->priv->_command);
#line 874 "../src/protocol.vala"
	_g_array_unref0 (self->priv->_arguments);
#line 865 "../src/protocol.vala"
	G_OBJECT_CLASS (lsp_command_like_parent_class)->finalize (obj);
#line 15687 "protocol.c"
}

 G_GNUC_NO_INLINE static GType
lsp_command_like_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (LspCommandLikeClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) lsp_command_like_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LspCommandLike), 0, (GInstanceInitFunc) lsp_command_like_instance_init, NULL };
	static const GInterfaceInfo json_serializable_info = { (GInterfaceInitFunc) lsp_command_like_json_serializable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType lsp_command_like_type_id;
	lsp_command_like_type_id = g_type_register_static (G_TYPE_OBJECT, "LspCommandLike", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	g_type_add_interface_static (lsp_command_like_type_id, json_serializable_get_type (), &json_serializable_info);
	LspCommandLike_private_offset = g_type_add_instance_private (lsp_command_like_type_id, sizeof (LspCommandLikePrivate));
	return lsp_command_like_type_id;
}

GType
lsp_command_like_get_type (void)
{
	static gsize lsp_command_like_type_id__once = 0;
	if (g_once_init_enter (&lsp_command_like_type_id__once)) {
		GType lsp_command_like_type_id;
		lsp_command_like_type_id = lsp_command_like_get_type_once ();
		g_once_init_leave (&lsp_command_like_type_id__once, lsp_command_like_type_id);
	}
	return lsp_command_like_type_id__once;
}

static void
_vala_lsp_command_like_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec)
{
	LspCommandLike * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_COMMAND_LIKE, LspCommandLike);
#line 865 "../src/protocol.vala"
	switch (property_id) {
#line 865 "../src/protocol.vala"
		case LSP_COMMAND_LIKE_COMMAND_PROPERTY:
#line 865 "../src/protocol.vala"
		g_value_set_string (value, lsp_command_like_get_command (self));
#line 865 "../src/protocol.vala"
		break;
#line 865 "../src/protocol.vala"
		case LSP_COMMAND_LIKE_ARGUMENTS_PROPERTY:
#line 865 "../src/protocol.vala"
		g_value_set_boxed (value, lsp_command_like_get_arguments (self));
#line 865 "../src/protocol.vala"
		break;
#line 15736 "protocol.c"
		default:
#line 865 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 865 "../src/protocol.vala"
		break;
#line 15742 "protocol.c"
	}
}

static void
_vala_lsp_command_like_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec)
{
	LspCommandLike * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_COMMAND_LIKE, LspCommandLike);
#line 865 "../src/protocol.vala"
	switch (property_id) {
#line 865 "../src/protocol.vala"
		case LSP_COMMAND_LIKE_COMMAND_PROPERTY:
#line 865 "../src/protocol.vala"
		lsp_command_like_set_command (self, g_value_get_string (value));
#line 865 "../src/protocol.vala"
		break;
#line 865 "../src/protocol.vala"
		case LSP_COMMAND_LIKE_ARGUMENTS_PROPERTY:
#line 865 "../src/protocol.vala"
		lsp_command_like_set_arguments (self, g_value_get_boxed (value));
#line 865 "../src/protocol.vala"
		break;
#line 15768 "protocol.c"
		default:
#line 865 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 865 "../src/protocol.vala"
		break;
#line 15774 "protocol.c"
	}
}

LspExecuteCommandParams*
lsp_execute_command_params_construct (GType object_type)
{
	LspExecuteCommandParams * self = NULL;
#line 925 "../src/protocol.vala"
	self = (LspExecuteCommandParams*) lsp_command_like_construct (object_type);
#line 925 "../src/protocol.vala"
	return self;
#line 15786 "protocol.c"
}

LspExecuteCommandParams*
lsp_execute_command_params_new (void)
{
#line 925 "../src/protocol.vala"
	return lsp_execute_command_params_construct (LSP_TYPE_EXECUTE_COMMAND_PARAMS);
#line 15794 "protocol.c"
}

static void
lsp_execute_command_params_class_init (LspExecuteCommandParamsClass * klass,
                                       gpointer klass_data)
{
#line 925 "../src/protocol.vala"
	lsp_execute_command_params_parent_class = g_type_class_peek_parent (klass);
#line 15803 "protocol.c"
}

static void
lsp_execute_command_params_instance_init (LspExecuteCommandParams * self,
                                          gpointer klass)
{
}

 G_GNUC_NO_INLINE static GType
lsp_execute_command_params_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (LspExecuteCommandParamsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) lsp_execute_command_params_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LspExecuteCommandParams), 0, (GInstanceInitFunc) lsp_execute_command_params_instance_init, NULL };
	GType lsp_execute_command_params_type_id;
	lsp_execute_command_params_type_id = g_type_register_static (LSP_TYPE_COMMAND_LIKE, "LspExecuteCommandParams", &g_define_type_info, 0);
	return lsp_execute_command_params_type_id;
}

GType
lsp_execute_command_params_get_type (void)
{
	static gsize lsp_execute_command_params_type_id__once = 0;
	if (g_once_init_enter (&lsp_execute_command_params_type_id__once)) {
		GType lsp_execute_command_params_type_id;
		lsp_execute_command_params_type_id = lsp_execute_command_params_get_type_once ();
		g_once_init_leave (&lsp_execute_command_params_type_id__once, lsp_execute_command_params_type_id);
	}
	return lsp_execute_command_params_type_id__once;
}

static inline gpointer
lsp_command_get_instance_private (LspCommand* self)
{
	return G_STRUCT_MEMBER_P (self, LspCommand_private_offset);
}

LspCommand*
lsp_command_construct (GType object_type)
{
	LspCommand * self = NULL;
#line 937 "../src/protocol.vala"
	self = (LspCommand*) lsp_command_like_construct (object_type);
#line 937 "../src/protocol.vala"
	return self;
#line 15847 "protocol.c"
}

LspCommand*
lsp_command_new (void)
{
#line 937 "../src/protocol.vala"
	return lsp_command_construct (LSP_TYPE_COMMAND);
#line 15855 "protocol.c"
}

const gchar*
lsp_command_get_title (LspCommand* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 941 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 941 "../src/protocol.vala"
	_tmp0_ = self->priv->_title;
#line 941 "../src/protocol.vala"
	result = _tmp0_;
#line 941 "../src/protocol.vala"
	return result;
#line 15871 "protocol.c"
}

void
lsp_command_set_title (LspCommand* self,
                       const gchar* value)
{
	gchar* old_value;
#line 941 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 941 "../src/protocol.vala"
	old_value = lsp_command_get_title (self);
#line 941 "../src/protocol.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 15885 "protocol.c"
		gchar* _tmp0_;
#line 941 "../src/protocol.vala"
		_tmp0_ = g_strdup (value);
#line 941 "../src/protocol.vala"
		_g_free0 (self->priv->_title);
#line 941 "../src/protocol.vala"
		self->priv->_title = _tmp0_;
#line 941 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_command_properties[LSP_COMMAND_TITLE_PROPERTY]);
#line 15895 "protocol.c"
	}
}

static void
lsp_command_class_init (LspCommandClass * klass,
                        gpointer klass_data)
{
#line 937 "../src/protocol.vala"
	lsp_command_parent_class = g_type_class_peek_parent (klass);
#line 937 "../src/protocol.vala"
	g_type_class_adjust_private_offset (klass, &LspCommand_private_offset);
#line 937 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_lsp_command_get_property;
#line 937 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_lsp_command_set_property;
#line 937 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->finalize = lsp_command_finalize;
#line 15913 "protocol.c"
	/**
	         * The title of the command, like `save`.
	         */
#line 937 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_COMMAND_TITLE_PROPERTY, lsp_command_properties[LSP_COMMAND_TITLE_PROPERTY] = g_param_spec_string ("title", "title", "title", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 15919 "protocol.c"
}

static void
lsp_command_instance_init (LspCommand * self,
                           gpointer klass)
{
#line 937 "../src/protocol.vala"
	self->priv = lsp_command_get_instance_private (self);
#line 15928 "protocol.c"
}

static void
lsp_command_finalize (GObject * obj)
{
	LspCommand * self;
#line 937 "../src/protocol.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, LSP_TYPE_COMMAND, LspCommand);
#line 941 "../src/protocol.vala"
	_g_free0 (self->priv->_title);
#line 937 "../src/protocol.vala"
	G_OBJECT_CLASS (lsp_command_parent_class)->finalize (obj);
#line 15941 "protocol.c"
}

/**
     * Represents a reference to a command. Provides a title which will be used
     * to represent a command in the UI. Commands are identified by a string
     * identifier. The recommended way to handle commands is to implement their
     * execution on the server side if the client and server provides the
     * corresponding capabilities. Alternatively the tool extension code could
     * handle the command. The protocol currently doesn’t specify a set of
     * well-known commands.
     */
 G_GNUC_NO_INLINE static GType
lsp_command_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (LspCommandClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) lsp_command_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LspCommand), 0, (GInstanceInitFunc) lsp_command_instance_init, NULL };
	GType lsp_command_type_id;
	lsp_command_type_id = g_type_register_static (LSP_TYPE_COMMAND_LIKE, "LspCommand", &g_define_type_info, 0);
	LspCommand_private_offset = g_type_add_instance_private (lsp_command_type_id, sizeof (LspCommandPrivate));
	return lsp_command_type_id;
}

GType
lsp_command_get_type (void)
{
	static gsize lsp_command_type_id__once = 0;
	if (g_once_init_enter (&lsp_command_type_id__once)) {
		GType lsp_command_type_id;
		lsp_command_type_id = lsp_command_get_type_once ();
		g_once_init_leave (&lsp_command_type_id__once, lsp_command_type_id);
	}
	return lsp_command_type_id__once;
}

static void
_vala_lsp_command_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	LspCommand * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_COMMAND, LspCommand);
#line 937 "../src/protocol.vala"
	switch (property_id) {
#line 937 "../src/protocol.vala"
		case LSP_COMMAND_TITLE_PROPERTY:
#line 937 "../src/protocol.vala"
		g_value_set_string (value, lsp_command_get_title (self));
#line 937 "../src/protocol.vala"
		break;
#line 15991 "protocol.c"
		default:
#line 937 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 937 "../src/protocol.vala"
		break;
#line 15997 "protocol.c"
	}
}

static void
_vala_lsp_command_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	LspCommand * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_COMMAND, LspCommand);
#line 937 "../src/protocol.vala"
	switch (property_id) {
#line 937 "../src/protocol.vala"
		case LSP_COMMAND_TITLE_PROPERTY:
#line 937 "../src/protocol.vala"
		lsp_command_set_title (self, g_value_get_string (value));
#line 937 "../src/protocol.vala"
		break;
#line 16017 "protocol.c"
		default:
#line 937 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 937 "../src/protocol.vala"
		break;
#line 16023 "protocol.c"
	}
}

static inline gpointer
lsp_code_lens_get_instance_private (LspCodeLens* self)
{
	return G_STRUCT_MEMBER_P (self, LspCodeLens_private_offset);
}

LspCodeLens*
lsp_code_lens_construct (GType object_type)
{
	LspCodeLens * self = NULL;
#line 952 "../src/protocol.vala"
	self = (LspCodeLens*) g_object_new (object_type, NULL);
#line 952 "../src/protocol.vala"
	return self;
#line 16041 "protocol.c"
}

LspCodeLens*
lsp_code_lens_new (void)
{
#line 952 "../src/protocol.vala"
	return lsp_code_lens_construct (LSP_TYPE_CODE_LENS);
#line 16049 "protocol.c"
}

LspRange*
lsp_code_lens_get_range (LspCodeLens* self)
{
	LspRange* result;
	LspRange* _tmp0_;
#line 957 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 957 "../src/protocol.vala"
	_tmp0_ = self->priv->_range;
#line 957 "../src/protocol.vala"
	result = _tmp0_;
#line 957 "../src/protocol.vala"
	return result;
#line 16065 "protocol.c"
}

void
lsp_code_lens_set_range (LspCodeLens* self,
                         LspRange* value)
{
	LspRange* old_value;
#line 957 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 957 "../src/protocol.vala"
	old_value = lsp_code_lens_get_range (self);
#line 957 "../src/protocol.vala"
	if (old_value != value) {
#line 16079 "protocol.c"
		LspRange* _tmp0_;
#line 957 "../src/protocol.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 957 "../src/protocol.vala"
		_g_object_unref0 (self->priv->_range);
#line 957 "../src/protocol.vala"
		self->priv->_range = _tmp0_;
#line 957 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_code_lens_properties[LSP_CODE_LENS_RANGE_PROPERTY]);
#line 16089 "protocol.c"
	}
}

LspCommand*
lsp_code_lens_get_command (LspCodeLens* self)
{
	LspCommand* result;
	LspCommand* _tmp0_;
#line 962 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 962 "../src/protocol.vala"
	_tmp0_ = self->priv->_command;
#line 962 "../src/protocol.vala"
	result = _tmp0_;
#line 962 "../src/protocol.vala"
	return result;
#line 16106 "protocol.c"
}

void
lsp_code_lens_set_command (LspCodeLens* self,
                           LspCommand* value)
{
	LspCommand* old_value;
#line 962 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 962 "../src/protocol.vala"
	old_value = lsp_code_lens_get_command (self);
#line 962 "../src/protocol.vala"
	if (old_value != value) {
#line 16120 "protocol.c"
		LspCommand* _tmp0_;
#line 962 "../src/protocol.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 962 "../src/protocol.vala"
		_g_object_unref0 (self->priv->_command);
#line 962 "../src/protocol.vala"
		self->priv->_command = _tmp0_;
#line 962 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_code_lens_properties[LSP_CODE_LENS_COMMAND_PROPERTY]);
#line 16130 "protocol.c"
	}
}

static void
lsp_code_lens_class_init (LspCodeLensClass * klass,
                          gpointer klass_data)
{
#line 952 "../src/protocol.vala"
	lsp_code_lens_parent_class = g_type_class_peek_parent (klass);
#line 952 "../src/protocol.vala"
	g_type_class_adjust_private_offset (klass, &LspCodeLens_private_offset);
#line 952 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_lsp_code_lens_get_property;
#line 952 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_lsp_code_lens_set_property;
#line 952 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->finalize = lsp_code_lens_finalize;
#line 16148 "protocol.c"
	/**
	         * The range in which this code lens is valid. Should only span a single
	         * line.
	         */
#line 952 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_CODE_LENS_RANGE_PROPERTY, lsp_code_lens_properties[LSP_CODE_LENS_RANGE_PROPERTY] = g_param_spec_object ("range", "range", "range", LSP_TYPE_RANGE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 16155 "protocol.c"
	/**
	         * The command this code lens represents.
	         */
#line 952 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_CODE_LENS_COMMAND_PROPERTY, lsp_code_lens_properties[LSP_CODE_LENS_COMMAND_PROPERTY] = g_param_spec_object ("command", "command", "command", LSP_TYPE_COMMAND, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 16161 "protocol.c"
}

static void
lsp_code_lens_instance_init (LspCodeLens * self,
                             gpointer klass)
{
#line 952 "../src/protocol.vala"
	self->priv = lsp_code_lens_get_instance_private (self);
#line 16170 "protocol.c"
}

static void
lsp_code_lens_finalize (GObject * obj)
{
	LspCodeLens * self;
#line 952 "../src/protocol.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, LSP_TYPE_CODE_LENS, LspCodeLens);
#line 957 "../src/protocol.vala"
	_g_object_unref0 (self->priv->_range);
#line 962 "../src/protocol.vala"
	_g_object_unref0 (self->priv->_command);
#line 952 "../src/protocol.vala"
	G_OBJECT_CLASS (lsp_code_lens_parent_class)->finalize (obj);
#line 16185 "protocol.c"
}

/**
     * A code lens represents a command that should be shown along with
     * source text, like the number of references, a way to run tests, etc.
     *
     * A code lens is _unresolved_ when no command is associated to it. For
     * performance reasons the creation of a code lens and resolving should be done
     * in two stages.
     */
 G_GNUC_NO_INLINE static GType
lsp_code_lens_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (LspCodeLensClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) lsp_code_lens_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LspCodeLens), 0, (GInstanceInitFunc) lsp_code_lens_instance_init, NULL };
	GType lsp_code_lens_type_id;
	lsp_code_lens_type_id = g_type_register_static (G_TYPE_OBJECT, "LspCodeLens", &g_define_type_info, 0);
	LspCodeLens_private_offset = g_type_add_instance_private (lsp_code_lens_type_id, sizeof (LspCodeLensPrivate));
	return lsp_code_lens_type_id;
}

GType
lsp_code_lens_get_type (void)
{
	static gsize lsp_code_lens_type_id__once = 0;
	if (g_once_init_enter (&lsp_code_lens_type_id__once)) {
		GType lsp_code_lens_type_id;
		lsp_code_lens_type_id = lsp_code_lens_get_type_once ();
		g_once_init_leave (&lsp_code_lens_type_id__once, lsp_code_lens_type_id);
	}
	return lsp_code_lens_type_id__once;
}

static void
_vala_lsp_code_lens_get_property (GObject * object,
                                  guint property_id,
                                  GValue * value,
                                  GParamSpec * pspec)
{
	LspCodeLens * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_CODE_LENS, LspCodeLens);
#line 952 "../src/protocol.vala"
	switch (property_id) {
#line 952 "../src/protocol.vala"
		case LSP_CODE_LENS_RANGE_PROPERTY:
#line 952 "../src/protocol.vala"
		g_value_set_object (value, lsp_code_lens_get_range (self));
#line 952 "../src/protocol.vala"
		break;
#line 952 "../src/protocol.vala"
		case LSP_CODE_LENS_COMMAND_PROPERTY:
#line 952 "../src/protocol.vala"
		g_value_set_object (value, lsp_code_lens_get_command (self));
#line 952 "../src/protocol.vala"
		break;
#line 16240 "protocol.c"
		default:
#line 952 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 952 "../src/protocol.vala"
		break;
#line 16246 "protocol.c"
	}
}

static void
_vala_lsp_code_lens_set_property (GObject * object,
                                  guint property_id,
                                  const GValue * value,
                                  GParamSpec * pspec)
{
	LspCodeLens * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_CODE_LENS, LspCodeLens);
#line 952 "../src/protocol.vala"
	switch (property_id) {
#line 952 "../src/protocol.vala"
		case LSP_CODE_LENS_RANGE_PROPERTY:
#line 952 "../src/protocol.vala"
		lsp_code_lens_set_range (self, g_value_get_object (value));
#line 952 "../src/protocol.vala"
		break;
#line 952 "../src/protocol.vala"
		case LSP_CODE_LENS_COMMAND_PROPERTY:
#line 952 "../src/protocol.vala"
		lsp_code_lens_set_command (self, g_value_get_object (value));
#line 952 "../src/protocol.vala"
		break;
#line 16272 "protocol.c"
		default:
#line 952 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 952 "../src/protocol.vala"
		break;
#line 16278 "protocol.c"
	}
}

static inline gpointer
lsp_document_range_formatting_params_get_instance_private (LspDocumentRangeFormattingParams* self)
{
	return G_STRUCT_MEMBER_P (self, LspDocumentRangeFormattingParams_private_offset);
}

LspDocumentRangeFormattingParams*
lsp_document_range_formatting_params_construct (GType object_type)
{
	LspDocumentRangeFormattingParams * self = NULL;
#line 965 "../src/protocol.vala"
	self = (LspDocumentRangeFormattingParams*) g_object_new (object_type, NULL);
#line 965 "../src/protocol.vala"
	return self;
#line 16296 "protocol.c"
}

LspDocumentRangeFormattingParams*
lsp_document_range_formatting_params_new (void)
{
#line 965 "../src/protocol.vala"
	return lsp_document_range_formatting_params_construct (LSP_TYPE_DOCUMENT_RANGE_FORMATTING_PARAMS);
#line 16304 "protocol.c"
}

LspTextDocumentIdentifier*
lsp_document_range_formatting_params_get_textDocument (LspDocumentRangeFormattingParams* self)
{
	LspTextDocumentIdentifier* result;
	LspTextDocumentIdentifier* _tmp0_;
#line 966 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 966 "../src/protocol.vala"
	_tmp0_ = self->priv->_textDocument;
#line 966 "../src/protocol.vala"
	result = _tmp0_;
#line 966 "../src/protocol.vala"
	return result;
#line 16320 "protocol.c"
}

void
lsp_document_range_formatting_params_set_textDocument (LspDocumentRangeFormattingParams* self,
                                                       LspTextDocumentIdentifier* value)
{
	LspTextDocumentIdentifier* old_value;
#line 966 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 966 "../src/protocol.vala"
	old_value = lsp_document_range_formatting_params_get_textDocument (self);
#line 966 "../src/protocol.vala"
	if (old_value != value) {
#line 16334 "protocol.c"
		LspTextDocumentIdentifier* _tmp0_;
#line 966 "../src/protocol.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 966 "../src/protocol.vala"
		_g_object_unref0 (self->priv->_textDocument);
#line 966 "../src/protocol.vala"
		self->priv->_textDocument = _tmp0_;
#line 966 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_document_range_formatting_params_properties[LSP_DOCUMENT_RANGE_FORMATTING_PARAMS_TEXT_DOCUMENT_PROPERTY]);
#line 16344 "protocol.c"
	}
}

LspRange*
lsp_document_range_formatting_params_get_range (LspDocumentRangeFormattingParams* self)
{
	LspRange* result;
	LspRange* _tmp0_;
#line 967 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 967 "../src/protocol.vala"
	_tmp0_ = self->priv->_range;
#line 967 "../src/protocol.vala"
	result = _tmp0_;
#line 967 "../src/protocol.vala"
	return result;
#line 16361 "protocol.c"
}

void
lsp_document_range_formatting_params_set_range (LspDocumentRangeFormattingParams* self,
                                                LspRange* value)
{
	LspRange* old_value;
#line 967 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 967 "../src/protocol.vala"
	old_value = lsp_document_range_formatting_params_get_range (self);
#line 967 "../src/protocol.vala"
	if (old_value != value) {
#line 16375 "protocol.c"
		LspRange* _tmp0_;
#line 967 "../src/protocol.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 967 "../src/protocol.vala"
		_g_object_unref0 (self->priv->_range);
#line 967 "../src/protocol.vala"
		self->priv->_range = _tmp0_;
#line 967 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_document_range_formatting_params_properties[LSP_DOCUMENT_RANGE_FORMATTING_PARAMS_RANGE_PROPERTY]);
#line 16385 "protocol.c"
	}
}

LspFormattingOptions*
lsp_document_range_formatting_params_get_options (LspDocumentRangeFormattingParams* self)
{
	LspFormattingOptions* result;
	LspFormattingOptions* _tmp0_;
#line 968 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 968 "../src/protocol.vala"
	_tmp0_ = self->priv->_options;
#line 968 "../src/protocol.vala"
	result = _tmp0_;
#line 968 "../src/protocol.vala"
	return result;
#line 16402 "protocol.c"
}

void
lsp_document_range_formatting_params_set_options (LspDocumentRangeFormattingParams* self,
                                                  LspFormattingOptions* value)
{
	LspFormattingOptions* old_value;
#line 968 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 968 "../src/protocol.vala"
	old_value = lsp_document_range_formatting_params_get_options (self);
#line 968 "../src/protocol.vala"
	if (old_value != value) {
#line 16416 "protocol.c"
		LspFormattingOptions* _tmp0_;
#line 968 "../src/protocol.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 968 "../src/protocol.vala"
		_g_object_unref0 (self->priv->_options);
#line 968 "../src/protocol.vala"
		self->priv->_options = _tmp0_;
#line 968 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_document_range_formatting_params_properties[LSP_DOCUMENT_RANGE_FORMATTING_PARAMS_OPTIONS_PROPERTY]);
#line 16426 "protocol.c"
	}
}

static void
lsp_document_range_formatting_params_class_init (LspDocumentRangeFormattingParamsClass * klass,
                                                 gpointer klass_data)
{
#line 965 "../src/protocol.vala"
	lsp_document_range_formatting_params_parent_class = g_type_class_peek_parent (klass);
#line 965 "../src/protocol.vala"
	g_type_class_adjust_private_offset (klass, &LspDocumentRangeFormattingParams_private_offset);
#line 965 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_lsp_document_range_formatting_params_get_property;
#line 965 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_lsp_document_range_formatting_params_set_property;
#line 965 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->finalize = lsp_document_range_formatting_params_finalize;
#line 965 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_DOCUMENT_RANGE_FORMATTING_PARAMS_TEXT_DOCUMENT_PROPERTY, lsp_document_range_formatting_params_properties[LSP_DOCUMENT_RANGE_FORMATTING_PARAMS_TEXT_DOCUMENT_PROPERTY] = g_param_spec_object ("textDocument", "textDocument", "textDocument", LSP_TYPE_TEXT_DOCUMENT_IDENTIFIER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 965 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_DOCUMENT_RANGE_FORMATTING_PARAMS_RANGE_PROPERTY, lsp_document_range_formatting_params_properties[LSP_DOCUMENT_RANGE_FORMATTING_PARAMS_RANGE_PROPERTY] = g_param_spec_object ("range", "range", "range", LSP_TYPE_RANGE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 965 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_DOCUMENT_RANGE_FORMATTING_PARAMS_OPTIONS_PROPERTY, lsp_document_range_formatting_params_properties[LSP_DOCUMENT_RANGE_FORMATTING_PARAMS_OPTIONS_PROPERTY] = g_param_spec_object ("options", "options", "options", LSP_TYPE_FORMATTING_OPTIONS, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 16450 "protocol.c"
}

static void
lsp_document_range_formatting_params_instance_init (LspDocumentRangeFormattingParams * self,
                                                    gpointer klass)
{
#line 965 "../src/protocol.vala"
	self->priv = lsp_document_range_formatting_params_get_instance_private (self);
#line 16459 "protocol.c"
}

static void
lsp_document_range_formatting_params_finalize (GObject * obj)
{
	LspDocumentRangeFormattingParams * self;
#line 965 "../src/protocol.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, LSP_TYPE_DOCUMENT_RANGE_FORMATTING_PARAMS, LspDocumentRangeFormattingParams);
#line 966 "../src/protocol.vala"
	_g_object_unref0 (self->priv->_textDocument);
#line 967 "../src/protocol.vala"
	_g_object_unref0 (self->priv->_range);
#line 968 "../src/protocol.vala"
	_g_object_unref0 (self->priv->_options);
#line 965 "../src/protocol.vala"
	G_OBJECT_CLASS (lsp_document_range_formatting_params_parent_class)->finalize (obj);
#line 16476 "protocol.c"
}

 G_GNUC_NO_INLINE static GType
lsp_document_range_formatting_params_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (LspDocumentRangeFormattingParamsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) lsp_document_range_formatting_params_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LspDocumentRangeFormattingParams), 0, (GInstanceInitFunc) lsp_document_range_formatting_params_instance_init, NULL };
	GType lsp_document_range_formatting_params_type_id;
	lsp_document_range_formatting_params_type_id = g_type_register_static (G_TYPE_OBJECT, "LspDocumentRangeFormattingParams", &g_define_type_info, 0);
	LspDocumentRangeFormattingParams_private_offset = g_type_add_instance_private (lsp_document_range_formatting_params_type_id, sizeof (LspDocumentRangeFormattingParamsPrivate));
	return lsp_document_range_formatting_params_type_id;
}

GType
lsp_document_range_formatting_params_get_type (void)
{
	static gsize lsp_document_range_formatting_params_type_id__once = 0;
	if (g_once_init_enter (&lsp_document_range_formatting_params_type_id__once)) {
		GType lsp_document_range_formatting_params_type_id;
		lsp_document_range_formatting_params_type_id = lsp_document_range_formatting_params_get_type_once ();
		g_once_init_leave (&lsp_document_range_formatting_params_type_id__once, lsp_document_range_formatting_params_type_id);
	}
	return lsp_document_range_formatting_params_type_id__once;
}

static void
_vala_lsp_document_range_formatting_params_get_property (GObject * object,
                                                         guint property_id,
                                                         GValue * value,
                                                         GParamSpec * pspec)
{
	LspDocumentRangeFormattingParams * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_DOCUMENT_RANGE_FORMATTING_PARAMS, LspDocumentRangeFormattingParams);
#line 965 "../src/protocol.vala"
	switch (property_id) {
#line 965 "../src/protocol.vala"
		case LSP_DOCUMENT_RANGE_FORMATTING_PARAMS_TEXT_DOCUMENT_PROPERTY:
#line 965 "../src/protocol.vala"
		g_value_set_object (value, lsp_document_range_formatting_params_get_textDocument (self));
#line 965 "../src/protocol.vala"
		break;
#line 965 "../src/protocol.vala"
		case LSP_DOCUMENT_RANGE_FORMATTING_PARAMS_RANGE_PROPERTY:
#line 965 "../src/protocol.vala"
		g_value_set_object (value, lsp_document_range_formatting_params_get_range (self));
#line 965 "../src/protocol.vala"
		break;
#line 965 "../src/protocol.vala"
		case LSP_DOCUMENT_RANGE_FORMATTING_PARAMS_OPTIONS_PROPERTY:
#line 965 "../src/protocol.vala"
		g_value_set_object (value, lsp_document_range_formatting_params_get_options (self));
#line 965 "../src/protocol.vala"
		break;
#line 16529 "protocol.c"
		default:
#line 965 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 965 "../src/protocol.vala"
		break;
#line 16535 "protocol.c"
	}
}

static void
_vala_lsp_document_range_formatting_params_set_property (GObject * object,
                                                         guint property_id,
                                                         const GValue * value,
                                                         GParamSpec * pspec)
{
	LspDocumentRangeFormattingParams * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_DOCUMENT_RANGE_FORMATTING_PARAMS, LspDocumentRangeFormattingParams);
#line 965 "../src/protocol.vala"
	switch (property_id) {
#line 965 "../src/protocol.vala"
		case LSP_DOCUMENT_RANGE_FORMATTING_PARAMS_TEXT_DOCUMENT_PROPERTY:
#line 965 "../src/protocol.vala"
		lsp_document_range_formatting_params_set_textDocument (self, g_value_get_object (value));
#line 965 "../src/protocol.vala"
		break;
#line 965 "../src/protocol.vala"
		case LSP_DOCUMENT_RANGE_FORMATTING_PARAMS_RANGE_PROPERTY:
#line 965 "../src/protocol.vala"
		lsp_document_range_formatting_params_set_range (self, g_value_get_object (value));
#line 965 "../src/protocol.vala"
		break;
#line 965 "../src/protocol.vala"
		case LSP_DOCUMENT_RANGE_FORMATTING_PARAMS_OPTIONS_PROPERTY:
#line 965 "../src/protocol.vala"
		lsp_document_range_formatting_params_set_options (self, g_value_get_object (value));
#line 965 "../src/protocol.vala"
		break;
#line 16567 "protocol.c"
		default:
#line 965 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 965 "../src/protocol.vala"
		break;
#line 16573 "protocol.c"
	}
}

static inline gpointer
lsp_formatting_options_get_instance_private (LspFormattingOptions* self)
{
	return G_STRUCT_MEMBER_P (self, LspFormattingOptions_private_offset);
}

LspFormattingOptions*
lsp_formatting_options_construct (GType object_type)
{
	LspFormattingOptions * self = NULL;
#line 971 "../src/protocol.vala"
	self = (LspFormattingOptions*) g_object_new (object_type, NULL);
#line 971 "../src/protocol.vala"
	return self;
#line 16591 "protocol.c"
}

LspFormattingOptions*
lsp_formatting_options_new (void)
{
#line 971 "../src/protocol.vala"
	return lsp_formatting_options_construct (LSP_TYPE_FORMATTING_OPTIONS);
#line 16599 "protocol.c"
}

guint
lsp_formatting_options_get_tabSize (LspFormattingOptions* self)
{
	guint result;
#line 972 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 972 "../src/protocol.vala"
	result = self->priv->_tabSize;
#line 972 "../src/protocol.vala"
	return result;
#line 16612 "protocol.c"
}

void
lsp_formatting_options_set_tabSize (LspFormattingOptions* self,
                                    guint value)
{
	guint old_value;
#line 972 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 972 "../src/protocol.vala"
	old_value = lsp_formatting_options_get_tabSize (self);
#line 972 "../src/protocol.vala"
	if (old_value != value) {
#line 972 "../src/protocol.vala"
		self->priv->_tabSize = value;
#line 972 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_formatting_options_properties[LSP_FORMATTING_OPTIONS_TAB_SIZE_PROPERTY]);
#line 16630 "protocol.c"
	}
}

gboolean
lsp_formatting_options_get_insertSpaces (LspFormattingOptions* self)
{
	gboolean result;
#line 973 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 973 "../src/protocol.vala"
	result = self->priv->_insertSpaces;
#line 973 "../src/protocol.vala"
	return result;
#line 16644 "protocol.c"
}

void
lsp_formatting_options_set_insertSpaces (LspFormattingOptions* self,
                                         gboolean value)
{
	gboolean old_value;
#line 973 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 973 "../src/protocol.vala"
	old_value = lsp_formatting_options_get_insertSpaces (self);
#line 973 "../src/protocol.vala"
	if (old_value != value) {
#line 973 "../src/protocol.vala"
		self->priv->_insertSpaces = value;
#line 973 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_formatting_options_properties[LSP_FORMATTING_OPTIONS_INSERT_SPACES_PROPERTY]);
#line 16662 "protocol.c"
	}
}

gboolean
lsp_formatting_options_get_trimTrailingWhitespace (LspFormattingOptions* self)
{
	gboolean result;
#line 974 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 974 "../src/protocol.vala"
	result = self->priv->_trimTrailingWhitespace;
#line 974 "../src/protocol.vala"
	return result;
#line 16676 "protocol.c"
}

void
lsp_formatting_options_set_trimTrailingWhitespace (LspFormattingOptions* self,
                                                   gboolean value)
{
	gboolean old_value;
#line 974 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 974 "../src/protocol.vala"
	old_value = lsp_formatting_options_get_trimTrailingWhitespace (self);
#line 974 "../src/protocol.vala"
	if (old_value != value) {
#line 974 "../src/protocol.vala"
		self->priv->_trimTrailingWhitespace = value;
#line 974 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_formatting_options_properties[LSP_FORMATTING_OPTIONS_TRIM_TRAILING_WHITESPACE_PROPERTY]);
#line 16694 "protocol.c"
	}
}

gboolean
lsp_formatting_options_get_insertFinalNewline (LspFormattingOptions* self)
{
	gboolean result;
#line 975 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 975 "../src/protocol.vala"
	result = self->priv->_insertFinalNewline;
#line 975 "../src/protocol.vala"
	return result;
#line 16708 "protocol.c"
}

void
lsp_formatting_options_set_insertFinalNewline (LspFormattingOptions* self,
                                               gboolean value)
{
	gboolean old_value;
#line 975 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 975 "../src/protocol.vala"
	old_value = lsp_formatting_options_get_insertFinalNewline (self);
#line 975 "../src/protocol.vala"
	if (old_value != value) {
#line 975 "../src/protocol.vala"
		self->priv->_insertFinalNewline = value;
#line 975 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_formatting_options_properties[LSP_FORMATTING_OPTIONS_INSERT_FINAL_NEWLINE_PROPERTY]);
#line 16726 "protocol.c"
	}
}

gboolean
lsp_formatting_options_get_trimFinalNewlines (LspFormattingOptions* self)
{
	gboolean result;
#line 976 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 976 "../src/protocol.vala"
	result = self->priv->_trimFinalNewlines;
#line 976 "../src/protocol.vala"
	return result;
#line 16740 "protocol.c"
}

void
lsp_formatting_options_set_trimFinalNewlines (LspFormattingOptions* self,
                                              gboolean value)
{
	gboolean old_value;
#line 976 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 976 "../src/protocol.vala"
	old_value = lsp_formatting_options_get_trimFinalNewlines (self);
#line 976 "../src/protocol.vala"
	if (old_value != value) {
#line 976 "../src/protocol.vala"
		self->priv->_trimFinalNewlines = value;
#line 976 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_formatting_options_properties[LSP_FORMATTING_OPTIONS_TRIM_FINAL_NEWLINES_PROPERTY]);
#line 16758 "protocol.c"
	}
}

static void
lsp_formatting_options_class_init (LspFormattingOptionsClass * klass,
                                   gpointer klass_data)
{
#line 971 "../src/protocol.vala"
	lsp_formatting_options_parent_class = g_type_class_peek_parent (klass);
#line 971 "../src/protocol.vala"
	g_type_class_adjust_private_offset (klass, &LspFormattingOptions_private_offset);
#line 971 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_lsp_formatting_options_get_property;
#line 971 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_lsp_formatting_options_set_property;
#line 971 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->finalize = lsp_formatting_options_finalize;
#line 971 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_FORMATTING_OPTIONS_TAB_SIZE_PROPERTY, lsp_formatting_options_properties[LSP_FORMATTING_OPTIONS_TAB_SIZE_PROPERTY] = g_param_spec_uint ("tabSize", "tabSize", "tabSize", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 971 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_FORMATTING_OPTIONS_INSERT_SPACES_PROPERTY, lsp_formatting_options_properties[LSP_FORMATTING_OPTIONS_INSERT_SPACES_PROPERTY] = g_param_spec_boolean ("insertSpaces", "insertSpaces", "insertSpaces", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 971 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_FORMATTING_OPTIONS_TRIM_TRAILING_WHITESPACE_PROPERTY, lsp_formatting_options_properties[LSP_FORMATTING_OPTIONS_TRIM_TRAILING_WHITESPACE_PROPERTY] = g_param_spec_boolean ("trimTrailingWhitespace", "trimTrailingWhitespace", "trimTrailingWhitespace", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 971 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_FORMATTING_OPTIONS_INSERT_FINAL_NEWLINE_PROPERTY, lsp_formatting_options_properties[LSP_FORMATTING_OPTIONS_INSERT_FINAL_NEWLINE_PROPERTY] = g_param_spec_boolean ("insertFinalNewline", "insertFinalNewline", "insertFinalNewline", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 971 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_FORMATTING_OPTIONS_TRIM_FINAL_NEWLINES_PROPERTY, lsp_formatting_options_properties[LSP_FORMATTING_OPTIONS_TRIM_FINAL_NEWLINES_PROPERTY] = g_param_spec_boolean ("trimFinalNewlines", "trimFinalNewlines", "trimFinalNewlines", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 16786 "protocol.c"
}

static void
lsp_formatting_options_instance_init (LspFormattingOptions * self,
                                      gpointer klass)
{
#line 971 "../src/protocol.vala"
	self->priv = lsp_formatting_options_get_instance_private (self);
#line 16795 "protocol.c"
}

static void
lsp_formatting_options_finalize (GObject * obj)
{
	LspFormattingOptions * self;
#line 971 "../src/protocol.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, LSP_TYPE_FORMATTING_OPTIONS, LspFormattingOptions);
#line 971 "../src/protocol.vala"
	G_OBJECT_CLASS (lsp_formatting_options_parent_class)->finalize (obj);
#line 16806 "protocol.c"
}

 G_GNUC_NO_INLINE static GType
lsp_formatting_options_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (LspFormattingOptionsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) lsp_formatting_options_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LspFormattingOptions), 0, (GInstanceInitFunc) lsp_formatting_options_instance_init, NULL };
	GType lsp_formatting_options_type_id;
	lsp_formatting_options_type_id = g_type_register_static (G_TYPE_OBJECT, "LspFormattingOptions", &g_define_type_info, 0);
	LspFormattingOptions_private_offset = g_type_add_instance_private (lsp_formatting_options_type_id, sizeof (LspFormattingOptionsPrivate));
	return lsp_formatting_options_type_id;
}

GType
lsp_formatting_options_get_type (void)
{
	static gsize lsp_formatting_options_type_id__once = 0;
	if (g_once_init_enter (&lsp_formatting_options_type_id__once)) {
		GType lsp_formatting_options_type_id;
		lsp_formatting_options_type_id = lsp_formatting_options_get_type_once ();
		g_once_init_leave (&lsp_formatting_options_type_id__once, lsp_formatting_options_type_id);
	}
	return lsp_formatting_options_type_id__once;
}

static void
_vala_lsp_formatting_options_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec)
{
	LspFormattingOptions * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_FORMATTING_OPTIONS, LspFormattingOptions);
#line 971 "../src/protocol.vala"
	switch (property_id) {
#line 971 "../src/protocol.vala"
		case LSP_FORMATTING_OPTIONS_TAB_SIZE_PROPERTY:
#line 971 "../src/protocol.vala"
		g_value_set_uint (value, lsp_formatting_options_get_tabSize (self));
#line 971 "../src/protocol.vala"
		break;
#line 971 "../src/protocol.vala"
		case LSP_FORMATTING_OPTIONS_INSERT_SPACES_PROPERTY:
#line 971 "../src/protocol.vala"
		g_value_set_boolean (value, lsp_formatting_options_get_insertSpaces (self));
#line 971 "../src/protocol.vala"
		break;
#line 971 "../src/protocol.vala"
		case LSP_FORMATTING_OPTIONS_TRIM_TRAILING_WHITESPACE_PROPERTY:
#line 971 "../src/protocol.vala"
		g_value_set_boolean (value, lsp_formatting_options_get_trimTrailingWhitespace (self));
#line 971 "../src/protocol.vala"
		break;
#line 971 "../src/protocol.vala"
		case LSP_FORMATTING_OPTIONS_INSERT_FINAL_NEWLINE_PROPERTY:
#line 971 "../src/protocol.vala"
		g_value_set_boolean (value, lsp_formatting_options_get_insertFinalNewline (self));
#line 971 "../src/protocol.vala"
		break;
#line 971 "../src/protocol.vala"
		case LSP_FORMATTING_OPTIONS_TRIM_FINAL_NEWLINES_PROPERTY:
#line 971 "../src/protocol.vala"
		g_value_set_boolean (value, lsp_formatting_options_get_trimFinalNewlines (self));
#line 971 "../src/protocol.vala"
		break;
#line 16871 "protocol.c"
		default:
#line 971 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 971 "../src/protocol.vala"
		break;
#line 16877 "protocol.c"
	}
}

static void
_vala_lsp_formatting_options_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec)
{
	LspFormattingOptions * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_FORMATTING_OPTIONS, LspFormattingOptions);
#line 971 "../src/protocol.vala"
	switch (property_id) {
#line 971 "../src/protocol.vala"
		case LSP_FORMATTING_OPTIONS_TAB_SIZE_PROPERTY:
#line 971 "../src/protocol.vala"
		lsp_formatting_options_set_tabSize (self, g_value_get_uint (value));
#line 971 "../src/protocol.vala"
		break;
#line 971 "../src/protocol.vala"
		case LSP_FORMATTING_OPTIONS_INSERT_SPACES_PROPERTY:
#line 971 "../src/protocol.vala"
		lsp_formatting_options_set_insertSpaces (self, g_value_get_boolean (value));
#line 971 "../src/protocol.vala"
		break;
#line 971 "../src/protocol.vala"
		case LSP_FORMATTING_OPTIONS_TRIM_TRAILING_WHITESPACE_PROPERTY:
#line 971 "../src/protocol.vala"
		lsp_formatting_options_set_trimTrailingWhitespace (self, g_value_get_boolean (value));
#line 971 "../src/protocol.vala"
		break;
#line 971 "../src/protocol.vala"
		case LSP_FORMATTING_OPTIONS_INSERT_FINAL_NEWLINE_PROPERTY:
#line 971 "../src/protocol.vala"
		lsp_formatting_options_set_insertFinalNewline (self, g_value_get_boolean (value));
#line 971 "../src/protocol.vala"
		break;
#line 971 "../src/protocol.vala"
		case LSP_FORMATTING_OPTIONS_TRIM_FINAL_NEWLINES_PROPERTY:
#line 971 "../src/protocol.vala"
		lsp_formatting_options_set_trimFinalNewlines (self, g_value_get_boolean (value));
#line 971 "../src/protocol.vala"
		break;
#line 16921 "protocol.c"
		default:
#line 971 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 971 "../src/protocol.vala"
		break;
#line 16927 "protocol.c"
	}
}

static inline gpointer
lsp_code_action_params_get_instance_private (LspCodeActionParams* self)
{
	return G_STRUCT_MEMBER_P (self, LspCodeActionParams_private_offset);
}

LspCodeActionParams*
lsp_code_action_params_construct (GType object_type)
{
	LspCodeActionParams * self = NULL;
#line 979 "../src/protocol.vala"
	self = (LspCodeActionParams*) g_object_new (object_type, NULL);
#line 979 "../src/protocol.vala"
	return self;
#line 16945 "protocol.c"
}

LspCodeActionParams*
lsp_code_action_params_new (void)
{
#line 979 "../src/protocol.vala"
	return lsp_code_action_params_construct (LSP_TYPE_CODE_ACTION_PARAMS);
#line 16953 "protocol.c"
}

LspTextDocumentIdentifier*
lsp_code_action_params_get_textDocument (LspCodeActionParams* self)
{
	LspTextDocumentIdentifier* result;
	LspTextDocumentIdentifier* _tmp0_;
#line 980 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 980 "../src/protocol.vala"
	_tmp0_ = self->priv->_textDocument;
#line 980 "../src/protocol.vala"
	result = _tmp0_;
#line 980 "../src/protocol.vala"
	return result;
#line 16969 "protocol.c"
}

void
lsp_code_action_params_set_textDocument (LspCodeActionParams* self,
                                         LspTextDocumentIdentifier* value)
{
	LspTextDocumentIdentifier* old_value;
#line 980 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 980 "../src/protocol.vala"
	old_value = lsp_code_action_params_get_textDocument (self);
#line 980 "../src/protocol.vala"
	if (old_value != value) {
#line 16983 "protocol.c"
		LspTextDocumentIdentifier* _tmp0_;
#line 980 "../src/protocol.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 980 "../src/protocol.vala"
		_g_object_unref0 (self->priv->_textDocument);
#line 980 "../src/protocol.vala"
		self->priv->_textDocument = _tmp0_;
#line 980 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_code_action_params_properties[LSP_CODE_ACTION_PARAMS_TEXT_DOCUMENT_PROPERTY]);
#line 16993 "protocol.c"
	}
}

LspRange*
lsp_code_action_params_get_range (LspCodeActionParams* self)
{
	LspRange* result;
	LspRange* _tmp0_;
#line 981 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 981 "../src/protocol.vala"
	_tmp0_ = self->priv->_range;
#line 981 "../src/protocol.vala"
	result = _tmp0_;
#line 981 "../src/protocol.vala"
	return result;
#line 17010 "protocol.c"
}

void
lsp_code_action_params_set_range (LspCodeActionParams* self,
                                  LspRange* value)
{
	LspRange* old_value;
#line 981 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 981 "../src/protocol.vala"
	old_value = lsp_code_action_params_get_range (self);
#line 981 "../src/protocol.vala"
	if (old_value != value) {
#line 17024 "protocol.c"
		LspRange* _tmp0_;
#line 981 "../src/protocol.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 981 "../src/protocol.vala"
		_g_object_unref0 (self->priv->_range);
#line 981 "../src/protocol.vala"
		self->priv->_range = _tmp0_;
#line 981 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_code_action_params_properties[LSP_CODE_ACTION_PARAMS_RANGE_PROPERTY]);
#line 17034 "protocol.c"
	}
}

LspCodeActionContext*
lsp_code_action_params_get_context (LspCodeActionParams* self)
{
	LspCodeActionContext* result;
	LspCodeActionContext* _tmp0_;
#line 982 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 982 "../src/protocol.vala"
	_tmp0_ = self->priv->_context;
#line 982 "../src/protocol.vala"
	result = _tmp0_;
#line 982 "../src/protocol.vala"
	return result;
#line 17051 "protocol.c"
}

void
lsp_code_action_params_set_context (LspCodeActionParams* self,
                                    LspCodeActionContext* value)
{
	LspCodeActionContext* old_value;
#line 982 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 982 "../src/protocol.vala"
	old_value = lsp_code_action_params_get_context (self);
#line 982 "../src/protocol.vala"
	if (old_value != value) {
#line 17065 "protocol.c"
		LspCodeActionContext* _tmp0_;
#line 982 "../src/protocol.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 982 "../src/protocol.vala"
		_g_object_unref0 (self->priv->_context);
#line 982 "../src/protocol.vala"
		self->priv->_context = _tmp0_;
#line 982 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_code_action_params_properties[LSP_CODE_ACTION_PARAMS_CONTEXT_PROPERTY]);
#line 17075 "protocol.c"
	}
}

static void
lsp_code_action_params_class_init (LspCodeActionParamsClass * klass,
                                   gpointer klass_data)
{
#line 979 "../src/protocol.vala"
	lsp_code_action_params_parent_class = g_type_class_peek_parent (klass);
#line 979 "../src/protocol.vala"
	g_type_class_adjust_private_offset (klass, &LspCodeActionParams_private_offset);
#line 979 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_lsp_code_action_params_get_property;
#line 979 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_lsp_code_action_params_set_property;
#line 979 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->finalize = lsp_code_action_params_finalize;
#line 979 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_CODE_ACTION_PARAMS_TEXT_DOCUMENT_PROPERTY, lsp_code_action_params_properties[LSP_CODE_ACTION_PARAMS_TEXT_DOCUMENT_PROPERTY] = g_param_spec_object ("textDocument", "textDocument", "textDocument", LSP_TYPE_TEXT_DOCUMENT_IDENTIFIER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 979 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_CODE_ACTION_PARAMS_RANGE_PROPERTY, lsp_code_action_params_properties[LSP_CODE_ACTION_PARAMS_RANGE_PROPERTY] = g_param_spec_object ("range", "range", "range", LSP_TYPE_RANGE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 979 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_CODE_ACTION_PARAMS_CONTEXT_PROPERTY, lsp_code_action_params_properties[LSP_CODE_ACTION_PARAMS_CONTEXT_PROPERTY] = g_param_spec_object ("context", "context", "context", LSP_TYPE_CODE_ACTION_CONTEXT, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 17099 "protocol.c"
}

static void
lsp_code_action_params_instance_init (LspCodeActionParams * self,
                                      gpointer klass)
{
#line 979 "../src/protocol.vala"
	self->priv = lsp_code_action_params_get_instance_private (self);
#line 17108 "protocol.c"
}

static void
lsp_code_action_params_finalize (GObject * obj)
{
	LspCodeActionParams * self;
#line 979 "../src/protocol.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, LSP_TYPE_CODE_ACTION_PARAMS, LspCodeActionParams);
#line 980 "../src/protocol.vala"
	_g_object_unref0 (self->priv->_textDocument);
#line 981 "../src/protocol.vala"
	_g_object_unref0 (self->priv->_range);
#line 982 "../src/protocol.vala"
	_g_object_unref0 (self->priv->_context);
#line 979 "../src/protocol.vala"
	G_OBJECT_CLASS (lsp_code_action_params_parent_class)->finalize (obj);
#line 17125 "protocol.c"
}

 G_GNUC_NO_INLINE static GType
lsp_code_action_params_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (LspCodeActionParamsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) lsp_code_action_params_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LspCodeActionParams), 0, (GInstanceInitFunc) lsp_code_action_params_instance_init, NULL };
	GType lsp_code_action_params_type_id;
	lsp_code_action_params_type_id = g_type_register_static (G_TYPE_OBJECT, "LspCodeActionParams", &g_define_type_info, 0);
	LspCodeActionParams_private_offset = g_type_add_instance_private (lsp_code_action_params_type_id, sizeof (LspCodeActionParamsPrivate));
	return lsp_code_action_params_type_id;
}

GType
lsp_code_action_params_get_type (void)
{
	static gsize lsp_code_action_params_type_id__once = 0;
	if (g_once_init_enter (&lsp_code_action_params_type_id__once)) {
		GType lsp_code_action_params_type_id;
		lsp_code_action_params_type_id = lsp_code_action_params_get_type_once ();
		g_once_init_leave (&lsp_code_action_params_type_id__once, lsp_code_action_params_type_id);
	}
	return lsp_code_action_params_type_id__once;
}

static void
_vala_lsp_code_action_params_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec)
{
	LspCodeActionParams * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_CODE_ACTION_PARAMS, LspCodeActionParams);
#line 979 "../src/protocol.vala"
	switch (property_id) {
#line 979 "../src/protocol.vala"
		case LSP_CODE_ACTION_PARAMS_TEXT_DOCUMENT_PROPERTY:
#line 979 "../src/protocol.vala"
		g_value_set_object (value, lsp_code_action_params_get_textDocument (self));
#line 979 "../src/protocol.vala"
		break;
#line 979 "../src/protocol.vala"
		case LSP_CODE_ACTION_PARAMS_RANGE_PROPERTY:
#line 979 "../src/protocol.vala"
		g_value_set_object (value, lsp_code_action_params_get_range (self));
#line 979 "../src/protocol.vala"
		break;
#line 979 "../src/protocol.vala"
		case LSP_CODE_ACTION_PARAMS_CONTEXT_PROPERTY:
#line 979 "../src/protocol.vala"
		g_value_set_object (value, lsp_code_action_params_get_context (self));
#line 979 "../src/protocol.vala"
		break;
#line 17178 "protocol.c"
		default:
#line 979 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 979 "../src/protocol.vala"
		break;
#line 17184 "protocol.c"
	}
}

static void
_vala_lsp_code_action_params_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec)
{
	LspCodeActionParams * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_CODE_ACTION_PARAMS, LspCodeActionParams);
#line 979 "../src/protocol.vala"
	switch (property_id) {
#line 979 "../src/protocol.vala"
		case LSP_CODE_ACTION_PARAMS_TEXT_DOCUMENT_PROPERTY:
#line 979 "../src/protocol.vala"
		lsp_code_action_params_set_textDocument (self, g_value_get_object (value));
#line 979 "../src/protocol.vala"
		break;
#line 979 "../src/protocol.vala"
		case LSP_CODE_ACTION_PARAMS_RANGE_PROPERTY:
#line 979 "../src/protocol.vala"
		lsp_code_action_params_set_range (self, g_value_get_object (value));
#line 979 "../src/protocol.vala"
		break;
#line 979 "../src/protocol.vala"
		case LSP_CODE_ACTION_PARAMS_CONTEXT_PROPERTY:
#line 979 "../src/protocol.vala"
		lsp_code_action_params_set_context (self, g_value_get_object (value));
#line 979 "../src/protocol.vala"
		break;
#line 17216 "protocol.c"
		default:
#line 979 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 979 "../src/protocol.vala"
		break;
#line 17222 "protocol.c"
	}
}

static inline gpointer
lsp_code_action_context_get_instance_private (LspCodeActionContext* self)
{
	return G_STRUCT_MEMBER_P (self, LspCodeActionContext_private_offset);
}

static Block28Data*
block28_data_ref (Block28Data* _data28_)
{
#line 989 "../src/protocol.vala"
	g_atomic_int_inc (&_data28_->_ref_count_);
#line 989 "../src/protocol.vala"
	return _data28_;
#line 17239 "protocol.c"
}

static void
block28_data_unref (void * _userdata_)
{
	Block28Data* _data28_;
	_data28_ = (Block28Data*) _userdata_;
#line 989 "../src/protocol.vala"
	if (g_atomic_int_dec_and_test (&_data28_->_ref_count_)) {
#line 17249 "protocol.c"
		LspCodeActionContext* self;
#line 989 "../src/protocol.vala"
		self = _data28_->self;
#line 989 "../src/protocol.vala"
		_g_object_unref0 (_data28_->diags);
#line 989 "../src/protocol.vala"
		_g_object_unref0 (self);
#line 989 "../src/protocol.vala"
		g_slice_free (Block28Data, _data28_);
#line 17259 "protocol.c"
	}
}

static void
__lambda8_ (Block28Data* _data28_,
            JsonArray* array,
            guint index,
            JsonNode* element)
{
	LspCodeActionContext* self;
	GError* _inner_error0_ = NULL;
#line 993 "../src/protocol.vala"
	self = _data28_->self;
#line 993 "../src/protocol.vala"
	g_return_if_fail (array != NULL);
#line 993 "../src/protocol.vala"
	g_return_if_fail (element != NULL);
#line 17277 "protocol.c"
	{
		GVariant* _tmp0_ = NULL;
		GVariant* _tmp1_;
		GeeArrayList* _tmp2_;
		gpointer _tmp3_;
		LspDiagnostic* _tmp4_;
#line 995 "../src/protocol.vala"
		_tmp1_ = json_gvariant_deserialize (element, NULL, &_inner_error0_);
#line 995 "../src/protocol.vala"
		_tmp0_ = _tmp1_;
#line 995 "../src/protocol.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 17290 "protocol.c"
			goto __catch0_g_error;
		}
#line 995 "../src/protocol.vala"
		_tmp2_ = _data28_->diags;
#line 995 "../src/protocol.vala"
		_tmp3_ = vls_util_parse_variant (LSP_TYPE_DIAGNOSTIC, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _tmp0_);
#line 995 "../src/protocol.vala"
		_tmp4_ = (LspDiagnostic*) _tmp3_;
#line 995 "../src/protocol.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp2_, _tmp4_);
#line 995 "../src/protocol.vala"
		_g_object_unref0 (_tmp4_);
#line 994 "../src/protocol.vala"
		_g_variant_unref0 (_tmp0_);
#line 17305 "protocol.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp5_;
		const gchar* _tmp6_;
#line 994 "../src/protocol.vala"
		e = _inner_error0_;
#line 994 "../src/protocol.vala"
		_inner_error0_ = NULL;
#line 997 "../src/protocol.vala"
		_tmp5_ = e;
#line 997 "../src/protocol.vala"
		_tmp6_ = _tmp5_->message;
#line 997 "../src/protocol.vala"
		g_warning ("protocol.vala:997: argument %u could not be deserialized: %s", index, _tmp6_);
#line 994 "../src/protocol.vala"
		_g_error_free0 (e);
#line 17325 "protocol.c"
	}
	__finally0:
#line 994 "../src/protocol.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 994 "../src/protocol.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 994 "../src/protocol.vala"
		g_clear_error (&_inner_error0_);
#line 994 "../src/protocol.vala"
		return;
#line 17336 "protocol.c"
	}
}

static void
___lambda8__json_array_foreach (JsonArray* array,
                                guint index_,
                                JsonNode* element_node,
                                gpointer self)
{
#line 993 "../src/protocol.vala"
	__lambda8_ (self, array, index_, element_node);
#line 17348 "protocol.c"
}

static gboolean
lsp_code_action_context_real_deserialize_property (JsonSerializable* base,
                                                   const gchar* property_name,
                                                   GValue* value,
                                                   GParamSpec* pspec,
                                                   JsonNode* property_node)
{
	LspCodeActionContext * self;
	GValue _vala_value = {0};
	Block28Data* _data28_;
	GeeArrayList* _tmp2_;
	JsonArray* _tmp3_;
	GeeArrayList* _tmp4_;
	GValue _tmp5_ = {0};
	gboolean result;
#line 989 "../src/protocol.vala"
	self = (LspCodeActionContext*) base;
#line 989 "../src/protocol.vala"
	g_return_val_if_fail (property_name != NULL, FALSE);
#line 989 "../src/protocol.vala"
	g_return_val_if_fail (pspec != NULL, FALSE);
#line 989 "../src/protocol.vala"
	g_return_val_if_fail (property_node != NULL, FALSE);
#line 989 "../src/protocol.vala"
	_data28_ = g_slice_new0 (Block28Data);
#line 989 "../src/protocol.vala"
	_data28_->_ref_count_ = 1;
#line 989 "../src/protocol.vala"
	_data28_->self = g_object_ref (self);
#line 990 "../src/protocol.vala"
	if (g_strcmp0 (property_name, "diagnostics") != 0) {
#line 17382 "protocol.c"
		GValue _tmp0_ = {0};
		gboolean _tmp1_;
#line 991 "../src/protocol.vala"
		_tmp1_ = json_serializable_default_deserialize_property ((JsonSerializable*) self, property_name, &_tmp0_, pspec, property_node);
#line 991 "../src/protocol.vala"
		G_IS_VALUE (&_vala_value) ? (g_value_unset (&_vala_value), NULL) : NULL;
#line 991 "../src/protocol.vala"
		_vala_value = _tmp0_;
#line 991 "../src/protocol.vala"
		result = _tmp1_;
#line 991 "../src/protocol.vala"
		block28_data_unref (_data28_);
#line 991 "../src/protocol.vala"
		_data28_ = NULL;
#line 991 "../src/protocol.vala"
		if (value) {
#line 991 "../src/protocol.vala"
			*value = _vala_value;
#line 17401 "protocol.c"
		} else {
#line 991 "../src/protocol.vala"
			G_IS_VALUE (&_vala_value) ? (g_value_unset (&_vala_value), NULL) : NULL;
#line 17405 "protocol.c"
		}
#line 991 "../src/protocol.vala"
		return result;
#line 17409 "protocol.c"
	}
#line 992 "../src/protocol.vala"
	_tmp2_ = gee_array_list_new (LSP_TYPE_DIAGNOSTIC, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 992 "../src/protocol.vala"
	if (_tmp2_) {
#line 992 "../src/protocol.vala"
		g_object_set_data ((GObject *) _tmp2_, "vala-creation-function", "Lsp.CodeActionContext.deserialize_property");
#line 17417 "protocol.c"
	}
#line 992 "../src/protocol.vala"
	_data28_->diags = _tmp2_;
#line 993 "../src/protocol.vala"
	_tmp3_ = json_node_get_array (property_node);
#line 993 "../src/protocol.vala"
	json_array_foreach_element (_tmp3_, ___lambda8__json_array_foreach, _data28_);
#line 1000 "../src/protocol.vala"
	_tmp4_ = _data28_->diags;
#line 1000 "../src/protocol.vala"
	g_value_init (&_tmp5_, GEE_TYPE_ARRAY_LIST);
#line 1000 "../src/protocol.vala"
	g_value_set_object (&_tmp5_, _tmp4_);
#line 1000 "../src/protocol.vala"
	G_IS_VALUE (&_vala_value) ? (g_value_unset (&_vala_value), NULL) : NULL;
#line 1000 "../src/protocol.vala"
	_vala_value = _tmp5_;
#line 1001 "../src/protocol.vala"
	result = TRUE;
#line 1001 "../src/protocol.vala"
	block28_data_unref (_data28_);
#line 1001 "../src/protocol.vala"
	_data28_ = NULL;
#line 1001 "../src/protocol.vala"
	if (value) {
#line 1001 "../src/protocol.vala"
		*value = _vala_value;
#line 17445 "protocol.c"
	} else {
#line 1001 "../src/protocol.vala"
		G_IS_VALUE (&_vala_value) ? (g_value_unset (&_vala_value), NULL) : NULL;
#line 17449 "protocol.c"
	}
#line 1001 "../src/protocol.vala"
	return result;
#line 17453 "protocol.c"
}

LspCodeActionContext*
lsp_code_action_context_construct (GType object_type)
{
	LspCodeActionContext * self = NULL;
#line 985 "../src/protocol.vala"
	self = (LspCodeActionContext*) g_object_new (object_type, NULL);
#line 985 "../src/protocol.vala"
	return self;
#line 17464 "protocol.c"
}

LspCodeActionContext*
lsp_code_action_context_new (void)
{
#line 985 "../src/protocol.vala"
	return lsp_code_action_context_construct (LSP_TYPE_CODE_ACTION_CONTEXT);
#line 17472 "protocol.c"
}

GeeList*
lsp_code_action_context_get_diagnostics (LspCodeActionContext* self)
{
	GeeList* result;
	GeeList* _tmp0_;
#line 986 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 986 "../src/protocol.vala"
	_tmp0_ = self->priv->_diagnostics;
#line 986 "../src/protocol.vala"
	result = _tmp0_;
#line 986 "../src/protocol.vala"
	return result;
#line 17488 "protocol.c"
}

void
lsp_code_action_context_set_diagnostics (LspCodeActionContext* self,
                                         GeeList* value)
{
	GeeList* old_value;
#line 986 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 986 "../src/protocol.vala"
	old_value = lsp_code_action_context_get_diagnostics (self);
#line 986 "../src/protocol.vala"
	if (old_value != value) {
#line 17502 "protocol.c"
		GeeList* _tmp0_;
#line 986 "../src/protocol.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 986 "../src/protocol.vala"
		_g_object_unref0 (self->priv->_diagnostics);
#line 986 "../src/protocol.vala"
		self->priv->_diagnostics = _tmp0_;
#line 986 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_code_action_context_properties[LSP_CODE_ACTION_CONTEXT_DIAGNOSTICS_PROPERTY]);
#line 17512 "protocol.c"
	}
}

gchar**
lsp_code_action_context_get_only (LspCodeActionContext* self,
                                  gint* result_length1)
{
	gchar** result;
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar** _tmp1_;
	gint _tmp1__length1;
#line 987 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 987 "../src/protocol.vala"
	_tmp0_ = self->priv->_only;
#line 987 "../src/protocol.vala"
	_tmp0__length1 = self->priv->_only_length1;
#line 987 "../src/protocol.vala"
	_tmp1_ = _tmp0_;
#line 987 "../src/protocol.vala"
	_tmp1__length1 = _tmp0__length1;
#line 987 "../src/protocol.vala"
	if (result_length1) {
#line 987 "../src/protocol.vala"
		*result_length1 = _tmp1__length1;
#line 17539 "protocol.c"
	}
#line 987 "../src/protocol.vala"
	result = _tmp1_;
#line 987 "../src/protocol.vala"
	return result;
#line 17545 "protocol.c"
}

static gchar**
_vala_array_dup12 (gchar** self,
                   gssize length)
{
#line 987 "../src/protocol.vala"
	if (length >= 0) {
#line 17554 "protocol.c"
		gchar** result;
		gssize i;
#line 987 "../src/protocol.vala"
		result = g_new0 (gchar*, length + 1);
#line 987 "../src/protocol.vala"
		for (i = 0; i < length; i++) {
#line 17561 "protocol.c"
			gchar* _tmp0_;
#line 987 "../src/protocol.vala"
			_tmp0_ = g_strdup (self[i]);
#line 987 "../src/protocol.vala"
			result[i] = _tmp0_;
#line 17567 "protocol.c"
		}
#line 987 "../src/protocol.vala"
		return result;
#line 17571 "protocol.c"
	}
#line 987 "../src/protocol.vala"
	return NULL;
#line 17575 "protocol.c"
}

void
lsp_code_action_context_set_only (LspCodeActionContext* self,
                                  gchar** value,
                                  gint value_length1)
{
	gchar** old_value;
	gint old_value_length;
#line 987 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 987 "../src/protocol.vala"
	old_value = lsp_code_action_context_get_only (self, &old_value_length);
#line 987 "../src/protocol.vala"
	if (old_value != value) {
#line 17591 "protocol.c"
		gchar** _tmp0_;
		gint _tmp0__length1;
#line 987 "../src/protocol.vala"
		_tmp0_ = (value != NULL) ? _vala_array_dup12 (value, value_length1) : value;
#line 987 "../src/protocol.vala"
		_tmp0__length1 = value_length1;
#line 987 "../src/protocol.vala"
		self->priv->_only = (_vala_array_free (self->priv->_only, self->priv->_only_length1, (GDestroyNotify) g_free), NULL);
#line 987 "../src/protocol.vala"
		self->priv->_only = _tmp0_;
#line 987 "../src/protocol.vala"
		self->priv->_only_length1 = _tmp0__length1;
#line 987 "../src/protocol.vala"
		self->priv->__only_size_ = self->priv->_only_length1;
#line 987 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_code_action_context_properties[LSP_CODE_ACTION_CONTEXT_ONLY_PROPERTY]);
#line 17608 "protocol.c"
	}
}

static void
lsp_code_action_context_class_init (LspCodeActionContextClass * klass,
                                    gpointer klass_data)
{
#line 985 "../src/protocol.vala"
	lsp_code_action_context_parent_class = g_type_class_peek_parent (klass);
#line 985 "../src/protocol.vala"
	g_type_class_adjust_private_offset (klass, &LspCodeActionContext_private_offset);
#line 985 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_lsp_code_action_context_get_property;
#line 985 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_lsp_code_action_context_set_property;
#line 985 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->finalize = lsp_code_action_context_finalize;
#line 985 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_CODE_ACTION_CONTEXT_DIAGNOSTICS_PROPERTY, lsp_code_action_context_properties[LSP_CODE_ACTION_CONTEXT_DIAGNOSTICS_PROPERTY] = g_param_spec_object ("diagnostics", "diagnostics", "diagnostics", GEE_TYPE_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 985 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_CODE_ACTION_CONTEXT_ONLY_PROPERTY, lsp_code_action_context_properties[LSP_CODE_ACTION_CONTEXT_ONLY_PROPERTY] = g_param_spec_boxed ("only", "only", "only", G_TYPE_STRV, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 17630 "protocol.c"
}

static void
lsp_code_action_context_json_serializable_interface_init (JsonSerializableIface * iface,
                                                          gpointer iface_data)
{
#line 985 "../src/protocol.vala"
	lsp_code_action_context_json_serializable_parent_iface = g_type_interface_peek_parent (iface);
#line 985 "../src/protocol.vala"
	iface->deserialize_property = (gboolean (*) (JsonSerializable*, const gchar*, GValue*, GParamSpec*, JsonNode*)) lsp_code_action_context_real_deserialize_property;
#line 17641 "protocol.c"
}

static void
lsp_code_action_context_instance_init (LspCodeActionContext * self,
                                       gpointer klass)
{
	GeeArrayList* _tmp0_;
#line 985 "../src/protocol.vala"
	self->priv = lsp_code_action_context_get_instance_private (self);
#line 986 "../src/protocol.vala"
	_tmp0_ = gee_array_list_new (LSP_TYPE_DIAGNOSTIC, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 986 "../src/protocol.vala"
	if (_tmp0_) {
#line 986 "../src/protocol.vala"
		g_object_set_data ((GObject *) _tmp0_, "vala-creation-function", "");
#line 17657 "protocol.c"
	}
#line 986 "../src/protocol.vala"
	self->priv->_diagnostics = (GeeList*) _tmp0_;
#line 17661 "protocol.c"
}

static void
lsp_code_action_context_finalize (GObject * obj)
{
	LspCodeActionContext * self;
#line 985 "../src/protocol.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, LSP_TYPE_CODE_ACTION_CONTEXT, LspCodeActionContext);
#line 986 "../src/protocol.vala"
	_g_object_unref0 (self->priv->_diagnostics);
#line 987 "../src/protocol.vala"
	self->priv->_only = (_vala_array_free (self->priv->_only, self->priv->_only_length1, (GDestroyNotify) g_free), NULL);
#line 985 "../src/protocol.vala"
	G_OBJECT_CLASS (lsp_code_action_context_parent_class)->finalize (obj);
#line 17676 "protocol.c"
}

 G_GNUC_NO_INLINE static GType
lsp_code_action_context_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (LspCodeActionContextClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) lsp_code_action_context_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LspCodeActionContext), 0, (GInstanceInitFunc) lsp_code_action_context_instance_init, NULL };
	static const GInterfaceInfo json_serializable_info = { (GInterfaceInitFunc) lsp_code_action_context_json_serializable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType lsp_code_action_context_type_id;
	lsp_code_action_context_type_id = g_type_register_static (G_TYPE_OBJECT, "LspCodeActionContext", &g_define_type_info, 0);
	g_type_add_interface_static (lsp_code_action_context_type_id, json_serializable_get_type (), &json_serializable_info);
	LspCodeActionContext_private_offset = g_type_add_instance_private (lsp_code_action_context_type_id, sizeof (LspCodeActionContextPrivate));
	return lsp_code_action_context_type_id;
}

GType
lsp_code_action_context_get_type (void)
{
	static gsize lsp_code_action_context_type_id__once = 0;
	if (g_once_init_enter (&lsp_code_action_context_type_id__once)) {
		GType lsp_code_action_context_type_id;
		lsp_code_action_context_type_id = lsp_code_action_context_get_type_once ();
		g_once_init_leave (&lsp_code_action_context_type_id__once, lsp_code_action_context_type_id);
	}
	return lsp_code_action_context_type_id__once;
}

static void
_vala_lsp_code_action_context_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec)
{
	LspCodeActionContext * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_CODE_ACTION_CONTEXT, LspCodeActionContext);
#line 985 "../src/protocol.vala"
	switch (property_id) {
#line 985 "../src/protocol.vala"
		case LSP_CODE_ACTION_CONTEXT_DIAGNOSTICS_PROPERTY:
#line 985 "../src/protocol.vala"
		g_value_set_object (value, lsp_code_action_context_get_diagnostics (self));
#line 985 "../src/protocol.vala"
		break;
#line 985 "../src/protocol.vala"
		case LSP_CODE_ACTION_CONTEXT_ONLY_PROPERTY:
#line 17721 "protocol.c"
		{
			int length;
#line 985 "../src/protocol.vala"
			g_value_set_boxed (value, lsp_code_action_context_get_only (self, &length));
#line 17726 "protocol.c"
		}
#line 985 "../src/protocol.vala"
		break;
#line 17730 "protocol.c"
		default:
#line 985 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 985 "../src/protocol.vala"
		break;
#line 17736 "protocol.c"
	}
}

static void
_vala_lsp_code_action_context_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec)
{
	LspCodeActionContext * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_CODE_ACTION_CONTEXT, LspCodeActionContext);
#line 985 "../src/protocol.vala"
	switch (property_id) {
#line 985 "../src/protocol.vala"
		case LSP_CODE_ACTION_CONTEXT_DIAGNOSTICS_PROPERTY:
#line 985 "../src/protocol.vala"
		lsp_code_action_context_set_diagnostics (self, g_value_get_object (value));
#line 985 "../src/protocol.vala"
		break;
#line 985 "../src/protocol.vala"
		case LSP_CODE_ACTION_CONTEXT_ONLY_PROPERTY:
#line 17758 "protocol.c"
		{
			gpointer boxed;
#line 985 "../src/protocol.vala"
			boxed = g_value_get_boxed (value);
#line 985 "../src/protocol.vala"
			lsp_code_action_context_set_only (self, boxed, (boxed == NULL) ? 0 : g_strv_length (boxed));
#line 17765 "protocol.c"
		}
#line 985 "../src/protocol.vala"
		break;
#line 17769 "protocol.c"
		default:
#line 985 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 985 "../src/protocol.vala"
		break;
#line 17775 "protocol.c"
	}
}

static inline gpointer
lsp_code_action_get_instance_private (LspCodeAction* self)
{
	return G_STRUCT_MEMBER_P (self, LspCodeAction_private_offset);
}

void
lsp_code_action_add_diagnostic (LspCodeAction* self,
                                LspDiagnostic* diag)
{
	GeeCollection* _tmp0_;
	GeeCollection* _tmp3_;
#line 1014 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 1014 "../src/protocol.vala"
	g_return_if_fail (diag != NULL);
#line 1015 "../src/protocol.vala"
	_tmp0_ = self->priv->_diagnostics;
#line 1015 "../src/protocol.vala"
	if (_tmp0_ == NULL) {
#line 17799 "protocol.c"
		GeeArrayList* _tmp1_;
		GeeArrayList* _tmp2_;
#line 1016 "../src/protocol.vala"
		_tmp1_ = gee_array_list_new (LSP_TYPE_DIAGNOSTIC, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1016 "../src/protocol.vala"
		if (_tmp1_) {
#line 1016 "../src/protocol.vala"
			g_object_set_data ((GObject *) _tmp1_, "vala-creation-function", "Lsp.CodeAction.add_diagnostic");
#line 17808 "protocol.c"
		}
#line 1016 "../src/protocol.vala"
		_tmp2_ = _tmp1_;
#line 1016 "../src/protocol.vala"
		lsp_code_action_set_diagnostics (self, (GeeCollection*) _tmp2_);
#line 1016 "../src/protocol.vala"
		_g_object_unref0 (_tmp2_);
#line 17816 "protocol.c"
	}
#line 1017 "../src/protocol.vala"
	_tmp3_ = self->priv->_diagnostics;
#line 1017 "../src/protocol.vala"
	gee_collection_add (_tmp3_, diag);
#line 17822 "protocol.c"
}

static JsonNode*
lsp_code_action_real_serialize_property (JsonSerializable* base,
                                         const gchar* property_name,
                                         GValue* value,
                                         GParamSpec* pspec)
{
	LspCodeAction * self;
	JsonArray* array = NULL;
	JsonArray* _tmp2_;
	GeeCollection* _tmp3_;
	JsonNode* _tmp12_;
	JsonNode* _tmp13_;
	JsonArray* _tmp14_;
	JsonNode* _tmp15_;
	JsonNode* _tmp16_;
	JsonNode* _tmp17_;
	JsonNode* result;
#line 1020 "../src/protocol.vala"
	self = (LspCodeAction*) base;
#line 1020 "../src/protocol.vala"
	g_return_val_if_fail (property_name != NULL, NULL);
#line 1020 "../src/protocol.vala"
	g_return_val_if_fail (value != NULL, NULL);
#line 1020 "../src/protocol.vala"
	g_return_val_if_fail (pspec != NULL, NULL);
#line 1021 "../src/protocol.vala"
	if (g_strcmp0 (property_name, "diagnostics") != 0) {
#line 17852 "protocol.c"
		GValue _tmp0_;
		JsonNode* _tmp1_;
#line 1022 "../src/protocol.vala"
		_tmp0_ = *value;
#line 1022 "../src/protocol.vala"
		_tmp1_ = json_serializable_default_serialize_property ((JsonSerializable*) self, property_name, &_tmp0_, pspec);
#line 1022 "../src/protocol.vala"
		result = _tmp1_;
#line 1022 "../src/protocol.vala"
		return result;
#line 17863 "protocol.c"
	}
#line 1024 "../src/protocol.vala"
	_tmp2_ = json_array_new ();
#line 1024 "../src/protocol.vala"
	array = _tmp2_;
#line 1025 "../src/protocol.vala"
	_tmp3_ = self->priv->_diagnostics;
#line 1025 "../src/protocol.vala"
	if (_tmp3_ != NULL) {
#line 17873 "protocol.c"
		{
			GeeIterator* _text_edit_it = NULL;
			GeeCollection* _tmp4_;
			GeeIterator* _tmp5_;
#line 1026 "../src/protocol.vala"
			_tmp4_ = self->priv->_diagnostics;
#line 1026 "../src/protocol.vala"
			_tmp5_ = gee_iterable_iterator ((GeeIterable*) _tmp4_);
#line 1026 "../src/protocol.vala"
			_text_edit_it = _tmp5_;
#line 1026 "../src/protocol.vala"
			while (TRUE) {
#line 17886 "protocol.c"
				GeeIterator* _tmp6_;
				LspDiagnostic* text_edit = NULL;
				GeeIterator* _tmp7_;
				gpointer _tmp8_;
				JsonArray* _tmp9_;
				LspDiagnostic* _tmp10_;
				JsonNode* _tmp11_;
#line 1026 "../src/protocol.vala"
				_tmp6_ = _text_edit_it;
#line 1026 "../src/protocol.vala"
				if (!gee_iterator_next (_tmp6_)) {
#line 1026 "../src/protocol.vala"
					break;
#line 17900 "protocol.c"
				}
#line 1026 "../src/protocol.vala"
				_tmp7_ = _text_edit_it;
#line 1026 "../src/protocol.vala"
				_tmp8_ = gee_iterator_get (_tmp7_);
#line 1026 "../src/protocol.vala"
				text_edit = (LspDiagnostic*) _tmp8_;
#line 1027 "../src/protocol.vala"
				_tmp9_ = array;
#line 1027 "../src/protocol.vala"
				_tmp10_ = text_edit;
#line 1027 "../src/protocol.vala"
				_tmp11_ = json_gobject_serialize ((GObject*) _tmp10_);
#line 1027 "../src/protocol.vala"
				json_array_add_element (_tmp9_, _tmp11_);
#line 1026 "../src/protocol.vala"
				_g_object_unref0 (text_edit);
#line 17918 "protocol.c"
			}
#line 1026 "../src/protocol.vala"
			_g_object_unref0 (_text_edit_it);
#line 17922 "protocol.c"
		}
	}
#line 1028 "../src/protocol.vala"
	_tmp12_ = json_node_alloc ();
#line 1028 "../src/protocol.vala"
	_tmp13_ = _tmp12_;
#line 1028 "../src/protocol.vala"
	_tmp14_ = array;
#line 1028 "../src/protocol.vala"
	_tmp15_ = json_node_init_array (_tmp13_, _tmp14_);
#line 1028 "../src/protocol.vala"
	_tmp16_ = __vala_JsonNode_copy0 (_tmp15_);
#line 1028 "../src/protocol.vala"
	_tmp17_ = _tmp16_;
#line 1028 "../src/protocol.vala"
	__vala_JsonNode_free0 (_tmp13_);
#line 1028 "../src/protocol.vala"
	result = _tmp17_;
#line 1028 "../src/protocol.vala"
	_json_array_unref0 (array);
#line 1028 "../src/protocol.vala"
	return result;
#line 17945 "protocol.c"
}

LspCodeAction*
lsp_code_action_construct (GType object_type)
{
	LspCodeAction * self = NULL;
#line 1005 "../src/protocol.vala"
	self = (LspCodeAction*) g_object_new (object_type, NULL);
#line 1005 "../src/protocol.vala"
	return self;
#line 17956 "protocol.c"
}

LspCodeAction*
lsp_code_action_new (void)
{
#line 1005 "../src/protocol.vala"
	return lsp_code_action_construct (LSP_TYPE_CODE_ACTION);
#line 17964 "protocol.c"
}

const gchar*
lsp_code_action_get_title (LspCodeAction* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 1006 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1006 "../src/protocol.vala"
	_tmp0_ = self->priv->_title;
#line 1006 "../src/protocol.vala"
	result = _tmp0_;
#line 1006 "../src/protocol.vala"
	return result;
#line 17980 "protocol.c"
}

void
lsp_code_action_set_title (LspCodeAction* self,
                           const gchar* value)
{
	gchar* old_value;
#line 1006 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 1006 "../src/protocol.vala"
	old_value = lsp_code_action_get_title (self);
#line 1006 "../src/protocol.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 17994 "protocol.c"
		gchar* _tmp0_;
#line 1006 "../src/protocol.vala"
		_tmp0_ = g_strdup (value);
#line 1006 "../src/protocol.vala"
		_g_free0 (self->priv->_title);
#line 1006 "../src/protocol.vala"
		self->priv->_title = _tmp0_;
#line 1006 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_code_action_properties[LSP_CODE_ACTION_TITLE_PROPERTY]);
#line 18004 "protocol.c"
	}
}

const gchar*
lsp_code_action_get_kind (LspCodeAction* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 1007 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1007 "../src/protocol.vala"
	_tmp0_ = self->priv->_kind;
#line 1007 "../src/protocol.vala"
	result = _tmp0_;
#line 1007 "../src/protocol.vala"
	return result;
#line 18021 "protocol.c"
}

void
lsp_code_action_set_kind (LspCodeAction* self,
                          const gchar* value)
{
	gchar* old_value;
#line 1007 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 1007 "../src/protocol.vala"
	old_value = lsp_code_action_get_kind (self);
#line 1007 "../src/protocol.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 18035 "protocol.c"
		gchar* _tmp0_;
#line 1007 "../src/protocol.vala"
		_tmp0_ = g_strdup (value);
#line 1007 "../src/protocol.vala"
		_g_free0 (self->priv->_kind);
#line 1007 "../src/protocol.vala"
		self->priv->_kind = _tmp0_;
#line 1007 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_code_action_properties[LSP_CODE_ACTION_KIND_PROPERTY]);
#line 18045 "protocol.c"
	}
}

GeeCollection*
lsp_code_action_get_diagnostics (LspCodeAction* self)
{
	GeeCollection* result;
	GeeCollection* _tmp0_;
#line 1008 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1008 "../src/protocol.vala"
	_tmp0_ = self->priv->_diagnostics;
#line 1008 "../src/protocol.vala"
	result = _tmp0_;
#line 1008 "../src/protocol.vala"
	return result;
#line 18062 "protocol.c"
}

void
lsp_code_action_set_diagnostics (LspCodeAction* self,
                                 GeeCollection* value)
{
	GeeCollection* old_value;
#line 1008 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 1008 "../src/protocol.vala"
	old_value = lsp_code_action_get_diagnostics (self);
#line 1008 "../src/protocol.vala"
	if (old_value != value) {
#line 18076 "protocol.c"
		GeeCollection* _tmp0_;
#line 1008 "../src/protocol.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 1008 "../src/protocol.vala"
		_g_object_unref0 (self->priv->_diagnostics);
#line 1008 "../src/protocol.vala"
		self->priv->_diagnostics = _tmp0_;
#line 1008 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_code_action_properties[LSP_CODE_ACTION_DIAGNOSTICS_PROPERTY]);
#line 18086 "protocol.c"
	}
}

gboolean
lsp_code_action_get_isPreferred (LspCodeAction* self)
{
	gboolean result;
#line 1009 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1009 "../src/protocol.vala"
	result = self->priv->_isPreferred;
#line 1009 "../src/protocol.vala"
	return result;
#line 18100 "protocol.c"
}

void
lsp_code_action_set_isPreferred (LspCodeAction* self,
                                 gboolean value)
{
	gboolean old_value;
#line 1009 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 1009 "../src/protocol.vala"
	old_value = lsp_code_action_get_isPreferred (self);
#line 1009 "../src/protocol.vala"
	if (old_value != value) {
#line 1009 "../src/protocol.vala"
		self->priv->_isPreferred = value;
#line 1009 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_code_action_properties[LSP_CODE_ACTION_IS_PREFERRED_PROPERTY]);
#line 18118 "protocol.c"
	}
}

LspWorkspaceEdit*
lsp_code_action_get_edit (LspCodeAction* self)
{
	LspWorkspaceEdit* result;
	LspWorkspaceEdit* _tmp0_;
#line 1010 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1010 "../src/protocol.vala"
	_tmp0_ = self->priv->_edit;
#line 1010 "../src/protocol.vala"
	result = _tmp0_;
#line 1010 "../src/protocol.vala"
	return result;
#line 18135 "protocol.c"
}

void
lsp_code_action_set_edit (LspCodeAction* self,
                          LspWorkspaceEdit* value)
{
	LspWorkspaceEdit* old_value;
#line 1010 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 1010 "../src/protocol.vala"
	old_value = lsp_code_action_get_edit (self);
#line 1010 "../src/protocol.vala"
	if (old_value != value) {
#line 18149 "protocol.c"
		LspWorkspaceEdit* _tmp0_;
#line 1010 "../src/protocol.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 1010 "../src/protocol.vala"
		_g_object_unref0 (self->priv->_edit);
#line 1010 "../src/protocol.vala"
		self->priv->_edit = _tmp0_;
#line 1010 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_code_action_properties[LSP_CODE_ACTION_EDIT_PROPERTY]);
#line 18159 "protocol.c"
	}
}

LspCommand*
lsp_code_action_get_command (LspCodeAction* self)
{
	LspCommand* result;
	LspCommand* _tmp0_;
#line 1011 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1011 "../src/protocol.vala"
	_tmp0_ = self->priv->_command;
#line 1011 "../src/protocol.vala"
	result = _tmp0_;
#line 1011 "../src/protocol.vala"
	return result;
#line 18176 "protocol.c"
}

void
lsp_code_action_set_command (LspCodeAction* self,
                             LspCommand* value)
{
	LspCommand* old_value;
#line 1011 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 1011 "../src/protocol.vala"
	old_value = lsp_code_action_get_command (self);
#line 1011 "../src/protocol.vala"
	if (old_value != value) {
#line 18190 "protocol.c"
		LspCommand* _tmp0_;
#line 1011 "../src/protocol.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 1011 "../src/protocol.vala"
		_g_object_unref0 (self->priv->_command);
#line 1011 "../src/protocol.vala"
		self->priv->_command = _tmp0_;
#line 1011 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_code_action_properties[LSP_CODE_ACTION_COMMAND_PROPERTY]);
#line 18200 "protocol.c"
	}
}

GObject*
lsp_code_action_get_data (LspCodeAction* self)
{
	GObject* result;
	GObject* _tmp0_;
#line 1012 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1012 "../src/protocol.vala"
	_tmp0_ = self->priv->_data;
#line 1012 "../src/protocol.vala"
	result = _tmp0_;
#line 1012 "../src/protocol.vala"
	return result;
#line 18217 "protocol.c"
}

void
lsp_code_action_set_data (LspCodeAction* self,
                          GObject* value)
{
	GObject* old_value;
#line 1012 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 1012 "../src/protocol.vala"
	old_value = lsp_code_action_get_data (self);
#line 1012 "../src/protocol.vala"
	if (old_value != value) {
#line 18231 "protocol.c"
		GObject* _tmp0_;
#line 1012 "../src/protocol.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 1012 "../src/protocol.vala"
		_g_object_unref0 (self->priv->_data);
#line 1012 "../src/protocol.vala"
		self->priv->_data = _tmp0_;
#line 1012 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_code_action_properties[LSP_CODE_ACTION_DATA_PROPERTY]);
#line 18241 "protocol.c"
	}
}

static void
lsp_code_action_class_init (LspCodeActionClass * klass,
                            gpointer klass_data)
{
#line 1005 "../src/protocol.vala"
	lsp_code_action_parent_class = g_type_class_peek_parent (klass);
#line 1005 "../src/protocol.vala"
	g_type_class_adjust_private_offset (klass, &LspCodeAction_private_offset);
#line 1005 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_lsp_code_action_get_property;
#line 1005 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_lsp_code_action_set_property;
#line 1005 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->finalize = lsp_code_action_finalize;
#line 1005 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_CODE_ACTION_TITLE_PROPERTY, lsp_code_action_properties[LSP_CODE_ACTION_TITLE_PROPERTY] = g_param_spec_string ("title", "title", "title", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1005 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_CODE_ACTION_KIND_PROPERTY, lsp_code_action_properties[LSP_CODE_ACTION_KIND_PROPERTY] = g_param_spec_string ("kind", "kind", "kind", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1005 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_CODE_ACTION_DIAGNOSTICS_PROPERTY, lsp_code_action_properties[LSP_CODE_ACTION_DIAGNOSTICS_PROPERTY] = g_param_spec_object ("diagnostics", "diagnostics", "diagnostics", GEE_TYPE_COLLECTION, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1005 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_CODE_ACTION_IS_PREFERRED_PROPERTY, lsp_code_action_properties[LSP_CODE_ACTION_IS_PREFERRED_PROPERTY] = g_param_spec_boolean ("isPreferred", "isPreferred", "isPreferred", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1005 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_CODE_ACTION_EDIT_PROPERTY, lsp_code_action_properties[LSP_CODE_ACTION_EDIT_PROPERTY] = g_param_spec_object ("edit", "edit", "edit", LSP_TYPE_WORKSPACE_EDIT, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1005 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_CODE_ACTION_COMMAND_PROPERTY, lsp_code_action_properties[LSP_CODE_ACTION_COMMAND_PROPERTY] = g_param_spec_object ("command", "command", "command", LSP_TYPE_COMMAND, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1005 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_CODE_ACTION_DATA_PROPERTY, lsp_code_action_properties[LSP_CODE_ACTION_DATA_PROPERTY] = g_param_spec_object ("data", "data", "data", G_TYPE_OBJECT, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 18273 "protocol.c"
}

static void
lsp_code_action_json_serializable_interface_init (JsonSerializableIface * iface,
                                                  gpointer iface_data)
{
#line 1005 "../src/protocol.vala"
	lsp_code_action_json_serializable_parent_iface = g_type_interface_peek_parent (iface);
#line 1005 "../src/protocol.vala"
	iface->serialize_property = (JsonNode* (*) (JsonSerializable*, const gchar*, GValue*, GParamSpec*)) lsp_code_action_real_serialize_property;
#line 18284 "protocol.c"
}

static void
lsp_code_action_instance_init (LspCodeAction * self,
                               gpointer klass)
{
#line 1005 "../src/protocol.vala"
	self->priv = lsp_code_action_get_instance_private (self);
#line 18293 "protocol.c"
}

static void
lsp_code_action_finalize (GObject * obj)
{
	LspCodeAction * self;
#line 1005 "../src/protocol.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, LSP_TYPE_CODE_ACTION, LspCodeAction);
#line 1006 "../src/protocol.vala"
	_g_free0 (self->priv->_title);
#line 1007 "../src/protocol.vala"
	_g_free0 (self->priv->_kind);
#line 1008 "../src/protocol.vala"
	_g_object_unref0 (self->priv->_diagnostics);
#line 1010 "../src/protocol.vala"
	_g_object_unref0 (self->priv->_edit);
#line 1011 "../src/protocol.vala"
	_g_object_unref0 (self->priv->_command);
#line 1012 "../src/protocol.vala"
	_g_object_unref0 (self->priv->_data);
#line 1005 "../src/protocol.vala"
	G_OBJECT_CLASS (lsp_code_action_parent_class)->finalize (obj);
#line 18316 "protocol.c"
}

 G_GNUC_NO_INLINE static GType
lsp_code_action_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (LspCodeActionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) lsp_code_action_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LspCodeAction), 0, (GInstanceInitFunc) lsp_code_action_instance_init, NULL };
	static const GInterfaceInfo json_serializable_info = { (GInterfaceInitFunc) lsp_code_action_json_serializable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType lsp_code_action_type_id;
	lsp_code_action_type_id = g_type_register_static (G_TYPE_OBJECT, "LspCodeAction", &g_define_type_info, 0);
	g_type_add_interface_static (lsp_code_action_type_id, json_serializable_get_type (), &json_serializable_info);
	LspCodeAction_private_offset = g_type_add_instance_private (lsp_code_action_type_id, sizeof (LspCodeActionPrivate));
	return lsp_code_action_type_id;
}

GType
lsp_code_action_get_type (void)
{
	static gsize lsp_code_action_type_id__once = 0;
	if (g_once_init_enter (&lsp_code_action_type_id__once)) {
		GType lsp_code_action_type_id;
		lsp_code_action_type_id = lsp_code_action_get_type_once ();
		g_once_init_leave (&lsp_code_action_type_id__once, lsp_code_action_type_id);
	}
	return lsp_code_action_type_id__once;
}

static void
_vala_lsp_code_action_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec)
{
	LspCodeAction * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_CODE_ACTION, LspCodeAction);
#line 1005 "../src/protocol.vala"
	switch (property_id) {
#line 1005 "../src/protocol.vala"
		case LSP_CODE_ACTION_TITLE_PROPERTY:
#line 1005 "../src/protocol.vala"
		g_value_set_string (value, lsp_code_action_get_title (self));
#line 1005 "../src/protocol.vala"
		break;
#line 1005 "../src/protocol.vala"
		case LSP_CODE_ACTION_KIND_PROPERTY:
#line 1005 "../src/protocol.vala"
		g_value_set_string (value, lsp_code_action_get_kind (self));
#line 1005 "../src/protocol.vala"
		break;
#line 1005 "../src/protocol.vala"
		case LSP_CODE_ACTION_DIAGNOSTICS_PROPERTY:
#line 1005 "../src/protocol.vala"
		g_value_set_object (value, lsp_code_action_get_diagnostics (self));
#line 1005 "../src/protocol.vala"
		break;
#line 1005 "../src/protocol.vala"
		case LSP_CODE_ACTION_IS_PREFERRED_PROPERTY:
#line 1005 "../src/protocol.vala"
		g_value_set_boolean (value, lsp_code_action_get_isPreferred (self));
#line 1005 "../src/protocol.vala"
		break;
#line 1005 "../src/protocol.vala"
		case LSP_CODE_ACTION_EDIT_PROPERTY:
#line 1005 "../src/protocol.vala"
		g_value_set_object (value, lsp_code_action_get_edit (self));
#line 1005 "../src/protocol.vala"
		break;
#line 1005 "../src/protocol.vala"
		case LSP_CODE_ACTION_COMMAND_PROPERTY:
#line 1005 "../src/protocol.vala"
		g_value_set_object (value, lsp_code_action_get_command (self));
#line 1005 "../src/protocol.vala"
		break;
#line 1005 "../src/protocol.vala"
		case LSP_CODE_ACTION_DATA_PROPERTY:
#line 1005 "../src/protocol.vala"
		g_value_set_object (value, lsp_code_action_get_data (self));
#line 1005 "../src/protocol.vala"
		break;
#line 18395 "protocol.c"
		default:
#line 1005 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 1005 "../src/protocol.vala"
		break;
#line 18401 "protocol.c"
	}
}

static void
_vala_lsp_code_action_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec)
{
	LspCodeAction * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_CODE_ACTION, LspCodeAction);
#line 1005 "../src/protocol.vala"
	switch (property_id) {
#line 1005 "../src/protocol.vala"
		case LSP_CODE_ACTION_TITLE_PROPERTY:
#line 1005 "../src/protocol.vala"
		lsp_code_action_set_title (self, g_value_get_string (value));
#line 1005 "../src/protocol.vala"
		break;
#line 1005 "../src/protocol.vala"
		case LSP_CODE_ACTION_KIND_PROPERTY:
#line 1005 "../src/protocol.vala"
		lsp_code_action_set_kind (self, g_value_get_string (value));
#line 1005 "../src/protocol.vala"
		break;
#line 1005 "../src/protocol.vala"
		case LSP_CODE_ACTION_DIAGNOSTICS_PROPERTY:
#line 1005 "../src/protocol.vala"
		lsp_code_action_set_diagnostics (self, g_value_get_object (value));
#line 1005 "../src/protocol.vala"
		break;
#line 1005 "../src/protocol.vala"
		case LSP_CODE_ACTION_IS_PREFERRED_PROPERTY:
#line 1005 "../src/protocol.vala"
		lsp_code_action_set_isPreferred (self, g_value_get_boolean (value));
#line 1005 "../src/protocol.vala"
		break;
#line 1005 "../src/protocol.vala"
		case LSP_CODE_ACTION_EDIT_PROPERTY:
#line 1005 "../src/protocol.vala"
		lsp_code_action_set_edit (self, g_value_get_object (value));
#line 1005 "../src/protocol.vala"
		break;
#line 1005 "../src/protocol.vala"
		case LSP_CODE_ACTION_COMMAND_PROPERTY:
#line 1005 "../src/protocol.vala"
		lsp_code_action_set_command (self, g_value_get_object (value));
#line 1005 "../src/protocol.vala"
		break;
#line 1005 "../src/protocol.vala"
		case LSP_CODE_ACTION_DATA_PROPERTY:
#line 1005 "../src/protocol.vala"
		lsp_code_action_set_data (self, g_value_get_object (value));
#line 1005 "../src/protocol.vala"
		break;
#line 18457 "protocol.c"
		default:
#line 1005 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 1005 "../src/protocol.vala"
		break;
#line 18463 "protocol.c"
	}
}

static inline gpointer
lsp_workspace_edit_get_instance_private (LspWorkspaceEdit* self)
{
	return G_STRUCT_MEMBER_P (self, LspWorkspaceEdit_private_offset);
}

static JsonNode*
lsp_workspace_edit_real_serialize_property (JsonSerializable* base,
                                            const gchar* property_name,
                                            GValue* value,
                                            GParamSpec* pspec)
{
	LspWorkspaceEdit * self;
	JsonNode* node = NULL;
	JsonNode* _tmp2_;
	JsonNode* _tmp3_;
	JsonArray* _tmp4_;
	JsonArray* _tmp5_;
	GeeList* _tmp6_;
	JsonNode* result;
#line 1035 "../src/protocol.vala"
	self = (LspWorkspaceEdit*) base;
#line 1035 "../src/protocol.vala"
	g_return_val_if_fail (property_name != NULL, NULL);
#line 1035 "../src/protocol.vala"
	g_return_val_if_fail (value != NULL, NULL);
#line 1035 "../src/protocol.vala"
	g_return_val_if_fail (pspec != NULL, NULL);
#line 1036 "../src/protocol.vala"
	if (g_strcmp0 (property_name, "documentChanges") != 0) {
#line 18497 "protocol.c"
		GValue _tmp0_;
		JsonNode* _tmp1_;
#line 1037 "../src/protocol.vala"
		_tmp0_ = *value;
#line 1037 "../src/protocol.vala"
		_tmp1_ = json_serializable_default_serialize_property ((JsonSerializable*) self, property_name, &_tmp0_, pspec);
#line 1037 "../src/protocol.vala"
		result = _tmp1_;
#line 1037 "../src/protocol.vala"
		return result;
#line 18508 "protocol.c"
	}
#line 1039 "../src/protocol.vala"
	_tmp2_ = json_node_new (JSON_NODE_ARRAY);
#line 1039 "../src/protocol.vala"
	node = _tmp2_;
#line 1040 "../src/protocol.vala"
	_tmp3_ = node;
#line 1040 "../src/protocol.vala"
	_tmp4_ = json_array_new ();
#line 1040 "../src/protocol.vala"
	_tmp5_ = _tmp4_;
#line 1040 "../src/protocol.vala"
	json_node_init_array (_tmp3_, _tmp5_);
#line 1040 "../src/protocol.vala"
	_json_array_unref0 (_tmp5_);
#line 1041 "../src/protocol.vala"
	_tmp6_ = self->priv->_documentChanges;
#line 1041 "../src/protocol.vala"
	if (_tmp6_ != NULL) {
#line 18528 "protocol.c"
		JsonArray* array = NULL;
		JsonNode* _tmp7_;
		JsonArray* _tmp8_;
		JsonArray* _tmp9_;
#line 1042 "../src/protocol.vala"
		_tmp7_ = node;
#line 1042 "../src/protocol.vala"
		_tmp8_ = json_node_get_array (_tmp7_);
#line 1042 "../src/protocol.vala"
		_tmp9_ = _json_array_ref0 (_tmp8_);
#line 1042 "../src/protocol.vala"
		array = _tmp9_;
#line 18541 "protocol.c"
		{
			GeeList* _text_edit_list = NULL;
			GeeList* _tmp10_;
			gint _text_edit_size = 0;
			GeeList* _tmp11_;
			gint _tmp12_;
			gint _tmp13_;
			gint _text_edit_index = 0;
#line 1043 "../src/protocol.vala"
			_tmp10_ = self->priv->_documentChanges;
#line 1043 "../src/protocol.vala"
			_text_edit_list = _tmp10_;
#line 1043 "../src/protocol.vala"
			_tmp11_ = _text_edit_list;
#line 1043 "../src/protocol.vala"
			_tmp12_ = gee_collection_get_size ((GeeCollection*) _tmp11_);
#line 1043 "../src/protocol.vala"
			_tmp13_ = _tmp12_;
#line 1043 "../src/protocol.vala"
			_text_edit_size = _tmp13_;
#line 1043 "../src/protocol.vala"
			_text_edit_index = -1;
#line 1043 "../src/protocol.vala"
			while (TRUE) {
#line 18566 "protocol.c"
				gint _tmp14_;
				gint _tmp15_;
				LspTextDocumentEdit* text_edit = NULL;
				GeeList* _tmp16_;
				gpointer _tmp17_;
				JsonArray* _tmp18_;
				LspTextDocumentEdit* _tmp19_;
				JsonNode* _tmp20_;
#line 1043 "../src/protocol.vala"
				_text_edit_index = _text_edit_index + 1;
#line 1043 "../src/protocol.vala"
				_tmp14_ = _text_edit_index;
#line 1043 "../src/protocol.vala"
				_tmp15_ = _text_edit_size;
#line 1043 "../src/protocol.vala"
				if (!(_tmp14_ < _tmp15_)) {
#line 1043 "../src/protocol.vala"
					break;
#line 18585 "protocol.c"
				}
#line 1043 "../src/protocol.vala"
				_tmp16_ = _text_edit_list;
#line 1043 "../src/protocol.vala"
				_tmp17_ = gee_list_get (_tmp16_, _text_edit_index);
#line 1043 "../src/protocol.vala"
				text_edit = (LspTextDocumentEdit*) _tmp17_;
#line 1044 "../src/protocol.vala"
				_tmp18_ = array;
#line 1044 "../src/protocol.vala"
				_tmp19_ = text_edit;
#line 1044 "../src/protocol.vala"
				_tmp20_ = json_gobject_serialize ((GObject*) _tmp19_);
#line 1044 "../src/protocol.vala"
				json_array_add_element (_tmp18_, _tmp20_);
#line 1043 "../src/protocol.vala"
				_g_object_unref0 (text_edit);
#line 18603 "protocol.c"
			}
		}
#line 1041 "../src/protocol.vala"
		_json_array_unref0 (array);
#line 18608 "protocol.c"
	}
#line 1047 "../src/protocol.vala"
	result = node;
#line 1047 "../src/protocol.vala"
	return result;
#line 18614 "protocol.c"
}

LspWorkspaceEdit*
lsp_workspace_edit_construct (GType object_type)
{
	LspWorkspaceEdit * self = NULL;
#line 1032 "../src/protocol.vala"
	self = (LspWorkspaceEdit*) g_object_new (object_type, NULL);
#line 1032 "../src/protocol.vala"
	return self;
#line 18625 "protocol.c"
}

LspWorkspaceEdit*
lsp_workspace_edit_new (void)
{
#line 1032 "../src/protocol.vala"
	return lsp_workspace_edit_construct (LSP_TYPE_WORKSPACE_EDIT);
#line 18633 "protocol.c"
}

GeeList*
lsp_workspace_edit_get_documentChanges (LspWorkspaceEdit* self)
{
	GeeList* result;
	GeeList* _tmp0_;
#line 1033 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1033 "../src/protocol.vala"
	_tmp0_ = self->priv->_documentChanges;
#line 1033 "../src/protocol.vala"
	result = _tmp0_;
#line 1033 "../src/protocol.vala"
	return result;
#line 18649 "protocol.c"
}

void
lsp_workspace_edit_set_documentChanges (LspWorkspaceEdit* self,
                                        GeeList* value)
{
	GeeList* old_value;
#line 1033 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 1033 "../src/protocol.vala"
	old_value = lsp_workspace_edit_get_documentChanges (self);
#line 1033 "../src/protocol.vala"
	if (old_value != value) {
#line 18663 "protocol.c"
		GeeList* _tmp0_;
#line 1033 "../src/protocol.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 1033 "../src/protocol.vala"
		_g_object_unref0 (self->priv->_documentChanges);
#line 1033 "../src/protocol.vala"
		self->priv->_documentChanges = _tmp0_;
#line 1033 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_workspace_edit_properties[LSP_WORKSPACE_EDIT_DOCUMENT_CHANGES_PROPERTY]);
#line 18673 "protocol.c"
	}
}

static void
lsp_workspace_edit_class_init (LspWorkspaceEditClass * klass,
                               gpointer klass_data)
{
#line 1032 "../src/protocol.vala"
	lsp_workspace_edit_parent_class = g_type_class_peek_parent (klass);
#line 1032 "../src/protocol.vala"
	g_type_class_adjust_private_offset (klass, &LspWorkspaceEdit_private_offset);
#line 1032 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_lsp_workspace_edit_get_property;
#line 1032 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_lsp_workspace_edit_set_property;
#line 1032 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->finalize = lsp_workspace_edit_finalize;
#line 1032 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_WORKSPACE_EDIT_DOCUMENT_CHANGES_PROPERTY, lsp_workspace_edit_properties[LSP_WORKSPACE_EDIT_DOCUMENT_CHANGES_PROPERTY] = g_param_spec_object ("documentChanges", "documentChanges", "documentChanges", GEE_TYPE_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 18693 "protocol.c"
}

static void
lsp_workspace_edit_json_serializable_interface_init (JsonSerializableIface * iface,
                                                     gpointer iface_data)
{
#line 1032 "../src/protocol.vala"
	lsp_workspace_edit_json_serializable_parent_iface = g_type_interface_peek_parent (iface);
#line 1032 "../src/protocol.vala"
	iface->serialize_property = (JsonNode* (*) (JsonSerializable*, const gchar*, GValue*, GParamSpec*)) lsp_workspace_edit_real_serialize_property;
#line 18704 "protocol.c"
}

static void
lsp_workspace_edit_instance_init (LspWorkspaceEdit * self,
                                  gpointer klass)
{
#line 1032 "../src/protocol.vala"
	self->priv = lsp_workspace_edit_get_instance_private (self);
#line 18713 "protocol.c"
}

static void
lsp_workspace_edit_finalize (GObject * obj)
{
	LspWorkspaceEdit * self;
#line 1032 "../src/protocol.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, LSP_TYPE_WORKSPACE_EDIT, LspWorkspaceEdit);
#line 1033 "../src/protocol.vala"
	_g_object_unref0 (self->priv->_documentChanges);
#line 1032 "../src/protocol.vala"
	G_OBJECT_CLASS (lsp_workspace_edit_parent_class)->finalize (obj);
#line 18726 "protocol.c"
}

 G_GNUC_NO_INLINE static GType
lsp_workspace_edit_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (LspWorkspaceEditClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) lsp_workspace_edit_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LspWorkspaceEdit), 0, (GInstanceInitFunc) lsp_workspace_edit_instance_init, NULL };
	static const GInterfaceInfo json_serializable_info = { (GInterfaceInitFunc) lsp_workspace_edit_json_serializable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType lsp_workspace_edit_type_id;
	lsp_workspace_edit_type_id = g_type_register_static (G_TYPE_OBJECT, "LspWorkspaceEdit", &g_define_type_info, 0);
	g_type_add_interface_static (lsp_workspace_edit_type_id, json_serializable_get_type (), &json_serializable_info);
	LspWorkspaceEdit_private_offset = g_type_add_instance_private (lsp_workspace_edit_type_id, sizeof (LspWorkspaceEditPrivate));
	return lsp_workspace_edit_type_id;
}

GType
lsp_workspace_edit_get_type (void)
{
	static gsize lsp_workspace_edit_type_id__once = 0;
	if (g_once_init_enter (&lsp_workspace_edit_type_id__once)) {
		GType lsp_workspace_edit_type_id;
		lsp_workspace_edit_type_id = lsp_workspace_edit_get_type_once ();
		g_once_init_leave (&lsp_workspace_edit_type_id__once, lsp_workspace_edit_type_id);
	}
	return lsp_workspace_edit_type_id__once;
}

static void
_vala_lsp_workspace_edit_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec)
{
	LspWorkspaceEdit * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_WORKSPACE_EDIT, LspWorkspaceEdit);
#line 1032 "../src/protocol.vala"
	switch (property_id) {
#line 1032 "../src/protocol.vala"
		case LSP_WORKSPACE_EDIT_DOCUMENT_CHANGES_PROPERTY:
#line 1032 "../src/protocol.vala"
		g_value_set_object (value, lsp_workspace_edit_get_documentChanges (self));
#line 1032 "../src/protocol.vala"
		break;
#line 18769 "protocol.c"
		default:
#line 1032 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 1032 "../src/protocol.vala"
		break;
#line 18775 "protocol.c"
	}
}

static void
_vala_lsp_workspace_edit_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec)
{
	LspWorkspaceEdit * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_WORKSPACE_EDIT, LspWorkspaceEdit);
#line 1032 "../src/protocol.vala"
	switch (property_id) {
#line 1032 "../src/protocol.vala"
		case LSP_WORKSPACE_EDIT_DOCUMENT_CHANGES_PROPERTY:
#line 1032 "../src/protocol.vala"
		lsp_workspace_edit_set_documentChanges (self, g_value_get_object (value));
#line 1032 "../src/protocol.vala"
		break;
#line 18795 "protocol.c"
		default:
#line 1032 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 1032 "../src/protocol.vala"
		break;
#line 18801 "protocol.c"
	}
}

 G_GNUC_NO_INLINE static GType
lsp_symbol_tags_get_type_once (void)
{
	static const GFlagsValue values[] = {{LSP_SYMBOL_TAGS_NONE, "LSP_SYMBOL_TAGS_NONE", "none"}, {LSP_SYMBOL_TAGS_DEPRECATED, "LSP_SYMBOL_TAGS_DEPRECATED", "deprecated"}, {0, NULL, NULL}};
	GType lsp_symbol_tags_type_id;
	lsp_symbol_tags_type_id = g_flags_register_static ("LspSymbolTags", values);
	return lsp_symbol_tags_type_id;
}

GType
lsp_symbol_tags_get_type (void)
{
	static gsize lsp_symbol_tags_type_id__once = 0;
	if (g_once_init_enter (&lsp_symbol_tags_type_id__once)) {
		GType lsp_symbol_tags_type_id;
		lsp_symbol_tags_type_id = lsp_symbol_tags_get_type_once ();
		g_once_init_leave (&lsp_symbol_tags_type_id__once, lsp_symbol_tags_type_id);
	}
	return lsp_symbol_tags_type_id__once;
}

static inline gpointer
lsp_call_hierarchy_item_get_instance_private (LspCallHierarchyItem* self)
{
	return G_STRUCT_MEMBER_P (self, LspCallHierarchyItem_private_offset);
}

static JsonNode*
lsp_call_hierarchy_item_real_serialize_property (JsonSerializable* base,
                                                 const gchar* property_name,
                                                 GValue* value,
                                                 GParamSpec* pspec)
{
	LspCallHierarchyItem * self;
	JsonArray* array = NULL;
	JsonArray* _tmp2_;
	LspSymbolTags _tmp3_;
	JsonNode* _tmp5_;
	JsonNode* _tmp6_;
	JsonArray* _tmp7_;
	JsonNode* _tmp8_;
	JsonNode* _tmp9_;
	JsonNode* _tmp10_;
	JsonNode* result;
#line 1066 "../src/protocol.vala"
	self = (LspCallHierarchyItem*) base;
#line 1066 "../src/protocol.vala"
	g_return_val_if_fail (property_name != NULL, NULL);
#line 1066 "../src/protocol.vala"
	g_return_val_if_fail (value != NULL, NULL);
#line 1066 "../src/protocol.vala"
	g_return_val_if_fail (pspec != NULL, NULL);
#line 1067 "../src/protocol.vala"
	if (g_strcmp0 (property_name, "tags") != 0) {
#line 18859 "protocol.c"
		GValue _tmp0_;
		JsonNode* _tmp1_;
#line 1068 "../src/protocol.vala"
		_tmp0_ = *value;
#line 1068 "../src/protocol.vala"
		_tmp1_ = json_serializable_default_serialize_property ((JsonSerializable*) self, property_name, &_tmp0_, pspec);
#line 1068 "../src/protocol.vala"
		result = _tmp1_;
#line 1068 "../src/protocol.vala"
		return result;
#line 18870 "protocol.c"
	}
#line 1069 "../src/protocol.vala"
	_tmp2_ = json_array_new ();
#line 1069 "../src/protocol.vala"
	array = _tmp2_;
#line 1070 "../src/protocol.vala"
	_tmp3_ = self->priv->_tags;
#line 1070 "../src/protocol.vala"
	if ((_tmp3_ & LSP_SYMBOL_TAGS_DEPRECATED) == LSP_SYMBOL_TAGS_DEPRECATED) {
#line 18880 "protocol.c"
		JsonArray* _tmp4_;
#line 1071 "../src/protocol.vala"
		_tmp4_ = array;
#line 1071 "../src/protocol.vala"
		json_array_add_int_element (_tmp4_, (gint64) LSP_SYMBOL_TAGS_DEPRECATED);
#line 18886 "protocol.c"
	}
#line 1072 "../src/protocol.vala"
	_tmp5_ = json_node_alloc ();
#line 1072 "../src/protocol.vala"
	_tmp6_ = _tmp5_;
#line 1072 "../src/protocol.vala"
	_tmp7_ = array;
#line 1072 "../src/protocol.vala"
	_tmp8_ = json_node_init_array (_tmp6_, _tmp7_);
#line 1072 "../src/protocol.vala"
	_tmp9_ = __vala_JsonNode_copy0 (_tmp8_);
#line 1072 "../src/protocol.vala"
	_tmp10_ = _tmp9_;
#line 1072 "../src/protocol.vala"
	__vala_JsonNode_free0 (_tmp6_);
#line 1072 "../src/protocol.vala"
	result = _tmp10_;
#line 1072 "../src/protocol.vala"
	_json_array_unref0 (array);
#line 1072 "../src/protocol.vala"
	return result;
#line 18908 "protocol.c"
}

LspCallHierarchyItem*
lsp_call_hierarchy_item_construct_from_symbol (GType object_type,
                                               ValaSymbol* symbol)
{
	LspCallHierarchyItem * self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	ValaAttribute* version = NULL;
	ValaAttribute* _tmp4_;
	ValaAttribute* _tmp5_;
	gboolean _tmp6_ = FALSE;
	ValaAttribute* _tmp7_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	ValaSourceReference* _tmp16_;
	ValaSourceReference* _tmp17_;
	ValaSourceFile* _tmp18_;
	ValaSourceFile* _tmp19_;
	const gchar* _tmp20_;
	const gchar* _tmp21_;
	GFile* _tmp22_;
	GFile* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	ValaSourceReference* _tmp26_;
	ValaSourceReference* _tmp27_;
	LspRange* _tmp28_;
	LspRange* _tmp29_;
	ValaComment* _tmp30_;
	ValaComment* _tmp31_;
	gboolean _tmp41_ = FALSE;
	ValaSourceReference* _tmp53_;
	ValaSourceReference* _tmp54_;
	LspRange* _tmp55_;
	LspRange* _tmp56_;
#line 1075 "../src/protocol.vala"
	g_return_val_if_fail (symbol != NULL, NULL);
#line 1075 "../src/protocol.vala"
	self = (LspCallHierarchyItem*) g_object_new (object_type, NULL);
#line 1076 "../src/protocol.vala"
	_tmp0_ = vala_symbol_get_full_name (symbol);
#line 1076 "../src/protocol.vala"
	_tmp1_ = _tmp0_;
#line 1076 "../src/protocol.vala"
	lsp_call_hierarchy_item_set_name (self, _tmp1_);
#line 1076 "../src/protocol.vala"
	_g_free0 (_tmp1_);
#line 1077 "../src/protocol.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (symbol, VALA_TYPE_METHOD)) {
#line 18960 "protocol.c"
		ValaSymbol* _tmp2_;
		ValaSymbol* _tmp3_;
#line 1078 "../src/protocol.vala"
		_tmp2_ = vala_symbol_get_parent_symbol (symbol);
#line 1078 "../src/protocol.vala"
		_tmp3_ = _tmp2_;
#line 1078 "../src/protocol.vala"
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp3_, VALA_TYPE_NAMESPACE)) {
#line 1079 "../src/protocol.vala"
			lsp_call_hierarchy_item_set_kind (self, LSP_SYMBOL_KIND_Function);
#line 18971 "protocol.c"
		} else {
#line 1081 "../src/protocol.vala"
			lsp_call_hierarchy_item_set_kind (self, LSP_SYMBOL_KIND_Method);
#line 18975 "protocol.c"
		}
	} else {
#line 1082 "../src/protocol.vala"
		if (G_TYPE_CHECK_INSTANCE_TYPE (symbol, VALA_TYPE_SIGNAL)) {
#line 1083 "../src/protocol.vala"
			lsp_call_hierarchy_item_set_kind (self, LSP_SYMBOL_KIND_Event);
#line 18982 "protocol.c"
		} else {
#line 1084 "../src/protocol.vala"
			if (G_TYPE_CHECK_INSTANCE_TYPE (symbol, VALA_TYPE_CONSTRUCTOR)) {
#line 1085 "../src/protocol.vala"
				lsp_call_hierarchy_item_set_kind (self, LSP_SYMBOL_KIND_Constructor);
#line 18988 "protocol.c"
			} else {
#line 1087 "../src/protocol.vala"
				lsp_call_hierarchy_item_set_kind (self, LSP_SYMBOL_KIND_Method);
#line 18992 "protocol.c"
			}
		}
	}
#line 1089 "../src/protocol.vala"
	_tmp4_ = vala_code_node_get_attribute ((ValaCodeNode*) symbol, "Version");
#line 1089 "../src/protocol.vala"
	_tmp5_ = _vala_code_node_ref0 (_tmp4_);
#line 1089 "../src/protocol.vala"
	version = _tmp5_;
#line 1090 "../src/protocol.vala"
	_tmp7_ = version;
#line 1090 "../src/protocol.vala"
	if (_tmp7_ != NULL) {
#line 19006 "protocol.c"
		gboolean _tmp8_ = FALSE;
		ValaAttribute* _tmp9_;
#line 1090 "../src/protocol.vala"
		_tmp9_ = version;
#line 1090 "../src/protocol.vala"
		if (vala_attribute_get_bool (_tmp9_, "deprecated", FALSE)) {
#line 1090 "../src/protocol.vala"
			_tmp8_ = TRUE;
#line 19015 "protocol.c"
		} else {
			ValaAttribute* _tmp10_;
			gchar* _tmp11_;
			gchar* _tmp12_;
#line 1090 "../src/protocol.vala"
			_tmp10_ = version;
#line 1090 "../src/protocol.vala"
			_tmp11_ = vala_attribute_get_string (_tmp10_, "deprecated_since", NULL);
#line 1090 "../src/protocol.vala"
			_tmp12_ = _tmp11_;
#line 1090 "../src/protocol.vala"
			_tmp8_ = _tmp12_ != NULL;
#line 1090 "../src/protocol.vala"
			_g_free0 (_tmp12_);
#line 19030 "protocol.c"
		}
#line 1090 "../src/protocol.vala"
		_tmp6_ = _tmp8_;
#line 19034 "protocol.c"
	} else {
#line 1090 "../src/protocol.vala"
		_tmp6_ = FALSE;
#line 19038 "protocol.c"
	}
#line 1090 "../src/protocol.vala"
	if (_tmp6_) {
#line 19042 "protocol.c"
		LspSymbolTags _tmp13_;
#line 1091 "../src/protocol.vala"
		_tmp13_ = self->priv->_tags;
#line 1091 "../src/protocol.vala"
		lsp_call_hierarchy_item_set_tags (self, _tmp13_ | LSP_SYMBOL_TAGS_DEPRECATED);
#line 19048 "protocol.c"
	}
#line 1093 "../src/protocol.vala"
	_tmp14_ = vls_code_help_get_symbol_representation (NULL, symbol, NULL, TRUE, NULL, NULL, TRUE, FALSE, NULL, TRUE);
#line 1093 "../src/protocol.vala"
	_tmp15_ = _tmp14_;
#line 1093 "../src/protocol.vala"
	lsp_call_hierarchy_item_set_detail (self, _tmp15_);
#line 1093 "../src/protocol.vala"
	_g_free0 (_tmp15_);
#line 1094 "../src/protocol.vala"
	_tmp16_ = vala_code_node_get_source_reference ((ValaCodeNode*) symbol);
#line 1094 "../src/protocol.vala"
	_tmp17_ = _tmp16_;
#line 1094 "../src/protocol.vala"
	_tmp18_ = vala_source_reference_get_file (_tmp17_);
#line 1094 "../src/protocol.vala"
	_tmp19_ = _tmp18_;
#line 1094 "../src/protocol.vala"
	_tmp20_ = vala_source_file_get_filename (_tmp19_);
#line 1094 "../src/protocol.vala"
	_tmp21_ = _tmp20_;
#line 1094 "../src/protocol.vala"
	_tmp22_ = g_file_new_for_commandline_arg (_tmp21_);
#line 1094 "../src/protocol.vala"
	_tmp23_ = _tmp22_;
#line 1094 "../src/protocol.vala"
	_tmp24_ = g_file_get_uri (_tmp23_);
#line 1094 "../src/protocol.vala"
	_tmp25_ = _tmp24_;
#line 1094 "../src/protocol.vala"
	lsp_call_hierarchy_item_set_uri (self, _tmp25_);
#line 1094 "../src/protocol.vala"
	_g_free0 (_tmp25_);
#line 1094 "../src/protocol.vala"
	_g_object_unref0 (_tmp23_);
#line 1095 "../src/protocol.vala"
	_tmp26_ = vala_code_node_get_source_reference ((ValaCodeNode*) symbol);
#line 1095 "../src/protocol.vala"
	_tmp27_ = _tmp26_;
#line 1095 "../src/protocol.vala"
	_tmp28_ = lsp_range_new_from_sourceref (_tmp27_);
#line 1095 "../src/protocol.vala"
	if (_tmp28_) {
#line 1095 "../src/protocol.vala"
		g_object_set_data ((GObject *) _tmp28_, "vala-creation-function", "Lsp.CallHierarchyItem.from_symbol");
#line 19094 "protocol.c"
	}
#line 1095 "../src/protocol.vala"
	_tmp29_ = _tmp28_;
#line 1095 "../src/protocol.vala"
	lsp_call_hierarchy_item_set_range (self, _tmp29_);
#line 1095 "../src/protocol.vala"
	_g_object_unref0 (_tmp29_);
#line 1096 "../src/protocol.vala"
	_tmp30_ = vala_symbol_get_comment (symbol);
#line 1096 "../src/protocol.vala"
	_tmp31_ = _tmp30_;
#line 1096 "../src/protocol.vala"
	if (_tmp31_ != NULL) {
#line 19108 "protocol.c"
		ValaComment* _tmp32_;
		ValaComment* _tmp33_;
		ValaSourceReference* _tmp34_;
		ValaSourceReference* _tmp35_;
		LspRange* _tmp36_;
		LspRange* _tmp37_;
		LspRange* _tmp38_;
		LspRange* _tmp39_;
		LspRange* _tmp40_;
#line 1097 "../src/protocol.vala"
		_tmp32_ = vala_symbol_get_comment (symbol);
#line 1097 "../src/protocol.vala"
		_tmp33_ = _tmp32_;
#line 1097 "../src/protocol.vala"
		_tmp34_ = vala_comment_get_source_reference (_tmp33_);
#line 1097 "../src/protocol.vala"
		_tmp35_ = _tmp34_;
#line 1097 "../src/protocol.vala"
		_tmp36_ = lsp_range_new_from_sourceref (_tmp35_);
#line 1097 "../src/protocol.vala"
		if (_tmp36_) {
#line 1097 "../src/protocol.vala"
			g_object_set_data ((GObject *) _tmp36_, "vala-creation-function", "Lsp.CallHierarchyItem.from_symbol");
#line 19132 "protocol.c"
		}
#line 1097 "../src/protocol.vala"
		_tmp37_ = _tmp36_;
#line 1097 "../src/protocol.vala"
		_tmp38_ = self->priv->_range;
#line 1097 "../src/protocol.vala"
		_tmp39_ = lsp_range_union (_tmp37_, _tmp38_);
#line 1097 "../src/protocol.vala"
		_tmp40_ = _tmp39_;
#line 1097 "../src/protocol.vala"
		lsp_call_hierarchy_item_set_range (self, _tmp40_);
#line 1097 "../src/protocol.vala"
		_g_object_unref0 (_tmp40_);
#line 1097 "../src/protocol.vala"
		_g_object_unref0 (_tmp37_);
#line 19148 "protocol.c"
	}
#line 1098 "../src/protocol.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (symbol, VALA_TYPE_SUBROUTINE)) {
#line 19152 "protocol.c"
		ValaBlock* _tmp42_;
		ValaBlock* _tmp43_;
#line 1098 "../src/protocol.vala"
		_tmp42_ = vala_subroutine_get_body (G_TYPE_CHECK_INSTANCE_CAST (symbol, VALA_TYPE_SUBROUTINE, ValaSubroutine));
#line 1098 "../src/protocol.vala"
		_tmp43_ = _tmp42_;
#line 1098 "../src/protocol.vala"
		_tmp41_ = _tmp43_ != NULL;
#line 19161 "protocol.c"
	} else {
#line 1098 "../src/protocol.vala"
		_tmp41_ = FALSE;
#line 19165 "protocol.c"
	}
#line 1098 "../src/protocol.vala"
	if (_tmp41_) {
#line 19169 "protocol.c"
		ValaBlock* _tmp44_;
		ValaBlock* _tmp45_;
		ValaSourceReference* _tmp46_;
		ValaSourceReference* _tmp47_;
		LspRange* _tmp48_;
		LspRange* _tmp49_;
		LspRange* _tmp50_;
		LspRange* _tmp51_;
		LspRange* _tmp52_;
#line 1099 "../src/protocol.vala"
		_tmp44_ = vala_subroutine_get_body (G_TYPE_CHECK_INSTANCE_CAST (symbol, VALA_TYPE_SUBROUTINE, ValaSubroutine));
#line 1099 "../src/protocol.vala"
		_tmp45_ = _tmp44_;
#line 1099 "../src/protocol.vala"
		_tmp46_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp45_);
#line 1099 "../src/protocol.vala"
		_tmp47_ = _tmp46_;
#line 1099 "../src/protocol.vala"
		_tmp48_ = lsp_range_new_from_sourceref (_tmp47_);
#line 1099 "../src/protocol.vala"
		if (_tmp48_) {
#line 1099 "../src/protocol.vala"
			g_object_set_data ((GObject *) _tmp48_, "vala-creation-function", "Lsp.CallHierarchyItem.from_symbol");
#line 19193 "protocol.c"
		}
#line 1099 "../src/protocol.vala"
		_tmp49_ = _tmp48_;
#line 1099 "../src/protocol.vala"
		_tmp50_ = self->priv->_range;
#line 1099 "../src/protocol.vala"
		_tmp51_ = lsp_range_union (_tmp49_, _tmp50_);
#line 1099 "../src/protocol.vala"
		_tmp52_ = _tmp51_;
#line 1099 "../src/protocol.vala"
		lsp_call_hierarchy_item_set_range (self, _tmp52_);
#line 1099 "../src/protocol.vala"
		_g_object_unref0 (_tmp52_);
#line 1099 "../src/protocol.vala"
		_g_object_unref0 (_tmp49_);
#line 19209 "protocol.c"
	}
#line 1100 "../src/protocol.vala"
	_tmp53_ = vala_code_node_get_source_reference ((ValaCodeNode*) symbol);
#line 1100 "../src/protocol.vala"
	_tmp54_ = _tmp53_;
#line 1100 "../src/protocol.vala"
	_tmp55_ = lsp_range_new_from_sourceref (_tmp54_);
#line 1100 "../src/protocol.vala"
	if (_tmp55_) {
#line 1100 "../src/protocol.vala"
		g_object_set_data ((GObject *) _tmp55_, "vala-creation-function", "Lsp.CallHierarchyItem.from_symbol");
#line 19221 "protocol.c"
	}
#line 1100 "../src/protocol.vala"
	_tmp56_ = _tmp55_;
#line 1100 "../src/protocol.vala"
	lsp_call_hierarchy_item_set_selectionRange (self, _tmp56_);
#line 1100 "../src/protocol.vala"
	_g_object_unref0 (_tmp56_);
#line 1075 "../src/protocol.vala"
	_vala_code_node_unref0 (version);
#line 1075 "../src/protocol.vala"
	return self;
#line 19233 "protocol.c"
}

LspCallHierarchyItem*
lsp_call_hierarchy_item_new_from_symbol (ValaSymbol* symbol)
{
#line 1075 "../src/protocol.vala"
	return lsp_call_hierarchy_item_construct_from_symbol (LSP_TYPE_CALL_HIERARCHY_ITEM, symbol);
#line 19241 "protocol.c"
}

LspCallHierarchyItem*
lsp_call_hierarchy_item_construct (GType object_type)
{
	LspCallHierarchyItem * self = NULL;
#line 1057 "../src/protocol.vala"
	self = (LspCallHierarchyItem*) g_object_new (object_type, NULL);
#line 1057 "../src/protocol.vala"
	return self;
#line 19252 "protocol.c"
}

LspCallHierarchyItem*
lsp_call_hierarchy_item_new (void)
{
#line 1057 "../src/protocol.vala"
	return lsp_call_hierarchy_item_construct (LSP_TYPE_CALL_HIERARCHY_ITEM);
#line 19260 "protocol.c"
}

const gchar*
lsp_call_hierarchy_item_get_name (LspCallHierarchyItem* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 1058 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1058 "../src/protocol.vala"
	_tmp0_ = self->priv->_name;
#line 1058 "../src/protocol.vala"
	result = _tmp0_;
#line 1058 "../src/protocol.vala"
	return result;
#line 19276 "protocol.c"
}

void
lsp_call_hierarchy_item_set_name (LspCallHierarchyItem* self,
                                  const gchar* value)
{
	gchar* old_value;
#line 1058 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 1058 "../src/protocol.vala"
	old_value = lsp_call_hierarchy_item_get_name (self);
#line 1058 "../src/protocol.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 19290 "protocol.c"
		gchar* _tmp0_;
#line 1058 "../src/protocol.vala"
		_tmp0_ = g_strdup (value);
#line 1058 "../src/protocol.vala"
		_g_free0 (self->priv->_name);
#line 1058 "../src/protocol.vala"
		self->priv->_name = _tmp0_;
#line 1058 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_call_hierarchy_item_properties[LSP_CALL_HIERARCHY_ITEM_NAME_PROPERTY]);
#line 19300 "protocol.c"
	}
}

LspSymbolKind
lsp_call_hierarchy_item_get_kind (LspCallHierarchyItem* self)
{
	LspSymbolKind result;
#line 1059 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, LSP_SYMBOL_KIND_Variable);
#line 1059 "../src/protocol.vala"
	result = self->priv->_kind;
#line 1059 "../src/protocol.vala"
	return result;
#line 19314 "protocol.c"
}

void
lsp_call_hierarchy_item_set_kind (LspCallHierarchyItem* self,
                                  LspSymbolKind value)
{
	LspSymbolKind old_value;
#line 1059 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 1059 "../src/protocol.vala"
	old_value = lsp_call_hierarchy_item_get_kind (self);
#line 1059 "../src/protocol.vala"
	if (old_value != value) {
#line 1059 "../src/protocol.vala"
		self->priv->_kind = value;
#line 1059 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_call_hierarchy_item_properties[LSP_CALL_HIERARCHY_ITEM_KIND_PROPERTY]);
#line 19332 "protocol.c"
	}
}

LspSymbolTags
lsp_call_hierarchy_item_get_tags (LspCallHierarchyItem* self)
{
	LspSymbolTags result;
#line 1060 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 1060 "../src/protocol.vala"
	result = self->priv->_tags;
#line 1060 "../src/protocol.vala"
	return result;
#line 19346 "protocol.c"
}

void
lsp_call_hierarchy_item_set_tags (LspCallHierarchyItem* self,
                                  LspSymbolTags value)
{
	LspSymbolTags old_value;
#line 1060 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 1060 "../src/protocol.vala"
	old_value = lsp_call_hierarchy_item_get_tags (self);
#line 1060 "../src/protocol.vala"
	if (old_value != value) {
#line 1060 "../src/protocol.vala"
		self->priv->_tags = value;
#line 1060 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_call_hierarchy_item_properties[LSP_CALL_HIERARCHY_ITEM_TAGS_PROPERTY]);
#line 19364 "protocol.c"
	}
}

const gchar*
lsp_call_hierarchy_item_get_detail (LspCallHierarchyItem* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 1061 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1061 "../src/protocol.vala"
	_tmp0_ = self->priv->_detail;
#line 1061 "../src/protocol.vala"
	result = _tmp0_;
#line 1061 "../src/protocol.vala"
	return result;
#line 19381 "protocol.c"
}

void
lsp_call_hierarchy_item_set_detail (LspCallHierarchyItem* self,
                                    const gchar* value)
{
	gchar* old_value;
#line 1061 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 1061 "../src/protocol.vala"
	old_value = lsp_call_hierarchy_item_get_detail (self);
#line 1061 "../src/protocol.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 19395 "protocol.c"
		gchar* _tmp0_;
#line 1061 "../src/protocol.vala"
		_tmp0_ = g_strdup (value);
#line 1061 "../src/protocol.vala"
		_g_free0 (self->priv->_detail);
#line 1061 "../src/protocol.vala"
		self->priv->_detail = _tmp0_;
#line 1061 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_call_hierarchy_item_properties[LSP_CALL_HIERARCHY_ITEM_DETAIL_PROPERTY]);
#line 19405 "protocol.c"
	}
}

const gchar*
lsp_call_hierarchy_item_get_uri (LspCallHierarchyItem* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 1062 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1062 "../src/protocol.vala"
	_tmp0_ = self->priv->_uri;
#line 1062 "../src/protocol.vala"
	result = _tmp0_;
#line 1062 "../src/protocol.vala"
	return result;
#line 19422 "protocol.c"
}

void
lsp_call_hierarchy_item_set_uri (LspCallHierarchyItem* self,
                                 const gchar* value)
{
	gchar* old_value;
#line 1062 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 1062 "../src/protocol.vala"
	old_value = lsp_call_hierarchy_item_get_uri (self);
#line 1062 "../src/protocol.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 19436 "protocol.c"
		gchar* _tmp0_;
#line 1062 "../src/protocol.vala"
		_tmp0_ = g_strdup (value);
#line 1062 "../src/protocol.vala"
		_g_free0 (self->priv->_uri);
#line 1062 "../src/protocol.vala"
		self->priv->_uri = _tmp0_;
#line 1062 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_call_hierarchy_item_properties[LSP_CALL_HIERARCHY_ITEM_URI_PROPERTY]);
#line 19446 "protocol.c"
	}
}

LspRange*
lsp_call_hierarchy_item_get_range (LspCallHierarchyItem* self)
{
	LspRange* result;
	LspRange* _tmp0_;
#line 1063 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1063 "../src/protocol.vala"
	_tmp0_ = self->priv->_range;
#line 1063 "../src/protocol.vala"
	result = _tmp0_;
#line 1063 "../src/protocol.vala"
	return result;
#line 19463 "protocol.c"
}

void
lsp_call_hierarchy_item_set_range (LspCallHierarchyItem* self,
                                   LspRange* value)
{
	LspRange* old_value;
#line 1063 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 1063 "../src/protocol.vala"
	old_value = lsp_call_hierarchy_item_get_range (self);
#line 1063 "../src/protocol.vala"
	if (old_value != value) {
#line 19477 "protocol.c"
		LspRange* _tmp0_;
#line 1063 "../src/protocol.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 1063 "../src/protocol.vala"
		_g_object_unref0 (self->priv->_range);
#line 1063 "../src/protocol.vala"
		self->priv->_range = _tmp0_;
#line 1063 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_call_hierarchy_item_properties[LSP_CALL_HIERARCHY_ITEM_RANGE_PROPERTY]);
#line 19487 "protocol.c"
	}
}

LspRange*
lsp_call_hierarchy_item_get_selectionRange (LspCallHierarchyItem* self)
{
	LspRange* result;
	LspRange* _tmp0_;
#line 1064 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1064 "../src/protocol.vala"
	_tmp0_ = self->priv->_selectionRange;
#line 1064 "../src/protocol.vala"
	result = _tmp0_;
#line 1064 "../src/protocol.vala"
	return result;
#line 19504 "protocol.c"
}

void
lsp_call_hierarchy_item_set_selectionRange (LspCallHierarchyItem* self,
                                            LspRange* value)
{
	LspRange* old_value;
#line 1064 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 1064 "../src/protocol.vala"
	old_value = lsp_call_hierarchy_item_get_selectionRange (self);
#line 1064 "../src/protocol.vala"
	if (old_value != value) {
#line 19518 "protocol.c"
		LspRange* _tmp0_;
#line 1064 "../src/protocol.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 1064 "../src/protocol.vala"
		_g_object_unref0 (self->priv->_selectionRange);
#line 1064 "../src/protocol.vala"
		self->priv->_selectionRange = _tmp0_;
#line 1064 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_call_hierarchy_item_properties[LSP_CALL_HIERARCHY_ITEM_SELECTION_RANGE_PROPERTY]);
#line 19528 "protocol.c"
	}
}

static void
lsp_call_hierarchy_item_class_init (LspCallHierarchyItemClass * klass,
                                    gpointer klass_data)
{
#line 1057 "../src/protocol.vala"
	lsp_call_hierarchy_item_parent_class = g_type_class_peek_parent (klass);
#line 1057 "../src/protocol.vala"
	g_type_class_adjust_private_offset (klass, &LspCallHierarchyItem_private_offset);
#line 1057 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_lsp_call_hierarchy_item_get_property;
#line 1057 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_lsp_call_hierarchy_item_set_property;
#line 1057 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->finalize = lsp_call_hierarchy_item_finalize;
#line 1057 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_CALL_HIERARCHY_ITEM_NAME_PROPERTY, lsp_call_hierarchy_item_properties[LSP_CALL_HIERARCHY_ITEM_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1057 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_CALL_HIERARCHY_ITEM_KIND_PROPERTY, lsp_call_hierarchy_item_properties[LSP_CALL_HIERARCHY_ITEM_KIND_PROPERTY] = g_param_spec_enum ("kind", "kind", "kind", LSP_TYPE_SYMBOL_KIND, LSP_SYMBOL_KIND_Variable, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1057 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_CALL_HIERARCHY_ITEM_TAGS_PROPERTY, lsp_call_hierarchy_item_properties[LSP_CALL_HIERARCHY_ITEM_TAGS_PROPERTY] = g_param_spec_flags ("tags", "tags", "tags", LSP_TYPE_SYMBOL_TAGS, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1057 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_CALL_HIERARCHY_ITEM_DETAIL_PROPERTY, lsp_call_hierarchy_item_properties[LSP_CALL_HIERARCHY_ITEM_DETAIL_PROPERTY] = g_param_spec_string ("detail", "detail", "detail", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1057 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_CALL_HIERARCHY_ITEM_URI_PROPERTY, lsp_call_hierarchy_item_properties[LSP_CALL_HIERARCHY_ITEM_URI_PROPERTY] = g_param_spec_string ("uri", "uri", "uri", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1057 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_CALL_HIERARCHY_ITEM_RANGE_PROPERTY, lsp_call_hierarchy_item_properties[LSP_CALL_HIERARCHY_ITEM_RANGE_PROPERTY] = g_param_spec_object ("range", "range", "range", LSP_TYPE_RANGE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1057 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_CALL_HIERARCHY_ITEM_SELECTION_RANGE_PROPERTY, lsp_call_hierarchy_item_properties[LSP_CALL_HIERARCHY_ITEM_SELECTION_RANGE_PROPERTY] = g_param_spec_object ("selectionRange", "selectionRange", "selectionRange", LSP_TYPE_RANGE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 19560 "protocol.c"
}

static void
lsp_call_hierarchy_item_json_serializable_interface_init (JsonSerializableIface * iface,
                                                          gpointer iface_data)
{
#line 1057 "../src/protocol.vala"
	lsp_call_hierarchy_item_json_serializable_parent_iface = g_type_interface_peek_parent (iface);
#line 1057 "../src/protocol.vala"
	iface->serialize_property = (JsonNode* (*) (JsonSerializable*, const gchar*, GValue*, GParamSpec*)) lsp_call_hierarchy_item_real_serialize_property;
#line 19571 "protocol.c"
}

static void
lsp_call_hierarchy_item_instance_init (LspCallHierarchyItem * self,
                                       gpointer klass)
{
#line 1057 "../src/protocol.vala"
	self->priv = lsp_call_hierarchy_item_get_instance_private (self);
#line 19580 "protocol.c"
}

static void
lsp_call_hierarchy_item_finalize (GObject * obj)
{
	LspCallHierarchyItem * self;
#line 1057 "../src/protocol.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, LSP_TYPE_CALL_HIERARCHY_ITEM, LspCallHierarchyItem);
#line 1058 "../src/protocol.vala"
	_g_free0 (self->priv->_name);
#line 1061 "../src/protocol.vala"
	_g_free0 (self->priv->_detail);
#line 1062 "../src/protocol.vala"
	_g_free0 (self->priv->_uri);
#line 1063 "../src/protocol.vala"
	_g_object_unref0 (self->priv->_range);
#line 1064 "../src/protocol.vala"
	_g_object_unref0 (self->priv->_selectionRange);
#line 1057 "../src/protocol.vala"
	G_OBJECT_CLASS (lsp_call_hierarchy_item_parent_class)->finalize (obj);
#line 19601 "protocol.c"
}

 G_GNUC_NO_INLINE static GType
lsp_call_hierarchy_item_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (LspCallHierarchyItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) lsp_call_hierarchy_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LspCallHierarchyItem), 0, (GInstanceInitFunc) lsp_call_hierarchy_item_instance_init, NULL };
	static const GInterfaceInfo json_serializable_info = { (GInterfaceInitFunc) lsp_call_hierarchy_item_json_serializable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType lsp_call_hierarchy_item_type_id;
	lsp_call_hierarchy_item_type_id = g_type_register_static (G_TYPE_OBJECT, "LspCallHierarchyItem", &g_define_type_info, 0);
	g_type_add_interface_static (lsp_call_hierarchy_item_type_id, json_serializable_get_type (), &json_serializable_info);
	LspCallHierarchyItem_private_offset = g_type_add_instance_private (lsp_call_hierarchy_item_type_id, sizeof (LspCallHierarchyItemPrivate));
	return lsp_call_hierarchy_item_type_id;
}

GType
lsp_call_hierarchy_item_get_type (void)
{
	static gsize lsp_call_hierarchy_item_type_id__once = 0;
	if (g_once_init_enter (&lsp_call_hierarchy_item_type_id__once)) {
		GType lsp_call_hierarchy_item_type_id;
		lsp_call_hierarchy_item_type_id = lsp_call_hierarchy_item_get_type_once ();
		g_once_init_leave (&lsp_call_hierarchy_item_type_id__once, lsp_call_hierarchy_item_type_id);
	}
	return lsp_call_hierarchy_item_type_id__once;
}

static void
_vala_lsp_call_hierarchy_item_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec)
{
	LspCallHierarchyItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_CALL_HIERARCHY_ITEM, LspCallHierarchyItem);
#line 1057 "../src/protocol.vala"
	switch (property_id) {
#line 1057 "../src/protocol.vala"
		case LSP_CALL_HIERARCHY_ITEM_NAME_PROPERTY:
#line 1057 "../src/protocol.vala"
		g_value_set_string (value, lsp_call_hierarchy_item_get_name (self));
#line 1057 "../src/protocol.vala"
		break;
#line 1057 "../src/protocol.vala"
		case LSP_CALL_HIERARCHY_ITEM_KIND_PROPERTY:
#line 1057 "../src/protocol.vala"
		g_value_set_enum (value, lsp_call_hierarchy_item_get_kind (self));
#line 1057 "../src/protocol.vala"
		break;
#line 1057 "../src/protocol.vala"
		case LSP_CALL_HIERARCHY_ITEM_TAGS_PROPERTY:
#line 1057 "../src/protocol.vala"
		g_value_set_flags (value, lsp_call_hierarchy_item_get_tags (self));
#line 1057 "../src/protocol.vala"
		break;
#line 1057 "../src/protocol.vala"
		case LSP_CALL_HIERARCHY_ITEM_DETAIL_PROPERTY:
#line 1057 "../src/protocol.vala"
		g_value_set_string (value, lsp_call_hierarchy_item_get_detail (self));
#line 1057 "../src/protocol.vala"
		break;
#line 1057 "../src/protocol.vala"
		case LSP_CALL_HIERARCHY_ITEM_URI_PROPERTY:
#line 1057 "../src/protocol.vala"
		g_value_set_string (value, lsp_call_hierarchy_item_get_uri (self));
#line 1057 "../src/protocol.vala"
		break;
#line 1057 "../src/protocol.vala"
		case LSP_CALL_HIERARCHY_ITEM_RANGE_PROPERTY:
#line 1057 "../src/protocol.vala"
		g_value_set_object (value, lsp_call_hierarchy_item_get_range (self));
#line 1057 "../src/protocol.vala"
		break;
#line 1057 "../src/protocol.vala"
		case LSP_CALL_HIERARCHY_ITEM_SELECTION_RANGE_PROPERTY:
#line 1057 "../src/protocol.vala"
		g_value_set_object (value, lsp_call_hierarchy_item_get_selectionRange (self));
#line 1057 "../src/protocol.vala"
		break;
#line 19680 "protocol.c"
		default:
#line 1057 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 1057 "../src/protocol.vala"
		break;
#line 19686 "protocol.c"
	}
}

static void
_vala_lsp_call_hierarchy_item_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec)
{
	LspCallHierarchyItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_CALL_HIERARCHY_ITEM, LspCallHierarchyItem);
#line 1057 "../src/protocol.vala"
	switch (property_id) {
#line 1057 "../src/protocol.vala"
		case LSP_CALL_HIERARCHY_ITEM_NAME_PROPERTY:
#line 1057 "../src/protocol.vala"
		lsp_call_hierarchy_item_set_name (self, g_value_get_string (value));
#line 1057 "../src/protocol.vala"
		break;
#line 1057 "../src/protocol.vala"
		case LSP_CALL_HIERARCHY_ITEM_KIND_PROPERTY:
#line 1057 "../src/protocol.vala"
		lsp_call_hierarchy_item_set_kind (self, g_value_get_enum (value));
#line 1057 "../src/protocol.vala"
		break;
#line 1057 "../src/protocol.vala"
		case LSP_CALL_HIERARCHY_ITEM_TAGS_PROPERTY:
#line 1057 "../src/protocol.vala"
		lsp_call_hierarchy_item_set_tags (self, g_value_get_flags (value));
#line 1057 "../src/protocol.vala"
		break;
#line 1057 "../src/protocol.vala"
		case LSP_CALL_HIERARCHY_ITEM_DETAIL_PROPERTY:
#line 1057 "../src/protocol.vala"
		lsp_call_hierarchy_item_set_detail (self, g_value_get_string (value));
#line 1057 "../src/protocol.vala"
		break;
#line 1057 "../src/protocol.vala"
		case LSP_CALL_HIERARCHY_ITEM_URI_PROPERTY:
#line 1057 "../src/protocol.vala"
		lsp_call_hierarchy_item_set_uri (self, g_value_get_string (value));
#line 1057 "../src/protocol.vala"
		break;
#line 1057 "../src/protocol.vala"
		case LSP_CALL_HIERARCHY_ITEM_RANGE_PROPERTY:
#line 1057 "../src/protocol.vala"
		lsp_call_hierarchy_item_set_range (self, g_value_get_object (value));
#line 1057 "../src/protocol.vala"
		break;
#line 1057 "../src/protocol.vala"
		case LSP_CALL_HIERARCHY_ITEM_SELECTION_RANGE_PROPERTY:
#line 1057 "../src/protocol.vala"
		lsp_call_hierarchy_item_set_selectionRange (self, g_value_get_object (value));
#line 1057 "../src/protocol.vala"
		break;
#line 19742 "protocol.c"
		default:
#line 1057 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 1057 "../src/protocol.vala"
		break;
#line 19748 "protocol.c"
	}
}

static inline gpointer
lsp_call_hierarchy_incoming_call_get_instance_private (LspCallHierarchyIncomingCall* self)
{
	return G_STRUCT_MEMBER_P (self, LspCallHierarchyIncomingCall_private_offset);
}

static JsonNode*
lsp_call_hierarchy_incoming_call_real_serialize_property (JsonSerializable* base,
                                                          const gchar* property_name,
                                                          GValue* value,
                                                          GParamSpec* pspec)
{
	LspCallHierarchyIncomingCall * self;
	JsonArray* array = NULL;
	JsonArray* _tmp2_;
	JsonNode* _tmp14_;
	JsonNode* _tmp15_;
	JsonArray* _tmp16_;
	JsonNode* _tmp17_;
	JsonNode* _tmp18_;
	JsonNode* _tmp19_;
	JsonNode* result;
#line 1115 "../src/protocol.vala"
	self = (LspCallHierarchyIncomingCall*) base;
#line 1115 "../src/protocol.vala"
	g_return_val_if_fail (property_name != NULL, NULL);
#line 1115 "../src/protocol.vala"
	g_return_val_if_fail (value != NULL, NULL);
#line 1115 "../src/protocol.vala"
	g_return_val_if_fail (pspec != NULL, NULL);
#line 1116 "../src/protocol.vala"
	if (g_strcmp0 (property_name, "from") == 0) {
#line 19784 "protocol.c"
		GValue _tmp0_;
		JsonNode* _tmp1_;
#line 1117 "../src/protocol.vala"
		_tmp0_ = *value;
#line 1117 "../src/protocol.vala"
		_tmp1_ = json_serializable_default_serialize_property ((JsonSerializable*) self, property_name, &_tmp0_, pspec);
#line 1117 "../src/protocol.vala"
		result = _tmp1_;
#line 1117 "../src/protocol.vala"
		return result;
#line 19795 "protocol.c"
	}
#line 1118 "../src/protocol.vala"
	_tmp2_ = json_array_new ();
#line 1118 "../src/protocol.vala"
	array = _tmp2_;
#line 19801 "protocol.c"
	{
		GeeArrayList* _range_list = NULL;
		GeeArrayList* _tmp3_;
		gint _range_size = 0;
		GeeArrayList* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		gint _range_index = 0;
#line 1119 "../src/protocol.vala"
		_tmp3_ = self->priv->_fromRanges;
#line 1119 "../src/protocol.vala"
		_range_list = _tmp3_;
#line 1119 "../src/protocol.vala"
		_tmp4_ = _range_list;
#line 1119 "../src/protocol.vala"
		_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
#line 1119 "../src/protocol.vala"
		_tmp6_ = _tmp5_;
#line 1119 "../src/protocol.vala"
		_range_size = _tmp6_;
#line 1119 "../src/protocol.vala"
		_range_index = -1;
#line 1119 "../src/protocol.vala"
		while (TRUE) {
#line 19826 "protocol.c"
			gint _tmp7_;
			gint _tmp8_;
			LspRange* range = NULL;
			GeeArrayList* _tmp9_;
			gpointer _tmp10_;
			JsonArray* _tmp11_;
			LspRange* _tmp12_;
			JsonNode* _tmp13_;
#line 1119 "../src/protocol.vala"
			_range_index = _range_index + 1;
#line 1119 "../src/protocol.vala"
			_tmp7_ = _range_index;
#line 1119 "../src/protocol.vala"
			_tmp8_ = _range_size;
#line 1119 "../src/protocol.vala"
			if (!(_tmp7_ < _tmp8_)) {
#line 1119 "../src/protocol.vala"
				break;
#line 19845 "protocol.c"
			}
#line 1119 "../src/protocol.vala"
			_tmp9_ = _range_list;
#line 1119 "../src/protocol.vala"
			_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _range_index);
#line 1119 "../src/protocol.vala"
			range = (LspRange*) _tmp10_;
#line 1120 "../src/protocol.vala"
			_tmp11_ = array;
#line 1120 "../src/protocol.vala"
			_tmp12_ = range;
#line 1120 "../src/protocol.vala"
			_tmp13_ = json_gobject_serialize ((GObject*) _tmp12_);
#line 1120 "../src/protocol.vala"
			json_array_add_element (_tmp11_, _tmp13_);
#line 1119 "../src/protocol.vala"
			_g_object_unref0 (range);
#line 19863 "protocol.c"
		}
	}
#line 1121 "../src/protocol.vala"
	_tmp14_ = json_node_alloc ();
#line 1121 "../src/protocol.vala"
	_tmp15_ = _tmp14_;
#line 1121 "../src/protocol.vala"
	_tmp16_ = array;
#line 1121 "../src/protocol.vala"
	_tmp17_ = json_node_init_array (_tmp15_, _tmp16_);
#line 1121 "../src/protocol.vala"
	_tmp18_ = __vala_JsonNode_copy0 (_tmp17_);
#line 1121 "../src/protocol.vala"
	_tmp19_ = _tmp18_;
#line 1121 "../src/protocol.vala"
	__vala_JsonNode_free0 (_tmp15_);
#line 1121 "../src/protocol.vala"
	result = _tmp19_;
#line 1121 "../src/protocol.vala"
	_json_array_unref0 (array);
#line 1121 "../src/protocol.vala"
	return result;
#line 19886 "protocol.c"
}

LspCallHierarchyIncomingCall*
lsp_call_hierarchy_incoming_call_construct (GType object_type)
{
	LspCallHierarchyIncomingCall * self = NULL;
#line 1104 "../src/protocol.vala"
	self = (LspCallHierarchyIncomingCall*) g_object_new (object_type, NULL);
#line 1104 "../src/protocol.vala"
	return self;
#line 19897 "protocol.c"
}

LspCallHierarchyIncomingCall*
lsp_call_hierarchy_incoming_call_new (void)
{
#line 1104 "../src/protocol.vala"
	return lsp_call_hierarchy_incoming_call_construct (LSP_TYPE_CALL_HIERARCHY_INCOMING_CALL);
#line 19905 "protocol.c"
}

LspCallHierarchyItem*
lsp_call_hierarchy_incoming_call_get_from (LspCallHierarchyIncomingCall* self)
{
	LspCallHierarchyItem* result;
	LspCallHierarchyItem* _tmp0_;
#line 1108 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1108 "../src/protocol.vala"
	_tmp0_ = self->priv->_from;
#line 1108 "../src/protocol.vala"
	result = _tmp0_;
#line 1108 "../src/protocol.vala"
	return result;
#line 19921 "protocol.c"
}

void
lsp_call_hierarchy_incoming_call_set_from (LspCallHierarchyIncomingCall* self,
                                           LspCallHierarchyItem* value)
{
	LspCallHierarchyItem* old_value;
#line 1108 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 1108 "../src/protocol.vala"
	old_value = lsp_call_hierarchy_incoming_call_get_from (self);
#line 1108 "../src/protocol.vala"
	if (old_value != value) {
#line 19935 "protocol.c"
		LspCallHierarchyItem* _tmp0_;
#line 1108 "../src/protocol.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 1108 "../src/protocol.vala"
		_g_object_unref0 (self->priv->_from);
#line 1108 "../src/protocol.vala"
		self->priv->_from = _tmp0_;
#line 1108 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_call_hierarchy_incoming_call_properties[LSP_CALL_HIERARCHY_INCOMING_CALL_FROM_PROPERTY]);
#line 19945 "protocol.c"
	}
}

GeeArrayList*
lsp_call_hierarchy_incoming_call_get_fromRanges (LspCallHierarchyIncomingCall* self)
{
	GeeArrayList* result;
	GeeArrayList* _tmp0_;
#line 1113 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1113 "../src/protocol.vala"
	_tmp0_ = self->priv->_fromRanges;
#line 1113 "../src/protocol.vala"
	result = _tmp0_;
#line 1113 "../src/protocol.vala"
	return result;
#line 19962 "protocol.c"
}

void
lsp_call_hierarchy_incoming_call_set_fromRanges (LspCallHierarchyIncomingCall* self,
                                                 GeeArrayList* value)
{
	GeeArrayList* old_value;
#line 1113 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 1113 "../src/protocol.vala"
	old_value = lsp_call_hierarchy_incoming_call_get_fromRanges (self);
#line 1113 "../src/protocol.vala"
	if (old_value != value) {
#line 19976 "protocol.c"
		GeeArrayList* _tmp0_;
#line 1113 "../src/protocol.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 1113 "../src/protocol.vala"
		_g_object_unref0 (self->priv->_fromRanges);
#line 1113 "../src/protocol.vala"
		self->priv->_fromRanges = _tmp0_;
#line 1113 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_call_hierarchy_incoming_call_properties[LSP_CALL_HIERARCHY_INCOMING_CALL_FROM_RANGES_PROPERTY]);
#line 19986 "protocol.c"
	}
}

static void
lsp_call_hierarchy_incoming_call_class_init (LspCallHierarchyIncomingCallClass * klass,
                                             gpointer klass_data)
{
#line 1104 "../src/protocol.vala"
	lsp_call_hierarchy_incoming_call_parent_class = g_type_class_peek_parent (klass);
#line 1104 "../src/protocol.vala"
	g_type_class_adjust_private_offset (klass, &LspCallHierarchyIncomingCall_private_offset);
#line 1104 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_lsp_call_hierarchy_incoming_call_get_property;
#line 1104 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_lsp_call_hierarchy_incoming_call_set_property;
#line 1104 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->finalize = lsp_call_hierarchy_incoming_call_finalize;
#line 20004 "protocol.c"
	/**
	         * The method that calls the query method.
	         */
#line 1104 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_CALL_HIERARCHY_INCOMING_CALL_FROM_PROPERTY, lsp_call_hierarchy_incoming_call_properties[LSP_CALL_HIERARCHY_INCOMING_CALL_FROM_PROPERTY] = g_param_spec_object ("from", "from", "from", LSP_TYPE_CALL_HIERARCHY_ITEM, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 20010 "protocol.c"
	/**
	         * The ranges at which the query method is called by `from`.
	         */
#line 1104 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_CALL_HIERARCHY_INCOMING_CALL_FROM_RANGES_PROPERTY, lsp_call_hierarchy_incoming_call_properties[LSP_CALL_HIERARCHY_INCOMING_CALL_FROM_RANGES_PROPERTY] = g_param_spec_object ("fromRanges", "fromRanges", "fromRanges", GEE_TYPE_ARRAY_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 20016 "protocol.c"
}

static void
lsp_call_hierarchy_incoming_call_json_serializable_interface_init (JsonSerializableIface * iface,
                                                                   gpointer iface_data)
{
#line 1104 "../src/protocol.vala"
	lsp_call_hierarchy_incoming_call_json_serializable_parent_iface = g_type_interface_peek_parent (iface);
#line 1104 "../src/protocol.vala"
	iface->serialize_property = (JsonNode* (*) (JsonSerializable*, const gchar*, GValue*, GParamSpec*)) lsp_call_hierarchy_incoming_call_real_serialize_property;
#line 20027 "protocol.c"
}

static void
lsp_call_hierarchy_incoming_call_instance_init (LspCallHierarchyIncomingCall * self,
                                                gpointer klass)
{
	GeeArrayList* _tmp0_;
#line 1104 "../src/protocol.vala"
	self->priv = lsp_call_hierarchy_incoming_call_get_instance_private (self);
#line 1113 "../src/protocol.vala"
	_tmp0_ = gee_array_list_new (LSP_TYPE_RANGE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1113 "../src/protocol.vala"
	if (_tmp0_) {
#line 1113 "../src/protocol.vala"
		g_object_set_data ((GObject *) _tmp0_, "vala-creation-function", "");
#line 20043 "protocol.c"
	}
#line 1113 "../src/protocol.vala"
	self->priv->_fromRanges = _tmp0_;
#line 20047 "protocol.c"
}

static void
lsp_call_hierarchy_incoming_call_finalize (GObject * obj)
{
	LspCallHierarchyIncomingCall * self;
#line 1104 "../src/protocol.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, LSP_TYPE_CALL_HIERARCHY_INCOMING_CALL, LspCallHierarchyIncomingCall);
#line 1108 "../src/protocol.vala"
	_g_object_unref0 (self->priv->_from);
#line 1113 "../src/protocol.vala"
	_g_object_unref0 (self->priv->_fromRanges);
#line 1104 "../src/protocol.vala"
	G_OBJECT_CLASS (lsp_call_hierarchy_incoming_call_parent_class)->finalize (obj);
#line 20062 "protocol.c"
}

 G_GNUC_NO_INLINE static GType
lsp_call_hierarchy_incoming_call_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (LspCallHierarchyIncomingCallClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) lsp_call_hierarchy_incoming_call_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LspCallHierarchyIncomingCall), 0, (GInstanceInitFunc) lsp_call_hierarchy_incoming_call_instance_init, NULL };
	static const GInterfaceInfo json_serializable_info = { (GInterfaceInitFunc) lsp_call_hierarchy_incoming_call_json_serializable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType lsp_call_hierarchy_incoming_call_type_id;
	lsp_call_hierarchy_incoming_call_type_id = g_type_register_static (G_TYPE_OBJECT, "LspCallHierarchyIncomingCall", &g_define_type_info, 0);
	g_type_add_interface_static (lsp_call_hierarchy_incoming_call_type_id, json_serializable_get_type (), &json_serializable_info);
	LspCallHierarchyIncomingCall_private_offset = g_type_add_instance_private (lsp_call_hierarchy_incoming_call_type_id, sizeof (LspCallHierarchyIncomingCallPrivate));
	return lsp_call_hierarchy_incoming_call_type_id;
}

GType
lsp_call_hierarchy_incoming_call_get_type (void)
{
	static gsize lsp_call_hierarchy_incoming_call_type_id__once = 0;
	if (g_once_init_enter (&lsp_call_hierarchy_incoming_call_type_id__once)) {
		GType lsp_call_hierarchy_incoming_call_type_id;
		lsp_call_hierarchy_incoming_call_type_id = lsp_call_hierarchy_incoming_call_get_type_once ();
		g_once_init_leave (&lsp_call_hierarchy_incoming_call_type_id__once, lsp_call_hierarchy_incoming_call_type_id);
	}
	return lsp_call_hierarchy_incoming_call_type_id__once;
}

static void
_vala_lsp_call_hierarchy_incoming_call_get_property (GObject * object,
                                                     guint property_id,
                                                     GValue * value,
                                                     GParamSpec * pspec)
{
	LspCallHierarchyIncomingCall * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_CALL_HIERARCHY_INCOMING_CALL, LspCallHierarchyIncomingCall);
#line 1104 "../src/protocol.vala"
	switch (property_id) {
#line 1104 "../src/protocol.vala"
		case LSP_CALL_HIERARCHY_INCOMING_CALL_FROM_PROPERTY:
#line 1104 "../src/protocol.vala"
		g_value_set_object (value, lsp_call_hierarchy_incoming_call_get_from (self));
#line 1104 "../src/protocol.vala"
		break;
#line 1104 "../src/protocol.vala"
		case LSP_CALL_HIERARCHY_INCOMING_CALL_FROM_RANGES_PROPERTY:
#line 1104 "../src/protocol.vala"
		g_value_set_object (value, lsp_call_hierarchy_incoming_call_get_fromRanges (self));
#line 1104 "../src/protocol.vala"
		break;
#line 20111 "protocol.c"
		default:
#line 1104 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 1104 "../src/protocol.vala"
		break;
#line 20117 "protocol.c"
	}
}

static void
_vala_lsp_call_hierarchy_incoming_call_set_property (GObject * object,
                                                     guint property_id,
                                                     const GValue * value,
                                                     GParamSpec * pspec)
{
	LspCallHierarchyIncomingCall * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_CALL_HIERARCHY_INCOMING_CALL, LspCallHierarchyIncomingCall);
#line 1104 "../src/protocol.vala"
	switch (property_id) {
#line 1104 "../src/protocol.vala"
		case LSP_CALL_HIERARCHY_INCOMING_CALL_FROM_PROPERTY:
#line 1104 "../src/protocol.vala"
		lsp_call_hierarchy_incoming_call_set_from (self, g_value_get_object (value));
#line 1104 "../src/protocol.vala"
		break;
#line 1104 "../src/protocol.vala"
		case LSP_CALL_HIERARCHY_INCOMING_CALL_FROM_RANGES_PROPERTY:
#line 1104 "../src/protocol.vala"
		lsp_call_hierarchy_incoming_call_set_fromRanges (self, g_value_get_object (value));
#line 1104 "../src/protocol.vala"
		break;
#line 20143 "protocol.c"
		default:
#line 1104 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 1104 "../src/protocol.vala"
		break;
#line 20149 "protocol.c"
	}
}

static inline gpointer
lsp_call_hierarchy_outgoing_call_get_instance_private (LspCallHierarchyOutgoingCall* self)
{
	return G_STRUCT_MEMBER_P (self, LspCallHierarchyOutgoingCall_private_offset);
}

static JsonNode*
lsp_call_hierarchy_outgoing_call_real_serialize_property (JsonSerializable* base,
                                                          const gchar* property_name,
                                                          GValue* value,
                                                          GParamSpec* pspec)
{
	LspCallHierarchyOutgoingCall * self;
	JsonArray* array = NULL;
	JsonArray* _tmp2_;
	JsonNode* _tmp14_;
	JsonNode* _tmp15_;
	JsonArray* _tmp16_;
	JsonNode* _tmp17_;
	JsonNode* _tmp18_;
	JsonNode* _tmp19_;
	JsonNode* result;
#line 1136 "../src/protocol.vala"
	self = (LspCallHierarchyOutgoingCall*) base;
#line 1136 "../src/protocol.vala"
	g_return_val_if_fail (property_name != NULL, NULL);
#line 1136 "../src/protocol.vala"
	g_return_val_if_fail (value != NULL, NULL);
#line 1136 "../src/protocol.vala"
	g_return_val_if_fail (pspec != NULL, NULL);
#line 1137 "../src/protocol.vala"
	if (g_strcmp0 (property_name, "to") == 0) {
#line 20185 "protocol.c"
		GValue _tmp0_;
		JsonNode* _tmp1_;
#line 1138 "../src/protocol.vala"
		_tmp0_ = *value;
#line 1138 "../src/protocol.vala"
		_tmp1_ = json_serializable_default_serialize_property ((JsonSerializable*) self, property_name, &_tmp0_, pspec);
#line 1138 "../src/protocol.vala"
		result = _tmp1_;
#line 1138 "../src/protocol.vala"
		return result;
#line 20196 "protocol.c"
	}
#line 1139 "../src/protocol.vala"
	_tmp2_ = json_array_new ();
#line 1139 "../src/protocol.vala"
	array = _tmp2_;
#line 20202 "protocol.c"
	{
		GeeArrayList* _range_list = NULL;
		GeeArrayList* _tmp3_;
		gint _range_size = 0;
		GeeArrayList* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		gint _range_index = 0;
#line 1140 "../src/protocol.vala"
		_tmp3_ = self->priv->_fromRanges;
#line 1140 "../src/protocol.vala"
		_range_list = _tmp3_;
#line 1140 "../src/protocol.vala"
		_tmp4_ = _range_list;
#line 1140 "../src/protocol.vala"
		_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
#line 1140 "../src/protocol.vala"
		_tmp6_ = _tmp5_;
#line 1140 "../src/protocol.vala"
		_range_size = _tmp6_;
#line 1140 "../src/protocol.vala"
		_range_index = -1;
#line 1140 "../src/protocol.vala"
		while (TRUE) {
#line 20227 "protocol.c"
			gint _tmp7_;
			gint _tmp8_;
			LspRange* range = NULL;
			GeeArrayList* _tmp9_;
			gpointer _tmp10_;
			JsonArray* _tmp11_;
			LspRange* _tmp12_;
			JsonNode* _tmp13_;
#line 1140 "../src/protocol.vala"
			_range_index = _range_index + 1;
#line 1140 "../src/protocol.vala"
			_tmp7_ = _range_index;
#line 1140 "../src/protocol.vala"
			_tmp8_ = _range_size;
#line 1140 "../src/protocol.vala"
			if (!(_tmp7_ < _tmp8_)) {
#line 1140 "../src/protocol.vala"
				break;
#line 20246 "protocol.c"
			}
#line 1140 "../src/protocol.vala"
			_tmp9_ = _range_list;
#line 1140 "../src/protocol.vala"
			_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _range_index);
#line 1140 "../src/protocol.vala"
			range = (LspRange*) _tmp10_;
#line 1141 "../src/protocol.vala"
			_tmp11_ = array;
#line 1141 "../src/protocol.vala"
			_tmp12_ = range;
#line 1141 "../src/protocol.vala"
			_tmp13_ = json_gobject_serialize ((GObject*) _tmp12_);
#line 1141 "../src/protocol.vala"
			json_array_add_element (_tmp11_, _tmp13_);
#line 1140 "../src/protocol.vala"
			_g_object_unref0 (range);
#line 20264 "protocol.c"
		}
	}
#line 1142 "../src/protocol.vala"
	_tmp14_ = json_node_alloc ();
#line 1142 "../src/protocol.vala"
	_tmp15_ = _tmp14_;
#line 1142 "../src/protocol.vala"
	_tmp16_ = array;
#line 1142 "../src/protocol.vala"
	_tmp17_ = json_node_init_array (_tmp15_, _tmp16_);
#line 1142 "../src/protocol.vala"
	_tmp18_ = __vala_JsonNode_copy0 (_tmp17_);
#line 1142 "../src/protocol.vala"
	_tmp19_ = _tmp18_;
#line 1142 "../src/protocol.vala"
	__vala_JsonNode_free0 (_tmp15_);
#line 1142 "../src/protocol.vala"
	result = _tmp19_;
#line 1142 "../src/protocol.vala"
	_json_array_unref0 (array);
#line 1142 "../src/protocol.vala"
	return result;
#line 20287 "protocol.c"
}

LspCallHierarchyOutgoingCall*
lsp_call_hierarchy_outgoing_call_construct (GType object_type)
{
	LspCallHierarchyOutgoingCall * self = NULL;
#line 1125 "../src/protocol.vala"
	self = (LspCallHierarchyOutgoingCall*) g_object_new (object_type, NULL);
#line 1125 "../src/protocol.vala"
	return self;
#line 20298 "protocol.c"
}

LspCallHierarchyOutgoingCall*
lsp_call_hierarchy_outgoing_call_new (void)
{
#line 1125 "../src/protocol.vala"
	return lsp_call_hierarchy_outgoing_call_construct (LSP_TYPE_CALL_HIERARCHY_OUTGOING_CALL);
#line 20306 "protocol.c"
}

LspCallHierarchyItem*
lsp_call_hierarchy_outgoing_call_get_to (LspCallHierarchyOutgoingCall* self)
{
	LspCallHierarchyItem* result;
	LspCallHierarchyItem* _tmp0_;
#line 1129 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1129 "../src/protocol.vala"
	_tmp0_ = self->priv->_to;
#line 1129 "../src/protocol.vala"
	result = _tmp0_;
#line 1129 "../src/protocol.vala"
	return result;
#line 20322 "protocol.c"
}

void
lsp_call_hierarchy_outgoing_call_set_to (LspCallHierarchyOutgoingCall* self,
                                         LspCallHierarchyItem* value)
{
	LspCallHierarchyItem* old_value;
#line 1129 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 1129 "../src/protocol.vala"
	old_value = lsp_call_hierarchy_outgoing_call_get_to (self);
#line 1129 "../src/protocol.vala"
	if (old_value != value) {
#line 20336 "protocol.c"
		LspCallHierarchyItem* _tmp0_;
#line 1129 "../src/protocol.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 1129 "../src/protocol.vala"
		_g_object_unref0 (self->priv->_to);
#line 1129 "../src/protocol.vala"
		self->priv->_to = _tmp0_;
#line 1129 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_call_hierarchy_outgoing_call_properties[LSP_CALL_HIERARCHY_OUTGOING_CALL_TO_PROPERTY]);
#line 20346 "protocol.c"
	}
}

GeeArrayList*
lsp_call_hierarchy_outgoing_call_get_fromRanges (LspCallHierarchyOutgoingCall* self)
{
	GeeArrayList* result;
	GeeArrayList* _tmp0_;
#line 1134 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1134 "../src/protocol.vala"
	_tmp0_ = self->priv->_fromRanges;
#line 1134 "../src/protocol.vala"
	result = _tmp0_;
#line 1134 "../src/protocol.vala"
	return result;
#line 20363 "protocol.c"
}

void
lsp_call_hierarchy_outgoing_call_set_fromRanges (LspCallHierarchyOutgoingCall* self,
                                                 GeeArrayList* value)
{
	GeeArrayList* old_value;
#line 1134 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 1134 "../src/protocol.vala"
	old_value = lsp_call_hierarchy_outgoing_call_get_fromRanges (self);
#line 1134 "../src/protocol.vala"
	if (old_value != value) {
#line 20377 "protocol.c"
		GeeArrayList* _tmp0_;
#line 1134 "../src/protocol.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 1134 "../src/protocol.vala"
		_g_object_unref0 (self->priv->_fromRanges);
#line 1134 "../src/protocol.vala"
		self->priv->_fromRanges = _tmp0_;
#line 1134 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_call_hierarchy_outgoing_call_properties[LSP_CALL_HIERARCHY_OUTGOING_CALL_FROM_RANGES_PROPERTY]);
#line 20387 "protocol.c"
	}
}

static void
lsp_call_hierarchy_outgoing_call_class_init (LspCallHierarchyOutgoingCallClass * klass,
                                             gpointer klass_data)
{
#line 1125 "../src/protocol.vala"
	lsp_call_hierarchy_outgoing_call_parent_class = g_type_class_peek_parent (klass);
#line 1125 "../src/protocol.vala"
	g_type_class_adjust_private_offset (klass, &LspCallHierarchyOutgoingCall_private_offset);
#line 1125 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_lsp_call_hierarchy_outgoing_call_get_property;
#line 1125 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_lsp_call_hierarchy_outgoing_call_set_property;
#line 1125 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->finalize = lsp_call_hierarchy_outgoing_call_finalize;
#line 20405 "protocol.c"
	/**
	         * The method that the query method calls.
	         */
#line 1125 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_CALL_HIERARCHY_OUTGOING_CALL_TO_PROPERTY, lsp_call_hierarchy_outgoing_call_properties[LSP_CALL_HIERARCHY_OUTGOING_CALL_TO_PROPERTY] = g_param_spec_object ("to", "to", "to", LSP_TYPE_CALL_HIERARCHY_ITEM, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 20411 "protocol.c"
	/**
	         * The ranges at which the method is called by the query method.
	         */
#line 1125 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_CALL_HIERARCHY_OUTGOING_CALL_FROM_RANGES_PROPERTY, lsp_call_hierarchy_outgoing_call_properties[LSP_CALL_HIERARCHY_OUTGOING_CALL_FROM_RANGES_PROPERTY] = g_param_spec_object ("fromRanges", "fromRanges", "fromRanges", GEE_TYPE_ARRAY_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 20417 "protocol.c"
}

static void
lsp_call_hierarchy_outgoing_call_json_serializable_interface_init (JsonSerializableIface * iface,
                                                                   gpointer iface_data)
{
#line 1125 "../src/protocol.vala"
	lsp_call_hierarchy_outgoing_call_json_serializable_parent_iface = g_type_interface_peek_parent (iface);
#line 1125 "../src/protocol.vala"
	iface->serialize_property = (JsonNode* (*) (JsonSerializable*, const gchar*, GValue*, GParamSpec*)) lsp_call_hierarchy_outgoing_call_real_serialize_property;
#line 20428 "protocol.c"
}

static void
lsp_call_hierarchy_outgoing_call_instance_init (LspCallHierarchyOutgoingCall * self,
                                                gpointer klass)
{
	GeeArrayList* _tmp0_;
#line 1125 "../src/protocol.vala"
	self->priv = lsp_call_hierarchy_outgoing_call_get_instance_private (self);
#line 1134 "../src/protocol.vala"
	_tmp0_ = gee_array_list_new (LSP_TYPE_RANGE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1134 "../src/protocol.vala"
	if (_tmp0_) {
#line 1134 "../src/protocol.vala"
		g_object_set_data ((GObject *) _tmp0_, "vala-creation-function", "");
#line 20444 "protocol.c"
	}
#line 1134 "../src/protocol.vala"
	self->priv->_fromRanges = _tmp0_;
#line 20448 "protocol.c"
}

static void
lsp_call_hierarchy_outgoing_call_finalize (GObject * obj)
{
	LspCallHierarchyOutgoingCall * self;
#line 1125 "../src/protocol.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, LSP_TYPE_CALL_HIERARCHY_OUTGOING_CALL, LspCallHierarchyOutgoingCall);
#line 1129 "../src/protocol.vala"
	_g_object_unref0 (self->priv->_to);
#line 1134 "../src/protocol.vala"
	_g_object_unref0 (self->priv->_fromRanges);
#line 1125 "../src/protocol.vala"
	G_OBJECT_CLASS (lsp_call_hierarchy_outgoing_call_parent_class)->finalize (obj);
#line 20463 "protocol.c"
}

 G_GNUC_NO_INLINE static GType
lsp_call_hierarchy_outgoing_call_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (LspCallHierarchyOutgoingCallClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) lsp_call_hierarchy_outgoing_call_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LspCallHierarchyOutgoingCall), 0, (GInstanceInitFunc) lsp_call_hierarchy_outgoing_call_instance_init, NULL };
	static const GInterfaceInfo json_serializable_info = { (GInterfaceInitFunc) lsp_call_hierarchy_outgoing_call_json_serializable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType lsp_call_hierarchy_outgoing_call_type_id;
	lsp_call_hierarchy_outgoing_call_type_id = g_type_register_static (G_TYPE_OBJECT, "LspCallHierarchyOutgoingCall", &g_define_type_info, 0);
	g_type_add_interface_static (lsp_call_hierarchy_outgoing_call_type_id, json_serializable_get_type (), &json_serializable_info);
	LspCallHierarchyOutgoingCall_private_offset = g_type_add_instance_private (lsp_call_hierarchy_outgoing_call_type_id, sizeof (LspCallHierarchyOutgoingCallPrivate));
	return lsp_call_hierarchy_outgoing_call_type_id;
}

GType
lsp_call_hierarchy_outgoing_call_get_type (void)
{
	static gsize lsp_call_hierarchy_outgoing_call_type_id__once = 0;
	if (g_once_init_enter (&lsp_call_hierarchy_outgoing_call_type_id__once)) {
		GType lsp_call_hierarchy_outgoing_call_type_id;
		lsp_call_hierarchy_outgoing_call_type_id = lsp_call_hierarchy_outgoing_call_get_type_once ();
		g_once_init_leave (&lsp_call_hierarchy_outgoing_call_type_id__once, lsp_call_hierarchy_outgoing_call_type_id);
	}
	return lsp_call_hierarchy_outgoing_call_type_id__once;
}

static void
_vala_lsp_call_hierarchy_outgoing_call_get_property (GObject * object,
                                                     guint property_id,
                                                     GValue * value,
                                                     GParamSpec * pspec)
{
	LspCallHierarchyOutgoingCall * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_CALL_HIERARCHY_OUTGOING_CALL, LspCallHierarchyOutgoingCall);
#line 1125 "../src/protocol.vala"
	switch (property_id) {
#line 1125 "../src/protocol.vala"
		case LSP_CALL_HIERARCHY_OUTGOING_CALL_TO_PROPERTY:
#line 1125 "../src/protocol.vala"
		g_value_set_object (value, lsp_call_hierarchy_outgoing_call_get_to (self));
#line 1125 "../src/protocol.vala"
		break;
#line 1125 "../src/protocol.vala"
		case LSP_CALL_HIERARCHY_OUTGOING_CALL_FROM_RANGES_PROPERTY:
#line 1125 "../src/protocol.vala"
		g_value_set_object (value, lsp_call_hierarchy_outgoing_call_get_fromRanges (self));
#line 1125 "../src/protocol.vala"
		break;
#line 20512 "protocol.c"
		default:
#line 1125 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 1125 "../src/protocol.vala"
		break;
#line 20518 "protocol.c"
	}
}

static void
_vala_lsp_call_hierarchy_outgoing_call_set_property (GObject * object,
                                                     guint property_id,
                                                     const GValue * value,
                                                     GParamSpec * pspec)
{
	LspCallHierarchyOutgoingCall * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_CALL_HIERARCHY_OUTGOING_CALL, LspCallHierarchyOutgoingCall);
#line 1125 "../src/protocol.vala"
	switch (property_id) {
#line 1125 "../src/protocol.vala"
		case LSP_CALL_HIERARCHY_OUTGOING_CALL_TO_PROPERTY:
#line 1125 "../src/protocol.vala"
		lsp_call_hierarchy_outgoing_call_set_to (self, g_value_get_object (value));
#line 1125 "../src/protocol.vala"
		break;
#line 1125 "../src/protocol.vala"
		case LSP_CALL_HIERARCHY_OUTGOING_CALL_FROM_RANGES_PROPERTY:
#line 1125 "../src/protocol.vala"
		lsp_call_hierarchy_outgoing_call_set_fromRanges (self, g_value_get_object (value));
#line 1125 "../src/protocol.vala"
		break;
#line 20544 "protocol.c"
		default:
#line 1125 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 1125 "../src/protocol.vala"
		break;
#line 20550 "protocol.c"
	}
}

static inline gpointer
lsp_inlay_hint_params_get_instance_private (LspInlayHintParams* self)
{
	return G_STRUCT_MEMBER_P (self, LspInlayHintParams_private_offset);
}

LspInlayHintParams*
lsp_inlay_hint_params_construct (GType object_type)
{
	LspInlayHintParams * self = NULL;
#line 1146 "../src/protocol.vala"
	self = (LspInlayHintParams*) g_object_new (object_type, NULL);
#line 1146 "../src/protocol.vala"
	return self;
#line 20568 "protocol.c"
}

LspInlayHintParams*
lsp_inlay_hint_params_new (void)
{
#line 1146 "../src/protocol.vala"
	return lsp_inlay_hint_params_construct (LSP_TYPE_INLAY_HINT_PARAMS);
#line 20576 "protocol.c"
}

LspTextDocumentIdentifier*
lsp_inlay_hint_params_get_textDocument (LspInlayHintParams* self)
{
	LspTextDocumentIdentifier* result;
	LspTextDocumentIdentifier* _tmp0_;
#line 1147 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1147 "../src/protocol.vala"
	_tmp0_ = self->priv->_textDocument;
#line 1147 "../src/protocol.vala"
	result = _tmp0_;
#line 1147 "../src/protocol.vala"
	return result;
#line 20592 "protocol.c"
}

void
lsp_inlay_hint_params_set_textDocument (LspInlayHintParams* self,
                                        LspTextDocumentIdentifier* value)
{
	LspTextDocumentIdentifier* old_value;
#line 1147 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 1147 "../src/protocol.vala"
	old_value = lsp_inlay_hint_params_get_textDocument (self);
#line 1147 "../src/protocol.vala"
	if (old_value != value) {
#line 20606 "protocol.c"
		LspTextDocumentIdentifier* _tmp0_;
#line 1147 "../src/protocol.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 1147 "../src/protocol.vala"
		_g_object_unref0 (self->priv->_textDocument);
#line 1147 "../src/protocol.vala"
		self->priv->_textDocument = _tmp0_;
#line 1147 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_inlay_hint_params_properties[LSP_INLAY_HINT_PARAMS_TEXT_DOCUMENT_PROPERTY]);
#line 20616 "protocol.c"
	}
}

LspRange*
lsp_inlay_hint_params_get_range (LspInlayHintParams* self)
{
	LspRange* result;
	LspRange* _tmp0_;
#line 1148 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1148 "../src/protocol.vala"
	_tmp0_ = self->priv->_range;
#line 1148 "../src/protocol.vala"
	result = _tmp0_;
#line 1148 "../src/protocol.vala"
	return result;
#line 20633 "protocol.c"
}

void
lsp_inlay_hint_params_set_range (LspInlayHintParams* self,
                                 LspRange* value)
{
	LspRange* old_value;
#line 1148 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 1148 "../src/protocol.vala"
	old_value = lsp_inlay_hint_params_get_range (self);
#line 1148 "../src/protocol.vala"
	if (old_value != value) {
#line 20647 "protocol.c"
		LspRange* _tmp0_;
#line 1148 "../src/protocol.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 1148 "../src/protocol.vala"
		_g_object_unref0 (self->priv->_range);
#line 1148 "../src/protocol.vala"
		self->priv->_range = _tmp0_;
#line 1148 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_inlay_hint_params_properties[LSP_INLAY_HINT_PARAMS_RANGE_PROPERTY]);
#line 20657 "protocol.c"
	}
}

static void
lsp_inlay_hint_params_class_init (LspInlayHintParamsClass * klass,
                                  gpointer klass_data)
{
#line 1146 "../src/protocol.vala"
	lsp_inlay_hint_params_parent_class = g_type_class_peek_parent (klass);
#line 1146 "../src/protocol.vala"
	g_type_class_adjust_private_offset (klass, &LspInlayHintParams_private_offset);
#line 1146 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_lsp_inlay_hint_params_get_property;
#line 1146 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_lsp_inlay_hint_params_set_property;
#line 1146 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->finalize = lsp_inlay_hint_params_finalize;
#line 1146 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_INLAY_HINT_PARAMS_TEXT_DOCUMENT_PROPERTY, lsp_inlay_hint_params_properties[LSP_INLAY_HINT_PARAMS_TEXT_DOCUMENT_PROPERTY] = g_param_spec_object ("textDocument", "textDocument", "textDocument", LSP_TYPE_TEXT_DOCUMENT_IDENTIFIER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1146 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_INLAY_HINT_PARAMS_RANGE_PROPERTY, lsp_inlay_hint_params_properties[LSP_INLAY_HINT_PARAMS_RANGE_PROPERTY] = g_param_spec_object ("range", "range", "range", LSP_TYPE_RANGE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 20679 "protocol.c"
}

static void
lsp_inlay_hint_params_json_serializable_interface_init (JsonSerializableIface * iface,
                                                        gpointer iface_data)
{
#line 1146 "../src/protocol.vala"
	lsp_inlay_hint_params_json_serializable_parent_iface = g_type_interface_peek_parent (iface);
#line 20688 "protocol.c"
}

static void
lsp_inlay_hint_params_instance_init (LspInlayHintParams * self,
                                     gpointer klass)
{
#line 1146 "../src/protocol.vala"
	self->priv = lsp_inlay_hint_params_get_instance_private (self);
#line 20697 "protocol.c"
}

static void
lsp_inlay_hint_params_finalize (GObject * obj)
{
	LspInlayHintParams * self;
#line 1146 "../src/protocol.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, LSP_TYPE_INLAY_HINT_PARAMS, LspInlayHintParams);
#line 1147 "../src/protocol.vala"
	_g_object_unref0 (self->priv->_textDocument);
#line 1148 "../src/protocol.vala"
	_g_object_unref0 (self->priv->_range);
#line 1146 "../src/protocol.vala"
	G_OBJECT_CLASS (lsp_inlay_hint_params_parent_class)->finalize (obj);
#line 20712 "protocol.c"
}

 G_GNUC_NO_INLINE static GType
lsp_inlay_hint_params_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (LspInlayHintParamsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) lsp_inlay_hint_params_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LspInlayHintParams), 0, (GInstanceInitFunc) lsp_inlay_hint_params_instance_init, NULL };
	static const GInterfaceInfo json_serializable_info = { (GInterfaceInitFunc) lsp_inlay_hint_params_json_serializable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType lsp_inlay_hint_params_type_id;
	lsp_inlay_hint_params_type_id = g_type_register_static (G_TYPE_OBJECT, "LspInlayHintParams", &g_define_type_info, 0);
	g_type_add_interface_static (lsp_inlay_hint_params_type_id, json_serializable_get_type (), &json_serializable_info);
	LspInlayHintParams_private_offset = g_type_add_instance_private (lsp_inlay_hint_params_type_id, sizeof (LspInlayHintParamsPrivate));
	return lsp_inlay_hint_params_type_id;
}

GType
lsp_inlay_hint_params_get_type (void)
{
	static gsize lsp_inlay_hint_params_type_id__once = 0;
	if (g_once_init_enter (&lsp_inlay_hint_params_type_id__once)) {
		GType lsp_inlay_hint_params_type_id;
		lsp_inlay_hint_params_type_id = lsp_inlay_hint_params_get_type_once ();
		g_once_init_leave (&lsp_inlay_hint_params_type_id__once, lsp_inlay_hint_params_type_id);
	}
	return lsp_inlay_hint_params_type_id__once;
}

static void
_vala_lsp_inlay_hint_params_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec)
{
	LspInlayHintParams * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_INLAY_HINT_PARAMS, LspInlayHintParams);
#line 1146 "../src/protocol.vala"
	switch (property_id) {
#line 1146 "../src/protocol.vala"
		case LSP_INLAY_HINT_PARAMS_TEXT_DOCUMENT_PROPERTY:
#line 1146 "../src/protocol.vala"
		g_value_set_object (value, lsp_inlay_hint_params_get_textDocument (self));
#line 1146 "../src/protocol.vala"
		break;
#line 1146 "../src/protocol.vala"
		case LSP_INLAY_HINT_PARAMS_RANGE_PROPERTY:
#line 1146 "../src/protocol.vala"
		g_value_set_object (value, lsp_inlay_hint_params_get_range (self));
#line 1146 "../src/protocol.vala"
		break;
#line 20761 "protocol.c"
		default:
#line 1146 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 1146 "../src/protocol.vala"
		break;
#line 20767 "protocol.c"
	}
}

static void
_vala_lsp_inlay_hint_params_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec)
{
	LspInlayHintParams * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_INLAY_HINT_PARAMS, LspInlayHintParams);
#line 1146 "../src/protocol.vala"
	switch (property_id) {
#line 1146 "../src/protocol.vala"
		case LSP_INLAY_HINT_PARAMS_TEXT_DOCUMENT_PROPERTY:
#line 1146 "../src/protocol.vala"
		lsp_inlay_hint_params_set_textDocument (self, g_value_get_object (value));
#line 1146 "../src/protocol.vala"
		break;
#line 1146 "../src/protocol.vala"
		case LSP_INLAY_HINT_PARAMS_RANGE_PROPERTY:
#line 1146 "../src/protocol.vala"
		lsp_inlay_hint_params_set_range (self, g_value_get_object (value));
#line 1146 "../src/protocol.vala"
		break;
#line 20793 "protocol.c"
		default:
#line 1146 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 1146 "../src/protocol.vala"
		break;
#line 20799 "protocol.c"
	}
}

 G_GNUC_NO_INLINE static GType
lsp_inlay_hint_kind_get_type_once (void)
{
	static const GEnumValue values[] = {{LSP_INLAY_HINT_KIND_UNSET, "LSP_INLAY_HINT_KIND_UNSET", "unset"}, {LSP_INLAY_HINT_KIND_TYPE, "LSP_INLAY_HINT_KIND_TYPE", "type"}, {LSP_INLAY_HINT_KIND_PARAMETER, "LSP_INLAY_HINT_KIND_PARAMETER", "parameter"}, {0, NULL, NULL}};
	GType lsp_inlay_hint_kind_type_id;
	lsp_inlay_hint_kind_type_id = g_enum_register_static ("LspInlayHintKind", values);
	return lsp_inlay_hint_kind_type_id;
}

GType
lsp_inlay_hint_kind_get_type (void)
{
	static gsize lsp_inlay_hint_kind_type_id__once = 0;
	if (g_once_init_enter (&lsp_inlay_hint_kind_type_id__once)) {
		GType lsp_inlay_hint_kind_type_id;
		lsp_inlay_hint_kind_type_id = lsp_inlay_hint_kind_get_type_once ();
		g_once_init_leave (&lsp_inlay_hint_kind_type_id__once, lsp_inlay_hint_kind_type_id);
	}
	return lsp_inlay_hint_kind_type_id__once;
}

static inline gpointer
lsp_inlay_hint_get_instance_private (LspInlayHint* self)
{
	return G_STRUCT_MEMBER_P (self, LspInlayHint_private_offset);
}

LspInlayHint*
lsp_inlay_hint_construct (GType object_type)
{
	LspInlayHint * self = NULL;
#line 1157 "../src/protocol.vala"
	self = (LspInlayHint*) g_object_new (object_type, NULL);
#line 1157 "../src/protocol.vala"
	return self;
#line 20838 "protocol.c"
}

LspInlayHint*
lsp_inlay_hint_new (void)
{
#line 1157 "../src/protocol.vala"
	return lsp_inlay_hint_construct (LSP_TYPE_INLAY_HINT);
#line 20846 "protocol.c"
}

LspPosition*
lsp_inlay_hint_get_position (LspInlayHint* self)
{
	LspPosition* result;
	LspPosition* _tmp0_;
#line 1158 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1158 "../src/protocol.vala"
	_tmp0_ = self->priv->_position;
#line 1158 "../src/protocol.vala"
	result = _tmp0_;
#line 1158 "../src/protocol.vala"
	return result;
#line 20862 "protocol.c"
}

void
lsp_inlay_hint_set_position (LspInlayHint* self,
                             LspPosition* value)
{
	LspPosition* old_value;
#line 1158 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 1158 "../src/protocol.vala"
	old_value = lsp_inlay_hint_get_position (self);
#line 1158 "../src/protocol.vala"
	if (old_value != value) {
#line 20876 "protocol.c"
		LspPosition* _tmp0_;
#line 1158 "../src/protocol.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 1158 "../src/protocol.vala"
		_g_object_unref0 (self->priv->_position);
#line 1158 "../src/protocol.vala"
		self->priv->_position = _tmp0_;
#line 1158 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_inlay_hint_properties[LSP_INLAY_HINT_POSITION_PROPERTY]);
#line 20886 "protocol.c"
	}
}

const gchar*
lsp_inlay_hint_get_label (LspInlayHint* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 1159 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1159 "../src/protocol.vala"
	_tmp0_ = self->priv->_label;
#line 1159 "../src/protocol.vala"
	result = _tmp0_;
#line 1159 "../src/protocol.vala"
	return result;
#line 20903 "protocol.c"
}

void
lsp_inlay_hint_set_label (LspInlayHint* self,
                          const gchar* value)
{
	gchar* old_value;
#line 1159 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 1159 "../src/protocol.vala"
	old_value = lsp_inlay_hint_get_label (self);
#line 1159 "../src/protocol.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 20917 "protocol.c"
		gchar* _tmp0_;
#line 1159 "../src/protocol.vala"
		_tmp0_ = g_strdup (value);
#line 1159 "../src/protocol.vala"
		_g_free0 (self->priv->_label);
#line 1159 "../src/protocol.vala"
		self->priv->_label = _tmp0_;
#line 1159 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_inlay_hint_properties[LSP_INLAY_HINT_LABEL_PROPERTY]);
#line 20927 "protocol.c"
	}
}

LspInlayHintKind
lsp_inlay_hint_get_kind (LspInlayHint* self)
{
	LspInlayHintKind result;
#line 1160 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 1160 "../src/protocol.vala"
	result = self->priv->_kind;
#line 1160 "../src/protocol.vala"
	return result;
#line 20941 "protocol.c"
}

void
lsp_inlay_hint_set_kind (LspInlayHint* self,
                         LspInlayHintKind value)
{
	LspInlayHintKind old_value;
#line 1160 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 1160 "../src/protocol.vala"
	old_value = lsp_inlay_hint_get_kind (self);
#line 1160 "../src/protocol.vala"
	if (old_value != value) {
#line 1160 "../src/protocol.vala"
		self->priv->_kind = value;
#line 1160 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_inlay_hint_properties[LSP_INLAY_HINT_KIND_PROPERTY]);
#line 20959 "protocol.c"
	}
}

const gchar*
lsp_inlay_hint_get_tooltip (LspInlayHint* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 1161 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1161 "../src/protocol.vala"
	_tmp0_ = self->priv->_tooltip;
#line 1161 "../src/protocol.vala"
	result = _tmp0_;
#line 1161 "../src/protocol.vala"
	return result;
#line 20976 "protocol.c"
}

void
lsp_inlay_hint_set_tooltip (LspInlayHint* self,
                            const gchar* value)
{
	gchar* old_value;
#line 1161 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 1161 "../src/protocol.vala"
	old_value = lsp_inlay_hint_get_tooltip (self);
#line 1161 "../src/protocol.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 20990 "protocol.c"
		gchar* _tmp0_;
#line 1161 "../src/protocol.vala"
		_tmp0_ = g_strdup (value);
#line 1161 "../src/protocol.vala"
		_g_free0 (self->priv->_tooltip);
#line 1161 "../src/protocol.vala"
		self->priv->_tooltip = _tmp0_;
#line 1161 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_inlay_hint_properties[LSP_INLAY_HINT_TOOLTIP_PROPERTY]);
#line 21000 "protocol.c"
	}
}

gboolean
lsp_inlay_hint_get_paddingLeft (LspInlayHint* self)
{
	gboolean result;
#line 1162 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1162 "../src/protocol.vala"
	result = self->priv->_paddingLeft;
#line 1162 "../src/protocol.vala"
	return result;
#line 21014 "protocol.c"
}

void
lsp_inlay_hint_set_paddingLeft (LspInlayHint* self,
                                gboolean value)
{
	gboolean old_value;
#line 1162 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 1162 "../src/protocol.vala"
	old_value = lsp_inlay_hint_get_paddingLeft (self);
#line 1162 "../src/protocol.vala"
	if (old_value != value) {
#line 1162 "../src/protocol.vala"
		self->priv->_paddingLeft = value;
#line 1162 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_inlay_hint_properties[LSP_INLAY_HINT_PADDING_LEFT_PROPERTY]);
#line 21032 "protocol.c"
	}
}

gboolean
lsp_inlay_hint_get_paddingRight (LspInlayHint* self)
{
	gboolean result;
#line 1163 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1163 "../src/protocol.vala"
	result = self->priv->_paddingRight;
#line 1163 "../src/protocol.vala"
	return result;
#line 21046 "protocol.c"
}

void
lsp_inlay_hint_set_paddingRight (LspInlayHint* self,
                                 gboolean value)
{
	gboolean old_value;
#line 1163 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 1163 "../src/protocol.vala"
	old_value = lsp_inlay_hint_get_paddingRight (self);
#line 1163 "../src/protocol.vala"
	if (old_value != value) {
#line 1163 "../src/protocol.vala"
		self->priv->_paddingRight = value;
#line 1163 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_inlay_hint_properties[LSP_INLAY_HINT_PADDING_RIGHT_PROPERTY]);
#line 21064 "protocol.c"
	}
}

static void
lsp_inlay_hint_class_init (LspInlayHintClass * klass,
                           gpointer klass_data)
{
#line 1157 "../src/protocol.vala"
	lsp_inlay_hint_parent_class = g_type_class_peek_parent (klass);
#line 1157 "../src/protocol.vala"
	g_type_class_adjust_private_offset (klass, &LspInlayHint_private_offset);
#line 1157 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_lsp_inlay_hint_get_property;
#line 1157 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_lsp_inlay_hint_set_property;
#line 1157 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->finalize = lsp_inlay_hint_finalize;
#line 1157 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_INLAY_HINT_POSITION_PROPERTY, lsp_inlay_hint_properties[LSP_INLAY_HINT_POSITION_PROPERTY] = g_param_spec_object ("position", "position", "position", LSP_TYPE_POSITION, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1157 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_INLAY_HINT_LABEL_PROPERTY, lsp_inlay_hint_properties[LSP_INLAY_HINT_LABEL_PROPERTY] = g_param_spec_string ("label", "label", "label", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1157 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_INLAY_HINT_KIND_PROPERTY, lsp_inlay_hint_properties[LSP_INLAY_HINT_KIND_PROPERTY] = g_param_spec_enum ("kind", "kind", "kind", LSP_TYPE_INLAY_HINT_KIND, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1157 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_INLAY_HINT_TOOLTIP_PROPERTY, lsp_inlay_hint_properties[LSP_INLAY_HINT_TOOLTIP_PROPERTY] = g_param_spec_string ("tooltip", "tooltip", "tooltip", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1157 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_INLAY_HINT_PADDING_LEFT_PROPERTY, lsp_inlay_hint_properties[LSP_INLAY_HINT_PADDING_LEFT_PROPERTY] = g_param_spec_boolean ("paddingLeft", "paddingLeft", "paddingLeft", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1157 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_INLAY_HINT_PADDING_RIGHT_PROPERTY, lsp_inlay_hint_properties[LSP_INLAY_HINT_PADDING_RIGHT_PROPERTY] = g_param_spec_boolean ("paddingRight", "paddingRight", "paddingRight", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 21094 "protocol.c"
}

static void
lsp_inlay_hint_instance_init (LspInlayHint * self,
                              gpointer klass)
{
#line 1157 "../src/protocol.vala"
	self->priv = lsp_inlay_hint_get_instance_private (self);
#line 21103 "protocol.c"
}

static void
lsp_inlay_hint_finalize (GObject * obj)
{
	LspInlayHint * self;
#line 1157 "../src/protocol.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, LSP_TYPE_INLAY_HINT, LspInlayHint);
#line 1158 "../src/protocol.vala"
	_g_object_unref0 (self->priv->_position);
#line 1159 "../src/protocol.vala"
	_g_free0 (self->priv->_label);
#line 1161 "../src/protocol.vala"
	_g_free0 (self->priv->_tooltip);
#line 1157 "../src/protocol.vala"
	G_OBJECT_CLASS (lsp_inlay_hint_parent_class)->finalize (obj);
#line 21120 "protocol.c"
}

 G_GNUC_NO_INLINE static GType
lsp_inlay_hint_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (LspInlayHintClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) lsp_inlay_hint_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LspInlayHint), 0, (GInstanceInitFunc) lsp_inlay_hint_instance_init, NULL };
	GType lsp_inlay_hint_type_id;
	lsp_inlay_hint_type_id = g_type_register_static (G_TYPE_OBJECT, "LspInlayHint", &g_define_type_info, 0);
	LspInlayHint_private_offset = g_type_add_instance_private (lsp_inlay_hint_type_id, sizeof (LspInlayHintPrivate));
	return lsp_inlay_hint_type_id;
}

GType
lsp_inlay_hint_get_type (void)
{
	static gsize lsp_inlay_hint_type_id__once = 0;
	if (g_once_init_enter (&lsp_inlay_hint_type_id__once)) {
		GType lsp_inlay_hint_type_id;
		lsp_inlay_hint_type_id = lsp_inlay_hint_get_type_once ();
		g_once_init_leave (&lsp_inlay_hint_type_id__once, lsp_inlay_hint_type_id);
	}
	return lsp_inlay_hint_type_id__once;
}

static void
_vala_lsp_inlay_hint_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec)
{
	LspInlayHint * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_INLAY_HINT, LspInlayHint);
#line 1157 "../src/protocol.vala"
	switch (property_id) {
#line 1157 "../src/protocol.vala"
		case LSP_INLAY_HINT_POSITION_PROPERTY:
#line 1157 "../src/protocol.vala"
		g_value_set_object (value, lsp_inlay_hint_get_position (self));
#line 1157 "../src/protocol.vala"
		break;
#line 1157 "../src/protocol.vala"
		case LSP_INLAY_HINT_LABEL_PROPERTY:
#line 1157 "../src/protocol.vala"
		g_value_set_string (value, lsp_inlay_hint_get_label (self));
#line 1157 "../src/protocol.vala"
		break;
#line 1157 "../src/protocol.vala"
		case LSP_INLAY_HINT_KIND_PROPERTY:
#line 1157 "../src/protocol.vala"
		g_value_set_enum (value, lsp_inlay_hint_get_kind (self));
#line 1157 "../src/protocol.vala"
		break;
#line 1157 "../src/protocol.vala"
		case LSP_INLAY_HINT_TOOLTIP_PROPERTY:
#line 1157 "../src/protocol.vala"
		g_value_set_string (value, lsp_inlay_hint_get_tooltip (self));
#line 1157 "../src/protocol.vala"
		break;
#line 1157 "../src/protocol.vala"
		case LSP_INLAY_HINT_PADDING_LEFT_PROPERTY:
#line 1157 "../src/protocol.vala"
		g_value_set_boolean (value, lsp_inlay_hint_get_paddingLeft (self));
#line 1157 "../src/protocol.vala"
		break;
#line 1157 "../src/protocol.vala"
		case LSP_INLAY_HINT_PADDING_RIGHT_PROPERTY:
#line 1157 "../src/protocol.vala"
		g_value_set_boolean (value, lsp_inlay_hint_get_paddingRight (self));
#line 1157 "../src/protocol.vala"
		break;
#line 21191 "protocol.c"
		default:
#line 1157 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 1157 "../src/protocol.vala"
		break;
#line 21197 "protocol.c"
	}
}

static void
_vala_lsp_inlay_hint_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec)
{
	LspInlayHint * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_INLAY_HINT, LspInlayHint);
#line 1157 "../src/protocol.vala"
	switch (property_id) {
#line 1157 "../src/protocol.vala"
		case LSP_INLAY_HINT_POSITION_PROPERTY:
#line 1157 "../src/protocol.vala"
		lsp_inlay_hint_set_position (self, g_value_get_object (value));
#line 1157 "../src/protocol.vala"
		break;
#line 1157 "../src/protocol.vala"
		case LSP_INLAY_HINT_LABEL_PROPERTY:
#line 1157 "../src/protocol.vala"
		lsp_inlay_hint_set_label (self, g_value_get_string (value));
#line 1157 "../src/protocol.vala"
		break;
#line 1157 "../src/protocol.vala"
		case LSP_INLAY_HINT_KIND_PROPERTY:
#line 1157 "../src/protocol.vala"
		lsp_inlay_hint_set_kind (self, g_value_get_enum (value));
#line 1157 "../src/protocol.vala"
		break;
#line 1157 "../src/protocol.vala"
		case LSP_INLAY_HINT_TOOLTIP_PROPERTY:
#line 1157 "../src/protocol.vala"
		lsp_inlay_hint_set_tooltip (self, g_value_get_string (value));
#line 1157 "../src/protocol.vala"
		break;
#line 1157 "../src/protocol.vala"
		case LSP_INLAY_HINT_PADDING_LEFT_PROPERTY:
#line 1157 "../src/protocol.vala"
		lsp_inlay_hint_set_paddingLeft (self, g_value_get_boolean (value));
#line 1157 "../src/protocol.vala"
		break;
#line 1157 "../src/protocol.vala"
		case LSP_INLAY_HINT_PADDING_RIGHT_PROPERTY:
#line 1157 "../src/protocol.vala"
		lsp_inlay_hint_set_paddingRight (self, g_value_get_boolean (value));
#line 1157 "../src/protocol.vala"
		break;
#line 21247 "protocol.c"
		default:
#line 1157 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 1157 "../src/protocol.vala"
		break;
#line 21253 "protocol.c"
	}
}

static inline gpointer
lsp_typehierarchy_item_get_instance_private (LspTypeHierarchyItem* self)
{
	return G_STRUCT_MEMBER_P (self, LspTypeHierarchyItem_private_offset);
}

static LspTypeHierarchyItem*
lsp_typehierarchy_item_construct (GType object_type)
{
	LspTypeHierarchyItem * self = NULL;
#line 1205 "../src/protocol.vala"
	self = (LspTypeHierarchyItem*) g_object_new (object_type, NULL);
#line 1205 "../src/protocol.vala"
	return self;
#line 21271 "protocol.c"
}

static LspTypeHierarchyItem*
lsp_typehierarchy_item_new (void)
{
#line 1205 "../src/protocol.vala"
	return lsp_typehierarchy_item_construct (LSP_TYPE_TYPEHIERARCHY_ITEM);
#line 21279 "protocol.c"
}

LspTypeHierarchyItem*
lsp_typehierarchy_item_construct_from_symbol (GType object_type,
                                              ValaTypeSymbol* symbol)
{
	LspTypeHierarchyItem * self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	ValaAttribute* version = NULL;
	ValaAttribute* _tmp4_;
	ValaAttribute* _tmp5_;
	gboolean _tmp6_ = FALSE;
	ValaAttribute* _tmp7_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	ValaSourceReference* _tmp16_;
	ValaSourceReference* _tmp17_;
	ValaSourceFile* _tmp18_;
	ValaSourceFile* _tmp19_;
	const gchar* _tmp20_;
	const gchar* _tmp21_;
	GFile* _tmp22_;
	GFile* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	ValaSourceReference* _tmp26_;
	ValaSourceReference* _tmp27_;
	LspRange* _tmp28_;
	LspRange* _tmp29_;
	LspRange* _tmp30_;
#line 1207 "../src/protocol.vala"
	g_return_val_if_fail (symbol != NULL, NULL);
#line 1207 "../src/protocol.vala"
	self = (LspTypeHierarchyItem*) g_object_new (object_type, NULL);
#line 1208 "../src/protocol.vala"
	_tmp0_ = vala_symbol_get_full_name ((ValaSymbol*) symbol);
#line 1208 "../src/protocol.vala"
	_tmp1_ = _tmp0_;
#line 1208 "../src/protocol.vala"
	lsp_typehierarchy_item_set_name (self, _tmp1_);
#line 1208 "../src/protocol.vala"
	_g_free0 (_tmp1_);
#line 1209 "../src/protocol.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (symbol, VALA_TYPE_CLASS)) {
#line 1210 "../src/protocol.vala"
		lsp_typehierarchy_item_set_kind (self, LSP_SYMBOL_KIND_Class);
#line 21327 "protocol.c"
	} else {
#line 1211 "../src/protocol.vala"
		if (G_TYPE_CHECK_INSTANCE_TYPE (symbol, VALA_TYPE_DELEGATE)) {
#line 1212 "../src/protocol.vala"
			lsp_typehierarchy_item_set_kind (self, LSP_SYMBOL_KIND_Interface);
#line 21333 "protocol.c"
		} else {
#line 1213 "../src/protocol.vala"
			if (G_TYPE_CHECK_INSTANCE_TYPE (symbol, VALA_TYPE_ENUM)) {
#line 1214 "../src/protocol.vala"
				lsp_typehierarchy_item_set_kind (self, LSP_SYMBOL_KIND_Enum);
#line 21339 "protocol.c"
			} else {
#line 1215 "../src/protocol.vala"
				if (G_TYPE_CHECK_INSTANCE_TYPE (symbol, VALA_TYPE_ERROR_CODE)) {
#line 1216 "../src/protocol.vala"
					lsp_typehierarchy_item_set_kind (self, LSP_SYMBOL_KIND_EnumMember);
#line 21345 "protocol.c"
				} else {
#line 1217 "../src/protocol.vala"
					if (G_TYPE_CHECK_INSTANCE_TYPE (symbol, VALA_TYPE_ERROR_DOMAIN)) {
#line 1218 "../src/protocol.vala"
						lsp_typehierarchy_item_set_kind (self, LSP_SYMBOL_KIND_Enum);
#line 21351 "protocol.c"
					} else {
#line 1219 "../src/protocol.vala"
						if (G_TYPE_CHECK_INSTANCE_TYPE (symbol, VALA_TYPE_INTERFACE)) {
#line 1220 "../src/protocol.vala"
							lsp_typehierarchy_item_set_kind (self, LSP_SYMBOL_KIND_Interface);
#line 21357 "protocol.c"
						} else {
#line 1221 "../src/protocol.vala"
							if (G_TYPE_CHECK_INSTANCE_TYPE (symbol, VALA_TYPE_STRUCT)) {
#line 1222 "../src/protocol.vala"
								lsp_typehierarchy_item_set_kind (self, LSP_SYMBOL_KIND_Struct);
#line 21363 "protocol.c"
							} else {
#line 1223 "../src/protocol.vala"
								if (G_TYPE_CHECK_INSTANCE_TYPE (symbol, VALA_TYPE_TYPEPARAMETER)) {
#line 1224 "../src/protocol.vala"
									lsp_typehierarchy_item_set_kind (self, LSP_SYMBOL_KIND_TypeParameter);
#line 21369 "protocol.c"
								} else {
									const gchar* _tmp2_;
									const gchar* _tmp3_;
#line 1226 "../src/protocol.vala"
									lsp_typehierarchy_item_set_kind (self, LSP_SYMBOL_KIND_Module);
#line 1227 "../src/protocol.vala"
									_tmp2_ = vala_code_node_get_type_name ((ValaCodeNode*) symbol);
#line 1227 "../src/protocol.vala"
									_tmp3_ = _tmp2_;
#line 1227 "../src/protocol.vala"
									g_warning ("protocol.vala:1227: unexpected symbol kind in type hierarchy: `%s'", _tmp3_);
#line 21381 "protocol.c"
								}
							}
						}
					}
				}
			}
		}
	}
#line 1230 "../src/protocol.vala"
	_tmp4_ = vala_code_node_get_attribute ((ValaCodeNode*) symbol, "Version");
#line 1230 "../src/protocol.vala"
	_tmp5_ = _vala_code_node_ref0 (_tmp4_);
#line 1230 "../src/protocol.vala"
	version = _tmp5_;
#line 1231 "../src/protocol.vala"
	_tmp7_ = version;
#line 1231 "../src/protocol.vala"
	if (_tmp7_ != NULL) {
#line 21400 "protocol.c"
		gboolean _tmp8_ = FALSE;
		ValaAttribute* _tmp9_;
#line 1231 "../src/protocol.vala"
		_tmp9_ = version;
#line 1231 "../src/protocol.vala"
		if (vala_attribute_get_bool (_tmp9_, "deprecated", FALSE)) {
#line 1231 "../src/protocol.vala"
			_tmp8_ = TRUE;
#line 21409 "protocol.c"
		} else {
			ValaAttribute* _tmp10_;
			gchar* _tmp11_;
			gchar* _tmp12_;
#line 1231 "../src/protocol.vala"
			_tmp10_ = version;
#line 1231 "../src/protocol.vala"
			_tmp11_ = vala_attribute_get_string (_tmp10_, "deprecated_since", NULL);
#line 1231 "../src/protocol.vala"
			_tmp12_ = _tmp11_;
#line 1231 "../src/protocol.vala"
			_tmp8_ = _tmp12_ != NULL;
#line 1231 "../src/protocol.vala"
			_g_free0 (_tmp12_);
#line 21424 "protocol.c"
		}
#line 1231 "../src/protocol.vala"
		_tmp6_ = _tmp8_;
#line 21428 "protocol.c"
	} else {
#line 1231 "../src/protocol.vala"
		_tmp6_ = FALSE;
#line 21432 "protocol.c"
	}
#line 1231 "../src/protocol.vala"
	if (_tmp6_) {
#line 21436 "protocol.c"
		LspSymbolTags _tmp13_;
#line 1232 "../src/protocol.vala"
		_tmp13_ = self->priv->_tags;
#line 1232 "../src/protocol.vala"
		lsp_typehierarchy_item_set_tags (self, _tmp13_ | LSP_SYMBOL_TAGS_DEPRECATED);
#line 21442 "protocol.c"
	}
#line 1234 "../src/protocol.vala"
	_tmp14_ = vls_code_help_get_symbol_representation (NULL, (ValaSymbol*) symbol, NULL, TRUE, NULL, NULL, TRUE, FALSE, NULL, TRUE);
#line 1234 "../src/protocol.vala"
	_tmp15_ = _tmp14_;
#line 1234 "../src/protocol.vala"
	lsp_typehierarchy_item_set_detail (self, _tmp15_);
#line 1234 "../src/protocol.vala"
	_g_free0 (_tmp15_);
#line 1235 "../src/protocol.vala"
	_tmp16_ = vala_code_node_get_source_reference ((ValaCodeNode*) symbol);
#line 1235 "../src/protocol.vala"
	_tmp17_ = _tmp16_;
#line 1235 "../src/protocol.vala"
	_tmp18_ = vala_source_reference_get_file (_tmp17_);
#line 1235 "../src/protocol.vala"
	_tmp19_ = _tmp18_;
#line 1235 "../src/protocol.vala"
	_tmp20_ = vala_source_file_get_filename (_tmp19_);
#line 1235 "../src/protocol.vala"
	_tmp21_ = _tmp20_;
#line 1235 "../src/protocol.vala"
	_tmp22_ = g_file_new_for_commandline_arg (_tmp21_);
#line 1235 "../src/protocol.vala"
	_tmp23_ = _tmp22_;
#line 1235 "../src/protocol.vala"
	_tmp24_ = g_file_get_uri (_tmp23_);
#line 1235 "../src/protocol.vala"
	_tmp25_ = _tmp24_;
#line 1235 "../src/protocol.vala"
	lsp_typehierarchy_item_set_uri (self, _tmp25_);
#line 1235 "../src/protocol.vala"
	_g_free0 (_tmp25_);
#line 1235 "../src/protocol.vala"
	_g_object_unref0 (_tmp23_);
#line 1236 "../src/protocol.vala"
	_tmp26_ = vala_code_node_get_source_reference ((ValaCodeNode*) symbol);
#line 1236 "../src/protocol.vala"
	_tmp27_ = _tmp26_;
#line 1236 "../src/protocol.vala"
	_tmp28_ = lsp_range_new_from_sourceref (_tmp27_);
#line 1236 "../src/protocol.vala"
	if (_tmp28_) {
#line 1236 "../src/protocol.vala"
		g_object_set_data ((GObject *) _tmp28_, "vala-creation-function", "Lsp.TypeHierarchyItem.from_symbol");
#line 21488 "protocol.c"
	}
#line 1236 "../src/protocol.vala"
	_tmp29_ = _tmp28_;
#line 1236 "../src/protocol.vala"
	lsp_typehierarchy_item_set_range (self, _tmp29_);
#line 1236 "../src/protocol.vala"
	_g_object_unref0 (_tmp29_);
#line 1237 "../src/protocol.vala"
	_tmp30_ = self->priv->_range;
#line 1237 "../src/protocol.vala"
	lsp_typehierarchy_item_set_selectionRange (self, _tmp30_);
#line 1240 "../src/protocol.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (symbol, VALA_TYPE_OBJECT_TYPE_SYMBOL)) {
#line 21502 "protocol.c"
		{
			ValaList* _member_list = NULL;
			ValaList* _tmp31_;
			gint _member_size = 0;
			ValaList* _tmp32_;
			gint _tmp33_;
			gint _tmp34_;
			gint _member_index = 0;
#line 1241 "../src/protocol.vala"
			_tmp31_ = vala_object_type_symbol_get_members (G_TYPE_CHECK_INSTANCE_CAST (symbol, VALA_TYPE_OBJECT_TYPE_SYMBOL, ValaObjectTypeSymbol));
#line 1241 "../src/protocol.vala"
			_member_list = _tmp31_;
#line 1241 "../src/protocol.vala"
			_tmp32_ = _member_list;
#line 1241 "../src/protocol.vala"
			_tmp33_ = vala_collection_get_size ((ValaCollection*) _tmp32_);
#line 1241 "../src/protocol.vala"
			_tmp34_ = _tmp33_;
#line 1241 "../src/protocol.vala"
			_member_size = _tmp34_;
#line 1241 "../src/protocol.vala"
			_member_index = -1;
#line 1241 "../src/protocol.vala"
			while (TRUE) {
#line 21527 "protocol.c"
				gint _tmp35_;
				gint _tmp36_;
				ValaSymbol* member = NULL;
				ValaList* _tmp37_;
				gpointer _tmp38_;
				ValaSymbol* _tmp39_;
				ValaSourceReference* _tmp40_;
				ValaSourceReference* _tmp41_;
#line 1241 "../src/protocol.vala"
				_member_index = _member_index + 1;
#line 1241 "../src/protocol.vala"
				_tmp35_ = _member_index;
#line 1241 "../src/protocol.vala"
				_tmp36_ = _member_size;
#line 1241 "../src/protocol.vala"
				if (!(_tmp35_ < _tmp36_)) {
#line 1241 "../src/protocol.vala"
					break;
#line 21546 "protocol.c"
				}
#line 1241 "../src/protocol.vala"
				_tmp37_ = _member_list;
#line 1241 "../src/protocol.vala"
				_tmp38_ = vala_list_get (_tmp37_, _member_index);
#line 1241 "../src/protocol.vala"
				member = (ValaSymbol*) _tmp38_;
#line 1242 "../src/protocol.vala"
				_tmp39_ = member;
#line 1242 "../src/protocol.vala"
				_tmp40_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp39_);
#line 1242 "../src/protocol.vala"
				_tmp41_ = _tmp40_;
#line 1242 "../src/protocol.vala"
				if (_tmp41_ != NULL) {
#line 21562 "protocol.c"
					LspRange* _tmp42_;
					ValaSymbol* _tmp43_;
					ValaSourceReference* _tmp44_;
					ValaSourceReference* _tmp45_;
					LspRange* _tmp46_;
					LspRange* _tmp47_;
					LspRange* _tmp48_;
					LspRange* _tmp49_;
#line 1243 "../src/protocol.vala"
					_tmp42_ = self->priv->_range;
#line 1243 "../src/protocol.vala"
					_tmp43_ = member;
#line 1243 "../src/protocol.vala"
					_tmp44_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp43_);
#line 1243 "../src/protocol.vala"
					_tmp45_ = _tmp44_;
#line 1243 "../src/protocol.vala"
					_tmp46_ = lsp_range_new_from_sourceref (_tmp45_);
#line 1243 "../src/protocol.vala"
					if (_tmp46_) {
#line 1243 "../src/protocol.vala"
						g_object_set_data ((GObject *) _tmp46_, "vala-creation-function", "Lsp.TypeHierarchyItem.from_symbol");
#line 21585 "protocol.c"
					}
#line 1243 "../src/protocol.vala"
					_tmp47_ = _tmp46_;
#line 1243 "../src/protocol.vala"
					_tmp48_ = lsp_range_union (_tmp42_, _tmp47_);
#line 1243 "../src/protocol.vala"
					_tmp49_ = _tmp48_;
#line 1243 "../src/protocol.vala"
					lsp_typehierarchy_item_set_range (self, _tmp49_);
#line 1243 "../src/protocol.vala"
					_g_object_unref0 (_tmp49_);
#line 1243 "../src/protocol.vala"
					_g_object_unref0 (_tmp47_);
#line 21599 "protocol.c"
				}
#line 1241 "../src/protocol.vala"
				_vala_code_node_unref0 (member);
#line 21603 "protocol.c"
			}
		}
	} else {
#line 1245 "../src/protocol.vala"
		if (G_TYPE_CHECK_INSTANCE_TYPE (symbol, VALA_TYPE_ENUM)) {
#line 21609 "protocol.c"
			{
				ValaList* _member_list = NULL;
				ValaList* _tmp50_;
				gint _member_size = 0;
				ValaList* _tmp51_;
				gint _tmp52_;
				gint _tmp53_;
				gint _member_index = 0;
#line 1246 "../src/protocol.vala"
				_tmp50_ = vala_enum_get_values (G_TYPE_CHECK_INSTANCE_CAST (symbol, VALA_TYPE_ENUM, ValaEnum));
#line 1246 "../src/protocol.vala"
				_member_list = _tmp50_;
#line 1246 "../src/protocol.vala"
				_tmp51_ = _member_list;
#line 1246 "../src/protocol.vala"
				_tmp52_ = vala_collection_get_size ((ValaCollection*) _tmp51_);
#line 1246 "../src/protocol.vala"
				_tmp53_ = _tmp52_;
#line 1246 "../src/protocol.vala"
				_member_size = _tmp53_;
#line 1246 "../src/protocol.vala"
				_member_index = -1;
#line 1246 "../src/protocol.vala"
				while (TRUE) {
#line 21634 "protocol.c"
					gint _tmp54_;
					gint _tmp55_;
					ValaEnumValue* member = NULL;
					ValaList* _tmp56_;
					gpointer _tmp57_;
					ValaEnumValue* _tmp58_;
					ValaSourceReference* _tmp59_;
					ValaSourceReference* _tmp60_;
#line 1246 "../src/protocol.vala"
					_member_index = _member_index + 1;
#line 1246 "../src/protocol.vala"
					_tmp54_ = _member_index;
#line 1246 "../src/protocol.vala"
					_tmp55_ = _member_size;
#line 1246 "../src/protocol.vala"
					if (!(_tmp54_ < _tmp55_)) {
#line 1246 "../src/protocol.vala"
						break;
#line 21653 "protocol.c"
					}
#line 1246 "../src/protocol.vala"
					_tmp56_ = _member_list;
#line 1246 "../src/protocol.vala"
					_tmp57_ = vala_list_get (_tmp56_, _member_index);
#line 1246 "../src/protocol.vala"
					member = (ValaEnumValue*) _tmp57_;
#line 1247 "../src/protocol.vala"
					_tmp58_ = member;
#line 1247 "../src/protocol.vala"
					_tmp59_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp58_);
#line 1247 "../src/protocol.vala"
					_tmp60_ = _tmp59_;
#line 1247 "../src/protocol.vala"
					if (_tmp60_ != NULL) {
#line 21669 "protocol.c"
						LspRange* _tmp61_;
						ValaEnumValue* _tmp62_;
						ValaSourceReference* _tmp63_;
						ValaSourceReference* _tmp64_;
						LspRange* _tmp65_;
						LspRange* _tmp66_;
						LspRange* _tmp67_;
						LspRange* _tmp68_;
#line 1248 "../src/protocol.vala"
						_tmp61_ = self->priv->_range;
#line 1248 "../src/protocol.vala"
						_tmp62_ = member;
#line 1248 "../src/protocol.vala"
						_tmp63_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp62_);
#line 1248 "../src/protocol.vala"
						_tmp64_ = _tmp63_;
#line 1248 "../src/protocol.vala"
						_tmp65_ = lsp_range_new_from_sourceref (_tmp64_);
#line 1248 "../src/protocol.vala"
						if (_tmp65_) {
#line 1248 "../src/protocol.vala"
							g_object_set_data ((GObject *) _tmp65_, "vala-creation-function", "Lsp.TypeHierarchyItem.from_symbol");
#line 21692 "protocol.c"
						}
#line 1248 "../src/protocol.vala"
						_tmp66_ = _tmp65_;
#line 1248 "../src/protocol.vala"
						_tmp67_ = lsp_range_union (_tmp61_, _tmp66_);
#line 1248 "../src/protocol.vala"
						_tmp68_ = _tmp67_;
#line 1248 "../src/protocol.vala"
						lsp_typehierarchy_item_set_range (self, _tmp68_);
#line 1248 "../src/protocol.vala"
						_g_object_unref0 (_tmp68_);
#line 1248 "../src/protocol.vala"
						_g_object_unref0 (_tmp66_);
#line 21706 "protocol.c"
					}
#line 1246 "../src/protocol.vala"
					_vala_code_node_unref0 (member);
#line 21710 "protocol.c"
				}
			}
			{
				ValaList* _method_list = NULL;
				ValaList* _tmp69_;
				gint _method_size = 0;
				ValaList* _tmp70_;
				gint _tmp71_;
				gint _tmp72_;
				gint _method_index = 0;
#line 1250 "../src/protocol.vala"
				_tmp69_ = vala_enum_get_methods (G_TYPE_CHECK_INSTANCE_CAST (symbol, VALA_TYPE_ENUM, ValaEnum));
#line 1250 "../src/protocol.vala"
				_method_list = _tmp69_;
#line 1250 "../src/protocol.vala"
				_tmp70_ = _method_list;
#line 1250 "../src/protocol.vala"
				_tmp71_ = vala_collection_get_size ((ValaCollection*) _tmp70_);
#line 1250 "../src/protocol.vala"
				_tmp72_ = _tmp71_;
#line 1250 "../src/protocol.vala"
				_method_size = _tmp72_;
#line 1250 "../src/protocol.vala"
				_method_index = -1;
#line 1250 "../src/protocol.vala"
				while (TRUE) {
#line 21737 "protocol.c"
					gint _tmp73_;
					gint _tmp74_;
					ValaMethod* method = NULL;
					ValaList* _tmp75_;
					gpointer _tmp76_;
					ValaMethod* _tmp77_;
					ValaSourceReference* _tmp78_;
					ValaSourceReference* _tmp79_;
#line 1250 "../src/protocol.vala"
					_method_index = _method_index + 1;
#line 1250 "../src/protocol.vala"
					_tmp73_ = _method_index;
#line 1250 "../src/protocol.vala"
					_tmp74_ = _method_size;
#line 1250 "../src/protocol.vala"
					if (!(_tmp73_ < _tmp74_)) {
#line 1250 "../src/protocol.vala"
						break;
#line 21756 "protocol.c"
					}
#line 1250 "../src/protocol.vala"
					_tmp75_ = _method_list;
#line 1250 "../src/protocol.vala"
					_tmp76_ = vala_list_get (_tmp75_, _method_index);
#line 1250 "../src/protocol.vala"
					method = (ValaMethod*) _tmp76_;
#line 1251 "../src/protocol.vala"
					_tmp77_ = method;
#line 1251 "../src/protocol.vala"
					_tmp78_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp77_);
#line 1251 "../src/protocol.vala"
					_tmp79_ = _tmp78_;
#line 1251 "../src/protocol.vala"
					if (_tmp79_ != NULL) {
#line 21772 "protocol.c"
						LspRange* _tmp80_;
						ValaMethod* _tmp81_;
						ValaSourceReference* _tmp82_;
						ValaSourceReference* _tmp83_;
						LspRange* _tmp84_;
						LspRange* _tmp85_;
						LspRange* _tmp86_;
						LspRange* _tmp87_;
#line 1252 "../src/protocol.vala"
						_tmp80_ = self->priv->_range;
#line 1252 "../src/protocol.vala"
						_tmp81_ = method;
#line 1252 "../src/protocol.vala"
						_tmp82_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp81_);
#line 1252 "../src/protocol.vala"
						_tmp83_ = _tmp82_;
#line 1252 "../src/protocol.vala"
						_tmp84_ = lsp_range_new_from_sourceref (_tmp83_);
#line 1252 "../src/protocol.vala"
						if (_tmp84_) {
#line 1252 "../src/protocol.vala"
							g_object_set_data ((GObject *) _tmp84_, "vala-creation-function", "Lsp.TypeHierarchyItem.from_symbol");
#line 21795 "protocol.c"
						}
#line 1252 "../src/protocol.vala"
						_tmp85_ = _tmp84_;
#line 1252 "../src/protocol.vala"
						_tmp86_ = lsp_range_union (_tmp80_, _tmp85_);
#line 1252 "../src/protocol.vala"
						_tmp87_ = _tmp86_;
#line 1252 "../src/protocol.vala"
						lsp_typehierarchy_item_set_range (self, _tmp87_);
#line 1252 "../src/protocol.vala"
						_g_object_unref0 (_tmp87_);
#line 1252 "../src/protocol.vala"
						_g_object_unref0 (_tmp85_);
#line 21809 "protocol.c"
					}
#line 1250 "../src/protocol.vala"
					_vala_code_node_unref0 (method);
#line 21813 "protocol.c"
				}
			}
		} else {
#line 1254 "../src/protocol.vala"
			if (G_TYPE_CHECK_INSTANCE_TYPE (symbol, VALA_TYPE_ERROR_DOMAIN)) {
#line 21819 "protocol.c"
				{
					ValaList* _member_list = NULL;
					ValaList* _tmp88_;
					gint _member_size = 0;
					ValaList* _tmp89_;
					gint _tmp90_;
					gint _tmp91_;
					gint _member_index = 0;
#line 1255 "../src/protocol.vala"
					_tmp88_ = vala_error_domain_get_codes (G_TYPE_CHECK_INSTANCE_CAST (symbol, VALA_TYPE_ERROR_DOMAIN, ValaErrorDomain));
#line 1255 "../src/protocol.vala"
					_member_list = _tmp88_;
#line 1255 "../src/protocol.vala"
					_tmp89_ = _member_list;
#line 1255 "../src/protocol.vala"
					_tmp90_ = vala_collection_get_size ((ValaCollection*) _tmp89_);
#line 1255 "../src/protocol.vala"
					_tmp91_ = _tmp90_;
#line 1255 "../src/protocol.vala"
					_member_size = _tmp91_;
#line 1255 "../src/protocol.vala"
					_member_index = -1;
#line 1255 "../src/protocol.vala"
					while (TRUE) {
#line 21844 "protocol.c"
						gint _tmp92_;
						gint _tmp93_;
						ValaErrorCode* member = NULL;
						ValaList* _tmp94_;
						gpointer _tmp95_;
						ValaErrorCode* _tmp96_;
						ValaSourceReference* _tmp97_;
						ValaSourceReference* _tmp98_;
#line 1255 "../src/protocol.vala"
						_member_index = _member_index + 1;
#line 1255 "../src/protocol.vala"
						_tmp92_ = _member_index;
#line 1255 "../src/protocol.vala"
						_tmp93_ = _member_size;
#line 1255 "../src/protocol.vala"
						if (!(_tmp92_ < _tmp93_)) {
#line 1255 "../src/protocol.vala"
							break;
#line 21863 "protocol.c"
						}
#line 1255 "../src/protocol.vala"
						_tmp94_ = _member_list;
#line 1255 "../src/protocol.vala"
						_tmp95_ = vala_list_get (_tmp94_, _member_index);
#line 1255 "../src/protocol.vala"
						member = (ValaErrorCode*) _tmp95_;
#line 1256 "../src/protocol.vala"
						_tmp96_ = member;
#line 1256 "../src/protocol.vala"
						_tmp97_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp96_);
#line 1256 "../src/protocol.vala"
						_tmp98_ = _tmp97_;
#line 1256 "../src/protocol.vala"
						if (_tmp98_ != NULL) {
#line 21879 "protocol.c"
							LspRange* _tmp99_;
							ValaErrorCode* _tmp100_;
							ValaSourceReference* _tmp101_;
							ValaSourceReference* _tmp102_;
							LspRange* _tmp103_;
							LspRange* _tmp104_;
							LspRange* _tmp105_;
							LspRange* _tmp106_;
#line 1257 "../src/protocol.vala"
							_tmp99_ = self->priv->_range;
#line 1257 "../src/protocol.vala"
							_tmp100_ = member;
#line 1257 "../src/protocol.vala"
							_tmp101_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp100_);
#line 1257 "../src/protocol.vala"
							_tmp102_ = _tmp101_;
#line 1257 "../src/protocol.vala"
							_tmp103_ = lsp_range_new_from_sourceref (_tmp102_);
#line 1257 "../src/protocol.vala"
							if (_tmp103_) {
#line 1257 "../src/protocol.vala"
								g_object_set_data ((GObject *) _tmp103_, "vala-creation-function", "Lsp.TypeHierarchyItem.from_symbol");
#line 21902 "protocol.c"
							}
#line 1257 "../src/protocol.vala"
							_tmp104_ = _tmp103_;
#line 1257 "../src/protocol.vala"
							_tmp105_ = lsp_range_union (_tmp99_, _tmp104_);
#line 1257 "../src/protocol.vala"
							_tmp106_ = _tmp105_;
#line 1257 "../src/protocol.vala"
							lsp_typehierarchy_item_set_range (self, _tmp106_);
#line 1257 "../src/protocol.vala"
							_g_object_unref0 (_tmp106_);
#line 1257 "../src/protocol.vala"
							_g_object_unref0 (_tmp104_);
#line 21916 "protocol.c"
						}
#line 1255 "../src/protocol.vala"
						_vala_code_node_unref0 (member);
#line 21920 "protocol.c"
					}
				}
				{
					ValaList* _method_list = NULL;
					ValaList* _tmp107_;
					gint _method_size = 0;
					ValaList* _tmp108_;
					gint _tmp109_;
					gint _tmp110_;
					gint _method_index = 0;
#line 1259 "../src/protocol.vala"
					_tmp107_ = vala_error_domain_get_methods (G_TYPE_CHECK_INSTANCE_CAST (symbol, VALA_TYPE_ERROR_DOMAIN, ValaErrorDomain));
#line 1259 "../src/protocol.vala"
					_method_list = _tmp107_;
#line 1259 "../src/protocol.vala"
					_tmp108_ = _method_list;
#line 1259 "../src/protocol.vala"
					_tmp109_ = vala_collection_get_size ((ValaCollection*) _tmp108_);
#line 1259 "../src/protocol.vala"
					_tmp110_ = _tmp109_;
#line 1259 "../src/protocol.vala"
					_method_size = _tmp110_;
#line 1259 "../src/protocol.vala"
					_method_index = -1;
#line 1259 "../src/protocol.vala"
					while (TRUE) {
#line 21947 "protocol.c"
						gint _tmp111_;
						gint _tmp112_;
						ValaMethod* method = NULL;
						ValaList* _tmp113_;
						gpointer _tmp114_;
						ValaMethod* _tmp115_;
						ValaSourceReference* _tmp116_;
						ValaSourceReference* _tmp117_;
#line 1259 "../src/protocol.vala"
						_method_index = _method_index + 1;
#line 1259 "../src/protocol.vala"
						_tmp111_ = _method_index;
#line 1259 "../src/protocol.vala"
						_tmp112_ = _method_size;
#line 1259 "../src/protocol.vala"
						if (!(_tmp111_ < _tmp112_)) {
#line 1259 "../src/protocol.vala"
							break;
#line 21966 "protocol.c"
						}
#line 1259 "../src/protocol.vala"
						_tmp113_ = _method_list;
#line 1259 "../src/protocol.vala"
						_tmp114_ = vala_list_get (_tmp113_, _method_index);
#line 1259 "../src/protocol.vala"
						method = (ValaMethod*) _tmp114_;
#line 1260 "../src/protocol.vala"
						_tmp115_ = method;
#line 1260 "../src/protocol.vala"
						_tmp116_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp115_);
#line 1260 "../src/protocol.vala"
						_tmp117_ = _tmp116_;
#line 1260 "../src/protocol.vala"
						if (_tmp117_ != NULL) {
#line 21982 "protocol.c"
							LspRange* _tmp118_;
							ValaMethod* _tmp119_;
							ValaSourceReference* _tmp120_;
							ValaSourceReference* _tmp121_;
							LspRange* _tmp122_;
							LspRange* _tmp123_;
							LspRange* _tmp124_;
							LspRange* _tmp125_;
#line 1261 "../src/protocol.vala"
							_tmp118_ = self->priv->_range;
#line 1261 "../src/protocol.vala"
							_tmp119_ = method;
#line 1261 "../src/protocol.vala"
							_tmp120_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp119_);
#line 1261 "../src/protocol.vala"
							_tmp121_ = _tmp120_;
#line 1261 "../src/protocol.vala"
							_tmp122_ = lsp_range_new_from_sourceref (_tmp121_);
#line 1261 "../src/protocol.vala"
							if (_tmp122_) {
#line 1261 "../src/protocol.vala"
								g_object_set_data ((GObject *) _tmp122_, "vala-creation-function", "Lsp.TypeHierarchyItem.from_symbol");
#line 22005 "protocol.c"
							}
#line 1261 "../src/protocol.vala"
							_tmp123_ = _tmp122_;
#line 1261 "../src/protocol.vala"
							_tmp124_ = lsp_range_union (_tmp118_, _tmp123_);
#line 1261 "../src/protocol.vala"
							_tmp125_ = _tmp124_;
#line 1261 "../src/protocol.vala"
							lsp_typehierarchy_item_set_range (self, _tmp125_);
#line 1261 "../src/protocol.vala"
							_g_object_unref0 (_tmp125_);
#line 1261 "../src/protocol.vala"
							_g_object_unref0 (_tmp123_);
#line 22019 "protocol.c"
						}
#line 1259 "../src/protocol.vala"
						_vala_code_node_unref0 (method);
#line 22023 "protocol.c"
					}
				}
			} else {
#line 1263 "../src/protocol.vala"
				if (G_TYPE_CHECK_INSTANCE_TYPE (symbol, VALA_TYPE_STRUCT)) {
#line 22029 "protocol.c"
					{
						ValaList* _field_list = NULL;
						ValaList* _tmp126_;
						gint _field_size = 0;
						ValaList* _tmp127_;
						gint _tmp128_;
						gint _tmp129_;
						gint _field_index = 0;
#line 1264 "../src/protocol.vala"
						_tmp126_ = vala_struct_get_fields (G_TYPE_CHECK_INSTANCE_CAST (symbol, VALA_TYPE_STRUCT, ValaStruct));
#line 1264 "../src/protocol.vala"
						_field_list = _tmp126_;
#line 1264 "../src/protocol.vala"
						_tmp127_ = _field_list;
#line 1264 "../src/protocol.vala"
						_tmp128_ = vala_collection_get_size ((ValaCollection*) _tmp127_);
#line 1264 "../src/protocol.vala"
						_tmp129_ = _tmp128_;
#line 1264 "../src/protocol.vala"
						_field_size = _tmp129_;
#line 1264 "../src/protocol.vala"
						_field_index = -1;
#line 1264 "../src/protocol.vala"
						while (TRUE) {
#line 22054 "protocol.c"
							gint _tmp130_;
							gint _tmp131_;
							ValaField* field = NULL;
							ValaList* _tmp132_;
							gpointer _tmp133_;
							ValaField* _tmp134_;
							ValaSourceReference* _tmp135_;
							ValaSourceReference* _tmp136_;
#line 1264 "../src/protocol.vala"
							_field_index = _field_index + 1;
#line 1264 "../src/protocol.vala"
							_tmp130_ = _field_index;
#line 1264 "../src/protocol.vala"
							_tmp131_ = _field_size;
#line 1264 "../src/protocol.vala"
							if (!(_tmp130_ < _tmp131_)) {
#line 1264 "../src/protocol.vala"
								break;
#line 22073 "protocol.c"
							}
#line 1264 "../src/protocol.vala"
							_tmp132_ = _field_list;
#line 1264 "../src/protocol.vala"
							_tmp133_ = vala_list_get (_tmp132_, _field_index);
#line 1264 "../src/protocol.vala"
							field = (ValaField*) _tmp133_;
#line 1265 "../src/protocol.vala"
							_tmp134_ = field;
#line 1265 "../src/protocol.vala"
							_tmp135_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp134_);
#line 1265 "../src/protocol.vala"
							_tmp136_ = _tmp135_;
#line 1265 "../src/protocol.vala"
							if (_tmp136_ != NULL) {
#line 22089 "protocol.c"
								LspRange* _tmp137_;
								ValaField* _tmp138_;
								ValaSourceReference* _tmp139_;
								ValaSourceReference* _tmp140_;
								LspRange* _tmp141_;
								LspRange* _tmp142_;
								LspRange* _tmp143_;
								LspRange* _tmp144_;
#line 1266 "../src/protocol.vala"
								_tmp137_ = self->priv->_range;
#line 1266 "../src/protocol.vala"
								_tmp138_ = field;
#line 1266 "../src/protocol.vala"
								_tmp139_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp138_);
#line 1266 "../src/protocol.vala"
								_tmp140_ = _tmp139_;
#line 1266 "../src/protocol.vala"
								_tmp141_ = lsp_range_new_from_sourceref (_tmp140_);
#line 1266 "../src/protocol.vala"
								if (_tmp141_) {
#line 1266 "../src/protocol.vala"
									g_object_set_data ((GObject *) _tmp141_, "vala-creation-function", "Lsp.TypeHierarchyItem.from_symbol");
#line 22112 "protocol.c"
								}
#line 1266 "../src/protocol.vala"
								_tmp142_ = _tmp141_;
#line 1266 "../src/protocol.vala"
								_tmp143_ = lsp_range_union (_tmp137_, _tmp142_);
#line 1266 "../src/protocol.vala"
								_tmp144_ = _tmp143_;
#line 1266 "../src/protocol.vala"
								lsp_typehierarchy_item_set_range (self, _tmp144_);
#line 1266 "../src/protocol.vala"
								_g_object_unref0 (_tmp144_);
#line 1266 "../src/protocol.vala"
								_g_object_unref0 (_tmp142_);
#line 22126 "protocol.c"
							}
#line 1264 "../src/protocol.vala"
							_vala_code_node_unref0 (field);
#line 22130 "protocol.c"
						}
					}
					{
						ValaList* _method_list = NULL;
						ValaList* _tmp145_;
						gint _method_size = 0;
						ValaList* _tmp146_;
						gint _tmp147_;
						gint _tmp148_;
						gint _method_index = 0;
#line 1268 "../src/protocol.vala"
						_tmp145_ = vala_struct_get_methods (G_TYPE_CHECK_INSTANCE_CAST (symbol, VALA_TYPE_STRUCT, ValaStruct));
#line 1268 "../src/protocol.vala"
						_method_list = _tmp145_;
#line 1268 "../src/protocol.vala"
						_tmp146_ = _method_list;
#line 1268 "../src/protocol.vala"
						_tmp147_ = vala_collection_get_size ((ValaCollection*) _tmp146_);
#line 1268 "../src/protocol.vala"
						_tmp148_ = _tmp147_;
#line 1268 "../src/protocol.vala"
						_method_size = _tmp148_;
#line 1268 "../src/protocol.vala"
						_method_index = -1;
#line 1268 "../src/protocol.vala"
						while (TRUE) {
#line 22157 "protocol.c"
							gint _tmp149_;
							gint _tmp150_;
							ValaMethod* method = NULL;
							ValaList* _tmp151_;
							gpointer _tmp152_;
							ValaMethod* _tmp153_;
							ValaSourceReference* _tmp154_;
							ValaSourceReference* _tmp155_;
#line 1268 "../src/protocol.vala"
							_method_index = _method_index + 1;
#line 1268 "../src/protocol.vala"
							_tmp149_ = _method_index;
#line 1268 "../src/protocol.vala"
							_tmp150_ = _method_size;
#line 1268 "../src/protocol.vala"
							if (!(_tmp149_ < _tmp150_)) {
#line 1268 "../src/protocol.vala"
								break;
#line 22176 "protocol.c"
							}
#line 1268 "../src/protocol.vala"
							_tmp151_ = _method_list;
#line 1268 "../src/protocol.vala"
							_tmp152_ = vala_list_get (_tmp151_, _method_index);
#line 1268 "../src/protocol.vala"
							method = (ValaMethod*) _tmp152_;
#line 1269 "../src/protocol.vala"
							_tmp153_ = method;
#line 1269 "../src/protocol.vala"
							_tmp154_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp153_);
#line 1269 "../src/protocol.vala"
							_tmp155_ = _tmp154_;
#line 1269 "../src/protocol.vala"
							if (_tmp155_ != NULL) {
#line 22192 "protocol.c"
								LspRange* _tmp156_;
								ValaMethod* _tmp157_;
								ValaSourceReference* _tmp158_;
								ValaSourceReference* _tmp159_;
								LspRange* _tmp160_;
								LspRange* _tmp161_;
								LspRange* _tmp162_;
								LspRange* _tmp163_;
#line 1270 "../src/protocol.vala"
								_tmp156_ = self->priv->_range;
#line 1270 "../src/protocol.vala"
								_tmp157_ = method;
#line 1270 "../src/protocol.vala"
								_tmp158_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp157_);
#line 1270 "../src/protocol.vala"
								_tmp159_ = _tmp158_;
#line 1270 "../src/protocol.vala"
								_tmp160_ = lsp_range_new_from_sourceref (_tmp159_);
#line 1270 "../src/protocol.vala"
								if (_tmp160_) {
#line 1270 "../src/protocol.vala"
									g_object_set_data ((GObject *) _tmp160_, "vala-creation-function", "Lsp.TypeHierarchyItem.from_symbol");
#line 22215 "protocol.c"
								}
#line 1270 "../src/protocol.vala"
								_tmp161_ = _tmp160_;
#line 1270 "../src/protocol.vala"
								_tmp162_ = lsp_range_union (_tmp156_, _tmp161_);
#line 1270 "../src/protocol.vala"
								_tmp163_ = _tmp162_;
#line 1270 "../src/protocol.vala"
								lsp_typehierarchy_item_set_range (self, _tmp163_);
#line 1270 "../src/protocol.vala"
								_g_object_unref0 (_tmp163_);
#line 1270 "../src/protocol.vala"
								_g_object_unref0 (_tmp161_);
#line 22229 "protocol.c"
							}
#line 1268 "../src/protocol.vala"
							_vala_code_node_unref0 (method);
#line 22233 "protocol.c"
						}
					}
				}
			}
		}
	}
#line 1207 "../src/protocol.vala"
	_vala_code_node_unref0 (version);
#line 1207 "../src/protocol.vala"
	return self;
#line 22244 "protocol.c"
}

LspTypeHierarchyItem*
lsp_typehierarchy_item_new_from_symbol (ValaTypeSymbol* symbol)
{
#line 1207 "../src/protocol.vala"
	return lsp_typehierarchy_item_construct_from_symbol (LSP_TYPE_TYPEHIERARCHY_ITEM, symbol);
#line 22252 "protocol.c"
}

const gchar*
lsp_typehierarchy_item_get_name (LspTypeHierarchyItem* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 1170 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1170 "../src/protocol.vala"
	_tmp0_ = self->priv->_name;
#line 1170 "../src/protocol.vala"
	result = _tmp0_;
#line 1170 "../src/protocol.vala"
	return result;
#line 22268 "protocol.c"
}

void
lsp_typehierarchy_item_set_name (LspTypeHierarchyItem* self,
                                 const gchar* value)
{
	gchar* old_value;
#line 1170 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 1170 "../src/protocol.vala"
	old_value = lsp_typehierarchy_item_get_name (self);
#line 1170 "../src/protocol.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 22282 "protocol.c"
		gchar* _tmp0_;
#line 1170 "../src/protocol.vala"
		_tmp0_ = g_strdup (value);
#line 1170 "../src/protocol.vala"
		_g_free0 (self->priv->_name);
#line 1170 "../src/protocol.vala"
		self->priv->_name = _tmp0_;
#line 1170 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_typehierarchy_item_properties[LSP_TYPEHIERARCHY_ITEM_NAME_PROPERTY]);
#line 22292 "protocol.c"
	}
}

LspSymbolKind
lsp_typehierarchy_item_get_kind (LspTypeHierarchyItem* self)
{
	LspSymbolKind result;
#line 1175 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, LSP_SYMBOL_KIND_Variable);
#line 1175 "../src/protocol.vala"
	result = self->priv->_kind;
#line 1175 "../src/protocol.vala"
	return result;
#line 22306 "protocol.c"
}

void
lsp_typehierarchy_item_set_kind (LspTypeHierarchyItem* self,
                                 LspSymbolKind value)
{
	LspSymbolKind old_value;
#line 1175 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 1175 "../src/protocol.vala"
	old_value = lsp_typehierarchy_item_get_kind (self);
#line 1175 "../src/protocol.vala"
	if (old_value != value) {
#line 1175 "../src/protocol.vala"
		self->priv->_kind = value;
#line 1175 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_typehierarchy_item_properties[LSP_TYPEHIERARCHY_ITEM_KIND_PROPERTY]);
#line 22324 "protocol.c"
	}
}

LspSymbolTags
lsp_typehierarchy_item_get_tags (LspTypeHierarchyItem* self)
{
	LspSymbolTags result;
#line 1180 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 1180 "../src/protocol.vala"
	result = self->priv->_tags;
#line 1180 "../src/protocol.vala"
	return result;
#line 22338 "protocol.c"
}

void
lsp_typehierarchy_item_set_tags (LspTypeHierarchyItem* self,
                                 LspSymbolTags value)
{
	LspSymbolTags old_value;
#line 1180 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 1180 "../src/protocol.vala"
	old_value = lsp_typehierarchy_item_get_tags (self);
#line 1180 "../src/protocol.vala"
	if (old_value != value) {
#line 1180 "../src/protocol.vala"
		self->priv->_tags = value;
#line 1180 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_typehierarchy_item_properties[LSP_TYPEHIERARCHY_ITEM_TAGS_PROPERTY]);
#line 22356 "protocol.c"
	}
}

const gchar*
lsp_typehierarchy_item_get_detail (LspTypeHierarchyItem* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 1185 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1185 "../src/protocol.vala"
	_tmp0_ = self->priv->_detail;
#line 1185 "../src/protocol.vala"
	result = _tmp0_;
#line 1185 "../src/protocol.vala"
	return result;
#line 22373 "protocol.c"
}

void
lsp_typehierarchy_item_set_detail (LspTypeHierarchyItem* self,
                                   const gchar* value)
{
	gchar* old_value;
#line 1185 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 1185 "../src/protocol.vala"
	old_value = lsp_typehierarchy_item_get_detail (self);
#line 1185 "../src/protocol.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 22387 "protocol.c"
		gchar* _tmp0_;
#line 1185 "../src/protocol.vala"
		_tmp0_ = g_strdup (value);
#line 1185 "../src/protocol.vala"
		_g_free0 (self->priv->_detail);
#line 1185 "../src/protocol.vala"
		self->priv->_detail = _tmp0_;
#line 1185 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_typehierarchy_item_properties[LSP_TYPEHIERARCHY_ITEM_DETAIL_PROPERTY]);
#line 22397 "protocol.c"
	}
}

const gchar*
lsp_typehierarchy_item_get_uri (LspTypeHierarchyItem* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 1190 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1190 "../src/protocol.vala"
	_tmp0_ = self->priv->_uri;
#line 1190 "../src/protocol.vala"
	result = _tmp0_;
#line 1190 "../src/protocol.vala"
	return result;
#line 22414 "protocol.c"
}

void
lsp_typehierarchy_item_set_uri (LspTypeHierarchyItem* self,
                                const gchar* value)
{
	gchar* old_value;
#line 1190 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 1190 "../src/protocol.vala"
	old_value = lsp_typehierarchy_item_get_uri (self);
#line 1190 "../src/protocol.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 22428 "protocol.c"
		gchar* _tmp0_;
#line 1190 "../src/protocol.vala"
		_tmp0_ = g_strdup (value);
#line 1190 "../src/protocol.vala"
		_g_free0 (self->priv->_uri);
#line 1190 "../src/protocol.vala"
		self->priv->_uri = _tmp0_;
#line 1190 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_typehierarchy_item_properties[LSP_TYPEHIERARCHY_ITEM_URI_PROPERTY]);
#line 22438 "protocol.c"
	}
}

LspRange*
lsp_typehierarchy_item_get_range (LspTypeHierarchyItem* self)
{
	LspRange* result;
	LspRange* _tmp0_;
#line 1196 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1196 "../src/protocol.vala"
	_tmp0_ = self->priv->_range;
#line 1196 "../src/protocol.vala"
	result = _tmp0_;
#line 1196 "../src/protocol.vala"
	return result;
#line 22455 "protocol.c"
}

void
lsp_typehierarchy_item_set_range (LspTypeHierarchyItem* self,
                                  LspRange* value)
{
	LspRange* old_value;
#line 1196 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 1196 "../src/protocol.vala"
	old_value = lsp_typehierarchy_item_get_range (self);
#line 1196 "../src/protocol.vala"
	if (old_value != value) {
#line 22469 "protocol.c"
		LspRange* _tmp0_;
#line 1196 "../src/protocol.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 1196 "../src/protocol.vala"
		_g_object_unref0 (self->priv->_range);
#line 1196 "../src/protocol.vala"
		self->priv->_range = _tmp0_;
#line 1196 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_typehierarchy_item_properties[LSP_TYPEHIERARCHY_ITEM_RANGE_PROPERTY]);
#line 22479 "protocol.c"
	}
}

LspRange*
lsp_typehierarchy_item_get_selectionRange (LspTypeHierarchyItem* self)
{
	LspRange* result;
	LspRange* _tmp0_;
#line 1203 "../src/protocol.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1203 "../src/protocol.vala"
	_tmp0_ = self->priv->_selectionRange;
#line 1203 "../src/protocol.vala"
	result = _tmp0_;
#line 1203 "../src/protocol.vala"
	return result;
#line 22496 "protocol.c"
}

void
lsp_typehierarchy_item_set_selectionRange (LspTypeHierarchyItem* self,
                                           LspRange* value)
{
	LspRange* old_value;
#line 1203 "../src/protocol.vala"
	g_return_if_fail (self != NULL);
#line 1203 "../src/protocol.vala"
	old_value = lsp_typehierarchy_item_get_selectionRange (self);
#line 1203 "../src/protocol.vala"
	if (old_value != value) {
#line 22510 "protocol.c"
		LspRange* _tmp0_;
#line 1203 "../src/protocol.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 1203 "../src/protocol.vala"
		_g_object_unref0 (self->priv->_selectionRange);
#line 1203 "../src/protocol.vala"
		self->priv->_selectionRange = _tmp0_;
#line 1203 "../src/protocol.vala"
		g_object_notify_by_pspec ((GObject *) self, lsp_typehierarchy_item_properties[LSP_TYPEHIERARCHY_ITEM_SELECTION_RANGE_PROPERTY]);
#line 22520 "protocol.c"
	}
}

static void
lsp_typehierarchy_item_class_init (LspTypeHierarchyItemClass * klass,
                                   gpointer klass_data)
{
#line 1166 "../src/protocol.vala"
	lsp_typehierarchy_item_parent_class = g_type_class_peek_parent (klass);
#line 1166 "../src/protocol.vala"
	g_type_class_adjust_private_offset (klass, &LspTypeHierarchyItem_private_offset);
#line 1166 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_lsp_typehierarchy_item_get_property;
#line 1166 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_lsp_typehierarchy_item_set_property;
#line 1166 "../src/protocol.vala"
	G_OBJECT_CLASS (klass)->finalize = lsp_typehierarchy_item_finalize;
#line 22538 "protocol.c"
	/**
	         * The name of this item
	         */
#line 1166 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_TYPEHIERARCHY_ITEM_NAME_PROPERTY, lsp_typehierarchy_item_properties[LSP_TYPEHIERARCHY_ITEM_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22544 "protocol.c"
	/**
	         * The kind of this item
	         */
#line 1166 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_TYPEHIERARCHY_ITEM_KIND_PROPERTY, lsp_typehierarchy_item_properties[LSP_TYPEHIERARCHY_ITEM_KIND_PROPERTY] = g_param_spec_enum ("kind", "kind", "kind", LSP_TYPE_SYMBOL_KIND, LSP_SYMBOL_KIND_Variable, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22550 "protocol.c"
	/**
	         * Tags for this item
	         */
#line 1166 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_TYPEHIERARCHY_ITEM_TAGS_PROPERTY, lsp_typehierarchy_item_properties[LSP_TYPEHIERARCHY_ITEM_TAGS_PROPERTY] = g_param_spec_flags ("tags", "tags", "tags", LSP_TYPE_SYMBOL_TAGS, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22556 "protocol.c"
	/**
	         * More detail for this item, e.g. the signature of a function.
	         */
#line 1166 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_TYPEHIERARCHY_ITEM_DETAIL_PROPERTY, lsp_typehierarchy_item_properties[LSP_TYPEHIERARCHY_ITEM_DETAIL_PROPERTY] = g_param_spec_string ("detail", "detail", "detail", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22562 "protocol.c"
	/**
	         * The resource identifier of this item.
	         */
#line 1166 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_TYPEHIERARCHY_ITEM_URI_PROPERTY, lsp_typehierarchy_item_properties[LSP_TYPEHIERARCHY_ITEM_URI_PROPERTY] = g_param_spec_string ("uri", "uri", "uri", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22568 "protocol.c"
	/**
	         * The range enclosing this symbol not including leading/trailing
	         * whitespace, but everything else, e.g. comments and code.
	         */
#line 1166 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_TYPEHIERARCHY_ITEM_RANGE_PROPERTY, lsp_typehierarchy_item_properties[LSP_TYPEHIERARCHY_ITEM_RANGE_PROPERTY] = g_param_spec_object ("range", "range", "range", LSP_TYPE_RANGE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22575 "protocol.c"
	/**
	         * The range that should be selected and revealed when this symbol
	         * is being picked, e.g. the name of a function. Must be contained
	         * by {@link TypeHierarchyItem.range}
	         */
#line 1166 "../src/protocol.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LSP_TYPEHIERARCHY_ITEM_SELECTION_RANGE_PROPERTY, lsp_typehierarchy_item_properties[LSP_TYPEHIERARCHY_ITEM_SELECTION_RANGE_PROPERTY] = g_param_spec_object ("selectionRange", "selectionRange", "selectionRange", LSP_TYPE_RANGE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22583 "protocol.c"
}

static void
lsp_typehierarchy_item_json_serializable_interface_init (JsonSerializableIface * iface,
                                                         gpointer iface_data)
{
#line 1166 "../src/protocol.vala"
	lsp_typehierarchy_item_json_serializable_parent_iface = g_type_interface_peek_parent (iface);
#line 22592 "protocol.c"
}

static void
lsp_typehierarchy_item_instance_init (LspTypeHierarchyItem * self,
                                      gpointer klass)
{
#line 1166 "../src/protocol.vala"
	self->priv = lsp_typehierarchy_item_get_instance_private (self);
#line 22601 "protocol.c"
}

static void
lsp_typehierarchy_item_finalize (GObject * obj)
{
	LspTypeHierarchyItem * self;
#line 1166 "../src/protocol.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, LSP_TYPE_TYPEHIERARCHY_ITEM, LspTypeHierarchyItem);
#line 1170 "../src/protocol.vala"
	_g_free0 (self->priv->_name);
#line 1185 "../src/protocol.vala"
	_g_free0 (self->priv->_detail);
#line 1190 "../src/protocol.vala"
	_g_free0 (self->priv->_uri);
#line 1196 "../src/protocol.vala"
	_g_object_unref0 (self->priv->_range);
#line 1203 "../src/protocol.vala"
	_g_object_unref0 (self->priv->_selectionRange);
#line 1166 "../src/protocol.vala"
	G_OBJECT_CLASS (lsp_typehierarchy_item_parent_class)->finalize (obj);
#line 22622 "protocol.c"
}

 G_GNUC_NO_INLINE static GType
lsp_typehierarchy_item_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (LspTypeHierarchyItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) lsp_typehierarchy_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LspTypeHierarchyItem), 0, (GInstanceInitFunc) lsp_typehierarchy_item_instance_init, NULL };
	static const GInterfaceInfo json_serializable_info = { (GInterfaceInitFunc) lsp_typehierarchy_item_json_serializable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType lsp_typehierarchy_item_type_id;
	lsp_typehierarchy_item_type_id = g_type_register_static (G_TYPE_OBJECT, "LspTypeHierarchyItem", &g_define_type_info, 0);
	g_type_add_interface_static (lsp_typehierarchy_item_type_id, json_serializable_get_type (), &json_serializable_info);
	LspTypeHierarchyItem_private_offset = g_type_add_instance_private (lsp_typehierarchy_item_type_id, sizeof (LspTypeHierarchyItemPrivate));
	return lsp_typehierarchy_item_type_id;
}

GType
lsp_typehierarchy_item_get_type (void)
{
	static gsize lsp_typehierarchy_item_type_id__once = 0;
	if (g_once_init_enter (&lsp_typehierarchy_item_type_id__once)) {
		GType lsp_typehierarchy_item_type_id;
		lsp_typehierarchy_item_type_id = lsp_typehierarchy_item_get_type_once ();
		g_once_init_leave (&lsp_typehierarchy_item_type_id__once, lsp_typehierarchy_item_type_id);
	}
	return lsp_typehierarchy_item_type_id__once;
}

static void
_vala_lsp_typehierarchy_item_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec)
{
	LspTypeHierarchyItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_TYPEHIERARCHY_ITEM, LspTypeHierarchyItem);
#line 1166 "../src/protocol.vala"
	switch (property_id) {
#line 1166 "../src/protocol.vala"
		case LSP_TYPEHIERARCHY_ITEM_NAME_PROPERTY:
#line 1166 "../src/protocol.vala"
		g_value_set_string (value, lsp_typehierarchy_item_get_name (self));
#line 1166 "../src/protocol.vala"
		break;
#line 1166 "../src/protocol.vala"
		case LSP_TYPEHIERARCHY_ITEM_KIND_PROPERTY:
#line 1166 "../src/protocol.vala"
		g_value_set_enum (value, lsp_typehierarchy_item_get_kind (self));
#line 1166 "../src/protocol.vala"
		break;
#line 1166 "../src/protocol.vala"
		case LSP_TYPEHIERARCHY_ITEM_TAGS_PROPERTY:
#line 1166 "../src/protocol.vala"
		g_value_set_flags (value, lsp_typehierarchy_item_get_tags (self));
#line 1166 "../src/protocol.vala"
		break;
#line 1166 "../src/protocol.vala"
		case LSP_TYPEHIERARCHY_ITEM_DETAIL_PROPERTY:
#line 1166 "../src/protocol.vala"
		g_value_set_string (value, lsp_typehierarchy_item_get_detail (self));
#line 1166 "../src/protocol.vala"
		break;
#line 1166 "../src/protocol.vala"
		case LSP_TYPEHIERARCHY_ITEM_URI_PROPERTY:
#line 1166 "../src/protocol.vala"
		g_value_set_string (value, lsp_typehierarchy_item_get_uri (self));
#line 1166 "../src/protocol.vala"
		break;
#line 1166 "../src/protocol.vala"
		case LSP_TYPEHIERARCHY_ITEM_RANGE_PROPERTY:
#line 1166 "../src/protocol.vala"
		g_value_set_object (value, lsp_typehierarchy_item_get_range (self));
#line 1166 "../src/protocol.vala"
		break;
#line 1166 "../src/protocol.vala"
		case LSP_TYPEHIERARCHY_ITEM_SELECTION_RANGE_PROPERTY:
#line 1166 "../src/protocol.vala"
		g_value_set_object (value, lsp_typehierarchy_item_get_selectionRange (self));
#line 1166 "../src/protocol.vala"
		break;
#line 22701 "protocol.c"
		default:
#line 1166 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 1166 "../src/protocol.vala"
		break;
#line 22707 "protocol.c"
	}
}

static void
_vala_lsp_typehierarchy_item_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec)
{
	LspTypeHierarchyItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, LSP_TYPE_TYPEHIERARCHY_ITEM, LspTypeHierarchyItem);
#line 1166 "../src/protocol.vala"
	switch (property_id) {
#line 1166 "../src/protocol.vala"
		case LSP_TYPEHIERARCHY_ITEM_NAME_PROPERTY:
#line 1166 "../src/protocol.vala"
		lsp_typehierarchy_item_set_name (self, g_value_get_string (value));
#line 1166 "../src/protocol.vala"
		break;
#line 1166 "../src/protocol.vala"
		case LSP_TYPEHIERARCHY_ITEM_KIND_PROPERTY:
#line 1166 "../src/protocol.vala"
		lsp_typehierarchy_item_set_kind (self, g_value_get_enum (value));
#line 1166 "../src/protocol.vala"
		break;
#line 1166 "../src/protocol.vala"
		case LSP_TYPEHIERARCHY_ITEM_TAGS_PROPERTY:
#line 1166 "../src/protocol.vala"
		lsp_typehierarchy_item_set_tags (self, g_value_get_flags (value));
#line 1166 "../src/protocol.vala"
		break;
#line 1166 "../src/protocol.vala"
		case LSP_TYPEHIERARCHY_ITEM_DETAIL_PROPERTY:
#line 1166 "../src/protocol.vala"
		lsp_typehierarchy_item_set_detail (self, g_value_get_string (value));
#line 1166 "../src/protocol.vala"
		break;
#line 1166 "../src/protocol.vala"
		case LSP_TYPEHIERARCHY_ITEM_URI_PROPERTY:
#line 1166 "../src/protocol.vala"
		lsp_typehierarchy_item_set_uri (self, g_value_get_string (value));
#line 1166 "../src/protocol.vala"
		break;
#line 1166 "../src/protocol.vala"
		case LSP_TYPEHIERARCHY_ITEM_RANGE_PROPERTY:
#line 1166 "../src/protocol.vala"
		lsp_typehierarchy_item_set_range (self, g_value_get_object (value));
#line 1166 "../src/protocol.vala"
		break;
#line 1166 "../src/protocol.vala"
		case LSP_TYPEHIERARCHY_ITEM_SELECTION_RANGE_PROPERTY:
#line 1166 "../src/protocol.vala"
		lsp_typehierarchy_item_set_selectionRange (self, g_value_get_object (value));
#line 1166 "../src/protocol.vala"
		break;
#line 22763 "protocol.c"
		default:
#line 1166 "../src/protocol.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 1166 "../src/protocol.vala"
		break;
#line 22769 "protocol.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

